# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class AlgorithmObjectIdentifiers:

    _name_  = 'AlgorithmObjectIdentifiers'
    _oid_   = [2, 5, 1, 8, 7]
    
    _obj_ = [
        'nullAlgorithm',
        'encryptionAlgorithm',
        'hashAlgorithm',
        'signatureAlgorithm',
        'id-ea',
        'id-ha',
        'id-sa',
        'rsa',
        'KeySize',
        'id-ea-rsa',
        'id-ha-sqMod-n',
        'id-sa-sqMod-nWithRSA',
        'mD5Algorithm',
        'sha1Algorithm',
        ]
    _type_ = [
        'KeySize',
        ]
    _set_ = [
        ]
    _val_ = [
        'nullAlgorithm',
        'encryptionAlgorithm',
        'hashAlgorithm',
        'signatureAlgorithm',
        'id-ea',
        'id-ha',
        'id-sa',
        'rsa',
        'id-ea-rsa',
        'id-ha-sqMod-n',
        'id-sa-sqMod-nWithRSA',
        'mD5Algorithm',
        'sha1Algorithm',
        ]
    _class_ = [
        'rsa',
        'mD5Algorithm',
        'sha1Algorithm',
        ]
    _param_ = [
        ]
    
    #-----< nullAlgorithm >-----#
    nullAlgorithm = OID(name='nullAlgorithm', mode=MODE_VALUE)
    nullAlgorithm._val = (2, 5, 8, 0)
    
    #-----< encryptionAlgorithm >-----#
    encryptionAlgorithm = OID(name='encryptionAlgorithm', mode=MODE_VALUE)
    encryptionAlgorithm._val = (2, 5, 8, 1)
    
    #-----< hashAlgorithm >-----#
    hashAlgorithm = OID(name='hashAlgorithm', mode=MODE_VALUE)
    hashAlgorithm._val = (2, 5, 8, 2)
    
    #-----< signatureAlgorithm >-----#
    signatureAlgorithm = OID(name='signatureAlgorithm', mode=MODE_VALUE)
    signatureAlgorithm._val = (2, 5, 8, 3)
    
    #-----< id-ea >-----#
    id_ea = OID(name='id-ea', mode=MODE_VALUE)
    id_ea._val = (2, 5, 8, 1)
    
    #-----< id-ha >-----#
    id_ha = OID(name='id-ha', mode=MODE_VALUE)
    id_ha._val = (2, 5, 8, 2)
    
    #-----< id-sa >-----#
    id_sa = OID(name='id-sa', mode=MODE_VALUE)
    id_sa._val = (2, 5, 8, 3)
    
    #-----< rsa >-----#
    rsa = CLASS(name='rsa', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _rsa_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmObjectIdentifiers', 'KeySize')))
    rsa._val = dict([('Type', _rsa_val_Type), ('id', (2, 5, 8, 1, 1))])
    
    #-----< KeySize >-----#
    KeySize = INT(name='KeySize', mode=MODE_TYPE)
    
    #-----< id-ea-rsa >-----#
    id_ea_rsa = OID(name='id-ea-rsa', mode=MODE_VALUE)
    id_ea_rsa._val = (2, 5, 8, 1, 1)
    
    #-----< id-ha-sqMod-n >-----#
    id_ha_sqMod_n = OID(name='id-ha-sqMod-n', mode=MODE_VALUE)
    id_ha_sqMod_n._val = (2, 5, 8, 2, 1)
    
    #-----< id-sa-sqMod-nWithRSA >-----#
    id_sa_sqMod_nWithRSA = OID(name='id-sa-sqMod-nWithRSA', mode=MODE_VALUE)
    id_sa_sqMod_nWithRSA._val = (2, 5, 8, 3, 1)
    
    #-----< mD5Algorithm >-----#
    mD5Algorithm = CLASS(name='mD5Algorithm', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _mD5Algorithm_val_Type = NULL(name='Type', mode=MODE_TYPE)
    mD5Algorithm._val = dict([('Type', _mD5Algorithm_val_Type), ('id', (1, 2, 840, 113549, 2, 5))])
    
    #-----< sha1Algorithm >-----#
    sha1Algorithm = CLASS(name='sha1Algorithm', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _sha1Algorithm_val_Type = NULL(name='Type', mode=MODE_TYPE)
    sha1Algorithm._val = dict([('Type', _sha1Algorithm_val_Type), ('id', (1, 3, 14, 3, 2, 26))])
    
    _all_ = [
        nullAlgorithm,
        encryptionAlgorithm,
        hashAlgorithm,
        signatureAlgorithm,
        id_ea,
        id_ha,
        id_sa,
        rsa,
        _rsa_val_Type,
        KeySize,
        id_ea_rsa,
        id_ha_sqMod_n,
        id_sa_sqMod_nWithRSA,
        mD5Algorithm,
        _mD5Algorithm_val_Type,
        sha1Algorithm,
        _sha1Algorithm_val_Type,
    ]

class AttributeCertificateDefinitions:

    _name_  = 'AttributeCertificateDefinitions'
    _oid_   = [2, 5, 1, 32, 7]
    
    _obj_ = [
        'AttributeCertificate',
        'AttributeCertificateInfo',
        'AttCertVersion',
        'Holder',
        'IssuerSerial',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'AttCertValidityPeriod',
        'AttributeCertificationPath',
        'ACPathData',
        'PrivilegePolicy',
        'role',
        'RoleSyntax',
        'xmlPrivilegeInfo',
        'permission',
        'DualStringSyntax',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'Targets',
        'Target',
        'TargetCert',
        'userNotice',
        'acceptablePrivilegePolicies',
        'AcceptablePrivilegePoliciesSyntax',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'AttributeDescriptorSyntax',
        'AttributeIdentifier',
        'AttributeIDs',
        'AttributeName',
        'AttributeDescription',
        'PrivilegePolicyIdentifier',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'RoleSpecCertIdentifierSyntax',
        'RoleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'BasicAttConstraintsSyntax',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'AcceptableCertPoliciesSyntax',
        'CertPolicyId',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'AuthorityAttributeIdentifierSyntax',
        'AuthAttId',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'AllowedAttributeAssignments',
        'attributeMappings',
        'AttributeMappings',
        'holderNameConstraints',
        'HolderNameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'AttCertPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'AttributeCertificateExactAssertion',
        'attributeCertificateMatch',
        'AttributeCertificateAssertion',
        'holderIssuerMatch',
        'HolderIssuerAssertion',
        'delegationPathMatch',
        'DelMatchSyntax',
        'extensionPresenceMatch',
        'id-oc-pmiUser',
        'id-oc-pmiAA',
        'id-oc-pmiSOA',
        'id-oc-attCertCRLDistributionPts',
        'id-oc-privilegePolicy',
        'id-oc-pmiDelegationPath',
        'id-oc-protectedPrivilegePolicy',
        'id-at-attributeCertificate',
        'id-at-attributeCertificateRevocationList',
        'id-at-aACertificate',
        'id-at-attributeDescriptorCertificate',
        'id-at-attributeAuthorityRevocationList',
        'id-at-privPolicy',
        'id-at-role',
        'id-at-delegationPath',
        'id-at-protPrivPolicy',
        'id-at-xMLPrivilegeInfo',
        'id-at-xmlPrivPolicy',
        'id-at-permission',
        'id-ce-authorityAttributeIdentifier',
        'id-ce-roleSpecCertIdentifier',
        'id-ce-basicAttConstraints',
        'id-ce-delegatedNameConstraints',
        'id-ce-timeSpecification',
        'id-ce-attributeDescriptor',
        'id-ce-userNotice',
        'id-ce-sOAIdentifier',
        'id-ce-acceptableCertPolicies',
        'id-ce-targetInformation',
        'id-ce-noRevAvail',
        'id-ce-acceptablePrivilegePolicies',
        'id-ce-indirectIssuer',
        'id-ce-noAssertion',
        'id-ce-issuedOnBehalfOf',
        'id-ce-singleUse',
        'id-ce-groupAC',
        'id-ce-allowedAttAss',
        'id-ce-attributeMappings',
        'id-ce-holderNameConstraints',
        'id-mr-attributeCertificateMatch',
        'id-mr-attributeCertificateExactMatch',
        'id-mr-holderIssuerMatch',
        'id-mr-authAttIdMatch',
        'id-mr-roleSpecCertIdMatch',
        'id-mr-basicAttConstraintsMatch',
        'id-mr-delegatedNameConstraintsMatch',
        'id-mr-timeSpecMatch',
        'id-mr-attDescriptorMatch',
        'id-mr-acceptableCertPoliciesMatch',
        'id-mr-delegationPathMatch',
        'id-mr-sOAIdentifierMatch',
        'id-mr-extensionPresenceMatch',
        'id-mr-dualStringMatch',
        ]
    _type_ = [
        'AttributeCertificate',
        'AttributeCertificateInfo',
        'AttCertVersion',
        'Holder',
        'IssuerSerial',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'AttCertValidityPeriod',
        'AttributeCertificationPath',
        'ACPathData',
        'PrivilegePolicy',
        'RoleSyntax',
        'DualStringSyntax',
        'Targets',
        'Target',
        'TargetCert',
        'AcceptablePrivilegePoliciesSyntax',
        'AttributeDescriptorSyntax',
        'AttributeIdentifier',
        'AttributeName',
        'AttributeDescription',
        'PrivilegePolicyIdentifier',
        'RoleSpecCertIdentifierSyntax',
        'RoleSpecCertIdentifier',
        'BasicAttConstraintsSyntax',
        'AcceptableCertPoliciesSyntax',
        'CertPolicyId',
        'AuthorityAttributeIdentifierSyntax',
        'AuthAttId',
        'AllowedAttributeAssignments',
        'AttributeMappings',
        'HolderNameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'AttCertPath',
        'AttributeCertificateExactAssertion',
        'AttributeCertificateAssertion',
        'HolderIssuerAssertion',
        'DelMatchSyntax',
        ]
    _set_ = [
        'AttributeIDs',
        ]
    _val_ = [
        'role',
        'xmlPrivilegeInfo',
        'permission',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'userNotice',
        'acceptablePrivilegePolicies',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'attributeMappings',
        'holderNameConstraints',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'attributeCertificateMatch',
        'holderIssuerMatch',
        'delegationPathMatch',
        'extensionPresenceMatch',
        'id-oc-pmiUser',
        'id-oc-pmiAA',
        'id-oc-pmiSOA',
        'id-oc-attCertCRLDistributionPts',
        'id-oc-privilegePolicy',
        'id-oc-pmiDelegationPath',
        'id-oc-protectedPrivilegePolicy',
        'id-at-attributeCertificate',
        'id-at-attributeCertificateRevocationList',
        'id-at-aACertificate',
        'id-at-attributeDescriptorCertificate',
        'id-at-attributeAuthorityRevocationList',
        'id-at-privPolicy',
        'id-at-role',
        'id-at-delegationPath',
        'id-at-protPrivPolicy',
        'id-at-xMLPrivilegeInfo',
        'id-at-xmlPrivPolicy',
        'id-at-permission',
        'id-ce-authorityAttributeIdentifier',
        'id-ce-roleSpecCertIdentifier',
        'id-ce-basicAttConstraints',
        'id-ce-delegatedNameConstraints',
        'id-ce-timeSpecification',
        'id-ce-attributeDescriptor',
        'id-ce-userNotice',
        'id-ce-sOAIdentifier',
        'id-ce-acceptableCertPolicies',
        'id-ce-targetInformation',
        'id-ce-noRevAvail',
        'id-ce-acceptablePrivilegePolicies',
        'id-ce-indirectIssuer',
        'id-ce-noAssertion',
        'id-ce-issuedOnBehalfOf',
        'id-ce-singleUse',
        'id-ce-groupAC',
        'id-ce-allowedAttAss',
        'id-ce-attributeMappings',
        'id-ce-holderNameConstraints',
        'id-mr-attributeCertificateMatch',
        'id-mr-attributeCertificateExactMatch',
        'id-mr-holderIssuerMatch',
        'id-mr-authAttIdMatch',
        'id-mr-roleSpecCertIdMatch',
        'id-mr-basicAttConstraintsMatch',
        'id-mr-delegatedNameConstraintsMatch',
        'id-mr-timeSpecMatch',
        'id-mr-attDescriptorMatch',
        'id-mr-acceptableCertPoliciesMatch',
        'id-mr-delegationPathMatch',
        'id-mr-sOAIdentifierMatch',
        'id-mr-extensionPresenceMatch',
        'id-mr-dualStringMatch',
        ]
    _class_ = [
        'role',
        'xmlPrivilegeInfo',
        'permission',
        'dualStringMatch',
        'timeSpecification',
        'timeSpecificationMatch',
        'targetingInformation',
        'userNotice',
        'acceptablePrivilegePolicies',
        'singleUse',
        'groupAC',
        'noRevAvail',
        'sOAIdentifier',
        'sOAIdentifierMatch',
        'attributeDescriptor',
        'AttributeIDs',
        'attDescriptor',
        'roleSpecCertIdentifier',
        'roleSpecCertIdMatch',
        'basicAttConstraints',
        'basicAttConstraintsMatch',
        'delegatedNameConstraints',
        'delegatedNameConstraintsMatch',
        'acceptableCertPolicies',
        'acceptableCertPoliciesMatch',
        'authorityAttributeIdentifier',
        'authAttIdMatch',
        'indirectIssuer',
        'issuedOnBehalfOf',
        'noAssertion',
        'allowedAttributeAssignments',
        'attributeMappings',
        'holderNameConstraints',
        'pmiUser',
        'pmiAA',
        'pmiSOA',
        'attCertCRLDistributionPt',
        'pmiDelegationPath',
        'privilegePolicy',
        'protectedPrivilegePolicy',
        'attributeCertificateAttribute',
        'aACertificate',
        'attributeDescriptorCertificate',
        'attributeCertificateRevocationList',
        'attributeAuthorityRevocationList',
        'delegationPath',
        'privPolicy',
        'protPrivPolicy',
        'xmlPrivPolicy',
        'attributeCertificateExactMatch',
        'attributeCertificateMatch',
        'holderIssuerMatch',
        'delegationPathMatch',
        'extensionPresenceMatch',
        ]
    _param_ = [
        ]
    
    #-----< AttributeCertificate >-----#
    AttributeCertificate = SEQ(name='AttributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeCertificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateInfo')))
    _AttributeCertificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeCertificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeCertificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeCertificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab = ___AttributeCertificate_algorithmIdentifier_parameters_tab
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeCertificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeCertificate_algorithmIdentifier_algorithm),
        ('parameters', __AttributeCertificate_algorithmIdentifier_parameters),
        ])
    _AttributeCertificate_algorithmIdentifier._ext = []
    _AttributeCertificate_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    AttributeCertificate._cont = ASN1Dict([
        ('toBeSigned', _AttributeCertificate_toBeSigned),
        ('algorithmIdentifier', _AttributeCertificate_algorithmIdentifier),
        ('encrypted', _AttributeCertificate_encrypted),
        ])
    AttributeCertificate._ext = []
    
    #-----< AttributeCertificateInfo >-----#
    AttributeCertificateInfo = SEQ(name='AttributeCertificateInfo', mode=MODE_TYPE)
    _AttributeCertificateInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertVersion')))
    _AttributeCertificateInfo_holder = SEQ(name='holder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    _AttributeCertificateInfo_issuer = SEQ(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _AttributeCertificateInfo_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeCertificateInfo_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeCertificateInfo_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificateInfo_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificateInfo_signature_algorithm._const_tab = ___AttributeCertificateInfo_signature_algorithm_tab
    __AttributeCertificateInfo_signature_algorithm._const_tab_at = None
    __AttributeCertificateInfo_signature_algorithm._const_tab_id = 'id'
    __AttributeCertificateInfo_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeCertificateInfo_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificateInfo_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificateInfo_signature_parameters._const_tab = ___AttributeCertificateInfo_signature_parameters_tab
    __AttributeCertificateInfo_signature_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeCertificateInfo_signature_parameters._const_tab_id = 'Type'
    _AttributeCertificateInfo_signature._cont = ASN1Dict([
        ('algorithm', __AttributeCertificateInfo_signature_algorithm),
        ('parameters', __AttributeCertificateInfo_signature_parameters),
        ])
    _AttributeCertificateInfo_signature._ext = []
    _AttributeCertificateInfo_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _AttributeCertificateInfo_attrCertValidityPeriod = SEQ(name='attrCertValidityPeriod', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertValidityPeriod')))
    _AttributeCertificateInfo_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE)
    __AttributeCertificateInfo_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AttributeCertificateInfo_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AttributeCertificateInfo_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AttributeCertificateInfo_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AttributeCertificateInfo_attributes__item__type._const_tab = ____AttributeCertificateInfo_attributes__item__type_tab
    ___AttributeCertificateInfo_attributes__item__type._const_tab_at = None
    ___AttributeCertificateInfo_attributes__item__type._const_tab_id = 'id'
    ___AttributeCertificateInfo_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AttributeCertificateInfo_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab = ____AttributeCertificateInfo_attributes__item__type_tab
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab_id = 'Type'
    ___AttributeCertificateInfo_attributes__item__values._cont = ____AttributeCertificateInfo_attributes__item__values__item_
    ___AttributeCertificateInfo_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AttributeCertificateInfo_attributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AttributeCertificateInfo_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value._const_tab = ____AttributeCertificateInfo_attributes__item__type_tab
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList._cont = ______AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList__item_
    _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AttributeCertificateInfo_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value),
        ('contextList', _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList),
        ])
    ____AttributeCertificateInfo_attributes__item__valuesWithContext__item_._ext = []
    ___AttributeCertificateInfo_attributes__item__valuesWithContext._cont = ____AttributeCertificateInfo_attributes__item__valuesWithContext__item_
    ___AttributeCertificateInfo_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeCertificateInfo_attributes__item_._cont = ASN1Dict([
        ('type', ___AttributeCertificateInfo_attributes__item__type),
        ('values', ___AttributeCertificateInfo_attributes__item__values),
        ('valuesWithContext', ___AttributeCertificateInfo_attributes__item__valuesWithContext),
        ])
    __AttributeCertificateInfo_attributes__item_._ext = []
    _AttributeCertificateInfo_attributes._cont = __AttributeCertificateInfo_attributes__item_
    _AttributeCertificateInfo_issuerUniqueID = BIT_STR(name='issuerUniqueID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _AttributeCertificateInfo_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    AttributeCertificateInfo._cont = ASN1Dict([
        ('version', _AttributeCertificateInfo_version),
        ('holder', _AttributeCertificateInfo_holder),
        ('issuer', _AttributeCertificateInfo_issuer),
        ('signature', _AttributeCertificateInfo_signature),
        ('serialNumber', _AttributeCertificateInfo_serialNumber),
        ('attrCertValidityPeriod', _AttributeCertificateInfo_attrCertValidityPeriod),
        ('attributes', _AttributeCertificateInfo_attributes),
        ('issuerUniqueID', _AttributeCertificateInfo_issuerUniqueID),
        ('extensions', _AttributeCertificateInfo_extensions),
        ])
    AttributeCertificateInfo._ext = ['extensions']
    
    #-----< AttCertVersion >-----#
    AttCertVersion = INT(name='AttCertVersion', mode=MODE_TYPE)
    AttCertVersion._cont = ASN1Dict([('v2', 1)])
    
    #-----< Holder >-----#
    Holder = SEQ(name='Holder', mode=MODE_TYPE)
    _Holder_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _Holder_entityName = SEQ_OF(name='entityName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _Holder_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    Holder._cont = ASN1Dict([
        ('baseCertificateID', _Holder_baseCertificateID),
        ('entityName', _Holder_entityName),
        ('objectDigestInfo', _Holder_objectDigestInfo),
        ])
    Holder._ext = None
    
    #-----< IssuerSerial >-----#
    IssuerSerial = SEQ(name='IssuerSerial', mode=MODE_TYPE)
    _IssuerSerial_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _IssuerSerial_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _IssuerSerial_issuerUID = BIT_STR(name='issuerUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    IssuerSerial._cont = ASN1Dict([
        ('issuer', _IssuerSerial_issuer),
        ('serial', _IssuerSerial_serial),
        ('issuerUID', _IssuerSerial_issuerUID),
        ])
    IssuerSerial._ext = []
    
    #-----< ObjectDigestInfo >-----#
    ObjectDigestInfo = SEQ(name='ObjectDigestInfo', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType = ENUM(name='digestedObjectType', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType._cont = ASN1Dict([('publicKey', 0), ('publicKeyCert', 1), ('otherObjectTypes', 2)])
    _ObjectDigestInfo_digestedObjectType._ext = None
    _ObjectDigestInfo_otherObjectTypeID = OID(name='otherObjectTypeID', mode=MODE_TYPE, opt=True)
    _ObjectDigestInfo_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __ObjectDigestInfo_digestAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab = ___ObjectDigestInfo_digestAlgorithm_algorithm_tab
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_at = None
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_id = 'id'
    __ObjectDigestInfo_digestAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab = ___ObjectDigestInfo_digestAlgorithm_parameters_tab
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_id = 'Type'
    _ObjectDigestInfo_digestAlgorithm._cont = ASN1Dict([
        ('algorithm', __ObjectDigestInfo_digestAlgorithm_algorithm),
        ('parameters', __ObjectDigestInfo_digestAlgorithm_parameters),
        ])
    _ObjectDigestInfo_digestAlgorithm._ext = []
    _ObjectDigestInfo_objectDigest = BIT_STR(name='objectDigest', mode=MODE_TYPE)
    ObjectDigestInfo._cont = ASN1Dict([
        ('digestedObjectType', _ObjectDigestInfo_digestedObjectType),
        ('otherObjectTypeID', _ObjectDigestInfo_otherObjectTypeID),
        ('digestAlgorithm', _ObjectDigestInfo_digestAlgorithm),
        ('objectDigest', _ObjectDigestInfo_objectDigest),
        ])
    ObjectDigestInfo._ext = []
    
    #-----< AttCertIssuer >-----#
    AttCertIssuer = SEQ(name='AttCertIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttCertIssuer_issuerName = SEQ_OF(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttCertIssuer_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _AttCertIssuer_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    AttCertIssuer._cont = ASN1Dict([
        ('issuerName', _AttCertIssuer_issuerName),
        ('baseCertificateID', _AttCertIssuer_baseCertificateID),
        ('objectDigestInfo', _AttCertIssuer_objectDigestInfo),
        ])
    AttCertIssuer._ext = []
    
    #-----< AttCertValidityPeriod >-----#
    AttCertValidityPeriod = SEQ(name='AttCertValidityPeriod', mode=MODE_TYPE)
    _AttCertValidityPeriod_notBeforeTime = TIME_GEN(name='notBeforeTime', mode=MODE_TYPE)
    _AttCertValidityPeriod_notAfterTime = TIME_GEN(name='notAfterTime', mode=MODE_TYPE)
    AttCertValidityPeriod._cont = ASN1Dict([
        ('notBeforeTime', _AttCertValidityPeriod_notBeforeTime),
        ('notAfterTime', _AttCertValidityPeriod_notAfterTime),
        ])
    AttCertValidityPeriod._ext = []
    
    #-----< AttributeCertificationPath >-----#
    AttributeCertificationPath = SEQ(name='AttributeCertificationPath', mode=MODE_TYPE)
    _AttributeCertificationPath_attributeCertificate = SEQ(name='attributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    _AttributeCertificationPath_acPath = SEQ_OF(name='acPath', mode=MODE_TYPE, opt=True)
    __AttributeCertificationPath_acPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ACPathData')))
    _AttributeCertificationPath_acPath._cont = __AttributeCertificationPath_acPath__item_
    AttributeCertificationPath._cont = ASN1Dict([
        ('attributeCertificate', _AttributeCertificationPath_attributeCertificate),
        ('acPath', _AttributeCertificationPath_acPath),
        ])
    AttributeCertificationPath._ext = []
    
    #-----< ACPathData >-----#
    ACPathData = SEQ(name='ACPathData', mode=MODE_TYPE)
    _ACPathData_certificate = SEQ(name='certificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _ACPathData_attributeCertificate = SEQ(name='attributeCertificate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')), opt=True)
    ACPathData._cont = ASN1Dict([
        ('certificate', _ACPathData_certificate),
        ('attributeCertificate', _ACPathData_attributeCertificate),
        ])
    ACPathData._ext = []
    
    #-----< PrivilegePolicy >-----#
    PrivilegePolicy = OID(name='PrivilegePolicy', mode=MODE_TYPE)
    
    #-----< role >-----#
    role = CLASS(name='role', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _role_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSyntax')))
    role._val = dict([('Type', _role_val_Type), ('id', (2, 5, 4, 72))])
    
    #-----< RoleSyntax >-----#
    RoleSyntax = SEQ(name='RoleSyntax', mode=MODE_TYPE)
    _RoleSyntax_roleAuthority = SEQ_OF(name='roleAuthority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _RoleSyntax_roleName = CHOICE(name='roleName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RoleSyntax._cont = ASN1Dict([
        ('roleAuthority', _RoleSyntax_roleAuthority),
        ('roleName', _RoleSyntax_roleName),
        ])
    RoleSyntax._ext = []
    
    #-----< xmlPrivilegeInfo >-----#
    xmlPrivilegeInfo = CLASS(name='xmlPrivilegeInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivilegeInfo_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    xmlPrivilegeInfo._val = dict([('Type', _xmlPrivilegeInfo_val_Type), ('id', (2, 5, 4, 75))])
    
    #-----< permission >-----#
    permission = CLASS(name='permission', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _permission_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    permission._val = dict([('Type', _permission_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 13, 69))])), ('id', (2, 5, 4, 82))])
    
    #-----< DualStringSyntax >-----#
    DualStringSyntax = SEQ(name='DualStringSyntax', mode=MODE_TYPE)
    _DualStringSyntax_operation = CHOICE(name='operation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DualStringSyntax_object = CHOICE(name='object', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    DualStringSyntax._cont = ASN1Dict([
        ('operation', _DualStringSyntax_operation),
        ('object', _DualStringSyntax_object),
        ])
    DualStringSyntax._ext = []
    
    #-----< dualStringMatch >-----#
    dualStringMatch = CLASS(name='dualStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _dualStringMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    dualStringMatch._val = dict([('AssertionType', _dualStringMatch_val_AssertionType), ('id', (2, 5, 13, 69))])
    
    #-----< timeSpecification >-----#
    timeSpecification = CLASS(name='timeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _timeSpecification_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecification._val = dict([('ExtnType', _timeSpecification_val_ExtnType), ('id', (2, 5, 29, 43))])
    
    #-----< timeSpecificationMatch >-----#
    timeSpecificationMatch = CLASS(name='timeSpecificationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _timeSpecificationMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecificationMatch._val = dict([('AssertionType', _timeSpecificationMatch_val_AssertionType), ('id', (2, 5, 13, 57))])
    
    #-----< targetingInformation >-----#
    targetingInformation = CLASS(name='targetingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _targetingInformation_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __targetingInformation_val_ExtnType__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Targets')))
    _targetingInformation_val_ExtnType._cont = __targetingInformation_val_ExtnType__item_
    _targetingInformation_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    targetingInformation._val = dict([('ExtnType', _targetingInformation_val_ExtnType), ('id', (2, 5, 29, 55))])
    
    #-----< Targets >-----#
    Targets = SEQ_OF(name='Targets', mode=MODE_TYPE)
    _Targets__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Target')))
    Targets._cont = _Targets__item_
    Targets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< Target >-----#
    Target = CHOICE(name='Target', mode=MODE_TYPE)
    _Target_targetName = CHOICE(name='targetName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetGroup = CHOICE(name='targetGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetCert = SEQ(name='targetCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'TargetCert')))
    Target._cont = ASN1Dict([
        ('targetName', _Target_targetName),
        ('targetGroup', _Target_targetGroup),
        ('targetCert', _Target_targetCert),
        ])
    Target._ext = []
    
    #-----< TargetCert >-----#
    TargetCert = SEQ(name='TargetCert', mode=MODE_TYPE)
    _TargetCert_targetCertificate = SEQ(name='targetCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    _TargetCert_targetName = CHOICE(name='targetName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _TargetCert_certDigestInfo = SEQ(name='certDigestInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    TargetCert._cont = ASN1Dict([
        ('targetCertificate', _TargetCert_targetCertificate),
        ('targetName', _TargetCert_targetName),
        ('certDigestInfo', _TargetCert_certDigestInfo),
        ])
    TargetCert._ext = None
    
    #-----< userNotice >-----#
    userNotice = CLASS(name='userNotice', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _userNotice_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __userNotice_val_ExtnType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit93', 'UserNotice')))
    _userNotice_val_ExtnType._cont = __userNotice_val_ExtnType__item_
    _userNotice_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    userNotice._val = dict([('ExtnType', _userNotice_val_ExtnType), ('id', (2, 5, 29, 49))])
    
    #-----< acceptablePrivilegePolicies >-----#
    acceptablePrivilegePolicies = CLASS(name='acceptablePrivilegePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptablePrivilegePolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptablePrivilegePoliciesSyntax')))
    acceptablePrivilegePolicies._val = dict([('ExtnType', _acceptablePrivilegePolicies_val_ExtnType), ('id', (2, 5, 29, 57))])
    
    #-----< AcceptablePrivilegePoliciesSyntax >-----#
    AcceptablePrivilegePoliciesSyntax = SEQ_OF(name='AcceptablePrivilegePoliciesSyntax', mode=MODE_TYPE)
    _AcceptablePrivilegePoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    AcceptablePrivilegePoliciesSyntax._cont = _AcceptablePrivilegePoliciesSyntax__item_
    AcceptablePrivilegePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< singleUse >-----#
    singleUse = CLASS(name='singleUse', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _singleUse_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    singleUse._val = dict([('ExtnType', _singleUse_val_ExtnType), ('id', (2, 5, 29, 65))])
    
    #-----< groupAC >-----#
    groupAC = CLASS(name='groupAC', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _groupAC_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    groupAC._val = dict([('ExtnType', _groupAC_val_ExtnType), ('id', (2, 5, 29, 66))])
    
    #-----< noRevAvail >-----#
    noRevAvail = CLASS(name='noRevAvail', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noRevAvail_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    noRevAvail._val = dict([('ExtnType', _noRevAvail_val_ExtnType), ('id', (2, 5, 29, 56))])
    
    #-----< sOAIdentifier >-----#
    sOAIdentifier = CLASS(name='sOAIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _sOAIdentifier_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    sOAIdentifier._val = dict([('ExtnType', _sOAIdentifier_val_ExtnType), ('id', (2, 5, 29, 50))])
    
    #-----< sOAIdentifierMatch >-----#
    sOAIdentifierMatch = CLASS(name='sOAIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _sOAIdentifierMatch_val_AssertionType = NULL(name='AssertionType', mode=MODE_TYPE)
    sOAIdentifierMatch._val = dict([('AssertionType', _sOAIdentifierMatch_val_AssertionType), ('id', (2, 5, 13, 66))])
    
    #-----< attributeDescriptor >-----#
    attributeDescriptor = CLASS(name='attributeDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeDescriptor_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attributeDescriptor._val = dict([('ExtnType', _attributeDescriptor_val_ExtnType), ('id', (2, 5, 29, 48))])
    
    #-----< AttributeDescriptorSyntax >-----#
    AttributeDescriptorSyntax = SEQ(name='AttributeDescriptorSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeIdentifier')))
    _AttributeDescriptorSyntax_attributeSyntax = OCT_STR(name='attributeSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_attributeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeDescriptorSyntax_name = STR_UTF8(name='name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeName')), opt=True)
    _AttributeDescriptorSyntax_description = STR_UTF8(name='description', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescription')), opt=True)
    _AttributeDescriptorSyntax_dominationRule = SEQ(name='dominationRule', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicyIdentifier')))
    AttributeDescriptorSyntax._cont = ASN1Dict([
        ('identifier', _AttributeDescriptorSyntax_identifier),
        ('attributeSyntax', _AttributeDescriptorSyntax_attributeSyntax),
        ('name', _AttributeDescriptorSyntax_name),
        ('description', _AttributeDescriptorSyntax_description),
        ('dominationRule', _AttributeDescriptorSyntax_dominationRule),
        ])
    AttributeDescriptorSyntax._ext = []
    
    #-----< AttributeIdentifier >-----#
    AttributeIdentifier = OID(name='AttributeIdentifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _AttributeIdentifier_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _AttributeIdentifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    AttributeIdentifier._const_tab = _AttributeIdentifier_tab
    AttributeIdentifier._const_tab_at = None
    AttributeIdentifier._const_tab_id = 'id'
    
    #-----< AttributeIDs >-----#
    AttributeIDs = CLASS(name='AttributeIDs', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    AttributeIDs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeName >-----#
    AttributeName = STR_UTF8(name='AttributeName', mode=MODE_TYPE)
    AttributeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeDescription >-----#
    AttributeDescription = STR_UTF8(name='AttributeDescription', mode=MODE_TYPE)
    AttributeDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PrivilegePolicyIdentifier >-----#
    PrivilegePolicyIdentifier = SEQ(name='PrivilegePolicyIdentifier', mode=MODE_TYPE)
    _PrivilegePolicyIdentifier_privilegePolicy = OID(name='privilegePolicy', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    _PrivilegePolicyIdentifier_privPolSyntax = CHOICE(name='privPolSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PrivilegePolicyIdentifier._cont = ASN1Dict([
        ('privilegePolicy', _PrivilegePolicyIdentifier_privilegePolicy),
        ('privPolSyntax', _PrivilegePolicyIdentifier_privPolSyntax),
        ])
    PrivilegePolicyIdentifier._ext = []
    
    #-----< attDescriptor >-----#
    attDescriptor = CLASS(name='attDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attDescriptor_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attDescriptor._val = dict([('AssertionType', _attDescriptor_val_AssertionType), ('id', (2, 5, 13, 58))])
    
    #-----< roleSpecCertIdentifier >-----#
    roleSpecCertIdentifier = CLASS(name='roleSpecCertIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _roleSpecCertIdentifier_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdentifier._val = dict([('ExtnType', _roleSpecCertIdentifier_val_ExtnType), ('id', (2, 5, 29, 39))])
    
    #-----< RoleSpecCertIdentifierSyntax >-----#
    RoleSpecCertIdentifierSyntax = SEQ_OF(name='RoleSpecCertIdentifierSyntax', mode=MODE_TYPE)
    _RoleSpecCertIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifier')))
    RoleSpecCertIdentifierSyntax._cont = _RoleSpecCertIdentifierSyntax__item_
    RoleSpecCertIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RoleSpecCertIdentifier >-----#
    RoleSpecCertIdentifier = SEQ(name='RoleSpecCertIdentifier', mode=MODE_TYPE)
    _RoleSpecCertIdentifier_roleName = CHOICE(name='roleName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertIssuer = CHOICE(name='roleCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertSerialNumber = INT(name='roleCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _RoleSpecCertIdentifier_roleCertLocator = SEQ_OF(name='roleCertLocator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    RoleSpecCertIdentifier._cont = ASN1Dict([
        ('roleName', _RoleSpecCertIdentifier_roleName),
        ('roleCertIssuer', _RoleSpecCertIdentifier_roleCertIssuer),
        ('roleCertSerialNumber', _RoleSpecCertIdentifier_roleCertSerialNumber),
        ('roleCertLocator', _RoleSpecCertIdentifier_roleCertLocator),
        ])
    RoleSpecCertIdentifier._ext = []
    
    #-----< roleSpecCertIdMatch >-----#
    roleSpecCertIdMatch = CLASS(name='roleSpecCertIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _roleSpecCertIdMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdMatch._val = dict([('AssertionType', _roleSpecCertIdMatch_val_AssertionType), ('id', (2, 5, 13, 54))])
    
    #-----< basicAttConstraints >-----#
    basicAttConstraints = CLASS(name='basicAttConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicAttConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraints._val = dict([('ExtnType', _basicAttConstraints_val_ExtnType), ('id', (2, 5, 29, 41))])
    
    #-----< BasicAttConstraintsSyntax >-----#
    BasicAttConstraintsSyntax = SEQ(name='BasicAttConstraintsSyntax', mode=MODE_TYPE)
    _BasicAttConstraintsSyntax_authority = BOOL(name='authority', mode=MODE_TYPE, default=False)
    _BasicAttConstraintsSyntax_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicAttConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicAttConstraintsSyntax._cont = ASN1Dict([
        ('authority', _BasicAttConstraintsSyntax_authority),
        ('pathLenConstraint', _BasicAttConstraintsSyntax_pathLenConstraint),
        ])
    BasicAttConstraintsSyntax._ext = []
    
    #-----< basicAttConstraintsMatch >-----#
    basicAttConstraintsMatch = CLASS(name='basicAttConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _basicAttConstraintsMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraintsMatch._val = dict([('AssertionType', _basicAttConstraintsMatch_val_AssertionType), ('id', (2, 5, 13, 55))])
    
    #-----< delegatedNameConstraints >-----#
    delegatedNameConstraints = CLASS(name='delegatedNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _delegatedNameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraints._val = dict([('ExtnType', _delegatedNameConstraints_val_ExtnType), ('id', (2, 5, 29, 42))])
    
    #-----< delegatedNameConstraintsMatch >-----#
    delegatedNameConstraintsMatch = CLASS(name='delegatedNameConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegatedNameConstraintsMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraintsMatch._val = dict([('AssertionType', _delegatedNameConstraintsMatch_val_AssertionType), ('id', (2, 5, 13, 56))])
    
    #-----< acceptableCertPolicies >-----#
    acceptableCertPolicies = CLASS(name='acceptableCertPolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptableCertPolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPolicies._val = dict([('ExtnType', _acceptableCertPolicies_val_ExtnType), ('id', (2, 5, 29, 52))])
    
    #-----< AcceptableCertPoliciesSyntax >-----#
    AcceptableCertPoliciesSyntax = SEQ_OF(name='AcceptableCertPoliciesSyntax', mode=MODE_TYPE)
    _AcceptableCertPoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'CertPolicyId')))
    AcceptableCertPoliciesSyntax._cont = _AcceptableCertPoliciesSyntax__item_
    AcceptableCertPoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name='CertPolicyId', mode=MODE_TYPE)
    
    #-----< acceptableCertPoliciesMatch >-----#
    acceptableCertPoliciesMatch = CLASS(name='acceptableCertPoliciesMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _acceptableCertPoliciesMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPoliciesMatch._val = dict([('AssertionType', _acceptableCertPoliciesMatch_val_AssertionType), ('id', (2, 5, 13, 59))])
    
    #-----< authorityAttributeIdentifier >-----#
    authorityAttributeIdentifier = CLASS(name='authorityAttributeIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityAttributeIdentifier_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authorityAttributeIdentifier._val = dict([('ExtnType', _authorityAttributeIdentifier_val_ExtnType), ('id', (2, 5, 29, 38))])
    
    #-----< AuthorityAttributeIdentifierSyntax >-----#
    AuthorityAttributeIdentifierSyntax = SEQ_OF(name='AuthorityAttributeIdentifierSyntax', mode=MODE_TYPE)
    _AuthorityAttributeIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthAttId')))
    AuthorityAttributeIdentifierSyntax._cont = _AuthorityAttributeIdentifierSyntax__item_
    AuthorityAttributeIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AuthAttId >-----#
    AuthAttId = SEQ(name='AuthAttId', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    
    #-----< authAttIdMatch >-----#
    authAttIdMatch = CLASS(name='authAttIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _authAttIdMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authAttIdMatch._val = dict([('AssertionType', _authAttIdMatch_val_AssertionType), ('id', (2, 5, 13, 53))])
    
    #-----< indirectIssuer >-----#
    indirectIssuer = CLASS(name='indirectIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _indirectIssuer_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    indirectIssuer._val = dict([('ExtnType', _indirectIssuer_val_ExtnType), ('id', (2, 5, 29, 61))])
    
    #-----< issuedOnBehalfOf >-----#
    issuedOnBehalfOf = CLASS(name='issuedOnBehalfOf', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuedOnBehalfOf_val_ExtnType = CHOICE(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    issuedOnBehalfOf._val = dict([('ExtnType', _issuedOnBehalfOf_val_ExtnType), ('id', (2, 5, 29, 64))])
    
    #-----< noAssertion >-----#
    noAssertion = CLASS(name='noAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noAssertion_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    noAssertion._val = dict([('ExtnType', _noAssertion_val_ExtnType), ('id', (2, 5, 29, 62))])
    
    #-----< allowedAttributeAssignments >-----#
    allowedAttributeAssignments = CLASS(name='allowedAttributeAssignments', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _allowedAttributeAssignments_val_ExtnType = SET_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AllowedAttributeAssignments')))
    allowedAttributeAssignments._val = dict([('ExtnType', _allowedAttributeAssignments_val_ExtnType), ('id', (2, 5, 29, 67))])
    
    #-----< AllowedAttributeAssignments >-----#
    AllowedAttributeAssignments = SET_OF(name='AllowedAttributeAssignments', mode=MODE_TYPE)
    _AllowedAttributeAssignments__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AllowedAttributeAssignments__item__attributes = SET_OF(name='attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllowedAttributeAssignments__item__attributes__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____AllowedAttributeAssignments__item__attributes__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues = SEQ(name='attributeTypeandValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab._val = ASN1Set(rv=[dict([('Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_at = None
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_id = 'id'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_at = ('..', '..', 'type')
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_id = 'Type'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_id = 'Type'
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._cont = ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value),
        ('contextList', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList),
        ])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._ext = []
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._cont = ASN1Dict([
        ('type', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type),
        ('values', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values),
        ('valuesWithContext', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext),
        ])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._ext = []
    ___AllowedAttributeAssignments__item__attributes__item_._cont = ASN1Dict([
        ('attributeType', ____AllowedAttributeAssignments__item__attributes__item__attributeType),
        ('attributeTypeandValues', ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues),
        ])
    ___AllowedAttributeAssignments__item__attributes__item_._ext = []
    __AllowedAttributeAssignments__item__attributes._cont = ___AllowedAttributeAssignments__item__attributes__item_
    __AllowedAttributeAssignments__item__holderDomain = CHOICE(name='holderDomain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _AllowedAttributeAssignments__item_._cont = ASN1Dict([
        ('attributes', __AllowedAttributeAssignments__item__attributes),
        ('holderDomain', __AllowedAttributeAssignments__item__holderDomain),
        ])
    _AllowedAttributeAssignments__item_._ext = []
    AllowedAttributeAssignments._cont = _AllowedAttributeAssignments__item_
    
    #-----< attributeMappings >-----#
    attributeMappings = CLASS(name='attributeMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeMappings_val_ExtnType = SET_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeMappings')))
    attributeMappings._val = dict([('ExtnType', _attributeMappings_val_ExtnType), ('id', (2, 5, 29, 68))])
    
    #-----< AttributeMappings >-----#
    AttributeMappings = SET_OF(name='AttributeMappings', mode=MODE_TYPE)
    _AttributeMappings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __AttributeMappings__item__typeMappings = SEQ(name='typeMappings', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeMappings_local = OID(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeMappings__item__typeMappings_remote = OID(name='remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __AttributeMappings__item__typeMappings._cont = ASN1Dict([
        ('local', ___AttributeMappings__item__typeMappings_local),
        ('remote', ___AttributeMappings__item__typeMappings_remote),
        ])
    __AttributeMappings__item__typeMappings._ext = []
    __AttributeMappings__item__typeValueMappings = SEQ(name='typeValueMappings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeValueMappings_local = SEQ(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    ___AttributeMappings__item__typeValueMappings_remote = SEQ(name='remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    __AttributeMappings__item__typeValueMappings._cont = ASN1Dict([
        ('local', ___AttributeMappings__item__typeValueMappings_local),
        ('remote', ___AttributeMappings__item__typeValueMappings_remote),
        ])
    __AttributeMappings__item__typeValueMappings._ext = []
    _AttributeMappings__item_._cont = ASN1Dict([
        ('typeMappings', __AttributeMappings__item__typeMappings),
        ('typeValueMappings', __AttributeMappings__item__typeValueMappings),
        ])
    _AttributeMappings__item_._ext = None
    AttributeMappings._cont = _AttributeMappings__item_
    
    #-----< holderNameConstraints >-----#
    holderNameConstraints = CLASS(name='holderNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holderNameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderNameConstraintsSyntax')))
    holderNameConstraints._val = dict([('ExtnType', _holderNameConstraints_val_ExtnType), ('id', (2, 5, 29, 69))])
    
    #-----< HolderNameConstraintsSyntax >-----#
    HolderNameConstraintsSyntax = SEQ(name='HolderNameConstraintsSyntax', mode=MODE_TYPE)
    _HolderNameConstraintsSyntax_permittedSubtrees = SEQ_OF(name='permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')))
    _HolderNameConstraintsSyntax_excludedSubtrees = SEQ_OF(name='excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')), opt=True)
    HolderNameConstraintsSyntax._cont = ASN1Dict([
        ('permittedSubtrees', _HolderNameConstraintsSyntax_permittedSubtrees),
        ('excludedSubtrees', _HolderNameConstraintsSyntax_excludedSubtrees),
        ])
    HolderNameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name='GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name='GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name='base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        ('base', _GeneralSubtree_base),
        ('minimum', _GeneralSubtree_minimum),
        ('maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< pmiUser >-----#
    pmiUser = CLASS(name='pmiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    pmiUser._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 58))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 24))])
    
    #-----< pmiAA >-----#
    pmiAA = CLASS(name='pmiAA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    pmiAA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 61))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 25))])
    
    #-----< pmiSOA >-----#
    pmiSOA = CLASS(name='pmiSOA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_2_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    pmiSOA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 63))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 62))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 26))])
    
    #-----< attCertCRLDistributionPt >-----#
    attCertCRLDistributionPt = CLASS(name='attCertCRLDistributionPt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    attCertCRLDistributionPt._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 59))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 27))])
    
    #-----< pmiDelegationPath >-----#
    pmiDelegationPath = CLASS(name='pmiDelegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    pmiDelegationPath._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_1), ('id', (2, 5, 4, 73))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 33))])
    
    #-----< privilegePolicy >-----#
    privilegePolicy = CLASS(name='privilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privilegePolicy._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_2), ('id', (2, 5, 4, 71))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 32))])
    
    #-----< protectedPrivilegePolicy >-----#
    protectedPrivilegePolicy = CLASS(name='protectedPrivilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    protectedPrivilegePolicy._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 74))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 34))])
    
    #-----< attributeCertificateAttribute >-----#
    attributeCertificateAttribute = CLASS(name='attributeCertificateAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateAttribute_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeCertificateAttribute._val = dict([('Type', _attributeCertificateAttribute_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 58))])
    
    #-----< aACertificate >-----#
    aACertificate = CLASS(name='aACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aACertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    aACertificate._val = dict([('Type', _aACertificate_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 61))])
    
    #-----< attributeDescriptorCertificate >-----#
    attributeDescriptorCertificate = CLASS(name='attributeDescriptorCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeDescriptorCertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeDescriptorCertificate._val = dict([('Type', _attributeDescriptorCertificate_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 62))])
    
    #-----< attributeCertificateRevocationList >-----#
    attributeCertificateRevocationList = CLASS(name='attributeCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeCertificateRevocationList._val = dict([('Type', _attributeCertificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 59))])
    
    #-----< attributeAuthorityRevocationList >-----#
    attributeAuthorityRevocationList = CLASS(name='attributeAuthorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeAuthorityRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeAuthorityRevocationList._val = dict([('Type', _attributeAuthorityRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('id', (2, 5, 4, 63))])
    
    #-----< delegationPath >-----#
    delegationPath = CLASS(name='delegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _delegationPath_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    delegationPath._val = dict([('Type', _delegationPath_val_Type), ('id', (2, 5, 4, 73))])
    
    #-----< AttCertPath >-----#
    AttCertPath = SEQ_OF(name='AttCertPath', mode=MODE_TYPE)
    _AttCertPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    AttCertPath._cont = _AttCertPath__item_
    
    #-----< privPolicy >-----#
    privPolicy = CLASS(name='privPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _privPolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privPolicy._val = dict([('Type', _privPolicy_val_Type), ('id', (2, 5, 4, 71))])
    
    #-----< protPrivPolicy >-----#
    protPrivPolicy = CLASS(name='protPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protPrivPolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    protPrivPolicy._val = dict([('Type', _protPrivPolicy_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 13, 45))])), ('id', (2, 5, 4, 74))])
    
    #-----< xmlPrivPolicy >-----#
    xmlPrivPolicy = CLASS(name='xmlPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivPolicy_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    xmlPrivPolicy._val = dict([('Type', _xmlPrivPolicy_val_Type), ('id', (2, 5, 4, 76))])
    
    #-----< attributeCertificateExactMatch >-----#
    attributeCertificateExactMatch = CLASS(name='attributeCertificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    attributeCertificateExactMatch._val = dict([('AssertionType', _attributeCertificateExactMatch_val_AssertionType), ('id', (2, 5, 13, 45))])
    
    #-----< AttributeCertificateExactAssertion >-----#
    AttributeCertificateExactAssertion = SEQ(name='AttributeCertificateExactAssertion', mode=MODE_TYPE)
    _AttributeCertificateExactAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _AttributeCertificateExactAssertion_issuer = SEQ(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    AttributeCertificateExactAssertion._cont = ASN1Dict([
        ('serialNumber', _AttributeCertificateExactAssertion_serialNumber),
        ('issuer', _AttributeCertificateExactAssertion_issuer),
        ])
    AttributeCertificateExactAssertion._ext = []
    
    #-----< attributeCertificateMatch >-----#
    attributeCertificateMatch = CLASS(name='attributeCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateAssertion')))
    attributeCertificateMatch._val = dict([('AssertionType', _attributeCertificateMatch_val_AssertionType), ('id', (2, 5, 13, 42))])
    
    #-----< AttributeCertificateAssertion >-----#
    AttributeCertificateAssertion = SEQ(name='AttributeCertificateAssertion', mode=MODE_TYPE)
    _AttributeCertificateAssertion_holder = CHOICE(name='holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_holder_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    __AttributeCertificateAssertion_holder_holderName = SEQ_OF(name='holderName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _AttributeCertificateAssertion_holder._cont = ASN1Dict([
        ('baseCertificateID', __AttributeCertificateAssertion_holder_baseCertificateID),
        ('holderName', __AttributeCertificateAssertion_holder_holderName),
        ])
    _AttributeCertificateAssertion_holder._ext = []
    _AttributeCertificateAssertion_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttributeCertificateAssertion_attCertValidity = TIME_GEN(name='attCertValidity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AttributeCertificateAssertion_attType = SET_OF(name='attType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_attType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCertificateAssertion_attType._cont = __AttributeCertificateAssertion_attType__item_
    AttributeCertificateAssertion._cont = ASN1Dict([
        ('holder', _AttributeCertificateAssertion_holder),
        ('issuer', _AttributeCertificateAssertion_issuer),
        ('attCertValidity', _AttributeCertificateAssertion_attCertValidity),
        ('attType', _AttributeCertificateAssertion_attType),
        ])
    AttributeCertificateAssertion._ext = []
    
    #-----< holderIssuerMatch >-----#
    holderIssuerMatch = CLASS(name='holderIssuerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _holderIssuerMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderIssuerAssertion')))
    holderIssuerMatch._val = dict([('AssertionType', _holderIssuerMatch_val_AssertionType), ('id', (2, 5, 13, 46))])
    
    #-----< HolderIssuerAssertion >-----#
    HolderIssuerAssertion = SEQ(name='HolderIssuerAssertion', mode=MODE_TYPE)
    _HolderIssuerAssertion_holder = SEQ(name='holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')), opt=True)
    _HolderIssuerAssertion_issuer = SEQ(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')), opt=True)
    HolderIssuerAssertion._cont = ASN1Dict([
        ('holder', _HolderIssuerAssertion_holder),
        ('issuer', _HolderIssuerAssertion_issuer),
        ])
    HolderIssuerAssertion._ext = []
    
    #-----< delegationPathMatch >-----#
    delegationPathMatch = CLASS(name='delegationPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegationPathMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DelMatchSyntax')))
    delegationPathMatch._val = dict([('AssertionType', _delegationPathMatch_val_AssertionType), ('id', (2, 5, 13, 61))])
    
    #-----< DelMatchSyntax >-----#
    DelMatchSyntax = SEQ(name='DelMatchSyntax', mode=MODE_TYPE)
    _DelMatchSyntax_firstIssuer = SEQ(name='firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _DelMatchSyntax_lastHolder = SEQ(name='lastHolder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    DelMatchSyntax._cont = ASN1Dict([
        ('firstIssuer', _DelMatchSyntax_firstIssuer),
        ('lastHolder', _DelMatchSyntax_lastHolder),
        ])
    DelMatchSyntax._ext = []
    
    #-----< extensionPresenceMatch >-----#
    extensionPresenceMatch = CLASS(name='extensionPresenceMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _extensionPresenceMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), ['id']))
    extensionPresenceMatch._val = dict([('AssertionType', _extensionPresenceMatch_val_AssertionType), ('id', (2, 5, 13, 67))])
    
    #-----< id-oc-pmiUser >-----#
    id_oc_pmiUser = OID(name='id-oc-pmiUser', mode=MODE_VALUE)
    id_oc_pmiUser._val = (2, 5, 6, 24)
    
    #-----< id-oc-pmiAA >-----#
    id_oc_pmiAA = OID(name='id-oc-pmiAA', mode=MODE_VALUE)
    id_oc_pmiAA._val = (2, 5, 6, 25)
    
    #-----< id-oc-pmiSOA >-----#
    id_oc_pmiSOA = OID(name='id-oc-pmiSOA', mode=MODE_VALUE)
    id_oc_pmiSOA._val = (2, 5, 6, 26)
    
    #-----< id-oc-attCertCRLDistributionPts >-----#
    id_oc_attCertCRLDistributionPts = OID(name='id-oc-attCertCRLDistributionPts', mode=MODE_VALUE)
    id_oc_attCertCRLDistributionPts._val = (2, 5, 6, 27)
    
    #-----< id-oc-privilegePolicy >-----#
    id_oc_privilegePolicy = OID(name='id-oc-privilegePolicy', mode=MODE_VALUE)
    id_oc_privilegePolicy._val = (2, 5, 6, 32)
    
    #-----< id-oc-pmiDelegationPath >-----#
    id_oc_pmiDelegationPath = OID(name='id-oc-pmiDelegationPath', mode=MODE_VALUE)
    id_oc_pmiDelegationPath._val = (2, 5, 6, 33)
    
    #-----< id-oc-protectedPrivilegePolicy >-----#
    id_oc_protectedPrivilegePolicy = OID(name='id-oc-protectedPrivilegePolicy', mode=MODE_VALUE)
    id_oc_protectedPrivilegePolicy._val = (2, 5, 6, 34)
    
    #-----< id-at-attributeCertificate >-----#
    id_at_attributeCertificate = OID(name='id-at-attributeCertificate', mode=MODE_VALUE)
    id_at_attributeCertificate._val = (2, 5, 4, 58)
    
    #-----< id-at-attributeCertificateRevocationList >-----#
    id_at_attributeCertificateRevocationList = OID(name='id-at-attributeCertificateRevocationList', mode=MODE_VALUE)
    id_at_attributeCertificateRevocationList._val = (2, 5, 4, 59)
    
    #-----< id-at-aACertificate >-----#
    id_at_aACertificate = OID(name='id-at-aACertificate', mode=MODE_VALUE)
    id_at_aACertificate._val = (2, 5, 4, 61)
    
    #-----< id-at-attributeDescriptorCertificate >-----#
    id_at_attributeDescriptorCertificate = OID(name='id-at-attributeDescriptorCertificate', mode=MODE_VALUE)
    id_at_attributeDescriptorCertificate._val = (2, 5, 4, 62)
    
    #-----< id-at-attributeAuthorityRevocationList >-----#
    id_at_attributeAuthorityRevocationList = OID(name='id-at-attributeAuthorityRevocationList', mode=MODE_VALUE)
    id_at_attributeAuthorityRevocationList._val = (2, 5, 4, 63)
    
    #-----< id-at-privPolicy >-----#
    id_at_privPolicy = OID(name='id-at-privPolicy', mode=MODE_VALUE)
    id_at_privPolicy._val = (2, 5, 4, 71)
    
    #-----< id-at-role >-----#
    id_at_role = OID(name='id-at-role', mode=MODE_VALUE)
    id_at_role._val = (2, 5, 4, 72)
    
    #-----< id-at-delegationPath >-----#
    id_at_delegationPath = OID(name='id-at-delegationPath', mode=MODE_VALUE)
    id_at_delegationPath._val = (2, 5, 4, 73)
    
    #-----< id-at-protPrivPolicy >-----#
    id_at_protPrivPolicy = OID(name='id-at-protPrivPolicy', mode=MODE_VALUE)
    id_at_protPrivPolicy._val = (2, 5, 4, 74)
    
    #-----< id-at-xMLPrivilegeInfo >-----#
    id_at_xMLPrivilegeInfo = OID(name='id-at-xMLPrivilegeInfo', mode=MODE_VALUE)
    id_at_xMLPrivilegeInfo._val = (2, 5, 4, 75)
    
    #-----< id-at-xmlPrivPolicy >-----#
    id_at_xmlPrivPolicy = OID(name='id-at-xmlPrivPolicy', mode=MODE_VALUE)
    id_at_xmlPrivPolicy._val = (2, 5, 4, 76)
    
    #-----< id-at-permission >-----#
    id_at_permission = OID(name='id-at-permission', mode=MODE_VALUE)
    id_at_permission._val = (2, 5, 4, 82)
    
    #-----< id-ce-authorityAttributeIdentifier >-----#
    id_ce_authorityAttributeIdentifier = OID(name='id-ce-authorityAttributeIdentifier', mode=MODE_VALUE)
    id_ce_authorityAttributeIdentifier._val = (2, 5, 29, 38)
    
    #-----< id-ce-roleSpecCertIdentifier >-----#
    id_ce_roleSpecCertIdentifier = OID(name='id-ce-roleSpecCertIdentifier', mode=MODE_VALUE)
    id_ce_roleSpecCertIdentifier._val = (2, 5, 29, 39)
    
    #-----< id-ce-basicAttConstraints >-----#
    id_ce_basicAttConstraints = OID(name='id-ce-basicAttConstraints', mode=MODE_VALUE)
    id_ce_basicAttConstraints._val = (2, 5, 29, 41)
    
    #-----< id-ce-delegatedNameConstraints >-----#
    id_ce_delegatedNameConstraints = OID(name='id-ce-delegatedNameConstraints', mode=MODE_VALUE)
    id_ce_delegatedNameConstraints._val = (2, 5, 29, 42)
    
    #-----< id-ce-timeSpecification >-----#
    id_ce_timeSpecification = OID(name='id-ce-timeSpecification', mode=MODE_VALUE)
    id_ce_timeSpecification._val = (2, 5, 29, 43)
    
    #-----< id-ce-attributeDescriptor >-----#
    id_ce_attributeDescriptor = OID(name='id-ce-attributeDescriptor', mode=MODE_VALUE)
    id_ce_attributeDescriptor._val = (2, 5, 29, 48)
    
    #-----< id-ce-userNotice >-----#
    id_ce_userNotice = OID(name='id-ce-userNotice', mode=MODE_VALUE)
    id_ce_userNotice._val = (2, 5, 29, 49)
    
    #-----< id-ce-sOAIdentifier >-----#
    id_ce_sOAIdentifier = OID(name='id-ce-sOAIdentifier', mode=MODE_VALUE)
    id_ce_sOAIdentifier._val = (2, 5, 29, 50)
    
    #-----< id-ce-acceptableCertPolicies >-----#
    id_ce_acceptableCertPolicies = OID(name='id-ce-acceptableCertPolicies', mode=MODE_VALUE)
    id_ce_acceptableCertPolicies._val = (2, 5, 29, 52)
    
    #-----< id-ce-targetInformation >-----#
    id_ce_targetInformation = OID(name='id-ce-targetInformation', mode=MODE_VALUE)
    id_ce_targetInformation._val = (2, 5, 29, 55)
    
    #-----< id-ce-noRevAvail >-----#
    id_ce_noRevAvail = OID(name='id-ce-noRevAvail', mode=MODE_VALUE)
    id_ce_noRevAvail._val = (2, 5, 29, 56)
    
    #-----< id-ce-acceptablePrivilegePolicies >-----#
    id_ce_acceptablePrivilegePolicies = OID(name='id-ce-acceptablePrivilegePolicies', mode=MODE_VALUE)
    id_ce_acceptablePrivilegePolicies._val = (2, 5, 29, 57)
    
    #-----< id-ce-indirectIssuer >-----#
    id_ce_indirectIssuer = OID(name='id-ce-indirectIssuer', mode=MODE_VALUE)
    id_ce_indirectIssuer._val = (2, 5, 29, 61)
    
    #-----< id-ce-noAssertion >-----#
    id_ce_noAssertion = OID(name='id-ce-noAssertion', mode=MODE_VALUE)
    id_ce_noAssertion._val = (2, 5, 29, 62)
    
    #-----< id-ce-issuedOnBehalfOf >-----#
    id_ce_issuedOnBehalfOf = OID(name='id-ce-issuedOnBehalfOf', mode=MODE_VALUE)
    id_ce_issuedOnBehalfOf._val = (2, 5, 29, 64)
    
    #-----< id-ce-singleUse >-----#
    id_ce_singleUse = OID(name='id-ce-singleUse', mode=MODE_VALUE)
    id_ce_singleUse._val = (2, 5, 29, 65)
    
    #-----< id-ce-groupAC >-----#
    id_ce_groupAC = OID(name='id-ce-groupAC', mode=MODE_VALUE)
    id_ce_groupAC._val = (2, 5, 29, 66)
    
    #-----< id-ce-allowedAttAss >-----#
    id_ce_allowedAttAss = OID(name='id-ce-allowedAttAss', mode=MODE_VALUE)
    id_ce_allowedAttAss._val = (2, 5, 29, 67)
    
    #-----< id-ce-attributeMappings >-----#
    id_ce_attributeMappings = OID(name='id-ce-attributeMappings', mode=MODE_VALUE)
    id_ce_attributeMappings._val = (2, 5, 29, 68)
    
    #-----< id-ce-holderNameConstraints >-----#
    id_ce_holderNameConstraints = OID(name='id-ce-holderNameConstraints', mode=MODE_VALUE)
    id_ce_holderNameConstraints._val = (2, 5, 29, 69)
    
    #-----< id-mr-attributeCertificateMatch >-----#
    id_mr_attributeCertificateMatch = OID(name='id-mr-attributeCertificateMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateMatch._val = (2, 5, 13, 42)
    
    #-----< id-mr-attributeCertificateExactMatch >-----#
    id_mr_attributeCertificateExactMatch = OID(name='id-mr-attributeCertificateExactMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateExactMatch._val = (2, 5, 13, 45)
    
    #-----< id-mr-holderIssuerMatch >-----#
    id_mr_holderIssuerMatch = OID(name='id-mr-holderIssuerMatch', mode=MODE_VALUE)
    id_mr_holderIssuerMatch._val = (2, 5, 13, 46)
    
    #-----< id-mr-authAttIdMatch >-----#
    id_mr_authAttIdMatch = OID(name='id-mr-authAttIdMatch', mode=MODE_VALUE)
    id_mr_authAttIdMatch._val = (2, 5, 13, 53)
    
    #-----< id-mr-roleSpecCertIdMatch >-----#
    id_mr_roleSpecCertIdMatch = OID(name='id-mr-roleSpecCertIdMatch', mode=MODE_VALUE)
    id_mr_roleSpecCertIdMatch._val = (2, 5, 13, 54)
    
    #-----< id-mr-basicAttConstraintsMatch >-----#
    id_mr_basicAttConstraintsMatch = OID(name='id-mr-basicAttConstraintsMatch', mode=MODE_VALUE)
    id_mr_basicAttConstraintsMatch._val = (2, 5, 13, 55)
    
    #-----< id-mr-delegatedNameConstraintsMatch >-----#
    id_mr_delegatedNameConstraintsMatch = OID(name='id-mr-delegatedNameConstraintsMatch', mode=MODE_VALUE)
    id_mr_delegatedNameConstraintsMatch._val = (2, 5, 13, 56)
    
    #-----< id-mr-timeSpecMatch >-----#
    id_mr_timeSpecMatch = OID(name='id-mr-timeSpecMatch', mode=MODE_VALUE)
    id_mr_timeSpecMatch._val = (2, 5, 13, 57)
    
    #-----< id-mr-attDescriptorMatch >-----#
    id_mr_attDescriptorMatch = OID(name='id-mr-attDescriptorMatch', mode=MODE_VALUE)
    id_mr_attDescriptorMatch._val = (2, 5, 13, 58)
    
    #-----< id-mr-acceptableCertPoliciesMatch >-----#
    id_mr_acceptableCertPoliciesMatch = OID(name='id-mr-acceptableCertPoliciesMatch', mode=MODE_VALUE)
    id_mr_acceptableCertPoliciesMatch._val = (2, 5, 13, 59)
    
    #-----< id-mr-delegationPathMatch >-----#
    id_mr_delegationPathMatch = OID(name='id-mr-delegationPathMatch', mode=MODE_VALUE)
    id_mr_delegationPathMatch._val = (2, 5, 13, 61)
    
    #-----< id-mr-sOAIdentifierMatch >-----#
    id_mr_sOAIdentifierMatch = OID(name='id-mr-sOAIdentifierMatch', mode=MODE_VALUE)
    id_mr_sOAIdentifierMatch._val = (2, 5, 13, 66)
    
    #-----< id-mr-extensionPresenceMatch >-----#
    id_mr_extensionPresenceMatch = OID(name='id-mr-extensionPresenceMatch', mode=MODE_VALUE)
    id_mr_extensionPresenceMatch._val = (2, 5, 13, 67)
    
    #-----< id-mr-dualStringMatch >-----#
    id_mr_dualStringMatch = OID(name='id-mr-dualStringMatch', mode=MODE_VALUE)
    id_mr_dualStringMatch._val = (2, 5, 13, 69)
    
    _all_ = [
        _AttributeCertificate_toBeSigned,
        ___AttributeCertificate_algorithmIdentifier_algorithm_tab,
        __AttributeCertificate_algorithmIdentifier_algorithm,
        ___AttributeCertificate_algorithmIdentifier_parameters_tab,
        __AttributeCertificate_algorithmIdentifier_parameters,
        _AttributeCertificate_algorithmIdentifier,
        _AttributeCertificate_encrypted,
        AttributeCertificate,
        _AttributeCertificateInfo_version,
        _AttributeCertificateInfo_holder,
        _AttributeCertificateInfo_issuer,
        ___AttributeCertificateInfo_signature_algorithm_tab,
        __AttributeCertificateInfo_signature_algorithm,
        ___AttributeCertificateInfo_signature_parameters_tab,
        __AttributeCertificateInfo_signature_parameters,
        _AttributeCertificateInfo_signature,
        _AttributeCertificateInfo_serialNumber,
        _AttributeCertificateInfo_attrCertValidityPeriod,
        ____AttributeCertificateInfo_attributes__item__type_tab,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___AttributeCertificateInfo_attributes__item__type,
        ____AttributeCertificateInfo_attributes__item__values__item_,
        ___AttributeCertificateInfo_attributes__item__values,
        _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__value,
        ______AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList__item_,
        _____AttributeCertificateInfo_attributes__item__valuesWithContext__item__contextList,
        ____AttributeCertificateInfo_attributes__item__valuesWithContext__item_,
        ___AttributeCertificateInfo_attributes__item__valuesWithContext,
        __AttributeCertificateInfo_attributes__item_,
        _AttributeCertificateInfo_attributes,
        _AttributeCertificateInfo_issuerUniqueID,
        _AttributeCertificateInfo_extensions,
        AttributeCertificateInfo,
        AttCertVersion,
        _Holder_baseCertificateID,
        _Holder_entityName,
        _Holder_objectDigestInfo,
        Holder,
        _IssuerSerial_issuer,
        _IssuerSerial_serial,
        _IssuerSerial_issuerUID,
        IssuerSerial,
        _ObjectDigestInfo_digestedObjectType,
        _ObjectDigestInfo_otherObjectTypeID,
        ___ObjectDigestInfo_digestAlgorithm_algorithm_tab,
        __ObjectDigestInfo_digestAlgorithm_algorithm,
        ___ObjectDigestInfo_digestAlgorithm_parameters_tab,
        __ObjectDigestInfo_digestAlgorithm_parameters,
        _ObjectDigestInfo_digestAlgorithm,
        _ObjectDigestInfo_objectDigest,
        ObjectDigestInfo,
        _AttCertIssuer_issuerName,
        _AttCertIssuer_baseCertificateID,
        _AttCertIssuer_objectDigestInfo,
        AttCertIssuer,
        _AttCertValidityPeriod_notBeforeTime,
        _AttCertValidityPeriod_notAfterTime,
        AttCertValidityPeriod,
        _AttributeCertificationPath_attributeCertificate,
        __AttributeCertificationPath_acPath__item_,
        _AttributeCertificationPath_acPath,
        AttributeCertificationPath,
        _ACPathData_certificate,
        _ACPathData_attributeCertificate,
        ACPathData,
        PrivilegePolicy,
        role,
        _role_val_Type,
        _RoleSyntax_roleAuthority,
        _RoleSyntax_roleName,
        RoleSyntax,
        xmlPrivilegeInfo,
        _xmlPrivilegeInfo_val_Type,
        permission,
        _permission_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1,
        _DualStringSyntax_operation,
        _DualStringSyntax_object,
        DualStringSyntax,
        dualStringMatch,
        _dualStringMatch_val_AssertionType,
        timeSpecification,
        _timeSpecification_val_ExtnType,
        timeSpecificationMatch,
        _timeSpecificationMatch_val_AssertionType,
        targetingInformation,
        __targetingInformation_val_ExtnType__item_,
        _targetingInformation_val_ExtnType,
        _Targets__item_,
        Targets,
        _Target_targetName,
        _Target_targetGroup,
        _Target_targetCert,
        Target,
        _TargetCert_targetCertificate,
        _TargetCert_targetName,
        _TargetCert_certDigestInfo,
        TargetCert,
        userNotice,
        __userNotice_val_ExtnType__item_,
        _userNotice_val_ExtnType,
        acceptablePrivilegePolicies,
        _acceptablePrivilegePolicies_val_ExtnType,
        _AcceptablePrivilegePoliciesSyntax__item_,
        AcceptablePrivilegePoliciesSyntax,
        singleUse,
        _singleUse_val_ExtnType,
        groupAC,
        _groupAC_val_ExtnType,
        noRevAvail,
        _noRevAvail_val_ExtnType,
        sOAIdentifier,
        _sOAIdentifier_val_ExtnType,
        sOAIdentifierMatch,
        _sOAIdentifierMatch_val_AssertionType,
        attributeDescriptor,
        _attributeDescriptor_val_ExtnType,
        _AttributeDescriptorSyntax_identifier,
        _AttributeDescriptorSyntax_attributeSyntax,
        _AttributeDescriptorSyntax_name,
        _AttributeDescriptorSyntax_description,
        _AttributeDescriptorSyntax_dominationRule,
        AttributeDescriptorSyntax,
        _AttributeIdentifier_tab,
        AttributeIdentifier,
        AttributeIDs,
        AttributeName,
        AttributeDescription,
        _PrivilegePolicyIdentifier_privilegePolicy,
        _PrivilegePolicyIdentifier_privPolSyntax,
        PrivilegePolicyIdentifier,
        attDescriptor,
        _attDescriptor_val_AssertionType,
        roleSpecCertIdentifier,
        _roleSpecCertIdentifier_val_ExtnType,
        _RoleSpecCertIdentifierSyntax__item_,
        RoleSpecCertIdentifierSyntax,
        _RoleSpecCertIdentifier_roleName,
        _RoleSpecCertIdentifier_roleCertIssuer,
        _RoleSpecCertIdentifier_roleCertSerialNumber,
        _RoleSpecCertIdentifier_roleCertLocator,
        RoleSpecCertIdentifier,
        roleSpecCertIdMatch,
        _roleSpecCertIdMatch_val_AssertionType,
        basicAttConstraints,
        _basicAttConstraints_val_ExtnType,
        _BasicAttConstraintsSyntax_authority,
        _BasicAttConstraintsSyntax_pathLenConstraint,
        BasicAttConstraintsSyntax,
        basicAttConstraintsMatch,
        _basicAttConstraintsMatch_val_AssertionType,
        delegatedNameConstraints,
        _delegatedNameConstraints_val_ExtnType,
        delegatedNameConstraintsMatch,
        _delegatedNameConstraintsMatch_val_AssertionType,
        acceptableCertPolicies,
        _acceptableCertPolicies_val_ExtnType,
        _AcceptableCertPoliciesSyntax__item_,
        AcceptableCertPoliciesSyntax,
        CertPolicyId,
        acceptableCertPoliciesMatch,
        _acceptableCertPoliciesMatch_val_AssertionType,
        authorityAttributeIdentifier,
        _authorityAttributeIdentifier_val_ExtnType,
        _AuthorityAttributeIdentifierSyntax__item_,
        AuthorityAttributeIdentifierSyntax,
        AuthAttId,
        authAttIdMatch,
        _authAttIdMatch_val_AssertionType,
        indirectIssuer,
        _indirectIssuer_val_ExtnType,
        issuedOnBehalfOf,
        _issuedOnBehalfOf_val_ExtnType,
        noAssertion,
        _noAssertion_val_ExtnType,
        allowedAttributeAssignments,
        _allowedAttributeAssignments_val_ExtnType,
        ____AllowedAttributeAssignments__item__attributes__item__attributeType,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value,
        ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext,
        ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues,
        ___AllowedAttributeAssignments__item__attributes__item_,
        __AllowedAttributeAssignments__item__attributes,
        __AllowedAttributeAssignments__item__holderDomain,
        _AllowedAttributeAssignments__item_,
        AllowedAttributeAssignments,
        attributeMappings,
        _attributeMappings_val_ExtnType,
        ___AttributeMappings__item__typeMappings_local,
        ___AttributeMappings__item__typeMappings_remote,
        __AttributeMappings__item__typeMappings,
        ___AttributeMappings__item__typeValueMappings_local,
        ___AttributeMappings__item__typeValueMappings_remote,
        __AttributeMappings__item__typeValueMappings,
        _AttributeMappings__item_,
        AttributeMappings,
        holderNameConstraints,
        _holderNameConstraints_val_ExtnType,
        _HolderNameConstraintsSyntax_permittedSubtrees,
        _HolderNameConstraintsSyntax_excludedSubtrees,
        HolderNameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        pmiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2,
        pmiAA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3,
        __pmiUser_OptionalAttributes_val_Type_2,
        pmiSOA,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_2_0,
        attCertCRLDistributionPt,
        pmiDelegationPath,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        privilegePolicy,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        protectedPrivilegePolicy,
        attributeCertificateAttribute,
        _attributeCertificateAttribute_val_Type,
        aACertificate,
        _aACertificate_val_Type,
        attributeDescriptorCertificate,
        _attributeDescriptorCertificate_val_Type,
        attributeCertificateRevocationList,
        _attributeCertificateRevocationList_val_Type,
        attributeAuthorityRevocationList,
        _attributeAuthorityRevocationList_val_Type,
        delegationPath,
        _delegationPath_val_Type,
        _AttCertPath__item_,
        AttCertPath,
        privPolicy,
        _privPolicy_val_Type,
        protPrivPolicy,
        _protPrivPolicy_val_Type,
        xmlPrivPolicy,
        _xmlPrivPolicy_val_Type,
        attributeCertificateExactMatch,
        _attributeCertificateExactMatch_val_AssertionType,
        _AttributeCertificateExactAssertion_serialNumber,
        _AttributeCertificateExactAssertion_issuer,
        AttributeCertificateExactAssertion,
        attributeCertificateMatch,
        _attributeCertificateMatch_val_AssertionType,
        __AttributeCertificateAssertion_holder_baseCertificateID,
        __AttributeCertificateAssertion_holder_holderName,
        _AttributeCertificateAssertion_holder,
        _AttributeCertificateAssertion_issuer,
        _AttributeCertificateAssertion_attCertValidity,
        __AttributeCertificateAssertion_attType__item_,
        _AttributeCertificateAssertion_attType,
        AttributeCertificateAssertion,
        holderIssuerMatch,
        _holderIssuerMatch_val_AssertionType,
        _HolderIssuerAssertion_holder,
        _HolderIssuerAssertion_issuer,
        HolderIssuerAssertion,
        delegationPathMatch,
        _delegationPathMatch_val_AssertionType,
        _DelMatchSyntax_firstIssuer,
        _DelMatchSyntax_lastHolder,
        DelMatchSyntax,
        extensionPresenceMatch,
        _extensionPresenceMatch_val_AssertionType,
        id_oc_pmiUser,
        id_oc_pmiAA,
        id_oc_pmiSOA,
        id_oc_attCertCRLDistributionPts,
        id_oc_privilegePolicy,
        id_oc_pmiDelegationPath,
        id_oc_protectedPrivilegePolicy,
        id_at_attributeCertificate,
        id_at_attributeCertificateRevocationList,
        id_at_aACertificate,
        id_at_attributeDescriptorCertificate,
        id_at_attributeAuthorityRevocationList,
        id_at_privPolicy,
        id_at_role,
        id_at_delegationPath,
        id_at_protPrivPolicy,
        id_at_xMLPrivilegeInfo,
        id_at_xmlPrivPolicy,
        id_at_permission,
        id_ce_authorityAttributeIdentifier,
        id_ce_roleSpecCertIdentifier,
        id_ce_basicAttConstraints,
        id_ce_delegatedNameConstraints,
        id_ce_timeSpecification,
        id_ce_attributeDescriptor,
        id_ce_userNotice,
        id_ce_sOAIdentifier,
        id_ce_acceptableCertPolicies,
        id_ce_targetInformation,
        id_ce_noRevAvail,
        id_ce_acceptablePrivilegePolicies,
        id_ce_indirectIssuer,
        id_ce_noAssertion,
        id_ce_issuedOnBehalfOf,
        id_ce_singleUse,
        id_ce_groupAC,
        id_ce_allowedAttAss,
        id_ce_attributeMappings,
        id_ce_holderNameConstraints,
        id_mr_attributeCertificateMatch,
        id_mr_attributeCertificateExactMatch,
        id_mr_holderIssuerMatch,
        id_mr_authAttIdMatch,
        id_mr_roleSpecCertIdMatch,
        id_mr_basicAttConstraintsMatch,
        id_mr_delegatedNameConstraintsMatch,
        id_mr_timeSpecMatch,
        id_mr_attDescriptorMatch,
        id_mr_acceptableCertPoliciesMatch,
        id_mr_delegationPathMatch,
        id_mr_sOAIdentifierMatch,
        id_mr_extensionPresenceMatch,
        id_mr_dualStringMatch,
    ]

class AuthenticationFramework:

    _name_  = 'AuthenticationFramework'
    _oid_   = [2, 5, 1, 7, 7]
    
    _obj_ = [
        'ENCRYPTED',
        'HASH',
        'ENCRYPTED-HASH',
        'SIGNATURE',
        'SIGNED',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'AlgorithmIdentifier',
        'SupportedAlgorithms',
        'ALGORITHM',
        'ecPublicKey',
        'SupportedCurves',
        'dummyCurv',
        'Validity',
        'SubjectPublicKeyInfo',
        'Time',
        'Extensions',
        'Extension',
        'der',
        'ExtensionSet',
        'EXTENSION',
        'Certificates',
        'ForwardCertificationPath',
        'CrossCertificates',
        'CertificationPath',
        'PkiPath',
        'CertificateList',
        'CertificateListContent',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'CertificatePair',
        'certificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'SupportedAlgorithm',
        'certificationPracticeStmt',
        'InfoSyntax',
        'POLICY',
        'HashedPolicyInfo',
        'Policies',
        'certificatePolicy',
        'PolicySyntax',
        'PolicyID',
        'pkiPath',
        'userPassword',
        'userPwd',
        'UserPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'PwdVocabulary',
        'pwdAlphabet',
        'PwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'PwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        'id-oc-cRLDistributionPoint',
        'id-oc-pkiUser',
        'id-oc-pkiCA',
        'id-oc-deltaCRL',
        'id-oc-cpCps',
        'id-oc-pkiCertPath',
        'id-nf-cRLDistPtNameForm',
        'id-at-userPassword',
        'id-at-userCertificate',
        'id-at-cAcertificate',
        'id-at-authorityRevocationList',
        'id-at-certificateRevocationList',
        'id-at-crossCertificatePair',
        'id-at-supportedAlgorithms',
        'id-at-deltaRevocationList',
        'id-at-certificationPracticeStmt',
        'id-at-certificatePolicy',
        'id-at-pkiPath',
        'id-at-userPwd',
        'id-oa-pwdStartTime',
        'id-oa-pwdExpiryTime',
        'id-oa-pwdEndTime',
        'id-oa-pwdFails',
        'id-oa-pwdFailureTime',
        'id-oa-pwdGracesUsed',
        'id-oa-userPwdHistory',
        'id-oa-userPwdRecentlyExpired',
        'id-oa-pwdModifyEntryAllowed',
        'id-oa-pwdChangeAllowed',
        'id-oa-pwdMaxAge',
        'id-oa-pwdExpiryAge',
        'id-oa-pwdMinLength',
        'id-oa-pwdVocabulary',
        'id-oa-pwdAlphabet',
        'id-oa-pwdDictionaries',
        'id-oa-pwdExpiryWarning',
        'id-oa-pwdGraces',
        'id-oa-pwdFailureDuration',
        'id-oa-pwdLockoutDuration',
        'id-oa-pwdMaxFailures',
        'id-oa-pwdMaxTimeInHistory',
        'id-oa-pwdMinTimeInHistory',
        'id-oa-pwdHistorySlots',
        'id-oa-pwdRecentlyExpiredDuration',
        'id-oa-pwdEncAlg',
        'id-mr-userPwdMatch',
        'id-mr-userPwdHistoryMatch',
        'id-mr-pwdEncAlgMatch',
        'id-asx-userPwdDescription',
        'id-asx-pwdVocabularyDescription',
        'id-asx-pwdAlphabetDescription',
        'id-asx-pwdEncAlgDescription',
        'id-lsx-x509Certificate',
        'id-lsx-x509CertificateList',
        'id-lsx-x509CertificatePair',
        'id-lsx-x509SupportedAlgorithm',
        'id-ecPublicKey',
        ]
    _type_ = [
        'ENCRYPTED',
        'HASH',
        'ENCRYPTED-HASH',
        'SIGNATURE',
        'SIGNED',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'AlgorithmIdentifier',
        'ALGORITHM',
        'Validity',
        'SubjectPublicKeyInfo',
        'Time',
        'Extensions',
        'Extension',
        'EXTENSION',
        'Certificates',
        'ForwardCertificationPath',
        'CrossCertificates',
        'CertificationPath',
        'PkiPath',
        'CertificateList',
        'CertificateListContent',
        'CertificatePair',
        'SupportedAlgorithm',
        'InfoSyntax',
        'POLICY',
        'HashedPolicyInfo',
        'PolicySyntax',
        'PolicyID',
        'UserPwd',
        'PwdVocabulary',
        'PwdAlphabet',
        'PwdEncAlg',
        ]
    _set_ = [
        'SupportedAlgorithms',
        'SupportedCurves',
        'ExtensionSet',
        'Policies',
        ]
    _val_ = [
        'ecPublicKey',
        'dummyCurv',
        'der',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'certificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'certificationPracticeStmt',
        'certificatePolicy',
        'pkiPath',
        'userPassword',
        'userPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'pwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        'id-oc-cRLDistributionPoint',
        'id-oc-pkiUser',
        'id-oc-pkiCA',
        'id-oc-deltaCRL',
        'id-oc-cpCps',
        'id-oc-pkiCertPath',
        'id-nf-cRLDistPtNameForm',
        'id-at-userPassword',
        'id-at-userCertificate',
        'id-at-cAcertificate',
        'id-at-authorityRevocationList',
        'id-at-certificateRevocationList',
        'id-at-crossCertificatePair',
        'id-at-supportedAlgorithms',
        'id-at-deltaRevocationList',
        'id-at-certificationPracticeStmt',
        'id-at-certificatePolicy',
        'id-at-pkiPath',
        'id-at-userPwd',
        'id-oa-pwdStartTime',
        'id-oa-pwdExpiryTime',
        'id-oa-pwdEndTime',
        'id-oa-pwdFails',
        'id-oa-pwdFailureTime',
        'id-oa-pwdGracesUsed',
        'id-oa-userPwdHistory',
        'id-oa-userPwdRecentlyExpired',
        'id-oa-pwdModifyEntryAllowed',
        'id-oa-pwdChangeAllowed',
        'id-oa-pwdMaxAge',
        'id-oa-pwdExpiryAge',
        'id-oa-pwdMinLength',
        'id-oa-pwdVocabulary',
        'id-oa-pwdAlphabet',
        'id-oa-pwdDictionaries',
        'id-oa-pwdExpiryWarning',
        'id-oa-pwdGraces',
        'id-oa-pwdFailureDuration',
        'id-oa-pwdLockoutDuration',
        'id-oa-pwdMaxFailures',
        'id-oa-pwdMaxTimeInHistory',
        'id-oa-pwdMinTimeInHistory',
        'id-oa-pwdHistorySlots',
        'id-oa-pwdRecentlyExpiredDuration',
        'id-oa-pwdEncAlg',
        'id-mr-userPwdMatch',
        'id-mr-userPwdHistoryMatch',
        'id-mr-pwdEncAlgMatch',
        'id-asx-userPwdDescription',
        'id-asx-pwdVocabularyDescription',
        'id-asx-pwdAlphabetDescription',
        'id-asx-pwdEncAlgDescription',
        'id-lsx-x509Certificate',
        'id-lsx-x509CertificateList',
        'id-lsx-x509CertificatePair',
        'id-lsx-x509SupportedAlgorithm',
        'id-ecPublicKey',
        ]
    _class_ = [
        'SupportedAlgorithms',
        'ALGORITHM',
        'ecPublicKey',
        'ExtensionSet',
        'EXTENSION',
        'pkiUser',
        'pkiCA',
        'cRLDistributionPoint',
        'cRLDistPtNameForm',
        'deltaCRL',
        'cpCps',
        'pkiCertPath',
        'userCertificate',
        'cACertificate',
        'crossCertificatePair',
        'certificateRevocationList',
        'authorityRevocationList',
        'deltaRevocationList',
        'supportedAlgorithms',
        'certificationPracticeStmt',
        'POLICY',
        'Policies',
        'certificatePolicy',
        'pkiPath',
        'userPassword',
        'userPwd',
        'pwdStartTime',
        'pwdExpiryTime',
        'pwdEndTime',
        'pwdFails',
        'pwdFailureTime',
        'pwdGracesUsed',
        'userPwdHistory',
        'userPwdRecentlyExpired',
        'pwdModifyEntryAllowed',
        'pwdChangeAllowed',
        'pwdMaxAge',
        'pwdExpiryAge',
        'pwdMinLength',
        'pwdVocabulary',
        'pwdAlphabet',
        'pwdDictionaries',
        'pwdExpiryWarning',
        'pwdGraces',
        'pwdFailureDuration',
        'pwdLockoutDuration',
        'pwdMaxFailures',
        'pwdMaxTimeInHistory',
        'pwdMinTimeInHistory',
        'pwdHistorySlots',
        'pwdRecentlyExpiredDuration',
        'pwdEncAlg',
        'userPwdMatch',
        'pwdEncAlgMatch',
        'userPwdHistoryMatch',
        'userPwdDescription',
        'pwdVocabularyDescription',
        'pwdAlphabetDescription',
        'pwdEncAlgDescription',
        'x509Certificate',
        'x509CertificateList',
        'x509CertificatePair',
        'x509SupportedAlgorithm',
        ]
    _param_ = [
        'ENCRYPTED',
        'HASH',
        'ENCRYPTED-HASH',
        'SIGNATURE',
        'SIGNED',
        'AlgorithmIdentifier',
        ]
    
    #-----< ENCRYPTED >-----#
    ENCRYPTED = BIT_STR(name='ENCRYPTED', mode=MODE_TYPE)
    
    #-----< HASH >-----#
    HASH = SEQ(name='HASH', mode=MODE_TYPE)
    _HASH_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __HASH_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___HASH_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_algorithm._const_tab = ___HASH_algorithmIdentifier_algorithm_tab
    __HASH_algorithmIdentifier_algorithm._const_tab_at = None
    __HASH_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __HASH_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___HASH_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_parameters._const_tab = ___HASH_algorithmIdentifier_parameters_tab
    __HASH_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __HASH_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _HASH_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __HASH_algorithmIdentifier_algorithm),
        ('parameters', __HASH_algorithmIdentifier_parameters),
        ])
    _HASH_algorithmIdentifier._ext = []
    _HASH_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    HASH._cont = ASN1Dict([
        ('algorithmIdentifier', _HASH_algorithmIdentifier),
        ('hashValue', _HASH_hashValue),
        ])
    HASH._ext = []
    
    #-----< ENCRYPTED-HASH >-----#
    ENCRYPTED_HASH = BIT_STR(name='ENCRYPTED-HASH', mode=MODE_TYPE)
    
    #-----< SIGNATURE >-----#
    SIGNATURE = SEQ(name='SIGNATURE', mode=MODE_TYPE)
    _SIGNATURE_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SIGNATURE_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab = ___SIGNATURE_algorithmIdentifier_algorithm_tab
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_at = None
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SIGNATURE_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SIGNATURE_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_parameters._const_tab = ___SIGNATURE_algorithmIdentifier_parameters_tab
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SIGNATURE_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SIGNATURE_algorithmIdentifier_algorithm),
        ('parameters', __SIGNATURE_algorithmIdentifier_parameters),
        ])
    _SIGNATURE_algorithmIdentifier._ext = []
    _SIGNATURE_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    SIGNATURE._cont = ASN1Dict([
        ('algorithmIdentifier', _SIGNATURE_algorithmIdentifier),
        ('encrypted', _SIGNATURE_encrypted),
        ])
    SIGNATURE._ext = []
    
    #-----< SIGNED >-----#
    SIGNED = SEQ(name='SIGNED', mode=MODE_TYPE, param=True)
    
    #-----< Certificate >-----#
    Certificate = SEQ(name='Certificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Certificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'TBSCertificate')))
    _Certificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Certificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Certificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_algorithm._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_algorithmIdentifier_algorithm._const_tab_at = None
    __Certificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __Certificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Certificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_parameters._const_tab = ___Certificate_algorithmIdentifier_parameters_tab
    __Certificate_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __Certificate_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _Certificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __Certificate_algorithmIdentifier_algorithm),
        ('parameters', __Certificate_algorithmIdentifier_parameters),
        ])
    _Certificate_algorithmIdentifier._ext = []
    _Certificate_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    Certificate._cont = ASN1Dict([
        ('toBeSigned', _Certificate_toBeSigned),
        ('algorithmIdentifier', _Certificate_algorithmIdentifier),
        ('encrypted', _Certificate_encrypted),
        ])
    Certificate._ext = []
    
    #-----< TBSCertificate >-----#
    TBSCertificate = SEQ(name='TBSCertificate', mode=MODE_TYPE)
    _TBSCertificate_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Version')), default=0)
    _TBSCertificate_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _TBSCertificate_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSCertificate_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TBSCertificate_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_algorithm._const_tab = ___TBSCertificate_signature_algorithm_tab
    __TBSCertificate_signature_algorithm._const_tab_at = None
    __TBSCertificate_signature_algorithm._const_tab_id = 'id'
    __TBSCertificate_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TBSCertificate_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_parameters._const_tab = ___TBSCertificate_signature_parameters_tab
    __TBSCertificate_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSCertificate_signature_parameters._const_tab_id = 'Type'
    _TBSCertificate_signature._cont = ASN1Dict([
        ('algorithm', __TBSCertificate_signature_algorithm),
        ('parameters', __TBSCertificate_signature_parameters),
        ])
    _TBSCertificate_signature._ext = []
    _TBSCertificate_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_validity = SEQ(name='validity', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Validity')))
    _TBSCertificate_subject = CHOICE(name='subject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_subjectPublicKeyInfo = SEQ(name='subjectPublicKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SubjectPublicKeyInfo')))
    _TBSCertificate_issuerUniqueIdentifier = BIT_STR(name='issuerUniqueIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _TBSCertificate_subjectUniqueIdentifier = BIT_STR(name='subjectUniqueIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True, group=0)
    _TBSCertificate_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True, group=1)
    TBSCertificate._cont = ASN1Dict([
        ('version', _TBSCertificate_version),
        ('serialNumber', _TBSCertificate_serialNumber),
        ('signature', _TBSCertificate_signature),
        ('issuer', _TBSCertificate_issuer),
        ('validity', _TBSCertificate_validity),
        ('subject', _TBSCertificate_subject),
        ('subjectPublicKeyInfo', _TBSCertificate_subjectPublicKeyInfo),
        ('issuerUniqueIdentifier', _TBSCertificate_issuerUniqueIdentifier),
        ('subjectUniqueIdentifier', _TBSCertificate_subjectUniqueIdentifier),
        ('extensions', _TBSCertificate_extensions),
        ])
    TBSCertificate._ext = ['subjectUniqueIdentifier', 'extensions']
    
    #-----< Version >-----#
    Version = INT(name='Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v3', 2)])
    
    #-----< CertificateSerialNumber >-----#
    CertificateSerialNumber = INT(name='CertificateSerialNumber', mode=MODE_TYPE)
    
    #-----< AlgorithmIdentifier >-----#
    AlgorithmIdentifier = SEQ(name='AlgorithmIdentifier', mode=MODE_TYPE, param=True)
    
    #-----< SupportedAlgorithms >-----#
    SupportedAlgorithms = CLASS(name='SupportedAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    SupportedAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ALGORITHM >-----#
    ALGORITHM = CLASS(name='ALGORITHM', mode=MODE_TYPE)
    _ALGORITHM_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ALGORITHM._cont = ASN1Dict([
        ('Type', _ALGORITHM_Type),
        ('id', _ALGORITHM_id),
        ])
    
    #-----< ecPublicKey >-----#
    ecPublicKey = CLASS(name='ecPublicKey', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _ecPublicKey_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedCurves')))
    ecPublicKey._val = dict([('Type', _ecPublicKey_val_Type), ('id', (1, 2, 840, 10045, 2, 1))])
    
    #-----< SupportedCurves >-----#
    SupportedCurves = OID(name='SupportedCurves', mode=MODE_SET)
    SupportedCurves._val = ASN1Set(rv=[(2, 5, 5)], rr=[], ev=[], er=[])
    
    #-----< dummyCurv >-----#
    dummyCurv = OID(name='dummyCurv', mode=MODE_VALUE)
    dummyCurv._val = (2, 5, 5)
    
    #-----< Validity >-----#
    Validity = SEQ(name='Validity', mode=MODE_TYPE)
    _Validity_notBefore = CHOICE(name='notBefore', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _Validity_notAfter = CHOICE(name='notAfter', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    Validity._cont = ASN1Dict([
        ('notBefore', _Validity_notBefore),
        ('notAfter', _Validity_notAfter),
        ])
    Validity._ext = []
    
    #-----< SubjectPublicKeyInfo >-----#
    SubjectPublicKeyInfo = SEQ(name='SubjectPublicKeyInfo', mode=MODE_TYPE)
    _SubjectPublicKeyInfo_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SubjectPublicKeyInfo_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab = ___SubjectPublicKeyInfo_algorithm_algorithm_tab
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_at = None
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_id = 'id'
    __SubjectPublicKeyInfo_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SubjectPublicKeyInfo_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab = ___SubjectPublicKeyInfo_algorithm_parameters_tab
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_id = 'Type'
    _SubjectPublicKeyInfo_algorithm._cont = ASN1Dict([
        ('algorithm', __SubjectPublicKeyInfo_algorithm_algorithm),
        ('parameters', __SubjectPublicKeyInfo_algorithm_parameters),
        ])
    _SubjectPublicKeyInfo_algorithm._ext = []
    _SubjectPublicKeyInfo_subjectPublicKey = BIT_STR(name='subjectPublicKey', mode=MODE_TYPE)
    SubjectPublicKeyInfo._cont = ASN1Dict([
        ('algorithm', _SubjectPublicKeyInfo_algorithm),
        ('subjectPublicKey', _SubjectPublicKeyInfo_subjectPublicKey),
        ])
    SubjectPublicKeyInfo._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name='Extensions', mode=MODE_TYPE)
    _Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extension')))
    Extensions._cont = _Extensions__item_
    
    #-----< Extension >-----#
    Extension = SEQ(name='Extension', mode=MODE_TYPE)
    _Extension_extnId = OID(name='extnId', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), ['id']))
    __Extension_extnId_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    __Extension_extnId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_extnId._const_tab = __Extension_extnId_tab
    _Extension_extnId._const_tab_at = None
    _Extension_extnId._const_tab_id = 'id'
    _Extension_critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    _Extension_extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    _Extension_extnValue._const_cont_enc = (2, 1, 2, 1)
    Extension._cont = ASN1Dict([
        ('extnId', _Extension_extnId),
        ('critical', _Extension_critical),
        ('extnValue', _Extension_extnValue),
        ])
    Extension._ext = []
    
    #-----< der >-----#
    der = OID(name='der', mode=MODE_VALUE)
    der._val = (2, 1, 2, 1)
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name='ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name='EXTENSION', mode=MODE_TYPE)
    _EXTENSION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ExtnType = OPEN(name='ExtnType', mode=MODE_TYPE)
    EXTENSION._cont = ASN1Dict([
        ('id', _EXTENSION_id),
        ('ExtnType', _EXTENSION_ExtnType),
        ])
    
    #-----< Certificates >-----#
    Certificates = SEQ(name='Certificates', mode=MODE_TYPE)
    _Certificates_userCertificate = SEQ(name='userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _Certificates_certificationPath = SEQ_OF(name='certificationPath', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ForwardCertificationPath')), opt=True)
    Certificates._cont = ASN1Dict([
        ('userCertificate', _Certificates_userCertificate),
        ('certificationPath', _Certificates_certificationPath),
        ])
    Certificates._ext = []
    
    #-----< ForwardCertificationPath >-----#
    ForwardCertificationPath = SEQ_OF(name='ForwardCertificationPath', mode=MODE_TYPE)
    _ForwardCertificationPath__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CrossCertificates')))
    ForwardCertificationPath._cont = _ForwardCertificationPath__item_
    ForwardCertificationPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CrossCertificates >-----#
    CrossCertificates = SET_OF(name='CrossCertificates', mode=MODE_TYPE)
    _CrossCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    CrossCertificates._cont = _CrossCertificates__item_
    CrossCertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name='CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userCertificate = SEQ(name='userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _CertificationPath_theCACertificates = SEQ_OF(name='theCACertificates', mode=MODE_TYPE, opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    _CertificationPath_theCACertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertificationPath._cont = ASN1Dict([
        ('userCertificate', _CertificationPath_userCertificate),
        ('theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = []
    
    #-----< PkiPath >-----#
    PkiPath = SEQ_OF(name='PkiPath', mode=MODE_TYPE)
    _PkiPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    PkiPath._cont = _PkiPath__item_
    PkiPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificateList >-----#
    CertificateList = SEQ(name='CertificateList', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _CertificateList_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateListContent')))
    _CertificateList_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateList_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___CertificateList_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_algorithm._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_algorithmIdentifier_algorithm._const_tab_at = None
    __CertificateList_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __CertificateList_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___CertificateList_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_parameters._const_tab = ___CertificateList_algorithmIdentifier_parameters_tab
    __CertificateList_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __CertificateList_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _CertificateList_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __CertificateList_algorithmIdentifier_algorithm),
        ('parameters', __CertificateList_algorithmIdentifier_parameters),
        ])
    _CertificateList_algorithmIdentifier._ext = []
    _CertificateList_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    CertificateList._cont = ASN1Dict([
        ('toBeSigned', _CertificateList_toBeSigned),
        ('algorithmIdentifier', _CertificateList_algorithmIdentifier),
        ('encrypted', _CertificateList_encrypted),
        ])
    CertificateList._ext = []
    
    #-----< CertificateListContent >-----#
    CertificateListContent = SEQ(name='CertificateListContent', mode=MODE_TYPE)
    _CertificateListContent_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Version')), opt=True)
    _CertificateListContent_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateListContent_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___CertificateListContent_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_algorithm._const_tab = ___CertificateListContent_signature_algorithm_tab
    __CertificateListContent_signature_algorithm._const_tab_at = None
    __CertificateListContent_signature_algorithm._const_tab_id = 'id'
    __CertificateListContent_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___CertificateListContent_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_parameters._const_tab = ___CertificateListContent_signature_parameters_tab
    __CertificateListContent_signature_parameters._const_tab_at = ('..', 'algorithm')
    __CertificateListContent_signature_parameters._const_tab_id = 'Type'
    _CertificateListContent_signature._cont = ASN1Dict([
        ('algorithm', __CertificateListContent_signature_algorithm),
        ('parameters', __CertificateListContent_signature_parameters),
        ])
    _CertificateListContent_signature._ext = []
    _CertificateListContent_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListContent_thisUpdate = CHOICE(name='thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListContent_nextUpdate = CHOICE(name='nextUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListContent_revokedCertificates = SEQ_OF(name='revokedCertificates', mode=MODE_TYPE, opt=True)
    __CertificateListContent_revokedCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___CertificateListContent_revokedCertificates__item__serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    ___CertificateListContent_revokedCertificates__item__revocationDate = CHOICE(name='revocationDate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    ___CertificateListContent_revokedCertificates__item__crlEntryExtensions = SEQ_OF(name='crlEntryExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    __CertificateListContent_revokedCertificates__item_._cont = ASN1Dict([
        ('serialNumber', ___CertificateListContent_revokedCertificates__item__serialNumber),
        ('revocationDate', ___CertificateListContent_revokedCertificates__item__revocationDate),
        ('crlEntryExtensions', ___CertificateListContent_revokedCertificates__item__crlEntryExtensions),
        ])
    __CertificateListContent_revokedCertificates__item_._ext = []
    _CertificateListContent_revokedCertificates._cont = __CertificateListContent_revokedCertificates__item_
    _CertificateListContent_crlExtensions = SEQ_OF(name='crlExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    CertificateListContent._cont = ASN1Dict([
        ('version', _CertificateListContent_version),
        ('signature', _CertificateListContent_signature),
        ('issuer', _CertificateListContent_issuer),
        ('thisUpdate', _CertificateListContent_thisUpdate),
        ('nextUpdate', _CertificateListContent_nextUpdate),
        ('revokedCertificates', _CertificateListContent_revokedCertificates),
        ('crlExtensions', _CertificateListContent_crlExtensions),
        ])
    CertificateListContent._ext = ['crlExtensions']
    
    #-----< pkiUser >-----#
    pkiUser = CLASS(name='pkiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    pkiUser._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['userCertificate']), ('ldapDesc', 'X.509 user certificate'), ('id', (2, 5, 4, 36))])], rr=[], ev=None, er=[])), ('ldapName', ['pkiUser']), ('ldapDesc', 'X.509 PKI User'), ('id', (2, 5, 6, 21))])
    
    #-----< pkiCA >-----#
    pkiCA = CLASS(name='pkiCA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    pkiCA._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['cACertificate']), ('ldapDesc', 'X.509 CA certificate'), ('id', (2, 5, 4, 37))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), ('ldapName', ['crossCertificatePair']), ('ldapDesc', 'X.509 cross certificate pair'), ('id', (2, 5, 4, 40))])], rr=[], ev=None, er=[])), ('ldapName', ['pkiCA']), ('ldapDesc', 'X.509 PKI Certificate Authority'), ('id', (2, 5, 6, 22))])
    
    #-----< cRLDistributionPoint >-----#
    cRLDistributionPoint = CLASS(name='cRLDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    cRLDistributionPoint._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['cRLDistributionPoint']), ('ldapDesc', 'X.509 CRL distribution point'), ('id', (2, 5, 6, 19))])
    
    #-----< cRLDistPtNameForm >-----#
    cRLDistPtNameForm = CLASS(name='cRLDistPtNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __cRLDistPtNameForm_MandatoryAttributes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    cRLDistPtNameForm._val = dict([('namedObjectClass', dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['cRLDistributionPoint']), ('ldapDesc', 'X.509 CRL distribution point'), ('id', (2, 5, 6, 19))])), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __cRLDistPtNameForm_MandatoryAttributes_val_Type_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('id', (2, 5, 15, 14))])
    
    #-----< deltaCRL >-----#
    deltaCRL = CLASS(name='deltaCRL', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    deltaCRL._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), ('ldapName', ['deltaCRL']), ('ldapDesc', 'X.509 delta CRL'), ('id', (2, 5, 6, 23))])
    
    #-----< cpCps >-----#
    cpCps = CLASS(name='cpCps', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    __pmiUser_OptionalAttributes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    cpCps._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_1), ('id', (2, 5, 4, 69))]), dict([('Type', __pmiUser_OptionalAttributes_val_Type_1_0), ('id', (2, 5, 4, 68))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 30))])
    
    #-----< pkiCertPath >-----#
    pkiCertPath = CLASS(name='pkiCertPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiCertPath._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __pmiUser_OptionalAttributes_val_Type_0_2), ('id', (2, 5, 4, 70))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 31))])
    
    #-----< userCertificate >-----#
    userCertificate = CLASS(name='userCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userCertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    userCertificate._val = dict([('Type', _userCertificate_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['userCertificate']), ('ldapDesc', 'X.509 user certificate'), ('id', (2, 5, 4, 36))])
    
    #-----< cACertificate >-----#
    cACertificate = CLASS(name='cACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _cACertificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    cACertificate._val = dict([('Type', _cACertificate_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), ('ldapName', ['cACertificate']), ('ldapDesc', 'X.509 CA certificate'), ('id', (2, 5, 4, 37))])
    
    #-----< crossCertificatePair >-----#
    crossCertificatePair = CLASS(name='crossCertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _crossCertificatePair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    crossCertificatePair._val = dict([('Type', _crossCertificatePair_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), ('ldapName', ['crossCertificatePair']), ('ldapDesc', 'X.509 cross certificate pair'), ('id', (2, 5, 4, 40))])
    
    #-----< CertificatePair >-----#
    CertificatePair = SEQ(name='CertificatePair', mode=MODE_TYPE)
    _CertificatePair_issuedToThisCA = SEQ(name='issuedToThisCA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificatePair_issuedByThisCA = SEQ(name='issuedByThisCA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    CertificatePair._cont = ASN1Dict([
        ('issuedToThisCA', _CertificatePair_issuedToThisCA),
        ('issuedByThisCA', _CertificatePair_issuedByThisCA),
        ])
    CertificatePair._ext = []
    
    #-----< certificateRevocationList >-----#
    certificateRevocationList = CLASS(name='certificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificateRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    certificateRevocationList._val = dict([('Type', _certificateRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['certificateRevocationList']), ('ldapDesc', 'X.509 certificate revocation list'), ('id', (2, 5, 4, 39))])
    
    #-----< authorityRevocationList >-----#
    authorityRevocationList = CLASS(name='authorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _authorityRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    authorityRevocationList._val = dict([('Type', _authorityRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['authorityRevocationList']), ('ldapDesc', 'X.509 authority revocation list'), ('id', (2, 5, 4, 38))])
    
    #-----< deltaRevocationList >-----#
    deltaRevocationList = CLASS(name='deltaRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _deltaRevocationList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    deltaRevocationList._val = dict([('Type', _deltaRevocationList_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), ('ldapName', ['deltaRevocationList']), ('ldapDesc', 'X.509 delta revocation list'), ('id', (2, 5, 4, 53))])
    
    #-----< supportedAlgorithms >-----#
    supportedAlgorithms = CLASS(name='supportedAlgorithms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedAlgorithms_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab = ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_at = None
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_id = 'id'
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab = ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_at = ('..', 'algorithm')
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_id = 'Type'
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4._cont = ASN1Dict([
        ('algorithm', _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm),
        ('parameters', _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters),
        ])
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4._ext = []
    supportedAlgorithms._val = dict([('Type', _supportedAlgorithms_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), ('ldapName', ['algorithmIdentifierMatch']), ('ldapDesc', 'X.509 Algorithm Identifier Match'), ('id', (2, 5, 13, 40))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)), ('ldapName', ['supportedAlgorithms']), ('ldapDesc', 'X.509 support algorithms'), ('id', (2, 5, 4, 52))])
    
    #-----< SupportedAlgorithm >-----#
    SupportedAlgorithm = SEQ(name='SupportedAlgorithm', mode=MODE_TYPE)
    _SupportedAlgorithm_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SupportedAlgorithm_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab = ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_at = None
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SupportedAlgorithm_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab = ___SupportedAlgorithm_algorithmIdentifier_parameters_tab
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SupportedAlgorithm_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SupportedAlgorithm_algorithmIdentifier_algorithm),
        ('parameters', __SupportedAlgorithm_algorithmIdentifier_parameters),
        ])
    _SupportedAlgorithm_algorithmIdentifier._ext = []
    _SupportedAlgorithm_intendedUsage = BIT_STR(name='intendedUsage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _SupportedAlgorithm_intendedCertificatePolicies = SEQ_OF(name='intendedCertificatePolicies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')), opt=True)
    SupportedAlgorithm._cont = ASN1Dict([
        ('algorithmIdentifier', _SupportedAlgorithm_algorithmIdentifier),
        ('intendedUsage', _SupportedAlgorithm_intendedUsage),
        ('intendedCertificatePolicies', _SupportedAlgorithm_intendedCertificatePolicies),
        ])
    SupportedAlgorithm._ext = []
    
    #-----< certificationPracticeStmt >-----#
    certificationPracticeStmt = CLASS(name='certificationPracticeStmt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificationPracticeStmt_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    certificationPracticeStmt._val = dict([('Type', _certificationPracticeStmt_val_Type), ('id', (2, 5, 4, 68))])
    
    #-----< InfoSyntax >-----#
    InfoSyntax = CHOICE(name='InfoSyntax', mode=MODE_TYPE)
    _InfoSyntax_content = CHOICE(name='content', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _InfoSyntax_pointer = SEQ(name='pointer', mode=MODE_TYPE)
    __InfoSyntax_pointer_name = SEQ_OF(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    __InfoSyntax_pointer_hash = SEQ(name='hash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')), opt=True)
    ___InfoSyntax_pointer_hash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_at = None
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___InfoSyntax_pointer_hash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm),
        ('parameters', ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters),
        ])
    ___InfoSyntax_pointer_hash_algorithmIdentifier._ext = []
    ___InfoSyntax_pointer_hash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    __InfoSyntax_pointer_hash._cont = ASN1Dict([
        ('algorithmIdentifier', ___InfoSyntax_pointer_hash_algorithmIdentifier),
        ('hashValue', ___InfoSyntax_pointer_hash_hashValue),
        ])
    __InfoSyntax_pointer_hash._ext = []
    _InfoSyntax_pointer._cont = ASN1Dict([
        ('name', __InfoSyntax_pointer_name),
        ('hash', __InfoSyntax_pointer_hash),
        ])
    _InfoSyntax_pointer._ext = []
    InfoSyntax._cont = ASN1Dict([
        ('content', _InfoSyntax_content),
        ('pointer', _InfoSyntax_pointer),
        ])
    InfoSyntax._ext = []
    
    #-----< POLICY >-----#
    POLICY = CLASS(name='POLICY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< HashedPolicyInfo >-----#
    HashedPolicyInfo = OPEN(name='HashedPolicyInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'POLICY'), ['Type']))
    _HashedPolicyInfo_tab = CLASS(name='_tab_POLICY', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    _HashedPolicyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    HashedPolicyInfo._const_tab = _HashedPolicyInfo_tab
    HashedPolicyInfo._const_tab_at = None
    HashedPolicyInfo._const_tab_id = 'Type'
    
    #-----< Policies >-----#
    Policies = CLASS(name='Policies', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    Policies._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< certificatePolicy >-----#
    certificatePolicy = CLASS(name='certificatePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificatePolicy_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    certificatePolicy._val = dict([('Type', _certificatePolicy_val_Type), ('id', (2, 5, 4, 69))])
    
    #-----< PolicySyntax >-----#
    PolicySyntax = SEQ(name='PolicySyntax', mode=MODE_TYPE)
    _PolicySyntax_policyIdentifier = OID(name='policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    _PolicySyntax_policySyntax = CHOICE(name='policySyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PolicySyntax._cont = ASN1Dict([
        ('policyIdentifier', _PolicySyntax_policyIdentifier),
        ('policySyntax', _PolicySyntax_policySyntax),
        ])
    PolicySyntax._ext = []
    
    #-----< PolicyID >-----#
    PolicyID = OID(name='PolicyID', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    
    #-----< pkiPath >-----#
    pkiPath = CLASS(name='pkiPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pkiPath_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiPath._val = dict([('Type', _pkiPath_val_Type), ('id', (2, 5, 4, 70))])
    
    #-----< userPassword >-----#
    userPassword = CLASS(name='userPassword', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPassword_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    _userPassword_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_5 = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    userPassword._val = dict([('Type', _userPassword_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['userPassword']), ('id', (2, 5, 4, 35))])
    
    #-----< userPwd >-----#
    userPwd = CLASS(name='userPwd', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwd_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_6 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwd._val = dict([('Type', _userPwd_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_6), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwd']), ('id', (2, 5, 4, 85))])
    
    #-----< UserPwd >-----#
    UserPwd = CHOICE(name='UserPwd', mode=MODE_TYPE)
    _UserPwd_clear = STR_UTF8(name='clear', mode=MODE_TYPE)
    _UserPwd_encrypted = SEQ(name='encrypted', mode=MODE_TYPE)
    __UserPwd_encrypted_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UserPwd_encrypted_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab = ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_at = None
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___UserPwd_encrypted_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab = ____UserPwd_encrypted_algorithmIdentifier_parameters_tab
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __UserPwd_encrypted_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___UserPwd_encrypted_algorithmIdentifier_algorithm),
        ('parameters', ___UserPwd_encrypted_algorithmIdentifier_parameters),
        ])
    __UserPwd_encrypted_algorithmIdentifier._ext = []
    __UserPwd_encrypted_encryptedString = OCT_STR(name='encryptedString', mode=MODE_TYPE)
    _UserPwd_encrypted._cont = ASN1Dict([
        ('algorithmIdentifier', __UserPwd_encrypted_algorithmIdentifier),
        ('encryptedString', __UserPwd_encrypted_encryptedString),
        ])
    _UserPwd_encrypted._ext = []
    UserPwd._cont = ASN1Dict([
        ('clear', _UserPwd_clear),
        ('encrypted', _UserPwd_encrypted),
        ])
    UserPwd._ext = []
    
    #-----< pwdStartTime >-----#
    pwdStartTime = CLASS(name='pwdStartTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdStartTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7 = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    __pwdStartTime_ordering_match_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    pwdStartTime._val = dict([('Type', _pwdStartTime_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdStartTime']), ('id', (2, 5, 18, 22))])
    
    #-----< pwdExpiryTime >-----#
    pwdExpiryTime = CLASS(name='pwdExpiryTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdExpiryTime._val = dict([('Type', _pwdExpiryTime_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdExpiryTime']), ('id', (2, 5, 18, 23))])
    
    #-----< pwdEndTime >-----#
    pwdEndTime = CLASS(name='pwdEndTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEndTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdEndTime._val = dict([('Type', _pwdEndTime_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdEndTime']), ('id', (2, 5, 18, 24))])
    
    #-----< pwdFails >-----#
    pwdFails = CLASS(name='pwdFails', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFails_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdFails_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8 = INT(name='AssertionType', mode=MODE_TYPE)
    __pwdStartTime_ordering_match_val_AssertionType_0 = INT(name='AssertionType', mode=MODE_TYPE)
    pwdFails._val = dict([('Type', _pwdFails_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdFails']), ('id', (2, 5, 18, 25))])
    
    #-----< pwdFailureTime >-----#
    pwdFailureTime = CLASS(name='pwdFailureTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    pwdFailureTime._val = dict([('Type', _pwdFailureTime_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['pwdFailureTime']), ('id', (2, 5, 18, 26))])
    
    #-----< pwdGracesUsed >-----#
    pwdGracesUsed = CLASS(name='pwdGracesUsed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGracesUsed_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdGracesUsed_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGracesUsed._val = dict([('Type', _pwdGracesUsed_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdGracesUsed']), ('id', (2, 5, 18, 27))])
    
    #-----< userPwdHistory >-----#
    userPwdHistory = CLASS(name='userPwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdHistory_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'PwdHistory')))
    __userPwdHistory_val_Type_time = TIME_GEN(name='time', mode=MODE_TYPE)
    __userPwdHistory_val_Type_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    _userPwdHistory_val_Type._cont = ASN1Dict([
        ('time', __userPwdHistory_val_Type_time),
        ('password', __userPwdHistory_val_Type_Type),
        ])
    _userPwdHistory_val_Type._ext = []
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwdHistory._val = dict([('Type', _userPwdHistory_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_Type), ('id', (2, 5, 13, 72))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 28))])
    
    #-----< userPwdRecentlyExpired >-----#
    userPwdRecentlyExpired = CLASS(name='userPwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdRecentlyExpired_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwdRecentlyExpired._val = dict([('Type', _userPwdRecentlyExpired_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_6), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 29))])
    
    #-----< pwdModifyEntryAllowed >-----#
    pwdModifyEntryAllowed = CLASS(name='pwdModifyEntryAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdModifyEntryAllowed_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_9 = BOOL(name='AssertionType', mode=MODE_TYPE)
    pwdModifyEntryAllowed._val = dict([('Type', _pwdModifyEntryAllowed_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), ('ldapName', ['pwdModifyEntryAllowed']), ('id', (2, 5, 18, 30))])
    
    #-----< pwdChangeAllowed >-----#
    pwdChangeAllowed = CLASS(name='pwdChangeAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdChangeAllowed_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    pwdChangeAllowed._val = dict([('Type', _pwdChangeAllowed_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), ('ldapName', ['pwdChangeAllowed']), ('id', (2, 5, 18, 31))])
    
    #-----< pwdMaxAge >-----#
    pwdMaxAge = CLASS(name='pwdMaxAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxAge_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxAge._val = dict([('Type', _pwdMaxAge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxAge']), ('id', (2, 5, 18, 32))])
    
    #-----< pwdExpiryAge >-----#
    pwdExpiryAge = CLASS(name='pwdExpiryAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryAge_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdExpiryAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryAge._val = dict([('Type', _pwdExpiryAge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdExpiryAge']), ('id', (2, 5, 18, 33))])
    
    #-----< pwdMinLength >-----#
    pwdMinLength = CLASS(name='pwdMinLength', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinLength_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMinLength_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinLength._val = dict([('Type', _pwdMinLength_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMinLength']), ('id', (2, 5, 18, 34))])
    
    #-----< pwdVocabulary >-----#
    pwdVocabulary = CLASS(name='pwdVocabulary', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdVocabulary_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdVocabulary')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_10 = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    pwdVocabulary._val = dict([('Type', _pwdVocabulary_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 1)), ('ldapName', ['pwdVocabulary']), ('id', (2, 5, 18, 35))])
    
    #-----< PwdVocabulary >-----#
    PwdVocabulary = BIT_STR(name='PwdVocabulary', mode=MODE_TYPE)
    PwdVocabulary._cont = ASN1Dict([('noDictionaryWords', 0), ('noPersonNames', 1), ('noGeographicalNames', 2)])
    
    #-----< pwdAlphabet >-----#
    pwdAlphabet = CLASS(name='pwdAlphabet', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAlphabet_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdAlphabet')))
    pwdAlphabet._val = dict([('Type', _pwdAlphabet_val_Type), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 2)), ('ldapName', ['pwdAlphabet']), ('id', (2, 5, 18, 36))])
    
    #-----< PwdAlphabet >-----#
    PwdAlphabet = SEQ_OF(name='PwdAlphabet', mode=MODE_TYPE)
    _PwdAlphabet__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    PwdAlphabet._cont = _PwdAlphabet__item_
    
    #-----< pwdDictionaries >-----#
    pwdDictionaries = CLASS(name='pwdDictionaries', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType__11 = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    pwdDictionaries._val = dict([('derivation', dict([('Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType__11), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['pwdDictionaries']), ('id', (2, 5, 18, 37))])
    
    #-----< pwdExpiryWarning >-----#
    pwdExpiryWarning = CLASS(name='pwdExpiryWarning', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryWarning_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdExpiryWarning_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryWarning._val = dict([('Type', _pwdExpiryWarning_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdExpiryWarning']), ('id', (2, 5, 18, 38))])
    
    #-----< pwdGraces >-----#
    pwdGraces = CLASS(name='pwdGraces', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGraces_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdGraces_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGraces._val = dict([('Type', _pwdGraces_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdGraces']), ('id', (2, 5, 18, 39))])
    
    #-----< pwdFailureDuration >-----#
    pwdFailureDuration = CLASS(name='pwdFailureDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdFailureDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdFailureDuration._val = dict([('Type', _pwdFailureDuration_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdFailureDuration']), ('id', (2, 5, 18, 40))])
    
    #-----< pwdLockoutDuration >-----#
    pwdLockoutDuration = CLASS(name='pwdLockoutDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdLockoutDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdLockoutDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdLockoutDuration._val = dict([('Type', _pwdLockoutDuration_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdLockoutDuration']), ('id', (2, 5, 18, 41))])
    
    #-----< pwdMaxFailures >-----#
    pwdMaxFailures = CLASS(name='pwdMaxFailures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxFailures_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxFailures_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxFailures._val = dict([('Type', _pwdMaxFailures_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxFailures']), ('id', (2, 5, 18, 42))])
    
    #-----< pwdMaxTimeInHistory >-----#
    pwdMaxTimeInHistory = CLASS(name='pwdMaxTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxTimeInHistory_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMaxTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxTimeInHistory._val = dict([('Type', _pwdMaxTimeInHistory_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMaxTimeInHistory']), ('id', (2, 5, 18, 43))])
    
    #-----< pwdMinTimeInHistory >-----#
    pwdMinTimeInHistory = CLASS(name='pwdMinTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinTimeInHistory_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdMinTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinTimeInHistory._val = dict([('Type', _pwdMinTimeInHistory_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdMinTimeInHistory']), ('id', (2, 5, 18, 44))])
    
    #-----< pwdHistorySlots >-----#
    pwdHistorySlots = CLASS(name='pwdHistorySlots', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdHistorySlots_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdHistorySlots_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=None)], ev=None, er=[])
    pwdHistorySlots._val = dict([('Type', _pwdHistorySlots_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdHistorySlots']), ('id', (2, 5, 18, 45))])
    
    #-----< pwdRecentlyExpiredDuration >-----#
    pwdRecentlyExpiredDuration = CLASS(name='pwdRecentlyExpiredDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdRecentlyExpiredDuration_val_Type = INT(name='Type', mode=MODE_TYPE)
    _pwdRecentlyExpiredDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdRecentlyExpiredDuration._val = dict([('Type', _pwdRecentlyExpiredDuration_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __pwdStartTime_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['pwdRecentlyExpiredDuration']), ('id', (2, 5, 18, 46))])
    
    #-----< pwdEncAlg >-----#
    pwdEncAlg = CLASS(name='pwdEncAlg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEncAlg_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdEncAlg')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType___12 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdEncAlg')))
    pwdEncAlg._val = dict([('Type', _pwdEncAlg_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType___12), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlgMatch']), ('id', (2, 5, 13, 73))])), ('single-valued', True), ('usage', 'directoryOperation'), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlg']), ('id', (2, 5, 18, 47))])
    
    #-----< PwdEncAlg >-----#
    PwdEncAlg = SEQ(name='PwdEncAlg', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _PwdEncAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    __PwdEncAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_algorithm._const_tab = __PwdEncAlg_algorithm_tab
    _PwdEncAlg_algorithm._const_tab_at = None
    _PwdEncAlg_algorithm._const_tab_id = 'id'
    _PwdEncAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    __PwdEncAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_parameters._const_tab = __PwdEncAlg_parameters_tab
    _PwdEncAlg_parameters._const_tab_at = ('..', 'algorithm')
    _PwdEncAlg_parameters._const_tab_id = 'Type'
    PwdEncAlg._cont = ASN1Dict([
        ('algorithm', _PwdEncAlg_algorithm),
        ('parameters', _PwdEncAlg_parameters),
        ])
    PwdEncAlg._ext = []
    
    #-----< userPwdMatch >-----#
    userPwdMatch = CLASS(name='userPwdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwdMatch._val = dict([('AssertionType', _userPwdMatch_val_AssertionType), ('ldapSyntax', (2, 5, 40, 0)), ('ldapName', ['userPwdMatch']), ('id', (2, 5, 13, 71))])
    
    #-----< pwdEncAlgMatch >-----#
    pwdEncAlgMatch = CLASS(name='pwdEncAlgMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pwdEncAlgMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdEncAlg')))
    pwdEncAlgMatch._val = dict([('AssertionType', _pwdEncAlgMatch_val_AssertionType), ('ldapSyntax', (2, 5, 40, 3)), ('ldapName', ['pwdEncAlgMatch']), ('id', (2, 5, 13, 73))])
    
    #-----< userPwdHistoryMatch >-----#
    userPwdHistoryMatch = CLASS(name='userPwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdHistoryMatch_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwdHistoryMatch._val = dict([('AssertionType', _userPwdHistoryMatch_val_Type), ('id', (2, 5, 13, 72))])
    
    #-----< userPwdDescription >-----#
    userPwdDescription = CLASS(name='userPwdDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _userPwdDescription_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    userPwdDescription._val = dict([('ldapDesc', 'User Password Description'), ('Type', _userPwdDescription_val_Type), ('id', (2, 5, 40, 0))])
    
    #-----< pwdVocabularyDescription >-----#
    pwdVocabularyDescription = CLASS(name='pwdVocabularyDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdVocabularyDescription_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdVocabulary')))
    pwdVocabularyDescription._val = dict([('ldapDesc', 'Password Vocabulary Description'), ('Type', _pwdVocabularyDescription_val_Type), ('id', (2, 5, 40, 1))])
    
    #-----< pwdAlphabetDescription >-----#
    pwdAlphabetDescription = CLASS(name='pwdAlphabetDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdAlphabetDescription_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdAlphabet')))
    pwdAlphabetDescription._val = dict([('ldapDesc', 'Password Alphabet Description'), ('Type', _pwdAlphabetDescription_val_Type), ('id', (2, 5, 40, 2))])
    
    #-----< pwdEncAlgDescription >-----#
    pwdEncAlgDescription = CLASS(name='pwdEncAlgDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdEncAlgDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PwdEncAlg')))
    pwdEncAlgDescription._val = dict([('ldapDesc', 'Password Alphabet Description'), ('Type', _pwdEncAlgDescription_val_Type), ('id', (2, 5, 40, 3))])
    
    #-----< x509Certificate >-----#
    x509Certificate = CLASS(name='x509Certificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509Certificate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    x509Certificate._val = dict([('ldapDesc', 'X.509 Certificate'), ('Type', _x509Certificate_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8))])
    
    #-----< x509CertificateList >-----#
    x509CertificateList = CLASS(name='x509CertificateList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificateList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    x509CertificateList._val = dict([('ldapDesc', 'X.509 Certificate List'), ('Type', _x509CertificateList_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9))])
    
    #-----< x509CertificatePair >-----#
    x509CertificatePair = CLASS(name='x509CertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificatePair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    x509CertificatePair._val = dict([('ldapDesc', 'X.509 Certificate Pair'), ('Type', _x509CertificatePair_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10))])
    
    #-----< x509SupportedAlgorithm >-----#
    x509SupportedAlgorithm = CLASS(name='x509SupportedAlgorithm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509SupportedAlgorithm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    x509SupportedAlgorithm._val = dict([('ldapDesc', 'X.509 Supported Algorithm'), ('Type', _x509SupportedAlgorithm_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49))])
    
    #-----< id-oc-cRLDistributionPoint >-----#
    id_oc_cRLDistributionPoint = OID(name='id-oc-cRLDistributionPoint', mode=MODE_VALUE)
    id_oc_cRLDistributionPoint._val = (2, 5, 6, 19)
    
    #-----< id-oc-pkiUser >-----#
    id_oc_pkiUser = OID(name='id-oc-pkiUser', mode=MODE_VALUE)
    id_oc_pkiUser._val = (2, 5, 6, 21)
    
    #-----< id-oc-pkiCA >-----#
    id_oc_pkiCA = OID(name='id-oc-pkiCA', mode=MODE_VALUE)
    id_oc_pkiCA._val = (2, 5, 6, 22)
    
    #-----< id-oc-deltaCRL >-----#
    id_oc_deltaCRL = OID(name='id-oc-deltaCRL', mode=MODE_VALUE)
    id_oc_deltaCRL._val = (2, 5, 6, 23)
    
    #-----< id-oc-cpCps >-----#
    id_oc_cpCps = OID(name='id-oc-cpCps', mode=MODE_VALUE)
    id_oc_cpCps._val = (2, 5, 6, 30)
    
    #-----< id-oc-pkiCertPath >-----#
    id_oc_pkiCertPath = OID(name='id-oc-pkiCertPath', mode=MODE_VALUE)
    id_oc_pkiCertPath._val = (2, 5, 6, 31)
    
    #-----< id-nf-cRLDistPtNameForm >-----#
    id_nf_cRLDistPtNameForm = OID(name='id-nf-cRLDistPtNameForm', mode=MODE_VALUE)
    id_nf_cRLDistPtNameForm._val = (2, 5, 15, 14)
    
    #-----< id-at-userPassword >-----#
    id_at_userPassword = OID(name='id-at-userPassword', mode=MODE_VALUE)
    id_at_userPassword._val = (2, 5, 4, 35)
    
    #-----< id-at-userCertificate >-----#
    id_at_userCertificate = OID(name='id-at-userCertificate', mode=MODE_VALUE)
    id_at_userCertificate._val = (2, 5, 4, 36)
    
    #-----< id-at-cAcertificate >-----#
    id_at_cAcertificate = OID(name='id-at-cAcertificate', mode=MODE_VALUE)
    id_at_cAcertificate._val = (2, 5, 4, 37)
    
    #-----< id-at-authorityRevocationList >-----#
    id_at_authorityRevocationList = OID(name='id-at-authorityRevocationList', mode=MODE_VALUE)
    id_at_authorityRevocationList._val = (2, 5, 4, 38)
    
    #-----< id-at-certificateRevocationList >-----#
    id_at_certificateRevocationList = OID(name='id-at-certificateRevocationList', mode=MODE_VALUE)
    id_at_certificateRevocationList._val = (2, 5, 4, 39)
    
    #-----< id-at-crossCertificatePair >-----#
    id_at_crossCertificatePair = OID(name='id-at-crossCertificatePair', mode=MODE_VALUE)
    id_at_crossCertificatePair._val = (2, 5, 4, 40)
    
    #-----< id-at-supportedAlgorithms >-----#
    id_at_supportedAlgorithms = OID(name='id-at-supportedAlgorithms', mode=MODE_VALUE)
    id_at_supportedAlgorithms._val = (2, 5, 4, 52)
    
    #-----< id-at-deltaRevocationList >-----#
    id_at_deltaRevocationList = OID(name='id-at-deltaRevocationList', mode=MODE_VALUE)
    id_at_deltaRevocationList._val = (2, 5, 4, 53)
    
    #-----< id-at-certificationPracticeStmt >-----#
    id_at_certificationPracticeStmt = OID(name='id-at-certificationPracticeStmt', mode=MODE_VALUE)
    id_at_certificationPracticeStmt._val = (2, 5, 4, 68)
    
    #-----< id-at-certificatePolicy >-----#
    id_at_certificatePolicy = OID(name='id-at-certificatePolicy', mode=MODE_VALUE)
    id_at_certificatePolicy._val = (2, 5, 4, 69)
    
    #-----< id-at-pkiPath >-----#
    id_at_pkiPath = OID(name='id-at-pkiPath', mode=MODE_VALUE)
    id_at_pkiPath._val = (2, 5, 4, 70)
    
    #-----< id-at-userPwd >-----#
    id_at_userPwd = OID(name='id-at-userPwd', mode=MODE_VALUE)
    id_at_userPwd._val = (2, 5, 4, 85)
    
    #-----< id-oa-pwdStartTime >-----#
    id_oa_pwdStartTime = OID(name='id-oa-pwdStartTime', mode=MODE_VALUE)
    id_oa_pwdStartTime._val = (2, 5, 18, 22)
    
    #-----< id-oa-pwdExpiryTime >-----#
    id_oa_pwdExpiryTime = OID(name='id-oa-pwdExpiryTime', mode=MODE_VALUE)
    id_oa_pwdExpiryTime._val = (2, 5, 18, 23)
    
    #-----< id-oa-pwdEndTime >-----#
    id_oa_pwdEndTime = OID(name='id-oa-pwdEndTime', mode=MODE_VALUE)
    id_oa_pwdEndTime._val = (2, 5, 18, 24)
    
    #-----< id-oa-pwdFails >-----#
    id_oa_pwdFails = OID(name='id-oa-pwdFails', mode=MODE_VALUE)
    id_oa_pwdFails._val = (2, 5, 18, 25)
    
    #-----< id-oa-pwdFailureTime >-----#
    id_oa_pwdFailureTime = OID(name='id-oa-pwdFailureTime', mode=MODE_VALUE)
    id_oa_pwdFailureTime._val = (2, 5, 18, 26)
    
    #-----< id-oa-pwdGracesUsed >-----#
    id_oa_pwdGracesUsed = OID(name='id-oa-pwdGracesUsed', mode=MODE_VALUE)
    id_oa_pwdGracesUsed._val = (2, 5, 18, 27)
    
    #-----< id-oa-userPwdHistory >-----#
    id_oa_userPwdHistory = OID(name='id-oa-userPwdHistory', mode=MODE_VALUE)
    id_oa_userPwdHistory._val = (2, 5, 18, 28)
    
    #-----< id-oa-userPwdRecentlyExpired >-----#
    id_oa_userPwdRecentlyExpired = OID(name='id-oa-userPwdRecentlyExpired', mode=MODE_VALUE)
    id_oa_userPwdRecentlyExpired._val = (2, 5, 18, 29)
    
    #-----< id-oa-pwdModifyEntryAllowed >-----#
    id_oa_pwdModifyEntryAllowed = OID(name='id-oa-pwdModifyEntryAllowed', mode=MODE_VALUE)
    id_oa_pwdModifyEntryAllowed._val = (2, 5, 18, 30)
    
    #-----< id-oa-pwdChangeAllowed >-----#
    id_oa_pwdChangeAllowed = OID(name='id-oa-pwdChangeAllowed', mode=MODE_VALUE)
    id_oa_pwdChangeAllowed._val = (2, 5, 18, 31)
    
    #-----< id-oa-pwdMaxAge >-----#
    id_oa_pwdMaxAge = OID(name='id-oa-pwdMaxAge', mode=MODE_VALUE)
    id_oa_pwdMaxAge._val = (2, 5, 18, 32)
    
    #-----< id-oa-pwdExpiryAge >-----#
    id_oa_pwdExpiryAge = OID(name='id-oa-pwdExpiryAge', mode=MODE_VALUE)
    id_oa_pwdExpiryAge._val = (2, 5, 18, 33)
    
    #-----< id-oa-pwdMinLength >-----#
    id_oa_pwdMinLength = OID(name='id-oa-pwdMinLength', mode=MODE_VALUE)
    id_oa_pwdMinLength._val = (2, 5, 18, 34)
    
    #-----< id-oa-pwdVocabulary >-----#
    id_oa_pwdVocabulary = OID(name='id-oa-pwdVocabulary', mode=MODE_VALUE)
    id_oa_pwdVocabulary._val = (2, 5, 18, 35)
    
    #-----< id-oa-pwdAlphabet >-----#
    id_oa_pwdAlphabet = OID(name='id-oa-pwdAlphabet', mode=MODE_VALUE)
    id_oa_pwdAlphabet._val = (2, 5, 18, 36)
    
    #-----< id-oa-pwdDictionaries >-----#
    id_oa_pwdDictionaries = OID(name='id-oa-pwdDictionaries', mode=MODE_VALUE)
    id_oa_pwdDictionaries._val = (2, 5, 18, 37)
    
    #-----< id-oa-pwdExpiryWarning >-----#
    id_oa_pwdExpiryWarning = OID(name='id-oa-pwdExpiryWarning', mode=MODE_VALUE)
    id_oa_pwdExpiryWarning._val = (2, 5, 18, 38)
    
    #-----< id-oa-pwdGraces >-----#
    id_oa_pwdGraces = OID(name='id-oa-pwdGraces', mode=MODE_VALUE)
    id_oa_pwdGraces._val = (2, 5, 18, 39)
    
    #-----< id-oa-pwdFailureDuration >-----#
    id_oa_pwdFailureDuration = OID(name='id-oa-pwdFailureDuration', mode=MODE_VALUE)
    id_oa_pwdFailureDuration._val = (2, 5, 18, 40)
    
    #-----< id-oa-pwdLockoutDuration >-----#
    id_oa_pwdLockoutDuration = OID(name='id-oa-pwdLockoutDuration', mode=MODE_VALUE)
    id_oa_pwdLockoutDuration._val = (2, 5, 18, 41)
    
    #-----< id-oa-pwdMaxFailures >-----#
    id_oa_pwdMaxFailures = OID(name='id-oa-pwdMaxFailures', mode=MODE_VALUE)
    id_oa_pwdMaxFailures._val = (2, 5, 18, 42)
    
    #-----< id-oa-pwdMaxTimeInHistory >-----#
    id_oa_pwdMaxTimeInHistory = OID(name='id-oa-pwdMaxTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMaxTimeInHistory._val = (2, 5, 18, 43)
    
    #-----< id-oa-pwdMinTimeInHistory >-----#
    id_oa_pwdMinTimeInHistory = OID(name='id-oa-pwdMinTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMinTimeInHistory._val = (2, 5, 18, 44)
    
    #-----< id-oa-pwdHistorySlots >-----#
    id_oa_pwdHistorySlots = OID(name='id-oa-pwdHistorySlots', mode=MODE_VALUE)
    id_oa_pwdHistorySlots._val = (2, 5, 18, 45)
    
    #-----< id-oa-pwdRecentlyExpiredDuration >-----#
    id_oa_pwdRecentlyExpiredDuration = OID(name='id-oa-pwdRecentlyExpiredDuration', mode=MODE_VALUE)
    id_oa_pwdRecentlyExpiredDuration._val = (2, 5, 18, 46)
    
    #-----< id-oa-pwdEncAlg >-----#
    id_oa_pwdEncAlg = OID(name='id-oa-pwdEncAlg', mode=MODE_VALUE)
    id_oa_pwdEncAlg._val = (2, 5, 18, 47)
    
    #-----< id-mr-userPwdMatch >-----#
    id_mr_userPwdMatch = OID(name='id-mr-userPwdMatch', mode=MODE_VALUE)
    id_mr_userPwdMatch._val = (2, 5, 13, 71)
    
    #-----< id-mr-userPwdHistoryMatch >-----#
    id_mr_userPwdHistoryMatch = OID(name='id-mr-userPwdHistoryMatch', mode=MODE_VALUE)
    id_mr_userPwdHistoryMatch._val = (2, 5, 13, 72)
    
    #-----< id-mr-pwdEncAlgMatch >-----#
    id_mr_pwdEncAlgMatch = OID(name='id-mr-pwdEncAlgMatch', mode=MODE_VALUE)
    id_mr_pwdEncAlgMatch._val = (2, 5, 13, 73)
    
    #-----< id-asx-userPwdDescription >-----#
    id_asx_userPwdDescription = OID(name='id-asx-userPwdDescription', mode=MODE_VALUE)
    id_asx_userPwdDescription._val = (2, 5, 40, 0)
    
    #-----< id-asx-pwdVocabularyDescription >-----#
    id_asx_pwdVocabularyDescription = OID(name='id-asx-pwdVocabularyDescription', mode=MODE_VALUE)
    id_asx_pwdVocabularyDescription._val = (2, 5, 40, 1)
    
    #-----< id-asx-pwdAlphabetDescription >-----#
    id_asx_pwdAlphabetDescription = OID(name='id-asx-pwdAlphabetDescription', mode=MODE_VALUE)
    id_asx_pwdAlphabetDescription._val = (2, 5, 40, 2)
    
    #-----< id-asx-pwdEncAlgDescription >-----#
    id_asx_pwdEncAlgDescription = OID(name='id-asx-pwdEncAlgDescription', mode=MODE_VALUE)
    id_asx_pwdEncAlgDescription._val = (2, 5, 40, 3)
    
    #-----< id-lsx-x509Certificate >-----#
    id_lsx_x509Certificate = OID(name='id-lsx-x509Certificate', mode=MODE_VALUE)
    id_lsx_x509Certificate._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)
    
    #-----< id-lsx-x509CertificateList >-----#
    id_lsx_x509CertificateList = OID(name='id-lsx-x509CertificateList', mode=MODE_VALUE)
    id_lsx_x509CertificateList._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)
    
    #-----< id-lsx-x509CertificatePair >-----#
    id_lsx_x509CertificatePair = OID(name='id-lsx-x509CertificatePair', mode=MODE_VALUE)
    id_lsx_x509CertificatePair._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)
    
    #-----< id-lsx-x509SupportedAlgorithm >-----#
    id_lsx_x509SupportedAlgorithm = OID(name='id-lsx-x509SupportedAlgorithm', mode=MODE_VALUE)
    id_lsx_x509SupportedAlgorithm._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)
    
    #-----< id-ecPublicKey >-----#
    id_ecPublicKey = OID(name='id-ecPublicKey', mode=MODE_VALUE)
    id_ecPublicKey._val = (1, 2, 840, 10045, 2, 1)
    
    _all_ = [
        ENCRYPTED,
        ___HASH_algorithmIdentifier_algorithm_tab,
        __HASH_algorithmIdentifier_algorithm,
        ___HASH_algorithmIdentifier_parameters_tab,
        __HASH_algorithmIdentifier_parameters,
        _HASH_algorithmIdentifier,
        _HASH_hashValue,
        HASH,
        ENCRYPTED_HASH,
        ___SIGNATURE_algorithmIdentifier_algorithm_tab,
        __SIGNATURE_algorithmIdentifier_algorithm,
        ___SIGNATURE_algorithmIdentifier_parameters_tab,
        __SIGNATURE_algorithmIdentifier_parameters,
        _SIGNATURE_algorithmIdentifier,
        _SIGNATURE_encrypted,
        SIGNATURE,
        _Certificate_toBeSigned,
        ___Certificate_algorithmIdentifier_algorithm_tab,
        __Certificate_algorithmIdentifier_algorithm,
        ___Certificate_algorithmIdentifier_parameters_tab,
        __Certificate_algorithmIdentifier_parameters,
        _Certificate_algorithmIdentifier,
        _Certificate_encrypted,
        Certificate,
        _TBSCertificate_version,
        _TBSCertificate_serialNumber,
        ___TBSCertificate_signature_algorithm_tab,
        __TBSCertificate_signature_algorithm,
        ___TBSCertificate_signature_parameters_tab,
        __TBSCertificate_signature_parameters,
        _TBSCertificate_signature,
        _TBSCertificate_issuer,
        _TBSCertificate_validity,
        _TBSCertificate_subject,
        _TBSCertificate_subjectPublicKeyInfo,
        _TBSCertificate_issuerUniqueIdentifier,
        _TBSCertificate_subjectUniqueIdentifier,
        _TBSCertificate_extensions,
        TBSCertificate,
        Version,
        CertificateSerialNumber,
        SupportedAlgorithms,
        _ALGORITHM_Type,
        _ALGORITHM_id,
        ALGORITHM,
        ecPublicKey,
        _ecPublicKey_val_Type,
        SupportedCurves,
        dummyCurv,
        _Validity_notBefore,
        _Validity_notAfter,
        Validity,
        ___SubjectPublicKeyInfo_algorithm_algorithm_tab,
        __SubjectPublicKeyInfo_algorithm_algorithm,
        ___SubjectPublicKeyInfo_algorithm_parameters_tab,
        __SubjectPublicKeyInfo_algorithm_parameters,
        _SubjectPublicKeyInfo_algorithm,
        _SubjectPublicKeyInfo_subjectPublicKey,
        SubjectPublicKeyInfo,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _Extensions__item_,
        Extensions,
        __Extension_extnId_tab,
        _Extension_extnId,
        _Extension_critical,
        _Extension_extnValue,
        Extension,
        der,
        ExtensionSet,
        _EXTENSION_id,
        _EXTENSION_ExtnType,
        EXTENSION,
        _Certificates_userCertificate,
        _Certificates_certificationPath,
        Certificates,
        _ForwardCertificationPath__item_,
        ForwardCertificationPath,
        _CrossCertificates__item_,
        CrossCertificates,
        _CertificationPath_userCertificate,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _PkiPath__item_,
        PkiPath,
        _CertificateList_toBeSigned,
        ___CertificateList_algorithmIdentifier_algorithm_tab,
        __CertificateList_algorithmIdentifier_algorithm,
        ___CertificateList_algorithmIdentifier_parameters_tab,
        __CertificateList_algorithmIdentifier_parameters,
        _CertificateList_algorithmIdentifier,
        _CertificateList_encrypted,
        CertificateList,
        _CertificateListContent_version,
        ___CertificateListContent_signature_algorithm_tab,
        __CertificateListContent_signature_algorithm,
        ___CertificateListContent_signature_parameters_tab,
        __CertificateListContent_signature_parameters,
        _CertificateListContent_signature,
        _CertificateListContent_issuer,
        _CertificateListContent_thisUpdate,
        _CertificateListContent_nextUpdate,
        ___CertificateListContent_revokedCertificates__item__serialNumber,
        ___CertificateListContent_revokedCertificates__item__revocationDate,
        ___CertificateListContent_revokedCertificates__item__crlEntryExtensions,
        __CertificateListContent_revokedCertificates__item_,
        _CertificateListContent_revokedCertificates,
        _CertificateListContent_crlExtensions,
        CertificateListContent,
        pkiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        pkiCA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1,
        __pmiUser_OptionalAttributes_val_Type_2,
        __pmiUser_OptionalAttributes_val_Type_3,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2,
        cRLDistributionPoint,
        ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3,
        _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        cRLDistPtNameForm,
        __cRLDistPtNameForm_MandatoryAttributes_val_Type_0,
        deltaCRL,
        cpCps,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        __pmiUser_OptionalAttributes_val_Type_1_0,
        pkiCertPath,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        userCertificate,
        _userCertificate_val_Type,
        cACertificate,
        _cACertificate_val_Type,
        crossCertificatePair,
        _crossCertificatePair_val_Type,
        _CertificatePair_issuedToThisCA,
        _CertificatePair_issuedByThisCA,
        CertificatePair,
        certificateRevocationList,
        _certificateRevocationList_val_Type,
        authorityRevocationList,
        _authorityRevocationList_val_Type,
        deltaRevocationList,
        _deltaRevocationList_val_Type,
        supportedAlgorithms,
        _supportedAlgorithms_val_Type,
        ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab,
        _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm,
        ________AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab,
        _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_4,
        ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab,
        __SupportedAlgorithm_algorithmIdentifier_algorithm,
        ___SupportedAlgorithm_algorithmIdentifier_parameters_tab,
        __SupportedAlgorithm_algorithmIdentifier_parameters,
        _SupportedAlgorithm_algorithmIdentifier,
        _SupportedAlgorithm_intendedUsage,
        _SupportedAlgorithm_intendedCertificatePolicies,
        SupportedAlgorithm,
        certificationPracticeStmt,
        _certificationPracticeStmt_val_Type,
        _InfoSyntax_content,
        __InfoSyntax_pointer_name,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters,
        ___InfoSyntax_pointer_hash_algorithmIdentifier,
        ___InfoSyntax_pointer_hash_hashValue,
        __InfoSyntax_pointer_hash,
        _InfoSyntax_pointer,
        InfoSyntax,
        POLICY,
        _HashedPolicyInfo_tab,
        HashedPolicyInfo,
        Policies,
        certificatePolicy,
        _certificatePolicy_val_Type,
        _PolicySyntax_policyIdentifier,
        _PolicySyntax_policySyntax,
        PolicySyntax,
        PolicyID,
        pkiPath,
        _pkiPath_val_Type,
        userPassword,
        _userPassword_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_5,
        userPwd,
        _userPwd_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_6,
        _UserPwd_clear,
        ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab,
        ___UserPwd_encrypted_algorithmIdentifier_algorithm,
        ____UserPwd_encrypted_algorithmIdentifier_parameters_tab,
        ___UserPwd_encrypted_algorithmIdentifier_parameters,
        __UserPwd_encrypted_algorithmIdentifier,
        __UserPwd_encrypted_encryptedString,
        _UserPwd_encrypted,
        UserPwd,
        pwdStartTime,
        _pwdStartTime_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_7,
        __pwdStartTime_ordering_match_val_AssertionType,
        pwdExpiryTime,
        _pwdExpiryTime_val_Type,
        pwdEndTime,
        _pwdEndTime_val_Type,
        pwdFails,
        _pwdFails_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_8,
        __pwdStartTime_ordering_match_val_AssertionType_0,
        pwdFailureTime,
        _pwdFailureTime_val_Type,
        pwdGracesUsed,
        _pwdGracesUsed_val_Type,
        userPwdHistory,
        __userPwdHistory_val_Type_time,
        __userPwdHistory_val_Type_Type,
        _userPwdHistory_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_Type,
        userPwdRecentlyExpired,
        _userPwdRecentlyExpired_val_Type,
        pwdModifyEntryAllowed,
        _pwdModifyEntryAllowed_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_9,
        pwdChangeAllowed,
        _pwdChangeAllowed_val_Type,
        pwdMaxAge,
        _pwdMaxAge_val_Type,
        pwdExpiryAge,
        _pwdExpiryAge_val_Type,
        pwdMinLength,
        _pwdMinLength_val_Type,
        pwdVocabulary,
        _pwdVocabulary_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_10,
        PwdVocabulary,
        pwdAlphabet,
        _pwdAlphabet_val_Type,
        _PwdAlphabet__item_,
        PwdAlphabet,
        pwdDictionaries,
        ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType__11,
        pwdExpiryWarning,
        _pwdExpiryWarning_val_Type,
        pwdGraces,
        _pwdGraces_val_Type,
        pwdFailureDuration,
        _pwdFailureDuration_val_Type,
        pwdLockoutDuration,
        _pwdLockoutDuration_val_Type,
        pwdMaxFailures,
        _pwdMaxFailures_val_Type,
        pwdMaxTimeInHistory,
        _pwdMaxTimeInHistory_val_Type,
        pwdMinTimeInHistory,
        _pwdMinTimeInHistory_val_Type,
        pwdHistorySlots,
        _pwdHistorySlots_val_Type,
        pwdRecentlyExpiredDuration,
        _pwdRecentlyExpiredDuration_val_Type,
        pwdEncAlg,
        _pwdEncAlg_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType___12,
        __PwdEncAlg_algorithm_tab,
        _PwdEncAlg_algorithm,
        __PwdEncAlg_parameters_tab,
        _PwdEncAlg_parameters,
        PwdEncAlg,
        userPwdMatch,
        _userPwdMatch_val_AssertionType,
        pwdEncAlgMatch,
        _pwdEncAlgMatch_val_AssertionType,
        userPwdHistoryMatch,
        _userPwdHistoryMatch_val_Type,
        userPwdDescription,
        _userPwdDescription_val_Type,
        pwdVocabularyDescription,
        _pwdVocabularyDescription_val_Type,
        pwdAlphabetDescription,
        _pwdAlphabetDescription_val_Type,
        pwdEncAlgDescription,
        _pwdEncAlgDescription_val_Type,
        x509Certificate,
        _x509Certificate_val_Type,
        x509CertificateList,
        _x509CertificateList_val_Type,
        x509CertificatePair,
        _x509CertificatePair_val_Type,
        x509SupportedAlgorithm,
        _x509SupportedAlgorithm_val_Type,
        id_oc_cRLDistributionPoint,
        id_oc_pkiUser,
        id_oc_pkiCA,
        id_oc_deltaCRL,
        id_oc_cpCps,
        id_oc_pkiCertPath,
        id_nf_cRLDistPtNameForm,
        id_at_userPassword,
        id_at_userCertificate,
        id_at_cAcertificate,
        id_at_authorityRevocationList,
        id_at_certificateRevocationList,
        id_at_crossCertificatePair,
        id_at_supportedAlgorithms,
        id_at_deltaRevocationList,
        id_at_certificationPracticeStmt,
        id_at_certificatePolicy,
        id_at_pkiPath,
        id_at_userPwd,
        id_oa_pwdStartTime,
        id_oa_pwdExpiryTime,
        id_oa_pwdEndTime,
        id_oa_pwdFails,
        id_oa_pwdFailureTime,
        id_oa_pwdGracesUsed,
        id_oa_userPwdHistory,
        id_oa_userPwdRecentlyExpired,
        id_oa_pwdModifyEntryAllowed,
        id_oa_pwdChangeAllowed,
        id_oa_pwdMaxAge,
        id_oa_pwdExpiryAge,
        id_oa_pwdMinLength,
        id_oa_pwdVocabulary,
        id_oa_pwdAlphabet,
        id_oa_pwdDictionaries,
        id_oa_pwdExpiryWarning,
        id_oa_pwdGraces,
        id_oa_pwdFailureDuration,
        id_oa_pwdLockoutDuration,
        id_oa_pwdMaxFailures,
        id_oa_pwdMaxTimeInHistory,
        id_oa_pwdMinTimeInHistory,
        id_oa_pwdHistorySlots,
        id_oa_pwdRecentlyExpiredDuration,
        id_oa_pwdEncAlg,
        id_mr_userPwdMatch,
        id_mr_userPwdHistoryMatch,
        id_mr_pwdEncAlgMatch,
        id_asx_userPwdDescription,
        id_asx_pwdVocabularyDescription,
        id_asx_pwdAlphabetDescription,
        id_asx_pwdEncAlgDescription,
        id_lsx_x509Certificate,
        id_lsx_x509CertificateList,
        id_lsx_x509CertificatePair,
        id_lsx_x509SupportedAlgorithm,
        id_ecPublicKey,
    ]

class BasicAccessControl:

    _name_  = 'BasicAccessControl'
    _oid_   = [2, 5, 1, 24, 7]
    
    _obj_ = [
        'accessControlScheme',
        'ACIItem',
        'Precedence',
        'ProtectedItems',
        'MaxValueCount',
        'RestrictedValue',
        'UserClasses',
        'ItemPermission',
        'UserPermission',
        'AuthenticationLevel',
        'GrantsAndDenials',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        'id-aca-accessControlScheme',
        'id-aca-prescriptiveACI',
        'id-aca-entryACI',
        'id-aca-subentryACI',
        'basicAccessControlScheme',
        'simplifiedAccessControlScheme',
        'rule-based-access-control',
        'rule-and-basic-access-control',
        'rule-and-simple-access-control',
        ]
    _type_ = [
        'ACIItem',
        'Precedence',
        'ProtectedItems',
        'MaxValueCount',
        'RestrictedValue',
        'UserClasses',
        'ItemPermission',
        'UserPermission',
        'AuthenticationLevel',
        'GrantsAndDenials',
        ]
    _set_ = [
        ]
    _val_ = [
        'accessControlScheme',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        'id-aca-accessControlScheme',
        'id-aca-prescriptiveACI',
        'id-aca-entryACI',
        'id-aca-subentryACI',
        'basicAccessControlScheme',
        'simplifiedAccessControlScheme',
        'rule-based-access-control',
        'rule-and-basic-access-control',
        'rule-and-simple-access-control',
        ]
    _class_ = [
        'accessControlScheme',
        'prescriptiveACI',
        'entryACI',
        'subentryACI',
        ]
    _param_ = [
        ]
    
    #-----< accessControlScheme >-----#
    accessControlScheme = CLASS(name='accessControlScheme', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlScheme_val_Type = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    accessControlScheme._val = dict([('Type', _accessControlScheme_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 1))])
    
    #-----< ACIItem >-----#
    ACIItem = SEQ(name='ACIItem', mode=MODE_TYPE)
    _ACIItem_identificationTag = CHOICE(name='identificationTag', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ACIItem_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')))
    _ACIItem_authenticationLevel = CHOICE(name='authenticationLevel', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')))
    _ACIItem_itemOrUserFirst = CHOICE(name='itemOrUserFirst', mode=MODE_TYPE)
    __ACIItem_itemOrUserFirst_itemFirst = SEQ(name='itemFirst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_itemFirst_protectedItems = SEQ(name='protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions = SET_OF(name='itemPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ItemPermission')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions._cont = ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_
    __ACIItem_itemOrUserFirst_itemFirst._cont = ASN1Dict([
        ('protectedItems', ___ACIItem_itemOrUserFirst_itemFirst_protectedItems),
        ('itemPermissions', ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions),
        ])
    __ACIItem_itemOrUserFirst_itemFirst._ext = []
    __ACIItem_itemOrUserFirst_userFirst = SEQ(name='userFirst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_userFirst_userClasses = SEQ(name='userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions = SET_OF(name='userPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserPermission')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions._cont = ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_
    __ACIItem_itemOrUserFirst_userFirst._cont = ASN1Dict([
        ('userClasses', ___ACIItem_itemOrUserFirst_userFirst_userClasses),
        ('userPermissions', ___ACIItem_itemOrUserFirst_userFirst_userPermissions),
        ])
    __ACIItem_itemOrUserFirst_userFirst._ext = []
    _ACIItem_itemOrUserFirst._cont = ASN1Dict([
        ('itemFirst', __ACIItem_itemOrUserFirst_itemFirst),
        ('userFirst', __ACIItem_itemOrUserFirst_userFirst),
        ])
    _ACIItem_itemOrUserFirst._ext = []
    ACIItem._cont = ASN1Dict([
        ('identificationTag', _ACIItem_identificationTag),
        ('precedence', _ACIItem_precedence),
        ('authenticationLevel', _ACIItem_authenticationLevel),
        ('itemOrUserFirst', _ACIItem_itemOrUserFirst),
        ])
    ACIItem._ext = []
    
    #-----< Precedence >-----#
    Precedence = INT(name='Precedence', mode=MODE_TYPE)
    Precedence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ProtectedItems >-----#
    ProtectedItems = SEQ(name='ProtectedItems', mode=MODE_TYPE)
    _ProtectedItems_entry = NULL(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_allUserAttributeTypes = NULL(name='allUserAttributeTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeType = SET_OF(name='attributeType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_attributeType._cont = __ProtectedItems_attributeType__item_
    _ProtectedItems_attributeType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allAttributeValues = SET_OF(name='allAttributeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_allAttributeValues__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_allAttributeValues._cont = __ProtectedItems_allAttributeValues__item_
    _ProtectedItems_allAttributeValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allUserAttributeTypesAndValues = NULL(name='allUserAttributeTypesAndValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeValue = SET_OF(name='attributeValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeValue__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _ProtectedItems_attributeValue._cont = __ProtectedItems_attributeValue__item_
    _ProtectedItems_attributeValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_selfValue = SET_OF(name='selfValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_selfValue__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_selfValue._cont = __ProtectedItems_selfValue__item_
    _ProtectedItems_selfValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_rangeOfValues = CHOICE(name='rangeOfValues', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _ProtectedItems_maxValueCount = SET_OF(name='maxValueCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_maxValueCount__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'MaxValueCount')))
    _ProtectedItems_maxValueCount._cont = __ProtectedItems_maxValueCount__item_
    _ProtectedItems_maxValueCount._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_maxImmSub = INT(name='maxImmSub', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_restrictedBy = SET_OF(name='restrictedBy', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_restrictedBy__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'RestrictedValue')))
    _ProtectedItems_restrictedBy._cont = __ProtectedItems_restrictedBy__item_
    _ProtectedItems_restrictedBy._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_contexts = SET_OF(name='contexts', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _ProtectedItems_contexts._cont = __ProtectedItems_contexts__item_
    _ProtectedItems_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_classes = CHOICE(name='classes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    ProtectedItems._cont = ASN1Dict([
        ('entry', _ProtectedItems_entry),
        ('allUserAttributeTypes', _ProtectedItems_allUserAttributeTypes),
        ('attributeType', _ProtectedItems_attributeType),
        ('allAttributeValues', _ProtectedItems_allAttributeValues),
        ('allUserAttributeTypesAndValues', _ProtectedItems_allUserAttributeTypesAndValues),
        ('attributeValue', _ProtectedItems_attributeValue),
        ('selfValue', _ProtectedItems_selfValue),
        ('rangeOfValues', _ProtectedItems_rangeOfValues),
        ('maxValueCount', _ProtectedItems_maxValueCount),
        ('maxImmSub', _ProtectedItems_maxImmSub),
        ('restrictedBy', _ProtectedItems_restrictedBy),
        ('contexts', _ProtectedItems_contexts),
        ('classes', _ProtectedItems_classes),
        ])
    ProtectedItems._ext = []
    
    #-----< MaxValueCount >-----#
    MaxValueCount = SEQ(name='MaxValueCount', mode=MODE_TYPE)
    _MaxValueCount_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MaxValueCount_maxCount = INT(name='maxCount', mode=MODE_TYPE)
    MaxValueCount._cont = ASN1Dict([
        ('type', _MaxValueCount_type),
        ('maxCount', _MaxValueCount_maxCount),
        ])
    MaxValueCount._ext = []
    
    #-----< RestrictedValue >-----#
    RestrictedValue = SEQ(name='RestrictedValue', mode=MODE_TYPE)
    _RestrictedValue_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _RestrictedValue_valuesIn = OID(name='valuesIn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    RestrictedValue._cont = ASN1Dict([
        ('type', _RestrictedValue_type),
        ('valuesIn', _RestrictedValue_valuesIn),
        ])
    RestrictedValue._ext = []
    
    #-----< UserClasses >-----#
    UserClasses = SEQ(name='UserClasses', mode=MODE_TYPE)
    _UserClasses_allUsers = NULL(name='allUsers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_thisEntry = NULL(name='thisEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_name = SET_OF(name='name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_name__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_name._cont = __UserClasses_name__item_
    _UserClasses_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_userGroup = SET_OF(name='userGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_userGroup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_userGroup._cont = __UserClasses_userGroup__item_
    _UserClasses_userGroup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_subtree = SET_OF(name='subtree', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    _UserClasses_subtree._cont = __UserClasses_subtree__item_
    _UserClasses_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UserClasses._cont = ASN1Dict([
        ('allUsers', _UserClasses_allUsers),
        ('thisEntry', _UserClasses_thisEntry),
        ('name', _UserClasses_name),
        ('userGroup', _UserClasses_userGroup),
        ('subtree', _UserClasses_subtree),
        ])
    UserClasses._ext = []
    
    #-----< ItemPermission >-----#
    ItemPermission = SEQ(name='ItemPermission', mode=MODE_TYPE)
    _ItemPermission_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _ItemPermission_userClasses = SEQ(name='userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    _ItemPermission_grantsAndDenials = BIT_STR(name='grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    ItemPermission._cont = ASN1Dict([
        ('precedence', _ItemPermission_precedence),
        ('userClasses', _ItemPermission_userClasses),
        ('grantsAndDenials', _ItemPermission_grantsAndDenials),
        ])
    ItemPermission._ext = []
    
    #-----< UserPermission >-----#
    UserPermission = SEQ(name='UserPermission', mode=MODE_TYPE)
    _UserPermission_precedence = INT(name='precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _UserPermission_protectedItems = SEQ(name='protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    _UserPermission_grantsAndDenials = BIT_STR(name='grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    UserPermission._cont = ASN1Dict([
        ('precedence', _UserPermission_precedence),
        ('protectedItems', _UserPermission_protectedItems),
        ('grantsAndDenials', _UserPermission_grantsAndDenials),
        ])
    UserPermission._ext = []
    
    #-----< AuthenticationLevel >-----#
    AuthenticationLevel = CHOICE(name='AuthenticationLevel', mode=MODE_TYPE)
    _AuthenticationLevel_basicLevels = SEQ(name='basicLevels', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level = ENUM(name='level', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level._cont = ASN1Dict([('none', 0), ('simple', 1), ('strong', 2)])
    __AuthenticationLevel_basicLevels_level._ext = []
    __AuthenticationLevel_basicLevels_localQualifier = INT(name='localQualifier', mode=MODE_TYPE, opt=True)
    __AuthenticationLevel_basicLevels_signed = BOOL(name='signed', mode=MODE_TYPE, default=False)
    _AuthenticationLevel_basicLevels._cont = ASN1Dict([
        ('level', __AuthenticationLevel_basicLevels_level),
        ('localQualifier', __AuthenticationLevel_basicLevels_localQualifier),
        ('signed', __AuthenticationLevel_basicLevels_signed),
        ])
    _AuthenticationLevel_basicLevels._ext = []
    _AuthenticationLevel_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    AuthenticationLevel._cont = ASN1Dict([
        ('basicLevels', _AuthenticationLevel_basicLevels),
        ('other', _AuthenticationLevel_other),
        ])
    AuthenticationLevel._ext = []
    
    #-----< GrantsAndDenials >-----#
    GrantsAndDenials = BIT_STR(name='GrantsAndDenials', mode=MODE_TYPE)
    GrantsAndDenials._cont = ASN1Dict([('grantAdd', 0), ('denyAdd', 1), ('grantDiscloseOnError', 2), ('denyDiscloseOnError', 3), ('grantRead', 4), ('denyRead', 5), ('grantRemove', 6), ('denyRemove', 7), ('grantBrowse', 8), ('denyBrowse', 9), ('grantExport', 10), ('denyExport', 11), ('grantImport', 12), ('denyImport', 13), ('grantModify', 14), ('denyModify', 15), ('grantRename', 16), ('denyRename', 17), ('grantReturnDN', 18), ('denyReturnDN', 19), ('grantCompare', 20), ('denyCompare', 21), ('grantFilterMatch', 22), ('denyFilterMatch', 23), ('grantInvoke', 24), ('denyInvoke', 25)])
    
    #-----< prescriptiveACI >-----#
    prescriptiveACI = CLASS(name='prescriptiveACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _prescriptiveACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    prescriptiveACI._val = dict([('Type', _prescriptiveACI_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 4))])
    
    #-----< entryACI >-----#
    entryACI = CLASS(name='entryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _entryACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    entryACI._val = dict([('Type', _entryACI_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 5))])
    
    #-----< subentryACI >-----#
    subentryACI = CLASS(name='subentryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subentryACI_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    subentryACI._val = dict([('Type', _subentryACI_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('usage', 'directoryOperation'), ('id', (2, 5, 24, 6))])
    
    #-----< id-aca-accessControlScheme >-----#
    id_aca_accessControlScheme = OID(name='id-aca-accessControlScheme', mode=MODE_VALUE)
    id_aca_accessControlScheme._val = (2, 5, 24, 1)
    
    #-----< id-aca-prescriptiveACI >-----#
    id_aca_prescriptiveACI = OID(name='id-aca-prescriptiveACI', mode=MODE_VALUE)
    id_aca_prescriptiveACI._val = (2, 5, 24, 4)
    
    #-----< id-aca-entryACI >-----#
    id_aca_entryACI = OID(name='id-aca-entryACI', mode=MODE_VALUE)
    id_aca_entryACI._val = (2, 5, 24, 5)
    
    #-----< id-aca-subentryACI >-----#
    id_aca_subentryACI = OID(name='id-aca-subentryACI', mode=MODE_VALUE)
    id_aca_subentryACI._val = (2, 5, 24, 6)
    
    #-----< basicAccessControlScheme >-----#
    basicAccessControlScheme = OID(name='basicAccessControlScheme', mode=MODE_VALUE)
    basicAccessControlScheme._val = (2, 5, 28, 1)
    
    #-----< simplifiedAccessControlScheme >-----#
    simplifiedAccessControlScheme = OID(name='simplifiedAccessControlScheme', mode=MODE_VALUE)
    simplifiedAccessControlScheme._val = (2, 5, 28, 2)
    
    #-----< rule-based-access-control >-----#
    rule_based_access_control = OID(name='rule-based-access-control', mode=MODE_VALUE)
    rule_based_access_control._val = (2, 5, 28, 3)
    
    #-----< rule-and-basic-access-control >-----#
    rule_and_basic_access_control = OID(name='rule-and-basic-access-control', mode=MODE_VALUE)
    rule_and_basic_access_control._val = (2, 5, 28, 4)
    
    #-----< rule-and-simple-access-control >-----#
    rule_and_simple_access_control = OID(name='rule-and-simple-access-control', mode=MODE_VALUE)
    rule_and_simple_access_control._val = (2, 5, 28, 5)
    
    _all_ = [
        accessControlScheme,
        _accessControlScheme_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _ACIItem_identificationTag,
        _ACIItem_precedence,
        _ACIItem_authenticationLevel,
        ___ACIItem_itemOrUserFirst_itemFirst_protectedItems,
        ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_,
        ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions,
        __ACIItem_itemOrUserFirst_itemFirst,
        ___ACIItem_itemOrUserFirst_userFirst_userClasses,
        ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_,
        ___ACIItem_itemOrUserFirst_userFirst_userPermissions,
        __ACIItem_itemOrUserFirst_userFirst,
        _ACIItem_itemOrUserFirst,
        ACIItem,
        Precedence,
        _ProtectedItems_entry,
        _ProtectedItems_allUserAttributeTypes,
        __ProtectedItems_attributeType__item_,
        _ProtectedItems_attributeType,
        __ProtectedItems_allAttributeValues__item_,
        _ProtectedItems_allAttributeValues,
        _ProtectedItems_allUserAttributeTypesAndValues,
        __ProtectedItems_attributeValue__item_,
        _ProtectedItems_attributeValue,
        __ProtectedItems_selfValue__item_,
        _ProtectedItems_selfValue,
        _ProtectedItems_rangeOfValues,
        __ProtectedItems_maxValueCount__item_,
        _ProtectedItems_maxValueCount,
        _ProtectedItems_maxImmSub,
        __ProtectedItems_restrictedBy__item_,
        _ProtectedItems_restrictedBy,
        __ProtectedItems_contexts__item_,
        _ProtectedItems_contexts,
        _ProtectedItems_classes,
        ProtectedItems,
        _MaxValueCount_type,
        _MaxValueCount_maxCount,
        MaxValueCount,
        _RestrictedValue_type,
        _RestrictedValue_valuesIn,
        RestrictedValue,
        _UserClasses_allUsers,
        _UserClasses_thisEntry,
        __UserClasses_name__item_,
        _UserClasses_name,
        __UserClasses_userGroup__item_,
        _UserClasses_userGroup,
        __UserClasses_subtree__item_,
        _UserClasses_subtree,
        UserClasses,
        _ItemPermission_precedence,
        _ItemPermission_userClasses,
        _ItemPermission_grantsAndDenials,
        ItemPermission,
        _UserPermission_precedence,
        _UserPermission_protectedItems,
        _UserPermission_grantsAndDenials,
        UserPermission,
        __AuthenticationLevel_basicLevels_level,
        __AuthenticationLevel_basicLevels_localQualifier,
        __AuthenticationLevel_basicLevels_signed,
        _AuthenticationLevel_basicLevels,
        _AuthenticationLevel_other,
        AuthenticationLevel,
        GrantsAndDenials,
        prescriptiveACI,
        _prescriptiveACI_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        entryACI,
        _entryACI_val_Type,
        subentryACI,
        _subentryACI_val_Type,
        id_aca_accessControlScheme,
        id_aca_prescriptiveACI,
        id_aca_entryACI,
        id_aca_subentryACI,
        basicAccessControlScheme,
        simplifiedAccessControlScheme,
        rule_based_access_control,
        rule_and_basic_access_control,
        rule_and_simple_access_control,
    ]

class CertificateExtensions:

    _name_  = 'CertificateExtensions'
    _oid_   = [2, 5, 1, 26, 7]
    
    _obj_ = [
        'authorityKeyIdentifier',
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'subjectKeyIdentifier',
        'SubjectKeyIdentifier',
        'keyUsage',
        'KeyUsage',
        'extKeyUsage',
        'KeyPurposeId',
        'privateKeyUsagePeriod',
        'PrivateKeyUsagePeriod',
        'certificatePolicies',
        'CertificatePoliciesSyntax',
        'PolicyInformation',
        'CertPolicyId',
        'PolicyQualifierInfo',
        'SupportedPolicyQualifiers',
        'anyPolicy',
        'CERT-POLICY-QUALIFIER',
        'policyMappings',
        'PolicyMappingsSyntax',
        'subjectAltName',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'AttributesSyntax',
        'basicConstraints',
        'BasicConstraintsSyntax',
        'nameConstraints',
        'NameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'policyConstraints',
        'PolicyConstraintsSyntax',
        'SkipCerts',
        'inhibitAnyPolicy',
        'cRLNumber',
        'CRLNumber',
        'crlScope',
        'CRLScopeSyntax',
        'PerAuthorityScope',
        'OnlyCertificateTypes',
        'NumberRange',
        'BaseRevocationInfo',
        'statusReferrals',
        'StatusReferrals',
        'StatusReferral',
        'CRLReferral',
        'DeltaRefInfo',
        'OTHER-REFERRAL',
        'cRLStreamIdentifier',
        'CRLStreamIdentifier',
        'orderedList',
        'OrderedListSyntax',
        'deltaInfo',
        'DeltaInformation',
        'toBeRevoked',
        'ToBeRevokedSyntax',
        'ToBeRevokedGroup',
        'ReasonInfo',
        'CertificateGroup',
        'CertificateGroupNumberRange',
        'CertificateSerialNumbers',
        'revokedGroups',
        'RevokedGroupsSyntax',
        'RevokedGroup',
        'RevokedCertificateGroup',
        'expiredCertsOnCRL',
        'ExpiredCertsOnCRL',
        'reasonCode',
        'CRLReason',
        'holdInstructionCode',
        'HoldInstruction',
        'invalidityDate',
        'cRLDistributionPoints',
        'CRLDistPointsSyntax',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'issuingDistributionPoint',
        'IssuingDistPointSyntax',
        'certificateIssuer',
        'deltaCRLIndicator',
        'BaseCRLNumber',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'AAIssuingDistPointSyntax',
        'certificateExactMatch',
        'CertificateExactAssertion',
        'certificateMatch',
        'CertificateAssertion',
        'AltNameType',
        'CertPolicySet',
        'certificatePairExactMatch',
        'CertificatePairExactAssertion',
        'certificatePairMatch',
        'CertificatePairAssertion',
        'certificateListExactMatch',
        'CertificateListExactAssertion',
        'certificateListMatch',
        'CertificateListAssertion',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'PkiPathMatchSyntax',
        'enhancedCertificateMatch',
        'EnhancedCertificateAssertion',
        'AltName',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        'id-ce-subjectDirectoryAttributes',
        'id-ce-subjectKeyIdentifier',
        'id-ce-keyUsage',
        'id-ce-privateKeyUsagePeriod',
        'id-ce-subjectAltName',
        'id-ce-issuerAltName',
        'id-ce-basicConstraints',
        'id-ce-cRLNumber',
        'id-ce-reasonCode',
        'id-ce-instructionCode',
        'id-ce-invalidityDate',
        'id-ce-deltaCRLIndicator',
        'id-ce-issuingDistributionPoint',
        'id-ce-certificateIssuer',
        'id-ce-nameConstraints',
        'id-ce-cRLDistributionPoints',
        'id-ce-certificatePolicies',
        'id-ce-policyMappings',
        'id-ce-authorityKeyIdentifier',
        'id-ce-policyConstraints',
        'id-ce-extKeyUsage',
        'id-ce-cRLStreamIdentifier',
        'id-ce-cRLScope',
        'id-ce-statusReferrals',
        'id-ce-freshestCRL',
        'id-ce-orderedList',
        'id-ce-baseUpdateTime',
        'id-ce-deltaInfo',
        'id-ce-inhibitAnyPolicy',
        'id-ce-toBeRevoked',
        'id-ce-RevokedGroups',
        'id-ce-expiredCertsOnCRL',
        'id-ce-aAissuingDistributionPoint',
        'id-mr-certificateExactMatch',
        'id-mr-certificateMatch',
        'id-mr-certificatePairExactMatch',
        'id-mr-certificatePairMatch',
        'id-mr-certificateListExactMatch',
        'id-mr-certificateListMatch',
        'id-mr-algorithmIdentifierMatch',
        'id-mr-policyMatch',
        'id-mr-pkiPathMatch',
        'id-mr-enhancedCertificateMatch',
        'id-ldx-certExactAssertion',
        'id-ldx-certAssertion',
        'id-ldx-certPairExactAssertion',
        'id-ldx-certPairAssertion',
        'id-ldx-certListExactAssertion',
        'id-ldx-certListAssertion',
        'id-ldx-algorithmIdentifier',
        ]
    _type_ = [
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'SubjectKeyIdentifier',
        'KeyUsage',
        'KeyPurposeId',
        'PrivateKeyUsagePeriod',
        'CertificatePoliciesSyntax',
        'PolicyInformation',
        'CertPolicyId',
        'PolicyQualifierInfo',
        'CERT-POLICY-QUALIFIER',
        'PolicyMappingsSyntax',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'AttributesSyntax',
        'BasicConstraintsSyntax',
        'NameConstraintsSyntax',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'PolicyConstraintsSyntax',
        'SkipCerts',
        'CRLNumber',
        'CRLScopeSyntax',
        'PerAuthorityScope',
        'OnlyCertificateTypes',
        'NumberRange',
        'BaseRevocationInfo',
        'StatusReferrals',
        'StatusReferral',
        'CRLReferral',
        'DeltaRefInfo',
        'OTHER-REFERRAL',
        'CRLStreamIdentifier',
        'OrderedListSyntax',
        'DeltaInformation',
        'ToBeRevokedSyntax',
        'ToBeRevokedGroup',
        'ReasonInfo',
        'CertificateGroup',
        'CertificateGroupNumberRange',
        'CertificateSerialNumbers',
        'RevokedGroupsSyntax',
        'RevokedGroup',
        'RevokedCertificateGroup',
        'ExpiredCertsOnCRL',
        'CRLReason',
        'HoldInstruction',
        'CRLDistPointsSyntax',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'IssuingDistPointSyntax',
        'BaseCRLNumber',
        'AAIssuingDistPointSyntax',
        'CertificateExactAssertion',
        'CertificateAssertion',
        'AltNameType',
        'CertPolicySet',
        'CertificatePairExactAssertion',
        'CertificatePairAssertion',
        'CertificateListExactAssertion',
        'CertificateListAssertion',
        'PkiPathMatchSyntax',
        'EnhancedCertificateAssertion',
        'AltName',
        ]
    _set_ = [
        'SupportedPolicyQualifiers',
        ]
    _val_ = [
        'authorityKeyIdentifier',
        'subjectKeyIdentifier',
        'keyUsage',
        'extKeyUsage',
        'privateKeyUsagePeriod',
        'certificatePolicies',
        'anyPolicy',
        'policyMappings',
        'subjectAltName',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'basicConstraints',
        'nameConstraints',
        'policyConstraints',
        'inhibitAnyPolicy',
        'cRLNumber',
        'crlScope',
        'statusReferrals',
        'cRLStreamIdentifier',
        'orderedList',
        'deltaInfo',
        'toBeRevoked',
        'revokedGroups',
        'expiredCertsOnCRL',
        'reasonCode',
        'holdInstructionCode',
        'invalidityDate',
        'cRLDistributionPoints',
        'issuingDistributionPoint',
        'certificateIssuer',
        'deltaCRLIndicator',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'certificateExactMatch',
        'certificateMatch',
        'certificatePairExactMatch',
        'certificatePairMatch',
        'certificateListExactMatch',
        'certificateListMatch',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'enhancedCertificateMatch',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        'id-ce-subjectDirectoryAttributes',
        'id-ce-subjectKeyIdentifier',
        'id-ce-keyUsage',
        'id-ce-privateKeyUsagePeriod',
        'id-ce-subjectAltName',
        'id-ce-issuerAltName',
        'id-ce-basicConstraints',
        'id-ce-cRLNumber',
        'id-ce-reasonCode',
        'id-ce-instructionCode',
        'id-ce-invalidityDate',
        'id-ce-deltaCRLIndicator',
        'id-ce-issuingDistributionPoint',
        'id-ce-certificateIssuer',
        'id-ce-nameConstraints',
        'id-ce-cRLDistributionPoints',
        'id-ce-certificatePolicies',
        'id-ce-policyMappings',
        'id-ce-authorityKeyIdentifier',
        'id-ce-policyConstraints',
        'id-ce-extKeyUsage',
        'id-ce-cRLStreamIdentifier',
        'id-ce-cRLScope',
        'id-ce-statusReferrals',
        'id-ce-freshestCRL',
        'id-ce-orderedList',
        'id-ce-baseUpdateTime',
        'id-ce-deltaInfo',
        'id-ce-inhibitAnyPolicy',
        'id-ce-toBeRevoked',
        'id-ce-RevokedGroups',
        'id-ce-expiredCertsOnCRL',
        'id-ce-aAissuingDistributionPoint',
        'id-mr-certificateExactMatch',
        'id-mr-certificateMatch',
        'id-mr-certificatePairExactMatch',
        'id-mr-certificatePairMatch',
        'id-mr-certificateListExactMatch',
        'id-mr-certificateListMatch',
        'id-mr-algorithmIdentifierMatch',
        'id-mr-policyMatch',
        'id-mr-pkiPathMatch',
        'id-mr-enhancedCertificateMatch',
        'id-ldx-certExactAssertion',
        'id-ldx-certAssertion',
        'id-ldx-certPairExactAssertion',
        'id-ldx-certPairAssertion',
        'id-ldx-certListExactAssertion',
        'id-ldx-certListAssertion',
        'id-ldx-algorithmIdentifier',
        ]
    _class_ = [
        'authorityKeyIdentifier',
        'subjectKeyIdentifier',
        'keyUsage',
        'extKeyUsage',
        'privateKeyUsagePeriod',
        'certificatePolicies',
        'SupportedPolicyQualifiers',
        'CERT-POLICY-QUALIFIER',
        'policyMappings',
        'subjectAltName',
        'OTHER-NAME',
        'issuerAltName',
        'subjectDirectoryAttributes',
        'basicConstraints',
        'nameConstraints',
        'policyConstraints',
        'inhibitAnyPolicy',
        'cRLNumber',
        'crlScope',
        'statusReferrals',
        'OTHER-REFERRAL',
        'cRLStreamIdentifier',
        'orderedList',
        'deltaInfo',
        'toBeRevoked',
        'revokedGroups',
        'expiredCertsOnCRL',
        'reasonCode',
        'holdInstructionCode',
        'invalidityDate',
        'cRLDistributionPoints',
        'issuingDistributionPoint',
        'certificateIssuer',
        'deltaCRLIndicator',
        'baseUpdateTime',
        'freshestCRL',
        'aAissuingDistributionPoint',
        'certificateExactMatch',
        'certificateMatch',
        'certificatePairExactMatch',
        'certificatePairMatch',
        'certificateListExactMatch',
        'certificateListMatch',
        'algorithmIdentifierMatch',
        'policyMatch',
        'pkiPathMatch',
        'enhancedCertificateMatch',
        'certExactAssertion',
        'certAssertion',
        'certPairExactAssertion',
        'certPairAssertion',
        'certListExactAssertion',
        'certListAssertion',
        'algorithmIdentifier',
        ]
    _param_ = [
        ]
    
    #-----< authorityKeyIdentifier >-----#
    authorityKeyIdentifier = CLASS(name='authorityKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityKeyIdentifier_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')))
    authorityKeyIdentifier._val = dict([('ExtnType', _authorityKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 35))])
    
    #-----< AuthorityKeyIdentifier >-----#
    AuthorityKeyIdentifier = SEQ(name='AuthorityKeyIdentifier', mode=MODE_TYPE)
    _AuthorityKeyIdentifier_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _AuthorityKeyIdentifier_authorityCertIssuer = SEQ_OF(name='authorityCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AuthorityKeyIdentifier_authorityCertSerialNumber = INT(name='authorityCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    AuthorityKeyIdentifier._cont = ASN1Dict([
        ('keyIdentifier', _AuthorityKeyIdentifier_keyIdentifier),
        ('authorityCertIssuer', _AuthorityKeyIdentifier_authorityCertIssuer),
        ('authorityCertSerialNumber', _AuthorityKeyIdentifier_authorityCertSerialNumber),
        ])
    AuthorityKeyIdentifier._ext = []
    
    #-----< KeyIdentifier >-----#
    KeyIdentifier = OCT_STR(name='KeyIdentifier', mode=MODE_TYPE)
    
    #-----< subjectKeyIdentifier >-----#
    subjectKeyIdentifier = CLASS(name='subjectKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectKeyIdentifier_val_ExtnType = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')))
    subjectKeyIdentifier._val = dict([('ExtnType', _subjectKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 14))])
    
    #-----< SubjectKeyIdentifier >-----#
    SubjectKeyIdentifier = OCT_STR(name='SubjectKeyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')))
    
    #-----< keyUsage >-----#
    keyUsage = CLASS(name='keyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _keyUsage_val_ExtnType = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')))
    keyUsage._val = dict([('ExtnType', _keyUsage_val_ExtnType), ('id', (2, 5, 29, 15))])
    
    #-----< KeyUsage >-----#
    KeyUsage = BIT_STR(name='KeyUsage', mode=MODE_TYPE)
    KeyUsage._cont = ASN1Dict([('digitalSignature', 0), ('contentCommitment', 1), ('keyEncipherment', 2), ('dataEncipherment', 3), ('keyAgreement', 4), ('keyCertSign', 5), ('cRLSign', 6), ('encipherOnly', 7), ('decipherOnly', 8)])
    
    #-----< extKeyUsage >-----#
    extKeyUsage = CLASS(name='extKeyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _extKeyUsage_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE)
    __extKeyUsage_val_ExtnType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyPurposeId')))
    _extKeyUsage_val_ExtnType._cont = __extKeyUsage_val_ExtnType__item_
    _extKeyUsage_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    extKeyUsage._val = dict([('ExtnType', _extKeyUsage_val_ExtnType), ('id', (2, 5, 29, 37))])
    
    #-----< KeyPurposeId >-----#
    KeyPurposeId = OID(name='KeyPurposeId', mode=MODE_TYPE)
    
    #-----< privateKeyUsagePeriod >-----#
    privateKeyUsagePeriod = CLASS(name='privateKeyUsagePeriod', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _privateKeyUsagePeriod_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PrivateKeyUsagePeriod')))
    privateKeyUsagePeriod._val = dict([('ExtnType', _privateKeyUsagePeriod_val_ExtnType), ('id', (2, 5, 29, 16))])
    
    #-----< PrivateKeyUsagePeriod >-----#
    PrivateKeyUsagePeriod = SEQ(name='PrivateKeyUsagePeriod', mode=MODE_TYPE)
    _PrivateKeyUsagePeriod_notBefore = TIME_GEN(name='notBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrivateKeyUsagePeriod_notAfter = TIME_GEN(name='notAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrivateKeyUsagePeriod._cont = ASN1Dict([
        ('notBefore', _PrivateKeyUsagePeriod_notBefore),
        ('notAfter', _PrivateKeyUsagePeriod_notAfter),
        ])
    PrivateKeyUsagePeriod._ext = []
    
    #-----< certificatePolicies >-----#
    certificatePolicies = CLASS(name='certificatePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificatePolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')))
    certificatePolicies._val = dict([('ExtnType', _certificatePolicies_val_ExtnType), ('id', (2, 5, 29, 32))])
    
    #-----< CertificatePoliciesSyntax >-----#
    CertificatePoliciesSyntax = SEQ_OF(name='CertificatePoliciesSyntax', mode=MODE_TYPE)
    _CertificatePoliciesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyInformation')))
    CertificatePoliciesSyntax._cont = _CertificatePoliciesSyntax__item_
    CertificatePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PolicyInformation >-----#
    PolicyInformation = SEQ(name='PolicyInformation', mode=MODE_TYPE)
    _PolicyInformation_policyIdentifier = OID(name='policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyInformation_policyQualifiers = SEQ_OF(name='policyQualifiers', mode=MODE_TYPE, opt=True)
    __PolicyInformation_policyQualifiers__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyQualifierInfo')))
    _PolicyInformation_policyQualifiers._cont = __PolicyInformation_policyQualifiers__item_
    _PolicyInformation_policyQualifiers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PolicyInformation._cont = ASN1Dict([
        ('policyIdentifier', _PolicyInformation_policyIdentifier),
        ('policyQualifiers', _PolicyInformation_policyQualifiers),
        ])
    PolicyInformation._ext = []
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name='CertPolicyId', mode=MODE_TYPE)
    
    #-----< PolicyQualifierInfo >-----#
    PolicyQualifierInfo = SEQ(name='PolicyQualifierInfo', mode=MODE_TYPE)
    _PolicyQualifierInfo_policyQualifierId = OID(name='policyQualifierId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), ['id']))
    __PolicyQualifierInfo_policyQualifierId_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_policyQualifierId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_policyQualifierId._const_tab = __PolicyQualifierInfo_policyQualifierId_tab
    _PolicyQualifierInfo_policyQualifierId._const_tab_at = None
    _PolicyQualifierInfo_policyQualifierId._const_tab_id = 'id'
    _PolicyQualifierInfo_qualifier = OPEN(name='qualifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), ['Qualifier']), opt=True)
    __PolicyQualifierInfo_qualifier_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_qualifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_qualifier._const_tab = __PolicyQualifierInfo_qualifier_tab
    _PolicyQualifierInfo_qualifier._const_tab_at = ('..', 'policyQualifierId')
    _PolicyQualifierInfo_qualifier._const_tab_id = 'Qualifier'
    PolicyQualifierInfo._cont = ASN1Dict([
        ('policyQualifierId', _PolicyQualifierInfo_policyQualifierId),
        ('qualifier', _PolicyQualifierInfo_qualifier),
        ])
    PolicyQualifierInfo._ext = []
    
    #-----< SupportedPolicyQualifiers >-----#
    SupportedPolicyQualifiers = CLASS(name='SupportedPolicyQualifiers', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    SupportedPolicyQualifiers._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< anyPolicy >-----#
    anyPolicy = OID(name='anyPolicy', mode=MODE_VALUE)
    anyPolicy._val = (2, 5, 29, 32, 0)
    
    #-----< CERT-POLICY-QUALIFIER >-----#
    CERT_POLICY_QUALIFIER = CLASS(name='CERT-POLICY-QUALIFIER', mode=MODE_TYPE)
    _CERT_POLICY_QUALIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _CERT_POLICY_QUALIFIER_Qualifier = OPEN(name='Qualifier', mode=MODE_TYPE, opt=True)
    CERT_POLICY_QUALIFIER._cont = ASN1Dict([
        ('id', _CERT_POLICY_QUALIFIER_id),
        ('Qualifier', _CERT_POLICY_QUALIFIER_Qualifier),
        ])
    
    #-----< policyMappings >-----#
    policyMappings = CLASS(name='policyMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyMappings_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyMappingsSyntax')))
    policyMappings._val = dict([('ExtnType', _policyMappings_val_ExtnType), ('id', (2, 5, 29, 33))])
    
    #-----< PolicyMappingsSyntax >-----#
    PolicyMappingsSyntax = SEQ_OF(name='PolicyMappingsSyntax', mode=MODE_TYPE)
    _PolicyMappingsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PolicyMappingsSyntax__item__issuerDomainPolicy = OID(name='issuerDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    __PolicyMappingsSyntax__item__subjectDomainPolicy = OID(name='subjectDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyMappingsSyntax__item_._cont = ASN1Dict([
        ('issuerDomainPolicy', __PolicyMappingsSyntax__item__issuerDomainPolicy),
        ('subjectDomainPolicy', __PolicyMappingsSyntax__item__subjectDomainPolicy),
        ])
    _PolicyMappingsSyntax__item_._ext = []
    PolicyMappingsSyntax._cont = _PolicyMappingsSyntax__item_
    PolicyMappingsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< subjectAltName >-----#
    subjectAltName = CLASS(name='subjectAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    subjectAltName._val = dict([('ExtnType', _subjectAltName_val_ExtnType), ('id', (2, 5, 29, 17))])
    
    #-----< GeneralNames >-----#
    GeneralNames = SEQ_OF(name='GeneralNames', mode=MODE_TYPE)
    _GeneralNames__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    GeneralNames._cont = _GeneralNames__item_
    GeneralNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralName >-----#
    GeneralName = CHOICE(name='GeneralName', mode=MODE_TYPE)
    _GeneralName_otherName = SEQ(name='otherName', mode=MODE_TYPE)
    __GeneralName_otherName_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['id']))
    __GeneralName_otherName_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['Type']))
    _GeneralName_otherName._cont = ASN1Dict([
        ('type-id', __GeneralName_otherName_type_id),
        ('value', __GeneralName_otherName_value),
        ])
    _GeneralName_otherName._ext = None
    _GeneralName_otherName.TAG = 8
    _GeneralName_rfc822Name = STR_IA5(name='rfc822Name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_dNSName = STR_IA5(name='dNSName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_x400Address = SEQ(name='x400Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'ORAddress')))
    _GeneralName_directoryName = CHOICE(name='directoryName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _GeneralName_ediPartyName = SEQ(name='ediPartyName', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'EDIPartyName')))
    _GeneralName_uniformResourceIdentifier = STR_IA5(name='uniformResourceIdentifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_iPAddress = OCT_STR(name='iPAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_registeredID = OID(name='registeredID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GeneralName._cont = ASN1Dict([
        ('otherName', _GeneralName_otherName),
        ('rfc822Name', _GeneralName_rfc822Name),
        ('dNSName', _GeneralName_dNSName),
        ('x400Address', _GeneralName_x400Address),
        ('directoryName', _GeneralName_directoryName),
        ('ediPartyName', _GeneralName_ediPartyName),
        ('uniformResourceIdentifier', _GeneralName_uniformResourceIdentifier),
        ('iPAddress', _GeneralName_iPAddress),
        ('registeredID', _GeneralName_registeredID),
        ])
    GeneralName._ext = []
    
    #-----< OTHER-NAME >-----#
    OTHER_NAME = CLASS(name='OTHER-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< EDIPartyName >-----#
    EDIPartyName = SEQ(name='EDIPartyName', mode=MODE_TYPE)
    _EDIPartyName_nameAssigner = CHOICE(name='nameAssigner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _EDIPartyName_partyName = CHOICE(name='partyName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    EDIPartyName._cont = ASN1Dict([
        ('nameAssigner', _EDIPartyName_nameAssigner),
        ('partyName', _EDIPartyName_partyName),
        ])
    EDIPartyName._ext = []
    
    #-----< issuerAltName >-----#
    issuerAltName = CLASS(name='issuerAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuerAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    issuerAltName._val = dict([('ExtnType', _issuerAltName_val_ExtnType), ('id', (2, 5, 29, 18))])
    
    #-----< subjectDirectoryAttributes >-----#
    subjectDirectoryAttributes = CLASS(name='subjectDirectoryAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectDirectoryAttributes_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AttributesSyntax')))
    subjectDirectoryAttributes._val = dict([('ExtnType', _subjectDirectoryAttributes_val_ExtnType), ('id', (2, 5, 29, 9))])
    
    #-----< AttributesSyntax >-----#
    AttributesSyntax = SEQ_OF(name='AttributesSyntax', mode=MODE_TYPE)
    _AttributesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __AttributesSyntax__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___AttributesSyntax__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____AttributesSyntax__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ____AttributesSyntax__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___AttributesSyntax__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____AttributesSyntax__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____AttributesSyntax__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __AttributesSyntax__item__type._const_tab = ___AttributesSyntax__item__type_tab
    __AttributesSyntax__item__type._const_tab_at = None
    __AttributesSyntax__item__type._const_tab_id = 'id'
    __AttributesSyntax__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___AttributesSyntax__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___AttributesSyntax__item__values__item_._const_tab = ___AttributesSyntax__item__type_tab
    ___AttributesSyntax__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___AttributesSyntax__item__values__item_._const_tab_id = 'Type'
    __AttributesSyntax__item__values._cont = ___AttributesSyntax__item__values__item_
    __AttributesSyntax__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __AttributesSyntax__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___AttributesSyntax__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____AttributesSyntax__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab = ___AttributesSyntax__item__type_tab
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ____AttributesSyntax__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____AttributesSyntax__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____AttributesSyntax__item__valuesWithContext__item__contextList._cont = _____AttributesSyntax__item__valuesWithContext__item__contextList__item_
    ____AttributesSyntax__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___AttributesSyntax__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____AttributesSyntax__item__valuesWithContext__item__value),
        ('contextList', ____AttributesSyntax__item__valuesWithContext__item__contextList),
        ])
    ___AttributesSyntax__item__valuesWithContext__item_._ext = []
    __AttributesSyntax__item__valuesWithContext._cont = ___AttributesSyntax__item__valuesWithContext__item_
    __AttributesSyntax__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributesSyntax__item_._cont = ASN1Dict([
        ('type', __AttributesSyntax__item__type),
        ('values', __AttributesSyntax__item__values),
        ('valuesWithContext', __AttributesSyntax__item__valuesWithContext),
        ])
    _AttributesSyntax__item_._ext = []
    AttributesSyntax._cont = _AttributesSyntax__item_
    AttributesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< basicConstraints >-----#
    basicConstraints = CLASS(name='basicConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BasicConstraintsSyntax')))
    basicConstraints._val = dict([('ExtnType', _basicConstraints_val_ExtnType), ('id', (2, 5, 29, 19))])
    
    #-----< BasicConstraintsSyntax >-----#
    BasicConstraintsSyntax = SEQ(name='BasicConstraintsSyntax', mode=MODE_TYPE)
    _BasicConstraintsSyntax_cA = BOOL(name='cA', mode=MODE_TYPE, default=False)
    _BasicConstraintsSyntax_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicConstraintsSyntax._cont = ASN1Dict([
        ('cA', _BasicConstraintsSyntax_cA),
        ('pathLenConstraint', _BasicConstraintsSyntax_pathLenConstraint),
        ])
    BasicConstraintsSyntax._ext = []
    
    #-----< nameConstraints >-----#
    nameConstraints = CLASS(name='nameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _nameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    nameConstraints._val = dict([('ExtnType', _nameConstraints_val_ExtnType), ('id', (2, 5, 29, 30))])
    
    #-----< NameConstraintsSyntax >-----#
    NameConstraintsSyntax = SEQ(name='NameConstraintsSyntax', mode=MODE_TYPE)
    _NameConstraintsSyntax_permittedSubtrees = SEQ_OF(name='permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    _NameConstraintsSyntax_excludedSubtrees = SEQ_OF(name='excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    NameConstraintsSyntax._cont = ASN1Dict([
        ('permittedSubtrees', _NameConstraintsSyntax_permittedSubtrees),
        ('excludedSubtrees', _NameConstraintsSyntax_excludedSubtrees),
        ])
    NameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name='GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name='GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name='base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        ('base', _GeneralSubtree_base),
        ('minimum', _GeneralSubtree_minimum),
        ('maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< policyConstraints >-----#
    policyConstraints = CLASS(name='policyConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyConstraintsSyntax')))
    policyConstraints._val = dict([('ExtnType', _policyConstraints_val_ExtnType), ('id', (2, 5, 29, 36))])
    
    #-----< PolicyConstraintsSyntax >-----#
    PolicyConstraintsSyntax = SEQ(name='PolicyConstraintsSyntax', mode=MODE_TYPE)
    _PolicyConstraintsSyntax_requireExplicitPolicy = INT(name='requireExplicitPolicy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    _PolicyConstraintsSyntax_inhibitPolicyMapping = INT(name='inhibitPolicyMapping', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    PolicyConstraintsSyntax._cont = ASN1Dict([
        ('requireExplicitPolicy', _PolicyConstraintsSyntax_requireExplicitPolicy),
        ('inhibitPolicyMapping', _PolicyConstraintsSyntax_inhibitPolicyMapping),
        ])
    PolicyConstraintsSyntax._ext = []
    
    #-----< SkipCerts >-----#
    SkipCerts = INT(name='SkipCerts', mode=MODE_TYPE)
    SkipCerts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< inhibitAnyPolicy >-----#
    inhibitAnyPolicy = CLASS(name='inhibitAnyPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _inhibitAnyPolicy_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')))
    inhibitAnyPolicy._val = dict([('ExtnType', _inhibitAnyPolicy_val_ExtnType), ('id', (2, 5, 29, 54))])
    
    #-----< cRLNumber >-----#
    cRLNumber = CLASS(name='cRLNumber', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLNumber_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    cRLNumber._val = dict([('ExtnType', _cRLNumber_val_ExtnType), ('id', (2, 5, 29, 20))])
    
    #-----< CRLNumber >-----#
    CRLNumber = INT(name='CRLNumber', mode=MODE_TYPE)
    CRLNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< crlScope >-----#
    crlScope = CLASS(name='crlScope', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _crlScope_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    crlScope._val = dict([('ExtnType', _crlScope_val_ExtnType), ('id', (2, 5, 29, 44))])
    
    #-----< CRLScopeSyntax >-----#
    CRLScopeSyntax = SEQ_OF(name='CRLScopeSyntax', mode=MODE_TYPE)
    _CRLScopeSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PerAuthorityScope')))
    CRLScopeSyntax._cont = _CRLScopeSyntax__item_
    CRLScopeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PerAuthorityScope >-----#
    PerAuthorityScope = SEQ(name='PerAuthorityScope', mode=MODE_TYPE)
    _PerAuthorityScope_authorityName = CHOICE(name='authorityName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _PerAuthorityScope_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _PerAuthorityScope_onlyContains = BIT_STR(name='onlyContains', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'OnlyCertificateTypes')), opt=True)
    _PerAuthorityScope_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _PerAuthorityScope_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_subjectKeyIdRange = SEQ(name='subjectKeyIdRange', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_nameSubtrees = SEQ_OF(name='nameSubtrees', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _PerAuthorityScope_baseRevocationInfo = SEQ(name='baseRevocationInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseRevocationInfo')), opt=True)
    PerAuthorityScope._cont = ASN1Dict([
        ('authorityName', _PerAuthorityScope_authorityName),
        ('distributionPoint', _PerAuthorityScope_distributionPoint),
        ('onlyContains', _PerAuthorityScope_onlyContains),
        ('onlySomeReasons', _PerAuthorityScope_onlySomeReasons),
        ('serialNumberRange', _PerAuthorityScope_serialNumberRange),
        ('subjectKeyIdRange', _PerAuthorityScope_subjectKeyIdRange),
        ('nameSubtrees', _PerAuthorityScope_nameSubtrees),
        ('baseRevocationInfo', _PerAuthorityScope_baseRevocationInfo),
        ])
    PerAuthorityScope._ext = []
    
    #-----< OnlyCertificateTypes >-----#
    OnlyCertificateTypes = BIT_STR(name='OnlyCertificateTypes', mode=MODE_TYPE)
    OnlyCertificateTypes._cont = ASN1Dict([('user', 0), ('authority', 1), ('attribute', 2)])
    
    #-----< NumberRange >-----#
    NumberRange = SEQ(name='NumberRange', mode=MODE_TYPE)
    _NumberRange_startingNumber = INT(name='startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_endingNumber = INT(name='endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_modulus = INT(name='modulus', mode=MODE_TYPE, opt=True)
    NumberRange._cont = ASN1Dict([
        ('startingNumber', _NumberRange_startingNumber),
        ('endingNumber', _NumberRange_endingNumber),
        ('modulus', _NumberRange_modulus),
        ])
    NumberRange._ext = []
    
    #-----< BaseRevocationInfo >-----#
    BaseRevocationInfo = SEQ(name='BaseRevocationInfo', mode=MODE_TYPE)
    _BaseRevocationInfo_cRLStreamIdentifier = INT(name='cRLStreamIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')), opt=True)
    _BaseRevocationInfo_cRLNumber = INT(name='cRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    _BaseRevocationInfo_baseThisUpdate = TIME_GEN(name='baseThisUpdate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    BaseRevocationInfo._cont = ASN1Dict([
        ('cRLStreamIdentifier', _BaseRevocationInfo_cRLStreamIdentifier),
        ('cRLNumber', _BaseRevocationInfo_cRLNumber),
        ('baseThisUpdate', _BaseRevocationInfo_baseThisUpdate),
        ])
    BaseRevocationInfo._ext = []
    
    #-----< statusReferrals >-----#
    statusReferrals = CLASS(name='statusReferrals', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _statusReferrals_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferrals')))
    statusReferrals._val = dict([('ExtnType', _statusReferrals_val_ExtnType), ('id', (2, 5, 29, 45))])
    
    #-----< StatusReferrals >-----#
    StatusReferrals = SEQ_OF(name='StatusReferrals', mode=MODE_TYPE)
    _StatusReferrals__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferral')))
    StatusReferrals._cont = _StatusReferrals__item_
    StatusReferrals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< StatusReferral >-----#
    StatusReferral = CHOICE(name='StatusReferral', mode=MODE_TYPE)
    _StatusReferral_cRLReferral = SEQ(name='cRLReferral', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLReferral')))
    _StatusReferral_otherReferral = SEQ(name='otherReferral', mode=MODE_TYPE)
    __StatusReferral_otherReferral_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['id']))
    __StatusReferral_otherReferral_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['Type']))
    _StatusReferral_otherReferral._cont = ASN1Dict([
        ('type-id', __StatusReferral_otherReferral_type_id),
        ('value', __StatusReferral_otherReferral_value),
        ])
    _StatusReferral_otherReferral._ext = None
    _StatusReferral_otherReferral.TAG = 8
    StatusReferral._cont = ASN1Dict([
        ('cRLReferral', _StatusReferral_cRLReferral),
        ('otherReferral', _StatusReferral_otherReferral),
        ])
    StatusReferral._ext = []
    
    #-----< CRLReferral >-----#
    CRLReferral = SEQ(name='CRLReferral', mode=MODE_TYPE)
    _CRLReferral_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_location = CHOICE(name='location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_deltaRefInfo = SEQ(name='deltaRefInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DeltaRefInfo')), opt=True)
    _CRLReferral_cRLScope = SEQ_OF(name='cRLScope', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    _CRLReferral_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CRLReferral_lastChangedCRL = TIME_GEN(name='lastChangedCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CRLReferral._cont = ASN1Dict([
        ('issuer', _CRLReferral_issuer),
        ('location', _CRLReferral_location),
        ('deltaRefInfo', _CRLReferral_deltaRefInfo),
        ('cRLScope', _CRLReferral_cRLScope),
        ('lastUpdate', _CRLReferral_lastUpdate),
        ('lastChangedCRL', _CRLReferral_lastChangedCRL),
        ])
    CRLReferral._ext = []
    
    #-----< DeltaRefInfo >-----#
    DeltaRefInfo = SEQ(name='DeltaRefInfo', mode=MODE_TYPE)
    _DeltaRefInfo_deltaLocation = CHOICE(name='deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaRefInfo_lastDelta = TIME_GEN(name='lastDelta', mode=MODE_TYPE, opt=True)
    DeltaRefInfo._cont = ASN1Dict([
        ('deltaLocation', _DeltaRefInfo_deltaLocation),
        ('lastDelta', _DeltaRefInfo_lastDelta),
        ])
    DeltaRefInfo._ext = []
    
    #-----< OTHER-REFERRAL >-----#
    OTHER_REFERRAL = CLASS(name='OTHER-REFERRAL', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< cRLStreamIdentifier >-----#
    cRLStreamIdentifier = CLASS(name='cRLStreamIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLStreamIdentifier_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')))
    cRLStreamIdentifier._val = dict([('ExtnType', _cRLStreamIdentifier_val_ExtnType), ('id', (2, 5, 29, 40))])
    
    #-----< CRLStreamIdentifier >-----#
    CRLStreamIdentifier = INT(name='CRLStreamIdentifier', mode=MODE_TYPE)
    CRLStreamIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< orderedList >-----#
    orderedList = CLASS(name='orderedList', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _orderedList_val_ExtnType = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'OrderedListSyntax')))
    orderedList._val = dict([('ExtnType', _orderedList_val_ExtnType), ('id', (2, 5, 29, 47))])
    
    #-----< OrderedListSyntax >-----#
    OrderedListSyntax = ENUM(name='OrderedListSyntax', mode=MODE_TYPE)
    OrderedListSyntax._cont = ASN1Dict([('ascSerialNum', 0), ('ascRevDate', 1)])
    OrderedListSyntax._ext = []
    
    #-----< deltaInfo >-----#
    deltaInfo = CLASS(name='deltaInfo', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaInfo_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DeltaInformation')))
    deltaInfo._val = dict([('ExtnType', _deltaInfo_val_ExtnType), ('id', (2, 5, 29, 53))])
    
    #-----< DeltaInformation >-----#
    DeltaInformation = SEQ(name='DeltaInformation', mode=MODE_TYPE)
    _DeltaInformation_deltaLocation = CHOICE(name='deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaInformation_nextDelta = TIME_GEN(name='nextDelta', mode=MODE_TYPE, opt=True)
    DeltaInformation._cont = ASN1Dict([
        ('deltaLocation', _DeltaInformation_deltaLocation),
        ('nextDelta', _DeltaInformation_nextDelta),
        ])
    DeltaInformation._ext = []
    
    #-----< toBeRevoked >-----#
    toBeRevoked = CLASS(name='toBeRevoked', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _toBeRevoked_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedSyntax')))
    toBeRevoked._val = dict([('ExtnType', _toBeRevoked_val_ExtnType), ('id', (2, 5, 29, 58))])
    
    #-----< ToBeRevokedSyntax >-----#
    ToBeRevokedSyntax = SEQ_OF(name='ToBeRevokedSyntax', mode=MODE_TYPE)
    _ToBeRevokedSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedGroup')))
    ToBeRevokedSyntax._cont = _ToBeRevokedSyntax__item_
    ToBeRevokedSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ToBeRevokedGroup >-----#
    ToBeRevokedGroup = SEQ(name='ToBeRevokedGroup', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateIssuer = CHOICE(name='certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _ToBeRevokedGroup_reasonInfo = SEQ(name='reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _ToBeRevokedGroup_revocationTime = TIME_GEN(name='revocationTime', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateGroup = CHOICE(name='certificateGroup', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroup')))
    ToBeRevokedGroup._cont = ASN1Dict([
        ('certificateIssuer', _ToBeRevokedGroup_certificateIssuer),
        ('reasonInfo', _ToBeRevokedGroup_reasonInfo),
        ('revocationTime', _ToBeRevokedGroup_revocationTime),
        ('certificateGroup', _ToBeRevokedGroup_certificateGroup),
        ])
    ToBeRevokedGroup._ext = []
    
    #-----< ReasonInfo >-----#
    ReasonInfo = SEQ(name='ReasonInfo', mode=MODE_TYPE)
    _ReasonInfo_reasonCode = ENUM(name='reasonCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    _ReasonInfo_holdInstructionCode = OID(name='holdInstructionCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')), opt=True)
    ReasonInfo._cont = ASN1Dict([
        ('reasonCode', _ReasonInfo_reasonCode),
        ('holdInstructionCode', _ReasonInfo_holdInstructionCode),
        ])
    ReasonInfo._ext = []
    
    #-----< CertificateGroup >-----#
    CertificateGroup = CHOICE(name='CertificateGroup', mode=MODE_TYPE)
    _CertificateGroup_serialNumbers = SEQ_OF(name='serialNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateSerialNumbers')))
    _CertificateGroup_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroupNumberRange')))
    _CertificateGroup_nameSubtree = CHOICE(name='nameSubtree', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    CertificateGroup._cont = ASN1Dict([
        ('serialNumbers', _CertificateGroup_serialNumbers),
        ('serialNumberRange', _CertificateGroup_serialNumberRange),
        ('nameSubtree', _CertificateGroup_nameSubtree),
        ])
    CertificateGroup._ext = []
    
    #-----< CertificateGroupNumberRange >-----#
    CertificateGroupNumberRange = SEQ(name='CertificateGroupNumberRange', mode=MODE_TYPE)
    _CertificateGroupNumberRange_startingNumber = INT(name='startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CertificateGroupNumberRange_endingNumber = INT(name='endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CertificateGroupNumberRange._cont = ASN1Dict([
        ('startingNumber', _CertificateGroupNumberRange_startingNumber),
        ('endingNumber', _CertificateGroupNumberRange_endingNumber),
        ])
    CertificateGroupNumberRange._ext = []
    
    #-----< CertificateSerialNumbers >-----#
    CertificateSerialNumbers = SEQ_OF(name='CertificateSerialNumbers', mode=MODE_TYPE)
    _CertificateSerialNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    CertificateSerialNumbers._cont = _CertificateSerialNumbers__item_
    CertificateSerialNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< revokedGroups >-----#
    revokedGroups = CLASS(name='revokedGroups', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _revokedGroups_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroupsSyntax')))
    revokedGroups._val = dict([('ExtnType', _revokedGroups_val_ExtnType), ('id', (2, 5, 29, 59))])
    
    #-----< RevokedGroupsSyntax >-----#
    RevokedGroupsSyntax = SEQ_OF(name='RevokedGroupsSyntax', mode=MODE_TYPE)
    _RevokedGroupsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroup')))
    RevokedGroupsSyntax._cont = _RevokedGroupsSyntax__item_
    RevokedGroupsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevokedGroup >-----#
    RevokedGroup = SEQ(name='RevokedGroup', mode=MODE_TYPE)
    _RevokedGroup_certificateIssuer = CHOICE(name='certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _RevokedGroup_reasonInfo = SEQ(name='reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _RevokedGroup_invalidityDate = TIME_GEN(name='invalidityDate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RevokedGroup_revokedcertificateGroup = CHOICE(name='revokedcertificateGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'RevokedCertificateGroup')))
    RevokedGroup._cont = ASN1Dict([
        ('certificateIssuer', _RevokedGroup_certificateIssuer),
        ('reasonInfo', _RevokedGroup_reasonInfo),
        ('invalidityDate', _RevokedGroup_invalidityDate),
        ('revokedcertificateGroup', _RevokedGroup_revokedcertificateGroup),
        ])
    RevokedGroup._ext = []
    
    #-----< RevokedCertificateGroup >-----#
    RevokedCertificateGroup = CHOICE(name='RevokedCertificateGroup', mode=MODE_TYPE)
    _RevokedCertificateGroup_serialNumberRange = SEQ(name='serialNumberRange', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')))
    _RevokedCertificateGroup_nameSubtree = CHOICE(name='nameSubtree', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RevokedCertificateGroup._cont = ASN1Dict([
        ('serialNumberRange', _RevokedCertificateGroup_serialNumberRange),
        ('nameSubtree', _RevokedCertificateGroup_nameSubtree),
        ])
    RevokedCertificateGroup._ext = None
    
    #-----< expiredCertsOnCRL >-----#
    expiredCertsOnCRL = CLASS(name='expiredCertsOnCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _expiredCertsOnCRL_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ExpiredCertsOnCRL')))
    expiredCertsOnCRL._val = dict([('ExtnType', _expiredCertsOnCRL_val_ExtnType), ('id', (2, 5, 29, 60))])
    
    #-----< ExpiredCertsOnCRL >-----#
    ExpiredCertsOnCRL = TIME_GEN(name='ExpiredCertsOnCRL', mode=MODE_TYPE)
    
    #-----< reasonCode >-----#
    reasonCode = CLASS(name='reasonCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _reasonCode_val_ExtnType = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    reasonCode._val = dict([('ExtnType', _reasonCode_val_ExtnType), ('id', (2, 5, 29, 21))])
    
    #-----< CRLReason >-----#
    CRLReason = ENUM(name='CRLReason', mode=MODE_TYPE)
    CRLReason._cont = ASN1Dict([('unspecified', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('removeFromCRL', 8), ('privilegeWithdrawn', 9), ('aACompromise', 10), ('weakAlgorithmOrKey', 11)])
    CRLReason._ext = ['weakAlgorithmOrKey']
    
    #-----< holdInstructionCode >-----#
    holdInstructionCode = CLASS(name='holdInstructionCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holdInstructionCode_val_ExtnType = OID(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')))
    holdInstructionCode._val = dict([('ExtnType', _holdInstructionCode_val_ExtnType), ('id', (2, 5, 29, 23))])
    
    #-----< HoldInstruction >-----#
    HoldInstruction = OID(name='HoldInstruction', mode=MODE_TYPE)
    
    #-----< invalidityDate >-----#
    invalidityDate = CLASS(name='invalidityDate', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _invalidityDate_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    invalidityDate._val = dict([('ExtnType', _invalidityDate_val_ExtnType), ('id', (2, 5, 29, 24))])
    
    #-----< cRLDistributionPoints >-----#
    cRLDistributionPoints = CLASS(name='cRLDistributionPoints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLDistributionPoints_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    cRLDistributionPoints._val = dict([('ExtnType', _cRLDistributionPoints_val_ExtnType), ('id', (2, 5, 29, 31))])
    
    #-----< CRLDistPointsSyntax >-----#
    CRLDistPointsSyntax = SEQ_OF(name='CRLDistPointsSyntax', mode=MODE_TYPE)
    _CRLDistPointsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPoint')))
    CRLDistPointsSyntax._cont = _CRLDistPointsSyntax__item_
    CRLDistPointsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< DistributionPoint >-----#
    DistributionPoint = SEQ(name='DistributionPoint', mode=MODE_TYPE)
    _DistributionPoint_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _DistributionPoint_reasons = BIT_STR(name='reasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _DistributionPoint_cRLIssuer = SEQ_OF(name='cRLIssuer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    DistributionPoint._cont = ASN1Dict([
        ('distributionPoint', _DistributionPoint_distributionPoint),
        ('reasons', _DistributionPoint_reasons),
        ('cRLIssuer', _DistributionPoint_cRLIssuer),
        ])
    DistributionPoint._ext = []
    
    #-----< DistributionPointName >-----#
    DistributionPointName = CHOICE(name='DistributionPointName', mode=MODE_TYPE)
    _DistributionPointName_fullName = SEQ_OF(name='fullName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _DistributionPointName_nameRelativeToCRLIssuer = SET_OF(name='nameRelativeToCRLIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    DistributionPointName._cont = ASN1Dict([
        ('fullName', _DistributionPointName_fullName),
        ('nameRelativeToCRLIssuer', _DistributionPointName_nameRelativeToCRLIssuer),
        ])
    DistributionPointName._ext = []
    
    #-----< ReasonFlags >-----#
    ReasonFlags = BIT_STR(name='ReasonFlags', mode=MODE_TYPE)
    ReasonFlags._cont = ASN1Dict([('unused', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('privilegeWithdrawn', 7), ('aACompromise', 8), ('weakAlgorithmOrKey', 9)])
    ReasonFlags._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[10], er=[])
    
    #-----< issuingDistributionPoint >-----#
    issuingDistributionPoint = CLASS(name='issuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuingDistributionPoint_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'IssuingDistPointSyntax')))
    issuingDistributionPoint._val = dict([('ExtnType', _issuingDistributionPoint_val_ExtnType), ('id', (2, 5, 29, 28))])
    
    #-----< IssuingDistPointSyntax >-----#
    IssuingDistPointSyntax = SEQ(name='IssuingDistPointSyntax', mode=MODE_TYPE)
    _IssuingDistPointSyntax_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts = BOOL(name='onlyContainsUserPublicKeyCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlyContainsCACerts = BOOL(name='onlyContainsCACerts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _IssuingDistPointSyntax_indirectCRL = BOOL(name='indirectCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    IssuingDistPointSyntax._cont = ASN1Dict([
        ('distributionPoint', _IssuingDistPointSyntax_distributionPoint),
        ('onlyContainsUserPublicKeyCerts', _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts),
        ('onlyContainsCACerts', _IssuingDistPointSyntax_onlyContainsCACerts),
        ('onlySomeReasons', _IssuingDistPointSyntax_onlySomeReasons),
        ('indirectCRL', _IssuingDistPointSyntax_indirectCRL),
        ])
    IssuingDistPointSyntax._ext = []
    
    #-----< certificateIssuer >-----#
    certificateIssuer = CLASS(name='certificateIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificateIssuer_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    certificateIssuer._val = dict([('ExtnType', _certificateIssuer_val_ExtnType), ('id', (2, 5, 29, 29))])
    
    #-----< deltaCRLIndicator >-----#
    deltaCRLIndicator = CLASS(name='deltaCRLIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaCRLIndicator_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BaseCRLNumber')))
    deltaCRLIndicator._val = dict([('ExtnType', _deltaCRLIndicator_val_ExtnType), ('id', (2, 5, 29, 27))])
    
    #-----< BaseCRLNumber >-----#
    BaseCRLNumber = INT(name='BaseCRLNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    
    #-----< baseUpdateTime >-----#
    baseUpdateTime = CLASS(name='baseUpdateTime', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _baseUpdateTime_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    baseUpdateTime._val = dict([('ExtnType', _baseUpdateTime_val_ExtnType), ('id', (2, 5, 29, 51))])
    
    #-----< freshestCRL >-----#
    freshestCRL = CLASS(name='freshestCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _freshestCRL_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    freshestCRL._val = dict([('ExtnType', _freshestCRL_val_ExtnType), ('id', (2, 5, 29, 46))])
    
    #-----< aAissuingDistributionPoint >-----#
    aAissuingDistributionPoint = CLASS(name='aAissuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _aAissuingDistributionPoint_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AAIssuingDistPointSyntax')))
    aAissuingDistributionPoint._val = dict([('ExtnType', _aAissuingDistributionPoint_val_ExtnType), ('id', (2, 5, 29, 63))])
    
    #-----< AAIssuingDistPointSyntax >-----#
    AAIssuingDistPointSyntax = SEQ(name='AAIssuingDistPointSyntax', mode=MODE_TYPE)
    _AAIssuingDistPointSyntax_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _AAIssuingDistPointSyntax_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _AAIssuingDistPointSyntax_indirectCRL = BOOL(name='indirectCRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AAIssuingDistPointSyntax_containsUserAttributeCerts = BOOL(name='containsUserAttributeCerts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsAACerts = BOOL(name='containsAACerts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts = BOOL(name='containsSOAPublicKeyCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    AAIssuingDistPointSyntax._cont = ASN1Dict([
        ('distributionPoint', _AAIssuingDistPointSyntax_distributionPoint),
        ('onlySomeReasons', _AAIssuingDistPointSyntax_onlySomeReasons),
        ('indirectCRL', _AAIssuingDistPointSyntax_indirectCRL),
        ('containsUserAttributeCerts', _AAIssuingDistPointSyntax_containsUserAttributeCerts),
        ('containsAACerts', _AAIssuingDistPointSyntax_containsAACerts),
        ('containsSOAPublicKeyCerts', _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts),
        ])
    AAIssuingDistPointSyntax._ext = []
    
    #-----< certificateExactMatch >-----#
    certificateExactMatch = CLASS(name='certificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certificateExactMatch._val = dict([('AssertionType', _certificateExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), ('ldapName', ['certificateExactMatch']), ('ldapDesc', 'X.509 Certificate Exact Match'), ('id', (2, 5, 13, 34))])
    
    #-----< CertificateExactAssertion >-----#
    CertificateExactAssertion = SEQ(name='CertificateExactAssertion', mode=MODE_TYPE)
    _CertificateExactAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _CertificateExactAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    CertificateExactAssertion._cont = ASN1Dict([
        ('serialNumber', _CertificateExactAssertion_serialNumber),
        ('issuer', _CertificateExactAssertion_issuer),
        ])
    CertificateExactAssertion._ext = []
    
    #-----< certificateMatch >-----#
    certificateMatch = CLASS(name='certificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certificateMatch._val = dict([('AssertionType', _certificateMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 2)), ('ldapName', ['certificateMatch']), ('ldapDesc', 'X.509 Certificate Match'), ('id', (2, 5, 13, 35))])
    
    #-----< CertificateAssertion >-----#
    CertificateAssertion = SEQ(name='CertificateAssertion', mode=MODE_TYPE)
    _CertificateAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _CertificateAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _CertificateAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _CertificateAssertion_certificateValid = CHOICE(name='certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateAssertion_privateKeyValid = TIME_GEN(name='privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_subjectPublicKeyAlgID = OID(name='subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_keyUsage = BIT_STR(name='keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _CertificateAssertion_subjectAltName = CHOICE(name='subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')), opt=True)
    _CertificateAssertion_policy = SEQ_OF(name='policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _CertificateAssertion_pathToName = CHOICE(name='pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subject = CHOICE(name='subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_nameConstraints = SEQ(name='nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    CertificateAssertion._cont = ASN1Dict([
        ('serialNumber', _CertificateAssertion_serialNumber),
        ('issuer', _CertificateAssertion_issuer),
        ('subjectKeyIdentifier', _CertificateAssertion_subjectKeyIdentifier),
        ('authorityKeyIdentifier', _CertificateAssertion_authorityKeyIdentifier),
        ('certificateValid', _CertificateAssertion_certificateValid),
        ('privateKeyValid', _CertificateAssertion_privateKeyValid),
        ('subjectPublicKeyAlgID', _CertificateAssertion_subjectPublicKeyAlgID),
        ('keyUsage', _CertificateAssertion_keyUsage),
        ('subjectAltName', _CertificateAssertion_subjectAltName),
        ('policy', _CertificateAssertion_policy),
        ('pathToName', _CertificateAssertion_pathToName),
        ('subject', _CertificateAssertion_subject),
        ('nameConstraints', _CertificateAssertion_nameConstraints),
        ])
    CertificateAssertion._ext = []
    
    #-----< AltNameType >-----#
    AltNameType = CHOICE(name='AltNameType', mode=MODE_TYPE)
    _AltNameType_builtinNameForm = ENUM(name='builtinNameForm', mode=MODE_TYPE)
    _AltNameType_builtinNameForm._cont = ASN1Dict([('rfc822Name', 1), ('dNSName', 2), ('x400Address', 3), ('directoryName', 4), ('ediPartyName', 5), ('uniformResourceIdentifier', 6), ('iPAddress', 7), ('registeredId', 8)])
    _AltNameType_builtinNameForm._ext = []
    _AltNameType_otherNameForm = OID(name='otherNameForm', mode=MODE_TYPE)
    AltNameType._cont = ASN1Dict([
        ('builtinNameForm', _AltNameType_builtinNameForm),
        ('otherNameForm', _AltNameType_otherNameForm),
        ])
    AltNameType._ext = []
    
    #-----< CertPolicySet >-----#
    CertPolicySet = SEQ_OF(name='CertPolicySet', mode=MODE_TYPE)
    _CertPolicySet__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    CertPolicySet._cont = _CertPolicySet__item_
    CertPolicySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< certificatePairExactMatch >-----#
    certificatePairExactMatch = CLASS(name='certificatePairExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certificatePairExactMatch._val = dict([('AssertionType', _certificatePairExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), ('ldapName', ['certificatePairExactMatch']), ('ldapDesc', 'X.509 Certificate Pair Exact Match'), ('id', (2, 5, 13, 36))])
    
    #-----< CertificatePairExactAssertion >-----#
    CertificatePairExactAssertion = SEQ(name='CertificatePairExactAssertion', mode=MODE_TYPE)
    _CertificatePairExactAssertion_issuedToThisCAAssertion = SEQ(name='issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    _CertificatePairExactAssertion_issuedByThisCAAssertion = SEQ(name='issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    CertificatePairExactAssertion._cont = ASN1Dict([
        ('issuedToThisCAAssertion', _CertificatePairExactAssertion_issuedToThisCAAssertion),
        ('issuedByThisCAAssertion', _CertificatePairExactAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairExactAssertion._ext = []
    
    #-----< certificatePairMatch >-----#
    certificatePairMatch = CLASS(name='certificatePairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certificatePairMatch._val = dict([('AssertionType', _certificatePairMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 4)), ('ldapName', ['certificatePairMatch']), ('ldapDesc', 'X.509 Certificate Pair Match'), ('id', (2, 5, 13, 37))])
    
    #-----< CertificatePairAssertion >-----#
    CertificatePairAssertion = SEQ(name='CertificatePairAssertion', mode=MODE_TYPE)
    _CertificatePairAssertion_issuedToThisCAAssertion = SEQ(name='issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    _CertificatePairAssertion_issuedByThisCAAssertion = SEQ(name='issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    CertificatePairAssertion._cont = ASN1Dict([
        ('issuedToThisCAAssertion', _CertificatePairAssertion_issuedToThisCAAssertion),
        ('issuedByThisCAAssertion', _CertificatePairAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairAssertion._ext = []
    
    #-----< certificateListExactMatch >-----#
    certificateListExactMatch = CLASS(name='certificateListExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListExactMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certificateListExactMatch._val = dict([('AssertionType', _certificateListExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), ('ldapName', ['certificateListExactMatch']), ('ldapDesc', 'X.509 Certificate List Exact Match'), ('id', (2, 5, 13, 38))])
    
    #-----< CertificateListExactAssertion >-----#
    CertificateListExactAssertion = SEQ(name='CertificateListExactAssertion', mode=MODE_TYPE)
    _CertificateListExactAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListExactAssertion_thisUpdate = CHOICE(name='thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListExactAssertion_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    CertificateListExactAssertion._cont = ASN1Dict([
        ('issuer', _CertificateListExactAssertion_issuer),
        ('thisUpdate', _CertificateListExactAssertion_thisUpdate),
        ('distributionPoint', _CertificateListExactAssertion_distributionPoint),
        ])
    CertificateListExactAssertion._ext = None
    
    #-----< certificateListMatch >-----#
    certificateListMatch = CLASS(name='certificateListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certificateListMatch._val = dict([('AssertionType', _certificateListMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 6)), ('ldapName', ['certificateListMatch']), ('ldapDesc', 'X.509 Certificate List Match'), ('id', (2, 5, 13, 39))])
    
    #-----< CertificateListAssertion >-----#
    CertificateListAssertion = SEQ(name='CertificateListAssertion', mode=MODE_TYPE)
    _CertificateListAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateListAssertion_minCRLNumber = INT(name='minCRLNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_maxCRLNumber = INT(name='maxCRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_reasonFlags = BIT_STR(name='reasonFlags', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _CertificateListAssertion_dateAndTime = CHOICE(name='dateAndTime', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListAssertion_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _CertificateListAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    CertificateListAssertion._cont = ASN1Dict([
        ('issuer', _CertificateListAssertion_issuer),
        ('minCRLNumber', _CertificateListAssertion_minCRLNumber),
        ('maxCRLNumber', _CertificateListAssertion_maxCRLNumber),
        ('reasonFlags', _CertificateListAssertion_reasonFlags),
        ('dateAndTime', _CertificateListAssertion_dateAndTime),
        ('distributionPoint', _CertificateListAssertion_distributionPoint),
        ('authorityKeyIdentifier', _CertificateListAssertion_authorityKeyIdentifier),
        ])
    CertificateListAssertion._ext = []
    
    #-----< algorithmIdentifierMatch >-----#
    algorithmIdentifierMatch = CLASS(name='algorithmIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _algorithmIdentifierMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifierMatch_val_AssertionType_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab = ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_at = None
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_id = 'id'
    __algorithmIdentifierMatch_val_AssertionType_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab = ___algorithmIdentifierMatch_val_AssertionType_parameters_tab
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_at = ('..', 'algorithm')
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_id = 'Type'
    _algorithmIdentifierMatch_val_AssertionType._cont = ASN1Dict([
        ('algorithm', __algorithmIdentifierMatch_val_AssertionType_algorithm),
        ('parameters', __algorithmIdentifierMatch_val_AssertionType_parameters),
        ])
    _algorithmIdentifierMatch_val_AssertionType._ext = []
    algorithmIdentifierMatch._val = dict([('AssertionType', _algorithmIdentifierMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), ('ldapName', ['algorithmIdentifierMatch']), ('ldapDesc', 'X.509 Algorithm Identifier Match'), ('id', (2, 5, 13, 40))])
    
    #-----< policyMatch >-----#
    policyMatch = CLASS(name='policyMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _policyMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    policyMatch._val = dict([('AssertionType', _policyMatch_val_AssertionType), ('id', (2, 5, 13, 60))])
    
    #-----< pkiPathMatch >-----#
    pkiPathMatch = CLASS(name='pkiPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pkiPathMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PkiPathMatchSyntax')))
    pkiPathMatch._val = dict([('AssertionType', _pkiPathMatch_val_AssertionType), ('id', (2, 5, 13, 62))])
    
    #-----< PkiPathMatchSyntax >-----#
    PkiPathMatchSyntax = SEQ(name='PkiPathMatchSyntax', mode=MODE_TYPE)
    _PkiPathMatchSyntax_firstIssuer = CHOICE(name='firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _PkiPathMatchSyntax_lastSubject = CHOICE(name='lastSubject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    PkiPathMatchSyntax._cont = ASN1Dict([
        ('firstIssuer', _PkiPathMatchSyntax_firstIssuer),
        ('lastSubject', _PkiPathMatchSyntax_lastSubject),
        ])
    PkiPathMatchSyntax._ext = []
    
    #-----< enhancedCertificateMatch >-----#
    enhancedCertificateMatch = CLASS(name='enhancedCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _enhancedCertificateMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'EnhancedCertificateAssertion')))
    enhancedCertificateMatch._val = dict([('AssertionType', _enhancedCertificateMatch_val_AssertionType), ('id', (2, 5, 13, 65))])
    
    #-----< EnhancedCertificateAssertion >-----#
    EnhancedCertificateAssertion = SEQ(name='EnhancedCertificateAssertion', mode=MODE_TYPE)
    _EnhancedCertificateAssertion_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _EnhancedCertificateAssertion_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_authorityKeyIdentifier = SEQ(name='authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_certificateValid = CHOICE(name='certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _EnhancedCertificateAssertion_privateKeyValid = TIME_GEN(name='privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_subjectPublicKeyAlgID = OID(name='subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_keyUsage = BIT_STR(name='keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _EnhancedCertificateAssertion_subjectAltName = SEQ(name='subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltName')), opt=True)
    _EnhancedCertificateAssertion_policy = SEQ_OF(name='policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _EnhancedCertificateAssertion_pathToName = SEQ_OF(name='pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _EnhancedCertificateAssertion_subject = CHOICE(name='subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_nameConstraints = SEQ(name='nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    EnhancedCertificateAssertion._cont = ASN1Dict([
        ('serialNumber', _EnhancedCertificateAssertion_serialNumber),
        ('issuer', _EnhancedCertificateAssertion_issuer),
        ('subjectKeyIdentifier', _EnhancedCertificateAssertion_subjectKeyIdentifier),
        ('authorityKeyIdentifier', _EnhancedCertificateAssertion_authorityKeyIdentifier),
        ('certificateValid', _EnhancedCertificateAssertion_certificateValid),
        ('privateKeyValid', _EnhancedCertificateAssertion_privateKeyValid),
        ('subjectPublicKeyAlgID', _EnhancedCertificateAssertion_subjectPublicKeyAlgID),
        ('keyUsage', _EnhancedCertificateAssertion_keyUsage),
        ('subjectAltName', _EnhancedCertificateAssertion_subjectAltName),
        ('policy', _EnhancedCertificateAssertion_policy),
        ('pathToName', _EnhancedCertificateAssertion_pathToName),
        ('subject', _EnhancedCertificateAssertion_subject),
        ('nameConstraints', _EnhancedCertificateAssertion_nameConstraints),
        ])
    EnhancedCertificateAssertion._ext = []
    
    #-----< AltName >-----#
    AltName = SEQ(name='AltName', mode=MODE_TYPE)
    _AltName_altnameType = CHOICE(name='altnameType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')))
    _AltName_altNameValue = CHOICE(name='altNameValue', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    AltName._cont = ASN1Dict([
        ('altnameType', _AltName_altnameType),
        ('altNameValue', _AltName_altNameValue),
        ])
    AltName._ext = None
    
    #-----< certExactAssertion >-----#
    certExactAssertion = CLASS(name='certExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate Exact Assertion'), ('Type', _certExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 1))])
    
    #-----< certAssertion >-----#
    certAssertion = CLASS(name='certAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certAssertion._val = dict([('ldapDesc', 'X.509 Certificate Assertion'), ('Type', _certAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 2))])
    
    #-----< certPairExactAssertion >-----#
    certPairExactAssertion = CLASS(name='certPairExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certPairExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate Pair Exact Assertion'), ('Type', _certPairExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 3))])
    
    #-----< certPairAssertion >-----#
    certPairAssertion = CLASS(name='certPairAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certPairAssertion._val = dict([('ldapDesc', 'X.509 Certificate Pair Assertion'), ('Type', _certPairAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 4))])
    
    #-----< certListExactAssertion >-----#
    certListExactAssertion = CLASS(name='certListExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListExactAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certListExactAssertion._val = dict([('ldapDesc', 'X.509 Certificate List Exact Assertion'), ('Type', _certListExactAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 5))])
    
    #-----< certListAssertion >-----#
    certListAssertion = CLASS(name='certListAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListAssertion_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certListAssertion._val = dict([('ldapDesc', 'X.509 Certificate List Assertion'), ('Type', _certListAssertion_val_Type), ('id', (1, 3, 6, 1, 1, 15, 6))])
    
    #-----< algorithmIdentifier >-----#
    algorithmIdentifier = CLASS(name='algorithmIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _algorithmIdentifier_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifier_val_Type_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___algorithmIdentifier_val_Type_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_algorithm._const_tab = ___algorithmIdentifier_val_Type_algorithm_tab
    __algorithmIdentifier_val_Type_algorithm._const_tab_at = None
    __algorithmIdentifier_val_Type_algorithm._const_tab_id = 'id'
    __algorithmIdentifier_val_Type_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___algorithmIdentifier_val_Type_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_parameters._const_tab = ___algorithmIdentifier_val_Type_parameters_tab
    __algorithmIdentifier_val_Type_parameters._const_tab_at = ('..', 'algorithm')
    __algorithmIdentifier_val_Type_parameters._const_tab_id = 'Type'
    _algorithmIdentifier_val_Type._cont = ASN1Dict([
        ('algorithm', __algorithmIdentifier_val_Type_algorithm),
        ('parameters', __algorithmIdentifier_val_Type_parameters),
        ])
    _algorithmIdentifier_val_Type._ext = []
    algorithmIdentifier._val = dict([('ldapDesc', 'X.509 Algorithm Identifier'), ('Type', _algorithmIdentifier_val_Type), ('id', (1, 3, 6, 1, 1, 15, 7))])
    
    #-----< id-ce-subjectDirectoryAttributes >-----#
    id_ce_subjectDirectoryAttributes = OID(name='id-ce-subjectDirectoryAttributes', mode=MODE_VALUE)
    id_ce_subjectDirectoryAttributes._val = (2, 5, 29, 9)
    
    #-----< id-ce-subjectKeyIdentifier >-----#
    id_ce_subjectKeyIdentifier = OID(name='id-ce-subjectKeyIdentifier', mode=MODE_VALUE)
    id_ce_subjectKeyIdentifier._val = (2, 5, 29, 14)
    
    #-----< id-ce-keyUsage >-----#
    id_ce_keyUsage = OID(name='id-ce-keyUsage', mode=MODE_VALUE)
    id_ce_keyUsage._val = (2, 5, 29, 15)
    
    #-----< id-ce-privateKeyUsagePeriod >-----#
    id_ce_privateKeyUsagePeriod = OID(name='id-ce-privateKeyUsagePeriod', mode=MODE_VALUE)
    id_ce_privateKeyUsagePeriod._val = (2, 5, 29, 16)
    
    #-----< id-ce-subjectAltName >-----#
    id_ce_subjectAltName = OID(name='id-ce-subjectAltName', mode=MODE_VALUE)
    id_ce_subjectAltName._val = (2, 5, 29, 17)
    
    #-----< id-ce-issuerAltName >-----#
    id_ce_issuerAltName = OID(name='id-ce-issuerAltName', mode=MODE_VALUE)
    id_ce_issuerAltName._val = (2, 5, 29, 18)
    
    #-----< id-ce-basicConstraints >-----#
    id_ce_basicConstraints = OID(name='id-ce-basicConstraints', mode=MODE_VALUE)
    id_ce_basicConstraints._val = (2, 5, 29, 19)
    
    #-----< id-ce-cRLNumber >-----#
    id_ce_cRLNumber = OID(name='id-ce-cRLNumber', mode=MODE_VALUE)
    id_ce_cRLNumber._val = (2, 5, 29, 20)
    
    #-----< id-ce-reasonCode >-----#
    id_ce_reasonCode = OID(name='id-ce-reasonCode', mode=MODE_VALUE)
    id_ce_reasonCode._val = (2, 5, 29, 21)
    
    #-----< id-ce-instructionCode >-----#
    id_ce_instructionCode = OID(name='id-ce-instructionCode', mode=MODE_VALUE)
    id_ce_instructionCode._val = (2, 5, 29, 23)
    
    #-----< id-ce-invalidityDate >-----#
    id_ce_invalidityDate = OID(name='id-ce-invalidityDate', mode=MODE_VALUE)
    id_ce_invalidityDate._val = (2, 5, 29, 24)
    
    #-----< id-ce-deltaCRLIndicator >-----#
    id_ce_deltaCRLIndicator = OID(name='id-ce-deltaCRLIndicator', mode=MODE_VALUE)
    id_ce_deltaCRLIndicator._val = (2, 5, 29, 27)
    
    #-----< id-ce-issuingDistributionPoint >-----#
    id_ce_issuingDistributionPoint = OID(name='id-ce-issuingDistributionPoint', mode=MODE_VALUE)
    id_ce_issuingDistributionPoint._val = (2, 5, 29, 28)
    
    #-----< id-ce-certificateIssuer >-----#
    id_ce_certificateIssuer = OID(name='id-ce-certificateIssuer', mode=MODE_VALUE)
    id_ce_certificateIssuer._val = (2, 5, 29, 29)
    
    #-----< id-ce-nameConstraints >-----#
    id_ce_nameConstraints = OID(name='id-ce-nameConstraints', mode=MODE_VALUE)
    id_ce_nameConstraints._val = (2, 5, 29, 30)
    
    #-----< id-ce-cRLDistributionPoints >-----#
    id_ce_cRLDistributionPoints = OID(name='id-ce-cRLDistributionPoints', mode=MODE_VALUE)
    id_ce_cRLDistributionPoints._val = (2, 5, 29, 31)
    
    #-----< id-ce-certificatePolicies >-----#
    id_ce_certificatePolicies = OID(name='id-ce-certificatePolicies', mode=MODE_VALUE)
    id_ce_certificatePolicies._val = (2, 5, 29, 32)
    
    #-----< id-ce-policyMappings >-----#
    id_ce_policyMappings = OID(name='id-ce-policyMappings', mode=MODE_VALUE)
    id_ce_policyMappings._val = (2, 5, 29, 33)
    
    #-----< id-ce-authorityKeyIdentifier >-----#
    id_ce_authorityKeyIdentifier = OID(name='id-ce-authorityKeyIdentifier', mode=MODE_VALUE)
    id_ce_authorityKeyIdentifier._val = (2, 5, 29, 35)
    
    #-----< id-ce-policyConstraints >-----#
    id_ce_policyConstraints = OID(name='id-ce-policyConstraints', mode=MODE_VALUE)
    id_ce_policyConstraints._val = (2, 5, 29, 36)
    
    #-----< id-ce-extKeyUsage >-----#
    id_ce_extKeyUsage = OID(name='id-ce-extKeyUsage', mode=MODE_VALUE)
    id_ce_extKeyUsage._val = (2, 5, 29, 37)
    
    #-----< id-ce-cRLStreamIdentifier >-----#
    id_ce_cRLStreamIdentifier = OID(name='id-ce-cRLStreamIdentifier', mode=MODE_VALUE)
    id_ce_cRLStreamIdentifier._val = (2, 5, 29, 40)
    
    #-----< id-ce-cRLScope >-----#
    id_ce_cRLScope = OID(name='id-ce-cRLScope', mode=MODE_VALUE)
    id_ce_cRLScope._val = (2, 5, 29, 44)
    
    #-----< id-ce-statusReferrals >-----#
    id_ce_statusReferrals = OID(name='id-ce-statusReferrals', mode=MODE_VALUE)
    id_ce_statusReferrals._val = (2, 5, 29, 45)
    
    #-----< id-ce-freshestCRL >-----#
    id_ce_freshestCRL = OID(name='id-ce-freshestCRL', mode=MODE_VALUE)
    id_ce_freshestCRL._val = (2, 5, 29, 46)
    
    #-----< id-ce-orderedList >-----#
    id_ce_orderedList = OID(name='id-ce-orderedList', mode=MODE_VALUE)
    id_ce_orderedList._val = (2, 5, 29, 47)
    
    #-----< id-ce-baseUpdateTime >-----#
    id_ce_baseUpdateTime = OID(name='id-ce-baseUpdateTime', mode=MODE_VALUE)
    id_ce_baseUpdateTime._val = (2, 5, 29, 51)
    
    #-----< id-ce-deltaInfo >-----#
    id_ce_deltaInfo = OID(name='id-ce-deltaInfo', mode=MODE_VALUE)
    id_ce_deltaInfo._val = (2, 5, 29, 53)
    
    #-----< id-ce-inhibitAnyPolicy >-----#
    id_ce_inhibitAnyPolicy = OID(name='id-ce-inhibitAnyPolicy', mode=MODE_VALUE)
    id_ce_inhibitAnyPolicy._val = (2, 5, 29, 54)
    
    #-----< id-ce-toBeRevoked >-----#
    id_ce_toBeRevoked = OID(name='id-ce-toBeRevoked', mode=MODE_VALUE)
    id_ce_toBeRevoked._val = (2, 5, 29, 58)
    
    #-----< id-ce-RevokedGroups >-----#
    id_ce_RevokedGroups = OID(name='id-ce-RevokedGroups', mode=MODE_VALUE)
    id_ce_RevokedGroups._val = (2, 5, 29, 59)
    
    #-----< id-ce-expiredCertsOnCRL >-----#
    id_ce_expiredCertsOnCRL = OID(name='id-ce-expiredCertsOnCRL', mode=MODE_VALUE)
    id_ce_expiredCertsOnCRL._val = (2, 5, 29, 60)
    
    #-----< id-ce-aAissuingDistributionPoint >-----#
    id_ce_aAissuingDistributionPoint = OID(name='id-ce-aAissuingDistributionPoint', mode=MODE_VALUE)
    id_ce_aAissuingDistributionPoint._val = (2, 5, 29, 63)
    
    #-----< id-mr-certificateExactMatch >-----#
    id_mr_certificateExactMatch = OID(name='id-mr-certificateExactMatch', mode=MODE_VALUE)
    id_mr_certificateExactMatch._val = (2, 5, 13, 34)
    
    #-----< id-mr-certificateMatch >-----#
    id_mr_certificateMatch = OID(name='id-mr-certificateMatch', mode=MODE_VALUE)
    id_mr_certificateMatch._val = (2, 5, 13, 35)
    
    #-----< id-mr-certificatePairExactMatch >-----#
    id_mr_certificatePairExactMatch = OID(name='id-mr-certificatePairExactMatch', mode=MODE_VALUE)
    id_mr_certificatePairExactMatch._val = (2, 5, 13, 36)
    
    #-----< id-mr-certificatePairMatch >-----#
    id_mr_certificatePairMatch = OID(name='id-mr-certificatePairMatch', mode=MODE_VALUE)
    id_mr_certificatePairMatch._val = (2, 5, 13, 37)
    
    #-----< id-mr-certificateListExactMatch >-----#
    id_mr_certificateListExactMatch = OID(name='id-mr-certificateListExactMatch', mode=MODE_VALUE)
    id_mr_certificateListExactMatch._val = (2, 5, 13, 38)
    
    #-----< id-mr-certificateListMatch >-----#
    id_mr_certificateListMatch = OID(name='id-mr-certificateListMatch', mode=MODE_VALUE)
    id_mr_certificateListMatch._val = (2, 5, 13, 39)
    
    #-----< id-mr-algorithmIdentifierMatch >-----#
    id_mr_algorithmIdentifierMatch = OID(name='id-mr-algorithmIdentifierMatch', mode=MODE_VALUE)
    id_mr_algorithmIdentifierMatch._val = (2, 5, 13, 40)
    
    #-----< id-mr-policyMatch >-----#
    id_mr_policyMatch = OID(name='id-mr-policyMatch', mode=MODE_VALUE)
    id_mr_policyMatch._val = (2, 5, 13, 60)
    
    #-----< id-mr-pkiPathMatch >-----#
    id_mr_pkiPathMatch = OID(name='id-mr-pkiPathMatch', mode=MODE_VALUE)
    id_mr_pkiPathMatch._val = (2, 5, 13, 62)
    
    #-----< id-mr-enhancedCertificateMatch >-----#
    id_mr_enhancedCertificateMatch = OID(name='id-mr-enhancedCertificateMatch', mode=MODE_VALUE)
    id_mr_enhancedCertificateMatch._val = (2, 5, 13, 65)
    
    #-----< id-ldx-certExactAssertion >-----#
    id_ldx_certExactAssertion = OID(name='id-ldx-certExactAssertion', mode=MODE_VALUE)
    id_ldx_certExactAssertion._val = (1, 3, 6, 1, 1, 15, 1)
    
    #-----< id-ldx-certAssertion >-----#
    id_ldx_certAssertion = OID(name='id-ldx-certAssertion', mode=MODE_VALUE)
    id_ldx_certAssertion._val = (1, 3, 6, 1, 1, 15, 2)
    
    #-----< id-ldx-certPairExactAssertion >-----#
    id_ldx_certPairExactAssertion = OID(name='id-ldx-certPairExactAssertion', mode=MODE_VALUE)
    id_ldx_certPairExactAssertion._val = (1, 3, 6, 1, 1, 15, 3)
    
    #-----< id-ldx-certPairAssertion >-----#
    id_ldx_certPairAssertion = OID(name='id-ldx-certPairAssertion', mode=MODE_VALUE)
    id_ldx_certPairAssertion._val = (1, 3, 6, 1, 1, 15, 4)
    
    #-----< id-ldx-certListExactAssertion >-----#
    id_ldx_certListExactAssertion = OID(name='id-ldx-certListExactAssertion', mode=MODE_VALUE)
    id_ldx_certListExactAssertion._val = (1, 3, 6, 1, 1, 15, 5)
    
    #-----< id-ldx-certListAssertion >-----#
    id_ldx_certListAssertion = OID(name='id-ldx-certListAssertion', mode=MODE_VALUE)
    id_ldx_certListAssertion._val = (1, 3, 6, 1, 1, 15, 6)
    
    #-----< id-ldx-algorithmIdentifier >-----#
    id_ldx_algorithmIdentifier = OID(name='id-ldx-algorithmIdentifier', mode=MODE_VALUE)
    id_ldx_algorithmIdentifier._val = (1, 3, 6, 1, 1, 15, 7)
    
    _all_ = [
        authorityKeyIdentifier,
        _authorityKeyIdentifier_val_ExtnType,
        _AuthorityKeyIdentifier_keyIdentifier,
        _AuthorityKeyIdentifier_authorityCertIssuer,
        _AuthorityKeyIdentifier_authorityCertSerialNumber,
        AuthorityKeyIdentifier,
        KeyIdentifier,
        subjectKeyIdentifier,
        _subjectKeyIdentifier_val_ExtnType,
        SubjectKeyIdentifier,
        keyUsage,
        _keyUsage_val_ExtnType,
        KeyUsage,
        extKeyUsage,
        __extKeyUsage_val_ExtnType__item_,
        _extKeyUsage_val_ExtnType,
        KeyPurposeId,
        privateKeyUsagePeriod,
        _privateKeyUsagePeriod_val_ExtnType,
        _PrivateKeyUsagePeriod_notBefore,
        _PrivateKeyUsagePeriod_notAfter,
        PrivateKeyUsagePeriod,
        certificatePolicies,
        _certificatePolicies_val_ExtnType,
        _CertificatePoliciesSyntax__item_,
        CertificatePoliciesSyntax,
        _PolicyInformation_policyIdentifier,
        __PolicyInformation_policyQualifiers__item_,
        _PolicyInformation_policyQualifiers,
        PolicyInformation,
        CertPolicyId,
        __PolicyQualifierInfo_policyQualifierId_tab,
        _PolicyQualifierInfo_policyQualifierId,
        __PolicyQualifierInfo_qualifier_tab,
        _PolicyQualifierInfo_qualifier,
        PolicyQualifierInfo,
        SupportedPolicyQualifiers,
        anyPolicy,
        _CERT_POLICY_QUALIFIER_id,
        _CERT_POLICY_QUALIFIER_Qualifier,
        CERT_POLICY_QUALIFIER,
        policyMappings,
        _policyMappings_val_ExtnType,
        __PolicyMappingsSyntax__item__issuerDomainPolicy,
        __PolicyMappingsSyntax__item__subjectDomainPolicy,
        _PolicyMappingsSyntax__item_,
        PolicyMappingsSyntax,
        subjectAltName,
        _subjectAltName_val_ExtnType,
        _GeneralNames__item_,
        GeneralNames,
        __GeneralName_otherName_type_id,
        __GeneralName_otherName_value,
        _GeneralName_otherName,
        _GeneralName_otherName,
        _GeneralName_rfc822Name,
        _GeneralName_dNSName,
        _GeneralName_x400Address,
        _GeneralName_directoryName,
        _GeneralName_ediPartyName,
        _GeneralName_uniformResourceIdentifier,
        _GeneralName_iPAddress,
        _GeneralName_registeredID,
        GeneralName,
        OTHER_NAME,
        _EDIPartyName_nameAssigner,
        _EDIPartyName_partyName,
        EDIPartyName,
        issuerAltName,
        _issuerAltName_val_ExtnType,
        subjectDirectoryAttributes,
        _subjectDirectoryAttributes_val_ExtnType,
        ___AttributesSyntax__item__type_tab,
        ____AttributesSyntax__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        ____AttributesSyntax__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __AttributesSyntax__item__type,
        ___AttributesSyntax__item__values__item_,
        __AttributesSyntax__item__values,
        ____AttributesSyntax__item__valuesWithContext__item__value,
        _____AttributesSyntax__item__valuesWithContext__item__contextList__item_,
        ____AttributesSyntax__item__valuesWithContext__item__contextList,
        ___AttributesSyntax__item__valuesWithContext__item_,
        __AttributesSyntax__item__valuesWithContext,
        _AttributesSyntax__item_,
        AttributesSyntax,
        basicConstraints,
        _basicConstraints_val_ExtnType,
        _BasicConstraintsSyntax_cA,
        _BasicConstraintsSyntax_pathLenConstraint,
        BasicConstraintsSyntax,
        nameConstraints,
        _nameConstraints_val_ExtnType,
        _NameConstraintsSyntax_permittedSubtrees,
        _NameConstraintsSyntax_excludedSubtrees,
        NameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        policyConstraints,
        _policyConstraints_val_ExtnType,
        _PolicyConstraintsSyntax_requireExplicitPolicy,
        _PolicyConstraintsSyntax_inhibitPolicyMapping,
        PolicyConstraintsSyntax,
        SkipCerts,
        inhibitAnyPolicy,
        _inhibitAnyPolicy_val_ExtnType,
        cRLNumber,
        _cRLNumber_val_ExtnType,
        CRLNumber,
        crlScope,
        _crlScope_val_ExtnType,
        _CRLScopeSyntax__item_,
        CRLScopeSyntax,
        _PerAuthorityScope_authorityName,
        _PerAuthorityScope_distributionPoint,
        _PerAuthorityScope_onlyContains,
        _PerAuthorityScope_onlySomeReasons,
        _PerAuthorityScope_serialNumberRange,
        _PerAuthorityScope_subjectKeyIdRange,
        _PerAuthorityScope_nameSubtrees,
        _PerAuthorityScope_baseRevocationInfo,
        PerAuthorityScope,
        OnlyCertificateTypes,
        _NumberRange_startingNumber,
        _NumberRange_endingNumber,
        _NumberRange_modulus,
        NumberRange,
        _BaseRevocationInfo_cRLStreamIdentifier,
        _BaseRevocationInfo_cRLNumber,
        _BaseRevocationInfo_baseThisUpdate,
        BaseRevocationInfo,
        statusReferrals,
        _statusReferrals_val_ExtnType,
        _StatusReferrals__item_,
        StatusReferrals,
        _StatusReferral_cRLReferral,
        __StatusReferral_otherReferral_type_id,
        __StatusReferral_otherReferral_value,
        _StatusReferral_otherReferral,
        _StatusReferral_otherReferral,
        StatusReferral,
        _CRLReferral_issuer,
        _CRLReferral_location,
        _CRLReferral_deltaRefInfo,
        _CRLReferral_cRLScope,
        _CRLReferral_lastUpdate,
        _CRLReferral_lastChangedCRL,
        CRLReferral,
        _DeltaRefInfo_deltaLocation,
        _DeltaRefInfo_lastDelta,
        DeltaRefInfo,
        OTHER_REFERRAL,
        cRLStreamIdentifier,
        _cRLStreamIdentifier_val_ExtnType,
        CRLStreamIdentifier,
        orderedList,
        _orderedList_val_ExtnType,
        OrderedListSyntax,
        deltaInfo,
        _deltaInfo_val_ExtnType,
        _DeltaInformation_deltaLocation,
        _DeltaInformation_nextDelta,
        DeltaInformation,
        toBeRevoked,
        _toBeRevoked_val_ExtnType,
        _ToBeRevokedSyntax__item_,
        ToBeRevokedSyntax,
        _ToBeRevokedGroup_certificateIssuer,
        _ToBeRevokedGroup_reasonInfo,
        _ToBeRevokedGroup_revocationTime,
        _ToBeRevokedGroup_certificateGroup,
        ToBeRevokedGroup,
        _ReasonInfo_reasonCode,
        _ReasonInfo_holdInstructionCode,
        ReasonInfo,
        _CertificateGroup_serialNumbers,
        _CertificateGroup_serialNumberRange,
        _CertificateGroup_nameSubtree,
        CertificateGroup,
        _CertificateGroupNumberRange_startingNumber,
        _CertificateGroupNumberRange_endingNumber,
        CertificateGroupNumberRange,
        _CertificateSerialNumbers__item_,
        CertificateSerialNumbers,
        revokedGroups,
        _revokedGroups_val_ExtnType,
        _RevokedGroupsSyntax__item_,
        RevokedGroupsSyntax,
        _RevokedGroup_certificateIssuer,
        _RevokedGroup_reasonInfo,
        _RevokedGroup_invalidityDate,
        _RevokedGroup_revokedcertificateGroup,
        RevokedGroup,
        _RevokedCertificateGroup_serialNumberRange,
        _RevokedCertificateGroup_nameSubtree,
        RevokedCertificateGroup,
        expiredCertsOnCRL,
        _expiredCertsOnCRL_val_ExtnType,
        ExpiredCertsOnCRL,
        reasonCode,
        _reasonCode_val_ExtnType,
        CRLReason,
        holdInstructionCode,
        _holdInstructionCode_val_ExtnType,
        HoldInstruction,
        invalidityDate,
        _invalidityDate_val_ExtnType,
        cRLDistributionPoints,
        _cRLDistributionPoints_val_ExtnType,
        _CRLDistPointsSyntax__item_,
        CRLDistPointsSyntax,
        _DistributionPoint_distributionPoint,
        _DistributionPoint_reasons,
        _DistributionPoint_cRLIssuer,
        DistributionPoint,
        _DistributionPointName_fullName,
        _DistributionPointName_nameRelativeToCRLIssuer,
        DistributionPointName,
        ReasonFlags,
        issuingDistributionPoint,
        _issuingDistributionPoint_val_ExtnType,
        _IssuingDistPointSyntax_distributionPoint,
        _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts,
        _IssuingDistPointSyntax_onlyContainsCACerts,
        _IssuingDistPointSyntax_onlySomeReasons,
        _IssuingDistPointSyntax_indirectCRL,
        IssuingDistPointSyntax,
        certificateIssuer,
        _certificateIssuer_val_ExtnType,
        deltaCRLIndicator,
        _deltaCRLIndicator_val_ExtnType,
        BaseCRLNumber,
        baseUpdateTime,
        _baseUpdateTime_val_ExtnType,
        freshestCRL,
        _freshestCRL_val_ExtnType,
        aAissuingDistributionPoint,
        _aAissuingDistributionPoint_val_ExtnType,
        _AAIssuingDistPointSyntax_distributionPoint,
        _AAIssuingDistPointSyntax_onlySomeReasons,
        _AAIssuingDistPointSyntax_indirectCRL,
        _AAIssuingDistPointSyntax_containsUserAttributeCerts,
        _AAIssuingDistPointSyntax_containsAACerts,
        _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts,
        AAIssuingDistPointSyntax,
        certificateExactMatch,
        _certificateExactMatch_val_AssertionType,
        _CertificateExactAssertion_serialNumber,
        _CertificateExactAssertion_issuer,
        CertificateExactAssertion,
        certificateMatch,
        _certificateMatch_val_AssertionType,
        _CertificateAssertion_serialNumber,
        _CertificateAssertion_issuer,
        _CertificateAssertion_subjectKeyIdentifier,
        _CertificateAssertion_authorityKeyIdentifier,
        _CertificateAssertion_certificateValid,
        _CertificateAssertion_privateKeyValid,
        _CertificateAssertion_subjectPublicKeyAlgID,
        _CertificateAssertion_keyUsage,
        _CertificateAssertion_subjectAltName,
        _CertificateAssertion_policy,
        _CertificateAssertion_pathToName,
        _CertificateAssertion_subject,
        _CertificateAssertion_nameConstraints,
        CertificateAssertion,
        _AltNameType_builtinNameForm,
        _AltNameType_otherNameForm,
        AltNameType,
        _CertPolicySet__item_,
        CertPolicySet,
        certificatePairExactMatch,
        _certificatePairExactMatch_val_AssertionType,
        _CertificatePairExactAssertion_issuedToThisCAAssertion,
        _CertificatePairExactAssertion_issuedByThisCAAssertion,
        CertificatePairExactAssertion,
        certificatePairMatch,
        _certificatePairMatch_val_AssertionType,
        _CertificatePairAssertion_issuedToThisCAAssertion,
        _CertificatePairAssertion_issuedByThisCAAssertion,
        CertificatePairAssertion,
        certificateListExactMatch,
        _certificateListExactMatch_val_AssertionType,
        _CertificateListExactAssertion_issuer,
        _CertificateListExactAssertion_thisUpdate,
        _CertificateListExactAssertion_distributionPoint,
        CertificateListExactAssertion,
        certificateListMatch,
        _certificateListMatch_val_AssertionType,
        _CertificateListAssertion_issuer,
        _CertificateListAssertion_minCRLNumber,
        _CertificateListAssertion_maxCRLNumber,
        _CertificateListAssertion_reasonFlags,
        _CertificateListAssertion_dateAndTime,
        _CertificateListAssertion_distributionPoint,
        _CertificateListAssertion_authorityKeyIdentifier,
        CertificateListAssertion,
        algorithmIdentifierMatch,
        ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab,
        __algorithmIdentifierMatch_val_AssertionType_algorithm,
        ___algorithmIdentifierMatch_val_AssertionType_parameters_tab,
        __algorithmIdentifierMatch_val_AssertionType_parameters,
        _algorithmIdentifierMatch_val_AssertionType,
        policyMatch,
        _policyMatch_val_AssertionType,
        pkiPathMatch,
        _pkiPathMatch_val_AssertionType,
        _PkiPathMatchSyntax_firstIssuer,
        _PkiPathMatchSyntax_lastSubject,
        PkiPathMatchSyntax,
        enhancedCertificateMatch,
        _enhancedCertificateMatch_val_AssertionType,
        _EnhancedCertificateAssertion_serialNumber,
        _EnhancedCertificateAssertion_issuer,
        _EnhancedCertificateAssertion_subjectKeyIdentifier,
        _EnhancedCertificateAssertion_authorityKeyIdentifier,
        _EnhancedCertificateAssertion_certificateValid,
        _EnhancedCertificateAssertion_privateKeyValid,
        _EnhancedCertificateAssertion_subjectPublicKeyAlgID,
        _EnhancedCertificateAssertion_keyUsage,
        _EnhancedCertificateAssertion_subjectAltName,
        _EnhancedCertificateAssertion_policy,
        _EnhancedCertificateAssertion_pathToName,
        _EnhancedCertificateAssertion_subject,
        _EnhancedCertificateAssertion_nameConstraints,
        EnhancedCertificateAssertion,
        _AltName_altnameType,
        _AltName_altNameValue,
        AltName,
        certExactAssertion,
        _certExactAssertion_val_Type,
        certAssertion,
        _certAssertion_val_Type,
        certPairExactAssertion,
        _certPairExactAssertion_val_Type,
        certPairAssertion,
        _certPairAssertion_val_Type,
        certListExactAssertion,
        _certListExactAssertion_val_Type,
        certListAssertion,
        _certListAssertion_val_Type,
        algorithmIdentifier,
        ___algorithmIdentifier_val_Type_algorithm_tab,
        __algorithmIdentifier_val_Type_algorithm,
        ___algorithmIdentifier_val_Type_parameters_tab,
        __algorithmIdentifier_val_Type_parameters,
        _algorithmIdentifier_val_Type,
        id_ce_subjectDirectoryAttributes,
        id_ce_subjectKeyIdentifier,
        id_ce_keyUsage,
        id_ce_privateKeyUsagePeriod,
        id_ce_subjectAltName,
        id_ce_issuerAltName,
        id_ce_basicConstraints,
        id_ce_cRLNumber,
        id_ce_reasonCode,
        id_ce_instructionCode,
        id_ce_invalidityDate,
        id_ce_deltaCRLIndicator,
        id_ce_issuingDistributionPoint,
        id_ce_certificateIssuer,
        id_ce_nameConstraints,
        id_ce_cRLDistributionPoints,
        id_ce_certificatePolicies,
        id_ce_policyMappings,
        id_ce_authorityKeyIdentifier,
        id_ce_policyConstraints,
        id_ce_extKeyUsage,
        id_ce_cRLStreamIdentifier,
        id_ce_cRLScope,
        id_ce_statusReferrals,
        id_ce_freshestCRL,
        id_ce_orderedList,
        id_ce_baseUpdateTime,
        id_ce_deltaInfo,
        id_ce_inhibitAnyPolicy,
        id_ce_toBeRevoked,
        id_ce_RevokedGroups,
        id_ce_expiredCertsOnCRL,
        id_ce_aAissuingDistributionPoint,
        id_mr_certificateExactMatch,
        id_mr_certificateMatch,
        id_mr_certificatePairExactMatch,
        id_mr_certificatePairMatch,
        id_mr_certificateListExactMatch,
        id_mr_certificateListMatch,
        id_mr_algorithmIdentifierMatch,
        id_mr_policyMatch,
        id_mr_pkiPathMatch,
        id_mr_enhancedCertificateMatch,
        id_ldx_certExactAssertion,
        id_ldx_certAssertion,
        id_ldx_certPairExactAssertion,
        id_ldx_certPairAssertion,
        id_ldx_certListExactAssertion,
        id_ldx_certListAssertion,
        id_ldx_algorithmIdentifier,
    ]

class CommonProtocolSpecification:

    _name_  = 'CommonProtocolSpecification'
    _oid_   = [2, 5, 1, 35, 7]
    
    _obj_ = [
        'OPERATION',
        'ERROR',
        'Code',
        'InvokeId',
        'id-opcode-read',
        'id-opcode-compare',
        'id-opcode-abandon',
        'id-opcode-list',
        'id-opcode-search',
        'id-opcode-addEntry',
        'id-opcode-removeEntry',
        'id-opcode-modifyEntry',
        'id-opcode-modifyDN',
        'id-opcode-changePassword',
        'id-opcode-administerPassword',
        'id-opcode-ldapTransport',
        'id-opcode-linkedLDAP',
        'id-opcode-requestShadowUpdate',
        'id-opcode-updateShadow',
        'id-opcode-coordinateShadowUpdate',
        'id-op-establishOperationalBinding',
        'id-op-modifyOperationalBinding',
        'id-op-terminateOperationalBinding',
        'id-errcode-attributeError',
        'id-errcode-nameError',
        'id-errcode-serviceError',
        'id-errcode-referral',
        'id-errcode-abandoned',
        'id-errcode-securityError',
        'id-errcode-abandonFailed',
        'id-errcode-updateError',
        'id-errcode-dsaReferral',
        'id-errcode-shadowError',
        'id-err-operationalBindingError',
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _type_ = [
        'OPERATION',
        'ERROR',
        'Code',
        'InvokeId',
        ]
    _set_ = [
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _val_ = [
        'id-opcode-read',
        'id-opcode-compare',
        'id-opcode-abandon',
        'id-opcode-list',
        'id-opcode-search',
        'id-opcode-addEntry',
        'id-opcode-removeEntry',
        'id-opcode-modifyEntry',
        'id-opcode-modifyDN',
        'id-opcode-changePassword',
        'id-opcode-administerPassword',
        'id-opcode-ldapTransport',
        'id-opcode-linkedLDAP',
        'id-opcode-requestShadowUpdate',
        'id-opcode-updateShadow',
        'id-opcode-coordinateShadowUpdate',
        'id-op-establishOperationalBinding',
        'id-op-modifyOperationalBinding',
        'id-op-terminateOperationalBinding',
        'id-errcode-attributeError',
        'id-errcode-nameError',
        'id-errcode-serviceError',
        'id-errcode-referral',
        'id-errcode-abandoned',
        'id-errcode-securityError',
        'id-errcode-abandonFailed',
        'id-errcode-updateError',
        'id-errcode-dsaReferral',
        'id-errcode-shadowError',
        'id-err-operationalBindingError',
        ]
    _class_ = [
        'OPERATION',
        'ERROR',
        'DOP-Invokable',
        'DOP-Returnable',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name='OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name='ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_ResultType = OPEN(name='ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_Errors = CLASS(name='Errors', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')), opt=True)
    _OPERATION_operationCode = CHOICE(name='operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        ('ArgumentType', _OPERATION_ArgumentType),
        ('ResultType', _OPERATION_ResultType),
        ('Errors', _OPERATION_Errors),
        ('operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name='ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name='ParameterType', mode=MODE_TYPE)
    _ERROR_errorCode = CHOICE(name='errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        ('ParameterType', _ERROR_ParameterType),
        ('errorCode', _ERROR_errorCode),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name='Code', mode=MODE_TYPE)
    _Code_local = INT(name='local', mode=MODE_TYPE)
    _Code_global_ = OID(name='global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        ('local', _Code_local),
        ('global', _Code_global_),
        ])
    Code._ext = []
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name='InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name='present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name='absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        ('present', _InvokeId_present),
        ('absent', _InvokeId_absent),
        ])
    InvokeId._ext = []
    
    #-----< id-opcode-read >-----#
    id_opcode_read = CHOICE(name='id-opcode-read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_read._val = ('local', 1)
    
    #-----< id-opcode-compare >-----#
    id_opcode_compare = CHOICE(name='id-opcode-compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_compare._val = ('local', 2)
    
    #-----< id-opcode-abandon >-----#
    id_opcode_abandon = CHOICE(name='id-opcode-abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_abandon._val = ('local', 3)
    
    #-----< id-opcode-list >-----#
    id_opcode_list = CHOICE(name='id-opcode-list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_list._val = ('local', 4)
    
    #-----< id-opcode-search >-----#
    id_opcode_search = CHOICE(name='id-opcode-search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_search._val = ('local', 5)
    
    #-----< id-opcode-addEntry >-----#
    id_opcode_addEntry = CHOICE(name='id-opcode-addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_addEntry._val = ('local', 6)
    
    #-----< id-opcode-removeEntry >-----#
    id_opcode_removeEntry = CHOICE(name='id-opcode-removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_removeEntry._val = ('local', 7)
    
    #-----< id-opcode-modifyEntry >-----#
    id_opcode_modifyEntry = CHOICE(name='id-opcode-modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyEntry._val = ('local', 8)
    
    #-----< id-opcode-modifyDN >-----#
    id_opcode_modifyDN = CHOICE(name='id-opcode-modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyDN._val = ('local', 9)
    
    #-----< id-opcode-changePassword >-----#
    id_opcode_changePassword = CHOICE(name='id-opcode-changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_changePassword._val = ('local', 10)
    
    #-----< id-opcode-administerPassword >-----#
    id_opcode_administerPassword = CHOICE(name='id-opcode-administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_administerPassword._val = ('local', 11)
    
    #-----< id-opcode-ldapTransport >-----#
    id_opcode_ldapTransport = CHOICE(name='id-opcode-ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_ldapTransport._val = ('local', 12)
    
    #-----< id-opcode-linkedLDAP >-----#
    id_opcode_linkedLDAP = CHOICE(name='id-opcode-linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_linkedLDAP._val = ('local', 13)
    
    #-----< id-opcode-requestShadowUpdate >-----#
    id_opcode_requestShadowUpdate = CHOICE(name='id-opcode-requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_requestShadowUpdate._val = ('local', 1)
    
    #-----< id-opcode-updateShadow >-----#
    id_opcode_updateShadow = CHOICE(name='id-opcode-updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_updateShadow._val = ('local', 2)
    
    #-----< id-opcode-coordinateShadowUpdate >-----#
    id_opcode_coordinateShadowUpdate = CHOICE(name='id-opcode-coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_coordinateShadowUpdate._val = ('local', 3)
    
    #-----< id-op-establishOperationalBinding >-----#
    id_op_establishOperationalBinding = CHOICE(name='id-op-establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_establishOperationalBinding._val = ('local', 100)
    
    #-----< id-op-modifyOperationalBinding >-----#
    id_op_modifyOperationalBinding = CHOICE(name='id-op-modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_modifyOperationalBinding._val = ('local', 102)
    
    #-----< id-op-terminateOperationalBinding >-----#
    id_op_terminateOperationalBinding = CHOICE(name='id-op-terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_terminateOperationalBinding._val = ('local', 101)
    
    #-----< id-errcode-attributeError >-----#
    id_errcode_attributeError = CHOICE(name='id-errcode-attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_attributeError._val = ('local', 1)
    
    #-----< id-errcode-nameError >-----#
    id_errcode_nameError = CHOICE(name='id-errcode-nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_nameError._val = ('local', 2)
    
    #-----< id-errcode-serviceError >-----#
    id_errcode_serviceError = CHOICE(name='id-errcode-serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_serviceError._val = ('local', 3)
    
    #-----< id-errcode-referral >-----#
    id_errcode_referral = CHOICE(name='id-errcode-referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_referral._val = ('local', 4)
    
    #-----< id-errcode-abandoned >-----#
    id_errcode_abandoned = CHOICE(name='id-errcode-abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandoned._val = ('local', 5)
    
    #-----< id-errcode-securityError >-----#
    id_errcode_securityError = CHOICE(name='id-errcode-securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_securityError._val = ('local', 6)
    
    #-----< id-errcode-abandonFailed >-----#
    id_errcode_abandonFailed = CHOICE(name='id-errcode-abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandonFailed._val = ('local', 7)
    
    #-----< id-errcode-updateError >-----#
    id_errcode_updateError = CHOICE(name='id-errcode-updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_updateError._val = ('local', 8)
    
    #-----< id-errcode-dsaReferral >-----#
    id_errcode_dsaReferral = CHOICE(name='id-errcode-dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_dsaReferral._val = ('local', 9)
    
    #-----< id-errcode-shadowError >-----#
    id_errcode_shadowError = CHOICE(name='id-errcode-shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_shadowError._val = ('local', 1)
    
    #-----< id-err-operationalBindingError >-----#
    id_err_operationalBindingError = CHOICE(name='id-err-operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_err_operationalBindingError._val = ('local', 100)
    
    #-----< DOP-Invokable >-----#
    DOP_Invokable = CLASS(name='DOP-Invokable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Invokable_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    _DOP_Invokable_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Invokable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Invokable._val = ASN1Set(rv=[dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_0), ('ResultType', _DOP_Invokable_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_1), ('ResultType', _DOP_Invokable_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', _DOP_Invokable_val_ArgumentType_2), ('ResultType', _DOP_Invokable_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    
    #-----< DOP-Returnable >-----#
    DOP_Returnable = CLASS(name='DOP-Returnable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Returnable_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Returnable._val = ASN1Set(rv=[dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_0), ('ResultType', _DOP_Returnable_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_1), ('ResultType', _DOP_Returnable_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', _DOP_Returnable_val_ArgumentType_2), ('ResultType', _DOP_Returnable_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_ResultType,
        _OPERATION_Errors,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_errorCode,
        ERROR,
        _Code_local,
        _Code_global_,
        Code,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        id_opcode_read,
        id_opcode_compare,
        id_opcode_abandon,
        id_opcode_list,
        id_opcode_search,
        id_opcode_addEntry,
        id_opcode_removeEntry,
        id_opcode_modifyEntry,
        id_opcode_modifyDN,
        id_opcode_changePassword,
        id_opcode_administerPassword,
        id_opcode_ldapTransport,
        id_opcode_linkedLDAP,
        id_opcode_requestShadowUpdate,
        id_opcode_updateShadow,
        id_opcode_coordinateShadowUpdate,
        id_op_establishOperationalBinding,
        id_op_modifyOperationalBinding,
        id_op_terminateOperationalBinding,
        id_errcode_attributeError,
        id_errcode_nameError,
        id_errcode_serviceError,
        id_errcode_referral,
        id_errcode_abandoned,
        id_errcode_securityError,
        id_errcode_abandonFailed,
        id_errcode_updateError,
        id_errcode_dsaReferral,
        id_errcode_shadowError,
        id_err_operationalBindingError,
        DOP_Invokable,
        _DOP_Invokable_val_ArgumentType_0,
        _DOP_Invokable_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _DOP_Invokable_val_ArgumentType_1,
        _DOP_Invokable_val_ResultType_1,
        _DOP_Invokable_val_ArgumentType_2,
        _DOP_Invokable_val_ResultType_2,
        DOP_Returnable,
        _DOP_Returnable_val_ArgumentType_0,
        _DOP_Returnable_val_ResultType_0,
        _DOP_Returnable_val_ArgumentType_1,
        _DOP_Returnable_val_ResultType_1,
        _DOP_Returnable_val_ArgumentType_2,
        _DOP_Returnable_val_ResultType_2,
    ]

class DirectoryAbstractService:

    _name_  = 'DirectoryAbstractService'
    _oid_   = [2, 5, 1, 2, 7]
    
    _obj_ = [
        'CommonArguments',
        'CommonArgumentsSeq',
        'FamilyGrouping',
        'CommonResults',
        'CommonResultsSeq',
        'ServiceControls',
        'ServiceControlOptions',
        'EntryInformationSelection',
        'ContextSelection',
        'TypeAndContextAssertion',
        'FamilyReturn',
        'EntryInformation',
        'family-information',
        'FamilyEntries',
        'FamilyEntry',
        'Filter',
        'FilterItem',
        'MatchingRuleAssertion',
        'PagedResultsRequest',
        'SortKey',
        'SecurityParameters',
        'ProtectionRequest',
        'Time',
        'ErrorProtectionRequest',
        'directoryBind',
        'DirectoryBindArgument',
        'Credentials',
        'SimpleCredentials',
        'StrongCredentials',
        'SpkmCredentials',
        'SaslCredentials',
        'ub-saslMechanism',
        'Token',
        'TokenContent',
        'Versions',
        'DirectoryBindResult',
        'PwdResponseValue',
        'directoryBindError',
        'BindKeyInfo',
        'read',
        'ReadArgument',
        'ReadArgumentData',
        'ReadResult',
        'ReadResultData',
        'ModifyRights',
        'compare',
        'CompareArgument',
        'CompareArgumentData',
        'CompareResult',
        'CompareResultData',
        'abandon',
        'AbandonArgument',
        'AbandonArgumentData',
        'AbandonResult',
        'AbandonResultData',
        'list',
        'ListArgument',
        'ListArgumentData',
        'ListResult',
        'ListResultData',
        'PartialOutcomeQualifier',
        'LimitProblem',
        'search',
        'SearchArgument',
        'SearchArgumentData',
        'HierarchySelections',
        'SearchControlOptions',
        'JoinArgument',
        'DomainLocalID',
        'JoinAttPair',
        'JoinContextType',
        'SearchResult',
        'SearchResultData',
        'addEntry',
        'AddEntryArgument',
        'AddEntryArgumentData',
        'AddEntryResult',
        'AddEntryResultData',
        'removeEntry',
        'RemoveEntryArgument',
        'RemoveEntryArgumentData',
        'RemoveEntryResult',
        'RemoveEntryResultData',
        'modifyEntry',
        'ModifyEntryArgument',
        'ModifyEntryArgumentData',
        'ModifyEntryResult',
        'ModifyEntryResultData',
        'EntryModification',
        'modifyDN',
        'ModifyDNArgument',
        'ModifyDNArgumentData',
        'ModifyDNResult',
        'ModifyDNResultData',
        'changePassword',
        'ChangePasswordArgument',
        'ChangePasswordArgumentData',
        'ChangePasswordResult',
        'ChangePasswordResultData',
        'administerPassword',
        'AdministerPasswordArgument',
        'AdministerPasswordArgumentData',
        'AdministerPasswordResult',
        'AdministerPasswordResultData',
        'ldapTransport',
        'LdapArgument',
        'LdapArgumentData',
        'LinkId',
        'LdapResult',
        'LdapResultData',
        'linkedLDAP',
        'LinkedArgument',
        'LinkedArgumentData',
        'LinkedResult',
        'abandoned',
        'AbandonedData',
        'AbandonedProblem',
        'abandonFailed',
        'AbandonFailedData',
        'AbandonProblem',
        'attributeError',
        'AttributeErrorData',
        'AttributeProblem',
        'nameError',
        'NameErrorData',
        'NameProblem',
        'referral',
        'ReferralData',
        'securityError',
        'SecurityErrorData',
        'SecurityProblem',
        'EncPwdInfo',
        'serviceError',
        'ServiceErrorData',
        'ServiceProblem',
        'updateError',
        'UpdateErrorData',
        'UpdateProblem',
        'id-at-family-information',
        ]
    _type_ = [
        'CommonArguments',
        'CommonArgumentsSeq',
        'FamilyGrouping',
        'CommonResults',
        'CommonResultsSeq',
        'ServiceControls',
        'ServiceControlOptions',
        'EntryInformationSelection',
        'ContextSelection',
        'TypeAndContextAssertion',
        'FamilyReturn',
        'EntryInformation',
        'FamilyEntries',
        'FamilyEntry',
        'Filter',
        'FilterItem',
        'MatchingRuleAssertion',
        'PagedResultsRequest',
        'SortKey',
        'SecurityParameters',
        'ProtectionRequest',
        'Time',
        'ErrorProtectionRequest',
        'DirectoryBindArgument',
        'Credentials',
        'SimpleCredentials',
        'StrongCredentials',
        'SpkmCredentials',
        'SaslCredentials',
        'Token',
        'TokenContent',
        'Versions',
        'DirectoryBindResult',
        'PwdResponseValue',
        'BindKeyInfo',
        'ReadArgument',
        'ReadArgumentData',
        'ReadResult',
        'ReadResultData',
        'ModifyRights',
        'CompareArgument',
        'CompareArgumentData',
        'CompareResult',
        'CompareResultData',
        'AbandonArgument',
        'AbandonArgumentData',
        'AbandonResult',
        'AbandonResultData',
        'ListArgument',
        'ListArgumentData',
        'ListResult',
        'ListResultData',
        'PartialOutcomeQualifier',
        'LimitProblem',
        'SearchArgument',
        'SearchArgumentData',
        'HierarchySelections',
        'SearchControlOptions',
        'JoinArgument',
        'DomainLocalID',
        'JoinAttPair',
        'JoinContextType',
        'SearchResult',
        'SearchResultData',
        'AddEntryArgument',
        'AddEntryArgumentData',
        'AddEntryResult',
        'AddEntryResultData',
        'RemoveEntryArgument',
        'RemoveEntryArgumentData',
        'RemoveEntryResult',
        'RemoveEntryResultData',
        'ModifyEntryArgument',
        'ModifyEntryArgumentData',
        'ModifyEntryResult',
        'ModifyEntryResultData',
        'EntryModification',
        'ModifyDNArgument',
        'ModifyDNArgumentData',
        'ModifyDNResult',
        'ModifyDNResultData',
        'ChangePasswordArgument',
        'ChangePasswordArgumentData',
        'ChangePasswordResult',
        'ChangePasswordResultData',
        'AdministerPasswordArgument',
        'AdministerPasswordArgumentData',
        'AdministerPasswordResult',
        'AdministerPasswordResultData',
        'LdapArgument',
        'LdapArgumentData',
        'LinkId',
        'LdapResult',
        'LdapResultData',
        'LinkedArgument',
        'LinkedArgumentData',
        'LinkedResult',
        'AbandonedData',
        'AbandonedProblem',
        'AbandonFailedData',
        'AbandonProblem',
        'AttributeErrorData',
        'AttributeProblem',
        'NameErrorData',
        'NameProblem',
        'ReferralData',
        'SecurityErrorData',
        'SecurityProblem',
        'EncPwdInfo',
        'ServiceErrorData',
        'ServiceProblem',
        'UpdateErrorData',
        'UpdateProblem',
        ]
    _set_ = [
        ]
    _val_ = [
        'family-information',
        'directoryBind',
        'ub-saslMechanism',
        'directoryBindError',
        'read',
        'compare',
        'abandon',
        'list',
        'search',
        'addEntry',
        'removeEntry',
        'modifyEntry',
        'modifyDN',
        'changePassword',
        'administerPassword',
        'ldapTransport',
        'linkedLDAP',
        'abandoned',
        'abandonFailed',
        'attributeError',
        'nameError',
        'referral',
        'securityError',
        'serviceError',
        'updateError',
        'id-at-family-information',
        ]
    _class_ = [
        'family-information',
        'directoryBind',
        'directoryBindError',
        'read',
        'compare',
        'abandon',
        'list',
        'search',
        'addEntry',
        'removeEntry',
        'modifyEntry',
        'modifyDN',
        'changePassword',
        'administerPassword',
        'ldapTransport',
        'linkedLDAP',
        'abandoned',
        'abandonFailed',
        'attributeError',
        'nameError',
        'referral',
        'securityError',
        'serviceError',
        'updateError',
        ]
    _param_ = [
        ]
    
    #-----< CommonArguments >-----#
    CommonArguments = SET(name='CommonArguments', mode=MODE_TYPE)
    _CommonArguments_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArguments_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArguments_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArguments_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CommonArguments_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArguments_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArguments_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArguments_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArguments_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArguments_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CommonArguments._cont = ASN1Dict([
        ('serviceControls', _CommonArguments_serviceControls),
        ('securityParameters', _CommonArguments_securityParameters),
        ('requestor', _CommonArguments_requestor),
        ('operationProgress', _CommonArguments_operationProgress),
        ('aliasedRDNs', _CommonArguments_aliasedRDNs),
        ('criticalExtensions', _CommonArguments_criticalExtensions),
        ('referenceType', _CommonArguments_referenceType),
        ('entryOnly', _CommonArguments_entryOnly),
        ('exclusions', _CommonArguments_exclusions),
        ('nameResolveOnMaster', _CommonArguments_nameResolveOnMaster),
        ('operationContexts', _CommonArguments_operationContexts),
        ('familyGrouping', _CommonArguments_familyGrouping),
        ])
    CommonArguments._ext = []
    
    #-----< CommonArgumentsSeq >-----#
    CommonArgumentsSeq = SEQ(name='CommonArgumentsSeq', mode=MODE_TYPE)
    _CommonArgumentsSeq_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArgumentsSeq_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArgumentsSeq_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArgumentsSeq_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CommonArgumentsSeq_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArgumentsSeq_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArgumentsSeq_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArgumentsSeq_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArgumentsSeq_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArgumentsSeq_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CommonArgumentsSeq._cont = ASN1Dict([
        ('serviceControls', _CommonArgumentsSeq_serviceControls),
        ('securityParameters', _CommonArgumentsSeq_securityParameters),
        ('requestor', _CommonArgumentsSeq_requestor),
        ('operationProgress', _CommonArgumentsSeq_operationProgress),
        ('aliasedRDNs', _CommonArgumentsSeq_aliasedRDNs),
        ('criticalExtensions', _CommonArgumentsSeq_criticalExtensions),
        ('referenceType', _CommonArgumentsSeq_referenceType),
        ('entryOnly', _CommonArgumentsSeq_entryOnly),
        ('exclusions', _CommonArgumentsSeq_exclusions),
        ('nameResolveOnMaster', _CommonArgumentsSeq_nameResolveOnMaster),
        ('operationContexts', _CommonArgumentsSeq_operationContexts),
        ('familyGrouping', _CommonArgumentsSeq_familyGrouping),
        ])
    CommonArgumentsSeq._ext = []
    
    #-----< FamilyGrouping >-----#
    FamilyGrouping = ENUM(name='FamilyGrouping', mode=MODE_TYPE)
    FamilyGrouping._cont = ASN1Dict([('entryOnly', 1), ('compoundEntry', 2), ('strands', 3), ('multiStrand', 4)])
    FamilyGrouping._ext = []
    
    #-----< CommonResults >-----#
    CommonResults = SET(name='CommonResults', mode=MODE_TYPE)
    _CommonResults_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResults_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResults_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResults_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResults_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResults_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CommonResults_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResults_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____CommonResults_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResults_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CommonResults_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CommonResults_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResults_notification__item__type._const_tab = ____CommonResults_notification__item__type_tab
    ___CommonResults_notification__item__type._const_tab_at = None
    ___CommonResults_notification__item__type._const_tab_id = 'id'
    ___CommonResults_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CommonResults_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CommonResults_notification__item__values__item_._const_tab = ____CommonResults_notification__item__type_tab
    ____CommonResults_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CommonResults_notification__item__values__item_._const_tab_id = 'Type'
    ___CommonResults_notification__item__values._cont = ____CommonResults_notification__item__values__item_
    ___CommonResults_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResults_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResults_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResults_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab = ____CommonResults_notification__item__type_tab
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CommonResults_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CommonResults_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResults_notification__item__valuesWithContext__item__contextList._cont = ______CommonResults_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResults_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResults_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CommonResults_notification__item__valuesWithContext__item__value),
        ('contextList', _____CommonResults_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResults_notification__item__valuesWithContext__item_._ext = []
    ___CommonResults_notification__item__valuesWithContext._cont = ____CommonResults_notification__item__valuesWithContext__item_
    ___CommonResults_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResults_notification__item_._cont = ASN1Dict([
        ('type', ___CommonResults_notification__item__type),
        ('values', ___CommonResults_notification__item__values),
        ('valuesWithContext', ___CommonResults_notification__item__valuesWithContext),
        ])
    __CommonResults_notification__item_._ext = []
    _CommonResults_notification._cont = __CommonResults_notification__item_
    _CommonResults_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResults._cont = ASN1Dict([
        ('securityParameters', _CommonResults_securityParameters),
        ('performer', _CommonResults_performer),
        ('aliasDereferenced', _CommonResults_aliasDereferenced),
        ('notification', _CommonResults_notification),
        ])
    CommonResults._ext = []
    
    #-----< CommonResultsSeq >-----#
    CommonResultsSeq = SEQ(name='CommonResultsSeq', mode=MODE_TYPE)
    _CommonResultsSeq_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResultsSeq_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResultsSeq_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResultsSeq_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResultsSeq_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResultsSeq_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CommonResultsSeq_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResultsSeq_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResultsSeq_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResultsSeq_notification__item__type._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ___CommonResultsSeq_notification__item__type._const_tab_at = None
    ___CommonResultsSeq_notification__item__type._const_tab_id = 'id'
    ___CommonResultsSeq_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CommonResultsSeq_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CommonResultsSeq_notification__item__values__item_._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ____CommonResultsSeq_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CommonResultsSeq_notification__item__values__item_._const_tab_id = 'Type'
    ___CommonResultsSeq_notification__item__values._cont = ____CommonResultsSeq_notification__item__values__item_
    ___CommonResultsSeq_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResultsSeq_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResultsSeq_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab = ____CommonResultsSeq_notification__item__type_tab
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._cont = ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CommonResultsSeq_notification__item__valuesWithContext__item__value),
        ('contextList', _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._ext = []
    ___CommonResultsSeq_notification__item__valuesWithContext._cont = ____CommonResultsSeq_notification__item__valuesWithContext__item_
    ___CommonResultsSeq_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResultsSeq_notification__item_._cont = ASN1Dict([
        ('type', ___CommonResultsSeq_notification__item__type),
        ('values', ___CommonResultsSeq_notification__item__values),
        ('valuesWithContext', ___CommonResultsSeq_notification__item__valuesWithContext),
        ])
    __CommonResultsSeq_notification__item_._ext = []
    _CommonResultsSeq_notification._cont = __CommonResultsSeq_notification__item_
    _CommonResultsSeq_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResultsSeq._cont = ASN1Dict([
        ('securityParameters', _CommonResultsSeq_securityParameters),
        ('performer', _CommonResultsSeq_performer),
        ('aliasDereferenced', _CommonResultsSeq_aliasDereferenced),
        ('notification', _CommonResultsSeq_notification),
        ])
    CommonResultsSeq._ext = []
    
    #-----< ServiceControls >-----#
    ServiceControls = SET(name='ServiceControls', mode=MODE_TYPE)
    _ServiceControls_options = BIT_STR(name='options', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ServiceControls_priority = INT(name='priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _ServiceControls_priority._cont = ASN1Dict([('low', 0), ('medium', 1), ('high', 2)])
    _ServiceControls_timeLimit = INT(name='timeLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_sizeLimit = INT(name='sizeLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral = INT(name='scopeOfReferral', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral._cont = ASN1Dict([('dmd', 0), ('country', 1)])
    _ServiceControls_attributeSizeLimit = INT(name='attributeSizeLimit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_manageDSAITPlaneRef = SEQ(name='manageDSAITPlaneRef', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceControls_manageDSAITPlaneRef_dsaName = CHOICE(name='dsaName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    __ServiceControls_manageDSAITPlaneRef_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _ServiceControls_manageDSAITPlaneRef._cont = ASN1Dict([
        ('dsaName', __ServiceControls_manageDSAITPlaneRef_dsaName),
        ('agreementID', __ServiceControls_manageDSAITPlaneRef_agreementID),
        ])
    _ServiceControls_manageDSAITPlaneRef._ext = []
    _ServiceControls_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ServiceControls._cont = ASN1Dict([
        ('options', _ServiceControls_options),
        ('priority', _ServiceControls_priority),
        ('timeLimit', _ServiceControls_timeLimit),
        ('sizeLimit', _ServiceControls_sizeLimit),
        ('scopeOfReferral', _ServiceControls_scopeOfReferral),
        ('attributeSizeLimit', _ServiceControls_attributeSizeLimit),
        ('manageDSAITPlaneRef', _ServiceControls_manageDSAITPlaneRef),
        ('serviceType', _ServiceControls_serviceType),
        ('userClass', _ServiceControls_userClass),
        ])
    ServiceControls._ext = []
    
    #-----< ServiceControlOptions >-----#
    ServiceControlOptions = BIT_STR(name='ServiceControlOptions', mode=MODE_TYPE)
    ServiceControlOptions._cont = ASN1Dict([('preferChaining', 0), ('chainingProhibited', 1), ('localScope', 2), ('dontUseCopy', 3), ('dontDereferenceAliases', 4), ('subentries', 5), ('copyShallDo', 6), ('partialNameResolution', 7), ('manageDSAIT', 8), ('noSubtypeMatch', 9), ('noSubtypeSelection', 10), ('countFamily', 11), ('dontSelectFriends', 12), ('dontMatchFriends', 13), ('allowWriteableCopy', 14)])
    
    #-----< EntryInformationSelection >-----#
    EntryInformationSelection = SET(name='EntryInformationSelection', mode=MODE_TYPE)
    _EntryInformationSelection_attributes = CHOICE(name='attributes', mode=MODE_TYPE, default=('allUserAttributes', 0))
    __EntryInformationSelection_attributes_allUserAttributes = NULL(name='allUserAttributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_attributes_select = SET_OF(name='select', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_attributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_attributes_select._cont = ___EntryInformationSelection_attributes_select__item_
    _EntryInformationSelection_attributes._cont = ASN1Dict([
        ('allUserAttributes', __EntryInformationSelection_attributes_allUserAttributes),
        ('select', __EntryInformationSelection_attributes_select),
        ])
    _EntryInformationSelection_attributes._ext = None
    _EntryInformationSelection_infoTypes = INT(name='infoTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EntryInformationSelection_infoTypes._cont = ASN1Dict([('attributeTypesOnly', 0), ('attributeTypesAndValues', 1)])
    _EntryInformationSelection_extraAttributes = CHOICE(name='extraAttributes', mode=MODE_TYPE, opt=True)
    __EntryInformationSelection_extraAttributes_allOperationalAttributes = NULL(name='allOperationalAttributes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_extraAttributes_select = SET_OF(name='select', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_extraAttributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_extraAttributes_select._cont = ___EntryInformationSelection_extraAttributes_select__item_
    __EntryInformationSelection_extraAttributes_select._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformationSelection_extraAttributes._cont = ASN1Dict([
        ('allOperationalAttributes', __EntryInformationSelection_extraAttributes_allOperationalAttributes),
        ('select', __EntryInformationSelection_extraAttributes_select),
        ])
    _EntryInformationSelection_extraAttributes._ext = None
    _EntryInformationSelection_contextSelection = CHOICE(name='contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _EntryInformationSelection_returnContexts = BOOL(name='returnContexts', mode=MODE_TYPE, default=False)
    _EntryInformationSelection_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), default=dict([('memberSelect', 'contributingEntriesOnly')]))
    EntryInformationSelection._cont = ASN1Dict([
        ('attributes', _EntryInformationSelection_attributes),
        ('infoTypes', _EntryInformationSelection_infoTypes),
        ('extraAttributes', _EntryInformationSelection_extraAttributes),
        ('contextSelection', _EntryInformationSelection_contextSelection),
        ('returnContexts', _EntryInformationSelection_returnContexts),
        ('familyReturn', _EntryInformationSelection_familyReturn),
        ])
    EntryInformationSelection._ext = None
    
    #-----< ContextSelection >-----#
    ContextSelection = CHOICE(name='ContextSelection', mode=MODE_TYPE)
    _ContextSelection_allContexts = NULL(name='allContexts', mode=MODE_TYPE)
    _ContextSelection_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE)
    __ContextSelection_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    _ContextSelection_selectedContexts._cont = __ContextSelection_selectedContexts__item_
    _ContextSelection_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextSelection._cont = ASN1Dict([
        ('allContexts', _ContextSelection_allContexts),
        ('selectedContexts', _ContextSelection_selectedContexts),
        ])
    ContextSelection._ext = []
    
    #-----< TypeAndContextAssertion >-----#
    TypeAndContextAssertion = SEQ(name='TypeAndContextAssertion', mode=MODE_TYPE)
    _TypeAndContextAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _TypeAndContextAssertion_contextAssertions = CHOICE(name='contextAssertions', mode=MODE_TYPE)
    __TypeAndContextAssertion_contextAssertions_preference = SEQ_OF(name='preference', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_preference__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_preference._cont = ___TypeAndContextAssertion_contextAssertions_preference__item_
    __TypeAndContextAssertion_contextAssertions_all = SET_OF(name='all', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_all__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_all._cont = ___TypeAndContextAssertion_contextAssertions_all__item_
    _TypeAndContextAssertion_contextAssertions._cont = ASN1Dict([
        ('preference', __TypeAndContextAssertion_contextAssertions_preference),
        ('all', __TypeAndContextAssertion_contextAssertions_all),
        ])
    _TypeAndContextAssertion_contextAssertions._ext = []
    TypeAndContextAssertion._cont = ASN1Dict([
        ('type', _TypeAndContextAssertion_type),
        ('contextAssertions', _TypeAndContextAssertion_contextAssertions),
        ])
    TypeAndContextAssertion._ext = []
    
    #-----< FamilyReturn >-----#
    FamilyReturn = SEQ(name='FamilyReturn', mode=MODE_TYPE)
    _FamilyReturn_memberSelect = ENUM(name='memberSelect', mode=MODE_TYPE)
    _FamilyReturn_memberSelect._cont = ASN1Dict([('contributingEntriesOnly', 1), ('participatingEntriesOnly', 2), ('compoundEntry', 3)])
    _FamilyReturn_memberSelect._ext = []
    _FamilyReturn_familySelect = SEQ_OF(name='familySelect', mode=MODE_TYPE, opt=True)
    __FamilyReturn_familySelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _FamilyReturn_familySelect._cont = __FamilyReturn_familySelect__item_
    _FamilyReturn_familySelect._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyReturn._cont = ASN1Dict([
        ('memberSelect', _FamilyReturn_memberSelect),
        ('familySelect', _FamilyReturn_familySelect),
        ])
    FamilyReturn._ext = []
    
    #-----< EntryInformation >-----#
    EntryInformation = SEQ(name='EntryInformation', mode=MODE_TYPE)
    _EntryInformation_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _EntryInformation_fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, default=True)
    _EntryInformation_information = SET_OF(name='information', mode=MODE_TYPE, opt=True)
    __EntryInformation_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___EntryInformation_information__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___EntryInformation_information__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____EntryInformation_information__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____EntryInformation_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______EntryInformation_information__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____EntryInformation_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____EntryInformation_information__item__attribute_type._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ____EntryInformation_information__item__attribute_type._const_tab_at = None
    ____EntryInformation_information__item__attribute_type._const_tab_id = 'id'
    ____EntryInformation_information__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____EntryInformation_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____EntryInformation_information__item__attribute_values__item_._const_tab = _____EntryInformation_information__item__attribute_type_tab
    _____EntryInformation_information__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____EntryInformation_information__item__attribute_values__item_._const_tab_id = 'Type'
    ____EntryInformation_information__item__attribute_values._cont = _____EntryInformation_information__item__attribute_values__item_
    ____EntryInformation_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____EntryInformation_information__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____EntryInformation_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._cont = _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______EntryInformation_information__item__attribute_valuesWithContext__item__value),
        ('contextList', ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._ext = []
    ____EntryInformation_information__item__attribute_valuesWithContext._cont = _____EntryInformation_information__item__attribute_valuesWithContext__item_
    ____EntryInformation_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryInformation_information__item__attribute._cont = ASN1Dict([
        ('type', ____EntryInformation_information__item__attribute_type),
        ('values', ____EntryInformation_information__item__attribute_values),
        ('valuesWithContext', ____EntryInformation_information__item__attribute_valuesWithContext),
        ])
    ___EntryInformation_information__item__attribute._ext = []
    __EntryInformation_information__item_._cont = ASN1Dict([
        ('attributeType', ___EntryInformation_information__item__attributeType),
        ('attribute', ___EntryInformation_information__item__attribute),
        ])
    __EntryInformation_information__item_._ext = []
    _EntryInformation_information._cont = __EntryInformation_information__item_
    _EntryInformation_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformation_incompleteEntry = BOOL(name='incompleteEntry', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_partialName = BOOL(name='partialName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_derivedEntry = BOOL(name='derivedEntry', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    EntryInformation._cont = ASN1Dict([
        ('name', _EntryInformation_name),
        ('fromEntry', _EntryInformation_fromEntry),
        ('information', _EntryInformation_information),
        ('incompleteEntry', _EntryInformation_incompleteEntry),
        ('partialName', _EntryInformation_partialName),
        ('derivedEntry', _EntryInformation_derivedEntry),
        ])
    EntryInformation._ext = []
    
    #-----< family-information >-----#
    family_information = CLASS(name='family-information', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _family_information_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    family_information._val = dict([('Type', _family_information_val_Type), ('usage', 'directoryOperation'), ('id', (2, 5, 4, 64))])
    
    #-----< FamilyEntries >-----#
    FamilyEntries = SEQ(name='FamilyEntries', mode=MODE_TYPE)
    _FamilyEntries_family_class = OID(name='family-class', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _FamilyEntries_familyEntries = SEQ_OF(name='familyEntries', mode=MODE_TYPE)
    __FamilyEntries_familyEntries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntry')))
    _FamilyEntries_familyEntries._cont = __FamilyEntries_familyEntries__item_
    FamilyEntries._cont = ASN1Dict([
        ('family-class', _FamilyEntries_family_class),
        ('familyEntries', _FamilyEntries_familyEntries),
        ])
    FamilyEntries._ext = []
    
    #-----< FamilyEntry >-----#
    FamilyEntry = SEQ(name='FamilyEntry', mode=MODE_TYPE)
    _FamilyEntry_rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _FamilyEntry_information = SEQ_OF(name='information', mode=MODE_TYPE)
    __FamilyEntry_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___FamilyEntry_information__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___FamilyEntry_information__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____FamilyEntry_information__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____FamilyEntry_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____FamilyEntry_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_type._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ____FamilyEntry_information__item__attribute_type._const_tab_at = None
    ____FamilyEntry_information__item__attribute_type._const_tab_id = 'id'
    ____FamilyEntry_information__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____FamilyEntry_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____FamilyEntry_information__item__attribute_values__item_._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_id = 'Type'
    ____FamilyEntry_information__item__attribute_values._cont = _____FamilyEntry_information__item__attribute_values__item_
    ____FamilyEntry_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._cont = _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______FamilyEntry_information__item__attribute_valuesWithContext__item__value),
        ('contextList', ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._ext = []
    ____FamilyEntry_information__item__attribute_valuesWithContext._cont = _____FamilyEntry_information__item__attribute_valuesWithContext__item_
    ____FamilyEntry_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___FamilyEntry_information__item__attribute._cont = ASN1Dict([
        ('type', ____FamilyEntry_information__item__attribute_type),
        ('values', ____FamilyEntry_information__item__attribute_values),
        ('valuesWithContext', ____FamilyEntry_information__item__attribute_valuesWithContext),
        ])
    ___FamilyEntry_information__item__attribute._ext = []
    __FamilyEntry_information__item_._cont = ASN1Dict([
        ('attributeType', ___FamilyEntry_information__item__attributeType),
        ('attribute', ___FamilyEntry_information__item__attribute),
        ])
    __FamilyEntry_information__item_._ext = []
    _FamilyEntry_information._cont = __FamilyEntry_information__item_
    _FamilyEntry_family_info = SEQ_OF(name='family-info', mode=MODE_TYPE, opt=True)
    __FamilyEntry_family_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    _FamilyEntry_family_info._cont = __FamilyEntry_family_info__item_
    _FamilyEntry_family_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyEntry._cont = ASN1Dict([
        ('rdn', _FamilyEntry_rdn),
        ('information', _FamilyEntry_information),
        ('family-info', _FamilyEntry_family_info),
        ])
    FamilyEntry._ext = []
    
    #-----< Filter >-----#
    Filter = CHOICE(name='Filter', mode=MODE_TYPE)
    _Filter_item = CHOICE(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    _Filter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_and_._cont = __Filter_and___item_
    _Filter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_or_._cont = __Filter_or___item_
    _Filter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    Filter._cont = ASN1Dict([
        ('item', _Filter_item),
        ('and', _Filter_and_),
        ('or', _Filter_or_),
        ('not', _Filter_not_),
        ])
    Filter._ext = []
    
    #-----< FilterItem >-----#
    FilterItem = CHOICE(name='FilterItem', mode=MODE_TYPE)
    _FilterItem_equality = SEQ(name='equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_substrings = SEQ(name='substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FilterItem_substrings_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___FilterItem_substrings_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____FilterItem_substrings_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ____FilterItem_substrings_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___FilterItem_substrings_type_tab._val = ASN1Set(rv=[dict([('Type', ____FilterItem_substrings_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____FilterItem_substrings_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __FilterItem_substrings_type._const_tab = ___FilterItem_substrings_type_tab
    __FilterItem_substrings_type._const_tab_at = None
    __FilterItem_substrings_type._const_tab_id = 'id'
    __FilterItem_substrings_strings = SEQ_OF(name='strings', mode=MODE_TYPE)
    ___FilterItem_substrings_strings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____FilterItem_substrings_strings__item__initial = OPEN(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__initial._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__initial._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__initial._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__any = OPEN(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__any._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__any._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__any._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__final = OPEN(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____FilterItem_substrings_strings__item__final._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__final._const_tab_at = ('..', '..', '..', '..', 'substrings', 'type')
    ____FilterItem_substrings_strings__item__final._const_tab_id = 'Type'
    ____FilterItem_substrings_strings__item__control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____FilterItem_substrings_strings__item__control_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____FilterItem_substrings_strings__item__control_type._const_tab = ___FilterItem_substrings_type_tab
    _____FilterItem_substrings_strings__item__control_type._const_tab_at = None
    _____FilterItem_substrings_strings__item__control_type._const_tab_id = 'id'
    _____FilterItem_substrings_strings__item__control_values = SET_OF(name='values', mode=MODE_TYPE)
    ______FilterItem_substrings_strings__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab = ___FilterItem_substrings_type_tab
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_at = ('..', '..', 'type')
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_id = 'Type'
    _____FilterItem_substrings_strings__item__control_values._cont = ______FilterItem_substrings_strings__item__control_values__item_
    _____FilterItem_substrings_strings__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____FilterItem_substrings_strings__item__control_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab = ___FilterItem_substrings_type_tab
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_id = 'Type'
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._cont = ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value),
        ('contextList', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList),
        ])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._ext = []
    _____FilterItem_substrings_strings__item__control_valuesWithContext._cont = ______FilterItem_substrings_strings__item__control_valuesWithContext__item_
    _____FilterItem_substrings_strings__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____FilterItem_substrings_strings__item__control._cont = ASN1Dict([
        ('type', _____FilterItem_substrings_strings__item__control_type),
        ('values', _____FilterItem_substrings_strings__item__control_values),
        ('valuesWithContext', _____FilterItem_substrings_strings__item__control_valuesWithContext),
        ])
    ____FilterItem_substrings_strings__item__control._ext = []
    ___FilterItem_substrings_strings__item_._cont = ASN1Dict([
        ('initial', ____FilterItem_substrings_strings__item__initial),
        ('any', ____FilterItem_substrings_strings__item__any),
        ('final', ____FilterItem_substrings_strings__item__final),
        ('control', ____FilterItem_substrings_strings__item__control),
        ])
    ___FilterItem_substrings_strings__item_._ext = []
    __FilterItem_substrings_strings._cont = ___FilterItem_substrings_strings__item_
    _FilterItem_substrings._cont = ASN1Dict([
        ('type', __FilterItem_substrings_type),
        ('strings', __FilterItem_substrings_strings),
        ])
    _FilterItem_substrings._ext = []
    _FilterItem_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_present = OID(name='present', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _FilterItem_approximateMatch = SEQ(name='approximateMatch', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_extensibleMatch = SEQ(name='extensibleMatch', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'MatchingRuleAssertion')))
    _FilterItem_contextPresent = SEQ(name='contextPresent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAssertion')))
    FilterItem._cont = ASN1Dict([
        ('equality', _FilterItem_equality),
        ('substrings', _FilterItem_substrings),
        ('greaterOrEqual', _FilterItem_greaterOrEqual),
        ('lessOrEqual', _FilterItem_lessOrEqual),
        ('present', _FilterItem_present),
        ('approximateMatch', _FilterItem_approximateMatch),
        ('extensibleMatch', _FilterItem_extensibleMatch),
        ('contextPresent', _FilterItem_contextPresent),
        ])
    FilterItem._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name='MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = SET_OF(name='matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleAssertion_matchingRule__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleAssertion_matchingRule._cont = __MatchingRuleAssertion_matchingRule__item_
    _MatchingRuleAssertion_matchingRule._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleAssertion_type = OID(name='type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _MatchingRuleAssertion_matchValue = OPEN(name='matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['AssertionType']))
    _MatchingRuleAssertion_dnAttributes = BOOL(name='dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        ('matchingRule', _MatchingRuleAssertion_matchingRule),
        ('type', _MatchingRuleAssertion_type),
        ('matchValue', _MatchingRuleAssertion_matchValue),
        ('dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< PagedResultsRequest >-----#
    PagedResultsRequest = CHOICE(name='PagedResultsRequest', mode=MODE_TYPE)
    _PagedResultsRequest_newRequest = SEQ(name='newRequest', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_pageSize = INT(name='pageSize', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_sortKeys = SEQ_OF(name='sortKeys', mode=MODE_TYPE, opt=True)
    ___PagedResultsRequest_newRequest_sortKeys__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SortKey')))
    __PagedResultsRequest_newRequest_sortKeys._cont = ___PagedResultsRequest_newRequest_sortKeys__item_
    __PagedResultsRequest_newRequest_sortKeys._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PagedResultsRequest_newRequest_reverse = BOOL(name='reverse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_unmerged = BOOL(name='unmerged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_pageNumber = INT(name='pageNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PagedResultsRequest_newRequest._cont = ASN1Dict([
        ('pageSize', __PagedResultsRequest_newRequest_pageSize),
        ('sortKeys', __PagedResultsRequest_newRequest_sortKeys),
        ('reverse', __PagedResultsRequest_newRequest_reverse),
        ('unmerged', __PagedResultsRequest_newRequest_unmerged),
        ('pageNumber', __PagedResultsRequest_newRequest_pageNumber),
        ])
    _PagedResultsRequest_newRequest._ext = []
    _PagedResultsRequest_queryReference = OCT_STR(name='queryReference', mode=MODE_TYPE)
    _PagedResultsRequest_abandonQuery = OCT_STR(name='abandonQuery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    PagedResultsRequest._cont = ASN1Dict([
        ('newRequest', _PagedResultsRequest_newRequest),
        ('queryReference', _PagedResultsRequest_queryReference),
        ('abandonQuery', _PagedResultsRequest_abandonQuery),
        ])
    PagedResultsRequest._ext = []
    
    #-----< SortKey >-----#
    SortKey = SEQ(name='SortKey', mode=MODE_TYPE)
    _SortKey_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SortKey_orderingRule = OID(name='orderingRule', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    SortKey._cont = ASN1Dict([
        ('type', _SortKey_type),
        ('orderingRule', _SortKey_orderingRule),
        ])
    SortKey._ext = []
    
    #-----< SecurityParameters >-----#
    SecurityParameters = SET(name='SecurityParameters', mode=MODE_TYPE)
    _SecurityParameters_certification_path = SEQ(name='certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _SecurityParameters_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityParameters_time = CHOICE(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')), opt=True)
    _SecurityParameters_random = BIT_STR(name='random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SecurityParameters_target = INT(name='target', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ProtectionRequest')), opt=True)
    _SecurityParameters_operationCode = CHOICE(name='operationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    _SecurityParameters_errorProtection = INT(name='errorProtection', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ErrorProtectionRequest')), opt=True)
    _SecurityParameters_errorCode = CHOICE(name='errorCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    SecurityParameters._cont = ASN1Dict([
        ('certification-path', _SecurityParameters_certification_path),
        ('name', _SecurityParameters_name),
        ('time', _SecurityParameters_time),
        ('random', _SecurityParameters_random),
        ('target', _SecurityParameters_target),
        ('operationCode', _SecurityParameters_operationCode),
        ('errorProtection', _SecurityParameters_errorProtection),
        ('errorCode', _SecurityParameters_errorCode),
        ])
    SecurityParameters._ext = []
    
    #-----< ProtectionRequest >-----#
    ProtectionRequest = INT(name='ProtectionRequest', mode=MODE_TYPE)
    ProtectionRequest._cont = ASN1Dict([('none', 0), ('signed', 1)])
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< ErrorProtectionRequest >-----#
    ErrorProtectionRequest = INT(name='ErrorProtectionRequest', mode=MODE_TYPE)
    ErrorProtectionRequest._cont = ASN1Dict([('none', 0), ('signed', 1)])
    
    #-----< directoryBind >-----#
    directoryBind = CLASS(name='directoryBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _directoryBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    _directoryBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    directoryBind._val = dict([('ArgumentType', _directoryBind_val_ArgumentType), ('ResultType', _directoryBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DirectoryBindArgument >-----#
    DirectoryBindArgument = SET(name='DirectoryBindArgument', mode=MODE_TYPE)
    _DirectoryBindArgument_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindArgument_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DirectoryBindArgument._cont = ASN1Dict([
        ('credentials', _DirectoryBindArgument_credentials),
        ('versions', _DirectoryBindArgument_versions),
        ])
    DirectoryBindArgument._ext = []
    
    #-----< Credentials >-----#
    Credentials = CHOICE(name='Credentials', mode=MODE_TYPE)
    _Credentials_simple = SEQ(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _Credentials_strong = SET(name='strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _Credentials_externalProcedure = EXT(name='externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _Credentials_spkm = CHOICE(name='spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    _Credentials_sasl = SEQ(name='sasl', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SaslCredentials')))
    Credentials._cont = ASN1Dict([
        ('simple', _Credentials_simple),
        ('strong', _Credentials_strong),
        ('externalProcedure', _Credentials_externalProcedure),
        ('spkm', _Credentials_spkm),
        ('sasl', _Credentials_sasl),
        ])
    Credentials._ext = []
    
    #-----< SimpleCredentials >-----#
    SimpleCredentials = SEQ(name='SimpleCredentials', mode=MODE_TYPE)
    _SimpleCredentials_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _SimpleCredentials_validity = SET(name='validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_time1 = CHOICE(name='time1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time1_utc = TIME_UTC(name='utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time1_gt = TIME_GEN(name='gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time1._cont = ASN1Dict([
        ('utc', ___SimpleCredentials_validity_time1_utc),
        ('gt', ___SimpleCredentials_validity_time1_gt),
        ])
    __SimpleCredentials_validity_time1._ext = None
    __SimpleCredentials_validity_time2 = CHOICE(name='time2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time2_utc = TIME_UTC(name='utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time2_gt = TIME_GEN(name='gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time2._cont = ASN1Dict([
        ('utc', ___SimpleCredentials_validity_time2_utc),
        ('gt', ___SimpleCredentials_validity_time2_gt),
        ])
    __SimpleCredentials_validity_time2._ext = None
    __SimpleCredentials_validity_random1 = BIT_STR(name='random1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_random2 = BIT_STR(name='random2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SimpleCredentials_validity._cont = ASN1Dict([
        ('time1', __SimpleCredentials_validity_time1),
        ('time2', __SimpleCredentials_validity_time2),
        ('random1', __SimpleCredentials_validity_random1),
        ('random2', __SimpleCredentials_validity_random2),
        ])
    _SimpleCredentials_validity._ext = None
    _SimpleCredentials_password = CHOICE(name='password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_password_unprotected = OCT_STR(name='unprotected', mode=MODE_TYPE)
    __SimpleCredentials_password_protected = SEQ(name='protected', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    ___SimpleCredentials_password_protected_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_at = None
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___SimpleCredentials_password_protected_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm),
        ('parameters', ____SimpleCredentials_password_protected_algorithmIdentifier_parameters),
        ])
    ___SimpleCredentials_password_protected_algorithmIdentifier._ext = []
    ___SimpleCredentials_password_protected_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    __SimpleCredentials_password_protected._cont = ASN1Dict([
        ('algorithmIdentifier', ___SimpleCredentials_password_protected_algorithmIdentifier),
        ('hashValue', ___SimpleCredentials_password_protected_hashValue),
        ])
    __SimpleCredentials_password_protected._ext = []
    __SimpleCredentials_password_userPwd = CHOICE(name='userPwd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    _SimpleCredentials_password._cont = ASN1Dict([
        ('unprotected', __SimpleCredentials_password_unprotected),
        ('protected', __SimpleCredentials_password_protected),
        ('userPwd', __SimpleCredentials_password_userPwd),
        ])
    _SimpleCredentials_password._ext = ['userPwd']
    SimpleCredentials._cont = ASN1Dict([
        ('name', _SimpleCredentials_name),
        ('validity', _SimpleCredentials_validity),
        ('password', _SimpleCredentials_password),
        ])
    SimpleCredentials._ext = None
    
    #-----< StrongCredentials >-----#
    StrongCredentials = SET(name='StrongCredentials', mode=MODE_TYPE)
    _StrongCredentials_certification_path = SEQ(name='certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _StrongCredentials_bind_token = SEQ(name='bind-token', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Token')))
    _StrongCredentials_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _StrongCredentials_attributeCertificationPath = SEQ(name='attributeCertificationPath', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificationPath')), opt=True)
    StrongCredentials._cont = ASN1Dict([
        ('certification-path', _StrongCredentials_certification_path),
        ('bind-token', _StrongCredentials_bind_token),
        ('name', _StrongCredentials_name),
        ('attributeCertificationPath', _StrongCredentials_attributeCertificationPath),
        ])
    StrongCredentials._ext = []
    
    #-----< SpkmCredentials >-----#
    SpkmCredentials = CHOICE(name='SpkmCredentials', mode=MODE_TYPE)
    _SpkmCredentials_req = SEQ(name='req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SpkmCredentials_rep = SEQ(name='rep', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    SpkmCredentials._cont = ASN1Dict([
        ('req', _SpkmCredentials_req),
        ('rep', _SpkmCredentials_rep),
        ])
    SpkmCredentials._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name='SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = CHOICE(name='mechanism', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __SaslCredentials_mechanism_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SaslCredentials_mechanism_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _SaslCredentials_mechanism._cont = ASN1Dict([
        ('teletexString', __SaslCredentials_mechanism_teletexString),
        ('printableString', __SaslCredentials_mechanism_printableString),
        ('bmpString', __SaslCredentials_mechanism_bmpString),
        ('universalString', __SaslCredentials_mechanism_universalString),
        ('uTF8String', __SaslCredentials_mechanism_uTF8String),
        ])
    _SaslCredentials_mechanism._ext = None
    _SaslCredentials_credentials = OCT_STR(name='credentials', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SaslCredentials_saslAbort = BOOL(name='saslAbort', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    SaslCredentials._cont = ASN1Dict([
        ('mechanism', _SaslCredentials_mechanism),
        ('credentials', _SaslCredentials_credentials),
        ('saslAbort', _SaslCredentials_saslAbort),
        ])
    SaslCredentials._ext = []
    
    #-----< ub-saslMechanism >-----#
    ub_saslMechanism = INT(name='ub-saslMechanism', mode=MODE_VALUE)
    ub_saslMechanism._val = 20
    
    #-----< Token >-----#
    Token = SEQ(name='Token', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Token_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TokenContent')))
    _Token_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Token_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Token_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_algorithm._const_tab = ___Token_algorithmIdentifier_algorithm_tab
    __Token_algorithmIdentifier_algorithm._const_tab_at = None
    __Token_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __Token_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Token_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_parameters._const_tab = ___Token_algorithmIdentifier_parameters_tab
    __Token_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __Token_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _Token_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __Token_algorithmIdentifier_algorithm),
        ('parameters', __Token_algorithmIdentifier_parameters),
        ])
    _Token_algorithmIdentifier._ext = []
    _Token_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    Token._cont = ASN1Dict([
        ('toBeSigned', _Token_toBeSigned),
        ('algorithmIdentifier', _Token_algorithmIdentifier),
        ('encrypted', _Token_encrypted),
        ])
    Token._ext = []
    
    #-----< TokenContent >-----#
    TokenContent = SEQ(name='TokenContent', mode=MODE_TYPE)
    _TokenContent_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TokenContent_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___TokenContent_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_algorithm._const_tab = ___TokenContent_algorithm_algorithm_tab
    __TokenContent_algorithm_algorithm._const_tab_at = None
    __TokenContent_algorithm_algorithm._const_tab_id = 'id'
    __TokenContent_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___TokenContent_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_parameters._const_tab = ___TokenContent_algorithm_parameters_tab
    __TokenContent_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __TokenContent_algorithm_parameters._const_tab_id = 'Type'
    _TokenContent_algorithm._cont = ASN1Dict([
        ('algorithm', __TokenContent_algorithm_algorithm),
        ('parameters', __TokenContent_algorithm_parameters),
        ])
    _TokenContent_algorithm._ext = []
    _TokenContent_name = SEQ_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _TokenContent_time = CHOICE(name='time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')))
    _TokenContent_random = BIT_STR(name='random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _TokenContent_response = BIT_STR(name='response', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    TokenContent._cont = ASN1Dict([
        ('algorithm', _TokenContent_algorithm),
        ('name', _TokenContent_name),
        ('time', _TokenContent_time),
        ('random', _TokenContent_random),
        ('response', _TokenContent_response),
        ])
    TokenContent._ext = []
    
    #-----< Versions >-----#
    Versions = BIT_STR(name='Versions', mode=MODE_TYPE)
    Versions._cont = ASN1Dict([('v1', 0), ('v2', 1)])
    
    #-----< DirectoryBindResult >-----#
    DirectoryBindResult = SET(name='DirectoryBindResult', mode=MODE_TYPE)
    _DirectoryBindResult_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindResult_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _DirectoryBindResult_pwdResponseValue = SEQ(name='pwdResponseValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PwdResponseValue')), opt=True)
    DirectoryBindResult._cont = ASN1Dict([
        ('credentials', _DirectoryBindResult_credentials),
        ('versions', _DirectoryBindResult_versions),
        ('pwdResponseValue', _DirectoryBindResult_pwdResponseValue),
        ])
    DirectoryBindResult._ext = ['pwdResponseValue']
    
    #-----< PwdResponseValue >-----#
    PwdResponseValue = SEQ(name='PwdResponseValue', mode=MODE_TYPE)
    _PwdResponseValue_warning = CHOICE(name='warning', mode=MODE_TYPE, opt=True)
    __PwdResponseValue_warning_timeLeft = INT(name='timeLeft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_timeLeft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponseValue_warning_graceRemaining = INT(name='graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponseValue_warning._cont = ASN1Dict([
        ('timeLeft', __PwdResponseValue_warning_timeLeft),
        ('graceRemaining', __PwdResponseValue_warning_graceRemaining),
        ])
    _PwdResponseValue_warning._ext = []
    _PwdResponseValue_error = ENUM(name='error', mode=MODE_TYPE, opt=True)
    _PwdResponseValue_error._cont = ASN1Dict([('passwordExpired', 0), ('changeAfterReset', 1)])
    _PwdResponseValue_error._ext = []
    PwdResponseValue._cont = ASN1Dict([
        ('warning', _PwdResponseValue_warning),
        ('error', _PwdResponseValue_error),
        ])
    PwdResponseValue._ext = None
    
    #-----< directoryBindError >-----#
    directoryBindError = CLASS(name='directoryBindError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _directoryBindError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __directoryBindError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___directoryBindError_val_ParameterType_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ___directoryBindError_val_ParameterType_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ____directoryBindError_val_ParameterType_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ___directoryBindError_val_ParameterType_unsigned_error._cont = ASN1Dict([
        ('serviceError', ____directoryBindError_val_ParameterType_unsigned_error_serviceError),
        ('securityError', ____directoryBindError_val_ParameterType_unsigned_error_securityError),
        ])
    ___directoryBindError_val_ParameterType_unsigned_error._ext = []
    ___directoryBindError_val_ParameterType_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __directoryBindError_val_ParameterType_unsigned._cont = ASN1Dict([
        ('versions', ___directoryBindError_val_ParameterType_unsigned_versions),
        ('error', ___directoryBindError_val_ParameterType_unsigned_error),
        ('securityParameters', ___directoryBindError_val_ParameterType_unsigned_securityParameters),
        ])
    __directoryBindError_val_ParameterType_unsigned._ext = None
    __directoryBindError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___directoryBindError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError),
        ('securityError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError),
        ])
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._ext = []
    ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___directoryBindError_val_ParameterType_signed_toBeSigned._cont = ASN1Dict([
        ('versions', ____directoryBindError_val_ParameterType_signed_toBeSigned_versions),
        ('error', ____directoryBindError_val_ParameterType_signed_toBeSigned_error),
        ('securityParameters', ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters),
        ])
    ___directoryBindError_val_ParameterType_signed_toBeSigned._ext = None
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___directoryBindError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __directoryBindError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___directoryBindError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___directoryBindError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___directoryBindError_val_ParameterType_signed_encrypted),
        ])
    __directoryBindError_val_ParameterType_signed._ext = []
    _directoryBindError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __directoryBindError_val_ParameterType_unsigned),
        ('signed', __directoryBindError_val_ParameterType_signed),
        ])
    _directoryBindError_val_ParameterType._ext = None
    directoryBindError._val = dict([('ParameterType', _directoryBindError_val_ParameterType)])
    
    #-----< BindKeyInfo >-----#
    BindKeyInfo = BIT_STR(name='BindKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED')))
    
    #-----< read >-----#
    read = CLASS(name='read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _read_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    _read_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    read._val = dict([('ArgumentType', _read_val_ArgumentType), ('ResultType', _read_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< ReadArgument >-----#
    ReadArgument = CHOICE(name='ReadArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    _ReadArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    __ReadArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ReadArgument_signed_algorithmIdentifier_algorithm_tab
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ReadArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab = ____ReadArgument_signed_algorithmIdentifier_parameters_tab
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ReadArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ReadArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ReadArgument_signed_algorithmIdentifier_parameters),
        ])
    __ReadArgument_signed_algorithmIdentifier._ext = []
    __ReadArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ReadArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ReadArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ReadArgument_signed_algorithmIdentifier),
        ('encrypted', __ReadArgument_signed_encrypted),
        ])
    _ReadArgument_signed._ext = []
    ReadArgument._cont = ASN1Dict([
        ('unsigned', _ReadArgument_unsigned),
        ('signed', _ReadArgument_signed),
        ])
    ReadArgument._ext = None
    
    #-----< ReadArgumentData >-----#
    ReadArgumentData = SET(name='ReadArgumentData', mode=MODE_TYPE)
    _ReadArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ReadArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _ReadArgumentData_modifyRightsRequest = BOOL(name='modifyRightsRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ReadArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ReadArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ReadArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ReadArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ReadArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ReadArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ReadArgumentData._cont = ASN1Dict([
        ('object', _ReadArgumentData_object),
        ('selection', _ReadArgumentData_selection),
        ('modifyRightsRequest', _ReadArgumentData_modifyRightsRequest),
        ('serviceControls', _ReadArgumentData_serviceControls),
        ('securityParameters', _ReadArgumentData_securityParameters),
        ('requestor', _ReadArgumentData_requestor),
        ('operationProgress', _ReadArgumentData_operationProgress),
        ('aliasedRDNs', _ReadArgumentData_aliasedRDNs),
        ('criticalExtensions', _ReadArgumentData_criticalExtensions),
        ('referenceType', _ReadArgumentData_referenceType),
        ('entryOnly', _ReadArgumentData_entryOnly),
        ('exclusions', _ReadArgumentData_exclusions),
        ('nameResolveOnMaster', _ReadArgumentData_nameResolveOnMaster),
        ('operationContexts', _ReadArgumentData_operationContexts),
        ('familyGrouping', _ReadArgumentData_familyGrouping),
        ])
    ReadArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ReadResult >-----#
    ReadResult = CHOICE(name='ReadResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadResult_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    _ReadResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadResult_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    __ReadResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab = ____ReadResult_signed_algorithmIdentifier_algorithm_tab
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ReadResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ReadResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab = ____ReadResult_signed_algorithmIdentifier_parameters_tab
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ReadResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ReadResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ReadResult_signed_algorithmIdentifier_parameters),
        ])
    __ReadResult_signed_algorithmIdentifier._ext = []
    __ReadResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ReadResult_signed._cont = ASN1Dict([
        ('toBeSigned', __ReadResult_signed_toBeSigned),
        ('algorithmIdentifier', __ReadResult_signed_algorithmIdentifier),
        ('encrypted', __ReadResult_signed_encrypted),
        ])
    _ReadResult_signed._ext = []
    ReadResult._cont = ASN1Dict([
        ('unsigned', _ReadResult_unsigned),
        ('signed', _ReadResult_signed),
        ])
    ReadResult._ext = None
    
    #-----< ReadResultData >-----#
    ReadResultData = SET(name='ReadResultData', mode=MODE_TYPE)
    _ReadResultData_entry = SEQ(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    _ReadResultData_modifyRights = SET_OF(name='modifyRights', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyRights')), opt=True)
    _ReadResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReadResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReadResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ReadResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReadResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ReadResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReadResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ReadResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ReadResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReadResultData_notification__item__type._const_tab = ____ReadResultData_notification__item__type_tab
    ___ReadResultData_notification__item__type._const_tab_at = None
    ___ReadResultData_notification__item__type._const_tab_id = 'id'
    ___ReadResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ReadResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ReadResultData_notification__item__values__item_._const_tab = ____ReadResultData_notification__item__type_tab
    ____ReadResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ReadResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ReadResultData_notification__item__values._cont = ____ReadResultData_notification__item__values__item_
    ___ReadResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReadResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReadResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReadResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab = ____ReadResultData_notification__item__type_tab
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ReadResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._cont = ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReadResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ReadResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ReadResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReadResultData_notification__item__valuesWithContext__item_._ext = []
    ___ReadResultData_notification__item__valuesWithContext._cont = ____ReadResultData_notification__item__valuesWithContext__item_
    ___ReadResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReadResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ReadResultData_notification__item__type),
        ('values', ___ReadResultData_notification__item__values),
        ('valuesWithContext', ___ReadResultData_notification__item__valuesWithContext),
        ])
    __ReadResultData_notification__item_._ext = []
    _ReadResultData_notification._cont = __ReadResultData_notification__item_
    ReadResultData._cont = ASN1Dict([
        ('entry', _ReadResultData_entry),
        ('modifyRights', _ReadResultData_modifyRights),
        ('securityParameters', _ReadResultData_securityParameters),
        ('performer', _ReadResultData_performer),
        ('aliasDereferenced', _ReadResultData_aliasDereferenced),
        ('notification', _ReadResultData_notification),
        ])
    ReadResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ModifyRights >-----#
    ModifyRights = SET_OF(name='ModifyRights', mode=MODE_TYPE)
    _ModifyRights__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ModifyRights__item__item = CHOICE(name='item', mode=MODE_TYPE)
    ___ModifyRights__item__item_entry = NULL(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ModifyRights__item__item_attribute = OID(name='attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___ModifyRights__item__item_value = SEQ(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    __ModifyRights__item__item._cont = ASN1Dict([
        ('entry', ___ModifyRights__item__item_entry),
        ('attribute', ___ModifyRights__item__item_attribute),
        ('value', ___ModifyRights__item__item_value),
        ])
    __ModifyRights__item__item._ext = []
    __ModifyRights__item__permission = BIT_STR(name='permission', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyRights__item__permission._cont = ASN1Dict([('add', 0), ('remove', 1), ('rename', 2), ('move', 3)])
    _ModifyRights__item_._cont = ASN1Dict([
        ('item', __ModifyRights__item__item),
        ('permission', __ModifyRights__item__permission),
        ])
    _ModifyRights__item_._ext = []
    ModifyRights._cont = _ModifyRights__item_
    
    #-----< compare >-----#
    compare = CLASS(name='compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _compare_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    _compare_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    compare._val = dict([('ArgumentType', _compare_val_ArgumentType), ('ResultType', _compare_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< CompareArgument >-----#
    CompareArgument = CHOICE(name='CompareArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    _CompareArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    __CompareArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CompareArgument_signed_algorithmIdentifier_algorithm_tab
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CompareArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab = ____CompareArgument_signed_algorithmIdentifier_parameters_tab
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CompareArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CompareArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CompareArgument_signed_algorithmIdentifier_parameters),
        ])
    __CompareArgument_signed_algorithmIdentifier._ext = []
    __CompareArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _CompareArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __CompareArgument_signed_toBeSigned),
        ('algorithmIdentifier', __CompareArgument_signed_algorithmIdentifier),
        ('encrypted', __CompareArgument_signed_encrypted),
        ])
    _CompareArgument_signed._ext = []
    CompareArgument._cont = ASN1Dict([
        ('unsigned', _CompareArgument_unsigned),
        ('signed', _CompareArgument_signed),
        ])
    CompareArgument._ext = None
    
    #-----< CompareArgumentData >-----#
    CompareArgumentData = SET(name='CompareArgumentData', mode=MODE_TYPE)
    _CompareArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CompareArgumentData_purported = SEQ(name='purported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _CompareArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CompareArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _CompareArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CompareArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CompareArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CompareArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    CompareArgumentData._cont = ASN1Dict([
        ('object', _CompareArgumentData_object),
        ('purported', _CompareArgumentData_purported),
        ('serviceControls', _CompareArgumentData_serviceControls),
        ('securityParameters', _CompareArgumentData_securityParameters),
        ('requestor', _CompareArgumentData_requestor),
        ('operationProgress', _CompareArgumentData_operationProgress),
        ('aliasedRDNs', _CompareArgumentData_aliasedRDNs),
        ('criticalExtensions', _CompareArgumentData_criticalExtensions),
        ('referenceType', _CompareArgumentData_referenceType),
        ('entryOnly', _CompareArgumentData_entryOnly),
        ('exclusions', _CompareArgumentData_exclusions),
        ('nameResolveOnMaster', _CompareArgumentData_nameResolveOnMaster),
        ('operationContexts', _CompareArgumentData_operationContexts),
        ('familyGrouping', _CompareArgumentData_familyGrouping),
        ])
    CompareArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< CompareResult >-----#
    CompareResult = CHOICE(name='CompareResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareResult_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    _CompareResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareResult_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    __CompareResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab = ____CompareResult_signed_algorithmIdentifier_algorithm_tab
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CompareResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CompareResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab = ____CompareResult_signed_algorithmIdentifier_parameters_tab
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CompareResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CompareResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CompareResult_signed_algorithmIdentifier_parameters),
        ])
    __CompareResult_signed_algorithmIdentifier._ext = []
    __CompareResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _CompareResult_signed._cont = ASN1Dict([
        ('toBeSigned', __CompareResult_signed_toBeSigned),
        ('algorithmIdentifier', __CompareResult_signed_algorithmIdentifier),
        ('encrypted', __CompareResult_signed_encrypted),
        ])
    _CompareResult_signed._ext = []
    CompareResult._cont = ASN1Dict([
        ('unsigned', _CompareResult_unsigned),
        ('signed', _CompareResult_signed),
        ])
    CompareResult._ext = None
    
    #-----< CompareResultData >-----#
    CompareResultData = SET(name='CompareResultData', mode=MODE_TYPE)
    _CompareResultData_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CompareResultData_matched = BOOL(name='matched', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CompareResultData_fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareResultData_matchedSubtype = OID(name='matchedSubtype', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _CompareResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CompareResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CompareResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CompareResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CompareResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____CompareResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CompareResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CompareResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CompareResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CompareResultData_notification__item__type._const_tab = ____CompareResultData_notification__item__type_tab
    ___CompareResultData_notification__item__type._const_tab_at = None
    ___CompareResultData_notification__item__type._const_tab_id = 'id'
    ___CompareResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CompareResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CompareResultData_notification__item__values__item_._const_tab = ____CompareResultData_notification__item__type_tab
    ____CompareResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CompareResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___CompareResultData_notification__item__values._cont = ____CompareResultData_notification__item__values__item_
    ___CompareResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CompareResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CompareResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CompareResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab = ____CompareResultData_notification__item__type_tab
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CompareResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._cont = ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CompareResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CompareResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____CompareResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CompareResultData_notification__item__valuesWithContext__item_._ext = []
    ___CompareResultData_notification__item__valuesWithContext._cont = ____CompareResultData_notification__item__valuesWithContext__item_
    ___CompareResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CompareResultData_notification__item_._cont = ASN1Dict([
        ('type', ___CompareResultData_notification__item__type),
        ('values', ___CompareResultData_notification__item__values),
        ('valuesWithContext', ___CompareResultData_notification__item__valuesWithContext),
        ])
    __CompareResultData_notification__item_._ext = []
    _CompareResultData_notification._cont = __CompareResultData_notification__item_
    CompareResultData._cont = ASN1Dict([
        ('name', _CompareResultData_name),
        ('matched', _CompareResultData_matched),
        ('fromEntry', _CompareResultData_fromEntry),
        ('matchedSubtype', _CompareResultData_matchedSubtype),
        ('securityParameters', _CompareResultData_securityParameters),
        ('performer', _CompareResultData_performer),
        ('aliasDereferenced', _CompareResultData_aliasDereferenced),
        ('notification', _CompareResultData_notification),
        ])
    CompareResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< abandon >-----#
    abandon = CLASS(name='abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _abandon_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _abandon_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    abandon._val = dict([('ArgumentType', _abandon_val_ArgumentType), ('ResultType', _abandon_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< AbandonArgument >-----#
    AbandonArgument = CHOICE(name='AbandonArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AbandonArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    _AbandonArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AbandonArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    __AbandonArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AbandonArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AbandonArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab = ____AbandonArgument_signed_algorithmIdentifier_parameters_tab
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AbandonArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AbandonArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AbandonArgument_signed_algorithmIdentifier_parameters),
        ])
    __AbandonArgument_signed_algorithmIdentifier._ext = []
    __AbandonArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _AbandonArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AbandonArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AbandonArgument_signed_algorithmIdentifier),
        ('encrypted', __AbandonArgument_signed_encrypted),
        ])
    _AbandonArgument_signed._ext = []
    AbandonArgument._cont = ASN1Dict([
        ('unsigned', _AbandonArgument_unsigned),
        ('signed', _AbandonArgument_signed),
        ])
    AbandonArgument._ext = None
    
    #-----< AbandonArgumentData >-----#
    AbandonArgumentData = SEQ(name='AbandonArgumentData', mode=MODE_TYPE)
    _AbandonArgumentData_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    AbandonArgumentData._cont = ASN1Dict([
        ('invokeID', _AbandonArgumentData_invokeID),
        ])
    AbandonArgumentData._ext = []
    
    #-----< AbandonResult >-----#
    AbandonResult = CHOICE(name='AbandonResult', mode=MODE_TYPE)
    _AbandonResult_null = NULL(name='null', mode=MODE_TYPE)
    _AbandonResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AbandonResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    __AbandonResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AbandonResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    ___AbandonResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AbandonResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AbandonResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AbandonResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AbandonResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AbandonResult_information_signed_algorithmIdentifier._ext = []
    ___AbandonResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __AbandonResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AbandonResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AbandonResult_information_signed_algorithmIdentifier),
        ('encrypted', ___AbandonResult_information_signed_encrypted),
        ])
    __AbandonResult_information_signed._ext = []
    _AbandonResult_information._cont = ASN1Dict([
        ('unsigned', __AbandonResult_information_unsigned),
        ('signed', __AbandonResult_information_signed),
        ])
    _AbandonResult_information._ext = None
    AbandonResult._cont = ASN1Dict([
        ('null', _AbandonResult_null),
        ('information', _AbandonResult_information),
        ])
    AbandonResult._ext = []
    
    #-----< AbandonResultData >-----#
    AbandonResultData = SEQ(name='AbandonResultData', mode=MODE_TYPE)
    _AbandonResultData_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonResultData_notification__item__type._const_tab = ____AbandonResultData_notification__item__type_tab
    ___AbandonResultData_notification__item__type._const_tab_at = None
    ___AbandonResultData_notification__item__type._const_tab_id = 'id'
    ___AbandonResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonResultData_notification__item__values__item_._const_tab = ____AbandonResultData_notification__item__type_tab
    ____AbandonResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonResultData_notification__item__values._cont = ____AbandonResultData_notification__item__values__item_
    ___AbandonResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonResultData_notification__item__type_tab
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonResultData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonResultData_notification__item__valuesWithContext._cont = ____AbandonResultData_notification__item__valuesWithContext__item_
    ___AbandonResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonResultData_notification__item__type),
        ('values', ___AbandonResultData_notification__item__values),
        ('valuesWithContext', ___AbandonResultData_notification__item__valuesWithContext),
        ])
    __AbandonResultData_notification__item_._ext = []
    _AbandonResultData_notification._cont = __AbandonResultData_notification__item_
    AbandonResultData._cont = ASN1Dict([
        ('invokeID', _AbandonResultData_invokeID),
        ('securityParameters', _AbandonResultData_securityParameters),
        ('performer', _AbandonResultData_performer),
        ('aliasDereferenced', _AbandonResultData_aliasDereferenced),
        ('notification', _AbandonResultData_notification),
        ])
    AbandonResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< list >-----#
    list = CLASS(name='list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _list_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    _list_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    list._val = dict([('ArgumentType', _list_val_ArgumentType), ('ResultType', _list_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))])
    
    #-----< ListArgument >-----#
    ListArgument = CHOICE(name='ListArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    _ListArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    __ListArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ListArgument_signed_algorithmIdentifier_algorithm_tab
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ListArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ListArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab = ____ListArgument_signed_algorithmIdentifier_parameters_tab
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ListArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ListArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ListArgument_signed_algorithmIdentifier_parameters),
        ])
    __ListArgument_signed_algorithmIdentifier._ext = []
    __ListArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ListArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ListArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ListArgument_signed_algorithmIdentifier),
        ('encrypted', __ListArgument_signed_encrypted),
        ])
    _ListArgument_signed._ext = []
    ListArgument._cont = ASN1Dict([
        ('unsigned', _ListArgument_unsigned),
        ('signed', _ListArgument_signed),
        ])
    ListArgument._ext = None
    
    #-----< ListArgumentData >-----#
    ListArgumentData = SET(name='ListArgumentData', mode=MODE_TYPE)
    _ListArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ListArgumentData_pagedResults = CHOICE(name='pagedResults', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _ListArgumentData_listFamily = BOOL(name='listFamily', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ListArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ListArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ListArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ListArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ListArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ListArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ListArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ListArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ListArgumentData._cont = ASN1Dict([
        ('object', _ListArgumentData_object),
        ('pagedResults', _ListArgumentData_pagedResults),
        ('listFamily', _ListArgumentData_listFamily),
        ('serviceControls', _ListArgumentData_serviceControls),
        ('securityParameters', _ListArgumentData_securityParameters),
        ('requestor', _ListArgumentData_requestor),
        ('operationProgress', _ListArgumentData_operationProgress),
        ('aliasedRDNs', _ListArgumentData_aliasedRDNs),
        ('criticalExtensions', _ListArgumentData_criticalExtensions),
        ('referenceType', _ListArgumentData_referenceType),
        ('entryOnly', _ListArgumentData_entryOnly),
        ('exclusions', _ListArgumentData_exclusions),
        ('nameResolveOnMaster', _ListArgumentData_nameResolveOnMaster),
        ('operationContexts', _ListArgumentData_operationContexts),
        ('familyGrouping', _ListArgumentData_familyGrouping),
        ])
    ListArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ListResult >-----#
    ListResult = CHOICE(name='ListResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListResult_unsigned = CHOICE(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    _ListResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListResult_signed_toBeSigned = CHOICE(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    __ListResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab = ____ListResult_signed_algorithmIdentifier_algorithm_tab
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ListResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ListResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab = ____ListResult_signed_algorithmIdentifier_parameters_tab
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ListResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ListResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ListResult_signed_algorithmIdentifier_parameters),
        ])
    __ListResult_signed_algorithmIdentifier._ext = []
    __ListResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ListResult_signed._cont = ASN1Dict([
        ('toBeSigned', __ListResult_signed_toBeSigned),
        ('algorithmIdentifier', __ListResult_signed_algorithmIdentifier),
        ('encrypted', __ListResult_signed_encrypted),
        ])
    _ListResult_signed._ext = []
    ListResult._cont = ASN1Dict([
        ('unsigned', _ListResult_unsigned),
        ('signed', _ListResult_signed),
        ])
    ListResult._ext = None
    
    #-----< ListResultData >-----#
    ListResultData = CHOICE(name='ListResultData', mode=MODE_TYPE)
    _ListResultData_listInfo = SET(name='listInfo', mode=MODE_TYPE)
    __ListResultData_listInfo_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __ListResultData_listInfo_subordinates = SET_OF(name='subordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ListResultData_listInfo_subordinates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ListResultData_listInfo_subordinates__item__rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    ____ListResultData_listInfo_subordinates__item__aliasEntry = BOOL(name='aliasEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ____ListResultData_listInfo_subordinates__item__fromEntry = BOOL(name='fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    ___ListResultData_listInfo_subordinates__item_._cont = ASN1Dict([
        ('rdn', ____ListResultData_listInfo_subordinates__item__rdn),
        ('aliasEntry', ____ListResultData_listInfo_subordinates__item__aliasEntry),
        ('fromEntry', ____ListResultData_listInfo_subordinates__item__fromEntry),
        ])
    ___ListResultData_listInfo_subordinates__item_._ext = []
    __ListResultData_listInfo_subordinates._cont = ___ListResultData_listInfo_subordinates__item_
    __ListResultData_listInfo_partialOutcomeQualifier = SET(name='partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __ListResultData_listInfo_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __ListResultData_listInfo_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __ListResultData_listInfo_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __ListResultData_listInfo_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___ListResultData_listInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ListResultData_listInfo_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____ListResultData_listInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ListResultData_listInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__type._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ____ListResultData_listInfo_notification__item__type._const_tab_at = None
    ____ListResultData_listInfo_notification__item__type._const_tab_id = 'id'
    ____ListResultData_listInfo_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____ListResultData_listInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ListResultData_listInfo_notification__item__values__item_._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_id = 'Type'
    ____ListResultData_listInfo_notification__item__values._cont = _____ListResultData_listInfo_notification__item__values__item_
    ____ListResultData_listInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._cont = _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______ListResultData_listInfo_notification__item__valuesWithContext__item__value),
        ('contextList', ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._ext = []
    ____ListResultData_listInfo_notification__item__valuesWithContext._cont = _____ListResultData_listInfo_notification__item__valuesWithContext__item_
    ____ListResultData_listInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ListResultData_listInfo_notification__item_._cont = ASN1Dict([
        ('type', ____ListResultData_listInfo_notification__item__type),
        ('values', ____ListResultData_listInfo_notification__item__values),
        ('valuesWithContext', ____ListResultData_listInfo_notification__item__valuesWithContext),
        ])
    ___ListResultData_listInfo_notification__item_._ext = []
    __ListResultData_listInfo_notification._cont = ___ListResultData_listInfo_notification__item_
    _ListResultData_listInfo._cont = ASN1Dict([
        ('name', __ListResultData_listInfo_name),
        ('subordinates', __ListResultData_listInfo_subordinates),
        ('partialOutcomeQualifier', __ListResultData_listInfo_partialOutcomeQualifier),
        ('securityParameters', __ListResultData_listInfo_securityParameters),
        ('performer', __ListResultData_listInfo_performer),
        ('aliasDereferenced', __ListResultData_listInfo_aliasDereferenced),
        ('notification', __ListResultData_listInfo_notification),
        ])
    _ListResultData_listInfo._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    _ListResultData_uncorrelatedListInfo = SET_OF(name='uncorrelatedListInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ListResultData_uncorrelatedListInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    _ListResultData_uncorrelatedListInfo._cont = __ListResultData_uncorrelatedListInfo__item_
    ListResultData._cont = ASN1Dict([
        ('listInfo', _ListResultData_listInfo),
        ('uncorrelatedListInfo', _ListResultData_uncorrelatedListInfo),
        ])
    ListResultData._ext = []
    
    #-----< PartialOutcomeQualifier >-----#
    PartialOutcomeQualifier = SET(name='PartialOutcomeQualifier', mode=MODE_TYPE)
    _PartialOutcomeQualifier_limitProblem = INT(name='limitProblem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LimitProblem')), opt=True)
    _PartialOutcomeQualifier_unexplored = SET_OF(name='unexplored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unexplored__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _PartialOutcomeQualifier_unexplored._cont = __PartialOutcomeQualifier_unexplored__item_
    _PartialOutcomeQualifier_unexplored._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_unavailableCriticalExtensions = BOOL(name='unavailableCriticalExtensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _PartialOutcomeQualifier_unknownErrors = SET_OF(name='unknownErrors', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unknownErrors__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _PartialOutcomeQualifier_unknownErrors._cont = __PartialOutcomeQualifier_unknownErrors__item_
    _PartialOutcomeQualifier_unknownErrors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_queryReference = OCT_STR(name='queryReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PartialOutcomeQualifier_overspecFilter = CHOICE(name='overspecFilter', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _PartialOutcomeQualifier_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___PartialOutcomeQualifier_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____PartialOutcomeQualifier_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____PartialOutcomeQualifier_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__type._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ___PartialOutcomeQualifier_notification__item__type._const_tab_at = None
    ___PartialOutcomeQualifier_notification__item__type._const_tab_id = 'id'
    ___PartialOutcomeQualifier_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____PartialOutcomeQualifier_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_id = 'Type'
    ___PartialOutcomeQualifier_notification__item__values._cont = ____PartialOutcomeQualifier_notification__item__values__item_
    ___PartialOutcomeQualifier_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._cont = ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value),
        ('contextList', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList),
        ])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._ext = []
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._cont = ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PartialOutcomeQualifier_notification__item_._cont = ASN1Dict([
        ('type', ___PartialOutcomeQualifier_notification__item__type),
        ('values', ___PartialOutcomeQualifier_notification__item__values),
        ('valuesWithContext', ___PartialOutcomeQualifier_notification__item__valuesWithContext),
        ])
    __PartialOutcomeQualifier_notification__item_._ext = []
    _PartialOutcomeQualifier_notification._cont = __PartialOutcomeQualifier_notification__item_
    _PartialOutcomeQualifier_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_entryCount = CHOICE(name='entryCount', mode=MODE_TYPE, opt=True)
    __PartialOutcomeQualifier_entryCount_bestEstimate = INT(name='bestEstimate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_lowEstimate = INT(name='lowEstimate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_exact = INT(name='exact', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _PartialOutcomeQualifier_entryCount._cont = ASN1Dict([
        ('bestEstimate', __PartialOutcomeQualifier_entryCount_bestEstimate),
        ('lowEstimate', __PartialOutcomeQualifier_entryCount_lowEstimate),
        ('exact', __PartialOutcomeQualifier_entryCount_exact),
        ])
    _PartialOutcomeQualifier_entryCount._ext = []
    PartialOutcomeQualifier._cont = ASN1Dict([
        ('limitProblem', _PartialOutcomeQualifier_limitProblem),
        ('unexplored', _PartialOutcomeQualifier_unexplored),
        ('unavailableCriticalExtensions', _PartialOutcomeQualifier_unavailableCriticalExtensions),
        ('unknownErrors', _PartialOutcomeQualifier_unknownErrors),
        ('queryReference', _PartialOutcomeQualifier_queryReference),
        ('overspecFilter', _PartialOutcomeQualifier_overspecFilter),
        ('notification', _PartialOutcomeQualifier_notification),
        ('entryCount', _PartialOutcomeQualifier_entryCount),
        ])
    PartialOutcomeQualifier._ext = None
    
    #-----< LimitProblem >-----#
    LimitProblem = INT(name='LimitProblem', mode=MODE_TYPE)
    LimitProblem._cont = ASN1Dict([('timeLimitExceeded', 0), ('sizeLimitExceeded', 1), ('administrativeLimitExceeded', 2)])
    
    #-----< search >-----#
    search = CLASS(name='search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _search_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    _search_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    search._val = dict([('ArgumentType', _search_val_ArgumentType), ('ResultType', _search_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])
    
    #-----< SearchArgument >-----#
    SearchArgument = CHOICE(name='SearchArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    _SearchArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    __SearchArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab = ____SearchArgument_signed_algorithmIdentifier_algorithm_tab
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SearchArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab = ____SearchArgument_signed_algorithmIdentifier_parameters_tab
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SearchArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SearchArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___SearchArgument_signed_algorithmIdentifier_parameters),
        ])
    __SearchArgument_signed_algorithmIdentifier._ext = []
    __SearchArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _SearchArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __SearchArgument_signed_toBeSigned),
        ('algorithmIdentifier', __SearchArgument_signed_algorithmIdentifier),
        ('encrypted', __SearchArgument_signed_encrypted),
        ])
    _SearchArgument_signed._ext = []
    SearchArgument._cont = ASN1Dict([
        ('unsigned', _SearchArgument_unsigned),
        ('signed', _SearchArgument_signed),
        ])
    SearchArgument._ext = None
    
    #-----< SearchArgumentData >-----#
    SearchArgumentData = SET(name='SearchArgumentData', mode=MODE_TYPE)
    _SearchArgumentData_baseObject = CHOICE(name='baseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SearchArgumentData_subset = INT(name='subset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _SearchArgumentData_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _SearchArgumentData_filter = CHOICE(name='filter', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), default=('and', []))
    _SearchArgumentData_searchAliases = BOOL(name='searchAliases', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _SearchArgumentData_pagedResults = CHOICE(name='pagedResults', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _SearchArgumentData_matchedValuesOnly = BOOL(name='matchedValuesOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_extendedFilter = CHOICE(name='extendedFilter', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _SearchArgumentData_checkOverspecified = BOOL(name='checkOverspecified', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchArgumentData_extendedArea = INT(name='extendedArea', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_hierarchySelections = BIT_STR(name='hierarchySelections', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), default=(1, 1))
    _SearchArgumentData_searchControlOptions = BIT_STR(name='searchControlOptions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _SearchArgumentData_joinArguments = SEQ_OF(name='joinArguments', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchArgumentData_joinArguments__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinArgument')))
    _SearchArgumentData_joinArguments._cont = __SearchArgumentData_joinArguments__item_
    _SearchArgumentData_joinArguments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchArgumentData_joinType = ENUM(name='joinType', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='leftOuterJoin')
    _SearchArgumentData_joinType._cont = ASN1Dict([('innerJoin', 0), ('leftOuterJoin', 1), ('fullOuterJoin', 2)])
    _SearchArgumentData_joinType._ext = None
    _SearchArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _SearchArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SearchArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SearchArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _SearchArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _SearchArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _SearchArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _SearchArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    SearchArgumentData._cont = ASN1Dict([
        ('baseObject', _SearchArgumentData_baseObject),
        ('subset', _SearchArgumentData_subset),
        ('filter', _SearchArgumentData_filter),
        ('searchAliases', _SearchArgumentData_searchAliases),
        ('selection', _SearchArgumentData_selection),
        ('pagedResults', _SearchArgumentData_pagedResults),
        ('matchedValuesOnly', _SearchArgumentData_matchedValuesOnly),
        ('extendedFilter', _SearchArgumentData_extendedFilter),
        ('checkOverspecified', _SearchArgumentData_checkOverspecified),
        ('relaxation', _SearchArgumentData_relaxation),
        ('extendedArea', _SearchArgumentData_extendedArea),
        ('hierarchySelections', _SearchArgumentData_hierarchySelections),
        ('searchControlOptions', _SearchArgumentData_searchControlOptions),
        ('joinArguments', _SearchArgumentData_joinArguments),
        ('joinType', _SearchArgumentData_joinType),
        ('serviceControls', _SearchArgumentData_serviceControls),
        ('securityParameters', _SearchArgumentData_securityParameters),
        ('requestor', _SearchArgumentData_requestor),
        ('operationProgress', _SearchArgumentData_operationProgress),
        ('aliasedRDNs', _SearchArgumentData_aliasedRDNs),
        ('criticalExtensions', _SearchArgumentData_criticalExtensions),
        ('referenceType', _SearchArgumentData_referenceType),
        ('entryOnly', _SearchArgumentData_entryOnly),
        ('exclusions', _SearchArgumentData_exclusions),
        ('nameResolveOnMaster', _SearchArgumentData_nameResolveOnMaster),
        ('operationContexts', _SearchArgumentData_operationContexts),
        ('familyGrouping', _SearchArgumentData_familyGrouping),
        ])
    SearchArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< HierarchySelections >-----#
    HierarchySelections = BIT_STR(name='HierarchySelections', mode=MODE_TYPE)
    HierarchySelections._cont = ASN1Dict([('self', 0), ('children', 1), ('parent', 2), ('hierarchy', 3), ('top', 4), ('subtree', 5), ('siblings', 6), ('siblingChildren', 7), ('siblingSubtree', 8), ('all', 9)])
    
    #-----< SearchControlOptions >-----#
    SearchControlOptions = BIT_STR(name='SearchControlOptions', mode=MODE_TYPE)
    SearchControlOptions._cont = ASN1Dict([('searchAliases', 0), ('matchedValuesOnly', 1), ('checkOverspecified', 2), ('performExactly', 3), ('includeAllAreas', 4), ('noSystemRelaxation', 5), ('dnAttribute', 6), ('matchOnResidualName', 7), ('entryCount', 8), ('useSubset', 9), ('separateFamilyMembers', 10), ('searchFamily', 11)])
    
    #-----< JoinArgument >-----#
    JoinArgument = SEQ(name='JoinArgument', mode=MODE_TYPE)
    _JoinArgument_joinBaseObject = CHOICE(name='joinBaseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _JoinArgument_domainLocalID = CHOICE(name='domainLocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'DomainLocalID')), opt=True)
    _JoinArgument_joinSubset = ENUM(name='joinSubset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='baseObject')
    _JoinArgument_joinSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _JoinArgument_joinSubset._ext = []
    _JoinArgument_joinFilter = CHOICE(name='joinFilter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _JoinArgument_joinAttributes = SEQ_OF(name='joinAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __JoinArgument_joinAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinAttPair')))
    _JoinArgument_joinAttributes._cont = __JoinArgument_joinAttributes__item_
    _JoinArgument_joinAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _JoinArgument_joinSelection = SET(name='joinSelection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')))
    JoinArgument._cont = ASN1Dict([
        ('joinBaseObject', _JoinArgument_joinBaseObject),
        ('domainLocalID', _JoinArgument_domainLocalID),
        ('joinSubset', _JoinArgument_joinSubset),
        ('joinFilter', _JoinArgument_joinFilter),
        ('joinAttributes', _JoinArgument_joinAttributes),
        ('joinSelection', _JoinArgument_joinSelection),
        ])
    JoinArgument._ext = []
    
    #-----< DomainLocalID >-----#
    DomainLocalID = CHOICE(name='DomainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    
    #-----< JoinAttPair >-----#
    JoinAttPair = SEQ(name='JoinAttPair', mode=MODE_TYPE)
    _JoinAttPair_baseAtt = OID(name='baseAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinAtt = OID(name='joinAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinContext = SEQ_OF(name='joinContext', mode=MODE_TYPE, opt=True)
    __JoinAttPair_joinContext__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinContextType')))
    _JoinAttPair_joinContext._cont = __JoinAttPair_joinContext__item_
    _JoinAttPair_joinContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    JoinAttPair._cont = ASN1Dict([
        ('baseAtt', _JoinAttPair_baseAtt),
        ('joinAtt', _JoinAttPair_joinAtt),
        ('joinContext', _JoinAttPair_joinContext),
        ])
    JoinAttPair._ext = []
    
    #-----< JoinContextType >-----#
    JoinContextType = OID(name='JoinContextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _JoinContextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _JoinContextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    JoinContextType._const_tab = _JoinContextType_tab
    JoinContextType._const_tab_at = None
    JoinContextType._const_tab_id = 'id'
    
    #-----< SearchResult >-----#
    SearchResult = CHOICE(name='SearchResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchResult_unsigned = CHOICE(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    _SearchResult_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchResult_signed_toBeSigned = CHOICE(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    __SearchResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab = ____SearchResult_signed_algorithmIdentifier_algorithm_tab
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SearchResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SearchResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab = ____SearchResult_signed_algorithmIdentifier_parameters_tab
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SearchResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SearchResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___SearchResult_signed_algorithmIdentifier_parameters),
        ])
    __SearchResult_signed_algorithmIdentifier._ext = []
    __SearchResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _SearchResult_signed._cont = ASN1Dict([
        ('toBeSigned', __SearchResult_signed_toBeSigned),
        ('algorithmIdentifier', __SearchResult_signed_algorithmIdentifier),
        ('encrypted', __SearchResult_signed_encrypted),
        ])
    _SearchResult_signed._ext = []
    SearchResult._cont = ASN1Dict([
        ('unsigned', _SearchResult_unsigned),
        ('signed', _SearchResult_signed),
        ])
    SearchResult._ext = None
    
    #-----< SearchResultData >-----#
    SearchResultData = CHOICE(name='SearchResultData', mode=MODE_TYPE)
    _SearchResultData_searchInfo = SET(name='searchInfo', mode=MODE_TYPE)
    __SearchResultData_searchInfo_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __SearchResultData_searchInfo_entries = SET_OF(name='entries', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___SearchResultData_searchInfo_entries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    __SearchResultData_searchInfo_entries._cont = ___SearchResultData_searchInfo_entries__item_
    __SearchResultData_searchInfo_partialOutcomeQualifier = SET(name='partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __SearchResultData_searchInfo_altMatching = BOOL(name='altMatching', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __SearchResultData_searchInfo_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __SearchResultData_searchInfo_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SearchResultData_searchInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____SearchResultData_searchInfo_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____SearchResultData_searchInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____SearchResultData_searchInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__type._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ____SearchResultData_searchInfo_notification__item__type._const_tab_at = None
    ____SearchResultData_searchInfo_notification__item__type._const_tab_id = 'id'
    ____SearchResultData_searchInfo_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____SearchResultData_searchInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_id = 'Type'
    ____SearchResultData_searchInfo_notification__item__values._cont = _____SearchResultData_searchInfo_notification__item__values__item_
    ____SearchResultData_searchInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._cont = _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value),
        ('contextList', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._ext = []
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._cont = _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___SearchResultData_searchInfo_notification__item_._cont = ASN1Dict([
        ('type', ____SearchResultData_searchInfo_notification__item__type),
        ('values', ____SearchResultData_searchInfo_notification__item__values),
        ('valuesWithContext', ____SearchResultData_searchInfo_notification__item__valuesWithContext),
        ])
    ___SearchResultData_searchInfo_notification__item_._ext = []
    __SearchResultData_searchInfo_notification._cont = ___SearchResultData_searchInfo_notification__item_
    _SearchResultData_searchInfo._cont = ASN1Dict([
        ('name', __SearchResultData_searchInfo_name),
        ('entries', __SearchResultData_searchInfo_entries),
        ('partialOutcomeQualifier', __SearchResultData_searchInfo_partialOutcomeQualifier),
        ('altMatching', __SearchResultData_searchInfo_altMatching),
        ('securityParameters', __SearchResultData_searchInfo_securityParameters),
        ('performer', __SearchResultData_searchInfo_performer),
        ('aliasDereferenced', __SearchResultData_searchInfo_aliasDereferenced),
        ('notification', __SearchResultData_searchInfo_notification),
        ])
    _SearchResultData_searchInfo._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    _SearchResultData_uncorrelatedSearchInfo = SET_OF(name='uncorrelatedSearchInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SearchResultData_uncorrelatedSearchInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    _SearchResultData_uncorrelatedSearchInfo._cont = __SearchResultData_uncorrelatedSearchInfo__item_
    SearchResultData._cont = ASN1Dict([
        ('searchInfo', _SearchResultData_searchInfo),
        ('uncorrelatedSearchInfo', _SearchResultData_uncorrelatedSearchInfo),
        ])
    SearchResultData._ext = []
    
    #-----< addEntry >-----#
    addEntry = CLASS(name='addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _addEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    _addEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    addEntry._val = dict([('ArgumentType', _addEntry_val_ArgumentType), ('ResultType', _addEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))])
    
    #-----< AddEntryArgument >-----#
    AddEntryArgument = CHOICE(name='AddEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _AddEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    _AddEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AddEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    __AddEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AddEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AddEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AddEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AddEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __AddEntryArgument_signed_algorithmIdentifier._ext = []
    __AddEntryArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _AddEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AddEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AddEntryArgument_signed_algorithmIdentifier),
        ('encrypted', __AddEntryArgument_signed_encrypted),
        ])
    _AddEntryArgument_signed._ext = []
    AddEntryArgument._cont = ASN1Dict([
        ('unsigned', _AddEntryArgument_unsigned),
        ('signed', _AddEntryArgument_signed),
        ])
    AddEntryArgument._ext = None
    
    #-----< AddEntryArgumentData >-----#
    AddEntryArgumentData = SET(name='AddEntryArgumentData', mode=MODE_TYPE)
    _AddEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AddEntryArgumentData_entry = SET_OF(name='entry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AddEntryArgumentData_entry__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryArgumentData_entry__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AddEntryArgumentData_entry__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryArgumentData_entry__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__type._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ___AddEntryArgumentData_entry__item__type._const_tab_at = None
    ___AddEntryArgumentData_entry__item__type._const_tab_id = 'id'
    ___AddEntryArgumentData_entry__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AddEntryArgumentData_entry__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AddEntryArgumentData_entry__item__values__item_._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_id = 'Type'
    ___AddEntryArgumentData_entry__item__values._cont = ____AddEntryArgumentData_entry__item__values__item_
    ___AddEntryArgumentData_entry__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._cont = ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AddEntryArgumentData_entry__item__valuesWithContext__item__value),
        ('contextList', _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._ext = []
    ___AddEntryArgumentData_entry__item__valuesWithContext._cont = ____AddEntryArgumentData_entry__item__valuesWithContext__item_
    ___AddEntryArgumentData_entry__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryArgumentData_entry__item_._cont = ASN1Dict([
        ('type', ___AddEntryArgumentData_entry__item__type),
        ('values', ___AddEntryArgumentData_entry__item__values),
        ('valuesWithContext', ___AddEntryArgumentData_entry__item__valuesWithContext),
        ])
    __AddEntryArgumentData_entry__item_._ext = []
    _AddEntryArgumentData_entry._cont = __AddEntryArgumentData_entry__item_
    _AddEntryArgumentData_targetSystem = SET(name='targetSystem', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _AddEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _AddEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _AddEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _AddEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AddEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _AddEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _AddEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    AddEntryArgumentData._cont = ASN1Dict([
        ('object', _AddEntryArgumentData_object),
        ('entry', _AddEntryArgumentData_entry),
        ('targetSystem', _AddEntryArgumentData_targetSystem),
        ('serviceControls', _AddEntryArgumentData_serviceControls),
        ('securityParameters', _AddEntryArgumentData_securityParameters),
        ('requestor', _AddEntryArgumentData_requestor),
        ('operationProgress', _AddEntryArgumentData_operationProgress),
        ('aliasedRDNs', _AddEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _AddEntryArgumentData_criticalExtensions),
        ('referenceType', _AddEntryArgumentData_referenceType),
        ('entryOnly', _AddEntryArgumentData_entryOnly),
        ('exclusions', _AddEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _AddEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _AddEntryArgumentData_operationContexts),
        ('familyGrouping', _AddEntryArgumentData_familyGrouping),
        ])
    AddEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< AddEntryResult >-----#
    AddEntryResult = CHOICE(name='AddEntryResult', mode=MODE_TYPE)
    _AddEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _AddEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AddEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    __AddEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AddEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    ___AddEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AddEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AddEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AddEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AddEntryResult_information_signed_algorithmIdentifier._ext = []
    ___AddEntryResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __AddEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AddEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AddEntryResult_information_signed_algorithmIdentifier),
        ('encrypted', ___AddEntryResult_information_signed_encrypted),
        ])
    __AddEntryResult_information_signed._ext = []
    _AddEntryResult_information._cont = ASN1Dict([
        ('unsigned', __AddEntryResult_information_unsigned),
        ('signed', __AddEntryResult_information_signed),
        ])
    _AddEntryResult_information._ext = None
    AddEntryResult._cont = ASN1Dict([
        ('null', _AddEntryResult_null),
        ('information', _AddEntryResult_information),
        ])
    AddEntryResult._ext = []
    
    #-----< AddEntryResultData >-----#
    AddEntryResultData = SEQ(name='AddEntryResultData', mode=MODE_TYPE)
    _AddEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AddEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AddEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AddEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AddEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryResultData_notification__item__type._const_tab = ____AddEntryResultData_notification__item__type_tab
    ___AddEntryResultData_notification__item__type._const_tab_at = None
    ___AddEntryResultData_notification__item__type._const_tab_id = 'id'
    ___AddEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AddEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AddEntryResultData_notification__item__values__item_._const_tab = ____AddEntryResultData_notification__item__type_tab
    ____AddEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AddEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AddEntryResultData_notification__item__values._cont = ____AddEntryResultData_notification__item__values__item_
    ___AddEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____AddEntryResultData_notification__item__type_tab
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AddEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AddEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___AddEntryResultData_notification__item__valuesWithContext._cont = ____AddEntryResultData_notification__item__valuesWithContext__item_
    ___AddEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AddEntryResultData_notification__item__type),
        ('values', ___AddEntryResultData_notification__item__values),
        ('valuesWithContext', ___AddEntryResultData_notification__item__valuesWithContext),
        ])
    __AddEntryResultData_notification__item_._ext = []
    _AddEntryResultData_notification._cont = __AddEntryResultData_notification__item_
    AddEntryResultData._cont = ASN1Dict([
        ('securityParameters', _AddEntryResultData_securityParameters),
        ('performer', _AddEntryResultData_performer),
        ('aliasDereferenced', _AddEntryResultData_aliasDereferenced),
        ('notification', _AddEntryResultData_notification),
        ])
    AddEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< removeEntry >-----#
    removeEntry = CLASS(name='removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _removeEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    _removeEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    removeEntry._val = dict([('ArgumentType', _removeEntry_val_ArgumentType), ('ResultType', _removeEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))])
    
    #-----< RemoveEntryArgument >-----#
    RemoveEntryArgument = CHOICE(name='RemoveEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RemoveEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    _RemoveEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RemoveEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    __RemoveEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __RemoveEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___RemoveEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __RemoveEntryArgument_signed_algorithmIdentifier._ext = []
    __RemoveEntryArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _RemoveEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __RemoveEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __RemoveEntryArgument_signed_algorithmIdentifier),
        ('encrypted', __RemoveEntryArgument_signed_encrypted),
        ])
    _RemoveEntryArgument_signed._ext = []
    RemoveEntryArgument._cont = ASN1Dict([
        ('unsigned', _RemoveEntryArgument_unsigned),
        ('signed', _RemoveEntryArgument_signed),
        ])
    RemoveEntryArgument._ext = None
    
    #-----< RemoveEntryArgumentData >-----#
    RemoveEntryArgumentData = SET(name='RemoveEntryArgumentData', mode=MODE_TYPE)
    _RemoveEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _RemoveEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _RemoveEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _RemoveEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _RemoveEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _RemoveEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _RemoveEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _RemoveEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    RemoveEntryArgumentData._cont = ASN1Dict([
        ('object', _RemoveEntryArgumentData_object),
        ('serviceControls', _RemoveEntryArgumentData_serviceControls),
        ('securityParameters', _RemoveEntryArgumentData_securityParameters),
        ('requestor', _RemoveEntryArgumentData_requestor),
        ('operationProgress', _RemoveEntryArgumentData_operationProgress),
        ('aliasedRDNs', _RemoveEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _RemoveEntryArgumentData_criticalExtensions),
        ('referenceType', _RemoveEntryArgumentData_referenceType),
        ('entryOnly', _RemoveEntryArgumentData_entryOnly),
        ('exclusions', _RemoveEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _RemoveEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _RemoveEntryArgumentData_operationContexts),
        ('familyGrouping', _RemoveEntryArgumentData_familyGrouping),
        ])
    RemoveEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< RemoveEntryResult >-----#
    RemoveEntryResult = CHOICE(name='RemoveEntryResult', mode=MODE_TYPE)
    _RemoveEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _RemoveEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __RemoveEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    __RemoveEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RemoveEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    ___RemoveEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___RemoveEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RemoveEntryResult_information_signed_algorithmIdentifier._ext = []
    ___RemoveEntryResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __RemoveEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___RemoveEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___RemoveEntryResult_information_signed_algorithmIdentifier),
        ('encrypted', ___RemoveEntryResult_information_signed_encrypted),
        ])
    __RemoveEntryResult_information_signed._ext = []
    _RemoveEntryResult_information._cont = ASN1Dict([
        ('unsigned', __RemoveEntryResult_information_unsigned),
        ('signed', __RemoveEntryResult_information_signed),
        ])
    _RemoveEntryResult_information._ext = None
    RemoveEntryResult._cont = ASN1Dict([
        ('null', _RemoveEntryResult_null),
        ('information', _RemoveEntryResult_information),
        ])
    RemoveEntryResult._ext = []
    
    #-----< RemoveEntryResultData >-----#
    RemoveEntryResultData = SEQ(name='RemoveEntryResultData', mode=MODE_TYPE)
    _RemoveEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RemoveEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RemoveEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____RemoveEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RemoveEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__type._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ___RemoveEntryResultData_notification__item__type._const_tab_at = None
    ___RemoveEntryResultData_notification__item__type._const_tab_id = 'id'
    ___RemoveEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____RemoveEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RemoveEntryResultData_notification__item__values__item_._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___RemoveEntryResultData_notification__item__values._cont = ____RemoveEntryResultData_notification__item__values__item_
    ___RemoveEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____RemoveEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___RemoveEntryResultData_notification__item__valuesWithContext._cont = ____RemoveEntryResultData_notification__item__valuesWithContext__item_
    ___RemoveEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RemoveEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___RemoveEntryResultData_notification__item__type),
        ('values', ___RemoveEntryResultData_notification__item__values),
        ('valuesWithContext', ___RemoveEntryResultData_notification__item__valuesWithContext),
        ])
    __RemoveEntryResultData_notification__item_._ext = []
    _RemoveEntryResultData_notification._cont = __RemoveEntryResultData_notification__item_
    RemoveEntryResultData._cont = ASN1Dict([
        ('securityParameters', _RemoveEntryResultData_securityParameters),
        ('performer', _RemoveEntryResultData_performer),
        ('aliasDereferenced', _RemoveEntryResultData_aliasDereferenced),
        ('notification', _RemoveEntryResultData_notification),
        ])
    RemoveEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< modifyEntry >-----#
    modifyEntry = CLASS(name='modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    _modifyEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    modifyEntry._val = dict([('ArgumentType', _modifyEntry_val_ArgumentType), ('ResultType', _modifyEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))])
    
    #-----< ModifyEntryArgument >-----#
    ModifyEntryArgument = CHOICE(name='ModifyEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyEntryArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    _ModifyEntryArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyEntryArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    __ModifyEntryArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyEntryArgument_signed_algorithmIdentifier._ext = []
    __ModifyEntryArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ModifyEntryArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyEntryArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyEntryArgument_signed_algorithmIdentifier),
        ('encrypted', __ModifyEntryArgument_signed_encrypted),
        ])
    _ModifyEntryArgument_signed._ext = []
    ModifyEntryArgument._cont = ASN1Dict([
        ('unsigned', _ModifyEntryArgument_unsigned),
        ('signed', _ModifyEntryArgument_signed),
        ])
    ModifyEntryArgument._ext = None
    
    #-----< ModifyEntryArgumentData >-----#
    ModifyEntryArgumentData = SET(name='ModifyEntryArgumentData', mode=MODE_TYPE)
    _ModifyEntryArgumentData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ModifyEntryArgumentData_changes = SEQ_OF(name='changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyEntryArgumentData_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    _ModifyEntryArgumentData_changes._cont = __ModifyEntryArgumentData_changes__item_
    _ModifyEntryArgumentData_selection = SET(name='selection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), opt=True)
    _ModifyEntryArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyEntryArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ModifyEntryArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyEntryArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyEntryArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyEntryArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyEntryArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ModifyEntryArgumentData._cont = ASN1Dict([
        ('object', _ModifyEntryArgumentData_object),
        ('changes', _ModifyEntryArgumentData_changes),
        ('selection', _ModifyEntryArgumentData_selection),
        ('serviceControls', _ModifyEntryArgumentData_serviceControls),
        ('securityParameters', _ModifyEntryArgumentData_securityParameters),
        ('requestor', _ModifyEntryArgumentData_requestor),
        ('operationProgress', _ModifyEntryArgumentData_operationProgress),
        ('aliasedRDNs', _ModifyEntryArgumentData_aliasedRDNs),
        ('criticalExtensions', _ModifyEntryArgumentData_criticalExtensions),
        ('referenceType', _ModifyEntryArgumentData_referenceType),
        ('entryOnly', _ModifyEntryArgumentData_entryOnly),
        ('exclusions', _ModifyEntryArgumentData_exclusions),
        ('nameResolveOnMaster', _ModifyEntryArgumentData_nameResolveOnMaster),
        ('operationContexts', _ModifyEntryArgumentData_operationContexts),
        ('familyGrouping', _ModifyEntryArgumentData_familyGrouping),
        ])
    ModifyEntryArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ModifyEntryResult >-----#
    ModifyEntryResult = CHOICE(name='ModifyEntryResult', mode=MODE_TYPE)
    _ModifyEntryResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyEntryResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyEntryResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    __ModifyEntryResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyEntryResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    ___ModifyEntryResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyEntryResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyEntryResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __ModifyEntryResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyEntryResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyEntryResult_information_signed_algorithmIdentifier),
        ('encrypted', ___ModifyEntryResult_information_signed_encrypted),
        ])
    __ModifyEntryResult_information_signed._ext = []
    _ModifyEntryResult_information._cont = ASN1Dict([
        ('unsigned', __ModifyEntryResult_information_unsigned),
        ('signed', __ModifyEntryResult_information_signed),
        ])
    _ModifyEntryResult_information._ext = None
    ModifyEntryResult._cont = ASN1Dict([
        ('null', _ModifyEntryResult_null),
        ('information', _ModifyEntryResult_information),
        ])
    ModifyEntryResult._ext = []
    
    #-----< ModifyEntryResultData >-----#
    ModifyEntryResultData = SEQ(name='ModifyEntryResultData', mode=MODE_TYPE)
    _ModifyEntryResultData_entry = SEQ(name='entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')), opt=True)
    _ModifyEntryResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyEntryResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__type._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ___ModifyEntryResultData_notification__item__type._const_tab_at = None
    ___ModifyEntryResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyEntryResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyEntryResultData_notification__item__values__item_._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyEntryResultData_notification__item__values._cont = ____ModifyEntryResultData_notification__item__values__item_
    ___ModifyEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyEntryResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyEntryResultData_notification__item__valuesWithContext._cont = ____ModifyEntryResultData_notification__item__valuesWithContext__item_
    ___ModifyEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyEntryResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyEntryResultData_notification__item__type),
        ('values', ___ModifyEntryResultData_notification__item__values),
        ('valuesWithContext', ___ModifyEntryResultData_notification__item__valuesWithContext),
        ])
    __ModifyEntryResultData_notification__item_._ext = []
    _ModifyEntryResultData_notification._cont = __ModifyEntryResultData_notification__item_
    ModifyEntryResultData._cont = ASN1Dict([
        ('entry', _ModifyEntryResultData_entry),
        ('securityParameters', _ModifyEntryResultData_securityParameters),
        ('performer', _ModifyEntryResultData_performer),
        ('aliasDereferenced', _ModifyEntryResultData_aliasDereferenced),
        ('notification', _ModifyEntryResultData_notification),
        ])
    ModifyEntryResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< EntryModification >-----#
    EntryModification = CHOICE(name='EntryModification', mode=MODE_TYPE)
    _EntryModification_addAttribute = SEQ(name='addAttribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addAttribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___EntryModification_addAttribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____EntryModification_addAttribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ____EntryModification_addAttribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___EntryModification_addAttribute_type_tab._val = ASN1Set(rv=[dict([('Type', ____EntryModification_addAttribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____EntryModification_addAttribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __EntryModification_addAttribute_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addAttribute_type._const_tab_at = None
    __EntryModification_addAttribute_type._const_tab_id = 'id'
    __EntryModification_addAttribute_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_addAttribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_addAttribute_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addAttribute_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_addAttribute_values__item_._const_tab_id = 'Type'
    __EntryModification_addAttribute_values._cont = ___EntryModification_addAttribute_values__item_
    __EntryModification_addAttribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addAttribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addAttribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addAttribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_addAttribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._cont = _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addAttribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_addAttribute_valuesWithContext__item__value),
        ('contextList', ____EntryModification_addAttribute_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addAttribute_valuesWithContext__item_._ext = []
    __EntryModification_addAttribute_valuesWithContext._cont = ___EntryModification_addAttribute_valuesWithContext__item_
    __EntryModification_addAttribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addAttribute._cont = ASN1Dict([
        ('type', __EntryModification_addAttribute_type),
        ('values', __EntryModification_addAttribute_values),
        ('valuesWithContext', __EntryModification_addAttribute_valuesWithContext),
        ])
    _EntryModification_addAttribute._ext = []
    _EntryModification_removeAttribute = OID(name='removeAttribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_addValues = SEQ(name='addValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_addValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addValues_type._const_tab_at = None
    __EntryModification_addValues_type._const_tab_id = 'id'
    __EntryModification_addValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_addValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_addValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_addValues_values__item_._const_tab_id = 'Type'
    __EntryModification_addValues_values._cont = ___EntryModification_addValues_values__item_
    __EntryModification_addValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_addValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_addValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addValues_valuesWithContext__item__contextList._cont = _____EntryModification_addValues_valuesWithContext__item__contextList__item_
    ____EntryModification_addValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_addValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_addValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addValues_valuesWithContext__item_._ext = []
    __EntryModification_addValues_valuesWithContext._cont = ___EntryModification_addValues_valuesWithContext__item_
    __EntryModification_addValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addValues._cont = ASN1Dict([
        ('type', __EntryModification_addValues_type),
        ('values', __EntryModification_addValues_values),
        ('valuesWithContext', __EntryModification_addValues_valuesWithContext),
        ])
    _EntryModification_addValues._ext = []
    _EntryModification_removeValues = SEQ(name='removeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_removeValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_removeValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_removeValues_type._const_tab_at = None
    __EntryModification_removeValues_type._const_tab_id = 'id'
    __EntryModification_removeValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_removeValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_removeValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_removeValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_removeValues_values__item_._const_tab_id = 'Type'
    __EntryModification_removeValues_values._cont = ___EntryModification_removeValues_values__item_
    __EntryModification_removeValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_removeValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_removeValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_removeValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_removeValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_removeValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_removeValues_valuesWithContext__item__contextList._cont = _____EntryModification_removeValues_valuesWithContext__item__contextList__item_
    ____EntryModification_removeValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_removeValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_removeValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_removeValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_removeValues_valuesWithContext__item_._ext = []
    __EntryModification_removeValues_valuesWithContext._cont = ___EntryModification_removeValues_valuesWithContext__item_
    __EntryModification_removeValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_removeValues._cont = ASN1Dict([
        ('type', __EntryModification_removeValues_type),
        ('values', __EntryModification_removeValues_values),
        ('valuesWithContext', __EntryModification_removeValues_valuesWithContext),
        ])
    _EntryModification_removeValues._ext = []
    _EntryModification_alterValues = SEQ(name='alterValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EntryModification_resetValue = OID(name='resetValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_replaceValues = SEQ(name='replaceValues', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_replaceValues_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __EntryModification_replaceValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_replaceValues_type._const_tab_at = None
    __EntryModification_replaceValues_type._const_tab_id = 'id'
    __EntryModification_replaceValues_values = SET_OF(name='values', mode=MODE_TYPE)
    ___EntryModification_replaceValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___EntryModification_replaceValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_replaceValues_values__item_._const_tab_at = ('..', '..', 'type')
    ___EntryModification_replaceValues_values__item_._const_tab_id = 'Type'
    __EntryModification_replaceValues_values._cont = ___EntryModification_replaceValues_values__item_
    __EntryModification_replaceValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_replaceValues_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_replaceValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_replaceValues_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_id = 'Type'
    ____EntryModification_replaceValues_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._cont = _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_replaceValues_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____EntryModification_replaceValues_valuesWithContext__item__value),
        ('contextList', ____EntryModification_replaceValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_replaceValues_valuesWithContext__item_._ext = []
    __EntryModification_replaceValues_valuesWithContext._cont = ___EntryModification_replaceValues_valuesWithContext__item_
    __EntryModification_replaceValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_replaceValues._cont = ASN1Dict([
        ('type', __EntryModification_replaceValues_type),
        ('values', __EntryModification_replaceValues_values),
        ('valuesWithContext', __EntryModification_replaceValues_valuesWithContext),
        ])
    _EntryModification_replaceValues._ext = []
    EntryModification._cont = ASN1Dict([
        ('addAttribute', _EntryModification_addAttribute),
        ('removeAttribute', _EntryModification_removeAttribute),
        ('addValues', _EntryModification_addValues),
        ('removeValues', _EntryModification_removeValues),
        ('alterValues', _EntryModification_alterValues),
        ('resetValue', _EntryModification_resetValue),
        ('replaceValues', _EntryModification_replaceValues),
        ])
    EntryModification._ext = []
    
    #-----< modifyDN >-----#
    modifyDN = CLASS(name='modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyDN_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    _modifyDN_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    modifyDN._val = dict([('ArgumentType', _modifyDN_val_ArgumentType), ('ResultType', _modifyDN_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))])
    
    #-----< ModifyDNArgument >-----#
    ModifyDNArgument = CHOICE(name='ModifyDNArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyDNArgument_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    _ModifyDNArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyDNArgument_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    __ModifyDNArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyDNArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyDNArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyDNArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyDNArgument_signed_algorithmIdentifier._ext = []
    __ModifyDNArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ModifyDNArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyDNArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyDNArgument_signed_algorithmIdentifier),
        ('encrypted', __ModifyDNArgument_signed_encrypted),
        ])
    _ModifyDNArgument_signed._ext = []
    ModifyDNArgument._cont = ASN1Dict([
        ('unsigned', _ModifyDNArgument_unsigned),
        ('signed', _ModifyDNArgument_signed),
        ])
    ModifyDNArgument._ext = None
    
    #-----< ModifyDNArgumentData >-----#
    ModifyDNArgumentData = SET(name='ModifyDNArgumentData', mode=MODE_TYPE)
    _ModifyDNArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ModifyDNArgumentData_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNArgumentData_deleteOldRDN = BOOL(name='deleteOldRDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_newSuperior = SEQ_OF(name='newSuperior', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyDNArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ModifyDNArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyDNArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyDNArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyDNArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyDNArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    ModifyDNArgumentData._cont = ASN1Dict([
        ('object', _ModifyDNArgumentData_object),
        ('newRDN', _ModifyDNArgumentData_newRDN),
        ('deleteOldRDN', _ModifyDNArgumentData_deleteOldRDN),
        ('newSuperior', _ModifyDNArgumentData_newSuperior),
        ('serviceControls', _ModifyDNArgumentData_serviceControls),
        ('securityParameters', _ModifyDNArgumentData_securityParameters),
        ('requestor', _ModifyDNArgumentData_requestor),
        ('operationProgress', _ModifyDNArgumentData_operationProgress),
        ('aliasedRDNs', _ModifyDNArgumentData_aliasedRDNs),
        ('criticalExtensions', _ModifyDNArgumentData_criticalExtensions),
        ('referenceType', _ModifyDNArgumentData_referenceType),
        ('entryOnly', _ModifyDNArgumentData_entryOnly),
        ('exclusions', _ModifyDNArgumentData_exclusions),
        ('nameResolveOnMaster', _ModifyDNArgumentData_nameResolveOnMaster),
        ('operationContexts', _ModifyDNArgumentData_operationContexts),
        ('familyGrouping', _ModifyDNArgumentData_familyGrouping),
        ])
    ModifyDNArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< ModifyDNResult >-----#
    ModifyDNResult = CHOICE(name='ModifyDNResult', mode=MODE_TYPE)
    _ModifyDNResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyDNResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyDNResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    __ModifyDNResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyDNResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    ___ModifyDNResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyDNResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyDNResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyDNResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyDNResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __ModifyDNResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyDNResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyDNResult_information_signed_algorithmIdentifier),
        ('encrypted', ___ModifyDNResult_information_signed_encrypted),
        ])
    __ModifyDNResult_information_signed._ext = []
    _ModifyDNResult_information._cont = ASN1Dict([
        ('unsigned', __ModifyDNResult_information_unsigned),
        ('signed', __ModifyDNResult_information_signed),
        ])
    _ModifyDNResult_information._ext = None
    ModifyDNResult._cont = ASN1Dict([
        ('null', _ModifyDNResult_null),
        ('information', _ModifyDNResult_information),
        ])
    ModifyDNResult._ext = []
    
    #-----< ModifyDNResultData >-----#
    ModifyDNResultData = SEQ(name='ModifyDNResultData', mode=MODE_TYPE)
    _ModifyDNResultData_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyDNResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyDNResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyDNResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyDNResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyDNResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyDNResultData_notification__item__type._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ___ModifyDNResultData_notification__item__type._const_tab_at = None
    ___ModifyDNResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyDNResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyDNResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyDNResultData_notification__item__values__item_._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ____ModifyDNResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyDNResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyDNResultData_notification__item__values._cont = ____ModifyDNResultData_notification__item__values__item_
    ___ModifyDNResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyDNResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyDNResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyDNResultData_notification__item__type_tab
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyDNResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyDNResultData_notification__item__valuesWithContext._cont = ____ModifyDNResultData_notification__item__valuesWithContext__item_
    ___ModifyDNResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyDNResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyDNResultData_notification__item__type),
        ('values', ___ModifyDNResultData_notification__item__values),
        ('valuesWithContext', ___ModifyDNResultData_notification__item__valuesWithContext),
        ])
    __ModifyDNResultData_notification__item_._ext = []
    _ModifyDNResultData_notification._cont = __ModifyDNResultData_notification__item_
    ModifyDNResultData._cont = ASN1Dict([
        ('newRDN', _ModifyDNResultData_newRDN),
        ('securityParameters', _ModifyDNResultData_securityParameters),
        ('performer', _ModifyDNResultData_performer),
        ('aliasDereferenced', _ModifyDNResultData_aliasDereferenced),
        ('notification', _ModifyDNResultData_notification),
        ])
    ModifyDNResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< changePassword >-----#
    changePassword = CLASS(name='changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _changePassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    _changePassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    changePassword._val = dict([('ArgumentType', _changePassword_val_ArgumentType), ('ResultType', _changePassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])
    
    #-----< ChangePasswordArgument >-----#
    ChangePasswordArgument = CHOICE(name='ChangePasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ChangePasswordArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    _ChangePasswordArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ChangePasswordArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    __ChangePasswordArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ChangePasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ChangePasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __ChangePasswordArgument_signed_algorithmIdentifier._ext = []
    __ChangePasswordArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ChangePasswordArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ChangePasswordArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ChangePasswordArgument_signed_algorithmIdentifier),
        ('encrypted', __ChangePasswordArgument_signed_encrypted),
        ])
    _ChangePasswordArgument_signed._ext = []
    ChangePasswordArgument._cont = ASN1Dict([
        ('unsigned', _ChangePasswordArgument_unsigned),
        ('signed', _ChangePasswordArgument_signed),
        ])
    ChangePasswordArgument._ext = None
    
    #-----< ChangePasswordArgumentData >-----#
    ChangePasswordArgumentData = SEQ(name='ChangePasswordArgumentData', mode=MODE_TYPE)
    _ChangePasswordArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ChangePasswordArgumentData_oldPwd = CHOICE(name='oldPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    _ChangePasswordArgumentData_newPwd = CHOICE(name='newPwd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    ChangePasswordArgumentData._cont = ASN1Dict([
        ('object', _ChangePasswordArgumentData_object),
        ('oldPwd', _ChangePasswordArgumentData_oldPwd),
        ('newPwd', _ChangePasswordArgumentData_newPwd),
        ])
    ChangePasswordArgumentData._ext = []
    
    #-----< ChangePasswordResult >-----#
    ChangePasswordResult = CHOICE(name='ChangePasswordResult', mode=MODE_TYPE)
    _ChangePasswordResult_null = NULL(name='null', mode=MODE_TYPE)
    _ChangePasswordResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ChangePasswordResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    __ChangePasswordResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ChangePasswordResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    ___ChangePasswordResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ChangePasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ChangePasswordResult_information_signed_algorithmIdentifier._ext = []
    ___ChangePasswordResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __ChangePasswordResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___ChangePasswordResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___ChangePasswordResult_information_signed_algorithmIdentifier),
        ('encrypted', ___ChangePasswordResult_information_signed_encrypted),
        ])
    __ChangePasswordResult_information_signed._ext = []
    _ChangePasswordResult_information._cont = ASN1Dict([
        ('unsigned', __ChangePasswordResult_information_unsigned),
        ('signed', __ChangePasswordResult_information_signed),
        ])
    _ChangePasswordResult_information._ext = None
    ChangePasswordResult._cont = ASN1Dict([
        ('null', _ChangePasswordResult_null),
        ('information', _ChangePasswordResult_information),
        ])
    ChangePasswordResult._ext = []
    
    #-----< ChangePasswordResultData >-----#
    ChangePasswordResultData = SEQ(name='ChangePasswordResultData', mode=MODE_TYPE)
    _ChangePasswordResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ChangePasswordResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChangePasswordResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChangePasswordResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChangePasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ChangePasswordResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ChangePasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ChangePasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__type._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ___ChangePasswordResultData_notification__item__type._const_tab_at = None
    ___ChangePasswordResultData_notification__item__type._const_tab_id = 'id'
    ___ChangePasswordResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ChangePasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ChangePasswordResultData_notification__item__values__item_._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ChangePasswordResultData_notification__item__values._cont = ____ChangePasswordResultData_notification__item__values__item_
    ___ChangePasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ChangePasswordResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___ChangePasswordResultData_notification__item__valuesWithContext._cont = ____ChangePasswordResultData_notification__item__valuesWithContext__item_
    ___ChangePasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ChangePasswordResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ChangePasswordResultData_notification__item__type),
        ('values', ___ChangePasswordResultData_notification__item__values),
        ('valuesWithContext', ___ChangePasswordResultData_notification__item__valuesWithContext),
        ])
    __ChangePasswordResultData_notification__item_._ext = []
    _ChangePasswordResultData_notification._cont = __ChangePasswordResultData_notification__item_
    ChangePasswordResultData._cont = ASN1Dict([
        ('securityParameters', _ChangePasswordResultData_securityParameters),
        ('performer', _ChangePasswordResultData_performer),
        ('aliasDereferenced', _ChangePasswordResultData_aliasDereferenced),
        ('notification', _ChangePasswordResultData_notification),
        ])
    ChangePasswordResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< administerPassword >-----#
    administerPassword = CLASS(name='administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _administerPassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    _administerPassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    administerPassword._val = dict([('ArgumentType', _administerPassword_val_ArgumentType), ('ResultType', _administerPassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))])
    
    #-----< AdministerPasswordArgument >-----#
    AdministerPasswordArgument = CHOICE(name='AdministerPasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AdministerPasswordArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    _AdministerPasswordArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AdministerPasswordArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    __AdministerPasswordArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __AdministerPasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __AdministerPasswordArgument_signed_algorithmIdentifier._ext = []
    __AdministerPasswordArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _AdministerPasswordArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __AdministerPasswordArgument_signed_toBeSigned),
        ('algorithmIdentifier', __AdministerPasswordArgument_signed_algorithmIdentifier),
        ('encrypted', __AdministerPasswordArgument_signed_encrypted),
        ])
    _AdministerPasswordArgument_signed._ext = []
    AdministerPasswordArgument._cont = ASN1Dict([
        ('unsigned', _AdministerPasswordArgument_unsigned),
        ('signed', _AdministerPasswordArgument_signed),
        ])
    AdministerPasswordArgument._ext = None
    
    #-----< AdministerPasswordArgumentData >-----#
    AdministerPasswordArgumentData = SEQ(name='AdministerPasswordArgumentData', mode=MODE_TYPE)
    _AdministerPasswordArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AdministerPasswordArgumentData_newPwd = CHOICE(name='newPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'UserPwd')))
    AdministerPasswordArgumentData._cont = ASN1Dict([
        ('object', _AdministerPasswordArgumentData_object),
        ('newPwd', _AdministerPasswordArgumentData_newPwd),
        ])
    AdministerPasswordArgumentData._ext = []
    
    #-----< AdministerPasswordResult >-----#
    AdministerPasswordResult = CHOICE(name='AdministerPasswordResult', mode=MODE_TYPE)
    _AdministerPasswordResult_null = NULL(name='null', mode=MODE_TYPE)
    _AdministerPasswordResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AdministerPasswordResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    __AdministerPasswordResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AdministerPasswordResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    ___AdministerPasswordResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._ext = []
    ___AdministerPasswordResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __AdministerPasswordResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___AdministerPasswordResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___AdministerPasswordResult_information_signed_algorithmIdentifier),
        ('encrypted', ___AdministerPasswordResult_information_signed_encrypted),
        ])
    __AdministerPasswordResult_information_signed._ext = []
    _AdministerPasswordResult_information._cont = ASN1Dict([
        ('unsigned', __AdministerPasswordResult_information_unsigned),
        ('signed', __AdministerPasswordResult_information_signed),
        ])
    _AdministerPasswordResult_information._ext = None
    AdministerPasswordResult._cont = ASN1Dict([
        ('null', _AdministerPasswordResult_null),
        ('information', _AdministerPasswordResult_information),
        ])
    AdministerPasswordResult._ext = []
    
    #-----< AdministerPasswordResultData >-----#
    AdministerPasswordResultData = SEQ(name='AdministerPasswordResultData', mode=MODE_TYPE)
    _AdministerPasswordResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AdministerPasswordResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AdministerPasswordResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AdministerPasswordResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AdministerPasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AdministerPasswordResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AdministerPasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AdministerPasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__type._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ___AdministerPasswordResultData_notification__item__type._const_tab_at = None
    ___AdministerPasswordResultData_notification__item__type._const_tab_id = 'id'
    ___AdministerPasswordResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AdministerPasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___AdministerPasswordResultData_notification__item__values._cont = ____AdministerPasswordResultData_notification__item__values__item_
    ___AdministerPasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___AdministerPasswordResultData_notification__item__valuesWithContext._cont = ____AdministerPasswordResultData_notification__item__valuesWithContext__item_
    ___AdministerPasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AdministerPasswordResultData_notification__item_._cont = ASN1Dict([
        ('type', ___AdministerPasswordResultData_notification__item__type),
        ('values', ___AdministerPasswordResultData_notification__item__values),
        ('valuesWithContext', ___AdministerPasswordResultData_notification__item__valuesWithContext),
        ])
    __AdministerPasswordResultData_notification__item_._ext = []
    _AdministerPasswordResultData_notification._cont = __AdministerPasswordResultData_notification__item_
    AdministerPasswordResultData._cont = ASN1Dict([
        ('securityParameters', _AdministerPasswordResultData_securityParameters),
        ('performer', _AdministerPasswordResultData_performer),
        ('aliasDereferenced', _AdministerPasswordResultData_aliasDereferenced),
        ('notification', _AdministerPasswordResultData_notification),
        ])
    AdministerPasswordResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ldapTransport >-----#
    ldapTransport = CLASS(name='ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _ldapTransport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    _ldapTransport_val_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE)
    __ldapTransport_val_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _ldapTransport_val_ResultType._cont = __ldapTransport_val_ResultType__item_
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    ldapTransport._val = dict([('ArgumentType', _ldapTransport_val_ArgumentType), ('ResultType', _ldapTransport_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))])
    
    #-----< LdapArgument >-----#
    LdapArgument = CHOICE(name='LdapArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    _LdapArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    __LdapArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LdapArgument_signed_algorithmIdentifier_algorithm_tab
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LdapArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab = ____LdapArgument_signed_algorithmIdentifier_parameters_tab
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LdapArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LdapArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LdapArgument_signed_algorithmIdentifier_parameters),
        ])
    __LdapArgument_signed_algorithmIdentifier._ext = []
    __LdapArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _LdapArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __LdapArgument_signed_toBeSigned),
        ('algorithmIdentifier', __LdapArgument_signed_algorithmIdentifier),
        ('encrypted', __LdapArgument_signed_encrypted),
        ])
    _LdapArgument_signed._ext = []
    LdapArgument._cont = ASN1Dict([
        ('unsigned', _LdapArgument_unsigned),
        ('signed', _LdapArgument_signed),
        ])
    LdapArgument._ext = None
    
    #-----< LdapArgumentData >-----#
    LdapArgumentData = SEQ(name='LdapArgumentData', mode=MODE_TYPE)
    _LdapArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LdapArgumentData_ldapMessage = SEQ(name='ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapArgumentData_linkId = INT(name='linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')), opt=True)
    _LdapArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LdapArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _LdapArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LdapArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LdapArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LdapArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LdapArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    LdapArgumentData._cont = ASN1Dict([
        ('object', _LdapArgumentData_object),
        ('ldapMessage', _LdapArgumentData_ldapMessage),
        ('linkId', _LdapArgumentData_linkId),
        ('serviceControls', _LdapArgumentData_serviceControls),
        ('securityParameters', _LdapArgumentData_securityParameters),
        ('requestor', _LdapArgumentData_requestor),
        ('operationProgress', _LdapArgumentData_operationProgress),
        ('aliasedRDNs', _LdapArgumentData_aliasedRDNs),
        ('criticalExtensions', _LdapArgumentData_criticalExtensions),
        ('referenceType', _LdapArgumentData_referenceType),
        ('entryOnly', _LdapArgumentData_entryOnly),
        ('exclusions', _LdapArgumentData_exclusions),
        ('nameResolveOnMaster', _LdapArgumentData_nameResolveOnMaster),
        ('operationContexts', _LdapArgumentData_operationContexts),
        ('familyGrouping', _LdapArgumentData_familyGrouping),
        ])
    LdapArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< LinkId >-----#
    LinkId = INT(name='LinkId', mode=MODE_TYPE)
    
    #-----< LdapResult >-----#
    LdapResult = CHOICE(name='LdapResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapResult_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    _LdapResult_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapResult_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    __LdapResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab = ____LdapResult_signed_algorithmIdentifier_algorithm_tab
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LdapResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LdapResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab = ____LdapResult_signed_algorithmIdentifier_parameters_tab
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LdapResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LdapResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LdapResult_signed_algorithmIdentifier_parameters),
        ])
    __LdapResult_signed_algorithmIdentifier._ext = []
    __LdapResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _LdapResult_signed._cont = ASN1Dict([
        ('toBeSigned', __LdapResult_signed_toBeSigned),
        ('algorithmIdentifier', __LdapResult_signed_algorithmIdentifier),
        ('encrypted', __LdapResult_signed_encrypted),
        ])
    _LdapResult_signed._ext = []
    LdapResult._cont = ASN1Dict([
        ('unsigned', _LdapResult_unsigned),
        ('signed', _LdapResult_signed),
        ])
    LdapResult._ext = None
    
    #-----< LdapResultData >-----#
    LdapResultData = SEQ(name='LdapResultData', mode=MODE_TYPE)
    _LdapResultData_ldapMessages = SEQ_OF(name='ldapMessages', mode=MODE_TYPE, opt=True)
    __LdapResultData_ldapMessages__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapResultData_ldapMessages._cont = __LdapResultData_ldapMessages__item_
    _LdapResultData_ldapMessages._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _LdapResultData_returnToClient = BOOL(name='returnToClient', mode=MODE_TYPE, default=False)
    _LdapResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __LdapResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___LdapResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____LdapResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____LdapResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____LdapResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____LdapResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____LdapResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____LdapResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___LdapResultData_notification__item__type._const_tab = ____LdapResultData_notification__item__type_tab
    ___LdapResultData_notification__item__type._const_tab_at = None
    ___LdapResultData_notification__item__type._const_tab_id = 'id'
    ___LdapResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____LdapResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____LdapResultData_notification__item__values__item_._const_tab = ____LdapResultData_notification__item__type_tab
    ____LdapResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____LdapResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___LdapResultData_notification__item__values._cont = ____LdapResultData_notification__item__values__item_
    ___LdapResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___LdapResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____LdapResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____LdapResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab = ____LdapResultData_notification__item__type_tab
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____LdapResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._cont = ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____LdapResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____LdapResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____LdapResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____LdapResultData_notification__item__valuesWithContext__item_._ext = []
    ___LdapResultData_notification__item__valuesWithContext._cont = ____LdapResultData_notification__item__valuesWithContext__item_
    ___LdapResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __LdapResultData_notification__item_._cont = ASN1Dict([
        ('type', ___LdapResultData_notification__item__type),
        ('values', ___LdapResultData_notification__item__values),
        ('valuesWithContext', ___LdapResultData_notification__item__valuesWithContext),
        ])
    __LdapResultData_notification__item_._ext = []
    _LdapResultData_notification._cont = __LdapResultData_notification__item_
    LdapResultData._cont = ASN1Dict([
        ('ldapMessages', _LdapResultData_ldapMessages),
        ('returnToClient', _LdapResultData_returnToClient),
        ('securityParameters', _LdapResultData_securityParameters),
        ('performer', _LdapResultData_performer),
        ('aliasDereferenced', _LdapResultData_aliasDereferenced),
        ('notification', _LdapResultData_notification),
        ])
    LdapResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< linkedLDAP >-----#
    linkedLDAP = CLASS(name='linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _linkedLDAP_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    _linkedLDAP_val_ResultType = NULL(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    linkedLDAP._val = dict([('ArgumentType', _linkedLDAP_val_ArgumentType), ('ResultType', _linkedLDAP_val_ResultType), ('operationCode', ('local', 13))])
    
    #-----< LinkedArgument >-----#
    LinkedArgument = CHOICE(name='LinkedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LinkedArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    _LinkedArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LinkedArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    __LinkedArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LinkedArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___LinkedArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab = ____LinkedArgument_signed_algorithmIdentifier_parameters_tab
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __LinkedArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___LinkedArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___LinkedArgument_signed_algorithmIdentifier_parameters),
        ])
    __LinkedArgument_signed_algorithmIdentifier._ext = []
    __LinkedArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _LinkedArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __LinkedArgument_signed_toBeSigned),
        ('algorithmIdentifier', __LinkedArgument_signed_algorithmIdentifier),
        ('encrypted', __LinkedArgument_signed_encrypted),
        ])
    _LinkedArgument_signed._ext = []
    LinkedArgument._cont = ASN1Dict([
        ('unsigned', _LinkedArgument_unsigned),
        ('signed', _LinkedArgument_signed),
        ])
    LinkedArgument._ext = None
    
    #-----< LinkedArgumentData >-----#
    LinkedArgumentData = SEQ(name='LinkedArgumentData', mode=MODE_TYPE)
    _LinkedArgumentData_object = SEQ_OF(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LinkedArgumentData_ldapMessage = SEQ(name='ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LinkedArgumentData_linkId = INT(name='linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')))
    _LinkedArgumentData_returnToClient = BOOL(name='returnToClient', mode=MODE_TYPE, default=False)
    _LinkedArgumentData_serviceControls = SET(name='serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LinkedArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LinkedArgumentData_requestor = SEQ_OF(name='requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LinkedArgumentData_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _LinkedArgumentData_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_criticalExtensions = BIT_STR(name='criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LinkedArgumentData_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LinkedArgumentData_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LinkedArgumentData_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LinkedArgumentData_operationContexts = CHOICE(name='operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LinkedArgumentData_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default='entryOnly')
    LinkedArgumentData._cont = ASN1Dict([
        ('object', _LinkedArgumentData_object),
        ('ldapMessage', _LinkedArgumentData_ldapMessage),
        ('linkId', _LinkedArgumentData_linkId),
        ('returnToClient', _LinkedArgumentData_returnToClient),
        ('serviceControls', _LinkedArgumentData_serviceControls),
        ('securityParameters', _LinkedArgumentData_securityParameters),
        ('requestor', _LinkedArgumentData_requestor),
        ('operationProgress', _LinkedArgumentData_operationProgress),
        ('aliasedRDNs', _LinkedArgumentData_aliasedRDNs),
        ('criticalExtensions', _LinkedArgumentData_criticalExtensions),
        ('referenceType', _LinkedArgumentData_referenceType),
        ('entryOnly', _LinkedArgumentData_entryOnly),
        ('exclusions', _LinkedArgumentData_exclusions),
        ('nameResolveOnMaster', _LinkedArgumentData_nameResolveOnMaster),
        ('operationContexts', _LinkedArgumentData_operationContexts),
        ('familyGrouping', _LinkedArgumentData_familyGrouping),
        ])
    LinkedArgumentData._ext = ['serviceControls', 'securityParameters', 'requestor', 'operationProgress', 'aliasedRDNs', 'criticalExtensions', 'referenceType', 'entryOnly', 'exclusions', 'nameResolveOnMaster', 'operationContexts', 'familyGrouping']
    
    #-----< LinkedResult >-----#
    LinkedResult = NULL(name='LinkedResult', mode=MODE_TYPE)
    
    #-----< abandoned >-----#
    abandoned = CLASS(name='abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandoned_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandoned_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    __abandoned_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandoned_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___abandoned_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandoned_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __abandoned_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___abandoned_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___abandoned_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___abandoned_val_ParameterType_signed_encrypted),
        ])
    __abandoned_val_ParameterType_signed._ext = []
    _abandoned_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __abandoned_val_ParameterType_unsigned),
        ('signed', __abandoned_val_ParameterType_signed),
        ])
    _abandoned_val_ParameterType._ext = None
    abandoned._val = dict([('ParameterType', _abandoned_val_ParameterType), ('errorCode', ('local', 5))])
    
    #-----< AbandonedData >-----#
    AbandonedData = SET(name='AbandonedData', mode=MODE_TYPE)
    _AbandonedData_problem = ENUM(name='problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedProblem')), opt=True)
    _AbandonedData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonedData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonedData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonedData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonedData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonedData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonedData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonedData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonedData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonedData_notification__item__type._const_tab = ____AbandonedData_notification__item__type_tab
    ___AbandonedData_notification__item__type._const_tab_at = None
    ___AbandonedData_notification__item__type._const_tab_id = 'id'
    ___AbandonedData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonedData_notification__item__values__item_._const_tab = ____AbandonedData_notification__item__type_tab
    ____AbandonedData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonedData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonedData_notification__item__values._cont = ____AbandonedData_notification__item__values__item_
    ___AbandonedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonedData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonedData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonedData_notification__item__type_tab
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonedData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonedData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonedData_notification__item__valuesWithContext._cont = ____AbandonedData_notification__item__valuesWithContext__item_
    ___AbandonedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonedData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonedData_notification__item__type),
        ('values', ___AbandonedData_notification__item__values),
        ('valuesWithContext', ___AbandonedData_notification__item__valuesWithContext),
        ])
    __AbandonedData_notification__item_._ext = []
    _AbandonedData_notification._cont = __AbandonedData_notification__item_
    AbandonedData._cont = ASN1Dict([
        ('problem', _AbandonedData_problem),
        ('securityParameters', _AbandonedData_securityParameters),
        ('performer', _AbandonedData_performer),
        ('aliasDereferenced', _AbandonedData_aliasDereferenced),
        ('notification', _AbandonedData_notification),
        ])
    AbandonedData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AbandonedProblem >-----#
    AbandonedProblem = ENUM(name='AbandonedProblem', mode=MODE_TYPE)
    AbandonedProblem._cont = ASN1Dict([('pagingAbandoned', 0)])
    AbandonedProblem._ext = None
    
    #-----< abandonFailed >-----#
    abandonFailed = CLASS(name='abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandonFailed_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandonFailed_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    __abandonFailed_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandonFailed_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandonFailed_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __abandonFailed_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___abandonFailed_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___abandonFailed_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___abandonFailed_val_ParameterType_signed_encrypted),
        ])
    __abandonFailed_val_ParameterType_signed._ext = []
    _abandonFailed_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __abandonFailed_val_ParameterType_unsigned),
        ('signed', __abandonFailed_val_ParameterType_signed),
        ])
    _abandonFailed_val_ParameterType._ext = None
    abandonFailed._val = dict([('ParameterType', _abandonFailed_val_ParameterType), ('errorCode', ('local', 7))])
    
    #-----< AbandonFailedData >-----#
    AbandonFailedData = SET(name='AbandonFailedData', mode=MODE_TYPE)
    _AbandonFailedData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonProblem')))
    _AbandonFailedData_operation = CHOICE(name='operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonFailedData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonFailedData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonFailedData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonFailedData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonFailedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonFailedData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AbandonFailedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonFailedData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonFailedData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AbandonFailedData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AbandonFailedData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonFailedData_notification__item__type._const_tab = ____AbandonFailedData_notification__item__type_tab
    ___AbandonFailedData_notification__item__type._const_tab_at = None
    ___AbandonFailedData_notification__item__type._const_tab_id = 'id'
    ___AbandonFailedData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AbandonFailedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AbandonFailedData_notification__item__values__item_._const_tab = ____AbandonFailedData_notification__item__type_tab
    ____AbandonFailedData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AbandonFailedData_notification__item__values__item_._const_tab_id = 'Type'
    ___AbandonFailedData_notification__item__values._cont = ____AbandonFailedData_notification__item__values__item_
    ___AbandonFailedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonFailedData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonFailedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonFailedData_notification__item__type_tab
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AbandonFailedData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AbandonFailedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonFailedData_notification__item__valuesWithContext._cont = ____AbandonFailedData_notification__item__valuesWithContext__item_
    ___AbandonFailedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonFailedData_notification__item_._cont = ASN1Dict([
        ('type', ___AbandonFailedData_notification__item__type),
        ('values', ___AbandonFailedData_notification__item__values),
        ('valuesWithContext', ___AbandonFailedData_notification__item__valuesWithContext),
        ])
    __AbandonFailedData_notification__item_._ext = []
    _AbandonFailedData_notification._cont = __AbandonFailedData_notification__item_
    AbandonFailedData._cont = ASN1Dict([
        ('problem', _AbandonFailedData_problem),
        ('operation', _AbandonFailedData_operation),
        ('securityParameters', _AbandonFailedData_securityParameters),
        ('performer', _AbandonFailedData_performer),
        ('aliasDereferenced', _AbandonFailedData_aliasDereferenced),
        ('notification', _AbandonFailedData_notification),
        ])
    AbandonFailedData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AbandonProblem >-----#
    AbandonProblem = INT(name='AbandonProblem', mode=MODE_TYPE)
    AbandonProblem._cont = ASN1Dict([('noSuchOperation', 1), ('tooLate', 2), ('cannotAbandon', 3)])
    
    #-----< attributeError >-----#
    attributeError = CLASS(name='attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _attributeError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __attributeError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    __attributeError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___attributeError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___attributeError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___attributeError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __attributeError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___attributeError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___attributeError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___attributeError_val_ParameterType_signed_encrypted),
        ])
    __attributeError_val_ParameterType_signed._ext = []
    _attributeError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __attributeError_val_ParameterType_unsigned),
        ('signed', __attributeError_val_ParameterType_signed),
        ])
    _attributeError_val_ParameterType._ext = None
    attributeError._val = dict([('ParameterType', _attributeError_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< AttributeErrorData >-----#
    AttributeErrorData = SET(name='AttributeErrorData', mode=MODE_TYPE)
    _AttributeErrorData_object = CHOICE(name='object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AttributeErrorData_problems = SET_OF(name='problems', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeErrorData_problems__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___AttributeErrorData_problems__item__problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeProblem')))
    ___AttributeErrorData_problems__item__type = OID(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeErrorData_problems__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValue')), opt=True)
    __AttributeErrorData_problems__item_._cont = ASN1Dict([
        ('problem', ___AttributeErrorData_problems__item__problem),
        ('type', ___AttributeErrorData_problems__item__type),
        ('value', ___AttributeErrorData_problems__item__value),
        ])
    __AttributeErrorData_problems__item_._ext = []
    _AttributeErrorData_problems._cont = __AttributeErrorData_problems__item_
    _AttributeErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AttributeErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AttributeErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AttributeErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AttributeErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____AttributeErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AttributeErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AttributeErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AttributeErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____AttributeErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AttributeErrorData_notification__item__type._const_tab = ____AttributeErrorData_notification__item__type_tab
    ___AttributeErrorData_notification__item__type._const_tab_at = None
    ___AttributeErrorData_notification__item__type._const_tab_id = 'id'
    ___AttributeErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AttributeErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____AttributeErrorData_notification__item__values__item_._const_tab = ____AttributeErrorData_notification__item__type_tab
    ____AttributeErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AttributeErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___AttributeErrorData_notification__item__values._cont = ____AttributeErrorData_notification__item__values__item_
    ___AttributeErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AttributeErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AttributeErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab = ____AttributeErrorData_notification__item__type_tab
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._cont = ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____AttributeErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____AttributeErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._ext = []
    ___AttributeErrorData_notification__item__valuesWithContext._cont = ____AttributeErrorData_notification__item__valuesWithContext__item_
    ___AttributeErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___AttributeErrorData_notification__item__type),
        ('values', ___AttributeErrorData_notification__item__values),
        ('valuesWithContext', ___AttributeErrorData_notification__item__valuesWithContext),
        ])
    __AttributeErrorData_notification__item_._ext = []
    _AttributeErrorData_notification._cont = __AttributeErrorData_notification__item_
    AttributeErrorData._cont = ASN1Dict([
        ('object', _AttributeErrorData_object),
        ('problems', _AttributeErrorData_problems),
        ('securityParameters', _AttributeErrorData_securityParameters),
        ('performer', _AttributeErrorData_performer),
        ('aliasDereferenced', _AttributeErrorData_aliasDereferenced),
        ('notification', _AttributeErrorData_notification),
        ])
    AttributeErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< AttributeProblem >-----#
    AttributeProblem = INT(name='AttributeProblem', mode=MODE_TYPE)
    AttributeProblem._cont = ASN1Dict([('noSuchAttributeOrValue', 1), ('invalidAttributeSyntax', 2), ('undefinedAttributeType', 3), ('inappropriateMatching', 4), ('constraintViolation', 5), ('attributeOrValueAlreadyExists', 6), ('contextViolation', 7)])
    
    #-----< nameError >-----#
    nameError = CLASS(name='nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _nameError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __nameError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    __nameError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___nameError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___nameError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___nameError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___nameError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___nameError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __nameError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___nameError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___nameError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___nameError_val_ParameterType_signed_encrypted),
        ])
    __nameError_val_ParameterType_signed._ext = []
    _nameError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __nameError_val_ParameterType_unsigned),
        ('signed', __nameError_val_ParameterType_signed),
        ])
    _nameError_val_ParameterType._ext = None
    nameError._val = dict([('ParameterType', _nameError_val_ParameterType), ('errorCode', ('local', 2))])
    
    #-----< NameErrorData >-----#
    NameErrorData = SET(name='NameErrorData', mode=MODE_TYPE)
    _NameErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'NameProblem')))
    _NameErrorData_matched = CHOICE(name='matched', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _NameErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _NameErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _NameErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _NameErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NameErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___NameErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____NameErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____NameErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____NameErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____NameErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____NameErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____NameErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___NameErrorData_notification__item__type._const_tab = ____NameErrorData_notification__item__type_tab
    ___NameErrorData_notification__item__type._const_tab_at = None
    ___NameErrorData_notification__item__type._const_tab_id = 'id'
    ___NameErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____NameErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____NameErrorData_notification__item__values__item_._const_tab = ____NameErrorData_notification__item__type_tab
    ____NameErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____NameErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___NameErrorData_notification__item__values._cont = ____NameErrorData_notification__item__values__item_
    ___NameErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___NameErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____NameErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____NameErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab = ____NameErrorData_notification__item__type_tab
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____NameErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._cont = ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____NameErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____NameErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____NameErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____NameErrorData_notification__item__valuesWithContext__item_._ext = []
    ___NameErrorData_notification__item__valuesWithContext._cont = ____NameErrorData_notification__item__valuesWithContext__item_
    ___NameErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __NameErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___NameErrorData_notification__item__type),
        ('values', ___NameErrorData_notification__item__values),
        ('valuesWithContext', ___NameErrorData_notification__item__valuesWithContext),
        ])
    __NameErrorData_notification__item_._ext = []
    _NameErrorData_notification._cont = __NameErrorData_notification__item_
    NameErrorData._cont = ASN1Dict([
        ('problem', _NameErrorData_problem),
        ('matched', _NameErrorData_matched),
        ('securityParameters', _NameErrorData_securityParameters),
        ('performer', _NameErrorData_performer),
        ('aliasDereferenced', _NameErrorData_aliasDereferenced),
        ('notification', _NameErrorData_notification),
        ])
    NameErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< NameProblem >-----#
    NameProblem = INT(name='NameProblem', mode=MODE_TYPE)
    NameProblem._cont = ASN1Dict([('noSuchObject', 1), ('aliasProblem', 2), ('invalidAttributeSyntax', 3), ('aliasDereferencingProblem', 4)])
    
    #-----< referral >-----#
    referral = CLASS(name='referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _referral_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __referral_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    __referral_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___referral_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___referral_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___referral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____referral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___referral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___referral_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __referral_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___referral_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___referral_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___referral_val_ParameterType_signed_encrypted),
        ])
    __referral_val_ParameterType_signed._ext = []
    _referral_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __referral_val_ParameterType_unsigned),
        ('signed', __referral_val_ParameterType_signed),
        ])
    _referral_val_ParameterType._ext = None
    referral._val = dict([('ParameterType', _referral_val_ParameterType), ('errorCode', ('local', 4))])
    
    #-----< ReferralData >-----#
    ReferralData = SET(name='ReferralData', mode=MODE_TYPE)
    _ReferralData_candidate = SET(name='candidate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _ReferralData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReferralData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReferralData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReferralData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReferralData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReferralData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ReferralData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ReferralData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReferralData_notification__item__type._const_tab = ____ReferralData_notification__item__type_tab
    ___ReferralData_notification__item__type._const_tab_at = None
    ___ReferralData_notification__item__type._const_tab_id = 'id'
    ___ReferralData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ReferralData_notification__item__values__item_._const_tab = ____ReferralData_notification__item__type_tab
    ____ReferralData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ReferralData_notification__item__values__item_._const_tab_id = 'Type'
    ___ReferralData_notification__item__values._cont = ____ReferralData_notification__item__values__item_
    ___ReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReferralData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReferralData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab = ____ReferralData_notification__item__type_tab
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReferralData_notification__item__valuesWithContext__item__contextList._cont = ______ReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____ReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ReferralData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReferralData_notification__item__valuesWithContext__item_._ext = []
    ___ReferralData_notification__item__valuesWithContext._cont = ____ReferralData_notification__item__valuesWithContext__item_
    ___ReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReferralData_notification__item_._cont = ASN1Dict([
        ('type', ___ReferralData_notification__item__type),
        ('values', ___ReferralData_notification__item__values),
        ('valuesWithContext', ___ReferralData_notification__item__valuesWithContext),
        ])
    __ReferralData_notification__item_._ext = []
    _ReferralData_notification._cont = __ReferralData_notification__item_
    ReferralData._cont = ASN1Dict([
        ('candidate', _ReferralData_candidate),
        ('securityParameters', _ReferralData_securityParameters),
        ('performer', _ReferralData_performer),
        ('aliasDereferenced', _ReferralData_aliasDereferenced),
        ('notification', _ReferralData_notification),
        ])
    ReferralData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< securityError >-----#
    securityError = CLASS(name='securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _securityError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __securityError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    __securityError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___securityError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___securityError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___securityError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___securityError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___securityError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __securityError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___securityError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___securityError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___securityError_val_ParameterType_signed_encrypted),
        ])
    __securityError_val_ParameterType_signed._ext = []
    _securityError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __securityError_val_ParameterType_unsigned),
        ('signed', __securityError_val_ParameterType_signed),
        ])
    _securityError_val_ParameterType._ext = None
    securityError._val = dict([('ParameterType', _securityError_val_ParameterType), ('errorCode', ('local', 6))])
    
    #-----< SecurityErrorData >-----#
    SecurityErrorData = SET(name='SecurityErrorData', mode=MODE_TYPE)
    _SecurityErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _SecurityErrorData_spkmInfo = SEQ(name='spkmInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')), opt=True)
    _SecurityErrorData_encPwdInfo = SEQ(name='encPwdInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EncPwdInfo')), opt=True)
    _SecurityErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SecurityErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SecurityErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SecurityErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SecurityErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SecurityErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SecurityErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SecurityErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SecurityErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SecurityErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SecurityErrorData_notification__item__type._const_tab = ____SecurityErrorData_notification__item__type_tab
    ___SecurityErrorData_notification__item__type._const_tab_at = None
    ___SecurityErrorData_notification__item__type._const_tab_id = 'id'
    ___SecurityErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SecurityErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SecurityErrorData_notification__item__values__item_._const_tab = ____SecurityErrorData_notification__item__type_tab
    ____SecurityErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SecurityErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___SecurityErrorData_notification__item__values._cont = ____SecurityErrorData_notification__item__values__item_
    ___SecurityErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SecurityErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SecurityErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab = ____SecurityErrorData_notification__item__type_tab
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._cont = ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SecurityErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____SecurityErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._ext = []
    ___SecurityErrorData_notification__item__valuesWithContext._cont = ____SecurityErrorData_notification__item__valuesWithContext__item_
    ___SecurityErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SecurityErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___SecurityErrorData_notification__item__type),
        ('values', ___SecurityErrorData_notification__item__values),
        ('valuesWithContext', ___SecurityErrorData_notification__item__valuesWithContext),
        ])
    __SecurityErrorData_notification__item_._ext = []
    _SecurityErrorData_notification._cont = __SecurityErrorData_notification__item_
    SecurityErrorData._cont = ASN1Dict([
        ('problem', _SecurityErrorData_problem),
        ('spkmInfo', _SecurityErrorData_spkmInfo),
        ('encPwdInfo', _SecurityErrorData_encPwdInfo),
        ('securityParameters', _SecurityErrorData_securityParameters),
        ('performer', _SecurityErrorData_performer),
        ('aliasDereferenced', _SecurityErrorData_aliasDereferenced),
        ('notification', _SecurityErrorData_notification),
        ])
    SecurityErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< SecurityProblem >-----#
    SecurityProblem = INT(name='SecurityProblem', mode=MODE_TYPE)
    SecurityProblem._cont = ASN1Dict([('inappropriateAuthentication', 1), ('invalidCredentials', 2), ('insufficientAccessRights', 3), ('invalidSignature', 4), ('protectionRequired', 5), ('noInformation', 6), ('blockedCredentials', 7), ('spkmError', 9), ('unsupportedAuthenticationMethod', 10), ('passwordExpired', 11), ('inappropriateAlgorithms', 12)])
    
    #-----< EncPwdInfo >-----#
    EncPwdInfo = SEQ(name='EncPwdInfo', mode=MODE_TYPE)
    _EncPwdInfo_algorithms = SEQ_OF(name='algorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_algorithms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EncPwdInfo_algorithms__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EncPwdInfo_algorithms__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__algorithm._const_tab = ____EncPwdInfo_algorithms__item__algorithm_tab
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_at = None
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_id = 'id'
    ___EncPwdInfo_algorithms__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EncPwdInfo_algorithms__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__parameters._const_tab = ____EncPwdInfo_algorithms__item__parameters_tab
    ___EncPwdInfo_algorithms__item__parameters._const_tab_at = ('..', 'algorithm')
    ___EncPwdInfo_algorithms__item__parameters._const_tab_id = 'Type'
    __EncPwdInfo_algorithms__item_._cont = ASN1Dict([
        ('algorithm', ___EncPwdInfo_algorithms__item__algorithm),
        ('parameters', ___EncPwdInfo_algorithms__item__parameters),
        ])
    __EncPwdInfo_algorithms__item_._ext = []
    _EncPwdInfo_algorithms._cont = __EncPwdInfo_algorithms__item_
    _EncPwdInfo_pwdQualityRule = SEQ_OF(name='pwdQualityRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_pwdQualityRule__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EncPwdInfo_pwdQualityRule._cont = __EncPwdInfo_pwdQualityRule__item_
    EncPwdInfo._cont = ASN1Dict([
        ('algorithms', _EncPwdInfo_algorithms),
        ('pwdQualityRule', _EncPwdInfo_pwdQualityRule),
        ])
    EncPwdInfo._ext = []
    
    #-----< serviceError >-----#
    serviceError = CLASS(name='serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _serviceError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __serviceError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    __serviceError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___serviceError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___serviceError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___serviceError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __serviceError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___serviceError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___serviceError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___serviceError_val_ParameterType_signed_encrypted),
        ])
    __serviceError_val_ParameterType_signed._ext = []
    _serviceError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __serviceError_val_ParameterType_unsigned),
        ('signed', __serviceError_val_ParameterType_signed),
        ])
    _serviceError_val_ParameterType._ext = None
    serviceError._val = dict([('ParameterType', _serviceError_val_ParameterType), ('errorCode', ('local', 3))])
    
    #-----< ServiceErrorData >-----#
    ServiceErrorData = SET(name='ServiceErrorData', mode=MODE_TYPE)
    _ServiceErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _ServiceErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ServiceErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ServiceErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ServiceErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ServiceErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ServiceErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ServiceErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ServiceErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ServiceErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ServiceErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ServiceErrorData_notification__item__type._const_tab = ____ServiceErrorData_notification__item__type_tab
    ___ServiceErrorData_notification__item__type._const_tab_at = None
    ___ServiceErrorData_notification__item__type._const_tab_id = 'id'
    ___ServiceErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ServiceErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ServiceErrorData_notification__item__values__item_._const_tab = ____ServiceErrorData_notification__item__type_tab
    ____ServiceErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ServiceErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___ServiceErrorData_notification__item__values._cont = ____ServiceErrorData_notification__item__values__item_
    ___ServiceErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ServiceErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ServiceErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ServiceErrorData_notification__item__type_tab
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ServiceErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ServiceErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ServiceErrorData_notification__item__valuesWithContext._cont = ____ServiceErrorData_notification__item__valuesWithContext__item_
    ___ServiceErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ServiceErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___ServiceErrorData_notification__item__type),
        ('values', ___ServiceErrorData_notification__item__values),
        ('valuesWithContext', ___ServiceErrorData_notification__item__valuesWithContext),
        ])
    __ServiceErrorData_notification__item_._ext = []
    _ServiceErrorData_notification._cont = __ServiceErrorData_notification__item_
    ServiceErrorData._cont = ASN1Dict([
        ('problem', _ServiceErrorData_problem),
        ('securityParameters', _ServiceErrorData_securityParameters),
        ('performer', _ServiceErrorData_performer),
        ('aliasDereferenced', _ServiceErrorData_aliasDereferenced),
        ('notification', _ServiceErrorData_notification),
        ])
    ServiceErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ServiceProblem >-----#
    ServiceProblem = INT(name='ServiceProblem', mode=MODE_TYPE)
    ServiceProblem._cont = ASN1Dict([('busy', 1), ('unavailable', 2), ('unwillingToPerform', 3), ('chainingRequired', 4), ('unableToProceed', 5), ('invalidReference', 6), ('timeLimitExceeded', 7), ('administrativeLimitExceeded', 8), ('loopDetected', 9), ('unavailableCriticalExtension', 10), ('outOfScope', 11), ('ditError', 12), ('invalidQueryReference', 13), ('requestedServiceNotAvailable', 14), ('unsupportedMatchingUse', 15), ('ambiguousKeyAttributes', 16), ('saslBindInProgress', 17), ('notSupportedByLDAP', 18)])
    
    #-----< updateError >-----#
    updateError = CLASS(name='updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _updateError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __updateError_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    __updateError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___updateError_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___updateError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___updateError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___updateError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___updateError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __updateError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___updateError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___updateError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___updateError_val_ParameterType_signed_encrypted),
        ])
    __updateError_val_ParameterType_signed._ext = []
    _updateError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __updateError_val_ParameterType_unsigned),
        ('signed', __updateError_val_ParameterType_signed),
        ])
    _updateError_val_ParameterType._ext = None
    updateError._val = dict([('ParameterType', _updateError_val_ParameterType), ('errorCode', ('local', 8))])
    
    #-----< UpdateErrorData >-----#
    UpdateErrorData = SET(name='UpdateErrorData', mode=MODE_TYPE)
    _UpdateErrorData_problem = INT(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateProblem')))
    _UpdateErrorData_attributeInfo = SET_OF(name='attributeInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_attributeInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___UpdateErrorData_attributeInfo__item__attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___UpdateErrorData_attributeInfo__item__attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____UpdateErrorData_attributeInfo__item__attribute_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_at = None
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_id = 'id'
    ____UpdateErrorData_attributeInfo__item__attribute_values = SET_OF(name='values', mode=MODE_TYPE)
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_at = ('..', '..', 'type')
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_id = 'Type'
    ____UpdateErrorData_attributeInfo__item__attribute_values._cont = _____UpdateErrorData_attributeInfo__item__attribute_values__item_
    ____UpdateErrorData_attributeInfo__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_id = 'Type'
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._cont = _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value),
        ('contextList', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList),
        ])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._ext = []
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._cont = _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___UpdateErrorData_attributeInfo__item__attribute._cont = ASN1Dict([
        ('type', ____UpdateErrorData_attributeInfo__item__attribute_type),
        ('values', ____UpdateErrorData_attributeInfo__item__attribute_values),
        ('valuesWithContext', ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext),
        ])
    ___UpdateErrorData_attributeInfo__item__attribute._ext = []
    __UpdateErrorData_attributeInfo__item_._cont = ASN1Dict([
        ('attributeType', ___UpdateErrorData_attributeInfo__item__attributeType),
        ('attribute', ___UpdateErrorData_attributeInfo__item__attribute),
        ])
    __UpdateErrorData_attributeInfo__item_._ext = []
    _UpdateErrorData_attributeInfo._cont = __UpdateErrorData_attributeInfo__item_
    _UpdateErrorData_attributeInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UpdateErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___UpdateErrorData_notification__item__type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ___UpdateErrorData_notification__item__type._const_tab_at = None
    ___UpdateErrorData_notification__item__type._const_tab_id = 'id'
    ___UpdateErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____UpdateErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____UpdateErrorData_notification__item__values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____UpdateErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___UpdateErrorData_notification__item__values._cont = ____UpdateErrorData_notification__item__values__item_
    ___UpdateErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____UpdateErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____UpdateErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateErrorData_notification__item__valuesWithContext._cont = ____UpdateErrorData_notification__item__valuesWithContext__item_
    ___UpdateErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___UpdateErrorData_notification__item__type),
        ('values', ___UpdateErrorData_notification__item__values),
        ('valuesWithContext', ___UpdateErrorData_notification__item__valuesWithContext),
        ])
    __UpdateErrorData_notification__item_._ext = []
    _UpdateErrorData_notification._cont = __UpdateErrorData_notification__item_
    UpdateErrorData._cont = ASN1Dict([
        ('problem', _UpdateErrorData_problem),
        ('attributeInfo', _UpdateErrorData_attributeInfo),
        ('securityParameters', _UpdateErrorData_securityParameters),
        ('performer', _UpdateErrorData_performer),
        ('aliasDereferenced', _UpdateErrorData_aliasDereferenced),
        ('notification', _UpdateErrorData_notification),
        ])
    UpdateErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< UpdateProblem >-----#
    UpdateProblem = INT(name='UpdateProblem', mode=MODE_TYPE)
    UpdateProblem._cont = ASN1Dict([('namingViolation', 1), ('objectClassViolation', 2), ('notAllowedOnNonLeaf', 3), ('notAllowedOnRDN', 4), ('entryAlreadyExists', 5), ('affectsMultipleDSAs', 6), ('objectClassModificationProhibited', 7), ('noSuchSuperior', 8), ('notAncestor', 9), ('parentNotAncestor', 10), ('hierarchyRuleViolation', 11), ('familyRuleViolation', 12), ('insufficientPasswordQuality', 13), ('passwordInHistory', 14), ('noPasswordSlot', 15)])
    
    #-----< id-at-family-information >-----#
    id_at_family_information = OID(name='id-at-family-information', mode=MODE_VALUE)
    id_at_family_information._val = (2, 5, 4, 64)
    
    _all_ = [
        _CommonArguments_serviceControls,
        _CommonArguments_securityParameters,
        _CommonArguments_requestor,
        _CommonArguments_operationProgress,
        _CommonArguments_aliasedRDNs,
        _CommonArguments_criticalExtensions,
        _CommonArguments_referenceType,
        _CommonArguments_entryOnly,
        _CommonArguments_exclusions,
        _CommonArguments_nameResolveOnMaster,
        _CommonArguments_operationContexts,
        _CommonArguments_familyGrouping,
        CommonArguments,
        _CommonArgumentsSeq_serviceControls,
        _CommonArgumentsSeq_securityParameters,
        _CommonArgumentsSeq_requestor,
        _CommonArgumentsSeq_operationProgress,
        _CommonArgumentsSeq_aliasedRDNs,
        _CommonArgumentsSeq_criticalExtensions,
        _CommonArgumentsSeq_referenceType,
        _CommonArgumentsSeq_entryOnly,
        _CommonArgumentsSeq_exclusions,
        _CommonArgumentsSeq_nameResolveOnMaster,
        _CommonArgumentsSeq_operationContexts,
        _CommonArgumentsSeq_familyGrouping,
        CommonArgumentsSeq,
        FamilyGrouping,
        _CommonResults_securityParameters,
        _CommonResults_performer,
        _CommonResults_aliasDereferenced,
        ____CommonResults_notification__item__type_tab,
        _____CommonResults_notification__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CommonResults_notification__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CommonResults_notification__item__type,
        ____CommonResults_notification__item__values__item_,
        ___CommonResults_notification__item__values,
        _____CommonResults_notification__item__valuesWithContext__item__value,
        ______CommonResults_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResults_notification__item__valuesWithContext__item__contextList,
        ____CommonResults_notification__item__valuesWithContext__item_,
        ___CommonResults_notification__item__valuesWithContext,
        __CommonResults_notification__item_,
        _CommonResults_notification,
        CommonResults,
        _CommonResultsSeq_securityParameters,
        _CommonResultsSeq_performer,
        _CommonResultsSeq_aliasDereferenced,
        ____CommonResultsSeq_notification__item__type_tab,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_0,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_1,
        ___CommonResultsSeq_notification__item__type,
        ____CommonResultsSeq_notification__item__values__item_,
        ___CommonResultsSeq_notification__item__values,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__value,
        ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList,
        ____CommonResultsSeq_notification__item__valuesWithContext__item_,
        ___CommonResultsSeq_notification__item__valuesWithContext,
        __CommonResultsSeq_notification__item_,
        _CommonResultsSeq_notification,
        CommonResultsSeq,
        _ServiceControls_options,
        _ServiceControls_priority,
        _ServiceControls_timeLimit,
        _ServiceControls_sizeLimit,
        _ServiceControls_scopeOfReferral,
        _ServiceControls_attributeSizeLimit,
        __ServiceControls_manageDSAITPlaneRef_dsaName,
        __ServiceControls_manageDSAITPlaneRef_agreementID,
        _ServiceControls_manageDSAITPlaneRef,
        _ServiceControls_serviceType,
        _ServiceControls_userClass,
        ServiceControls,
        ServiceControlOptions,
        __EntryInformationSelection_attributes_allUserAttributes,
        ___EntryInformationSelection_attributes_select__item_,
        __EntryInformationSelection_attributes_select,
        _EntryInformationSelection_attributes,
        _EntryInformationSelection_infoTypes,
        __EntryInformationSelection_extraAttributes_allOperationalAttributes,
        ___EntryInformationSelection_extraAttributes_select__item_,
        __EntryInformationSelection_extraAttributes_select,
        _EntryInformationSelection_extraAttributes,
        _EntryInformationSelection_contextSelection,
        _EntryInformationSelection_returnContexts,
        _EntryInformationSelection_familyReturn,
        EntryInformationSelection,
        _ContextSelection_allContexts,
        __ContextSelection_selectedContexts__item_,
        _ContextSelection_selectedContexts,
        ContextSelection,
        _TypeAndContextAssertion_type,
        ___TypeAndContextAssertion_contextAssertions_preference__item_,
        __TypeAndContextAssertion_contextAssertions_preference,
        ___TypeAndContextAssertion_contextAssertions_all__item_,
        __TypeAndContextAssertion_contextAssertions_all,
        _TypeAndContextAssertion_contextAssertions,
        TypeAndContextAssertion,
        _FamilyReturn_memberSelect,
        __FamilyReturn_familySelect__item_,
        _FamilyReturn_familySelect,
        FamilyReturn,
        _EntryInformation_name,
        _EntryInformation_fromEntry,
        ___EntryInformation_information__item__attributeType,
        _____EntryInformation_information__item__attribute_type_tab,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_0,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_1,
        ____EntryInformation_information__item__attribute_type,
        _____EntryInformation_information__item__attribute_values__item_,
        ____EntryInformation_information__item__attribute_values,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__value,
        _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList,
        _____EntryInformation_information__item__attribute_valuesWithContext__item_,
        ____EntryInformation_information__item__attribute_valuesWithContext,
        ___EntryInformation_information__item__attribute,
        __EntryInformation_information__item_,
        _EntryInformation_information,
        _EntryInformation_incompleteEntry,
        _EntryInformation_partialName,
        _EntryInformation_derivedEntry,
        EntryInformation,
        family_information,
        _family_information_val_Type,
        _FamilyEntries_family_class,
        __FamilyEntries_familyEntries__item_,
        _FamilyEntries_familyEntries,
        FamilyEntries,
        _FamilyEntry_rdn,
        ___FamilyEntry_information__item__attributeType,
        _____FamilyEntry_information__item__attribute_type_tab,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_0,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_1,
        ____FamilyEntry_information__item__attribute_type,
        _____FamilyEntry_information__item__attribute_values__item_,
        ____FamilyEntry_information__item__attribute_values,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__value,
        _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList,
        _____FamilyEntry_information__item__attribute_valuesWithContext__item_,
        ____FamilyEntry_information__item__attribute_valuesWithContext,
        ___FamilyEntry_information__item__attribute,
        __FamilyEntry_information__item_,
        _FamilyEntry_information,
        __FamilyEntry_family_info__item_,
        _FamilyEntry_family_info,
        FamilyEntry,
        _Filter_item,
        __Filter_and___item_,
        _Filter_and_,
        __Filter_or___item_,
        _Filter_or_,
        _Filter_not_,
        Filter,
        _FilterItem_equality,
        ___FilterItem_substrings_type_tab,
        ____FilterItem_substrings_type_tab_val_Type_0,
        ____FilterItem_substrings_type_tab_val_Type_1,
        __FilterItem_substrings_type,
        ____FilterItem_substrings_strings__item__initial,
        ____FilterItem_substrings_strings__item__any,
        ____FilterItem_substrings_strings__item__final,
        _____FilterItem_substrings_strings__item__control_type,
        ______FilterItem_substrings_strings__item__control_values__item_,
        _____FilterItem_substrings_strings__item__control_values,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value,
        ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList,
        ______FilterItem_substrings_strings__item__control_valuesWithContext__item_,
        _____FilterItem_substrings_strings__item__control_valuesWithContext,
        ____FilterItem_substrings_strings__item__control,
        ___FilterItem_substrings_strings__item_,
        __FilterItem_substrings_strings,
        _FilterItem_substrings,
        _FilterItem_greaterOrEqual,
        _FilterItem_lessOrEqual,
        _FilterItem_present,
        _FilterItem_approximateMatch,
        _FilterItem_extensibleMatch,
        _FilterItem_contextPresent,
        FilterItem,
        __MatchingRuleAssertion_matchingRule__item_,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        __PagedResultsRequest_newRequest_pageSize,
        ___PagedResultsRequest_newRequest_sortKeys__item_,
        __PagedResultsRequest_newRequest_sortKeys,
        __PagedResultsRequest_newRequest_reverse,
        __PagedResultsRequest_newRequest_unmerged,
        __PagedResultsRequest_newRequest_pageNumber,
        _PagedResultsRequest_newRequest,
        _PagedResultsRequest_queryReference,
        _PagedResultsRequest_abandonQuery,
        PagedResultsRequest,
        _SortKey_type,
        _SortKey_orderingRule,
        SortKey,
        _SecurityParameters_certification_path,
        _SecurityParameters_name,
        _SecurityParameters_time,
        _SecurityParameters_random,
        _SecurityParameters_target,
        _SecurityParameters_operationCode,
        _SecurityParameters_errorProtection,
        _SecurityParameters_errorCode,
        SecurityParameters,
        ProtectionRequest,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        ErrorProtectionRequest,
        directoryBind,
        _directoryBind_val_ArgumentType,
        _directoryBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DirectoryBindArgument_credentials,
        _DirectoryBindArgument_versions,
        DirectoryBindArgument,
        _Credentials_simple,
        _Credentials_strong,
        _Credentials_externalProcedure,
        _Credentials_spkm,
        _Credentials_sasl,
        Credentials,
        _SimpleCredentials_name,
        ___SimpleCredentials_validity_time1_utc,
        ___SimpleCredentials_validity_time1_gt,
        __SimpleCredentials_validity_time1,
        ___SimpleCredentials_validity_time2_utc,
        ___SimpleCredentials_validity_time2_gt,
        __SimpleCredentials_validity_time2,
        __SimpleCredentials_validity_random1,
        __SimpleCredentials_validity_random2,
        _SimpleCredentials_validity,
        __SimpleCredentials_password_unprotected,
        _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm,
        _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_parameters,
        ___SimpleCredentials_password_protected_algorithmIdentifier,
        ___SimpleCredentials_password_protected_hashValue,
        __SimpleCredentials_password_protected,
        __SimpleCredentials_password_userPwd,
        _SimpleCredentials_password,
        SimpleCredentials,
        _StrongCredentials_certification_path,
        _StrongCredentials_bind_token,
        _StrongCredentials_name,
        _StrongCredentials_attributeCertificationPath,
        StrongCredentials,
        _SpkmCredentials_req,
        _SpkmCredentials_rep,
        SpkmCredentials,
        __SaslCredentials_mechanism_teletexString,
        __SaslCredentials_mechanism_printableString,
        __SaslCredentials_mechanism_bmpString,
        __SaslCredentials_mechanism_universalString,
        __SaslCredentials_mechanism_uTF8String,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        _SaslCredentials_saslAbort,
        SaslCredentials,
        ub_saslMechanism,
        _Token_toBeSigned,
        ___Token_algorithmIdentifier_algorithm_tab,
        __Token_algorithmIdentifier_algorithm,
        ___Token_algorithmIdentifier_parameters_tab,
        __Token_algorithmIdentifier_parameters,
        _Token_algorithmIdentifier,
        _Token_encrypted,
        Token,
        ___TokenContent_algorithm_algorithm_tab,
        __TokenContent_algorithm_algorithm,
        ___TokenContent_algorithm_parameters_tab,
        __TokenContent_algorithm_parameters,
        _TokenContent_algorithm,
        _TokenContent_name,
        _TokenContent_time,
        _TokenContent_random,
        _TokenContent_response,
        TokenContent,
        Versions,
        _DirectoryBindResult_credentials,
        _DirectoryBindResult_versions,
        _DirectoryBindResult_pwdResponseValue,
        DirectoryBindResult,
        __PwdResponseValue_warning_timeLeft,
        __PwdResponseValue_warning_graceRemaining,
        _PwdResponseValue_warning,
        _PwdResponseValue_error,
        PwdResponseValue,
        directoryBindError,
        ___directoryBindError_val_ParameterType_unsigned_versions,
        ____directoryBindError_val_ParameterType_unsigned_error_serviceError,
        ____directoryBindError_val_ParameterType_unsigned_error_securityError,
        ___directoryBindError_val_ParameterType_unsigned_error,
        ___directoryBindError_val_ParameterType_unsigned_securityParameters,
        __directoryBindError_val_ParameterType_unsigned,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_versions,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_error,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters,
        ___directoryBindError_val_ParameterType_signed_toBeSigned,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___directoryBindError_val_ParameterType_signed_algorithmIdentifier,
        ___directoryBindError_val_ParameterType_signed_encrypted,
        __directoryBindError_val_ParameterType_signed,
        _directoryBindError_val_ParameterType,
        BindKeyInfo,
        read,
        _read_val_ArgumentType,
        _read_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        _ReadArgument_unsigned,
        __ReadArgument_signed_toBeSigned,
        ____ReadArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ReadArgument_signed_algorithmIdentifier_algorithm,
        ____ReadArgument_signed_algorithmIdentifier_parameters_tab,
        ___ReadArgument_signed_algorithmIdentifier_parameters,
        __ReadArgument_signed_algorithmIdentifier,
        __ReadArgument_signed_encrypted,
        _ReadArgument_signed,
        ReadArgument,
        _ReadArgumentData_object,
        _ReadArgumentData_selection,
        _ReadArgumentData_modifyRightsRequest,
        _ReadArgumentData_serviceControls,
        _ReadArgumentData_securityParameters,
        _ReadArgumentData_requestor,
        _ReadArgumentData_operationProgress,
        _ReadArgumentData_aliasedRDNs,
        _ReadArgumentData_criticalExtensions,
        _ReadArgumentData_referenceType,
        _ReadArgumentData_entryOnly,
        _ReadArgumentData_exclusions,
        _ReadArgumentData_nameResolveOnMaster,
        _ReadArgumentData_operationContexts,
        _ReadArgumentData_familyGrouping,
        ReadArgumentData,
        _ReadResult_unsigned,
        __ReadResult_signed_toBeSigned,
        ____ReadResult_signed_algorithmIdentifier_algorithm_tab,
        ___ReadResult_signed_algorithmIdentifier_algorithm,
        ____ReadResult_signed_algorithmIdentifier_parameters_tab,
        ___ReadResult_signed_algorithmIdentifier_parameters,
        __ReadResult_signed_algorithmIdentifier,
        __ReadResult_signed_encrypted,
        _ReadResult_signed,
        ReadResult,
        _ReadResultData_entry,
        _ReadResultData_modifyRights,
        _ReadResultData_securityParameters,
        _ReadResultData_performer,
        _ReadResultData_aliasDereferenced,
        ____ReadResultData_notification__item__type_tab,
        _____ReadResultData_notification__item__type_tab_val_Type_0,
        _____ReadResultData_notification__item__type_tab_val_Type_1,
        ___ReadResultData_notification__item__type,
        ____ReadResultData_notification__item__values__item_,
        ___ReadResultData_notification__item__values,
        _____ReadResultData_notification__item__valuesWithContext__item__value,
        ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReadResultData_notification__item__valuesWithContext__item__contextList,
        ____ReadResultData_notification__item__valuesWithContext__item_,
        ___ReadResultData_notification__item__valuesWithContext,
        __ReadResultData_notification__item_,
        _ReadResultData_notification,
        ReadResultData,
        ___ModifyRights__item__item_entry,
        ___ModifyRights__item__item_attribute,
        ___ModifyRights__item__item_value,
        __ModifyRights__item__item,
        __ModifyRights__item__permission,
        _ModifyRights__item_,
        ModifyRights,
        compare,
        _compare_val_ArgumentType,
        _compare_val_ResultType,
        _CompareArgument_unsigned,
        __CompareArgument_signed_toBeSigned,
        ____CompareArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CompareArgument_signed_algorithmIdentifier_algorithm,
        ____CompareArgument_signed_algorithmIdentifier_parameters_tab,
        ___CompareArgument_signed_algorithmIdentifier_parameters,
        __CompareArgument_signed_algorithmIdentifier,
        __CompareArgument_signed_encrypted,
        _CompareArgument_signed,
        CompareArgument,
        _CompareArgumentData_object,
        _CompareArgumentData_purported,
        _CompareArgumentData_serviceControls,
        _CompareArgumentData_securityParameters,
        _CompareArgumentData_requestor,
        _CompareArgumentData_operationProgress,
        _CompareArgumentData_aliasedRDNs,
        _CompareArgumentData_criticalExtensions,
        _CompareArgumentData_referenceType,
        _CompareArgumentData_entryOnly,
        _CompareArgumentData_exclusions,
        _CompareArgumentData_nameResolveOnMaster,
        _CompareArgumentData_operationContexts,
        _CompareArgumentData_familyGrouping,
        CompareArgumentData,
        _CompareResult_unsigned,
        __CompareResult_signed_toBeSigned,
        ____CompareResult_signed_algorithmIdentifier_algorithm_tab,
        ___CompareResult_signed_algorithmIdentifier_algorithm,
        ____CompareResult_signed_algorithmIdentifier_parameters_tab,
        ___CompareResult_signed_algorithmIdentifier_parameters,
        __CompareResult_signed_algorithmIdentifier,
        __CompareResult_signed_encrypted,
        _CompareResult_signed,
        CompareResult,
        _CompareResultData_name,
        _CompareResultData_matched,
        _CompareResultData_fromEntry,
        _CompareResultData_matchedSubtype,
        _CompareResultData_securityParameters,
        _CompareResultData_performer,
        _CompareResultData_aliasDereferenced,
        ____CompareResultData_notification__item__type_tab,
        _____CompareResultData_notification__item__type_tab_val_Type_0,
        _____CompareResultData_notification__item__type_tab_val_Type_1,
        ___CompareResultData_notification__item__type,
        ____CompareResultData_notification__item__values__item_,
        ___CompareResultData_notification__item__values,
        _____CompareResultData_notification__item__valuesWithContext__item__value,
        ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CompareResultData_notification__item__valuesWithContext__item__contextList,
        ____CompareResultData_notification__item__valuesWithContext__item_,
        ___CompareResultData_notification__item__valuesWithContext,
        __CompareResultData_notification__item_,
        _CompareResultData_notification,
        CompareResultData,
        abandon,
        _abandon_val_ArgumentType,
        _abandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        _AbandonArgument_unsigned,
        __AbandonArgument_signed_toBeSigned,
        ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AbandonArgument_signed_algorithmIdentifier_algorithm,
        ____AbandonArgument_signed_algorithmIdentifier_parameters_tab,
        ___AbandonArgument_signed_algorithmIdentifier_parameters,
        __AbandonArgument_signed_algorithmIdentifier,
        __AbandonArgument_signed_encrypted,
        _AbandonArgument_signed,
        AbandonArgument,
        _AbandonArgumentData_invokeID,
        AbandonArgumentData,
        _AbandonResult_null,
        __AbandonResult_information_unsigned,
        ___AbandonResult_information_signed_toBeSigned,
        _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_algorithm,
        _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_parameters,
        ___AbandonResult_information_signed_algorithmIdentifier,
        ___AbandonResult_information_signed_encrypted,
        __AbandonResult_information_signed,
        _AbandonResult_information,
        AbandonResult,
        _AbandonResultData_invokeID,
        _AbandonResultData_securityParameters,
        _AbandonResultData_performer,
        _AbandonResultData_aliasDereferenced,
        ____AbandonResultData_notification__item__type_tab,
        _____AbandonResultData_notification__item__type_tab_val_Type_0,
        _____AbandonResultData_notification__item__type_tab_val_Type_1,
        ___AbandonResultData_notification__item__type,
        ____AbandonResultData_notification__item__values__item_,
        ___AbandonResultData_notification__item__values,
        _____AbandonResultData_notification__item__valuesWithContext__item__value,
        ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonResultData_notification__item__valuesWithContext__item__contextList,
        ____AbandonResultData_notification__item__valuesWithContext__item_,
        ___AbandonResultData_notification__item__valuesWithContext,
        __AbandonResultData_notification__item_,
        _AbandonResultData_notification,
        AbandonResultData,
        list,
        _list_val_ArgumentType,
        _list_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        _ListArgument_unsigned,
        __ListArgument_signed_toBeSigned,
        ____ListArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ListArgument_signed_algorithmIdentifier_algorithm,
        ____ListArgument_signed_algorithmIdentifier_parameters_tab,
        ___ListArgument_signed_algorithmIdentifier_parameters,
        __ListArgument_signed_algorithmIdentifier,
        __ListArgument_signed_encrypted,
        _ListArgument_signed,
        ListArgument,
        _ListArgumentData_object,
        _ListArgumentData_pagedResults,
        _ListArgumentData_listFamily,
        _ListArgumentData_serviceControls,
        _ListArgumentData_securityParameters,
        _ListArgumentData_requestor,
        _ListArgumentData_operationProgress,
        _ListArgumentData_aliasedRDNs,
        _ListArgumentData_criticalExtensions,
        _ListArgumentData_referenceType,
        _ListArgumentData_entryOnly,
        _ListArgumentData_exclusions,
        _ListArgumentData_nameResolveOnMaster,
        _ListArgumentData_operationContexts,
        _ListArgumentData_familyGrouping,
        ListArgumentData,
        _ListResult_unsigned,
        __ListResult_signed_toBeSigned,
        ____ListResult_signed_algorithmIdentifier_algorithm_tab,
        ___ListResult_signed_algorithmIdentifier_algorithm,
        ____ListResult_signed_algorithmIdentifier_parameters_tab,
        ___ListResult_signed_algorithmIdentifier_parameters,
        __ListResult_signed_algorithmIdentifier,
        __ListResult_signed_encrypted,
        _ListResult_signed,
        ListResult,
        __ListResultData_listInfo_name,
        ____ListResultData_listInfo_subordinates__item__rdn,
        ____ListResultData_listInfo_subordinates__item__aliasEntry,
        ____ListResultData_listInfo_subordinates__item__fromEntry,
        ___ListResultData_listInfo_subordinates__item_,
        __ListResultData_listInfo_subordinates,
        __ListResultData_listInfo_partialOutcomeQualifier,
        __ListResultData_listInfo_securityParameters,
        __ListResultData_listInfo_performer,
        __ListResultData_listInfo_aliasDereferenced,
        _____ListResultData_listInfo_notification__item__type_tab,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_0,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_1,
        ____ListResultData_listInfo_notification__item__type,
        _____ListResultData_listInfo_notification__item__values__item_,
        ____ListResultData_listInfo_notification__item__values,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__value,
        _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList,
        _____ListResultData_listInfo_notification__item__valuesWithContext__item_,
        ____ListResultData_listInfo_notification__item__valuesWithContext,
        ___ListResultData_listInfo_notification__item_,
        __ListResultData_listInfo_notification,
        _ListResultData_listInfo,
        __ListResultData_uncorrelatedListInfo__item_,
        _ListResultData_uncorrelatedListInfo,
        ListResultData,
        _PartialOutcomeQualifier_limitProblem,
        __PartialOutcomeQualifier_unexplored__item_,
        _PartialOutcomeQualifier_unexplored,
        _PartialOutcomeQualifier_unavailableCriticalExtensions,
        __PartialOutcomeQualifier_unknownErrors__item_,
        _PartialOutcomeQualifier_unknownErrors,
        _PartialOutcomeQualifier_queryReference,
        _PartialOutcomeQualifier_overspecFilter,
        ____PartialOutcomeQualifier_notification__item__type_tab,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1,
        ___PartialOutcomeQualifier_notification__item__type,
        ____PartialOutcomeQualifier_notification__item__values__item_,
        ___PartialOutcomeQualifier_notification__item__values,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value,
        ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList,
        ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_,
        ___PartialOutcomeQualifier_notification__item__valuesWithContext,
        __PartialOutcomeQualifier_notification__item_,
        _PartialOutcomeQualifier_notification,
        __PartialOutcomeQualifier_entryCount_bestEstimate,
        __PartialOutcomeQualifier_entryCount_lowEstimate,
        __PartialOutcomeQualifier_entryCount_exact,
        _PartialOutcomeQualifier_entryCount,
        PartialOutcomeQualifier,
        LimitProblem,
        search,
        _search_val_ArgumentType,
        _search_val_ResultType,
        _SearchArgument_unsigned,
        __SearchArgument_signed_toBeSigned,
        ____SearchArgument_signed_algorithmIdentifier_algorithm_tab,
        ___SearchArgument_signed_algorithmIdentifier_algorithm,
        ____SearchArgument_signed_algorithmIdentifier_parameters_tab,
        ___SearchArgument_signed_algorithmIdentifier_parameters,
        __SearchArgument_signed_algorithmIdentifier,
        __SearchArgument_signed_encrypted,
        _SearchArgument_signed,
        SearchArgument,
        _SearchArgumentData_baseObject,
        _SearchArgumentData_subset,
        _SearchArgumentData_filter,
        _SearchArgumentData_searchAliases,
        _SearchArgumentData_selection,
        _SearchArgumentData_pagedResults,
        _SearchArgumentData_matchedValuesOnly,
        _SearchArgumentData_extendedFilter,
        _SearchArgumentData_checkOverspecified,
        _SearchArgumentData_relaxation,
        _SearchArgumentData_extendedArea,
        _SearchArgumentData_hierarchySelections,
        _SearchArgumentData_searchControlOptions,
        __SearchArgumentData_joinArguments__item_,
        _SearchArgumentData_joinArguments,
        _SearchArgumentData_joinType,
        _SearchArgumentData_serviceControls,
        _SearchArgumentData_securityParameters,
        _SearchArgumentData_requestor,
        _SearchArgumentData_operationProgress,
        _SearchArgumentData_aliasedRDNs,
        _SearchArgumentData_criticalExtensions,
        _SearchArgumentData_referenceType,
        _SearchArgumentData_entryOnly,
        _SearchArgumentData_exclusions,
        _SearchArgumentData_nameResolveOnMaster,
        _SearchArgumentData_operationContexts,
        _SearchArgumentData_familyGrouping,
        SearchArgumentData,
        HierarchySelections,
        SearchControlOptions,
        _JoinArgument_joinBaseObject,
        _JoinArgument_domainLocalID,
        _JoinArgument_joinSubset,
        _JoinArgument_joinFilter,
        __JoinArgument_joinAttributes__item_,
        _JoinArgument_joinAttributes,
        _JoinArgument_joinSelection,
        JoinArgument,
        DomainLocalID,
        _JoinAttPair_baseAtt,
        _JoinAttPair_joinAtt,
        __JoinAttPair_joinContext__item_,
        _JoinAttPair_joinContext,
        JoinAttPair,
        _JoinContextType_tab,
        JoinContextType,
        _SearchResult_unsigned,
        __SearchResult_signed_toBeSigned,
        ____SearchResult_signed_algorithmIdentifier_algorithm_tab,
        ___SearchResult_signed_algorithmIdentifier_algorithm,
        ____SearchResult_signed_algorithmIdentifier_parameters_tab,
        ___SearchResult_signed_algorithmIdentifier_parameters,
        __SearchResult_signed_algorithmIdentifier,
        __SearchResult_signed_encrypted,
        _SearchResult_signed,
        SearchResult,
        __SearchResultData_searchInfo_name,
        ___SearchResultData_searchInfo_entries__item_,
        __SearchResultData_searchInfo_entries,
        __SearchResultData_searchInfo_partialOutcomeQualifier,
        __SearchResultData_searchInfo_altMatching,
        __SearchResultData_searchInfo_securityParameters,
        __SearchResultData_searchInfo_performer,
        __SearchResultData_searchInfo_aliasDereferenced,
        _____SearchResultData_searchInfo_notification__item__type_tab,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1,
        ____SearchResultData_searchInfo_notification__item__type,
        _____SearchResultData_searchInfo_notification__item__values__item_,
        ____SearchResultData_searchInfo_notification__item__values,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value,
        _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList,
        _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_,
        ____SearchResultData_searchInfo_notification__item__valuesWithContext,
        ___SearchResultData_searchInfo_notification__item_,
        __SearchResultData_searchInfo_notification,
        _SearchResultData_searchInfo,
        __SearchResultData_uncorrelatedSearchInfo__item_,
        _SearchResultData_uncorrelatedSearchInfo,
        SearchResultData,
        addEntry,
        _addEntry_val_ArgumentType,
        _addEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        _AddEntryArgument_unsigned,
        __AddEntryArgument_signed_toBeSigned,
        ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_algorithm,
        ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_parameters,
        __AddEntryArgument_signed_algorithmIdentifier,
        __AddEntryArgument_signed_encrypted,
        _AddEntryArgument_signed,
        AddEntryArgument,
        _AddEntryArgumentData_object,
        ____AddEntryArgumentData_entry__item__type_tab,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_0,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_1,
        ___AddEntryArgumentData_entry__item__type,
        ____AddEntryArgumentData_entry__item__values__item_,
        ___AddEntryArgumentData_entry__item__values,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__value,
        ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList,
        ____AddEntryArgumentData_entry__item__valuesWithContext__item_,
        ___AddEntryArgumentData_entry__item__valuesWithContext,
        __AddEntryArgumentData_entry__item_,
        _AddEntryArgumentData_entry,
        _AddEntryArgumentData_targetSystem,
        _AddEntryArgumentData_serviceControls,
        _AddEntryArgumentData_securityParameters,
        _AddEntryArgumentData_requestor,
        _AddEntryArgumentData_operationProgress,
        _AddEntryArgumentData_aliasedRDNs,
        _AddEntryArgumentData_criticalExtensions,
        _AddEntryArgumentData_referenceType,
        _AddEntryArgumentData_entryOnly,
        _AddEntryArgumentData_exclusions,
        _AddEntryArgumentData_nameResolveOnMaster,
        _AddEntryArgumentData_operationContexts,
        _AddEntryArgumentData_familyGrouping,
        AddEntryArgumentData,
        _AddEntryResult_null,
        __AddEntryResult_information_unsigned,
        ___AddEntryResult_information_signed_toBeSigned,
        _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_parameters,
        ___AddEntryResult_information_signed_algorithmIdentifier,
        ___AddEntryResult_information_signed_encrypted,
        __AddEntryResult_information_signed,
        _AddEntryResult_information,
        AddEntryResult,
        _AddEntryResultData_securityParameters,
        _AddEntryResultData_performer,
        _AddEntryResultData_aliasDereferenced,
        ____AddEntryResultData_notification__item__type_tab,
        _____AddEntryResultData_notification__item__type_tab_val_Type_0,
        _____AddEntryResultData_notification__item__type_tab_val_Type_1,
        ___AddEntryResultData_notification__item__type,
        ____AddEntryResultData_notification__item__values__item_,
        ___AddEntryResultData_notification__item__values,
        _____AddEntryResultData_notification__item__valuesWithContext__item__value,
        ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AddEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____AddEntryResultData_notification__item__valuesWithContext__item_,
        ___AddEntryResultData_notification__item__valuesWithContext,
        __AddEntryResultData_notification__item_,
        _AddEntryResultData_notification,
        AddEntryResultData,
        removeEntry,
        _removeEntry_val_ArgumentType,
        _removeEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        _RemoveEntryArgument_unsigned,
        __RemoveEntryArgument_signed_toBeSigned,
        ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm,
        ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_parameters,
        __RemoveEntryArgument_signed_algorithmIdentifier,
        __RemoveEntryArgument_signed_encrypted,
        _RemoveEntryArgument_signed,
        RemoveEntryArgument,
        _RemoveEntryArgumentData_object,
        _RemoveEntryArgumentData_serviceControls,
        _RemoveEntryArgumentData_securityParameters,
        _RemoveEntryArgumentData_requestor,
        _RemoveEntryArgumentData_operationProgress,
        _RemoveEntryArgumentData_aliasedRDNs,
        _RemoveEntryArgumentData_criticalExtensions,
        _RemoveEntryArgumentData_referenceType,
        _RemoveEntryArgumentData_entryOnly,
        _RemoveEntryArgumentData_exclusions,
        _RemoveEntryArgumentData_nameResolveOnMaster,
        _RemoveEntryArgumentData_operationContexts,
        _RemoveEntryArgumentData_familyGrouping,
        RemoveEntryArgumentData,
        _RemoveEntryResult_null,
        __RemoveEntryResult_information_unsigned,
        ___RemoveEntryResult_information_signed_toBeSigned,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters,
        ___RemoveEntryResult_information_signed_algorithmIdentifier,
        ___RemoveEntryResult_information_signed_encrypted,
        __RemoveEntryResult_information_signed,
        _RemoveEntryResult_information,
        RemoveEntryResult,
        _RemoveEntryResultData_securityParameters,
        _RemoveEntryResultData_performer,
        _RemoveEntryResultData_aliasDereferenced,
        ____RemoveEntryResultData_notification__item__type_tab,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_0,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_1,
        ___RemoveEntryResultData_notification__item__type,
        ____RemoveEntryResultData_notification__item__values__item_,
        ___RemoveEntryResultData_notification__item__values,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__value,
        ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____RemoveEntryResultData_notification__item__valuesWithContext__item_,
        ___RemoveEntryResultData_notification__item__valuesWithContext,
        __RemoveEntryResultData_notification__item_,
        _RemoveEntryResultData_notification,
        RemoveEntryResultData,
        modifyEntry,
        _modifyEntry_val_ArgumentType,
        _modifyEntry_val_ResultType,
        _ModifyEntryArgument_unsigned,
        __ModifyEntryArgument_signed_toBeSigned,
        ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_parameters,
        __ModifyEntryArgument_signed_algorithmIdentifier,
        __ModifyEntryArgument_signed_encrypted,
        _ModifyEntryArgument_signed,
        ModifyEntryArgument,
        _ModifyEntryArgumentData_object,
        __ModifyEntryArgumentData_changes__item_,
        _ModifyEntryArgumentData_changes,
        _ModifyEntryArgumentData_selection,
        _ModifyEntryArgumentData_serviceControls,
        _ModifyEntryArgumentData_securityParameters,
        _ModifyEntryArgumentData_requestor,
        _ModifyEntryArgumentData_operationProgress,
        _ModifyEntryArgumentData_aliasedRDNs,
        _ModifyEntryArgumentData_criticalExtensions,
        _ModifyEntryArgumentData_referenceType,
        _ModifyEntryArgumentData_entryOnly,
        _ModifyEntryArgumentData_exclusions,
        _ModifyEntryArgumentData_nameResolveOnMaster,
        _ModifyEntryArgumentData_operationContexts,
        _ModifyEntryArgumentData_familyGrouping,
        ModifyEntryArgumentData,
        _ModifyEntryResult_null,
        __ModifyEntryResult_information_unsigned,
        ___ModifyEntryResult_information_signed_toBeSigned,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyEntryResult_information_signed_algorithmIdentifier,
        ___ModifyEntryResult_information_signed_encrypted,
        __ModifyEntryResult_information_signed,
        _ModifyEntryResult_information,
        ModifyEntryResult,
        _ModifyEntryResultData_entry,
        _ModifyEntryResultData_securityParameters,
        _ModifyEntryResultData_performer,
        _ModifyEntryResultData_aliasDereferenced,
        ____ModifyEntryResultData_notification__item__type_tab,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_0,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_1,
        ___ModifyEntryResultData_notification__item__type,
        ____ModifyEntryResultData_notification__item__values__item_,
        ___ModifyEntryResultData_notification__item__values,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__value,
        ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyEntryResultData_notification__item__valuesWithContext__item_,
        ___ModifyEntryResultData_notification__item__valuesWithContext,
        __ModifyEntryResultData_notification__item_,
        _ModifyEntryResultData_notification,
        ModifyEntryResultData,
        ___EntryModification_addAttribute_type_tab,
        ____EntryModification_addAttribute_type_tab_val_Type_0,
        ____EntryModification_addAttribute_type_tab_val_Type_1,
        __EntryModification_addAttribute_type,
        ___EntryModification_addAttribute_values__item_,
        __EntryModification_addAttribute_values,
        ____EntryModification_addAttribute_valuesWithContext__item__value,
        _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_,
        ____EntryModification_addAttribute_valuesWithContext__item__contextList,
        ___EntryModification_addAttribute_valuesWithContext__item_,
        __EntryModification_addAttribute_valuesWithContext,
        _EntryModification_addAttribute,
        _EntryModification_removeAttribute,
        __EntryModification_addValues_type,
        ___EntryModification_addValues_values__item_,
        __EntryModification_addValues_values,
        ____EntryModification_addValues_valuesWithContext__item__value,
        _____EntryModification_addValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_addValues_valuesWithContext__item__contextList,
        ___EntryModification_addValues_valuesWithContext__item_,
        __EntryModification_addValues_valuesWithContext,
        _EntryModification_addValues,
        __EntryModification_removeValues_type,
        ___EntryModification_removeValues_values__item_,
        __EntryModification_removeValues_values,
        ____EntryModification_removeValues_valuesWithContext__item__value,
        _____EntryModification_removeValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_removeValues_valuesWithContext__item__contextList,
        ___EntryModification_removeValues_valuesWithContext__item_,
        __EntryModification_removeValues_valuesWithContext,
        _EntryModification_removeValues,
        _EntryModification_alterValues,
        _EntryModification_resetValue,
        __EntryModification_replaceValues_type,
        ___EntryModification_replaceValues_values__item_,
        __EntryModification_replaceValues_values,
        ____EntryModification_replaceValues_valuesWithContext__item__value,
        _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_replaceValues_valuesWithContext__item__contextList,
        ___EntryModification_replaceValues_valuesWithContext__item_,
        __EntryModification_replaceValues_valuesWithContext,
        _EntryModification_replaceValues,
        EntryModification,
        modifyDN,
        _modifyDN_val_ArgumentType,
        _modifyDN_val_ResultType,
        _ModifyDNArgument_unsigned,
        __ModifyDNArgument_signed_toBeSigned,
        ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_parameters,
        __ModifyDNArgument_signed_algorithmIdentifier,
        __ModifyDNArgument_signed_encrypted,
        _ModifyDNArgument_signed,
        ModifyDNArgument,
        _ModifyDNArgumentData_object,
        _ModifyDNArgumentData_newRDN,
        _ModifyDNArgumentData_deleteOldRDN,
        _ModifyDNArgumentData_newSuperior,
        _ModifyDNArgumentData_serviceControls,
        _ModifyDNArgumentData_securityParameters,
        _ModifyDNArgumentData_requestor,
        _ModifyDNArgumentData_operationProgress,
        _ModifyDNArgumentData_aliasedRDNs,
        _ModifyDNArgumentData_criticalExtensions,
        _ModifyDNArgumentData_referenceType,
        _ModifyDNArgumentData_entryOnly,
        _ModifyDNArgumentData_exclusions,
        _ModifyDNArgumentData_nameResolveOnMaster,
        _ModifyDNArgumentData_operationContexts,
        _ModifyDNArgumentData_familyGrouping,
        ModifyDNArgumentData,
        _ModifyDNResult_null,
        __ModifyDNResult_information_unsigned,
        ___ModifyDNResult_information_signed_toBeSigned,
        _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyDNResult_information_signed_algorithmIdentifier,
        ___ModifyDNResult_information_signed_encrypted,
        __ModifyDNResult_information_signed,
        _ModifyDNResult_information,
        ModifyDNResult,
        _ModifyDNResultData_newRDN,
        _ModifyDNResultData_securityParameters,
        _ModifyDNResultData_performer,
        _ModifyDNResultData_aliasDereferenced,
        ____ModifyDNResultData_notification__item__type_tab,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_0,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_1,
        ___ModifyDNResultData_notification__item__type,
        ____ModifyDNResultData_notification__item__values__item_,
        ___ModifyDNResultData_notification__item__values,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__value,
        ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyDNResultData_notification__item__valuesWithContext__item_,
        ___ModifyDNResultData_notification__item__valuesWithContext,
        __ModifyDNResultData_notification__item_,
        _ModifyDNResultData_notification,
        ModifyDNResultData,
        changePassword,
        _changePassword_val_ArgumentType,
        _changePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        _ChangePasswordArgument_unsigned,
        __ChangePasswordArgument_signed_toBeSigned,
        ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm,
        ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_parameters,
        __ChangePasswordArgument_signed_algorithmIdentifier,
        __ChangePasswordArgument_signed_encrypted,
        _ChangePasswordArgument_signed,
        ChangePasswordArgument,
        _ChangePasswordArgumentData_object,
        _ChangePasswordArgumentData_oldPwd,
        _ChangePasswordArgumentData_newPwd,
        ChangePasswordArgumentData,
        _ChangePasswordResult_null,
        __ChangePasswordResult_information_unsigned,
        ___ChangePasswordResult_information_signed_toBeSigned,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters,
        ___ChangePasswordResult_information_signed_algorithmIdentifier,
        ___ChangePasswordResult_information_signed_encrypted,
        __ChangePasswordResult_information_signed,
        _ChangePasswordResult_information,
        ChangePasswordResult,
        _ChangePasswordResultData_securityParameters,
        _ChangePasswordResultData_performer,
        _ChangePasswordResultData_aliasDereferenced,
        ____ChangePasswordResultData_notification__item__type_tab,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_0,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_1,
        ___ChangePasswordResultData_notification__item__type,
        ____ChangePasswordResultData_notification__item__values__item_,
        ___ChangePasswordResultData_notification__item__values,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__value,
        ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____ChangePasswordResultData_notification__item__valuesWithContext__item_,
        ___ChangePasswordResultData_notification__item__valuesWithContext,
        __ChangePasswordResultData_notification__item_,
        _ChangePasswordResultData_notification,
        ChangePasswordResultData,
        administerPassword,
        _administerPassword_val_ArgumentType,
        _administerPassword_val_ResultType,
        _AdministerPasswordArgument_unsigned,
        __AdministerPasswordArgument_signed_toBeSigned,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters,
        __AdministerPasswordArgument_signed_algorithmIdentifier,
        __AdministerPasswordArgument_signed_encrypted,
        _AdministerPasswordArgument_signed,
        AdministerPasswordArgument,
        _AdministerPasswordArgumentData_object,
        _AdministerPasswordArgumentData_newPwd,
        AdministerPasswordArgumentData,
        _AdministerPasswordResult_null,
        __AdministerPasswordResult_information_unsigned,
        ___AdministerPasswordResult_information_signed_toBeSigned,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters,
        ___AdministerPasswordResult_information_signed_algorithmIdentifier,
        ___AdministerPasswordResult_information_signed_encrypted,
        __AdministerPasswordResult_information_signed,
        _AdministerPasswordResult_information,
        AdministerPasswordResult,
        _AdministerPasswordResultData_securityParameters,
        _AdministerPasswordResultData_performer,
        _AdministerPasswordResultData_aliasDereferenced,
        ____AdministerPasswordResultData_notification__item__type_tab,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1,
        ___AdministerPasswordResultData_notification__item__type,
        ____AdministerPasswordResultData_notification__item__values__item_,
        ___AdministerPasswordResultData_notification__item__values,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value,
        ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____AdministerPasswordResultData_notification__item__valuesWithContext__item_,
        ___AdministerPasswordResultData_notification__item__valuesWithContext,
        __AdministerPasswordResultData_notification__item_,
        _AdministerPasswordResultData_notification,
        AdministerPasswordResultData,
        ldapTransport,
        _ldapTransport_val_ArgumentType,
        __ldapTransport_val_ResultType__item_,
        _ldapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        _LdapArgument_unsigned,
        __LdapArgument_signed_toBeSigned,
        ____LdapArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LdapArgument_signed_algorithmIdentifier_algorithm,
        ____LdapArgument_signed_algorithmIdentifier_parameters_tab,
        ___LdapArgument_signed_algorithmIdentifier_parameters,
        __LdapArgument_signed_algorithmIdentifier,
        __LdapArgument_signed_encrypted,
        _LdapArgument_signed,
        LdapArgument,
        _LdapArgumentData_object,
        _LdapArgumentData_ldapMessage,
        _LdapArgumentData_linkId,
        _LdapArgumentData_serviceControls,
        _LdapArgumentData_securityParameters,
        _LdapArgumentData_requestor,
        _LdapArgumentData_operationProgress,
        _LdapArgumentData_aliasedRDNs,
        _LdapArgumentData_criticalExtensions,
        _LdapArgumentData_referenceType,
        _LdapArgumentData_entryOnly,
        _LdapArgumentData_exclusions,
        _LdapArgumentData_nameResolveOnMaster,
        _LdapArgumentData_operationContexts,
        _LdapArgumentData_familyGrouping,
        LdapArgumentData,
        LinkId,
        _LdapResult_unsigned,
        __LdapResult_signed_toBeSigned,
        ____LdapResult_signed_algorithmIdentifier_algorithm_tab,
        ___LdapResult_signed_algorithmIdentifier_algorithm,
        ____LdapResult_signed_algorithmIdentifier_parameters_tab,
        ___LdapResult_signed_algorithmIdentifier_parameters,
        __LdapResult_signed_algorithmIdentifier,
        __LdapResult_signed_encrypted,
        _LdapResult_signed,
        LdapResult,
        __LdapResultData_ldapMessages__item_,
        _LdapResultData_ldapMessages,
        _LdapResultData_returnToClient,
        _LdapResultData_securityParameters,
        _LdapResultData_performer,
        _LdapResultData_aliasDereferenced,
        ____LdapResultData_notification__item__type_tab,
        _____LdapResultData_notification__item__type_tab_val_Type_0,
        _____LdapResultData_notification__item__type_tab_val_Type_1,
        ___LdapResultData_notification__item__type,
        ____LdapResultData_notification__item__values__item_,
        ___LdapResultData_notification__item__values,
        _____LdapResultData_notification__item__valuesWithContext__item__value,
        ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____LdapResultData_notification__item__valuesWithContext__item__contextList,
        ____LdapResultData_notification__item__valuesWithContext__item_,
        ___LdapResultData_notification__item__valuesWithContext,
        __LdapResultData_notification__item_,
        _LdapResultData_notification,
        LdapResultData,
        linkedLDAP,
        _linkedLDAP_val_ArgumentType,
        _linkedLDAP_val_ResultType,
        _LinkedArgument_unsigned,
        __LinkedArgument_signed_toBeSigned,
        ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LinkedArgument_signed_algorithmIdentifier_algorithm,
        ____LinkedArgument_signed_algorithmIdentifier_parameters_tab,
        ___LinkedArgument_signed_algorithmIdentifier_parameters,
        __LinkedArgument_signed_algorithmIdentifier,
        __LinkedArgument_signed_encrypted,
        _LinkedArgument_signed,
        LinkedArgument,
        _LinkedArgumentData_object,
        _LinkedArgumentData_ldapMessage,
        _LinkedArgumentData_linkId,
        _LinkedArgumentData_returnToClient,
        _LinkedArgumentData_serviceControls,
        _LinkedArgumentData_securityParameters,
        _LinkedArgumentData_requestor,
        _LinkedArgumentData_operationProgress,
        _LinkedArgumentData_aliasedRDNs,
        _LinkedArgumentData_criticalExtensions,
        _LinkedArgumentData_referenceType,
        _LinkedArgumentData_entryOnly,
        _LinkedArgumentData_exclusions,
        _LinkedArgumentData_nameResolveOnMaster,
        _LinkedArgumentData_operationContexts,
        _LinkedArgumentData_familyGrouping,
        LinkedArgumentData,
        LinkedResult,
        abandoned,
        __abandoned_val_ParameterType_unsigned,
        ___abandoned_val_ParameterType_signed_toBeSigned,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandoned_val_ParameterType_signed_algorithmIdentifier,
        ___abandoned_val_ParameterType_signed_encrypted,
        __abandoned_val_ParameterType_signed,
        _abandoned_val_ParameterType,
        _AbandonedData_problem,
        _AbandonedData_securityParameters,
        _AbandonedData_performer,
        _AbandonedData_aliasDereferenced,
        ____AbandonedData_notification__item__type_tab,
        _____AbandonedData_notification__item__type_tab_val_Type_0,
        _____AbandonedData_notification__item__type_tab_val_Type_1,
        ___AbandonedData_notification__item__type,
        ____AbandonedData_notification__item__values__item_,
        ___AbandonedData_notification__item__values,
        _____AbandonedData_notification__item__valuesWithContext__item__value,
        ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonedData_notification__item__valuesWithContext__item_,
        ___AbandonedData_notification__item__valuesWithContext,
        __AbandonedData_notification__item_,
        _AbandonedData_notification,
        AbandonedData,
        AbandonedProblem,
        abandonFailed,
        __abandonFailed_val_ParameterType_unsigned,
        ___abandonFailed_val_ParameterType_signed_toBeSigned,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandonFailed_val_ParameterType_signed_algorithmIdentifier,
        ___abandonFailed_val_ParameterType_signed_encrypted,
        __abandonFailed_val_ParameterType_signed,
        _abandonFailed_val_ParameterType,
        _AbandonFailedData_problem,
        _AbandonFailedData_operation,
        _AbandonFailedData_securityParameters,
        _AbandonFailedData_performer,
        _AbandonFailedData_aliasDereferenced,
        ____AbandonFailedData_notification__item__type_tab,
        _____AbandonFailedData_notification__item__type_tab_val_Type_0,
        _____AbandonFailedData_notification__item__type_tab_val_Type_1,
        ___AbandonFailedData_notification__item__type,
        ____AbandonFailedData_notification__item__values__item_,
        ___AbandonFailedData_notification__item__values,
        _____AbandonFailedData_notification__item__valuesWithContext__item__value,
        ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonFailedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonFailedData_notification__item__valuesWithContext__item_,
        ___AbandonFailedData_notification__item__valuesWithContext,
        __AbandonFailedData_notification__item_,
        _AbandonFailedData_notification,
        AbandonFailedData,
        AbandonProblem,
        attributeError,
        __attributeError_val_ParameterType_unsigned,
        ___attributeError_val_ParameterType_signed_toBeSigned,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___attributeError_val_ParameterType_signed_algorithmIdentifier,
        ___attributeError_val_ParameterType_signed_encrypted,
        __attributeError_val_ParameterType_signed,
        _attributeError_val_ParameterType,
        _AttributeErrorData_object,
        ___AttributeErrorData_problems__item__problem,
        ___AttributeErrorData_problems__item__type,
        ___AttributeErrorData_problems__item__value,
        __AttributeErrorData_problems__item_,
        _AttributeErrorData_problems,
        _AttributeErrorData_securityParameters,
        _AttributeErrorData_performer,
        _AttributeErrorData_aliasDereferenced,
        ____AttributeErrorData_notification__item__type_tab,
        _____AttributeErrorData_notification__item__type_tab_val_Type_0,
        _____AttributeErrorData_notification__item__type_tab_val_Type_1,
        ___AttributeErrorData_notification__item__type,
        ____AttributeErrorData_notification__item__values__item_,
        ___AttributeErrorData_notification__item__values,
        _____AttributeErrorData_notification__item__valuesWithContext__item__value,
        ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____AttributeErrorData_notification__item__valuesWithContext__item__contextList,
        ____AttributeErrorData_notification__item__valuesWithContext__item_,
        ___AttributeErrorData_notification__item__valuesWithContext,
        __AttributeErrorData_notification__item_,
        _AttributeErrorData_notification,
        AttributeErrorData,
        AttributeProblem,
        nameError,
        __nameError_val_ParameterType_unsigned,
        ___nameError_val_ParameterType_signed_toBeSigned,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___nameError_val_ParameterType_signed_algorithmIdentifier,
        ___nameError_val_ParameterType_signed_encrypted,
        __nameError_val_ParameterType_signed,
        _nameError_val_ParameterType,
        _NameErrorData_problem,
        _NameErrorData_matched,
        _NameErrorData_securityParameters,
        _NameErrorData_performer,
        _NameErrorData_aliasDereferenced,
        ____NameErrorData_notification__item__type_tab,
        _____NameErrorData_notification__item__type_tab_val_Type_0,
        _____NameErrorData_notification__item__type_tab_val_Type_1,
        ___NameErrorData_notification__item__type,
        ____NameErrorData_notification__item__values__item_,
        ___NameErrorData_notification__item__values,
        _____NameErrorData_notification__item__valuesWithContext__item__value,
        ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____NameErrorData_notification__item__valuesWithContext__item__contextList,
        ____NameErrorData_notification__item__valuesWithContext__item_,
        ___NameErrorData_notification__item__valuesWithContext,
        __NameErrorData_notification__item_,
        _NameErrorData_notification,
        NameErrorData,
        NameProblem,
        referral,
        __referral_val_ParameterType_unsigned,
        ___referral_val_ParameterType_signed_toBeSigned,
        _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___referral_val_ParameterType_signed_algorithmIdentifier,
        ___referral_val_ParameterType_signed_encrypted,
        __referral_val_ParameterType_signed,
        _referral_val_ParameterType,
        _ReferralData_candidate,
        _ReferralData_securityParameters,
        _ReferralData_performer,
        _ReferralData_aliasDereferenced,
        ____ReferralData_notification__item__type_tab,
        _____ReferralData_notification__item__type_tab_val_Type_0,
        _____ReferralData_notification__item__type_tab_val_Type_1,
        ___ReferralData_notification__item__type,
        ____ReferralData_notification__item__values__item_,
        ___ReferralData_notification__item__values,
        _____ReferralData_notification__item__valuesWithContext__item__value,
        ______ReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReferralData_notification__item__valuesWithContext__item__contextList,
        ____ReferralData_notification__item__valuesWithContext__item_,
        ___ReferralData_notification__item__valuesWithContext,
        __ReferralData_notification__item_,
        _ReferralData_notification,
        ReferralData,
        securityError,
        __securityError_val_ParameterType_unsigned,
        ___securityError_val_ParameterType_signed_toBeSigned,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___securityError_val_ParameterType_signed_algorithmIdentifier,
        ___securityError_val_ParameterType_signed_encrypted,
        __securityError_val_ParameterType_signed,
        _securityError_val_ParameterType,
        _SecurityErrorData_problem,
        _SecurityErrorData_spkmInfo,
        _SecurityErrorData_encPwdInfo,
        _SecurityErrorData_securityParameters,
        _SecurityErrorData_performer,
        _SecurityErrorData_aliasDereferenced,
        ____SecurityErrorData_notification__item__type_tab,
        _____SecurityErrorData_notification__item__type_tab_val_Type_0,
        _____SecurityErrorData_notification__item__type_tab_val_Type_1,
        ___SecurityErrorData_notification__item__type,
        ____SecurityErrorData_notification__item__values__item_,
        ___SecurityErrorData_notification__item__values,
        _____SecurityErrorData_notification__item__valuesWithContext__item__value,
        ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____SecurityErrorData_notification__item__valuesWithContext__item__contextList,
        ____SecurityErrorData_notification__item__valuesWithContext__item_,
        ___SecurityErrorData_notification__item__valuesWithContext,
        __SecurityErrorData_notification__item_,
        _SecurityErrorData_notification,
        SecurityErrorData,
        SecurityProblem,
        ____EncPwdInfo_algorithms__item__algorithm_tab,
        ___EncPwdInfo_algorithms__item__algorithm,
        ____EncPwdInfo_algorithms__item__parameters_tab,
        ___EncPwdInfo_algorithms__item__parameters,
        __EncPwdInfo_algorithms__item_,
        _EncPwdInfo_algorithms,
        __EncPwdInfo_pwdQualityRule__item_,
        _EncPwdInfo_pwdQualityRule,
        EncPwdInfo,
        serviceError,
        __serviceError_val_ParameterType_unsigned,
        ___serviceError_val_ParameterType_signed_toBeSigned,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___serviceError_val_ParameterType_signed_algorithmIdentifier,
        ___serviceError_val_ParameterType_signed_encrypted,
        __serviceError_val_ParameterType_signed,
        _serviceError_val_ParameterType,
        _ServiceErrorData_problem,
        _ServiceErrorData_securityParameters,
        _ServiceErrorData_performer,
        _ServiceErrorData_aliasDereferenced,
        ____ServiceErrorData_notification__item__type_tab,
        _____ServiceErrorData_notification__item__type_tab_val_Type_0,
        _____ServiceErrorData_notification__item__type_tab_val_Type_1,
        ___ServiceErrorData_notification__item__type,
        ____ServiceErrorData_notification__item__values__item_,
        ___ServiceErrorData_notification__item__values,
        _____ServiceErrorData_notification__item__valuesWithContext__item__value,
        ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ServiceErrorData_notification__item__valuesWithContext__item__contextList,
        ____ServiceErrorData_notification__item__valuesWithContext__item_,
        ___ServiceErrorData_notification__item__valuesWithContext,
        __ServiceErrorData_notification__item_,
        _ServiceErrorData_notification,
        ServiceErrorData,
        ServiceProblem,
        updateError,
        __updateError_val_ParameterType_unsigned,
        ___updateError_val_ParameterType_signed_toBeSigned,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___updateError_val_ParameterType_signed_algorithmIdentifier,
        ___updateError_val_ParameterType_signed_encrypted,
        __updateError_val_ParameterType_signed,
        _updateError_val_ParameterType,
        _UpdateErrorData_problem,
        ___UpdateErrorData_attributeInfo__item__attributeType,
        _____UpdateErrorData_attributeInfo__item__attribute_type_tab,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1,
        ____UpdateErrorData_attributeInfo__item__attribute_type,
        _____UpdateErrorData_attributeInfo__item__attribute_values__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_values,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value,
        _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList,
        _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext,
        ___UpdateErrorData_attributeInfo__item__attribute,
        __UpdateErrorData_attributeInfo__item_,
        _UpdateErrorData_attributeInfo,
        _UpdateErrorData_securityParameters,
        _UpdateErrorData_performer,
        _UpdateErrorData_aliasDereferenced,
        ___UpdateErrorData_notification__item__type,
        ____UpdateErrorData_notification__item__values__item_,
        ___UpdateErrorData_notification__item__values,
        _____UpdateErrorData_notification__item__valuesWithContext__item__value,
        ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateErrorData_notification__item__valuesWithContext__item__contextList,
        ____UpdateErrorData_notification__item__valuesWithContext__item_,
        ___UpdateErrorData_notification__item__valuesWithContext,
        __UpdateErrorData_notification__item_,
        _UpdateErrorData_notification,
        UpdateErrorData,
        UpdateProblem,
        id_at_family_information,
    ]

class DirectoryOperationalBindingTypes:

    _name_  = 'DirectoryOperationalBindingTypes'
    _oid_   = [2, 5, 1, 25, 7]
    
    _obj_ = [
        'id-op-binding-shadow',
        'id-op-binding-hierarchical',
        'id-op-binding-non-specific-hierarchical',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-op-binding-shadow',
        'id-op-binding-hierarchical',
        'id-op-binding-non-specific-hierarchical',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-op-binding-shadow >-----#
    id_op_binding_shadow = OID(name='id-op-binding-shadow', mode=MODE_VALUE)
    id_op_binding_shadow._val = (2, 5, 19, 1)
    
    #-----< id-op-binding-hierarchical >-----#
    id_op_binding_hierarchical = OID(name='id-op-binding-hierarchical', mode=MODE_VALUE)
    id_op_binding_hierarchical._val = (2, 5, 19, 2)
    
    #-----< id-op-binding-non-specific-hierarchical >-----#
    id_op_binding_non_specific_hierarchical = OID(name='id-op-binding-non-specific-hierarchical', mode=MODE_VALUE)
    id_op_binding_non_specific_hierarchical._val = (2, 5, 19, 3)
    
    _all_ = [
        id_op_binding_shadow,
        id_op_binding_hierarchical,
        id_op_binding_non_specific_hierarchical,
    ]

class DirectoryOSIProtocols:

    _name_  = 'DirectoryOSIProtocols'
    _oid_   = [2, 5, 1, 37, 7]
    
    _obj_ = [
        'DAP-OSI-PDUs',
        'DSP-OSI-PDUs',
        'DOP-OSI-PDUs',
        'ShadowSupplierInitiatedDISP-OSI-PDUs',
        'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        'ShadowConsumerInitiatedDISP-OSI-PDUs',
        'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        'APPLICATION-CONTEXT',
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        'id-as-directoryAccessAS',
        'id-as-directorySystemAS',
        'id-as-directoryShadowAS',
        'id-as-directoryOperationalBindingManagementAS',
        'id-acseAS',
        'id-ac-directoryAccessAC',
        'id-ac-directorySystemAC',
        'id-ac-directoryOperationalBindingManagementAC',
        'id-ac-shadowConsumerInitiatedAC',
        'id-ac-shadowSupplierInitiatedAC',
        'id-ac-shadowSupplierInitiatedAsynchronousAC',
        'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _type_ = [
        'DAP-OSI-PDUs',
        'DSP-OSI-PDUs',
        'DOP-OSI-PDUs',
        'ShadowSupplierInitiatedDISP-OSI-PDUs',
        'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        'ShadowConsumerInitiatedDISP-OSI-PDUs',
        'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        'APPLICATION-CONTEXT',
        ]
    _set_ = [
        ]
    _val_ = [
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        'id-as-directoryAccessAS',
        'id-as-directorySystemAS',
        'id-as-directoryShadowAS',
        'id-as-directoryOperationalBindingManagementAS',
        'id-acseAS',
        'id-ac-directoryAccessAC',
        'id-ac-directorySystemAC',
        'id-ac-directoryOperationalBindingManagementAC',
        'id-ac-shadowConsumerInitiatedAC',
        'id-ac-shadowSupplierInitiatedAC',
        'id-ac-shadowSupplierInitiatedAsynchronousAC',
        'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _class_ = [
        'APPLICATION-CONTEXT',
        'directoryAccessAC',
        'directorySystemAC',
        'shadowSupplierInitiatedAC',
        'shadowConsumerInitiatedAC',
        'shadowSupplierInitiatedAsynchronousAC',
        'shadowConsumerInitiatedAsynchronousAC',
        'directoryOperationalBindingManagementAC',
        ]
    _param_ = [
        ]
    
    #-----< DAP-OSI-PDUs >-----#
    DAP_OSI_PDUs = OPEN(name='DAP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DAP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DAP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DAP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_0_mode_selector._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DAP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_0._ext = None
    _DAP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DAP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DAP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_1_mode_selector._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DAP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_1._ext = None
    _DAP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DAP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DAP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_2._ext = None
    _DAP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DAP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), ('ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DAP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DAP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DAP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DAP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DAP_OSI_PDUs_val_3._ext = None
    _DAP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DAP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DAP_OSI_PDUs._const_val = ASN1Set(rv=[_DAP_OSI_PDUs_val_0, _DAP_OSI_PDUs_val_1, _DAP_OSI_PDUs_val_2, _DAP_OSI_PDUs_val_3, _DAP_OSI_PDUs_val_4, _DAP_OSI_PDUs_val_5], ev=None)
    
    #-----< DSP-OSI-PDUs >-----#
    DSP_OSI_PDUs = OPEN(name='DSP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DSP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DSP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DSP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_0_mode_selector._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DSP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_0._ext = None
    _DSP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DSP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DSP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_1_mode_selector._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DSP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_1._ext = None
    _DSP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DSP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DSP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_2._ext = None
    _DSP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DSP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_Errors_val_ParameterType_3_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_2._ext = None
    __OPERATION_Errors_val_ParameterType_4_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_2._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_3._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType._cont = _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_4._ext = None
    __OPERATION_Errors_val_ParameterType_2_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult),
        ('result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier),
        ('encrypted', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_encrypted),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned),
        ('signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._ext = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_4), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_3), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12), ('ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DSP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DSP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DSP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DSP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DSP_OSI_PDUs_val_3._ext = None
    _DSP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DSP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DSP_OSI_PDUs._const_val = ASN1Set(rv=[_DSP_OSI_PDUs_val_0, _DSP_OSI_PDUs_val_1, _DSP_OSI_PDUs_val_2, _DSP_OSI_PDUs_val_3, _DSP_OSI_PDUs_val_4, _DSP_OSI_PDUs_val_5], ev=None)
    
    #-----< DOP-OSI-PDUs >-----#
    DOP_OSI_PDUs = OPEN(name='DOP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DOP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DOP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DOP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_0_mode_selector._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __DOP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_0._ext = None
    _DOP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DOP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___DOP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_1_mode_selector._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __DOP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_1._ext = None
    _DOP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DOP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __DOP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_2._ext = None
    _DOP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DOP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_4_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_4_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_4._ext = None
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), ('ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DOP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DOP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DOP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __DOP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DOP_OSI_PDUs_val_3._ext = None
    _DOP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DOP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DOP_OSI_PDUs._const_val = ASN1Set(rv=[_DOP_OSI_PDUs_val_0, _DOP_OSI_PDUs_val_1, _DOP_OSI_PDUs_val_2, _DOP_OSI_PDUs_val_3, _DOP_OSI_PDUs_val_4, _DOP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedDISP_OSI_PDUs = OPEN(name='ShadowSupplierInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_5_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_5_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_5._ext = None
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name='ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedDISP_OSI_PDUs = OPEN(name='ShadowConsumerInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name='ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name='calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name='called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name='presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name='called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name='called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name='called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name='called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name='calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name='calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name='calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name='calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('called-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        ('called-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        ('called-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        ('called-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        ('calling-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        ('calling-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        ('calling-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        ('calling-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        ('calling-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        ('called-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        ('presentation-context-definition-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name='mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name='mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        ('mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        ('result', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        ('transfer-syntax-name', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        ('mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([('version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name='responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name='presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name='protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([('version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name='application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name='result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name='responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name='responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name='responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name='responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name='implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name='user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        ('application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        ('responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        ('responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        ('responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        ('responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        ('implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        ('user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        ('presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        ('protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        ('responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        ('presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        ('provider-reason', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        ('user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        ('normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name='request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([('ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), ('ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), ('ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = 'operationCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name='argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ArgumentType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', 'opcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = 'ArgumentType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        ('opcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        ('argument', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name='result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name='result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name='opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = 'operationCode'
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name='result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['ResultType']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', 'opcode')
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = 'ResultType'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        ('opcode', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        ('result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        ('invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        ('result', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name='invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name='errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'errorCode']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = 'errorCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name='error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), ['Errors', 'ParameterType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', 'errcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = 'ParameterType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        ('invokeID', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        ('errcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        ('error', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name='reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        ('request', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        ('result', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        ('error', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        ('reject', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        ('fully-encoded-data', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name='APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_bind_operation = CLASS(name='bind-operation', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_Operations = CLASS(name='Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_applicationContextName = OID(name='applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        ('bind-operation', _APPLICATION_CONTEXT_bind_operation),
        ('Operations', _APPLICATION_CONTEXT_Operations),
        ('applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< directoryAccessAC >-----#
    directoryAccessAC = CLASS(name='directoryAccessAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_6_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    directoryAccessAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 1))])
    
    #-----< directorySystemAC >-----#
    directorySystemAC = CLASS(name='directorySystemAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0 = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType_0 = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    directorySystemAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_2), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_4), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_3), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))])
    
    #-----< shadowSupplierInitiatedAC >-----#
    shadowSupplierInitiatedAC = CLASS(name='shadowSupplierInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    shadowSupplierInitiatedAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])
    
    #-----< shadowConsumerInitiatedAC >-----#
    shadowConsumerInitiatedAC = CLASS(name='shadowConsumerInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    shadowConsumerInitiatedAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])
    
    #-----< shadowSupplierInitiatedAsynchronousAC >-----#
    shadowSupplierInitiatedAsynchronousAC = CLASS(name='shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowSupplierInitiatedAsynchronousAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 8))])
    
    #-----< shadowConsumerInitiatedAsynchronousAC >-----#
    shadowConsumerInitiatedAsynchronousAC = CLASS(name='shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowConsumerInitiatedAsynchronousAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_5), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 9))])
    
    #-----< directoryOperationalBindingManagementAC >-----#
    directoryOperationalBindingManagementAC = CLASS(name='directoryOperationalBindingManagementAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    directoryOperationalBindingManagementAC._val = dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_4), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_3), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 3))])
    
    #-----< id-as-directoryAccessAS >-----#
    id_as_directoryAccessAS = OID(name='id-as-directoryAccessAS', mode=MODE_VALUE)
    id_as_directoryAccessAS._val = (2, 5, 9, 1)
    
    #-----< id-as-directorySystemAS >-----#
    id_as_directorySystemAS = OID(name='id-as-directorySystemAS', mode=MODE_VALUE)
    id_as_directorySystemAS._val = (2, 5, 9, 2)
    
    #-----< id-as-directoryShadowAS >-----#
    id_as_directoryShadowAS = OID(name='id-as-directoryShadowAS', mode=MODE_VALUE)
    id_as_directoryShadowAS._val = (2, 5, 9, 3)
    
    #-----< id-as-directoryOperationalBindingManagementAS >-----#
    id_as_directoryOperationalBindingManagementAS = OID(name='id-as-directoryOperationalBindingManagementAS', mode=MODE_VALUE)
    id_as_directoryOperationalBindingManagementAS._val = (2, 5, 9, 4)
    
    #-----< id-acseAS >-----#
    id_acseAS = OID(name='id-acseAS', mode=MODE_VALUE)
    id_acseAS._val = (2, 2, 1, 0, 1)
    
    #-----< id-ac-directoryAccessAC >-----#
    id_ac_directoryAccessAC = OID(name='id-ac-directoryAccessAC', mode=MODE_VALUE)
    id_ac_directoryAccessAC._val = (2, 5, 3, 1)
    
    #-----< id-ac-directorySystemAC >-----#
    id_ac_directorySystemAC = OID(name='id-ac-directorySystemAC', mode=MODE_VALUE)
    id_ac_directorySystemAC._val = (2, 5, 3, 2)
    
    #-----< id-ac-directoryOperationalBindingManagementAC >-----#
    id_ac_directoryOperationalBindingManagementAC = OID(name='id-ac-directoryOperationalBindingManagementAC', mode=MODE_VALUE)
    id_ac_directoryOperationalBindingManagementAC._val = (2, 5, 3, 3)
    
    #-----< id-ac-shadowConsumerInitiatedAC >-----#
    id_ac_shadowConsumerInitiatedAC = OID(name='id-ac-shadowConsumerInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAC._val = (2, 5, 3, 4)
    
    #-----< id-ac-shadowSupplierInitiatedAC >-----#
    id_ac_shadowSupplierInitiatedAC = OID(name='id-ac-shadowSupplierInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAC._val = (2, 5, 3, 5)
    
    #-----< id-ac-shadowSupplierInitiatedAsynchronousAC >-----#
    id_ac_shadowSupplierInitiatedAsynchronousAC = OID(name='id-ac-shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAsynchronousAC._val = (2, 5, 3, 8)
    
    #-----< id-ac-shadowConsumerInitiatedAsynchronousAC >-----#
    id_ac_shadowConsumerInitiatedAsynchronousAC = OID(name='id-ac-shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAsynchronousAC._val = (2, 5, 3, 9)
    
    _all_ = [
        ___DAP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_0_mode_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_0_normal_mode_parameters,
        _DAP_OSI_PDUs_val_0,
        ___DAP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_1_mode_selector,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_1_normal_mode_parameters,
        _DAP_OSI_PDUs_val_1,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_2_normal_mode_parameters,
        _DAP_OSI_PDUs_val_2,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DAP_OSI_PDUs_val_3_fully_encoded_data,
        _DAP_OSI_PDUs_val_3,
        _DAP_OSI_PDUs_val_4,
        _DAP_OSI_PDUs_val_5,
        DAP_OSI_PDUs,
        ___DSP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_0_mode_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_0_normal_mode_parameters,
        _DSP_OSI_PDUs_val_0,
        ___DSP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_1_mode_selector,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_1_normal_mode_parameters,
        _DSP_OSI_PDUs_val_1,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_2_normal_mode_parameters,
        _DSP_OSI_PDUs_val_2,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_Errors_val_ParameterType_3_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_2_signed,
        __OPERATION_Errors_val_ParameterType_3_2,
        ___OPERATION_Errors_val_ParameterType_4_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_2_signed,
        __OPERATION_Errors_val_ParameterType_4_2,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_3_signed,
        __OPERATION_Errors_val_ParameterType_1_3,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_4_signed,
        __OPERATION_Errors_val_ParameterType_1_4,
        ___OPERATION_Errors_val_ParameterType_2_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_3_signed,
        __OPERATION_Errors_val_ParameterType_2_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_encrypted,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DSP_OSI_PDUs_val_3_fully_encoded_data,
        _DSP_OSI_PDUs_val_3,
        _DSP_OSI_PDUs_val_4,
        _DSP_OSI_PDUs_val_5,
        DSP_OSI_PDUs,
        ___DOP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_0_mode_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_0_normal_mode_parameters,
        _DOP_OSI_PDUs_val_0,
        ___DOP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_1_mode_selector,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_1_normal_mode_parameters,
        _DOP_OSI_PDUs_val_1,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_2_normal_mode_parameters,
        _DOP_OSI_PDUs_val_2,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_4_signed,
        __OPERATION_Errors_val_ParameterType_0_4,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DOP_OSI_PDUs_val_3_fully_encoded_data,
        _DOP_OSI_PDUs_val_3,
        _DOP_OSI_PDUs_val_4,
        _DOP_OSI_PDUs_val_5,
        DOP_OSI_PDUs,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_5_signed,
        __OPERATION_Errors_val_ParameterType_0_5,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedDISP_OSI_PDUs,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs,
        _APPLICATION_CONTEXT_bind_operation,
        _APPLICATION_CONTEXT_Operations,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        directoryAccessAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_6_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_6_signed,
        __OPERATION_Errors_val_ParameterType_0_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        directorySystemAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        shadowSupplierInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        shadowConsumerInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_2,
        shadowSupplierInitiatedAsynchronousAC,
        shadowConsumerInitiatedAsynchronousAC,
        directoryOperationalBindingManagementAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2_0,
        id_as_directoryAccessAS,
        id_as_directorySystemAS,
        id_as_directoryShadowAS,
        id_as_directoryOperationalBindingManagementAS,
        id_acseAS,
        id_ac_directoryAccessAC,
        id_ac_directorySystemAC,
        id_ac_directoryOperationalBindingManagementAC,
        id_ac_shadowConsumerInitiatedAC,
        id_ac_shadowSupplierInitiatedAC,
        id_ac_shadowSupplierInitiatedAsynchronousAC,
        id_ac_shadowConsumerInitiatedAsynchronousAC,
    ]

class DirectoryShadowAbstractService:

    _name_  = 'DirectoryShadowAbstractService'
    _oid_   = [2, 5, 1, 15, 7]
    
    _obj_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'ModificationParameter',
        'AgreementID',
        'ShadowingAgreementInfo',
        'UnitOfReplication',
        'AreaSpecification',
        'Knowledge',
        'AttributeSelection',
        'ClassAttributeSelection',
        'ClassAttributes',
        'AttributeTypes',
        'UpdateMode',
        'SupplierUpdateMode',
        'ConsumerUpdateMode',
        'SchedulingParameters',
        'PeriodicStrategy',
        'Time',
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        'coordinateShadowUpdate',
        'CoordinateShadowUpdateArgument',
        'CoordinateShadowUpdateArgumentData',
        'CoordinateShadowUpdateResult',
        'CoordinateShadowUpdateResultData',
        'requestShadowUpdate',
        'RequestShadowUpdateArgument',
        'RequestShadowUpdateArgumentData',
        'RequestShadowUpdateResult',
        'RequestShadowUpdateResultData',
        'updateShadow',
        'UpdateShadowArgument',
        'UpdateShadowArgumentData',
        'UpdateShadowResult',
        'UpdateShadowResultData',
        'UpdateWindow',
        'RefreshInformation',
        'TotalRefresh',
        'SDSEContent',
        'SDSEType',
        'Subtree',
        'IncrementalRefresh',
        'IncrementalStepRefresh',
        'ContentChange',
        'SubordinateChanges',
        'shadowError',
        'ShadowErrorData',
        'ShadowProblem',
        ]
    _type_ = [
        'ModificationParameter',
        'AgreementID',
        'ShadowingAgreementInfo',
        'UnitOfReplication',
        'AreaSpecification',
        'Knowledge',
        'AttributeSelection',
        'ClassAttributeSelection',
        'ClassAttributes',
        'AttributeTypes',
        'UpdateMode',
        'SupplierUpdateMode',
        'ConsumerUpdateMode',
        'SchedulingParameters',
        'PeriodicStrategy',
        'Time',
        'CoordinateShadowUpdateArgument',
        'CoordinateShadowUpdateArgumentData',
        'CoordinateShadowUpdateResult',
        'CoordinateShadowUpdateResultData',
        'RequestShadowUpdateArgument',
        'RequestShadowUpdateArgumentData',
        'RequestShadowUpdateResult',
        'RequestShadowUpdateResultData',
        'UpdateShadowArgument',
        'UpdateShadowArgumentData',
        'UpdateShadowResult',
        'UpdateShadowResultData',
        'UpdateWindow',
        'RefreshInformation',
        'TotalRefresh',
        'SDSEContent',
        'SDSEType',
        'Subtree',
        'IncrementalRefresh',
        'IncrementalStepRefresh',
        'ContentChange',
        'SubordinateChanges',
        'ShadowErrorData',
        'ShadowProblem',
        ]
    _set_ = [
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        ]
    _val_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'coordinateShadowUpdate',
        'requestShadowUpdate',
        'updateShadow',
        'shadowError',
        ]
    _class_ = [
        'dSAShadowBind',
        'shadowOperationalBinding',
        'All-operations-consumer-initiated',
        'All-operations-supplier-initiated',
        'coordinateShadowUpdate',
        'requestShadowUpdate',
        'updateShadow',
        'shadowError',
        ]
    _param_ = [
        ]
    
    #-----< dSAShadowBind >-----#
    dSAShadowBind = CLASS(name='dSAShadowBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAShadowBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAShadowBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAShadowBind._val = dict([('ArgumentType', _dSAShadowBind_val_ArgumentType), ('ResultType', _dSAShadowBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< shadowOperationalBinding >-----#
    shadowOperationalBinding = CLASS(name='shadowOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _shadowOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __shadowOperationalBinding_roleA_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    shadowOperationalBinding._val = dict([('Agreement', _shadowOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), ('ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))])
    
    #-----< ModificationParameter >-----#
    ModificationParameter = SEQ(name='ModificationParameter', mode=MODE_TYPE)
    _ModificationParameter_secondaryShadows = SET_OF(name='secondaryShadows', mode=MODE_TYPE)
    __ModificationParameter_secondaryShadows__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    _ModificationParameter_secondaryShadows._cont = __ModificationParameter_secondaryShadows__item_
    ModificationParameter._cont = ASN1Dict([
        ('secondaryShadows', _ModificationParameter_secondaryShadows),
        ])
    ModificationParameter._ext = []
    
    #-----< AgreementID >-----#
    AgreementID = SEQ(name='AgreementID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    
    #-----< ShadowingAgreementInfo >-----#
    ShadowingAgreementInfo = SEQ(name='ShadowingAgreementInfo', mode=MODE_TYPE)
    _ShadowingAgreementInfo_shadowSubject = SEQ(name='shadowSubject', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UnitOfReplication')))
    _ShadowingAgreementInfo_updateMode = CHOICE(name='updateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateMode')), default=('supplierInitiated', ('onChange', True)))
    _ShadowingAgreementInfo_master = SET(name='master', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ShadowingAgreementInfo_secondaryShadows = BOOL(name='secondaryShadows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ShadowingAgreementInfo._cont = ASN1Dict([
        ('shadowSubject', _ShadowingAgreementInfo_shadowSubject),
        ('updateMode', _ShadowingAgreementInfo_updateMode),
        ('master', _ShadowingAgreementInfo_master),
        ('secondaryShadows', _ShadowingAgreementInfo_secondaryShadows),
        ])
    ShadowingAgreementInfo._ext = None
    
    #-----< UnitOfReplication >-----#
    UnitOfReplication = SEQ(name='UnitOfReplication', mode=MODE_TYPE)
    _UnitOfReplication_area = SEQ(name='area', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AreaSpecification')))
    _UnitOfReplication_attributes = SET_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeSelection')))
    _UnitOfReplication_knowledge = SEQ(name='knowledge', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Knowledge')), opt=True)
    _UnitOfReplication_subordinates = BOOL(name='subordinates', mode=MODE_TYPE, default=False)
    _UnitOfReplication_contextSelection = CHOICE(name='contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _UnitOfReplication_supplyContexts = CHOICE(name='supplyContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UnitOfReplication_supplyContexts_allContexts = NULL(name='allContexts', mode=MODE_TYPE)
    __UnitOfReplication_supplyContexts_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE)
    ___UnitOfReplication_supplyContexts_selectedContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __UnitOfReplication_supplyContexts_selectedContexts._cont = ___UnitOfReplication_supplyContexts_selectedContexts__item_
    __UnitOfReplication_supplyContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnitOfReplication_supplyContexts._cont = ASN1Dict([
        ('allContexts', __UnitOfReplication_supplyContexts_allContexts),
        ('selectedContexts', __UnitOfReplication_supplyContexts_selectedContexts),
        ])
    _UnitOfReplication_supplyContexts._ext = []
    UnitOfReplication._cont = ASN1Dict([
        ('area', _UnitOfReplication_area),
        ('attributes', _UnitOfReplication_attributes),
        ('knowledge', _UnitOfReplication_knowledge),
        ('subordinates', _UnitOfReplication_subordinates),
        ('contextSelection', _UnitOfReplication_contextSelection),
        ('supplyContexts', _UnitOfReplication_supplyContexts),
        ])
    UnitOfReplication._ext = None
    
    #-----< AreaSpecification >-----#
    AreaSpecification = SEQ(name='AreaSpecification', mode=MODE_TYPE)
    _AreaSpecification_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AreaSpecification_replicationArea = SEQ(name='replicationArea', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    AreaSpecification._cont = ASN1Dict([
        ('contextPrefix', _AreaSpecification_contextPrefix),
        ('replicationArea', _AreaSpecification_replicationArea),
        ])
    AreaSpecification._ext = []
    
    #-----< Knowledge >-----#
    Knowledge = SEQ(name='Knowledge', mode=MODE_TYPE)
    _Knowledge_knowledgeType = ENUM(name='knowledgeType', mode=MODE_TYPE)
    _Knowledge_knowledgeType._cont = ASN1Dict([('master', 0), ('shadow', 1), ('both', 2)])
    _Knowledge_knowledgeType._ext = None
    _Knowledge_extendedKnowledge = BOOL(name='extendedKnowledge', mode=MODE_TYPE, default=False)
    Knowledge._cont = ASN1Dict([
        ('knowledgeType', _Knowledge_knowledgeType),
        ('extendedKnowledge', _Knowledge_extendedKnowledge),
        ])
    Knowledge._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SET_OF(name='AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributeSelection')))
    AttributeSelection._cont = _AttributeSelection__item_
    
    #-----< ClassAttributeSelection >-----#
    ClassAttributeSelection = SEQ(name='ClassAttributeSelection', mode=MODE_TYPE)
    _ClassAttributeSelection_class_ = OID(name='class', mode=MODE_TYPE, opt=True)
    _ClassAttributeSelection_classAttributes = CHOICE(name='classAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributes')), default=('allAttributes', 0))
    ClassAttributeSelection._cont = ASN1Dict([
        ('class', _ClassAttributeSelection_class_),
        ('classAttributes', _ClassAttributeSelection_classAttributes),
        ])
    ClassAttributeSelection._ext = None
    
    #-----< ClassAttributes >-----#
    ClassAttributes = CHOICE(name='ClassAttributes', mode=MODE_TYPE)
    _ClassAttributes_allAttributes = NULL(name='allAttributes', mode=MODE_TYPE)
    _ClassAttributes_include = SET_OF(name='include', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    _ClassAttributes_exclude = SET_OF(name='exclude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    ClassAttributes._cont = ASN1Dict([
        ('allAttributes', _ClassAttributes_allAttributes),
        ('include', _ClassAttributes_include),
        ('exclude', _ClassAttributes_exclude),
        ])
    ClassAttributes._ext = []
    
    #-----< AttributeTypes >-----#
    AttributeTypes = SET_OF(name='AttributeTypes', mode=MODE_TYPE)
    _AttributeTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    AttributeTypes._cont = _AttributeTypes__item_
    
    #-----< UpdateMode >-----#
    UpdateMode = CHOICE(name='UpdateMode', mode=MODE_TYPE)
    _UpdateMode_supplierInitiated = CHOICE(name='supplierInitiated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SupplierUpdateMode')))
    _UpdateMode_consumerInitiated = SEQ(name='consumerInitiated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ConsumerUpdateMode')))
    UpdateMode._cont = ASN1Dict([
        ('supplierInitiated', _UpdateMode_supplierInitiated),
        ('consumerInitiated', _UpdateMode_consumerInitiated),
        ])
    UpdateMode._ext = []
    
    #-----< SupplierUpdateMode >-----#
    SupplierUpdateMode = CHOICE(name='SupplierUpdateMode', mode=MODE_TYPE)
    _SupplierUpdateMode_onChange = BOOL(name='onChange', mode=MODE_TYPE)
    _SupplierUpdateMode_scheduled = SEQ(name='scheduled', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    SupplierUpdateMode._cont = ASN1Dict([
        ('onChange', _SupplierUpdateMode_onChange),
        ('scheduled', _SupplierUpdateMode_scheduled),
        ])
    SupplierUpdateMode._ext = []
    
    #-----< ConsumerUpdateMode >-----#
    ConsumerUpdateMode = SEQ(name='ConsumerUpdateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    
    #-----< SchedulingParameters >-----#
    SchedulingParameters = SEQ(name='SchedulingParameters', mode=MODE_TYPE)
    _SchedulingParameters_periodic = SEQ(name='periodic', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'PeriodicStrategy')), opt=True)
    _SchedulingParameters_othertimes = BOOL(name='othertimes', mode=MODE_TYPE, default=False)
    SchedulingParameters._cont = ASN1Dict([
        ('periodic', _SchedulingParameters_periodic),
        ('othertimes', _SchedulingParameters_othertimes),
        ])
    SchedulingParameters._ext = []
    
    #-----< PeriodicStrategy >-----#
    PeriodicStrategy = SEQ(name='PeriodicStrategy', mode=MODE_TYPE)
    _PeriodicStrategy_beginTime = TIME_GEN(name='beginTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _PeriodicStrategy_windowSize = INT(name='windowSize', mode=MODE_TYPE)
    _PeriodicStrategy_updateInterval = INT(name='updateInterval', mode=MODE_TYPE)
    PeriodicStrategy._cont = ASN1Dict([
        ('beginTime', _PeriodicStrategy_beginTime),
        ('windowSize', _PeriodicStrategy_windowSize),
        ('updateInterval', _PeriodicStrategy_updateInterval),
        ])
    PeriodicStrategy._ext = []
    
    #-----< Time >-----#
    Time = TIME_GEN(name='Time', mode=MODE_TYPE)
    
    #-----< All-operations-consumer-initiated >-----#
    All_operations_consumer_initiated = CLASS(name='All-operations-consumer-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_consumer_initiated_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _All_operations_consumer_initiated_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    _All_operations_consumer_initiated_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_consumer_initiated_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_consumer_initiated._val = ASN1Set(rv=[dict([('ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_0), ('ResultType', _All_operations_consumer_initiated_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_1), ('ResultType', _All_operations_consumer_initiated_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    
    #-----< All-operations-supplier-initiated >-----#
    All_operations_supplier_initiated = CLASS(name='All-operations-supplier-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_supplier_initiated_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _All_operations_supplier_initiated_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _All_operations_supplier_initiated_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_supplier_initiated_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_supplier_initiated._val = ASN1Set(rv=[dict([('ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_0), ('ResultType', _All_operations_supplier_initiated_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_1), ('ResultType', _All_operations_supplier_initiated_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])
    
    #-----< coordinateShadowUpdate >-----#
    coordinateShadowUpdate = CLASS(name='coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _coordinateShadowUpdate_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _coordinateShadowUpdate_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    coordinateShadowUpdate._val = dict([('ArgumentType', _coordinateShadowUpdate_val_ArgumentType), ('ResultType', _coordinateShadowUpdate_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< CoordinateShadowUpdateArgument >-----#
    CoordinateShadowUpdateArgument = CHOICE(name='CoordinateShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CoordinateShadowUpdateArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    _CoordinateShadowUpdateArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CoordinateShadowUpdateArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __CoordinateShadowUpdateArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _CoordinateShadowUpdateArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __CoordinateShadowUpdateArgument_signed_toBeSigned),
        ('algorithmIdentifier', __CoordinateShadowUpdateArgument_signed_algorithmIdentifier),
        ('encrypted', __CoordinateShadowUpdateArgument_signed_encrypted),
        ])
    _CoordinateShadowUpdateArgument_signed._ext = []
    CoordinateShadowUpdateArgument._cont = ASN1Dict([
        ('unsigned', _CoordinateShadowUpdateArgument_unsigned),
        ('signed', _CoordinateShadowUpdateArgument_signed),
        ])
    CoordinateShadowUpdateArgument._ext = None
    
    #-----< CoordinateShadowUpdateArgumentData >-----#
    CoordinateShadowUpdateArgumentData = SEQ(name='CoordinateShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateArgumentData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateArgumentData_updateStrategy = CHOICE(name='updateStrategy', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard = ENUM(name='standard', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._cont = ASN1Dict([('noChanges', 0), ('incremental', 1), ('total', 2)])
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._ext = []
    __CoordinateShadowUpdateArgumentData_updateStrategy_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _CoordinateShadowUpdateArgumentData_updateStrategy._cont = ASN1Dict([
        ('standard', __CoordinateShadowUpdateArgumentData_updateStrategy_standard),
        ('other', __CoordinateShadowUpdateArgumentData_updateStrategy_other),
        ])
    _CoordinateShadowUpdateArgumentData_updateStrategy._ext = []
    _CoordinateShadowUpdateArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    CoordinateShadowUpdateArgumentData._cont = ASN1Dict([
        ('agreementID', _CoordinateShadowUpdateArgumentData_agreementID),
        ('lastUpdate', _CoordinateShadowUpdateArgumentData_lastUpdate),
        ('updateStrategy', _CoordinateShadowUpdateArgumentData_updateStrategy),
        ('securityParameters', _CoordinateShadowUpdateArgumentData_securityParameters),
        ])
    CoordinateShadowUpdateArgumentData._ext = []
    
    #-----< CoordinateShadowUpdateResult >-----#
    CoordinateShadowUpdateResult = CHOICE(name='CoordinateShadowUpdateResult', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_null = NULL(name='null', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __CoordinateShadowUpdateResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    __CoordinateShadowUpdateResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___CoordinateShadowUpdateResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___CoordinateShadowUpdateResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __CoordinateShadowUpdateResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___CoordinateShadowUpdateResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier),
        ('encrypted', ___CoordinateShadowUpdateResult_information_signed_encrypted),
        ])
    __CoordinateShadowUpdateResult_information_signed._ext = []
    _CoordinateShadowUpdateResult_information._cont = ASN1Dict([
        ('unsigned', __CoordinateShadowUpdateResult_information_unsigned),
        ('signed', __CoordinateShadowUpdateResult_information_signed),
        ])
    _CoordinateShadowUpdateResult_information._ext = None
    CoordinateShadowUpdateResult._cont = ASN1Dict([
        ('null', _CoordinateShadowUpdateResult_null),
        ('information', _CoordinateShadowUpdateResult_information),
        ])
    CoordinateShadowUpdateResult._ext = []
    
    #-----< CoordinateShadowUpdateResultData >-----#
    CoordinateShadowUpdateResultData = SEQ(name='CoordinateShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CoordinateShadowUpdateResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CoordinateShadowUpdateResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CoordinateShadowUpdateResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CoordinateShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CoordinateShadowUpdateResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_id = 'id'
    ___CoordinateShadowUpdateResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CoordinateShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___CoordinateShadowUpdateResultData_notification__item__values._cont = ____CoordinateShadowUpdateResultData_notification__item__values__item_
    ___CoordinateShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._cont = ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CoordinateShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        ('type', ___CoordinateShadowUpdateResultData_notification__item__type),
        ('values', ___CoordinateShadowUpdateResultData_notification__item__values),
        ('valuesWithContext', ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __CoordinateShadowUpdateResultData_notification__item_._ext = []
    _CoordinateShadowUpdateResultData_notification._cont = __CoordinateShadowUpdateResultData_notification__item_
    CoordinateShadowUpdateResultData._cont = ASN1Dict([
        ('agreementID', _CoordinateShadowUpdateResultData_agreementID),
        ('lastUpdate', _CoordinateShadowUpdateResultData_lastUpdate),
        ('securityParameters', _CoordinateShadowUpdateResultData_securityParameters),
        ('performer', _CoordinateShadowUpdateResultData_performer),
        ('aliasDereferenced', _CoordinateShadowUpdateResultData_aliasDereferenced),
        ('notification', _CoordinateShadowUpdateResultData_notification),
        ])
    CoordinateShadowUpdateResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< requestShadowUpdate >-----#
    requestShadowUpdate = CLASS(name='requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _requestShadowUpdate_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _requestShadowUpdate_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    requestShadowUpdate._val = dict([('ArgumentType', _requestShadowUpdate_val_ArgumentType), ('ResultType', _requestShadowUpdate_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< RequestShadowUpdateArgument >-----#
    RequestShadowUpdateArgument = CHOICE(name='RequestShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RequestShadowUpdateArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    _RequestShadowUpdateArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RequestShadowUpdateArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    __RequestShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __RequestShadowUpdateArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _RequestShadowUpdateArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __RequestShadowUpdateArgument_signed_toBeSigned),
        ('algorithmIdentifier', __RequestShadowUpdateArgument_signed_algorithmIdentifier),
        ('encrypted', __RequestShadowUpdateArgument_signed_encrypted),
        ])
    _RequestShadowUpdateArgument_signed._ext = []
    RequestShadowUpdateArgument._cont = ASN1Dict([
        ('unsigned', _RequestShadowUpdateArgument_unsigned),
        ('signed', _RequestShadowUpdateArgument_signed),
        ])
    RequestShadowUpdateArgument._ext = None
    
    #-----< RequestShadowUpdateArgumentData >-----#
    RequestShadowUpdateArgumentData = SEQ(name='RequestShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateArgumentData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateArgumentData_requestedStrategy = CHOICE(name='requestedStrategy', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard = ENUM(name='standard', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._cont = ASN1Dict([('incremental', 1), ('total', 2)])
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._ext = []
    __RequestShadowUpdateArgumentData_requestedStrategy_other = EXT(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RequestShadowUpdateArgumentData_requestedStrategy._cont = ASN1Dict([
        ('standard', __RequestShadowUpdateArgumentData_requestedStrategy_standard),
        ('other', __RequestShadowUpdateArgumentData_requestedStrategy_other),
        ])
    _RequestShadowUpdateArgumentData_requestedStrategy._ext = []
    _RequestShadowUpdateArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    RequestShadowUpdateArgumentData._cont = ASN1Dict([
        ('agreementID', _RequestShadowUpdateArgumentData_agreementID),
        ('lastUpdate', _RequestShadowUpdateArgumentData_lastUpdate),
        ('requestedStrategy', _RequestShadowUpdateArgumentData_requestedStrategy),
        ('securityParameters', _RequestShadowUpdateArgumentData_securityParameters),
        ])
    RequestShadowUpdateArgumentData._ext = []
    
    #-----< RequestShadowUpdateResult >-----#
    RequestShadowUpdateResult = CHOICE(name='RequestShadowUpdateResult', mode=MODE_TYPE)
    _RequestShadowUpdateResult_null = NULL(name='null', mode=MODE_TYPE)
    _RequestShadowUpdateResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __RequestShadowUpdateResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    __RequestShadowUpdateResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RequestShadowUpdateResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___RequestShadowUpdateResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __RequestShadowUpdateResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___RequestShadowUpdateResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___RequestShadowUpdateResult_information_signed_algorithmIdentifier),
        ('encrypted', ___RequestShadowUpdateResult_information_signed_encrypted),
        ])
    __RequestShadowUpdateResult_information_signed._ext = []
    _RequestShadowUpdateResult_information._cont = ASN1Dict([
        ('unsigned', __RequestShadowUpdateResult_information_unsigned),
        ('signed', __RequestShadowUpdateResult_information_signed),
        ])
    _RequestShadowUpdateResult_information._ext = None
    RequestShadowUpdateResult._cont = ASN1Dict([
        ('null', _RequestShadowUpdateResult_null),
        ('information', _RequestShadowUpdateResult_information),
        ])
    RequestShadowUpdateResult._ext = []
    
    #-----< RequestShadowUpdateResultData >-----#
    RequestShadowUpdateResultData = SEQ(name='RequestShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RequestShadowUpdateResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RequestShadowUpdateResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestShadowUpdateResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RequestShadowUpdateResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____RequestShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RequestShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__type._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_id = 'id'
    ___RequestShadowUpdateResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____RequestShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___RequestShadowUpdateResultData_notification__item__values._cont = ____RequestShadowUpdateResultData_notification__item__values__item_
    ___RequestShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._cont = ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RequestShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        ('type', ___RequestShadowUpdateResultData_notification__item__type),
        ('values', ___RequestShadowUpdateResultData_notification__item__values),
        ('valuesWithContext', ___RequestShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __RequestShadowUpdateResultData_notification__item_._ext = []
    _RequestShadowUpdateResultData_notification._cont = __RequestShadowUpdateResultData_notification__item_
    RequestShadowUpdateResultData._cont = ASN1Dict([
        ('agreementID', _RequestShadowUpdateResultData_agreementID),
        ('lastUpdate', _RequestShadowUpdateResultData_lastUpdate),
        ('securityParameters', _RequestShadowUpdateResultData_securityParameters),
        ('performer', _RequestShadowUpdateResultData_performer),
        ('aliasDereferenced', _RequestShadowUpdateResultData_aliasDereferenced),
        ('notification', _RequestShadowUpdateResultData_notification),
        ])
    RequestShadowUpdateResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< updateShadow >-----#
    updateShadow = CLASS(name='updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _updateShadow_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _updateShadow_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    updateShadow._val = dict([('ArgumentType', _updateShadow_val_ArgumentType), ('ResultType', _updateShadow_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< UpdateShadowArgument >-----#
    UpdateShadowArgument = CHOICE(name='UpdateShadowArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _UpdateShadowArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    _UpdateShadowArgument_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __UpdateShadowArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    __UpdateShadowArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __UpdateShadowArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___UpdateShadowArgument_signed_algorithmIdentifier_parameters),
        ])
    __UpdateShadowArgument_signed_algorithmIdentifier._ext = []
    __UpdateShadowArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _UpdateShadowArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __UpdateShadowArgument_signed_toBeSigned),
        ('algorithmIdentifier', __UpdateShadowArgument_signed_algorithmIdentifier),
        ('encrypted', __UpdateShadowArgument_signed_encrypted),
        ])
    _UpdateShadowArgument_signed._ext = []
    UpdateShadowArgument._cont = ASN1Dict([
        ('unsigned', _UpdateShadowArgument_unsigned),
        ('signed', _UpdateShadowArgument_signed),
        ])
    UpdateShadowArgument._ext = None
    
    #-----< UpdateShadowArgumentData >-----#
    UpdateShadowArgumentData = SEQ(name='UpdateShadowArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowArgumentData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowArgumentData_updateTime = TIME_GEN(name='updateTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateShadowArgumentData_updateWindow = SEQ(name='updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _UpdateShadowArgumentData_updatedInfo = CHOICE(name='updatedInfo', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RefreshInformation')))
    _UpdateShadowArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    UpdateShadowArgumentData._cont = ASN1Dict([
        ('agreementID', _UpdateShadowArgumentData_agreementID),
        ('updateTime', _UpdateShadowArgumentData_updateTime),
        ('updateWindow', _UpdateShadowArgumentData_updateWindow),
        ('updatedInfo', _UpdateShadowArgumentData_updatedInfo),
        ('securityParameters', _UpdateShadowArgumentData_securityParameters),
        ])
    UpdateShadowArgumentData._ext = []
    
    #-----< UpdateShadowResult >-----#
    UpdateShadowResult = CHOICE(name='UpdateShadowResult', mode=MODE_TYPE)
    _UpdateShadowResult_null = NULL(name='null', mode=MODE_TYPE)
    _UpdateShadowResult_information = CHOICE(name='information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __UpdateShadowResult_information_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    __UpdateShadowResult_information_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___UpdateShadowResult_information_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    ___UpdateShadowResult_information_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___UpdateShadowResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm),
        ('parameters', ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___UpdateShadowResult_information_signed_algorithmIdentifier._ext = []
    ___UpdateShadowResult_information_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __UpdateShadowResult_information_signed._cont = ASN1Dict([
        ('toBeSigned', ___UpdateShadowResult_information_signed_toBeSigned),
        ('algorithmIdentifier', ___UpdateShadowResult_information_signed_algorithmIdentifier),
        ('encrypted', ___UpdateShadowResult_information_signed_encrypted),
        ])
    __UpdateShadowResult_information_signed._ext = []
    _UpdateShadowResult_information._cont = ASN1Dict([
        ('unsigned', __UpdateShadowResult_information_unsigned),
        ('signed', __UpdateShadowResult_information_signed),
        ])
    _UpdateShadowResult_information._ext = None
    UpdateShadowResult._cont = ASN1Dict([
        ('null', _UpdateShadowResult_null),
        ('information', _UpdateShadowResult_information),
        ])
    UpdateShadowResult._ext = []
    
    #-----< UpdateShadowResultData >-----#
    UpdateShadowResultData = SEQ(name='UpdateShadowResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowResultData_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowResultData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _UpdateShadowResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateShadowResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateShadowResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateShadowResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateShadowResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateShadowResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____UpdateShadowResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____UpdateShadowResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__type._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ___UpdateShadowResultData_notification__item__type._const_tab_at = None
    ___UpdateShadowResultData_notification__item__type._const_tab_id = 'id'
    ___UpdateShadowResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____UpdateShadowResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____UpdateShadowResultData_notification__item__values__item_._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___UpdateShadowResultData_notification__item__values._cont = ____UpdateShadowResultData_notification__item__values__item_
    ___UpdateShadowResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____UpdateShadowResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateShadowResultData_notification__item__valuesWithContext._cont = ____UpdateShadowResultData_notification__item__valuesWithContext__item_
    ___UpdateShadowResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateShadowResultData_notification__item_._cont = ASN1Dict([
        ('type', ___UpdateShadowResultData_notification__item__type),
        ('values', ___UpdateShadowResultData_notification__item__values),
        ('valuesWithContext', ___UpdateShadowResultData_notification__item__valuesWithContext),
        ])
    __UpdateShadowResultData_notification__item_._ext = []
    _UpdateShadowResultData_notification._cont = __UpdateShadowResultData_notification__item_
    UpdateShadowResultData._cont = ASN1Dict([
        ('agreementID', _UpdateShadowResultData_agreementID),
        ('lastUpdate', _UpdateShadowResultData_lastUpdate),
        ('securityParameters', _UpdateShadowResultData_securityParameters),
        ('performer', _UpdateShadowResultData_performer),
        ('aliasDereferenced', _UpdateShadowResultData_aliasDereferenced),
        ('notification', _UpdateShadowResultData_notification),
        ])
    UpdateShadowResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< UpdateWindow >-----#
    UpdateWindow = SEQ(name='UpdateWindow', mode=MODE_TYPE)
    _UpdateWindow_start = TIME_GEN(name='start', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateWindow_stop = TIME_GEN(name='stop', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    UpdateWindow._cont = ASN1Dict([
        ('start', _UpdateWindow_start),
        ('stop', _UpdateWindow_stop),
        ])
    UpdateWindow._ext = []
    
    #-----< RefreshInformation >-----#
    RefreshInformation = CHOICE(name='RefreshInformation', mode=MODE_TYPE)
    _RefreshInformation_noRefresh = NULL(name='noRefresh', mode=MODE_TYPE)
    _RefreshInformation_total = SEQ(name='total', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'TotalRefresh')))
    _RefreshInformation_incremental = SEQ_OF(name='incremental', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalRefresh')))
    _RefreshInformation_otherStrategy = EXT(name='otherStrategy', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    RefreshInformation._cont = ASN1Dict([
        ('noRefresh', _RefreshInformation_noRefresh),
        ('total', _RefreshInformation_total),
        ('incremental', _RefreshInformation_incremental),
        ('otherStrategy', _RefreshInformation_otherStrategy),
        ])
    RefreshInformation._ext = []
    
    #-----< TotalRefresh >-----#
    TotalRefresh = SEQ(name='TotalRefresh', mode=MODE_TYPE)
    _TotalRefresh_sDSE = SEQ(name='sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _TotalRefresh_subtree = SET_OF(name='subtree', mode=MODE_TYPE, opt=True)
    __TotalRefresh_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _TotalRefresh_subtree._cont = __TotalRefresh_subtree__item_
    _TotalRefresh_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TotalRefresh._cont = ASN1Dict([
        ('sDSE', _TotalRefresh_sDSE),
        ('subtree', _TotalRefresh_subtree),
        ])
    TotalRefresh._ext = []
    
    #-----< SDSEContent >-----#
    SDSEContent = SEQ(name='SDSEContent', mode=MODE_TYPE)
    _SDSEContent_sDSEType = BIT_STR(name='sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _SDSEContent_subComplete = BOOL(name='subComplete', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SDSEContent_attComplete = BOOL(name='attComplete', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDSEContent_attributes = SET_OF(name='attributes', mode=MODE_TYPE)
    __SDSEContent_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SDSEContent_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SDSEContent_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SDSEContent_attributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SDSEContent_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SDSEContent_attributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SDSEContent_attributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SDSEContent_attributes__item__type._const_tab = ____SDSEContent_attributes__item__type_tab
    ___SDSEContent_attributes__item__type._const_tab_at = None
    ___SDSEContent_attributes__item__type._const_tab_id = 'id'
    ___SDSEContent_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SDSEContent_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SDSEContent_attributes__item__values__item_._const_tab = ____SDSEContent_attributes__item__type_tab
    ____SDSEContent_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SDSEContent_attributes__item__values__item_._const_tab_id = 'Type'
    ___SDSEContent_attributes__item__values._cont = ____SDSEContent_attributes__item__values__item_
    ___SDSEContent_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SDSEContent_attributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SDSEContent_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab = ____SDSEContent_attributes__item__type_tab
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._cont = ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SDSEContent_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SDSEContent_attributes__item__valuesWithContext__item__value),
        ('contextList', _____SDSEContent_attributes__item__valuesWithContext__item__contextList),
        ])
    ____SDSEContent_attributes__item__valuesWithContext__item_._ext = []
    ___SDSEContent_attributes__item__valuesWithContext._cont = ____SDSEContent_attributes__item__valuesWithContext__item_
    ___SDSEContent_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SDSEContent_attributes__item_._cont = ASN1Dict([
        ('type', ___SDSEContent_attributes__item__type),
        ('values', ___SDSEContent_attributes__item__values),
        ('valuesWithContext', ___SDSEContent_attributes__item__valuesWithContext),
        ])
    __SDSEContent_attributes__item_._ext = []
    _SDSEContent_attributes._cont = __SDSEContent_attributes__item_
    _SDSEContent_attValIncomplete = SET_OF(name='attValIncomplete', mode=MODE_TYPE, default=[])
    __SDSEContent_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SDSEContent_attValIncomplete._cont = __SDSEContent_attValIncomplete__item_
    SDSEContent._cont = ASN1Dict([
        ('sDSEType', _SDSEContent_sDSEType),
        ('subComplete', _SDSEContent_subComplete),
        ('attComplete', _SDSEContent_attComplete),
        ('attributes', _SDSEContent_attributes),
        ('attValIncomplete', _SDSEContent_attValIncomplete),
        ])
    SDSEContent._ext = []
    
    #-----< SDSEType >-----#
    SDSEType = BIT_STR(name='SDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    
    #-----< Subtree >-----#
    Subtree = SEQ(name='Subtree', mode=MODE_TYPE)
    _Subtree_rdn = SET_OF(name='rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Subtree_sDSE = SEQ(name='sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _Subtree_subtree = SET_OF(name='subtree', mode=MODE_TYPE, opt=True)
    __Subtree_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _Subtree_subtree._cont = __Subtree_subtree__item_
    Subtree._cont = ASN1Dict([
        ('rdn', _Subtree_rdn),
        ('sDSE', _Subtree_sDSE),
        ('subtree', _Subtree_subtree),
        ])
    Subtree._ext = []
    
    #-----< IncrementalRefresh >-----#
    IncrementalRefresh = SEQ_OF(name='IncrementalRefresh', mode=MODE_TYPE)
    _IncrementalRefresh__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    IncrementalRefresh._cont = _IncrementalRefresh__item_
    
    #-----< IncrementalStepRefresh >-----#
    IncrementalStepRefresh = SEQ(name='IncrementalStepRefresh', mode=MODE_TYPE)
    _IncrementalStepRefresh_sDSEChanges = CHOICE(name='sDSEChanges', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_sDSEChanges_add = SEQ(name='add', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')))
    __IncrementalStepRefresh_sDSEChanges_remove = NULL(name='remove', mode=MODE_TYPE)
    __IncrementalStepRefresh_sDSEChanges_modify = SEQ(name='modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ContentChange')))
    _IncrementalStepRefresh_sDSEChanges._cont = ASN1Dict([
        ('add', __IncrementalStepRefresh_sDSEChanges_add),
        ('remove', __IncrementalStepRefresh_sDSEChanges_remove),
        ('modify', __IncrementalStepRefresh_sDSEChanges_modify),
        ])
    _IncrementalStepRefresh_sDSEChanges._ext = []
    _IncrementalStepRefresh_subordinateUpdates = SEQ_OF(name='subordinateUpdates', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_subordinateUpdates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SubordinateChanges')))
    _IncrementalStepRefresh_subordinateUpdates._cont = __IncrementalStepRefresh_subordinateUpdates__item_
    _IncrementalStepRefresh_subordinateUpdates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    IncrementalStepRefresh._cont = ASN1Dict([
        ('sDSEChanges', _IncrementalStepRefresh_sDSEChanges),
        ('subordinateUpdates', _IncrementalStepRefresh_subordinateUpdates),
        ])
    IncrementalStepRefresh._ext = None
    
    #-----< ContentChange >-----#
    ContentChange = SEQ(name='ContentChange', mode=MODE_TYPE)
    _ContentChange_rename = CHOICE(name='rename', mode=MODE_TYPE, opt=True)
    __ContentChange_rename_newRDN = SET_OF(name='newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    __ContentChange_rename_newDN = SEQ_OF(name='newDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ContentChange_rename._cont = ASN1Dict([
        ('newRDN', __ContentChange_rename_newRDN),
        ('newDN', __ContentChange_rename_newDN),
        ])
    _ContentChange_rename._ext = None
    _ContentChange_attributeChanges = CHOICE(name='attributeChanges', mode=MODE_TYPE, opt=True)
    __ContentChange_attributeChanges_replace = SET_OF(name='replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_replace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ContentChange_attributeChanges_replace__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _____ContentChange_attributeChanges_replace__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ContentChange_attributeChanges_replace__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__type._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ____ContentChange_attributeChanges_replace__item__type._const_tab_at = None
    ____ContentChange_attributeChanges_replace__item__type._const_tab_id = 'id'
    ____ContentChange_attributeChanges_replace__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____ContentChange_attributeChanges_replace__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_id = 'Type'
    ____ContentChange_attributeChanges_replace__item__values._cont = _____ContentChange_attributeChanges_replace__item__values__item_
    ____ContentChange_attributeChanges_replace__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._cont = _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value),
        ('contextList', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList),
        ])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._ext = []
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._cont = _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ContentChange_attributeChanges_replace__item_._cont = ASN1Dict([
        ('type', ____ContentChange_attributeChanges_replace__item__type),
        ('values', ____ContentChange_attributeChanges_replace__item__values),
        ('valuesWithContext', ____ContentChange_attributeChanges_replace__item__valuesWithContext),
        ])
    ___ContentChange_attributeChanges_replace__item_._ext = []
    __ContentChange_attributeChanges_replace._cont = ___ContentChange_attributeChanges_replace__item_
    __ContentChange_attributeChanges_replace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ContentChange_attributeChanges_changes = SEQ_OF(name='changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    __ContentChange_attributeChanges_changes._cont = ___ContentChange_attributeChanges_changes__item_
    __ContentChange_attributeChanges_changes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContentChange_attributeChanges._cont = ASN1Dict([
        ('replace', __ContentChange_attributeChanges_replace),
        ('changes', __ContentChange_attributeChanges_changes),
        ])
    _ContentChange_attributeChanges._ext = None
    _ContentChange_sDSEType = BIT_STR(name='sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _ContentChange_subComplete = BOOL(name='subComplete', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ContentChange_attComplete = BOOL(name='attComplete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ContentChange_attValIncomplete = SET_OF(name='attValIncomplete', mode=MODE_TYPE, default=[])
    __ContentChange_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ContentChange_attValIncomplete._cont = __ContentChange_attValIncomplete__item_
    ContentChange._cont = ASN1Dict([
        ('rename', _ContentChange_rename),
        ('attributeChanges', _ContentChange_attributeChanges),
        ('sDSEType', _ContentChange_sDSEType),
        ('subComplete', _ContentChange_subComplete),
        ('attComplete', _ContentChange_attComplete),
        ('attValIncomplete', _ContentChange_attValIncomplete),
        ])
    ContentChange._ext = []
    
    #-----< SubordinateChanges >-----#
    SubordinateChanges = SEQ(name='SubordinateChanges', mode=MODE_TYPE)
    _SubordinateChanges_subordinate = SET_OF(name='subordinate', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubordinateChanges_changes = SEQ(name='changes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    SubordinateChanges._cont = ASN1Dict([
        ('subordinate', _SubordinateChanges_subordinate),
        ('changes', _SubordinateChanges_changes),
        ])
    SubordinateChanges._ext = []
    
    #-----< shadowError >-----#
    shadowError = CLASS(name='shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _shadowError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __shadowError_val_ParameterType_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    __shadowError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___shadowError_val_ParameterType_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___shadowError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___shadowError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __shadowError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___shadowError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___shadowError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___shadowError_val_ParameterType_signed_encrypted),
        ])
    __shadowError_val_ParameterType_signed._ext = []
    _shadowError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __shadowError_val_ParameterType_unsigned),
        ('signed', __shadowError_val_ParameterType_signed),
        ])
    _shadowError_val_ParameterType._ext = None
    shadowError._val = dict([('ParameterType', _shadowError_val_ParameterType), ('errorCode', ('local', 1))])
    
    #-----< ShadowErrorData >-----#
    ShadowErrorData = SEQ(name='ShadowErrorData', mode=MODE_TYPE)
    _ShadowErrorData_problem = INT(name='problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowProblem')))
    _ShadowErrorData_lastUpdate = TIME_GEN(name='lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _ShadowErrorData_updateWindow = SEQ(name='updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _ShadowErrorData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ShadowErrorData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ShadowErrorData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ShadowErrorData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ShadowErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ShadowErrorData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ShadowErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ShadowErrorData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ShadowErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ShadowErrorData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ShadowErrorData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ShadowErrorData_notification__item__type._const_tab = ____ShadowErrorData_notification__item__type_tab
    ___ShadowErrorData_notification__item__type._const_tab_at = None
    ___ShadowErrorData_notification__item__type._const_tab_id = 'id'
    ___ShadowErrorData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ShadowErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ShadowErrorData_notification__item__values__item_._const_tab = ____ShadowErrorData_notification__item__type_tab
    ____ShadowErrorData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ShadowErrorData_notification__item__values__item_._const_tab_id = 'Type'
    ___ShadowErrorData_notification__item__values._cont = ____ShadowErrorData_notification__item__values__item_
    ___ShadowErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ShadowErrorData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ShadowErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ShadowErrorData_notification__item__type_tab
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ShadowErrorData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ShadowErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ShadowErrorData_notification__item__valuesWithContext._cont = ____ShadowErrorData_notification__item__valuesWithContext__item_
    ___ShadowErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ShadowErrorData_notification__item_._cont = ASN1Dict([
        ('type', ___ShadowErrorData_notification__item__type),
        ('values', ___ShadowErrorData_notification__item__values),
        ('valuesWithContext', ___ShadowErrorData_notification__item__valuesWithContext),
        ])
    __ShadowErrorData_notification__item_._ext = []
    _ShadowErrorData_notification._cont = __ShadowErrorData_notification__item_
    ShadowErrorData._cont = ASN1Dict([
        ('problem', _ShadowErrorData_problem),
        ('lastUpdate', _ShadowErrorData_lastUpdate),
        ('updateWindow', _ShadowErrorData_updateWindow),
        ('securityParameters', _ShadowErrorData_securityParameters),
        ('performer', _ShadowErrorData_performer),
        ('aliasDereferenced', _ShadowErrorData_aliasDereferenced),
        ('notification', _ShadowErrorData_notification),
        ])
    ShadowErrorData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ShadowProblem >-----#
    ShadowProblem = INT(name='ShadowProblem', mode=MODE_TYPE)
    ShadowProblem._cont = ASN1Dict([('invalidAgreementID', 1), ('inactiveAgreement', 2), ('invalidInformationReceived', 3), ('unsupportedStrategy', 4), ('missedPrevious', 5), ('fullUpdateRequired', 6), ('unwillingToPerform', 7), ('unsuitableTiming', 8), ('updateAlreadyReceived', 9), ('invalidSequencing', 10), ('insufficientResources', 11)])
    
    _all_ = [
        dSAShadowBind,
        _dSAShadowBind_val_ArgumentType,
        _dSAShadowBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        shadowOperationalBinding,
        _shadowOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        __ModificationParameter_secondaryShadows__item_,
        _ModificationParameter_secondaryShadows,
        ModificationParameter,
        AgreementID,
        _ShadowingAgreementInfo_shadowSubject,
        _ShadowingAgreementInfo_updateMode,
        _ShadowingAgreementInfo_master,
        _ShadowingAgreementInfo_secondaryShadows,
        ShadowingAgreementInfo,
        _UnitOfReplication_area,
        _UnitOfReplication_attributes,
        _UnitOfReplication_knowledge,
        _UnitOfReplication_subordinates,
        _UnitOfReplication_contextSelection,
        __UnitOfReplication_supplyContexts_allContexts,
        ___UnitOfReplication_supplyContexts_selectedContexts__item_,
        __UnitOfReplication_supplyContexts_selectedContexts,
        _UnitOfReplication_supplyContexts,
        UnitOfReplication,
        _AreaSpecification_contextPrefix,
        _AreaSpecification_replicationArea,
        AreaSpecification,
        _Knowledge_knowledgeType,
        _Knowledge_extendedKnowledge,
        Knowledge,
        _AttributeSelection__item_,
        AttributeSelection,
        _ClassAttributeSelection_class_,
        _ClassAttributeSelection_classAttributes,
        ClassAttributeSelection,
        _ClassAttributes_allAttributes,
        _ClassAttributes_include,
        _ClassAttributes_exclude,
        ClassAttributes,
        _AttributeTypes__item_,
        AttributeTypes,
        _UpdateMode_supplierInitiated,
        _UpdateMode_consumerInitiated,
        UpdateMode,
        _SupplierUpdateMode_onChange,
        _SupplierUpdateMode_scheduled,
        SupplierUpdateMode,
        ConsumerUpdateMode,
        _SchedulingParameters_periodic,
        _SchedulingParameters_othertimes,
        SchedulingParameters,
        _PeriodicStrategy_beginTime,
        _PeriodicStrategy_windowSize,
        _PeriodicStrategy_updateInterval,
        PeriodicStrategy,
        Time,
        All_operations_consumer_initiated,
        _All_operations_consumer_initiated_val_ArgumentType_0,
        _All_operations_consumer_initiated_val_ResultType_0,
        _All_operations_consumer_initiated_val_ArgumentType_1,
        _All_operations_consumer_initiated_val_ResultType_1,
        All_operations_supplier_initiated,
        _All_operations_supplier_initiated_val_ArgumentType_0,
        _All_operations_supplier_initiated_val_ResultType_0,
        _All_operations_supplier_initiated_val_ArgumentType_1,
        _All_operations_supplier_initiated_val_ResultType_1,
        coordinateShadowUpdate,
        _coordinateShadowUpdate_val_ArgumentType,
        _coordinateShadowUpdate_val_ResultType,
        _CoordinateShadowUpdateArgument_unsigned,
        __CoordinateShadowUpdateArgument_signed_toBeSigned,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __CoordinateShadowUpdateArgument_signed_algorithmIdentifier,
        __CoordinateShadowUpdateArgument_signed_encrypted,
        _CoordinateShadowUpdateArgument_signed,
        CoordinateShadowUpdateArgument,
        _CoordinateShadowUpdateArgumentData_agreementID,
        _CoordinateShadowUpdateArgumentData_lastUpdate,
        __CoordinateShadowUpdateArgumentData_updateStrategy_standard,
        __CoordinateShadowUpdateArgumentData_updateStrategy_other,
        _CoordinateShadowUpdateArgumentData_updateStrategy,
        _CoordinateShadowUpdateArgumentData_securityParameters,
        CoordinateShadowUpdateArgumentData,
        _CoordinateShadowUpdateResult_null,
        __CoordinateShadowUpdateResult_information_unsigned,
        ___CoordinateShadowUpdateResult_information_signed_toBeSigned,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier,
        ___CoordinateShadowUpdateResult_information_signed_encrypted,
        __CoordinateShadowUpdateResult_information_signed,
        _CoordinateShadowUpdateResult_information,
        CoordinateShadowUpdateResult,
        _CoordinateShadowUpdateResultData_agreementID,
        _CoordinateShadowUpdateResultData_lastUpdate,
        _CoordinateShadowUpdateResultData_securityParameters,
        _CoordinateShadowUpdateResultData_performer,
        _CoordinateShadowUpdateResultData_aliasDereferenced,
        ____CoordinateShadowUpdateResultData_notification__item__type_tab,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CoordinateShadowUpdateResultData_notification__item__type,
        ____CoordinateShadowUpdateResultData_notification__item__values__item_,
        ___CoordinateShadowUpdateResultData_notification__item__values,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext,
        __CoordinateShadowUpdateResultData_notification__item_,
        _CoordinateShadowUpdateResultData_notification,
        CoordinateShadowUpdateResultData,
        requestShadowUpdate,
        _requestShadowUpdate_val_ArgumentType,
        _requestShadowUpdate_val_ResultType,
        _RequestShadowUpdateArgument_unsigned,
        __RequestShadowUpdateArgument_signed_toBeSigned,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __RequestShadowUpdateArgument_signed_algorithmIdentifier,
        __RequestShadowUpdateArgument_signed_encrypted,
        _RequestShadowUpdateArgument_signed,
        RequestShadowUpdateArgument,
        _RequestShadowUpdateArgumentData_agreementID,
        _RequestShadowUpdateArgumentData_lastUpdate,
        __RequestShadowUpdateArgumentData_requestedStrategy_standard,
        __RequestShadowUpdateArgumentData_requestedStrategy_other,
        _RequestShadowUpdateArgumentData_requestedStrategy,
        _RequestShadowUpdateArgumentData_securityParameters,
        RequestShadowUpdateArgumentData,
        _RequestShadowUpdateResult_null,
        __RequestShadowUpdateResult_information_unsigned,
        ___RequestShadowUpdateResult_information_signed_toBeSigned,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___RequestShadowUpdateResult_information_signed_algorithmIdentifier,
        ___RequestShadowUpdateResult_information_signed_encrypted,
        __RequestShadowUpdateResult_information_signed,
        _RequestShadowUpdateResult_information,
        RequestShadowUpdateResult,
        _RequestShadowUpdateResultData_agreementID,
        _RequestShadowUpdateResultData_lastUpdate,
        _RequestShadowUpdateResultData_securityParameters,
        _RequestShadowUpdateResultData_performer,
        _RequestShadowUpdateResultData_aliasDereferenced,
        ____RequestShadowUpdateResultData_notification__item__type_tab,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ___RequestShadowUpdateResultData_notification__item__type,
        ____RequestShadowUpdateResultData_notification__item__values__item_,
        ___RequestShadowUpdateResultData_notification__item__values,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___RequestShadowUpdateResultData_notification__item__valuesWithContext,
        __RequestShadowUpdateResultData_notification__item_,
        _RequestShadowUpdateResultData_notification,
        RequestShadowUpdateResultData,
        updateShadow,
        _updateShadow_val_ArgumentType,
        _updateShadow_val_ResultType,
        _UpdateShadowArgument_unsigned,
        __UpdateShadowArgument_signed_toBeSigned,
        ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm,
        ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_parameters,
        __UpdateShadowArgument_signed_algorithmIdentifier,
        __UpdateShadowArgument_signed_encrypted,
        _UpdateShadowArgument_signed,
        UpdateShadowArgument,
        _UpdateShadowArgumentData_agreementID,
        _UpdateShadowArgumentData_updateTime,
        _UpdateShadowArgumentData_updateWindow,
        _UpdateShadowArgumentData_updatedInfo,
        _UpdateShadowArgumentData_securityParameters,
        UpdateShadowArgumentData,
        _UpdateShadowResult_null,
        __UpdateShadowResult_information_unsigned,
        ___UpdateShadowResult_information_signed_toBeSigned,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters,
        ___UpdateShadowResult_information_signed_algorithmIdentifier,
        ___UpdateShadowResult_information_signed_encrypted,
        __UpdateShadowResult_information_signed,
        _UpdateShadowResult_information,
        UpdateShadowResult,
        _UpdateShadowResultData_agreementID,
        _UpdateShadowResultData_lastUpdate,
        _UpdateShadowResultData_securityParameters,
        _UpdateShadowResultData_performer,
        _UpdateShadowResultData_aliasDereferenced,
        ____UpdateShadowResultData_notification__item__type_tab,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_0,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_1,
        ___UpdateShadowResultData_notification__item__type,
        ____UpdateShadowResultData_notification__item__values__item_,
        ___UpdateShadowResultData_notification__item__values,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__value,
        ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList,
        ____UpdateShadowResultData_notification__item__valuesWithContext__item_,
        ___UpdateShadowResultData_notification__item__valuesWithContext,
        __UpdateShadowResultData_notification__item_,
        _UpdateShadowResultData_notification,
        UpdateShadowResultData,
        _UpdateWindow_start,
        _UpdateWindow_stop,
        UpdateWindow,
        _RefreshInformation_noRefresh,
        _RefreshInformation_total,
        _RefreshInformation_incremental,
        _RefreshInformation_otherStrategy,
        RefreshInformation,
        _TotalRefresh_sDSE,
        __TotalRefresh_subtree__item_,
        _TotalRefresh_subtree,
        TotalRefresh,
        _SDSEContent_sDSEType,
        _SDSEContent_subComplete,
        _SDSEContent_attComplete,
        ____SDSEContent_attributes__item__type_tab,
        _____SDSEContent_attributes__item__type_tab_val_Type_0,
        _____SDSEContent_attributes__item__type_tab_val_Type_1,
        ___SDSEContent_attributes__item__type,
        ____SDSEContent_attributes__item__values__item_,
        ___SDSEContent_attributes__item__values,
        _____SDSEContent_attributes__item__valuesWithContext__item__value,
        ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_,
        _____SDSEContent_attributes__item__valuesWithContext__item__contextList,
        ____SDSEContent_attributes__item__valuesWithContext__item_,
        ___SDSEContent_attributes__item__valuesWithContext,
        __SDSEContent_attributes__item_,
        _SDSEContent_attributes,
        __SDSEContent_attValIncomplete__item_,
        _SDSEContent_attValIncomplete,
        SDSEContent,
        SDSEType,
        _Subtree_rdn,
        _Subtree_sDSE,
        __Subtree_subtree__item_,
        _Subtree_subtree,
        Subtree,
        _IncrementalRefresh__item_,
        IncrementalRefresh,
        __IncrementalStepRefresh_sDSEChanges_add,
        __IncrementalStepRefresh_sDSEChanges_remove,
        __IncrementalStepRefresh_sDSEChanges_modify,
        _IncrementalStepRefresh_sDSEChanges,
        __IncrementalStepRefresh_subordinateUpdates__item_,
        _IncrementalStepRefresh_subordinateUpdates,
        IncrementalStepRefresh,
        __ContentChange_rename_newRDN,
        __ContentChange_rename_newDN,
        _ContentChange_rename,
        _____ContentChange_attributeChanges_replace__item__type_tab,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1,
        ____ContentChange_attributeChanges_replace__item__type,
        _____ContentChange_attributeChanges_replace__item__values__item_,
        ____ContentChange_attributeChanges_replace__item__values,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value,
        _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList,
        _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_,
        ____ContentChange_attributeChanges_replace__item__valuesWithContext,
        ___ContentChange_attributeChanges_replace__item_,
        __ContentChange_attributeChanges_replace,
        ___ContentChange_attributeChanges_changes__item_,
        __ContentChange_attributeChanges_changes,
        _ContentChange_attributeChanges,
        _ContentChange_sDSEType,
        _ContentChange_subComplete,
        _ContentChange_attComplete,
        __ContentChange_attValIncomplete__item_,
        _ContentChange_attValIncomplete,
        ContentChange,
        _SubordinateChanges_subordinate,
        _SubordinateChanges_changes,
        SubordinateChanges,
        shadowError,
        __shadowError_val_ParameterType_unsigned,
        ___shadowError_val_ParameterType_signed_toBeSigned,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___shadowError_val_ParameterType_signed_algorithmIdentifier,
        ___shadowError_val_ParameterType_signed_encrypted,
        __shadowError_val_ParameterType_signed,
        _shadowError_val_ParameterType,
        _ShadowErrorData_problem,
        _ShadowErrorData_lastUpdate,
        _ShadowErrorData_updateWindow,
        _ShadowErrorData_securityParameters,
        _ShadowErrorData_performer,
        _ShadowErrorData_aliasDereferenced,
        ____ShadowErrorData_notification__item__type_tab,
        _____ShadowErrorData_notification__item__type_tab_val_Type_0,
        _____ShadowErrorData_notification__item__type_tab_val_Type_1,
        ___ShadowErrorData_notification__item__type,
        ____ShadowErrorData_notification__item__values__item_,
        ___ShadowErrorData_notification__item__values,
        _____ShadowErrorData_notification__item__valuesWithContext__item__value,
        ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ShadowErrorData_notification__item__valuesWithContext__item__contextList,
        ____ShadowErrorData_notification__item__valuesWithContext__item_,
        ___ShadowErrorData_notification__item__valuesWithContext,
        __ShadowErrorData_notification__item_,
        _ShadowErrorData_notification,
        ShadowErrorData,
        ShadowProblem,
    ]

class DistributedOperations:

    _name_  = 'DistributedOperations'
    _oid_   = [2, 5, 1, 3, 7]
    
    _obj_ = [
        'dsaReferral',
        'DsaReferralData',
        'ChainingArguments',
        'Time',
        'DomainInfo',
        'ChainingResults',
        'CrossReference',
        'OperationProgress',
        'TraceInformation',
        'TraceItem',
        'ReferenceType',
        'AccessPoint',
        'MasterOrShadowAccessPoint',
        'MasterAndShadowAccessPoints',
        'AccessPointInformation',
        'DitBridgeKnowledge',
        'Exclusions',
        'ContinuationReference',
        'dSABind',
        'DSABindArgument',
        'DSACredentials',
        'DSABindResult',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _type_ = [
        'DsaReferralData',
        'ChainingArguments',
        'Time',
        'DomainInfo',
        'ChainingResults',
        'CrossReference',
        'OperationProgress',
        'TraceInformation',
        'TraceItem',
        'ReferenceType',
        'AccessPoint',
        'MasterOrShadowAccessPoint',
        'MasterAndShadowAccessPoints',
        'AccessPointInformation',
        'DitBridgeKnowledge',
        'Exclusions',
        'ContinuationReference',
        'DSABindArgument',
        'DSACredentials',
        'DSABindResult',
        ]
    _set_ = [
        ]
    _val_ = [
        'dsaReferral',
        'dSABind',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _class_ = [
        'dsaReferral',
        'dSABind',
        'chained',
        'chainedRead',
        'chainedCompare',
        'chainedAbandon',
        'chainedList',
        'chainedSearch',
        'chainedAddEntry',
        'chainedRemoveEntry',
        'chainedModifyEntry',
        'chainedModifyDN',
        'chainedChangePassword',
        'chainedAdministerPassword',
        'chainedLdapTransport',
        'chainedLinkedLDAP',
        ]
    _param_ = [
        'chained',
        ]
    
    #-----< dsaReferral >-----#
    dsaReferral = CLASS(name='dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _dsaReferral_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __dsaReferral_val_ParameterType_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    __dsaReferral_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___dsaReferral_val_ParameterType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___dsaReferral_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __dsaReferral_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___dsaReferral_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___dsaReferral_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___dsaReferral_val_ParameterType_signed_encrypted),
        ])
    __dsaReferral_val_ParameterType_signed._ext = []
    _dsaReferral_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __dsaReferral_val_ParameterType_unsigned),
        ('signed', __dsaReferral_val_ParameterType_signed),
        ])
    _dsaReferral_val_ParameterType._ext = None
    dsaReferral._val = dict([('ParameterType', _dsaReferral_val_ParameterType), ('errorCode', ('local', 9))])
    
    #-----< DsaReferralData >-----#
    DsaReferralData = SET(name='DsaReferralData', mode=MODE_TYPE)
    _DsaReferralData_reference = SET(name='reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _DsaReferralData_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _DsaReferralData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _DsaReferralData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DsaReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___DsaReferralData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____DsaReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____DsaReferralData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____DsaReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____DsaReferralData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____DsaReferralData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___DsaReferralData_notification__item__type._const_tab = ____DsaReferralData_notification__item__type_tab
    ___DsaReferralData_notification__item__type._const_tab_at = None
    ___DsaReferralData_notification__item__type._const_tab_id = 'id'
    ___DsaReferralData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____DsaReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____DsaReferralData_notification__item__values__item_._const_tab = ____DsaReferralData_notification__item__type_tab
    ____DsaReferralData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____DsaReferralData_notification__item__values__item_._const_tab_id = 'Type'
    ___DsaReferralData_notification__item__values._cont = ____DsaReferralData_notification__item__values__item_
    ___DsaReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___DsaReferralData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____DsaReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab = ____DsaReferralData_notification__item__type_tab
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._cont = ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____DsaReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____DsaReferralData_notification__item__valuesWithContext__item__value),
        ('contextList', _____DsaReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____DsaReferralData_notification__item__valuesWithContext__item_._ext = []
    ___DsaReferralData_notification__item__valuesWithContext._cont = ____DsaReferralData_notification__item__valuesWithContext__item_
    ___DsaReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __DsaReferralData_notification__item_._cont = ASN1Dict([
        ('type', ___DsaReferralData_notification__item__type),
        ('values', ___DsaReferralData_notification__item__values),
        ('valuesWithContext', ___DsaReferralData_notification__item__valuesWithContext),
        ])
    __DsaReferralData_notification__item_._ext = []
    _DsaReferralData_notification._cont = __DsaReferralData_notification__item_
    DsaReferralData._cont = ASN1Dict([
        ('reference', _DsaReferralData_reference),
        ('contextPrefix', _DsaReferralData_contextPrefix),
        ('securityParameters', _DsaReferralData_securityParameters),
        ('performer', _DsaReferralData_performer),
        ('aliasDereferenced', _DsaReferralData_aliasDereferenced),
        ('notification', _DsaReferralData_notification),
        ])
    DsaReferralData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< ChainingArguments >-----#
    ChainingArguments = SET(name='ChainingArguments', mode=MODE_TYPE)
    _ChainingArguments_originator = SEQ_OF(name='originator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_targetObject = SEQ_OF(name='targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([('nameResolutionPhase', 'notStarted')]))
    _ChainingArguments_traceInformation = SEQ_OF(name='traceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'TraceInformation')))
    _ChainingArguments_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_returnCrossRefs = BOOL(name='returnCrossRefs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), default='superior')
    _ChainingArguments_info = OPEN(name='info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingArguments_timeLimit = CHOICE(name='timeLimit', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Time')), opt=True)
    _ChainingArguments_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingArguments_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_uniqueIdentifier = BIT_STR(name='uniqueIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _ChainingArguments_authenticationLevel = CHOICE(name='authenticationLevel', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')), opt=True)
    _ChainingArguments_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ChainingArguments_excludeShadows = BOOL(name='excludeShadows', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_operationIdentifier = INT(name='operationIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_searchRuleId = SEQ(name='searchRuleId', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'SearchRuleId')), opt=True)
    _ChainingArguments_chainedRelaxation = SEQ(name='chainedRelaxation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), opt=True)
    _ChainingArguments_relatedEntry = INT(name='relatedEntry', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_dspPaging = BOOL(name='dspPaging', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_excludeWriteableCopies = BOOL(name='excludeWriteableCopies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ChainingArguments._cont = ASN1Dict([
        ('originator', _ChainingArguments_originator),
        ('targetObject', _ChainingArguments_targetObject),
        ('operationProgress', _ChainingArguments_operationProgress),
        ('traceInformation', _ChainingArguments_traceInformation),
        ('aliasDereferenced', _ChainingArguments_aliasDereferenced),
        ('aliasedRDNs', _ChainingArguments_aliasedRDNs),
        ('returnCrossRefs', _ChainingArguments_returnCrossRefs),
        ('referenceType', _ChainingArguments_referenceType),
        ('info', _ChainingArguments_info),
        ('timeLimit', _ChainingArguments_timeLimit),
        ('securityParameters', _ChainingArguments_securityParameters),
        ('entryOnly', _ChainingArguments_entryOnly),
        ('uniqueIdentifier', _ChainingArguments_uniqueIdentifier),
        ('authenticationLevel', _ChainingArguments_authenticationLevel),
        ('exclusions', _ChainingArguments_exclusions),
        ('excludeShadows', _ChainingArguments_excludeShadows),
        ('nameResolveOnMaster', _ChainingArguments_nameResolveOnMaster),
        ('operationIdentifier', _ChainingArguments_operationIdentifier),
        ('searchRuleId', _ChainingArguments_searchRuleId),
        ('chainedRelaxation', _ChainingArguments_chainedRelaxation),
        ('relatedEntry', _ChainingArguments_relatedEntry),
        ('dspPaging', _ChainingArguments_dspPaging),
        ('excludeWriteableCopies', _ChainingArguments_excludeWriteableCopies),
        ])
    ChainingArguments._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< DomainInfo >-----#
    DomainInfo = OPEN(name='DomainInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    
    #-----< ChainingResults >-----#
    ChainingResults = SET(name='ChainingResults', mode=MODE_TYPE)
    _ChainingResults_info = OPEN(name='info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingResults_crossReferences = SEQ_OF(name='crossReferences', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChainingResults_crossReferences__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'CrossReference')))
    _ChainingResults_crossReferences._cont = __ChainingResults_crossReferences__item_
    _ChainingResults_crossReferences._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChainingResults_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingResults_alreadySearched = SET_OF(name='alreadySearched', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    ChainingResults._cont = ASN1Dict([
        ('info', _ChainingResults_info),
        ('crossReferences', _ChainingResults_crossReferences),
        ('securityParameters', _ChainingResults_securityParameters),
        ('alreadySearched', _ChainingResults_alreadySearched),
        ])
    ChainingResults._ext = []
    
    #-----< CrossReference >-----#
    CrossReference = SET(name='CrossReference', mode=MODE_TYPE)
    _CrossReference_contextPrefix = SEQ_OF(name='contextPrefix', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _CrossReference_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    CrossReference._cont = ASN1Dict([
        ('contextPrefix', _CrossReference_contextPrefix),
        ('accessPoint', _CrossReference_accessPoint),
        ])
    CrossReference._ext = []
    
    #-----< OperationProgress >-----#
    OperationProgress = SET(name='OperationProgress', mode=MODE_TYPE)
    _OperationProgress_nameResolutionPhase = ENUM(name='nameResolutionPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OperationProgress_nameResolutionPhase._cont = ASN1Dict([('notStarted', 1), ('proceeding', 2), ('completed', 3)])
    _OperationProgress_nameResolutionPhase._ext = []
    _OperationProgress_nextRDNToBeResolved = INT(name='nextRDNToBeResolved', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    OperationProgress._cont = ASN1Dict([
        ('nameResolutionPhase', _OperationProgress_nameResolutionPhase),
        ('nextRDNToBeResolved', _OperationProgress_nextRDNToBeResolved),
        ])
    OperationProgress._ext = []
    
    #-----< TraceInformation >-----#
    TraceInformation = SEQ_OF(name='TraceInformation', mode=MODE_TYPE)
    _TraceInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'TraceItem')))
    TraceInformation._cont = _TraceInformation__item_
    
    #-----< TraceItem >-----#
    TraceItem = SET(name='TraceItem', mode=MODE_TYPE)
    _TraceItem_dsa = CHOICE(name='dsa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TraceItem_targetObject = CHOICE(name='targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _TraceItem_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    TraceItem._cont = ASN1Dict([
        ('dsa', _TraceItem_dsa),
        ('targetObject', _TraceItem_targetObject),
        ('operationProgress', _TraceItem_operationProgress),
        ])
    TraceItem._ext = []
    
    #-----< ReferenceType >-----#
    ReferenceType = ENUM(name='ReferenceType', mode=MODE_TYPE)
    ReferenceType._cont = ASN1Dict([('superior', 1), ('subordinate', 2), ('cross', 3), ('nonSpecificSubordinate', 4), ('supplier', 5), ('master', 6), ('immediateSuperior', 7), ('self', 8), ('ditBridge', 9)])
    ReferenceType._ext = []
    
    #-----< AccessPoint >-----#
    AccessPoint = SET(name='AccessPoint', mode=MODE_TYPE)
    _AccessPoint_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPoint_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPoint_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPoint_protocolInformation._cont = __AccessPoint_protocolInformation__item_
    _AccessPoint_protocolInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AccessPoint._cont = ASN1Dict([
        ('ae-title', _AccessPoint_ae_title),
        ('address', _AccessPoint_address),
        ('protocolInformation', _AccessPoint_protocolInformation),
        ])
    AccessPoint._ext = []
    
    #-----< MasterOrShadowAccessPoint >-----#
    MasterOrShadowAccessPoint = SET(name='MasterOrShadowAccessPoint', mode=MODE_TYPE)
    _MasterOrShadowAccessPoint_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _MasterOrShadowAccessPoint_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _MasterOrShadowAccessPoint_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MasterOrShadowAccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _MasterOrShadowAccessPoint_protocolInformation._cont = __MasterOrShadowAccessPoint_protocolInformation__item_
    _MasterOrShadowAccessPoint_category = ENUM(name='category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='master')
    _MasterOrShadowAccessPoint_category._cont = ASN1Dict([('master', 0), ('shadow', 1), ('writeableCopy', 2)])
    _MasterOrShadowAccessPoint_category._ext = []
    _MasterOrShadowAccessPoint_chainingRequired = BOOL(name='chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MasterOrShadowAccessPoint._cont = ASN1Dict([
        ('ae-title', _MasterOrShadowAccessPoint_ae_title),
        ('address', _MasterOrShadowAccessPoint_address),
        ('protocolInformation', _MasterOrShadowAccessPoint_protocolInformation),
        ('category', _MasterOrShadowAccessPoint_category),
        ('chainingRequired', _MasterOrShadowAccessPoint_chainingRequired),
        ])
    MasterOrShadowAccessPoint._ext = []
    
    #-----< MasterAndShadowAccessPoints >-----#
    MasterAndShadowAccessPoints = SET_OF(name='MasterAndShadowAccessPoints', mode=MODE_TYPE)
    _MasterAndShadowAccessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterOrShadowAccessPoint')))
    MasterAndShadowAccessPoints._cont = _MasterAndShadowAccessPoints__item_
    MasterAndShadowAccessPoints._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessPointInformation >-----#
    AccessPointInformation = SET(name='AccessPointInformation', mode=MODE_TYPE)
    _AccessPointInformation_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPointInformation_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPointInformation_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPointInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPointInformation_protocolInformation._cont = __AccessPointInformation_protocolInformation__item_
    _AccessPointInformation_category = ENUM(name='category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default='master')
    _AccessPointInformation_category._cont = ASN1Dict([('master', 0), ('shadow', 1), ('writeableCopy', 2)])
    _AccessPointInformation_category._ext = []
    _AccessPointInformation_chainingRequired = BOOL(name='chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AccessPointInformation_additionalPoints = SET_OF(name='additionalPoints', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    AccessPointInformation._cont = ASN1Dict([
        ('ae-title', _AccessPointInformation_ae_title),
        ('address', _AccessPointInformation_address),
        ('protocolInformation', _AccessPointInformation_protocolInformation),
        ('category', _AccessPointInformation_category),
        ('chainingRequired', _AccessPointInformation_chainingRequired),
        ('additionalPoints', _AccessPointInformation_additionalPoints),
        ])
    AccessPointInformation._ext = []
    
    #-----< DitBridgeKnowledge >-----#
    DitBridgeKnowledge = SEQ(name='DitBridgeKnowledge', mode=MODE_TYPE)
    _DitBridgeKnowledge_domainLocalID = CHOICE(name='domainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DitBridgeKnowledge_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    DitBridgeKnowledge._cont = ASN1Dict([
        ('domainLocalID', _DitBridgeKnowledge_domainLocalID),
        ('accessPoints', _DitBridgeKnowledge_accessPoints),
        ])
    DitBridgeKnowledge._ext = []
    
    #-----< Exclusions >-----#
    Exclusions = SET_OF(name='Exclusions', mode=MODE_TYPE)
    _Exclusions__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Exclusions._cont = _Exclusions__item_
    Exclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ContinuationReference >-----#
    ContinuationReference = SET(name='ContinuationReference', mode=MODE_TYPE)
    _ContinuationReference_targetObject = CHOICE(name='targetObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ContinuationReference_aliasedRDNs = INT(name='aliasedRDNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_operationProgress = SET(name='operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    _ContinuationReference_rdnsResolved = INT(name='rdnsResolved', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_referenceType = ENUM(name='referenceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')))
    _ContinuationReference_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContinuationReference_accessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    _ContinuationReference_accessPoints._cont = __ContinuationReference_accessPoints__item_
    _ContinuationReference_entryOnly = BOOL(name='entryOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_exclusions = SET_OF(name='exclusions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ContinuationReference_returnToDUA = BOOL(name='returnToDUA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_nameResolveOnMaster = BOOL(name='nameResolveOnMaster', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ContinuationReference._cont = ASN1Dict([
        ('targetObject', _ContinuationReference_targetObject),
        ('aliasedRDNs', _ContinuationReference_aliasedRDNs),
        ('operationProgress', _ContinuationReference_operationProgress),
        ('rdnsResolved', _ContinuationReference_rdnsResolved),
        ('referenceType', _ContinuationReference_referenceType),
        ('accessPoints', _ContinuationReference_accessPoints),
        ('entryOnly', _ContinuationReference_entryOnly),
        ('exclusions', _ContinuationReference_exclusions),
        ('returnToDUA', _ContinuationReference_returnToDUA),
        ('nameResolveOnMaster', _ContinuationReference_nameResolveOnMaster),
        ])
    ContinuationReference._ext = []
    
    #-----< dSABind >-----#
    dSABind = CLASS(name='dSABind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSABind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSABind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSABind._val = dict([('ArgumentType', _dSABind_val_ArgumentType), ('ResultType', _dSABind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DSABindArgument >-----#
    DSABindArgument = SET(name='DSABindArgument', mode=MODE_TYPE)
    _DSABindArgument_credentials = CHOICE(name='credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DSACredentials')), opt=True)
    _DSABindArgument_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DSABindArgument._cont = ASN1Dict([
        ('credentials', _DSABindArgument_credentials),
        ('versions', _DSABindArgument_versions),
        ])
    DSABindArgument._ext = []
    
    #-----< DSACredentials >-----#
    DSACredentials = CHOICE(name='DSACredentials', mode=MODE_TYPE)
    _DSACredentials_simple = SEQ(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _DSACredentials_strong = SET(name='strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _DSACredentials_externalProcedure = EXT(name='externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _DSACredentials_spkm = CHOICE(name='spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    DSACredentials._cont = ASN1Dict([
        ('simple', _DSACredentials_simple),
        ('strong', _DSACredentials_strong),
        ('externalProcedure', _DSACredentials_externalProcedure),
        ('spkm', _DSACredentials_spkm),
        ])
    DSACredentials._ext = []
    
    #-----< DSABindResult >-----#
    DSABindResult = SET(name='DSABindResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    
    #-----< chained >-----#
    chained = CLASS(name='chained', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), param=True)
    
    #-----< chainedRead >-----#
    chainedRead = CLASS(name='chainedRead', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRead_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRead_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __chainedRead_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedRead_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedRead_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRead_val_ArgumentType_unsigned._ext = None
    __chainedRead_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRead_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedRead_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRead_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRead_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedRead_val_ArgumentType_signed_encrypted),
        ])
    __chainedRead_val_ArgumentType_signed._ext = []
    _chainedRead_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedRead_val_ArgumentType_unsigned),
        ('signed', __chainedRead_val_ArgumentType_signed),
        ])
    _chainedRead_val_ArgumentType._ext = None
    _chainedRead_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRead_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __chainedRead_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedRead_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedRead_val_ResultType_unsigned_ResultType),
        ])
    __chainedRead_val_ResultType_unsigned._ext = None
    __chainedRead_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRead_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___chainedRead_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedRead_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRead_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRead_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedRead_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRead_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRead_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedRead_val_ResultType_signed_encrypted),
        ])
    __chainedRead_val_ResultType_signed._ext = []
    _chainedRead_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedRead_val_ResultType_unsigned),
        ('signed', __chainedRead_val_ResultType_signed),
        ])
    _chainedRead_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    chainedRead._val = dict([('ArgumentType', _chainedRead_val_ArgumentType), ('ResultType', _chainedRead_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))])
    
    #-----< chainedCompare >-----#
    chainedCompare = CLASS(name='chainedCompare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedCompare_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedCompare_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __chainedCompare_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedCompare_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedCompare_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedCompare_val_ArgumentType_unsigned._ext = None
    __chainedCompare_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedCompare_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedCompare_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedCompare_val_ArgumentType_signed_encrypted),
        ])
    __chainedCompare_val_ArgumentType_signed._ext = []
    _chainedCompare_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedCompare_val_ArgumentType_unsigned),
        ('signed', __chainedCompare_val_ArgumentType_signed),
        ])
    _chainedCompare_val_ArgumentType._ext = None
    _chainedCompare_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedCompare_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __chainedCompare_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedCompare_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedCompare_val_ResultType_unsigned_ResultType),
        ])
    __chainedCompare_val_ResultType_unsigned._ext = None
    __chainedCompare_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___chainedCompare_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedCompare_val_ResultType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedCompare_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedCompare_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedCompare_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedCompare_val_ResultType_signed_encrypted),
        ])
    __chainedCompare_val_ResultType_signed._ext = []
    _chainedCompare_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedCompare_val_ResultType_unsigned),
        ('signed', __chainedCompare_val_ResultType_signed),
        ])
    _chainedCompare_val_ResultType._ext = None
    chainedCompare._val = dict([('ArgumentType', _chainedCompare_val_ArgumentType), ('ResultType', _chainedCompare_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])
    
    #-----< chainedAbandon >-----#
    chainedAbandon = CLASS(name='chainedAbandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAbandon_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _chainedAbandon_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    chainedAbandon._val = dict([('ArgumentType', _chainedAbandon_val_ArgumentType), ('ResultType', _chainedAbandon_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])
    
    #-----< chainedList >-----#
    chainedList = CLASS(name='chainedList', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedList_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedList_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedList_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __chainedList_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedList_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedList_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedList_val_ArgumentType_unsigned._ext = None
    __chainedList_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___chainedList_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedList_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedList_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedList_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedList_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedList_val_ArgumentType_signed_encrypted),
        ])
    __chainedList_val_ArgumentType_signed._ext = []
    _chainedList_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedList_val_ArgumentType_unsigned),
        ('signed', __chainedList_val_ArgumentType_signed),
        ])
    _chainedList_val_ArgumentType._ext = None
    _chainedList_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedList_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedList_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __chainedList_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedList_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedList_val_ResultType_unsigned_ResultType),
        ])
    __chainedList_val_ResultType_unsigned._ext = None
    __chainedList_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedList_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___chainedList_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedList_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedList_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedList_val_ResultType_signed_toBeSigned._ext = None
    ___chainedList_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedList_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedList_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedList_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedList_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedList_val_ResultType_signed_encrypted),
        ])
    __chainedList_val_ResultType_signed._ext = []
    _chainedList_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedList_val_ResultType_unsigned),
        ('signed', __chainedList_val_ResultType_signed),
        ])
    _chainedList_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    chainedList._val = dict([('ArgumentType', _chainedList_val_ArgumentType), ('ResultType', _chainedList_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))])
    
    #-----< chainedSearch >-----#
    chainedSearch = CLASS(name='chainedSearch', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedSearch_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedSearch_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __chainedSearch_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedSearch_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedSearch_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedSearch_val_ArgumentType_unsigned._ext = None
    __chainedSearch_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedSearch_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedSearch_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedSearch_val_ArgumentType_signed_encrypted),
        ])
    __chainedSearch_val_ArgumentType_signed._ext = []
    _chainedSearch_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedSearch_val_ArgumentType_unsigned),
        ('signed', __chainedSearch_val_ArgumentType_signed),
        ])
    _chainedSearch_val_ArgumentType._ext = None
    _chainedSearch_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedSearch_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __chainedSearch_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedSearch_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedSearch_val_ResultType_unsigned_ResultType),
        ])
    __chainedSearch_val_ResultType_unsigned._ext = None
    __chainedSearch_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___chainedSearch_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedSearch_val_ResultType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedSearch_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedSearch_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedSearch_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedSearch_val_ResultType_signed_encrypted),
        ])
    __chainedSearch_val_ResultType_signed._ext = []
    _chainedSearch_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedSearch_val_ResultType_unsigned),
        ('signed', __chainedSearch_val_ResultType_signed),
        ])
    _chainedSearch_val_ResultType._ext = None
    chainedSearch._val = dict([('ArgumentType', _chainedSearch_val_ArgumentType), ('ResultType', _chainedSearch_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))])
    
    #-----< chainedAddEntry >-----#
    chainedAddEntry = CLASS(name='chainedAddEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAddEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __chainedAddEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAddEntry_val_ArgumentType_unsigned._ext = None
    __chainedAddEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedAddEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAddEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedAddEntry_val_ArgumentType_signed_encrypted),
        ])
    __chainedAddEntry_val_ArgumentType_signed._ext = []
    _chainedAddEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedAddEntry_val_ArgumentType_unsigned),
        ('signed', __chainedAddEntry_val_ArgumentType_signed),
        ])
    _chainedAddEntry_val_ArgumentType._ext = None
    _chainedAddEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAddEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __chainedAddEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedAddEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedAddEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedAddEntry_val_ResultType_unsigned._ext = None
    __chainedAddEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedAddEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAddEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedAddEntry_val_ResultType_signed_encrypted),
        ])
    __chainedAddEntry_val_ResultType_signed._ext = []
    _chainedAddEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedAddEntry_val_ResultType_unsigned),
        ('signed', __chainedAddEntry_val_ResultType_signed),
        ])
    _chainedAddEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    chainedAddEntry._val = dict([('ArgumentType', _chainedAddEntry_val_ArgumentType), ('ResultType', _chainedAddEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))])
    
    #-----< chainedRemoveEntry >-----#
    chainedRemoveEntry = CLASS(name='chainedRemoveEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRemoveEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __chainedRemoveEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRemoveEntry_val_ArgumentType_unsigned._ext = None
    __chainedRemoveEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedRemoveEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedRemoveEntry_val_ArgumentType_signed_encrypted),
        ])
    __chainedRemoveEntry_val_ArgumentType_signed._ext = []
    _chainedRemoveEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedRemoveEntry_val_ArgumentType_unsigned),
        ('signed', __chainedRemoveEntry_val_ArgumentType_signed),
        ])
    _chainedRemoveEntry_val_ArgumentType._ext = None
    _chainedRemoveEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRemoveEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __chainedRemoveEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedRemoveEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedRemoveEntry_val_ResultType_unsigned._ext = None
    __chainedRemoveEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedRemoveEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedRemoveEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedRemoveEntry_val_ResultType_signed_encrypted),
        ])
    __chainedRemoveEntry_val_ResultType_signed._ext = []
    _chainedRemoveEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedRemoveEntry_val_ResultType_unsigned),
        ('signed', __chainedRemoveEntry_val_ResultType_signed),
        ])
    _chainedRemoveEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    chainedRemoveEntry._val = dict([('ArgumentType', _chainedRemoveEntry_val_ArgumentType), ('ResultType', _chainedRemoveEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))])
    
    #-----< chainedModifyEntry >-----#
    chainedModifyEntry = CLASS(name='chainedModifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyEntry_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __chainedModifyEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyEntry_val_ArgumentType_unsigned._ext = None
    __chainedModifyEntry_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedModifyEntry_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedModifyEntry_val_ArgumentType_signed_encrypted),
        ])
    __chainedModifyEntry_val_ArgumentType_signed._ext = []
    _chainedModifyEntry_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedModifyEntry_val_ArgumentType_unsigned),
        ('signed', __chainedModifyEntry_val_ArgumentType_signed),
        ])
    _chainedModifyEntry_val_ArgumentType._ext = None
    _chainedModifyEntry_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyEntry_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __chainedModifyEntry_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedModifyEntry_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedModifyEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyEntry_val_ResultType_unsigned._ext = None
    __chainedModifyEntry_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedModifyEntry_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyEntry_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedModifyEntry_val_ResultType_signed_encrypted),
        ])
    __chainedModifyEntry_val_ResultType_signed._ext = []
    _chainedModifyEntry_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedModifyEntry_val_ResultType_unsigned),
        ('signed', __chainedModifyEntry_val_ResultType_signed),
        ])
    _chainedModifyEntry_val_ResultType._ext = None
    chainedModifyEntry._val = dict([('ArgumentType', _chainedModifyEntry_val_ArgumentType), ('ResultType', _chainedModifyEntry_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))])
    
    #-----< chainedModifyDN >-----#
    chainedModifyDN = CLASS(name='chainedModifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyDN_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __chainedModifyDN_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyDN_val_ArgumentType_unsigned._ext = None
    __chainedModifyDN_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedModifyDN_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyDN_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedModifyDN_val_ArgumentType_signed_encrypted),
        ])
    __chainedModifyDN_val_ArgumentType_signed._ext = []
    _chainedModifyDN_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedModifyDN_val_ArgumentType_unsigned),
        ('signed', __chainedModifyDN_val_ArgumentType_signed),
        ])
    _chainedModifyDN_val_ArgumentType._ext = None
    _chainedModifyDN_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyDN_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __chainedModifyDN_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedModifyDN_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedModifyDN_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyDN_val_ResultType_unsigned._ext = None
    __chainedModifyDN_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedModifyDN_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedModifyDN_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedModifyDN_val_ResultType_signed_encrypted),
        ])
    __chainedModifyDN_val_ResultType_signed._ext = []
    _chainedModifyDN_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedModifyDN_val_ResultType_unsigned),
        ('signed', __chainedModifyDN_val_ResultType_signed),
        ])
    _chainedModifyDN_val_ResultType._ext = None
    chainedModifyDN._val = dict([('ArgumentType', _chainedModifyDN_val_ArgumentType), ('ResultType', _chainedModifyDN_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))])
    
    #-----< chainedChangePassword >-----#
    chainedChangePassword = CLASS(name='chainedChangePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedChangePassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __chainedChangePassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedChangePassword_val_ArgumentType_unsigned._ext = None
    __chainedChangePassword_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedChangePassword_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedChangePassword_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedChangePassword_val_ArgumentType_signed_encrypted),
        ])
    __chainedChangePassword_val_ArgumentType_signed._ext = []
    _chainedChangePassword_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedChangePassword_val_ArgumentType_unsigned),
        ('signed', __chainedChangePassword_val_ArgumentType_signed),
        ])
    _chainedChangePassword_val_ArgumentType._ext = None
    _chainedChangePassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedChangePassword_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __chainedChangePassword_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedChangePassword_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedChangePassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedChangePassword_val_ResultType_unsigned._ext = None
    __chainedChangePassword_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedChangePassword_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedChangePassword_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedChangePassword_val_ResultType_signed_encrypted),
        ])
    __chainedChangePassword_val_ResultType_signed._ext = []
    _chainedChangePassword_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedChangePassword_val_ResultType_unsigned),
        ('signed', __chainedChangePassword_val_ResultType_signed),
        ])
    _chainedChangePassword_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    chainedChangePassword._val = dict([('ArgumentType', _chainedChangePassword_val_ArgumentType), ('ResultType', _chainedChangePassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))])
    
    #-----< chainedAdministerPassword >-----#
    chainedAdministerPassword = CLASS(name='chainedAdministerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAdministerPassword_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __chainedAdministerPassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAdministerPassword_val_ArgumentType_unsigned._ext = None
    __chainedAdministerPassword_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedAdministerPassword_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedAdministerPassword_val_ArgumentType_signed_encrypted),
        ])
    __chainedAdministerPassword_val_ArgumentType_signed._ext = []
    _chainedAdministerPassword_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedAdministerPassword_val_ArgumentType_unsigned),
        ('signed', __chainedAdministerPassword_val_ArgumentType_signed),
        ])
    _chainedAdministerPassword_val_ArgumentType._ext = None
    _chainedAdministerPassword_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAdministerPassword_val_ResultType_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __chainedAdministerPassword_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedAdministerPassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedAdministerPassword_val_ResultType_unsigned._ext = None
    __chainedAdministerPassword_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedAdministerPassword_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedAdministerPassword_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedAdministerPassword_val_ResultType_signed_encrypted),
        ])
    __chainedAdministerPassword_val_ResultType_signed._ext = []
    _chainedAdministerPassword_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedAdministerPassword_val_ResultType_unsigned),
        ('signed', __chainedAdministerPassword_val_ResultType_signed),
        ])
    _chainedAdministerPassword_val_ResultType._ext = None
    chainedAdministerPassword._val = dict([('ArgumentType', _chainedAdministerPassword_val_ArgumentType), ('ResultType', _chainedAdministerPassword_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))])
    
    #-----< chainedLdapTransport >-----#
    chainedLdapTransport = CLASS(name='chainedLdapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLdapTransport_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    __chainedLdapTransport_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLdapTransport_val_ArgumentType_unsigned._ext = None
    __chainedLdapTransport_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedLdapTransport_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedLdapTransport_val_ArgumentType_signed_encrypted),
        ])
    __chainedLdapTransport_val_ArgumentType_signed._ext = []
    _chainedLdapTransport_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedLdapTransport_val_ArgumentType_unsigned),
        ('signed', __chainedLdapTransport_val_ArgumentType_signed),
        ])
    _chainedLdapTransport_val_ArgumentType._ext = None
    _chainedLdapTransport_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType._cont = ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_
    __chainedLdapTransport_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedLdapTransport_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedLdapTransport_val_ResultType_unsigned_ResultType),
        ])
    __chainedLdapTransport_val_ResultType_unsigned._ext = None
    __chainedLdapTransport_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType._cont = _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedLdapTransport_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLdapTransport_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedLdapTransport_val_ResultType_signed_encrypted),
        ])
    __chainedLdapTransport_val_ResultType_signed._ext = []
    _chainedLdapTransport_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedLdapTransport_val_ResultType_unsigned),
        ('signed', __chainedLdapTransport_val_ResultType_signed),
        ])
    _chainedLdapTransport_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    chainedLdapTransport._val = dict([('ArgumentType', _chainedLdapTransport_val_ArgumentType), ('ResultType', _chainedLdapTransport_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))])
    
    #-----< chainedLinkedLDAP >-----#
    chainedLinkedLDAP = CLASS(name='chainedLinkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLinkedLDAP_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned._cont = ASN1Dict([
        ('chainedArgument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument),
        ('argument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLinkedLDAP_val_ArgumentType_unsigned._ext = None
    __chainedLinkedLDAP_val_ArgumentType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument),
        ('argument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ArgumentType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedLinkedLDAP_val_ArgumentType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier),
        ('encrypted', ___chainedLinkedLDAP_val_ArgumentType_signed_encrypted),
        ])
    __chainedLinkedLDAP_val_ArgumentType_signed._ext = []
    _chainedLinkedLDAP_val_ArgumentType._cont = ASN1Dict([
        ('unsigned', __chainedLinkedLDAP_val_ArgumentType_unsigned),
        ('signed', __chainedLinkedLDAP_val_ArgumentType_signed),
        ])
    _chainedLinkedLDAP_val_ArgumentType._ext = None
    _chainedLinkedLDAP_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ResultType_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    __chainedLinkedLDAP_val_ResultType_unsigned._cont = ASN1Dict([
        ('chainedResult', ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult),
        ('result', ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType),
        ])
    __chainedLinkedLDAP_val_ResultType_unsigned._ext = None
    __chainedLinkedLDAP_val_ResultType_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult),
        ('result', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ResultType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __chainedLinkedLDAP_val_ResultType_signed._cont = ASN1Dict([
        ('toBeSigned', ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned),
        ('algorithmIdentifier', ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier),
        ('encrypted', ___chainedLinkedLDAP_val_ResultType_signed_encrypted),
        ])
    __chainedLinkedLDAP_val_ResultType_signed._ext = []
    _chainedLinkedLDAP_val_ResultType._cont = ASN1Dict([
        ('unsigned', __chainedLinkedLDAP_val_ResultType_unsigned),
        ('signed', __chainedLinkedLDAP_val_ResultType_signed),
        ])
    _chainedLinkedLDAP_val_ResultType._ext = None
    chainedLinkedLDAP._val = dict([('ArgumentType', _chainedLinkedLDAP_val_ArgumentType), ('ResultType', _chainedLinkedLDAP_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])
    
    _all_ = [
        dsaReferral,
        __dsaReferral_val_ParameterType_unsigned,
        ___dsaReferral_val_ParameterType_signed_toBeSigned,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___dsaReferral_val_ParameterType_signed_algorithmIdentifier,
        ___dsaReferral_val_ParameterType_signed_encrypted,
        __dsaReferral_val_ParameterType_signed,
        _dsaReferral_val_ParameterType,
        _DsaReferralData_reference,
        _DsaReferralData_contextPrefix,
        _DsaReferralData_securityParameters,
        _DsaReferralData_performer,
        _DsaReferralData_aliasDereferenced,
        ____DsaReferralData_notification__item__type_tab,
        _____DsaReferralData_notification__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _____DsaReferralData_notification__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___DsaReferralData_notification__item__type,
        ____DsaReferralData_notification__item__values__item_,
        ___DsaReferralData_notification__item__values,
        _____DsaReferralData_notification__item__valuesWithContext__item__value,
        ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____DsaReferralData_notification__item__valuesWithContext__item__contextList,
        ____DsaReferralData_notification__item__valuesWithContext__item_,
        ___DsaReferralData_notification__item__valuesWithContext,
        __DsaReferralData_notification__item_,
        _DsaReferralData_notification,
        DsaReferralData,
        _ChainingArguments_originator,
        _ChainingArguments_targetObject,
        _ChainingArguments_operationProgress,
        _ChainingArguments_traceInformation,
        _ChainingArguments_aliasDereferenced,
        _ChainingArguments_aliasedRDNs,
        _ChainingArguments_returnCrossRefs,
        _ChainingArguments_referenceType,
        _ChainingArguments_info,
        _ChainingArguments_timeLimit,
        _ChainingArguments_securityParameters,
        _ChainingArguments_entryOnly,
        _ChainingArguments_uniqueIdentifier,
        _ChainingArguments_authenticationLevel,
        _ChainingArguments_exclusions,
        _ChainingArguments_excludeShadows,
        _ChainingArguments_nameResolveOnMaster,
        _ChainingArguments_operationIdentifier,
        _ChainingArguments_searchRuleId,
        _ChainingArguments_chainedRelaxation,
        _ChainingArguments_relatedEntry,
        _ChainingArguments_dspPaging,
        _ChainingArguments_excludeWriteableCopies,
        ChainingArguments,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        DomainInfo,
        _ChainingResults_info,
        __ChainingResults_crossReferences__item_,
        _ChainingResults_crossReferences,
        _ChainingResults_securityParameters,
        _ChainingResults_alreadySearched,
        ChainingResults,
        _CrossReference_contextPrefix,
        _CrossReference_accessPoint,
        CrossReference,
        _OperationProgress_nameResolutionPhase,
        _OperationProgress_nextRDNToBeResolved,
        OperationProgress,
        _TraceInformation__item_,
        TraceInformation,
        _TraceItem_dsa,
        _TraceItem_targetObject,
        _TraceItem_operationProgress,
        TraceItem,
        ReferenceType,
        _AccessPoint_ae_title,
        _AccessPoint_address,
        __AccessPoint_protocolInformation__item_,
        _AccessPoint_protocolInformation,
        AccessPoint,
        _MasterOrShadowAccessPoint_ae_title,
        _MasterOrShadowAccessPoint_address,
        __MasterOrShadowAccessPoint_protocolInformation__item_,
        _MasterOrShadowAccessPoint_protocolInformation,
        _MasterOrShadowAccessPoint_category,
        _MasterOrShadowAccessPoint_chainingRequired,
        MasterOrShadowAccessPoint,
        _MasterAndShadowAccessPoints__item_,
        MasterAndShadowAccessPoints,
        _AccessPointInformation_ae_title,
        _AccessPointInformation_address,
        __AccessPointInformation_protocolInformation__item_,
        _AccessPointInformation_protocolInformation,
        _AccessPointInformation_category,
        _AccessPointInformation_chainingRequired,
        _AccessPointInformation_additionalPoints,
        AccessPointInformation,
        _DitBridgeKnowledge_domainLocalID,
        _DitBridgeKnowledge_accessPoints,
        DitBridgeKnowledge,
        _Exclusions__item_,
        Exclusions,
        _ContinuationReference_targetObject,
        _ContinuationReference_aliasedRDNs,
        _ContinuationReference_operationProgress,
        _ContinuationReference_rdnsResolved,
        _ContinuationReference_referenceType,
        __ContinuationReference_accessPoints__item_,
        _ContinuationReference_accessPoints,
        _ContinuationReference_entryOnly,
        _ContinuationReference_exclusions,
        _ContinuationReference_returnToDUA,
        _ContinuationReference_nameResolveOnMaster,
        ContinuationReference,
        dSABind,
        _dSABind_val_ArgumentType,
        _dSABind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DSABindArgument_credentials,
        _DSABindArgument_versions,
        DSABindArgument,
        _DSACredentials_simple,
        _DSACredentials_strong,
        _DSACredentials_externalProcedure,
        _DSACredentials_spkm,
        DSACredentials,
        DSABindResult,
        chainedRead,
        ___chainedRead_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRead_val_ArgumentType_unsigned_ArgumentType,
        __chainedRead_val_ArgumentType_unsigned,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRead_val_ArgumentType_signed_toBeSigned,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRead_val_ArgumentType_signed_encrypted,
        __chainedRead_val_ArgumentType_signed,
        _chainedRead_val_ArgumentType,
        ___chainedRead_val_ResultType_unsigned_chainedResult,
        ___chainedRead_val_ResultType_unsigned_ResultType,
        __chainedRead_val_ResultType_unsigned,
        ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRead_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRead_val_ResultType_signed_toBeSigned,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ResultType_signed_algorithmIdentifier,
        ___chainedRead_val_ResultType_signed_encrypted,
        __chainedRead_val_ResultType_signed,
        _chainedRead_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        chainedCompare,
        ___chainedCompare_val_ArgumentType_unsigned_chainedArgument,
        ___chainedCompare_val_ArgumentType_unsigned_ArgumentType,
        __chainedCompare_val_ArgumentType_unsigned,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedCompare_val_ArgumentType_signed_toBeSigned,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedCompare_val_ArgumentType_signed_encrypted,
        __chainedCompare_val_ArgumentType_signed,
        _chainedCompare_val_ArgumentType,
        ___chainedCompare_val_ResultType_unsigned_chainedResult,
        ___chainedCompare_val_ResultType_unsigned_ResultType,
        __chainedCompare_val_ResultType_unsigned,
        ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedCompare_val_ResultType_signed_toBeSigned,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ResultType_signed_algorithmIdentifier,
        ___chainedCompare_val_ResultType_signed_encrypted,
        __chainedCompare_val_ResultType_signed,
        _chainedCompare_val_ResultType,
        chainedAbandon,
        _chainedAbandon_val_ArgumentType,
        _chainedAbandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        chainedList,
        ___chainedList_val_ArgumentType_unsigned_chainedArgument,
        ___chainedList_val_ArgumentType_unsigned_ArgumentType,
        __chainedList_val_ArgumentType_unsigned,
        ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedList_val_ArgumentType_signed_toBeSigned,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedList_val_ArgumentType_signed_encrypted,
        __chainedList_val_ArgumentType_signed,
        _chainedList_val_ArgumentType,
        ___chainedList_val_ResultType_unsigned_chainedResult,
        ___chainedList_val_ResultType_unsigned_ResultType,
        __chainedList_val_ResultType_unsigned,
        ____chainedList_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedList_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedList_val_ResultType_signed_toBeSigned,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ResultType_signed_algorithmIdentifier,
        ___chainedList_val_ResultType_signed_encrypted,
        __chainedList_val_ResultType_signed,
        _chainedList_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        chainedSearch,
        ___chainedSearch_val_ArgumentType_unsigned_chainedArgument,
        ___chainedSearch_val_ArgumentType_unsigned_ArgumentType,
        __chainedSearch_val_ArgumentType_unsigned,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedSearch_val_ArgumentType_signed_toBeSigned,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedSearch_val_ArgumentType_signed_encrypted,
        __chainedSearch_val_ArgumentType_signed,
        _chainedSearch_val_ArgumentType,
        ___chainedSearch_val_ResultType_unsigned_chainedResult,
        ___chainedSearch_val_ResultType_unsigned_ResultType,
        __chainedSearch_val_ResultType_unsigned,
        ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedSearch_val_ResultType_signed_toBeSigned,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ResultType_signed_algorithmIdentifier,
        ___chainedSearch_val_ResultType_signed_encrypted,
        __chainedSearch_val_ResultType_signed,
        _chainedSearch_val_ResultType,
        chainedAddEntry,
        ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedAddEntry_val_ArgumentType_unsigned,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAddEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ArgumentType_signed_encrypted,
        __chainedAddEntry_val_ArgumentType_signed,
        _chainedAddEntry_val_ArgumentType,
        ___chainedAddEntry_val_ResultType_unsigned_chainedResult,
        ___chainedAddEntry_val_ResultType_unsigned_ResultType,
        __chainedAddEntry_val_ResultType_unsigned,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAddEntry_val_ResultType_signed_toBeSigned,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ResultType_signed_encrypted,
        __chainedAddEntry_val_ResultType_signed,
        _chainedAddEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        chainedRemoveEntry,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedRemoveEntry_val_ArgumentType_unsigned,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ArgumentType_signed_encrypted,
        __chainedRemoveEntry_val_ArgumentType_signed,
        _chainedRemoveEntry_val_ArgumentType,
        ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult,
        ___chainedRemoveEntry_val_ResultType_unsigned_ResultType,
        __chainedRemoveEntry_val_ResultType_unsigned,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRemoveEntry_val_ResultType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ResultType_signed_encrypted,
        __chainedRemoveEntry_val_ResultType_signed,
        _chainedRemoveEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        chainedModifyEntry,
        ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyEntry_val_ArgumentType_unsigned,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ArgumentType_signed_encrypted,
        __chainedModifyEntry_val_ArgumentType_signed,
        _chainedModifyEntry_val_ArgumentType,
        ___chainedModifyEntry_val_ResultType_unsigned_chainedResult,
        ___chainedModifyEntry_val_ResultType_unsigned_ResultType,
        __chainedModifyEntry_val_ResultType_unsigned,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyEntry_val_ResultType_signed_toBeSigned,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ResultType_signed_encrypted,
        __chainedModifyEntry_val_ResultType_signed,
        _chainedModifyEntry_val_ResultType,
        chainedModifyDN,
        ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyDN_val_ArgumentType_unsigned,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyDN_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ArgumentType_signed_encrypted,
        __chainedModifyDN_val_ArgumentType_signed,
        _chainedModifyDN_val_ArgumentType,
        ___chainedModifyDN_val_ResultType_unsigned_chainedResult,
        ___chainedModifyDN_val_ResultType_unsigned_ResultType,
        __chainedModifyDN_val_ResultType_unsigned,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyDN_val_ResultType_signed_toBeSigned,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ResultType_signed_encrypted,
        __chainedModifyDN_val_ResultType_signed,
        _chainedModifyDN_val_ResultType,
        chainedChangePassword,
        ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedChangePassword_val_ArgumentType_unsigned,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedChangePassword_val_ArgumentType_signed_toBeSigned,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ArgumentType_signed_encrypted,
        __chainedChangePassword_val_ArgumentType_signed,
        _chainedChangePassword_val_ArgumentType,
        ___chainedChangePassword_val_ResultType_unsigned_chainedResult,
        ___chainedChangePassword_val_ResultType_unsigned_ResultType,
        __chainedChangePassword_val_ResultType_unsigned,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedChangePassword_val_ResultType_signed_toBeSigned,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ResultType_signed_encrypted,
        __chainedChangePassword_val_ResultType_signed,
        _chainedChangePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        chainedAdministerPassword,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedAdministerPassword_val_ArgumentType_unsigned,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ArgumentType_signed_encrypted,
        __chainedAdministerPassword_val_ArgumentType_signed,
        _chainedAdministerPassword_val_ArgumentType,
        ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult,
        ___chainedAdministerPassword_val_ResultType_unsigned_ResultType,
        __chainedAdministerPassword_val_ResultType_unsigned,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAdministerPassword_val_ResultType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ResultType_signed_encrypted,
        __chainedAdministerPassword_val_ResultType_signed,
        _chainedAdministerPassword_val_ResultType,
        chainedLdapTransport,
        ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType,
        __chainedLdapTransport_val_ArgumentType_unsigned,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ArgumentType_signed_encrypted,
        __chainedLdapTransport_val_ArgumentType_signed,
        _chainedLdapTransport_val_ArgumentType,
        ___chainedLdapTransport_val_ResultType_unsigned_chainedResult,
        ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_,
        ___chainedLdapTransport_val_ResultType_unsigned_ResultType,
        __chainedLdapTransport_val_ResultType_unsigned,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult,
        _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLdapTransport_val_ResultType_signed_toBeSigned,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ResultType_signed_encrypted,
        __chainedLdapTransport_val_ResultType_signed,
        _chainedLdapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        chainedLinkedLDAP,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType,
        __chainedLinkedLDAP_val_ArgumentType_unsigned,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ArgumentType_signed_encrypted,
        __chainedLinkedLDAP_val_ArgumentType_signed,
        _chainedLinkedLDAP_val_ArgumentType,
        ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult,
        ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType,
        __chainedLinkedLDAP_val_ResultType_unsigned,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ResultType_signed_encrypted,
        __chainedLinkedLDAP_val_ResultType_signed,
        _chainedLinkedLDAP_val_ResultType,
    ]

class DSAOperationalAttributeTypes:

    _name_  = 'DSAOperationalAttributeTypes'
    _oid_   = [2, 5, 1, 22, 7]
    
    _obj_ = [
        'dseType',
        'DSEType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'SupplierOrConsumer',
        'SupplierInformation',
        'supplierKnowledge',
        'ConsumerInformation',
        'consumerKnowledge',
        'SupplierAndConsumers',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        'id-doa-dseType',
        'id-doa-myAccessPoint',
        'id-doa-superiorKnowledge',
        'id-doa-specificKnowledge',
        'id-doa-nonSpecificKnowledge',
        'id-doa-supplierKnowledge',
        'id-doa-consumerKnowledge',
        'id-doa-secondaryShadows',
        'id-doa-ditBridgeKnowledge',
        'id-kmr-accessPointMatch',
        'id-kmr-masterShadowMatch',
        'id-kmr-supplierConsumerMatch',
        'id-kmr-supplierConsumersMatch',
        ]
    _type_ = [
        'DSEType',
        'SupplierOrConsumer',
        'SupplierInformation',
        'ConsumerInformation',
        'SupplierAndConsumers',
        ]
    _set_ = [
        ]
    _val_ = [
        'dseType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'supplierKnowledge',
        'consumerKnowledge',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        'id-doa-dseType',
        'id-doa-myAccessPoint',
        'id-doa-superiorKnowledge',
        'id-doa-specificKnowledge',
        'id-doa-nonSpecificKnowledge',
        'id-doa-supplierKnowledge',
        'id-doa-consumerKnowledge',
        'id-doa-secondaryShadows',
        'id-doa-ditBridgeKnowledge',
        'id-kmr-accessPointMatch',
        'id-kmr-masterShadowMatch',
        'id-kmr-supplierConsumerMatch',
        'id-kmr-supplierConsumersMatch',
        ]
    _class_ = [
        'dseType',
        'myAccessPoint',
        'superiorKnowledge',
        'specificKnowledge',
        'nonSpecificKnowledge',
        'supplierKnowledge',
        'consumerKnowledge',
        'secondaryShadows',
        'ditBridgeKnowledge',
        'accessPointMatch',
        'masterAndShadowAccessPointsMatch',
        'supplierOrConsumerInformationMatch',
        'supplierAndConsumersMatch',
        ]
    _param_ = [
        ]
    
    #-----< dseType >-----#
    dseType = CLASS(name='dseType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dseType_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    dseType._val = dict([('Type', _dseType_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 0))])
    
    #-----< DSEType >-----#
    DSEType = BIT_STR(name='DSEType', mode=MODE_TYPE)
    DSEType._cont = ASN1Dict([('root', 0), ('glue', 1), ('cp', 2), ('entry', 3), ('alias', 4), ('subr', 5), ('nssr', 6), ('supr', 7), ('xr', 8), ('admPoint', 9), ('subentry', 10), ('shadow', 11), ('immSupr', 13), ('rhob', 14), ('sa', 15), ('dsSubentry', 16), ('familyMember', 17), ('ditBridge', 18)])
    
    #-----< myAccessPoint >-----#
    myAccessPoint = CLASS(name='myAccessPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _myAccessPoint_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    myAccessPoint._val = dict([('Type', _myAccessPoint_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 0))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 1))])
    
    #-----< superiorKnowledge >-----#
    superiorKnowledge = CLASS(name='superiorKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _superiorKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    superiorKnowledge._val = dict([('Type', _superiorKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 0))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 2))])
    
    #-----< specificKnowledge >-----#
    specificKnowledge = CLASS(name='specificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _specificKnowledge_val_Type = SET_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1 = SET_OF(name='AssertionType', mode=MODE_TYPE)
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1._cont = _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1__item_
    specificKnowledge._val = dict([('Type', _specificKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 14, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'distributedOperation'), ('id', (2, 5, 12, 3))])
    
    #-----< nonSpecificKnowledge >-----#
    nonSpecificKnowledge = CLASS(name='nonSpecificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nonSpecificKnowledge_val_Type = SET_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    nonSpecificKnowledge._val = dict([('Type', _nonSpecificKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1), ('id', (2, 5, 14, 1))])), ('no-user-modification', True), ('usage', 'distributedOperation'), ('id', (2, 5, 12, 4))])
    
    #-----< SupplierOrConsumer >-----#
    SupplierOrConsumer = SET(name='SupplierOrConsumer', mode=MODE_TYPE)
    _SupplierOrConsumer_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierOrConsumer_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierOrConsumer_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierOrConsumer_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierOrConsumer_protocolInformation._cont = __SupplierOrConsumer_protocolInformation__item_
    _SupplierOrConsumer_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    SupplierOrConsumer._cont = ASN1Dict([
        ('ae-title', _SupplierOrConsumer_ae_title),
        ('address', _SupplierOrConsumer_address),
        ('protocolInformation', _SupplierOrConsumer_protocolInformation),
        ('agreementID', _SupplierOrConsumer_agreementID),
        ])
    SupplierOrConsumer._ext = []
    
    #-----< SupplierInformation >-----#
    SupplierInformation = SET(name='SupplierInformation', mode=MODE_TYPE)
    _SupplierInformation_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierInformation_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierInformation_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierInformation_protocolInformation._cont = __SupplierInformation_protocolInformation__item_
    _SupplierInformation_agreementID = SEQ(name='agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _SupplierInformation_supplier_is_master = BOOL(name='supplier-is-master', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SupplierInformation_non_supplying_master = SET(name='non-supplying-master', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    SupplierInformation._cont = ASN1Dict([
        ('ae-title', _SupplierInformation_ae_title),
        ('address', _SupplierInformation_address),
        ('protocolInformation', _SupplierInformation_protocolInformation),
        ('agreementID', _SupplierInformation_agreementID),
        ('supplier-is-master', _SupplierInformation_supplier_is_master),
        ('non-supplying-master', _SupplierInformation_non_supplying_master),
        ])
    SupplierInformation._ext = []
    
    #-----< supplierKnowledge >-----#
    supplierKnowledge = CLASS(name='supplierKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supplierKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierInformation')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2 = SET(name='AssertionType', mode=MODE_TYPE)
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier = INT(name='agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2._cont = ASN1Dict([
        ('ae-title', _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title),
        ('agreement-identifier', _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier),
        ])
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2._ext = None
    supplierKnowledge._val = dict([('Type', _supplierKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 14, 2))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 5))])
    
    #-----< ConsumerInformation >-----#
    ConsumerInformation = SET(name='ConsumerInformation', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierOrConsumer')))
    
    #-----< consumerKnowledge >-----#
    consumerKnowledge = CLASS(name='consumerKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _consumerKnowledge_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'ConsumerInformation')))
    consumerKnowledge._val = dict([('Type', _consumerKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2), ('id', (2, 5, 14, 2))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 6))])
    
    #-----< SupplierAndConsumers >-----#
    SupplierAndConsumers = SET(name='SupplierAndConsumers', mode=MODE_TYPE)
    _SupplierAndConsumers_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierAndConsumers_address = SEQ(name='address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierAndConsumers_protocolInformation = SET_OF(name='protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierAndConsumers_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierAndConsumers_protocolInformation._cont = __SupplierAndConsumers_protocolInformation__item_
    _SupplierAndConsumers_consumers = SET_OF(name='consumers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SupplierAndConsumers_consumers__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _SupplierAndConsumers_consumers._cont = __SupplierAndConsumers_consumers__item_
    SupplierAndConsumers._cont = ASN1Dict([
        ('ae-title', _SupplierAndConsumers_ae_title),
        ('address', _SupplierAndConsumers_address),
        ('protocolInformation', _SupplierAndConsumers_protocolInformation),
        ('consumers', _SupplierAndConsumers_consumers),
        ])
    SupplierAndConsumers._ext = []
    
    #-----< secondaryShadows >-----#
    secondaryShadows = CLASS(name='secondaryShadows', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _secondaryShadows_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    secondaryShadows._val = dict([('Type', _secondaryShadows_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('id', (2, 5, 14, 3))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 7))])
    
    #-----< ditBridgeKnowledge >-----#
    ditBridgeKnowledge = CLASS(name='ditBridgeKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ditBridgeKnowledge_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DitBridgeKnowledge')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ditBridgeKnowledge._val = dict([('Type', _ditBridgeKnowledge_val_Type), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])), ('no-user-modification', True), ('usage', 'dSAOperation'), ('id', (2, 5, 12, 8))])
    
    #-----< accessPointMatch >-----#
    accessPointMatch = CLASS(name='accessPointMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _accessPointMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    accessPointMatch._val = dict([('AssertionType', _accessPointMatch_val_AssertionType), ('id', (2, 5, 14, 0))])
    
    #-----< masterAndShadowAccessPointsMatch >-----#
    masterAndShadowAccessPointsMatch = CLASS(name='masterAndShadowAccessPointsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _masterAndShadowAccessPointsMatch_val_AssertionType = SET_OF(name='AssertionType', mode=MODE_TYPE)
    __masterAndShadowAccessPointsMatch_val_AssertionType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _masterAndShadowAccessPointsMatch_val_AssertionType._cont = __masterAndShadowAccessPointsMatch_val_AssertionType__item_
    masterAndShadowAccessPointsMatch._val = dict([('AssertionType', _masterAndShadowAccessPointsMatch_val_AssertionType), ('id', (2, 5, 14, 1))])
    
    #-----< supplierOrConsumerInformationMatch >-----#
    supplierOrConsumerInformationMatch = CLASS(name='supplierOrConsumerInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierOrConsumerInformationMatch_val_AssertionType = SET(name='AssertionType', mode=MODE_TYPE)
    __supplierOrConsumerInformationMatch_val_AssertionType_ae_title = CHOICE(name='ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier = INT(name='agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _supplierOrConsumerInformationMatch_val_AssertionType._cont = ASN1Dict([
        ('ae-title', __supplierOrConsumerInformationMatch_val_AssertionType_ae_title),
        ('agreement-identifier', __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier),
        ])
    _supplierOrConsumerInformationMatch_val_AssertionType._ext = None
    supplierOrConsumerInformationMatch._val = dict([('AssertionType', _supplierOrConsumerInformationMatch_val_AssertionType), ('id', (2, 5, 14, 2))])
    
    #-----< supplierAndConsumersMatch >-----#
    supplierAndConsumersMatch = CLASS(name='supplierAndConsumersMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierAndConsumersMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    supplierAndConsumersMatch._val = dict([('AssertionType', _supplierAndConsumersMatch_val_AssertionType), ('id', (2, 5, 14, 3))])
    
    #-----< id-doa-dseType >-----#
    id_doa_dseType = OID(name='id-doa-dseType', mode=MODE_VALUE)
    id_doa_dseType._val = (2, 5, 12, 0)
    
    #-----< id-doa-myAccessPoint >-----#
    id_doa_myAccessPoint = OID(name='id-doa-myAccessPoint', mode=MODE_VALUE)
    id_doa_myAccessPoint._val = (2, 5, 12, 1)
    
    #-----< id-doa-superiorKnowledge >-----#
    id_doa_superiorKnowledge = OID(name='id-doa-superiorKnowledge', mode=MODE_VALUE)
    id_doa_superiorKnowledge._val = (2, 5, 12, 2)
    
    #-----< id-doa-specificKnowledge >-----#
    id_doa_specificKnowledge = OID(name='id-doa-specificKnowledge', mode=MODE_VALUE)
    id_doa_specificKnowledge._val = (2, 5, 12, 3)
    
    #-----< id-doa-nonSpecificKnowledge >-----#
    id_doa_nonSpecificKnowledge = OID(name='id-doa-nonSpecificKnowledge', mode=MODE_VALUE)
    id_doa_nonSpecificKnowledge._val = (2, 5, 12, 4)
    
    #-----< id-doa-supplierKnowledge >-----#
    id_doa_supplierKnowledge = OID(name='id-doa-supplierKnowledge', mode=MODE_VALUE)
    id_doa_supplierKnowledge._val = (2, 5, 12, 5)
    
    #-----< id-doa-consumerKnowledge >-----#
    id_doa_consumerKnowledge = OID(name='id-doa-consumerKnowledge', mode=MODE_VALUE)
    id_doa_consumerKnowledge._val = (2, 5, 12, 6)
    
    #-----< id-doa-secondaryShadows >-----#
    id_doa_secondaryShadows = OID(name='id-doa-secondaryShadows', mode=MODE_VALUE)
    id_doa_secondaryShadows._val = (2, 5, 12, 7)
    
    #-----< id-doa-ditBridgeKnowledge >-----#
    id_doa_ditBridgeKnowledge = OID(name='id-doa-ditBridgeKnowledge', mode=MODE_VALUE)
    id_doa_ditBridgeKnowledge._val = (2, 5, 12, 8)
    
    #-----< id-kmr-accessPointMatch >-----#
    id_kmr_accessPointMatch = OID(name='id-kmr-accessPointMatch', mode=MODE_VALUE)
    id_kmr_accessPointMatch._val = (2, 5, 14, 0)
    
    #-----< id-kmr-masterShadowMatch >-----#
    id_kmr_masterShadowMatch = OID(name='id-kmr-masterShadowMatch', mode=MODE_VALUE)
    id_kmr_masterShadowMatch._val = (2, 5, 14, 1)
    
    #-----< id-kmr-supplierConsumerMatch >-----#
    id_kmr_supplierConsumerMatch = OID(name='id-kmr-supplierConsumerMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumerMatch._val = (2, 5, 14, 2)
    
    #-----< id-kmr-supplierConsumersMatch >-----#
    id_kmr_supplierConsumersMatch = OID(name='id-kmr-supplierConsumersMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumersMatch._val = (2, 5, 14, 3)
    
    _all_ = [
        dseType,
        _dseType_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        DSEType,
        myAccessPoint,
        _myAccessPoint_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        superiorKnowledge,
        _superiorKnowledge_val_Type,
        specificKnowledge,
        _specificKnowledge_val_Type,
        _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1__item_,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_1,
        nonSpecificKnowledge,
        _nonSpecificKnowledge_val_Type,
        _SupplierOrConsumer_ae_title,
        _SupplierOrConsumer_address,
        __SupplierOrConsumer_protocolInformation__item_,
        _SupplierOrConsumer_protocolInformation,
        _SupplierOrConsumer_agreementID,
        SupplierOrConsumer,
        _SupplierInformation_ae_title,
        _SupplierInformation_address,
        __SupplierInformation_protocolInformation__item_,
        _SupplierInformation_protocolInformation,
        _SupplierInformation_agreementID,
        _SupplierInformation_supplier_is_master,
        _SupplierInformation_non_supplying_master,
        SupplierInformation,
        supplierKnowledge,
        _supplierKnowledge_val_Type,
        _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title,
        _______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_2,
        ConsumerInformation,
        consumerKnowledge,
        _consumerKnowledge_val_Type,
        _SupplierAndConsumers_ae_title,
        _SupplierAndConsumers_address,
        __SupplierAndConsumers_protocolInformation__item_,
        _SupplierAndConsumers_protocolInformation,
        __SupplierAndConsumers_consumers__item_,
        _SupplierAndConsumers_consumers,
        SupplierAndConsumers,
        secondaryShadows,
        _secondaryShadows_val_Type,
        ditBridgeKnowledge,
        _ditBridgeKnowledge_val_Type,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_3,
        accessPointMatch,
        _accessPointMatch_val_AssertionType,
        masterAndShadowAccessPointsMatch,
        __masterAndShadowAccessPointsMatch_val_AssertionType__item_,
        _masterAndShadowAccessPointsMatch_val_AssertionType,
        supplierOrConsumerInformationMatch,
        __supplierOrConsumerInformationMatch_val_AssertionType_ae_title,
        __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier,
        _supplierOrConsumerInformationMatch_val_AssertionType,
        supplierAndConsumersMatch,
        _supplierAndConsumersMatch_val_AssertionType,
        id_doa_dseType,
        id_doa_myAccessPoint,
        id_doa_superiorKnowledge,
        id_doa_specificKnowledge,
        id_doa_nonSpecificKnowledge,
        id_doa_supplierKnowledge,
        id_doa_consumerKnowledge,
        id_doa_secondaryShadows,
        id_doa_ditBridgeKnowledge,
        id_kmr_accessPointMatch,
        id_kmr_masterShadowMatch,
        id_kmr_supplierConsumerMatch,
        id_kmr_supplierConsumersMatch,
    ]

class EnhancedSecurity:

    _name_  = 'EnhancedSecurity'
    _oid_   = [2, 5, 1, 28, 7]
    
    _obj_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        'attributeValueSecurityLabelContext',
        'SignedSecurityLabel',
        'SignedSecurityLabelContent',
        'SecurityLabel',
        'SecurityPolicyIdentifier',
        'SecurityClassification',
        'PrivacyMark',
        'SecurityCategories',
        'clearance',
        'Clearance',
        'ClassList',
        'SecurityCategory',
        'SECURITY-CATEGORY',
        'SecurityCategoriesTable',
        'attributeIntegrityInfo',
        'AttributeIntegrityInfo',
        'AttributeIntegrityInfoContent',
        'Signer',
        'ThisEntry',
        'IssuerAndSerialNumber',
        'SpecificallyIdentified',
        'Scope',
        'SelectedTypes',
        'AttribsHash',
        'HashedAttributes',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        'AttributeValueIntegrityInfo',
        'AttributeValueIntegrityInfoContent',
        'AVIHash',
        'AttributeTypeValueContexts',
        'id-oc-integrityInfo',
        'id-at-clearance',
        'id-at-attributeIntegrityInfo',
        'id-avc-attributeValueSecurityLabelContext',
        'id-avc-attributeValueIntegrityInfoContext',
        ]
    _type_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        'SignedSecurityLabel',
        'SignedSecurityLabelContent',
        'SecurityLabel',
        'SecurityPolicyIdentifier',
        'SecurityClassification',
        'PrivacyMark',
        'SecurityCategories',
        'Clearance',
        'ClassList',
        'SecurityCategory',
        'SECURITY-CATEGORY',
        'AttributeIntegrityInfo',
        'AttributeIntegrityInfoContent',
        'Signer',
        'ThisEntry',
        'IssuerAndSerialNumber',
        'SpecificallyIdentified',
        'Scope',
        'SelectedTypes',
        'AttribsHash',
        'HashedAttributes',
        'AttributeValueIntegrityInfo',
        'AttributeValueIntegrityInfoContent',
        'AVIHash',
        'AttributeTypeValueContexts',
        ]
    _set_ = [
        'SecurityCategoriesTable',
        ]
    _val_ = [
        'attributeValueSecurityLabelContext',
        'clearance',
        'attributeIntegrityInfo',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        'id-oc-integrityInfo',
        'id-at-clearance',
        'id-at-attributeIntegrityInfo',
        'id-avc-attributeValueSecurityLabelContext',
        'id-avc-attributeValueIntegrityInfoContext',
        ]
    _class_ = [
        'attributeValueSecurityLabelContext',
        'clearance',
        'SECURITY-CATEGORY',
        'SecurityCategoriesTable',
        'attributeIntegrityInfo',
        'integrityInfo',
        'attributeValueIntegrityInfoContext',
        ]
    _param_ = [
        'OPTIONALLY-PROTECTED',
        'OPTIONALLY-PROTECTED-SEQ',
        ]
    
    #-----< OPTIONALLY-PROTECTED >-----#
    OPTIONALLY_PROTECTED = CHOICE(name='OPTIONALLY-PROTECTED', mode=MODE_TYPE, param=True)
    
    #-----< OPTIONALLY-PROTECTED-SEQ >-----#
    OPTIONALLY_PROTECTED_SEQ = CHOICE(name='OPTIONALLY-PROTECTED-SEQ', mode=MODE_TYPE, param=True)
    
    #-----< attributeValueSecurityLabelContext >-----#
    attributeValueSecurityLabelContext = CLASS(name='attributeValueSecurityLabelContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueSecurityLabelContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabel')))
    attributeValueSecurityLabelContext._val = dict([('Type', _attributeValueSecurityLabelContext_val_Type), ('id', (2, 5, 31, 3))])
    
    #-----< SignedSecurityLabel >-----#
    SignedSecurityLabel = SEQ(name='SignedSecurityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _SignedSecurityLabel_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabelContent')))
    _SignedSecurityLabel_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SignedSecurityLabel_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab = ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_at = None
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __SignedSecurityLabel_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab = ___SignedSecurityLabel_algorithmIdentifier_parameters_tab
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _SignedSecurityLabel_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __SignedSecurityLabel_algorithmIdentifier_algorithm),
        ('parameters', __SignedSecurityLabel_algorithmIdentifier_parameters),
        ])
    _SignedSecurityLabel_algorithmIdentifier._ext = []
    _SignedSecurityLabel_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    SignedSecurityLabel._cont = ASN1Dict([
        ('toBeSigned', _SignedSecurityLabel_toBeSigned),
        ('algorithmIdentifier', _SignedSecurityLabel_algorithmIdentifier),
        ('encrypted', _SignedSecurityLabel_encrypted),
        ])
    SignedSecurityLabel._ext = []
    
    #-----< SignedSecurityLabelContent >-----#
    SignedSecurityLabelContent = SEQ(name='SignedSecurityLabelContent', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash = SEQ(name='attHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    __SignedSecurityLabelContent_attHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_at = None
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm),
        ('parameters', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters),
        ])
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._ext = []
    __SignedSecurityLabelContent_attHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash._cont = ASN1Dict([
        ('algorithmIdentifier', __SignedSecurityLabelContent_attHash_algorithmIdentifier),
        ('hashValue', __SignedSecurityLabelContent_attHash_hashValue),
        ])
    _SignedSecurityLabelContent_attHash._ext = []
    _SignedSecurityLabelContent_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _SignedSecurityLabelContent_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _SignedSecurityLabelContent_securityLabel = SET(name='securityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityLabel')))
    SignedSecurityLabelContent._cont = ASN1Dict([
        ('attHash', _SignedSecurityLabelContent_attHash),
        ('issuer', _SignedSecurityLabelContent_issuer),
        ('keyIdentifier', _SignedSecurityLabelContent_keyIdentifier),
        ('securityLabel', _SignedSecurityLabelContent_securityLabel),
        ])
    SignedSecurityLabelContent._ext = []
    
    #-----< SecurityLabel >-----#
    SecurityLabel = SET(name='SecurityLabel', mode=MODE_TYPE)
    _SecurityLabel_security_policy_identifier = OID(name='security-policy-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityPolicyIdentifier')), opt=True)
    _SecurityLabel_security_classification = INT(name='security-classification', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityClassification')), opt=True)
    _SecurityLabel_privacy_mark = STR_PRINT(name='privacy-mark', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'PrivacyMark')), opt=True)
    _SecurityLabel_security_categories = SET_OF(name='security-categories', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategories')), opt=True)
    SecurityLabel._cont = ASN1Dict([
        ('security-policy-identifier', _SecurityLabel_security_policy_identifier),
        ('security-classification', _SecurityLabel_security_classification),
        ('privacy-mark', _SecurityLabel_privacy_mark),
        ('security-categories', _SecurityLabel_security_categories),
        ])
    SecurityLabel._ext = []
    
    #-----< SecurityPolicyIdentifier >-----#
    SecurityPolicyIdentifier = OID(name='SecurityPolicyIdentifier', mode=MODE_TYPE)
    
    #-----< SecurityClassification >-----#
    SecurityClassification = INT(name='SecurityClassification', mode=MODE_TYPE)
    SecurityClassification._cont = ASN1Dict([('unmarked', 0), ('unclassified', 1), ('restricted', 2), ('confidential', 3), ('secret', 4), ('top-secret', 5)])
    
    #-----< PrivacyMark >-----#
    PrivacyMark = STR_PRINT(name='PrivacyMark', mode=MODE_TYPE)
    PrivacyMark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SecurityCategories >-----#
    SecurityCategories = SET_OF(name='SecurityCategories', mode=MODE_TYPE)
    _SecurityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    SecurityCategories._cont = _SecurityCategories__item_
    SecurityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< clearance >-----#
    clearance = CLASS(name='clearance', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _clearance_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Clearance')))
    clearance._val = dict([('Type', _clearance_val_Type), ('id', (2, 5, 4, 55))])
    
    #-----< Clearance >-----#
    Clearance = SEQ(name='Clearance', mode=MODE_TYPE)
    _Clearance_policyId = OID(name='policyId', mode=MODE_TYPE)
    _Clearance_classList = BIT_STR(name='classList', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'ClassList')), default=(1, 2))
    _Clearance_securityCategories = SET_OF(name='securityCategories', mode=MODE_TYPE, opt=True)
    __Clearance_securityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    _Clearance_securityCategories._cont = __Clearance_securityCategories__item_
    _Clearance_securityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    Clearance._cont = ASN1Dict([
        ('policyId', _Clearance_policyId),
        ('classList', _Clearance_classList),
        ('securityCategories', _Clearance_securityCategories),
        ])
    Clearance._ext = []
    
    #-----< ClassList >-----#
    ClassList = BIT_STR(name='ClassList', mode=MODE_TYPE)
    ClassList._cont = ASN1Dict([('unmarked', 0), ('unclassified', 1), ('restricted', 2), ('confidential', 3), ('secret', 4), ('topSecret', 5)])
    
    #-----< SecurityCategory >-----#
    SecurityCategory = SEQ(name='SecurityCategory', mode=MODE_TYPE)
    _SecurityCategory_type = OID(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), ['id']))
    __SecurityCategory_type_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_type._const_tab = __SecurityCategory_type_tab
    _SecurityCategory_type._const_tab_at = None
    _SecurityCategory_type._const_tab_id = 'id'
    _SecurityCategory_value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), ['Type']))
    __SecurityCategory_value_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_value._const_tab = __SecurityCategory_value_tab
    _SecurityCategory_value._const_tab_at = ('..', 'type')
    _SecurityCategory_value._const_tab_id = 'Type'
    SecurityCategory._cont = ASN1Dict([
        ('type', _SecurityCategory_type),
        ('value', _SecurityCategory_value),
        ])
    SecurityCategory._ext = []
    
    #-----< SECURITY-CATEGORY >-----#
    SECURITY_CATEGORY = CLASS(name='SECURITY-CATEGORY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< SecurityCategoriesTable >-----#
    SecurityCategoriesTable = CLASS(name='SecurityCategoriesTable', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    SecurityCategoriesTable._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< attributeIntegrityInfo >-----#
    attributeIntegrityInfo = CLASS(name='attributeIntegrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeIntegrityInfo_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    attributeIntegrityInfo._val = dict([('Type', _attributeIntegrityInfo_val_Type), ('single-valued', True), ('id', (2, 5, 4, 57))])
    
    #-----< AttributeIntegrityInfo >-----#
    AttributeIntegrityInfo = SEQ(name='AttributeIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeIntegrityInfo_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfoContent')))
    _AttributeIntegrityInfo_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeIntegrityInfo_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeIntegrityInfo_algorithmIdentifier_algorithm),
        ('parameters', __AttributeIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeIntegrityInfo_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    AttributeIntegrityInfo._cont = ASN1Dict([
        ('toBeSigned', _AttributeIntegrityInfo_toBeSigned),
        ('algorithmIdentifier', _AttributeIntegrityInfo_algorithmIdentifier),
        ('encrypted', _AttributeIntegrityInfo_encrypted),
        ])
    AttributeIntegrityInfo._ext = []
    
    #-----< AttributeIntegrityInfoContent >-----#
    AttributeIntegrityInfoContent = SEQ(name='AttributeIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeIntegrityInfoContent_scope = CHOICE(name='scope', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Scope')))
    _AttributeIntegrityInfoContent_signer = CHOICE(name='signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeIntegrityInfoContent_attribsHash = SEQ(name='attribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttribsHash')))
    AttributeIntegrityInfoContent._cont = ASN1Dict([
        ('scope', _AttributeIntegrityInfoContent_scope),
        ('signer', _AttributeIntegrityInfoContent_signer),
        ('attribsHash', _AttributeIntegrityInfoContent_attribsHash),
        ])
    AttributeIntegrityInfoContent._ext = []
    
    #-----< Signer >-----#
    Signer = CHOICE(name='Signer', mode=MODE_TYPE)
    _Signer_thisEntry = CHOICE(name='thisEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'ThisEntry')))
    _Signer_thirdParty = SEQ(name='thirdParty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SpecificallyIdentified')))
    Signer._cont = ASN1Dict([
        ('thisEntry', _Signer_thisEntry),
        ('thirdParty', _Signer_thirdParty),
        ])
    Signer._ext = []
    
    #-----< ThisEntry >-----#
    ThisEntry = CHOICE(name='ThisEntry', mode=MODE_TYPE)
    _ThisEntry_onlyOne = NULL(name='onlyOne', mode=MODE_TYPE)
    _ThisEntry_specific = SEQ(name='specific', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'IssuerAndSerialNumber')))
    ThisEntry._cont = ASN1Dict([
        ('onlyOne', _ThisEntry_onlyOne),
        ('specific', _ThisEntry_specific),
        ])
    ThisEntry._ext = []
    
    #-----< IssuerAndSerialNumber >-----#
    IssuerAndSerialNumber = SEQ(name='IssuerAndSerialNumber', mode=MODE_TYPE)
    _IssuerAndSerialNumber_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _IssuerAndSerialNumber_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    IssuerAndSerialNumber._cont = ASN1Dict([
        ('issuer', _IssuerAndSerialNumber_issuer),
        ('serial', _IssuerAndSerialNumber_serial),
        ])
    IssuerAndSerialNumber._ext = []
    
    #-----< SpecificallyIdentified >-----#
    SpecificallyIdentified = SEQ(name='SpecificallyIdentified', mode=MODE_TYPE)
    _SpecificallyIdentified_name = CHOICE(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _SpecificallyIdentified_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _SpecificallyIdentified_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    SpecificallyIdentified._cont = ASN1Dict([
        ('name', _SpecificallyIdentified_name),
        ('issuer', _SpecificallyIdentified_issuer),
        ('serial', _SpecificallyIdentified_serial),
        ])
    SpecificallyIdentified._ext = None
    
    #-----< Scope >-----#
    Scope = CHOICE(name='Scope', mode=MODE_TYPE)
    _Scope_wholeEntry = NULL(name='wholeEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Scope_selectedTypes = SEQ_OF(name='selectedTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SelectedTypes')))
    Scope._cont = ASN1Dict([
        ('wholeEntry', _Scope_wholeEntry),
        ('selectedTypes', _Scope_selectedTypes),
        ])
    Scope._ext = []
    
    #-----< SelectedTypes >-----#
    SelectedTypes = SEQ_OF(name='SelectedTypes', mode=MODE_TYPE)
    _SelectedTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    SelectedTypes._cont = _SelectedTypes__item_
    SelectedTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttribsHash >-----#
    AttribsHash = SEQ(name='AttribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AttribsHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttribsHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttribsHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_algorithm._const_tab = ___AttribsHash_algorithmIdentifier_algorithm_tab
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttribsHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttribsHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_parameters._const_tab = ___AttribsHash_algorithmIdentifier_parameters_tab
    __AttribsHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttribsHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttribsHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttribsHash_algorithmIdentifier_algorithm),
        ('parameters', __AttribsHash_algorithmIdentifier_parameters),
        ])
    _AttribsHash_algorithmIdentifier._ext = []
    _AttribsHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    AttribsHash._cont = ASN1Dict([
        ('algorithmIdentifier', _AttribsHash_algorithmIdentifier),
        ('hashValue', _AttribsHash_hashValue),
        ])
    AttribsHash._ext = []
    
    #-----< HashedAttributes >-----#
    HashedAttributes = SEQ_OF(name='HashedAttributes', mode=MODE_TYPE)
    _HashedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __HashedAttributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___HashedAttributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____HashedAttributes__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ____HashedAttributes__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___HashedAttributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____HashedAttributes__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ____HashedAttributes__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __HashedAttributes__item__type._const_tab = ___HashedAttributes__item__type_tab
    __HashedAttributes__item__type._const_tab_at = None
    __HashedAttributes__item__type._const_tab_id = 'id'
    __HashedAttributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___HashedAttributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___HashedAttributes__item__values__item_._const_tab = ___HashedAttributes__item__type_tab
    ___HashedAttributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___HashedAttributes__item__values__item_._const_tab_id = 'Type'
    __HashedAttributes__item__values._cont = ___HashedAttributes__item__values__item_
    __HashedAttributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __HashedAttributes__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ___HashedAttributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____HashedAttributes__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab = ___HashedAttributes__item__type_tab
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_id = 'Type'
    ____HashedAttributes__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    _____HashedAttributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____HashedAttributes__item__valuesWithContext__item__contextList._cont = _____HashedAttributes__item__valuesWithContext__item__contextList__item_
    ____HashedAttributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___HashedAttributes__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', ____HashedAttributes__item__valuesWithContext__item__value),
        ('contextList', ____HashedAttributes__item__valuesWithContext__item__contextList),
        ])
    ___HashedAttributes__item__valuesWithContext__item_._ext = []
    __HashedAttributes__item__valuesWithContext._cont = ___HashedAttributes__item__valuesWithContext__item_
    __HashedAttributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _HashedAttributes__item_._cont = ASN1Dict([
        ('type', __HashedAttributes__item__type),
        ('values', __HashedAttributes__item__values),
        ('valuesWithContext', __HashedAttributes__item__valuesWithContext),
        ])
    _HashedAttributes__item_._ext = []
    HashedAttributes._cont = _HashedAttributes__item_
    HashedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< integrityInfo >-----#
    integrityInfo = CLASS(name='integrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    integrityInfo._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), ('single-valued', True), ('id', (2, 5, 4, 57))])], rr=[], ev=None, er=[])), ('id', (2, 5, 6, 40))])
    
    #-----< attributeValueIntegrityInfoContext >-----#
    attributeValueIntegrityInfoContext = CLASS(name='attributeValueIntegrityInfoContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueIntegrityInfoContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfo')))
    attributeValueIntegrityInfoContext._val = dict([('Type', _attributeValueIntegrityInfoContext_val_Type), ('id', (2, 5, 31, 4))])
    
    #-----< AttributeValueIntegrityInfo >-----#
    AttributeValueIntegrityInfo = SEQ(name='AttributeValueIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeValueIntegrityInfo_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfoContent')))
    _AttributeValueIntegrityInfo_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AttributeValueIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm),
        ('parameters', __AttributeValueIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeValueIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeValueIntegrityInfo_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    AttributeValueIntegrityInfo._cont = ASN1Dict([
        ('toBeSigned', _AttributeValueIntegrityInfo_toBeSigned),
        ('algorithmIdentifier', _AttributeValueIntegrityInfo_algorithmIdentifier),
        ('encrypted', _AttributeValueIntegrityInfo_encrypted),
        ])
    AttributeValueIntegrityInfo._ext = []
    
    #-----< AttributeValueIntegrityInfoContent >-----#
    AttributeValueIntegrityInfoContent = SEQ(name='AttributeValueIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeValueIntegrityInfoContent_signer = CHOICE(name='signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeValueIntegrityInfoContent_aVIHash = SEQ(name='aVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AVIHash')))
    AttributeValueIntegrityInfoContent._cont = ASN1Dict([
        ('signer', _AttributeValueIntegrityInfoContent_signer),
        ('aVIHash', _AttributeValueIntegrityInfoContent_aVIHash),
        ])
    AttributeValueIntegrityInfoContent._ext = []
    
    #-----< AVIHash >-----#
    AVIHash = SEQ(name='AVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AVIHash_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AVIHash_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___AVIHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_algorithm._const_tab = ___AVIHash_algorithmIdentifier_algorithm_tab
    __AVIHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AVIHash_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AVIHash_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___AVIHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_parameters._const_tab = ___AVIHash_algorithmIdentifier_parameters_tab
    __AVIHash_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __AVIHash_algorithmIdentifier_parameters._const_tab_id = 'Type'
    _AVIHash_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AVIHash_algorithmIdentifier_algorithm),
        ('parameters', __AVIHash_algorithmIdentifier_parameters),
        ])
    _AVIHash_algorithmIdentifier._ext = []
    _AVIHash_hashValue = BIT_STR(name='hashValue', mode=MODE_TYPE)
    AVIHash._cont = ASN1Dict([
        ('algorithmIdentifier', _AVIHash_algorithmIdentifier),
        ('hashValue', _AVIHash_hashValue),
        ])
    AVIHash._ext = []
    
    #-----< AttributeTypeValueContexts >-----#
    AttributeTypeValueContexts = SEQ(name='AttributeTypeValueContexts', mode=MODE_TYPE)
    _AttributeTypeValueContexts_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeValueContexts_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeValueContexts_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeValueContexts_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeValueContexts_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeValueContexts_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeValueContexts_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeValueContexts_type._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_type._const_tab_at = None
    _AttributeTypeValueContexts_type._const_tab_id = 'id'
    _AttributeTypeValueContexts_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _AttributeTypeValueContexts_value._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_value._const_tab_at = ('..', 'type')
    _AttributeTypeValueContexts_value._const_tab_id = 'Type'
    _AttributeTypeValueContexts_contextList = SET_OF(name='contextList', mode=MODE_TYPE, opt=True)
    __AttributeTypeValueContexts_contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _AttributeTypeValueContexts_contextList._cont = __AttributeTypeValueContexts_contextList__item_
    _AttributeTypeValueContexts_contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeValueContexts._cont = ASN1Dict([
        ('type', _AttributeTypeValueContexts_type),
        ('value', _AttributeTypeValueContexts_value),
        ('contextList', _AttributeTypeValueContexts_contextList),
        ])
    AttributeTypeValueContexts._ext = []
    
    #-----< id-oc-integrityInfo >-----#
    id_oc_integrityInfo = OID(name='id-oc-integrityInfo', mode=MODE_VALUE)
    id_oc_integrityInfo._val = (2, 5, 6, 40)
    
    #-----< id-at-clearance >-----#
    id_at_clearance = OID(name='id-at-clearance', mode=MODE_VALUE)
    id_at_clearance._val = (2, 5, 4, 55)
    
    #-----< id-at-attributeIntegrityInfo >-----#
    id_at_attributeIntegrityInfo = OID(name='id-at-attributeIntegrityInfo', mode=MODE_VALUE)
    id_at_attributeIntegrityInfo._val = (2, 5, 4, 57)
    
    #-----< id-avc-attributeValueSecurityLabelContext >-----#
    id_avc_attributeValueSecurityLabelContext = OID(name='id-avc-attributeValueSecurityLabelContext', mode=MODE_VALUE)
    id_avc_attributeValueSecurityLabelContext._val = (2, 5, 31, 3)
    
    #-----< id-avc-attributeValueIntegrityInfoContext >-----#
    id_avc_attributeValueIntegrityInfoContext = OID(name='id-avc-attributeValueIntegrityInfoContext', mode=MODE_VALUE)
    id_avc_attributeValueIntegrityInfoContext._val = (2, 5, 31, 4)
    
    _all_ = [
        attributeValueSecurityLabelContext,
        _attributeValueSecurityLabelContext_val_Type,
        _SignedSecurityLabel_toBeSigned,
        ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab,
        __SignedSecurityLabel_algorithmIdentifier_algorithm,
        ___SignedSecurityLabel_algorithmIdentifier_parameters_tab,
        __SignedSecurityLabel_algorithmIdentifier_parameters,
        _SignedSecurityLabel_algorithmIdentifier,
        _SignedSecurityLabel_encrypted,
        SignedSecurityLabel,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters,
        __SignedSecurityLabelContent_attHash_algorithmIdentifier,
        __SignedSecurityLabelContent_attHash_hashValue,
        _SignedSecurityLabelContent_attHash,
        _SignedSecurityLabelContent_issuer,
        _SignedSecurityLabelContent_keyIdentifier,
        _SignedSecurityLabelContent_securityLabel,
        SignedSecurityLabelContent,
        _SecurityLabel_security_policy_identifier,
        _SecurityLabel_security_classification,
        _SecurityLabel_privacy_mark,
        _SecurityLabel_security_categories,
        SecurityLabel,
        SecurityPolicyIdentifier,
        SecurityClassification,
        PrivacyMark,
        _SecurityCategories__item_,
        SecurityCategories,
        clearance,
        _clearance_val_Type,
        _Clearance_policyId,
        _Clearance_classList,
        __Clearance_securityCategories__item_,
        _Clearance_securityCategories,
        Clearance,
        ClassList,
        __SecurityCategory_type_tab,
        _SecurityCategory_type,
        __SecurityCategory_value_tab,
        _SecurityCategory_value,
        SecurityCategory,
        SECURITY_CATEGORY,
        SecurityCategoriesTable,
        attributeIntegrityInfo,
        _attributeIntegrityInfo_val_Type,
        _AttributeIntegrityInfo_toBeSigned,
        ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeIntegrityInfo_algorithmIdentifier,
        _AttributeIntegrityInfo_encrypted,
        AttributeIntegrityInfo,
        _AttributeIntegrityInfoContent_scope,
        _AttributeIntegrityInfoContent_signer,
        _AttributeIntegrityInfoContent_attribsHash,
        AttributeIntegrityInfoContent,
        _Signer_thisEntry,
        _Signer_thirdParty,
        Signer,
        _ThisEntry_onlyOne,
        _ThisEntry_specific,
        ThisEntry,
        _IssuerAndSerialNumber_issuer,
        _IssuerAndSerialNumber_serial,
        IssuerAndSerialNumber,
        _SpecificallyIdentified_name,
        _SpecificallyIdentified_issuer,
        _SpecificallyIdentified_serial,
        SpecificallyIdentified,
        _Scope_wholeEntry,
        _Scope_selectedTypes,
        Scope,
        _SelectedTypes__item_,
        SelectedTypes,
        ___AttribsHash_algorithmIdentifier_algorithm_tab,
        __AttribsHash_algorithmIdentifier_algorithm,
        ___AttribsHash_algorithmIdentifier_parameters_tab,
        __AttribsHash_algorithmIdentifier_parameters,
        _AttribsHash_algorithmIdentifier,
        _AttribsHash_hashValue,
        AttribsHash,
        ___HashedAttributes__item__type_tab,
        ____HashedAttributes__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        ____HashedAttributes__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __HashedAttributes__item__type,
        ___HashedAttributes__item__values__item_,
        __HashedAttributes__item__values,
        ____HashedAttributes__item__valuesWithContext__item__value,
        _____HashedAttributes__item__valuesWithContext__item__contextList__item_,
        ____HashedAttributes__item__valuesWithContext__item__contextList,
        ___HashedAttributes__item__valuesWithContext__item_,
        __HashedAttributes__item__valuesWithContext,
        _HashedAttributes__item_,
        HashedAttributes,
        integrityInfo,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        attributeValueIntegrityInfoContext,
        _attributeValueIntegrityInfoContext_val_Type,
        _AttributeValueIntegrityInfo_toBeSigned,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeValueIntegrityInfo_algorithmIdentifier,
        _AttributeValueIntegrityInfo_encrypted,
        AttributeValueIntegrityInfo,
        _AttributeValueIntegrityInfoContent_signer,
        _AttributeValueIntegrityInfoContent_aVIHash,
        AttributeValueIntegrityInfoContent,
        ___AVIHash_algorithmIdentifier_algorithm_tab,
        __AVIHash_algorithmIdentifier_algorithm,
        ___AVIHash_algorithmIdentifier_parameters_tab,
        __AVIHash_algorithmIdentifier_parameters,
        _AVIHash_algorithmIdentifier,
        _AVIHash_hashValue,
        AVIHash,
        __AttributeTypeValueContexts_type_tab,
        ___AttributeTypeValueContexts_type_tab_val_Type_0,
        ___AttributeTypeValueContexts_type_tab_val_Type_1,
        _AttributeTypeValueContexts_type,
        _AttributeTypeValueContexts_value,
        __AttributeTypeValueContexts_contextList__item_,
        _AttributeTypeValueContexts_contextList,
        AttributeTypeValueContexts,
        id_oc_integrityInfo,
        id_at_clearance,
        id_at_attributeIntegrityInfo,
        id_avc_attributeValueSecurityLabelContext,
        id_avc_attributeValueIntegrityInfoContext,
    ]

class HierarchicalOperationalBindings:

    _name_  = 'HierarchicalOperationalBindings'
    _oid_   = [2, 5, 1, 20, 7]
    
    _obj_ = [
        'HierarchicalAgreement',
        'SuperiorToSubordinate',
        'DITcontext',
        'Vertex',
        'SubentryInfo',
        'SubordinateToSuperior',
        'SuperiorToSubordinateModification',
        'NonSpecificHierarchicalAgreement',
        'NHOBSuperiorToSubordinate',
        'NHOBSubordinateToSuperior',
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _type_ = [
        'HierarchicalAgreement',
        'SuperiorToSubordinate',
        'DITcontext',
        'Vertex',
        'SubentryInfo',
        'SubordinateToSuperior',
        'SuperiorToSubordinateModification',
        'NonSpecificHierarchicalAgreement',
        'NHOBSuperiorToSubordinate',
        'NHOBSubordinateToSuperior',
        ]
    _set_ = [
        ]
    _val_ = [
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _class_ = [
        'hierarchicalOperationalBinding',
        'nonSpecificHierarchicalOperationalBinding',
        ]
    _param_ = [
        ]
    
    #-----< HierarchicalAgreement >-----#
    HierarchicalAgreement = SEQ(name='HierarchicalAgreement', mode=MODE_TYPE)
    _HierarchicalAgreement_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _HierarchicalAgreement_immediateSuperior = SEQ_OF(name='immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    HierarchicalAgreement._cont = ASN1Dict([
        ('rdn', _HierarchicalAgreement_rdn),
        ('immediateSuperior', _HierarchicalAgreement_immediateSuperior),
        ])
    HierarchicalAgreement._ext = []
    
    #-----< SuperiorToSubordinate >-----#
    SuperiorToSubordinate = SEQ(name='SuperiorToSubordinate', mode=MODE_TYPE)
    _SuperiorToSubordinate_contextPrefixInfo = SEQ_OF(name='contextPrefixInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HierarchicalOperationalBindings', 'DITcontext')))
    _SuperiorToSubordinate_entryInfo = SET_OF(name='entryInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_entryInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SuperiorToSubordinate_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SuperiorToSubordinate_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_id = 'id'
    ___SuperiorToSubordinate_entryInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_id = 'Type'
    ___SuperiorToSubordinate_entryInfo__item__values._cont = ____SuperiorToSubordinate_entryInfo__item__values__item_
    ___SuperiorToSubordinate_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value),
        ('contextList', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_entryInfo__item_._cont = ASN1Dict([
        ('type', ___SuperiorToSubordinate_entryInfo__item__type),
        ('values', ___SuperiorToSubordinate_entryInfo__item__values),
        ('valuesWithContext', ___SuperiorToSubordinate_entryInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_entryInfo__item_._ext = []
    _SuperiorToSubordinate_entryInfo._cont = __SuperiorToSubordinate_entryInfo__item_
    _SuperiorToSubordinate_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SuperiorToSubordinate_immediateSuperiorInfo = SET_OF(name='immediateSuperiorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_immediateSuperiorInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_id = 'id'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_id = 'Type'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value),
        ('contextList', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._cont = ASN1Dict([
        ('type', ___SuperiorToSubordinate_immediateSuperiorInfo__item__type),
        ('values', ___SuperiorToSubordinate_immediateSuperiorInfo__item__values),
        ('valuesWithContext', ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._ext = []
    _SuperiorToSubordinate_immediateSuperiorInfo._cont = __SuperiorToSubordinate_immediateSuperiorInfo__item_
    _SuperiorToSubordinate_immediateSuperiorInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SuperiorToSubordinate._cont = ASN1Dict([
        ('contextPrefixInfo', _SuperiorToSubordinate_contextPrefixInfo),
        ('entryInfo', _SuperiorToSubordinate_entryInfo),
        ('immediateSuperiorInfo', _SuperiorToSubordinate_immediateSuperiorInfo),
        ])
    SuperiorToSubordinate._ext = []
    
    #-----< DITcontext >-----#
    DITcontext = SEQ_OF(name='DITcontext', mode=MODE_TYPE)
    _DITcontext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'Vertex')))
    DITcontext._cont = _DITcontext__item_
    
    #-----< Vertex >-----#
    Vertex = SEQ(name='Vertex', mode=MODE_TYPE)
    _Vertex_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Vertex_admPointInfo = SET_OF(name='admPointInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_admPointInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___Vertex_admPointInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____Vertex_admPointInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____Vertex_admPointInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____Vertex_admPointInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____Vertex_admPointInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____Vertex_admPointInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___Vertex_admPointInfo__item__type._const_tab = ____Vertex_admPointInfo__item__type_tab
    ___Vertex_admPointInfo__item__type._const_tab_at = None
    ___Vertex_admPointInfo__item__type._const_tab_id = 'id'
    ___Vertex_admPointInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____Vertex_admPointInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____Vertex_admPointInfo__item__values__item_._const_tab = ____Vertex_admPointInfo__item__type_tab
    ____Vertex_admPointInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____Vertex_admPointInfo__item__values__item_._const_tab_id = 'Type'
    ___Vertex_admPointInfo__item__values._cont = ____Vertex_admPointInfo__item__values__item_
    ___Vertex_admPointInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___Vertex_admPointInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____Vertex_admPointInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab = ____Vertex_admPointInfo__item__type_tab
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._cont = ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____Vertex_admPointInfo__item__valuesWithContext__item__value),
        ('contextList', _____Vertex_admPointInfo__item__valuesWithContext__item__contextList),
        ])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._ext = []
    ___Vertex_admPointInfo__item__valuesWithContext._cont = ____Vertex_admPointInfo__item__valuesWithContext__item_
    ___Vertex_admPointInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __Vertex_admPointInfo__item_._cont = ASN1Dict([
        ('type', ___Vertex_admPointInfo__item__type),
        ('values', ___Vertex_admPointInfo__item__values),
        ('valuesWithContext', ___Vertex_admPointInfo__item__valuesWithContext),
        ])
    __Vertex_admPointInfo__item_._ext = []
    _Vertex_admPointInfo._cont = __Vertex_admPointInfo__item_
    _Vertex_admPointInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _Vertex_subentries._cont = __Vertex_subentries__item_
    _Vertex_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    Vertex._cont = ASN1Dict([
        ('rdn', _Vertex_rdn),
        ('admPointInfo', _Vertex_admPointInfo),
        ('subentries', _Vertex_subentries),
        ('accessPoints', _Vertex_accessPoints),
        ])
    Vertex._ext = []
    
    #-----< SubentryInfo >-----#
    SubentryInfo = SEQ(name='SubentryInfo', mode=MODE_TYPE)
    _SubentryInfo_rdn = SET_OF(name='rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubentryInfo_info = SET_OF(name='info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SubentryInfo_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubentryInfo_info__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubentryInfo_info__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubentryInfo_info__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubentryInfo_info__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubentryInfo_info__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SubentryInfo_info__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubentryInfo_info__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubentryInfo_info__item__type._const_tab = ____SubentryInfo_info__item__type_tab
    ___SubentryInfo_info__item__type._const_tab_at = None
    ___SubentryInfo_info__item__type._const_tab_id = 'id'
    ___SubentryInfo_info__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubentryInfo_info__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubentryInfo_info__item__values__item_._const_tab = ____SubentryInfo_info__item__type_tab
    ____SubentryInfo_info__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SubentryInfo_info__item__values__item_._const_tab_id = 'Type'
    ___SubentryInfo_info__item__values._cont = ____SubentryInfo_info__item__values__item_
    ___SubentryInfo_info__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubentryInfo_info__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubentryInfo_info__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubentryInfo_info__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab = ____SubentryInfo_info__item__type_tab
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubentryInfo_info__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._cont = ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubentryInfo_info__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubentryInfo_info__item__valuesWithContext__item__value),
        ('contextList', _____SubentryInfo_info__item__valuesWithContext__item__contextList),
        ])
    ____SubentryInfo_info__item__valuesWithContext__item_._ext = []
    ___SubentryInfo_info__item__valuesWithContext._cont = ____SubentryInfo_info__item__valuesWithContext__item_
    ___SubentryInfo_info__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubentryInfo_info__item_._cont = ASN1Dict([
        ('type', ___SubentryInfo_info__item__type),
        ('values', ___SubentryInfo_info__item__values),
        ('valuesWithContext', ___SubentryInfo_info__item__valuesWithContext),
        ])
    __SubentryInfo_info__item_._ext = []
    _SubentryInfo_info._cont = __SubentryInfo_info__item_
    SubentryInfo._cont = ASN1Dict([
        ('rdn', _SubentryInfo_rdn),
        ('info', _SubentryInfo_info),
        ])
    SubentryInfo._ext = []
    
    #-----< SubordinateToSuperior >-----#
    SubordinateToSuperior = SEQ(name='SubordinateToSuperior', mode=MODE_TYPE)
    _SubordinateToSuperior_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _SubordinateToSuperior_alias = BOOL(name='alias', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SubordinateToSuperior_entryInfo = SET_OF(name='entryInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubordinateToSuperior_entryInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubordinateToSuperior_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubordinateToSuperior_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__type._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_at = None
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_id = 'id'
    ___SubordinateToSuperior_entryInfo__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubordinateToSuperior_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_id = 'Type'
    ___SubordinateToSuperior_entryInfo__item__values._cont = ____SubordinateToSuperior_entryInfo__item__values__item_
    ___SubordinateToSuperior_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._cont = ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value),
        ('contextList', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._ext = []
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._cont = ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubordinateToSuperior_entryInfo__item_._cont = ASN1Dict([
        ('type', ___SubordinateToSuperior_entryInfo__item__type),
        ('values', ___SubordinateToSuperior_entryInfo__item__values),
        ('valuesWithContext', ___SubordinateToSuperior_entryInfo__item__valuesWithContext),
        ])
    __SubordinateToSuperior_entryInfo__item_._ext = []
    _SubordinateToSuperior_entryInfo._cont = __SubordinateToSuperior_entryInfo__item_
    _SubordinateToSuperior_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SubordinateToSuperior_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _SubordinateToSuperior_subentries._cont = __SubordinateToSuperior_subentries__item_
    _SubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubordinateToSuperior._cont = ASN1Dict([
        ('accessPoints', _SubordinateToSuperior_accessPoints),
        ('alias', _SubordinateToSuperior_alias),
        ('entryInfo', _SubordinateToSuperior_entryInfo),
        ('subentries', _SubordinateToSuperior_subentries),
        ])
    SubordinateToSuperior._ext = []
    
    #-----< SuperiorToSubordinateModification >-----#
    SuperiorToSubordinateModification = SEQ(name='SuperiorToSubordinateModification', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NonSpecificHierarchicalAgreement >-----#
    NonSpecificHierarchicalAgreement = SEQ(name='NonSpecificHierarchicalAgreement', mode=MODE_TYPE)
    _NonSpecificHierarchicalAgreement_immediateSuperior = SEQ_OF(name='immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    NonSpecificHierarchicalAgreement._cont = ASN1Dict([
        ('immediateSuperior', _NonSpecificHierarchicalAgreement_immediateSuperior),
        ])
    NonSpecificHierarchicalAgreement._ext = []
    
    #-----< NHOBSuperiorToSubordinate >-----#
    NHOBSuperiorToSubordinate = SEQ(name='NHOBSuperiorToSubordinate', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NHOBSubordinateToSuperior >-----#
    NHOBSubordinateToSuperior = SEQ(name='NHOBSubordinateToSuperior', mode=MODE_TYPE)
    _NHOBSubordinateToSuperior_accessPoints = SET_OF(name='accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _NHOBSubordinateToSuperior_subentries = SET_OF(name='subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NHOBSubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _NHOBSubordinateToSuperior_subentries._cont = __NHOBSubordinateToSuperior_subentries__item_
    _NHOBSubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NHOBSubordinateToSuperior._cont = ASN1Dict([
        ('accessPoints', _NHOBSubordinateToSuperior_accessPoints),
        ('subentries', _NHOBSubordinateToSuperior_subentries),
        ])
    NHOBSubordinateToSuperior._ext = []
    
    #-----< hierarchicalOperationalBinding >-----#
    hierarchicalOperationalBinding = CLASS(name='hierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _hierarchicalOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __shadowOperationalBinding_roleA_val_EstablishParam = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __shadowOperationalBinding_roleB_val_EstablishParam = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    hierarchicalOperationalBinding._val = dict([('Agreement', _hierarchicalOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 2))])
    
    #-----< nonSpecificHierarchicalOperationalBinding >-----#
    nonSpecificHierarchicalOperationalBinding = CLASS(name='nonSpecificHierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _nonSpecificHierarchicalOperationalBinding_val_Agreement = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __shadowOperationalBinding_roleA_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleB_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    nonSpecificHierarchicalOperationalBinding._val = dict([('Agreement', _nonSpecificHierarchicalOperationalBinding_val_Agreement), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 3))])
    
    _all_ = [
        _HierarchicalAgreement_rdn,
        _HierarchicalAgreement_immediateSuperior,
        HierarchicalAgreement,
        _SuperiorToSubordinate_contextPrefixInfo,
        ____SuperiorToSubordinate_entryInfo__item__type_tab,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___SuperiorToSubordinate_entryInfo__item__type,
        ____SuperiorToSubordinate_entryInfo__item__values__item_,
        ___SuperiorToSubordinate_entryInfo__item__values,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_entryInfo__item__valuesWithContext,
        __SuperiorToSubordinate_entryInfo__item_,
        _SuperiorToSubordinate_entryInfo,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__type,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__values,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext,
        __SuperiorToSubordinate_immediateSuperiorInfo__item_,
        _SuperiorToSubordinate_immediateSuperiorInfo,
        SuperiorToSubordinate,
        _DITcontext__item_,
        DITcontext,
        _Vertex_rdn,
        ____Vertex_admPointInfo__item__type_tab,
        _____Vertex_admPointInfo__item__type_tab_val_Type_0,
        _____Vertex_admPointInfo__item__type_tab_val_Type_1,
        ___Vertex_admPointInfo__item__type,
        ____Vertex_admPointInfo__item__values__item_,
        ___Vertex_admPointInfo__item__values,
        _____Vertex_admPointInfo__item__valuesWithContext__item__value,
        ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_,
        _____Vertex_admPointInfo__item__valuesWithContext__item__contextList,
        ____Vertex_admPointInfo__item__valuesWithContext__item_,
        ___Vertex_admPointInfo__item__valuesWithContext,
        __Vertex_admPointInfo__item_,
        _Vertex_admPointInfo,
        __Vertex_subentries__item_,
        _Vertex_subentries,
        _Vertex_accessPoints,
        Vertex,
        _SubentryInfo_rdn,
        ____SubentryInfo_info__item__type_tab,
        _____SubentryInfo_info__item__type_tab_val_Type_0,
        _____SubentryInfo_info__item__type_tab_val_Type_1,
        ___SubentryInfo_info__item__type,
        ____SubentryInfo_info__item__values__item_,
        ___SubentryInfo_info__item__values,
        _____SubentryInfo_info__item__valuesWithContext__item__value,
        ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_,
        _____SubentryInfo_info__item__valuesWithContext__item__contextList,
        ____SubentryInfo_info__item__valuesWithContext__item_,
        ___SubentryInfo_info__item__valuesWithContext,
        __SubentryInfo_info__item_,
        _SubentryInfo_info,
        SubentryInfo,
        _SubordinateToSuperior_accessPoints,
        _SubordinateToSuperior_alias,
        ____SubordinateToSuperior_entryInfo__item__type_tab,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1,
        ___SubordinateToSuperior_entryInfo__item__type,
        ____SubordinateToSuperior_entryInfo__item__values__item_,
        ___SubordinateToSuperior_entryInfo__item__values,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value,
        ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList,
        ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_,
        ___SubordinateToSuperior_entryInfo__item__valuesWithContext,
        __SubordinateToSuperior_entryInfo__item_,
        _SubordinateToSuperior_entryInfo,
        __SubordinateToSuperior_subentries__item_,
        _SubordinateToSuperior_subentries,
        SubordinateToSuperior,
        SuperiorToSubordinateModification,
        _NonSpecificHierarchicalAgreement_immediateSuperior,
        NonSpecificHierarchicalAgreement,
        NHOBSuperiorToSubordinate,
        _NHOBSubordinateToSuperior_accessPoints,
        __NHOBSubordinateToSuperior_subentries__item_,
        _NHOBSubordinateToSuperior_subentries,
        NHOBSubordinateToSuperior,
        hierarchicalOperationalBinding,
        _hierarchicalOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleA_val_ModifyParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        nonSpecificHierarchicalOperationalBinding,
        _nonSpecificHierarchicalOperationalBinding_val_Agreement,
        __shadowOperationalBinding_roleA_val_EstablishParam_0,
        __shadowOperationalBinding_roleA_val_ModifyParam_0,
        __shadowOperationalBinding_roleB_val_EstablishParam_0,
        __shadowOperationalBinding_roleB_val_ModifyParam_0,
    ]

class InformationFramework:

    _name_  = 'InformationFramework'
    _oid_   = [2, 5, 1, 1, 7]
    
    _obj_ = [
        'Attribute',
        'AttributeType',
        'AttributeValue',
        'Context',
        'AttributeValueAssertion',
        'ContextAssertion',
        'AttributeTypeAssertion',
        'SupportedAttributes',
        'SupportedContexts',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'AttributeTypeAndValue',
        'SubtreeSpecification',
        'LocalName',
        'ChopSpecification',
        'BaseDistance',
        'Refinement',
        'OBJECT-CLASS',
        'ObjectClassKind',
        'top',
        'alias',
        'parent',
        'child',
        'ATTRIBUTE',
        'AttributeUsage',
        'objectClass',
        'aliasedEntryName',
        'MATCHING-RULE',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'DITStructureRule',
        'RuleIdentifier',
        'STRUCTURE-RULE',
        'DITContentRule',
        'CONTENT-RULE',
        'CONTEXT',
        'DITContextUse',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'SearchRuleDescription',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'PwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'HierarchyLevel',
        'hierarchyBelow',
        'HierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        'id-oc-top',
        'id-oc-alias',
        'id-oc-parent',
        'id-oc-child',
        'id-at-objectClass',
        'id-at-aliasedEntryName',
        'id-at-pwdAttribute',
        'id-mr-objectIdentifierMatch',
        'id-mr-distinguishedNameMatch',
        'id-oa-excludeAllCollectiveAttributes',
        'id-oa-createTimestamp',
        'id-oa-modifyTimestamp',
        'id-oa-creatorsName',
        'id-oa-modifiersName',
        'id-oa-administrativeRole',
        'id-oa-subtreeSpecification',
        'id-oa-collectiveExclusions',
        'id-oa-subschemaTimestamp',
        'id-oa-hasSubordinates',
        'id-oa-subschemaSubentryList',
        'id-oa-accessControlSubentryList',
        'id-oa-collectiveAttributeSubentryList',
        'id-oa-contextDefaultSubentryList',
        'id-oa-contextAssertionDefault',
        'id-oa-serviceAdminSubentryList',
        'id-oa-searchRules',
        'id-oa-hierarchyLevel',
        'id-oa-hierarchyBelow',
        'id-oa-hierarchyParent',
        'id-oa-hierarchyTop',
        'id-oa-pwdAdminSubentryList',
        'id-oa-allAttributeTypes',
        'id-sc-subentry',
        'id-sc-accessControlSubentry',
        'id-sc-collectiveAttributeSubentry',
        'id-sc-contextAssertionSubentry',
        'id-sc-serviceAdminSubentry',
        'id-sc-pwdAdminSubentry',
        'id-nf-subentryNameForm',
        'id-ar-autonomousArea',
        'id-ar-accessControlSpecificArea',
        'id-ar-accessControlInnerArea',
        'id-ar-subschemaAdminSpecificArea',
        'id-ar-collectiveAttributeSpecificArea',
        'id-ar-collectiveAttributeInnerArea',
        'id-ar-contextDefaultSpecificArea',
        'id-ar-serviceSpecificArea',
        'id-ar-pwdAdminSpecificArea',
        ]
    _type_ = [
        'Attribute',
        'AttributeType',
        'AttributeValue',
        'Context',
        'AttributeValueAssertion',
        'ContextAssertion',
        'AttributeTypeAssertion',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'AttributeTypeAndValue',
        'SubtreeSpecification',
        'LocalName',
        'ChopSpecification',
        'BaseDistance',
        'Refinement',
        'OBJECT-CLASS',
        'ObjectClassKind',
        'ATTRIBUTE',
        'AttributeUsage',
        'MATCHING-RULE',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'DITStructureRule',
        'RuleIdentifier',
        'STRUCTURE-RULE',
        'DITContentRule',
        'CONTENT-RULE',
        'CONTEXT',
        'DITContextUse',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'SearchRuleDescription',
        'PwdHistory',
        'HierarchyLevel',
        'HierarchyBelow',
        ]
    _set_ = [
        'SupportedAttributes',
        'SupportedContexts',
        ]
    _val_ = [
        'top',
        'alias',
        'parent',
        'child',
        'objectClass',
        'aliasedEntryName',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'hierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        'id-oc-top',
        'id-oc-alias',
        'id-oc-parent',
        'id-oc-child',
        'id-at-objectClass',
        'id-at-aliasedEntryName',
        'id-at-pwdAttribute',
        'id-mr-objectIdentifierMatch',
        'id-mr-distinguishedNameMatch',
        'id-oa-excludeAllCollectiveAttributes',
        'id-oa-createTimestamp',
        'id-oa-modifyTimestamp',
        'id-oa-creatorsName',
        'id-oa-modifiersName',
        'id-oa-administrativeRole',
        'id-oa-subtreeSpecification',
        'id-oa-collectiveExclusions',
        'id-oa-subschemaTimestamp',
        'id-oa-hasSubordinates',
        'id-oa-subschemaSubentryList',
        'id-oa-accessControlSubentryList',
        'id-oa-collectiveAttributeSubentryList',
        'id-oa-contextDefaultSubentryList',
        'id-oa-contextAssertionDefault',
        'id-oa-serviceAdminSubentryList',
        'id-oa-searchRules',
        'id-oa-hierarchyLevel',
        'id-oa-hierarchyBelow',
        'id-oa-hierarchyParent',
        'id-oa-hierarchyTop',
        'id-oa-pwdAdminSubentryList',
        'id-oa-allAttributeTypes',
        'id-sc-subentry',
        'id-sc-accessControlSubentry',
        'id-sc-collectiveAttributeSubentry',
        'id-sc-contextAssertionSubentry',
        'id-sc-serviceAdminSubentry',
        'id-sc-pwdAdminSubentry',
        'id-nf-subentryNameForm',
        'id-ar-autonomousArea',
        'id-ar-accessControlSpecificArea',
        'id-ar-accessControlInnerArea',
        'id-ar-subschemaAdminSpecificArea',
        'id-ar-collectiveAttributeSpecificArea',
        'id-ar-collectiveAttributeInnerArea',
        'id-ar-contextDefaultSpecificArea',
        'id-ar-serviceSpecificArea',
        'id-ar-pwdAdminSpecificArea',
        ]
    _class_ = [
        'SupportedAttributes',
        'SupportedContexts',
        'OBJECT-CLASS',
        'top',
        'alias',
        'parent',
        'child',
        'ATTRIBUTE',
        'objectClass',
        'aliasedEntryName',
        'MATCHING-RULE',
        'objectIdentifierMatch',
        'distinguishedNameMatch',
        'MAPPING-BASED-MATCHING',
        'NAME-FORM',
        'STRUCTURE-RULE',
        'CONTENT-RULE',
        'CONTEXT',
        'DIT-CONTEXT-USE-RULE',
        'FRIENDS',
        'SYNTAX-NAME',
        'subentry',
        'subentryNameForm',
        'subtreeSpecification',
        'administrativeRole',
        'createTimestamp',
        'modifyTimestamp',
        'subschemaTimestamp',
        'creatorsName',
        'modifiersName',
        'subschemaSubentryList',
        'accessControlSubentryList',
        'collectiveAttributeSubentryList',
        'contextDefaultSubentryList',
        'serviceAdminSubentryList',
        'pwdAdminSubentryList',
        'hasSubordinates',
        'accessControlSubentry',
        'collectiveAttributeSubentry',
        'collectiveExclusions',
        'contextAssertionSubentry',
        'contextAssertionDefaults',
        'serviceAdminSubentry',
        'searchRules',
        'pwdAdminSubentry',
        'pwdAttribute',
        'pwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        'hierarchyLevel',
        'hierarchyBelow',
        'hierarchyParent',
        'hierarchyTop',
        ]
    _param_ = [
        'Attribute',
        'MAPPING-BASED-MATCHING',
        'pwdHistory',
        'PwdHistory',
        'pwdRecentlyExpired',
        'pwdHistoryMatch',
        ]
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, param=True)
    
    #-----< AttributeType >-----#
    AttributeType = OID(name='AttributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    
    #-----< AttributeValue >-----#
    AttributeValue = OPEN(name='AttributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    
    #-----< Context >-----#
    Context = SEQ(name='Context', mode=MODE_TYPE)
    _Context_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __Context_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __Context_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Context_contextType._const_tab = __Context_contextType_tab
    _Context_contextType._const_tab_at = None
    _Context_contextType._const_tab_id = 'id'
    _Context_contextValues = SET_OF(name='contextValues', mode=MODE_TYPE)
    __Context_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Type']))
    ___Context_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___Context_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Context_contextValues__item_._const_tab = ___Context_contextValues__item__tab
    __Context_contextValues__item_._const_tab_at = ('..', '..', 'contextType')
    __Context_contextValues__item_._const_tab_id = 'Type'
    _Context_contextValues._cont = __Context_contextValues__item_
    _Context_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Context_fallback = BOOL(name='fallback', mode=MODE_TYPE, default=False)
    Context._cont = ASN1Dict([
        ('contextType', _Context_contextType),
        ('contextValues', _Context_contextValues),
        ('fallback', _Context_fallback),
        ])
    Context._ext = []
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeValueAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeValueAssertion_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ___AttributeValueAssertion_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeValueAssertion_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeValueAssertion_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeValueAssertion_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeValueAssertion_type._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_type._const_tab_at = None
    _AttributeValueAssertion_type._const_tab_id = 'id'
    _AttributeValueAssertion_assertion = OPEN(name='assertion', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['equality-match', 'AssertionType']))
    _AttributeValueAssertion_assertion._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_assertion._const_tab_at = ('..', 'type')
    _AttributeValueAssertion_assertion._const_tab_id = 'AssertionType'
    _AttributeValueAssertion_assertedContexts = CHOICE(name='assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeValueAssertion_assertedContexts_allContexts = NULL(name='allContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeValueAssertion_assertedContexts_selectedContexts = SET_OF(name='selectedContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___AttributeValueAssertion_assertedContexts_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __AttributeValueAssertion_assertedContexts_selectedContexts._cont = ___AttributeValueAssertion_assertedContexts_selectedContexts__item_
    __AttributeValueAssertion_assertedContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeValueAssertion_assertedContexts._cont = ASN1Dict([
        ('allContexts', __AttributeValueAssertion_assertedContexts_allContexts),
        ('selectedContexts', __AttributeValueAssertion_assertedContexts_selectedContexts),
        ])
    _AttributeValueAssertion_assertedContexts._ext = None
    AttributeValueAssertion._cont = ASN1Dict([
        ('type', _AttributeValueAssertion_type),
        ('assertion', _AttributeValueAssertion_assertion),
        ('assertedContexts', _AttributeValueAssertion_assertedContexts),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< ContextAssertion >-----#
    ContextAssertion = SEQ(name='ContextAssertion', mode=MODE_TYPE)
    _ContextAssertion_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextAssertion_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextAssertion_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextAssertion_contextType._const_tab = __ContextAssertion_contextType_tab
    _ContextAssertion_contextType._const_tab_at = None
    _ContextAssertion_contextType._const_tab_id = 'id'
    _ContextAssertion_contextValues = SET_OF(name='contextValues', mode=MODE_TYPE)
    __ContextAssertion_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Assertion']))
    ___ContextAssertion_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextAssertion_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextAssertion_contextValues__item_._const_tab = ___ContextAssertion_contextValues__item__tab
    __ContextAssertion_contextValues__item_._const_tab_at = ('..', '..', 'contextType')
    __ContextAssertion_contextValues__item_._const_tab_id = 'Assertion'
    _ContextAssertion_contextValues._cont = __ContextAssertion_contextValues__item_
    _ContextAssertion_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextAssertion._cont = ASN1Dict([
        ('contextType', _ContextAssertion_contextType),
        ('contextValues', _ContextAssertion_contextValues),
        ])
    ContextAssertion._ext = []
    
    #-----< AttributeTypeAssertion >-----#
    AttributeTypeAssertion = SEQ(name='AttributeTypeAssertion', mode=MODE_TYPE)
    _AttributeTypeAssertion_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAssertion_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeAssertion_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAssertion_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeAssertion_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeAssertion_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAssertion_type._const_tab = __AttributeTypeAssertion_type_tab
    _AttributeTypeAssertion_type._const_tab_at = None
    _AttributeTypeAssertion_type._const_tab_id = 'id'
    _AttributeTypeAssertion_assertedContexts = SEQ_OF(name='assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeTypeAssertion_assertedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _AttributeTypeAssertion_assertedContexts._cont = __AttributeTypeAssertion_assertedContexts__item_
    _AttributeTypeAssertion_assertedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeAssertion._cont = ASN1Dict([
        ('type', _AttributeTypeAssertion_type),
        ('assertedContexts', _AttributeTypeAssertion_assertedContexts),
        ])
    AttributeTypeAssertion._ext = []
    
    #-----< SupportedAttributes >-----#
    SupportedAttributes = CLASS(name='SupportedAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _SupportedAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    SupportedAttributes._val = ASN1Set(rv=[dict([('Type', _SupportedAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _SupportedAttributes_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=[], er=[])
    
    #-----< SupportedContexts >-----#
    SupportedContexts = CLASS(name='SupportedContexts', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    SupportedContexts._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Name >-----#
    Name = CHOICE(name='Name', mode=MODE_TYPE)
    _Name_rdnSequence = SEQ_OF(name='rdnSequence', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Name._cont = ASN1Dict([
        ('rdnSequence', _Name_rdnSequence),
        ])
    Name._ext = None
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name='RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name='DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name='RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    RelativeDistinguishedName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeTypeAndValue >-----#
    AttributeTypeAndValue = SEQ(name='AttributeTypeAndValue', mode=MODE_TYPE)
    _AttributeTypeAndValue_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __AttributeTypeAndValue_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAndValue_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___AttributeTypeAndValue_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAndValue_type_tab._val = ASN1Set(rv=[dict([('Type', ___AttributeTypeAndValue_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___AttributeTypeAndValue_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAndValue_type._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_type._const_tab_at = None
    _AttributeTypeAndValue_type._const_tab_id = 'id'
    _AttributeTypeAndValue_value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _AttributeTypeAndValue_value._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_value._const_tab_at = ('..', 'type')
    _AttributeTypeAndValue_value._const_tab_id = 'Type'
    AttributeTypeAndValue._cont = ASN1Dict([
        ('type', _AttributeTypeAndValue_type),
        ('value', _AttributeTypeAndValue_value),
        ])
    AttributeTypeAndValue._ext = []
    
    #-----< SubtreeSpecification >-----#
    SubtreeSpecification = SEQ(name='SubtreeSpecification', mode=MODE_TYPE)
    _SubtreeSpecification_base = SEQ_OF(name='base', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')), default=[])
    _SubtreeSpecification_specificExclusions = SET_OF(name='specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubtreeSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___SubtreeSpecification_specificExclusions__item__chopBefore = SEQ_OF(name='chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___SubtreeSpecification_specificExclusions__item__chopAfter = SEQ_OF(name='chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __SubtreeSpecification_specificExclusions__item_._cont = ASN1Dict([
        ('chopBefore', ___SubtreeSpecification_specificExclusions__item__chopBefore),
        ('chopAfter', ___SubtreeSpecification_specificExclusions__item__chopAfter),
        ])
    __SubtreeSpecification_specificExclusions__item_._ext = []
    _SubtreeSpecification_specificExclusions._cont = __SubtreeSpecification_specificExclusions__item_
    _SubtreeSpecification_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _SubtreeSpecification_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    _SubtreeSpecification_specificationFilter = CHOICE(name='specificationFilter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    SubtreeSpecification._cont = ASN1Dict([
        ('base', _SubtreeSpecification_base),
        ('specificExclusions', _SubtreeSpecification_specificExclusions),
        ('minimum', _SubtreeSpecification_minimum),
        ('maximum', _SubtreeSpecification_maximum),
        ('specificationFilter', _SubtreeSpecification_specificationFilter),
        ])
    SubtreeSpecification._ext = []
    
    #-----< LocalName >-----#
    LocalName = SEQ_OF(name='LocalName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< ChopSpecification >-----#
    ChopSpecification = SEQ(name='ChopSpecification', mode=MODE_TYPE)
    _ChopSpecification_specificExclusions = SET_OF(name='specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChopSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___ChopSpecification_specificExclusions__item__chopBefore = SEQ_OF(name='chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___ChopSpecification_specificExclusions__item__chopAfter = SEQ_OF(name='chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __ChopSpecification_specificExclusions__item_._cont = ASN1Dict([
        ('chopBefore', ___ChopSpecification_specificExclusions__item__chopBefore),
        ('chopAfter', ___ChopSpecification_specificExclusions__item__chopAfter),
        ])
    __ChopSpecification_specificExclusions__item_._ext = []
    _ChopSpecification_specificExclusions._cont = __ChopSpecification_specificExclusions__item_
    _ChopSpecification_specificExclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChopSpecification_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _ChopSpecification_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    ChopSpecification._cont = ASN1Dict([
        ('specificExclusions', _ChopSpecification_specificExclusions),
        ('minimum', _ChopSpecification_minimum),
        ('maximum', _ChopSpecification_maximum),
        ])
    ChopSpecification._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< Refinement >-----#
    Refinement = CHOICE(name='Refinement', mode=MODE_TYPE)
    _Refinement_item = OID(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _Refinement_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_and_._cont = __Refinement_and___item_
    _Refinement_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_or_._cont = __Refinement_or___item_
    _Refinement_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    Refinement._cont = ASN1Dict([
        ('item', _Refinement_item),
        ('and', _Refinement_and_),
        ('or', _Refinement_or_),
        ('not', _Refinement_not_),
        ])
    Refinement._ext = []
    
    #-----< OBJECT-CLASS >-----#
    OBJECT_CLASS = CLASS(name='OBJECT-CLASS', mode=MODE_TYPE)
    _OBJECT_CLASS_Superclasses = CLASS(name='Superclasses', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _OBJECT_CLASS_kind = ENUM(name='kind', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default='structural')
    _OBJECT_CLASS_MandatoryAttributes = CLASS(name='MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_OptionalAttributes = CLASS(name='OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __OBJECT_CLASS_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _OBJECT_CLASS_ldapName._cont = __OBJECT_CLASS_ldapName__item_
    _OBJECT_CLASS_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _OBJECT_CLASS_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _OBJECT_CLASS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    OBJECT_CLASS._cont = ASN1Dict([
        ('Superclasses', _OBJECT_CLASS_Superclasses),
        ('kind', _OBJECT_CLASS_kind),
        ('MandatoryAttributes', _OBJECT_CLASS_MandatoryAttributes),
        ('OptionalAttributes', _OBJECT_CLASS_OptionalAttributes),
        ('ldapName', _OBJECT_CLASS_ldapName),
        ('ldapDesc', _OBJECT_CLASS_ldapDesc),
        ('id', _OBJECT_CLASS_id),
        ])
    
    #-----< ObjectClassKind >-----#
    ObjectClassKind = ENUM(name='ObjectClassKind', mode=MODE_TYPE)
    ObjectClassKind._cont = ASN1Dict([('abstract', 0), ('structural', 1), ('auxiliary', 2)])
    ObjectClassKind._ext = None
    
    #-----< top >-----#
    top = CLASS(name='top', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    top._val = dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])
    
    #-----< alias >-----#
    alias = CLASS(name='alias', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    alias._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0), ('equality-match', dict([('AssertionType', ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])), ('ldapName', ['alias']), ('id', (2, 5, 6, 1))])
    
    #-----< parent >-----#
    parent = CLASS(name='parent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    parent._val = dict([('kind', 'abstract'), ('id', (2, 5, 6, 28))])
    
    #-----< child >-----#
    child = CLASS(name='child', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    child._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 6, 29))])
    
    #-----< ATTRIBUTE >-----#
    ATTRIBUTE = CLASS(name='ATTRIBUTE', mode=MODE_TYPE)
    _ATTRIBUTE_derivation = CLASS(name='derivation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _ATTRIBUTE_equality_match = CLASS(name='equality-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_ordering_match = CLASS(name='ordering-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_substrings_match = CLASS(name='substrings-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_single_valued = BOOL(name='single-valued', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_collective = BOOL(name='collective', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_dummy = BOOL(name='dummy', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_no_user_modification = BOOL(name='no-user-modification', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_usage = ENUM(name='usage', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default='userApplications')
    _ATTRIBUTE_ldapSyntax = OID(name='ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']), opt=True)
    _ATTRIBUTE_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __ATTRIBUTE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _ATTRIBUTE_ldapName._cont = __ATTRIBUTE_ldapName__item_
    _ATTRIBUTE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ATTRIBUTE_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _ATTRIBUTE_obsolete = BOOL(name='obsolete', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ATTRIBUTE._cont = ASN1Dict([
        ('derivation', _ATTRIBUTE_derivation),
        ('Type', _ATTRIBUTE_Type),
        ('equality-match', _ATTRIBUTE_equality_match),
        ('ordering-match', _ATTRIBUTE_ordering_match),
        ('substrings-match', _ATTRIBUTE_substrings_match),
        ('single-valued', _ATTRIBUTE_single_valued),
        ('collective', _ATTRIBUTE_collective),
        ('dummy', _ATTRIBUTE_dummy),
        ('no-user-modification', _ATTRIBUTE_no_user_modification),
        ('usage', _ATTRIBUTE_usage),
        ('ldapSyntax', _ATTRIBUTE_ldapSyntax),
        ('ldapName', _ATTRIBUTE_ldapName),
        ('ldapDesc', _ATTRIBUTE_ldapDesc),
        ('obsolete', _ATTRIBUTE_obsolete),
        ('id', _ATTRIBUTE_id),
        ])
    
    #-----< AttributeUsage >-----#
    AttributeUsage = ENUM(name='AttributeUsage', mode=MODE_TYPE)
    AttributeUsage._cont = ASN1Dict([('userApplications', 0), ('directoryOperation', 1), ('distributedOperation', 2), ('dSAOperation', 3)])
    AttributeUsage._ext = []
    
    #-----< objectClass >-----#
    objectClass = CLASS(name='objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClass_val_Type = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectClass._val = dict([('Type', _objectClass_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])
    
    #-----< aliasedEntryName >-----#
    aliasedEntryName = CLASS(name='aliasedEntryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aliasedEntryName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    aliasedEntryName._val = dict([('Type', _aliasedEntryName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])
    
    #-----< MATCHING-RULE >-----#
    MATCHING_RULE = CLASS(name='MATCHING-RULE', mode=MODE_TYPE)
    _MATCHING_RULE_ParentMatchingRules = CLASS(name='ParentMatchingRules', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _MATCHING_RULE_AssertionType = OPEN(name='AssertionType', mode=MODE_TYPE, opt=True)
    _MATCHING_RULE_uniqueMatchIndicator = CLASS(name='uniqueMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _MATCHING_RULE_ldapSyntax = OID(name='ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']), opt=True)
    _MATCHING_RULE_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __MATCHING_RULE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _MATCHING_RULE_ldapName._cont = __MATCHING_RULE_ldapName__item_
    _MATCHING_RULE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MATCHING_RULE_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _MATCHING_RULE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    MATCHING_RULE._cont = ASN1Dict([
        ('ParentMatchingRules', _MATCHING_RULE_ParentMatchingRules),
        ('AssertionType', _MATCHING_RULE_AssertionType),
        ('uniqueMatchIndicator', _MATCHING_RULE_uniqueMatchIndicator),
        ('ldapSyntax', _MATCHING_RULE_ldapSyntax),
        ('ldapName', _MATCHING_RULE_ldapName),
        ('ldapDesc', _MATCHING_RULE_ldapDesc),
        ('id', _MATCHING_RULE_id),
        ])
    
    #-----< objectIdentifierMatch >-----#
    objectIdentifierMatch = CLASS(name='objectIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectIdentifierMatch._val = dict([('AssertionType', _objectIdentifierMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])
    
    #-----< distinguishedNameMatch >-----#
    distinguishedNameMatch = CLASS(name='distinguishedNameMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _distinguishedNameMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedNameMatch._val = dict([('AssertionType', _distinguishedNameMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])
    
    #-----< MAPPING-BASED-MATCHING >-----#
    MAPPING_BASED_MATCHING = CLASS(name='MAPPING-BASED-MATCHING', mode=MODE_TYPE, param=True)
    
    #-----< NAME-FORM >-----#
    NAME_FORM = CLASS(name='NAME-FORM', mode=MODE_TYPE)
    _NAME_FORM_namedObjectClass = CLASS(name='namedObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    _NAME_FORM_MandatoryAttributes = CLASS(name='MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _NAME_FORM_OptionalAttributes = CLASS(name='OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _NAME_FORM_ldapName = SEQ_OF(name='ldapName', mode=MODE_VALUE, opt=True)
    __NAME_FORM_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _NAME_FORM_ldapName._cont = __NAME_FORM_ldapName__item_
    _NAME_FORM_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NAME_FORM_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE, opt=True)
    _NAME_FORM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    NAME_FORM._cont = ASN1Dict([
        ('namedObjectClass', _NAME_FORM_namedObjectClass),
        ('MandatoryAttributes', _NAME_FORM_MandatoryAttributes),
        ('OptionalAttributes', _NAME_FORM_OptionalAttributes),
        ('ldapName', _NAME_FORM_ldapName),
        ('ldapDesc', _NAME_FORM_ldapDesc),
        ('id', _NAME_FORM_id),
        ])
    
    #-----< DITStructureRule >-----#
    DITStructureRule = SEQ(name='DITStructureRule', mode=MODE_TYPE)
    _DITStructureRule_ruleIdentifier = INT(name='ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_nameForm = OID(name='nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _DITStructureRule_superiorStructureRules = SET_OF(name='superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRule_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_superiorStructureRules._cont = __DITStructureRule_superiorStructureRules__item_
    _DITStructureRule_superiorStructureRules._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITStructureRule._cont = ASN1Dict([
        ('ruleIdentifier', _DITStructureRule_ruleIdentifier),
        ('nameForm', _DITStructureRule_nameForm),
        ('superiorStructureRules', _DITStructureRule_superiorStructureRules),
        ])
    DITStructureRule._ext = []
    
    #-----< RuleIdentifier >-----#
    RuleIdentifier = INT(name='RuleIdentifier', mode=MODE_TYPE)
    
    #-----< STRUCTURE-RULE >-----#
    STRUCTURE_RULE = CLASS(name='STRUCTURE-RULE', mode=MODE_TYPE)
    _STRUCTURE_RULE_nameForm = CLASS(name='nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    _STRUCTURE_RULE_SuperiorStructureRules = INT(name='SuperiorStructureRules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'STRUCTURE-RULE'), ['id']), opt=True)
    _STRUCTURE_RULE_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    STRUCTURE_RULE._cont = ASN1Dict([
        ('nameForm', _STRUCTURE_RULE_nameForm),
        ('SuperiorStructureRules', _STRUCTURE_RULE_SuperiorStructureRules),
        ('id', _STRUCTURE_RULE_id),
        ])
    
    #-----< DITContentRule >-----#
    DITContentRule = SEQ(name='DITContentRule', mode=MODE_TYPE)
    _DITContentRule_structuralObjectClass = OID(name='structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRule_auxiliaries = SET_OF(name='auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRule_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRule_auxiliaries._cont = __DITContentRule_auxiliaries__item_
    _DITContentRule_auxiliaries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_mandatory = SET_OF(name='mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_mandatory._cont = __DITContentRule_mandatory__item_
    _DITContentRule_mandatory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_optional = SET_OF(name='optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_optional._cont = __DITContentRule_optional__item_
    _DITContentRule_optional._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_precluded = SET_OF(name='precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRule_precluded._cont = __DITContentRule_precluded__item_
    _DITContentRule_precluded._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContentRule._cont = ASN1Dict([
        ('structuralObjectClass', _DITContentRule_structuralObjectClass),
        ('auxiliaries', _DITContentRule_auxiliaries),
        ('mandatory', _DITContentRule_mandatory),
        ('optional', _DITContentRule_optional),
        ('precluded', _DITContentRule_precluded),
        ])
    DITContentRule._ext = []
    
    #-----< CONTENT-RULE >-----#
    CONTENT_RULE = CLASS(name='CONTENT-RULE', mode=MODE_TYPE)
    _CONTENT_RULE_structuralClass = OID(name='structuralClass', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), uniq=True)
    _CONTENT_RULE_Auxiliaries = CLASS(name='Auxiliaries', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _CONTENT_RULE_Mandatory = CLASS(name='Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Optional = CLASS(name='Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Precluded = CLASS(name='Precluded', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    CONTENT_RULE._cont = ASN1Dict([
        ('structuralClass', _CONTENT_RULE_structuralClass),
        ('Auxiliaries', _CONTENT_RULE_Auxiliaries),
        ('Mandatory', _CONTENT_RULE_Mandatory),
        ('Optional', _CONTENT_RULE_Optional),
        ('Precluded', _CONTENT_RULE_Precluded),
        ])
    
    #-----< CONTEXT >-----#
    CONTEXT = CLASS(name='CONTEXT', mode=MODE_TYPE)
    _CONTEXT_Type = OPEN(name='Type', mode=MODE_TYPE)
    _CONTEXT_defaultValue = OPEN(name='defaultValue', mode=MODE_VALUE, opt=True)
    _CONTEXT_Assertion = OPEN(name='Assertion', mode=MODE_TYPE, opt=True)
    _CONTEXT_absentMatch = BOOL(name='absentMatch', mode=MODE_VALUE, default=True)
    _CONTEXT_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    CONTEXT._cont = ASN1Dict([
        ('Type', _CONTEXT_Type),
        ('defaultValue', _CONTEXT_defaultValue),
        ('Assertion', _CONTEXT_Assertion),
        ('absentMatch', _CONTEXT_absentMatch),
        ('id', _CONTEXT_id),
        ])
    
    #-----< DITContextUse >-----#
    DITContextUse = SEQ(name='DITContextUse', mode=MODE_TYPE)
    _DITContextUse_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContextUse_mandatoryContexts = SET_OF(name='mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUse_mandatoryContexts._cont = __DITContextUse_mandatoryContexts__item_
    _DITContextUse_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUse_optionalContexts = SET_OF(name='optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUse_optionalContexts._cont = __DITContextUse_optionalContexts__item_
    _DITContextUse_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUse._cont = ASN1Dict([
        ('attributeType', _DITContextUse_attributeType),
        ('mandatoryContexts', _DITContextUse_mandatoryContexts),
        ('optionalContexts', _DITContextUse_optionalContexts),
        ])
    DITContextUse._ext = []
    
    #-----< DIT-CONTEXT-USE-RULE >-----#
    DIT_CONTEXT_USE_RULE = CLASS(name='DIT-CONTEXT-USE-RULE', mode=MODE_TYPE)
    _DIT_CONTEXT_USE_RULE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), uniq=True)
    _DIT_CONTEXT_USE_RULE_Mandatory = CLASS(name='Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    _DIT_CONTEXT_USE_RULE_Optional = CLASS(name='Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    DIT_CONTEXT_USE_RULE._cont = ASN1Dict([
        ('attributeType', _DIT_CONTEXT_USE_RULE_attributeType),
        ('Mandatory', _DIT_CONTEXT_USE_RULE_Mandatory),
        ('Optional', _DIT_CONTEXT_USE_RULE_Optional),
        ])
    
    #-----< FRIENDS >-----#
    FRIENDS = CLASS(name='FRIENDS', mode=MODE_TYPE)
    _FRIENDS_anchor = OID(name='anchor', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), uniq=True)
    _FRIENDS_Friends = CLASS(name='Friends', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    FRIENDS._cont = ASN1Dict([
        ('anchor', _FRIENDS_anchor),
        ('Friends', _FRIENDS_Friends),
        ])
    
    #-----< SYNTAX-NAME >-----#
    SYNTAX_NAME = CLASS(name='SYNTAX-NAME', mode=MODE_TYPE)
    _SYNTAX_NAME_ldapDesc = STR_UTF8(name='ldapDesc', mode=MODE_VALUE)
    _SYNTAX_NAME_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _SYNTAX_NAME_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    SYNTAX_NAME._cont = ASN1Dict([
        ('ldapDesc', _SYNTAX_NAME_ldapDesc),
        ('Type', _SYNTAX_NAME_Type),
        ('id', _SYNTAX_NAME_id),
        ])
    
    #-----< subentry >-----#
    subentry = CLASS(name='subentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subentry._val = dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))]), dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), ('ldapName', ['subentry']), ('id', (2, 5, 17, 0))])
    
    #-----< subentryNameForm >-----#
    subentryNameForm = CLASS(name='subentryNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __NAME_FORM_MandatoryAttributes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    subentryNameForm._val = dict([('namedObjectClass', dict([('Superclasses', ASN1Set(rv=[dict([('kind', 'abstract'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), ('ldapName', ['top']), ('id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), ('kind', 'structural'), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))]), dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), ('ldapName', ['subentry']), ('id', (2, 5, 17, 0))])), ('MandatoryAttributes', ASN1Set(rv=[dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __NAME_FORM_MandatoryAttributes_val_Type_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), ('id', (2, 5, 15, 16))])
    
    #-----< subtreeSpecification >-----#
    subtreeSpecification = CLASS(name='subtreeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subtreeSpecification_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpecification._val = dict([('Type', _subtreeSpecification_val_Type), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), ('ldapName', ['subtreeSpecification']), ('id', (2, 5, 18, 6))])
    
    #-----< administrativeRole >-----#
    administrativeRole = CLASS(name='administrativeRole', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _administrativeRole_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    administrativeRole._val = dict([('Type', _administrativeRole_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['administrativeRole']), ('id', (2, 5, 18, 5))])
    
    #-----< createTimestamp >-----#
    createTimestamp = CLASS(name='createTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _createTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_2 = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    createTimestamp._val = dict([('Type', _createTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['createTimestamp']), ('id', (2, 5, 18, 1))])
    
    #-----< modifyTimestamp >-----#
    modifyTimestamp = CLASS(name='modifyTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifyTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    modifyTimestamp._val = dict([('Type', _modifyTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['modifyTimestamp']), ('id', (2, 5, 18, 2))])
    
    #-----< subschemaTimestamp >-----#
    subschemaTimestamp = CLASS(name='subschemaTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaTimestamp_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    subschemaTimestamp._val = dict([('Type', _subschemaTimestamp_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 8))])
    
    #-----< creatorsName >-----#
    creatorsName = CLASS(name='creatorsName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _creatorsName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    creatorsName._val = dict([('Type', _creatorsName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['creatorsName']), ('id', (2, 5, 18, 3))])
    
    #-----< modifiersName >-----#
    modifiersName = CLASS(name='modifiersName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifiersName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    modifiersName._val = dict([('Type', _modifiersName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['modifiersName']), ('id', (2, 5, 18, 4))])
    
    #-----< subschemaSubentryList >-----#
    subschemaSubentryList = CLASS(name='subschemaSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    subschemaSubentryList._val = dict([('Type', _subschemaSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['subschemaSubentry']), ('id', (2, 5, 18, 10))])
    
    #-----< accessControlSubentryList >-----#
    accessControlSubentryList = CLASS(name='accessControlSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    accessControlSubentryList._val = dict([('Type', _accessControlSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 11))])
    
    #-----< collectiveAttributeSubentryList >-----#
    collectiveAttributeSubentryList = CLASS(name='collectiveAttributeSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveAttributeSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    collectiveAttributeSubentryList._val = dict([('Type', _collectiveAttributeSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 12))])
    
    #-----< contextDefaultSubentryList >-----#
    contextDefaultSubentryList = CLASS(name='contextDefaultSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextDefaultSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    contextDefaultSubentryList._val = dict([('Type', _contextDefaultSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 13))])
    
    #-----< serviceAdminSubentryList >-----#
    serviceAdminSubentryList = CLASS(name='serviceAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceAdminSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    serviceAdminSubentryList._val = dict([('Type', _serviceAdminSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 15))])
    
    #-----< pwdAdminSubentryList >-----#
    pwdAdminSubentryList = CLASS(name='pwdAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAdminSubentryList_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    pwdAdminSubentryList._val = dict([('Type', _pwdAdminSubentryList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['pwdAdminSubentryList']), ('id', (2, 5, 18, 21))])
    
    #-----< hasSubordinates >-----#
    hasSubordinates = CLASS(name='hasSubordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hasSubordinates_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_3 = BOOL(name='AssertionType', mode=MODE_TYPE)
    hasSubordinates._val = dict([('Type', _hasSubordinates_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 9))])
    
    #-----< accessControlSubentry >-----#
    accessControlSubentry = CLASS(name='accessControlSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    accessControlSubentry._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 17, 1))])
    
    #-----< collectiveAttributeSubentry >-----#
    collectiveAttributeSubentry = CLASS(name='collectiveAttributeSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    collectiveAttributeSubentry._val = dict([('kind', 'auxiliary'), ('id', (2, 5, 17, 2))])
    
    #-----< collectiveExclusions >-----#
    collectiveExclusions = CLASS(name='collectiveExclusions', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveExclusions_val_Type = OID(name='Type', mode=MODE_TYPE)
    collectiveExclusions._val = dict([('Type', _collectiveExclusions_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 7))])
    
    #-----< contextAssertionSubentry >-----#
    contextAssertionSubentry = CLASS(name='contextAssertionSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 14))])], rr=[], ev=None, er=[])), ('id', (2, 5, 17, 3))])
    
    #-----< contextAssertionDefaults >-----#
    contextAssertionDefaults = CLASS(name='contextAssertionDefaults', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextAssertionDefaults_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionDefaults._val = dict([('Type', _contextAssertionDefaults_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 14))])
    
    #-----< serviceAdminSubentry >-----#
    serviceAdminSubentry = CLASS(name='serviceAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = INT(name='AssertionType', mode=MODE_TYPE)
    serviceAdminSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 16))])], rr=[], ev=None, er=[])), ('id', (2, 5, 17, 4))])
    
    #-----< searchRules >-----#
    searchRules = CLASS(name='searchRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    searchRules._val = dict([('Type', _searchRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 16))])
    
    #-----< SearchRuleDescription >-----#
    SearchRuleDescription = SEQ(name='SearchRuleDescription', mode=MODE_TYPE)
    _SearchRuleDescription_id = INT(name='id', mode=MODE_TYPE)
    _SearchRuleDescription_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRuleDescription_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_inputAttributeTypes = SEQ_OF(name='inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRuleDescription_inputAttributeTypes._cont = __SearchRuleDescription_inputAttributeTypes__item_
    _SearchRuleDescription_attributeCombination = CHOICE(name='attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=('and', []))
    _SearchRuleDescription_outputAttributeTypes = SEQ_OF(name='outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRuleDescription_outputAttributeTypes._cont = __SearchRuleDescription_outputAttributeTypes__item_
    _SearchRuleDescription_defaultControls = SEQ(name='defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRuleDescription_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRuleDescription_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRuleDescription_additionalControl = SEQ_OF(name='additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRuleDescription_additionalControl._cont = __SearchRuleDescription_additionalControl__item_
    _SearchRuleDescription_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRuleDescription_imposedSubset = ENUM(name='imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRuleDescription_entryLimit = SEQ(name='entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SearchRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _SearchRuleDescription_name._cont = __SearchRuleDescription_name__item_
    _SearchRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    SearchRuleDescription._cont = ASN1Dict([
        ('id', _SearchRuleDescription_id),
        ('dmdId', _SearchRuleDescription_dmdId),
        ('serviceType', _SearchRuleDescription_serviceType),
        ('userClass', _SearchRuleDescription_userClass),
        ('inputAttributeTypes', _SearchRuleDescription_inputAttributeTypes),
        ('attributeCombination', _SearchRuleDescription_attributeCombination),
        ('outputAttributeTypes', _SearchRuleDescription_outputAttributeTypes),
        ('defaultControls', _SearchRuleDescription_defaultControls),
        ('mandatoryControls', _SearchRuleDescription_mandatoryControls),
        ('searchRuleControls', _SearchRuleDescription_searchRuleControls),
        ('familyGrouping', _SearchRuleDescription_familyGrouping),
        ('familyReturn', _SearchRuleDescription_familyReturn),
        ('relaxation', _SearchRuleDescription_relaxation),
        ('additionalControl', _SearchRuleDescription_additionalControl),
        ('allowedSubset', _SearchRuleDescription_allowedSubset),
        ('imposedSubset', _SearchRuleDescription_imposedSubset),
        ('entryLimit', _SearchRuleDescription_entryLimit),
        ('name', _SearchRuleDescription_name),
        ('description', _SearchRuleDescription_description),
        ])
    SearchRuleDescription._ext = []
    
    #-----< pwdAdminSubentry >-----#
    pwdAdminSubentry = CLASS(name='pwdAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    pwdAdminSubentry._val = dict([('kind', 'auxiliary'), ('MandatoryAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['pwdAttribute']), ('id', (2, 5, 4, 84))])], rr=[], ev=None, er=[])), ('ldapName', ['pwdAdminSubentry']), ('id', (2, 5, 17, 5))])
    
    #-----< pwdAttribute >-----#
    pwdAttribute = CLASS(name='pwdAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAttribute_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    pwdAttribute._val = dict([('Type', _pwdAttribute_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['pwdAttribute']), ('id', (2, 5, 4, 84))])
    
    #-----< pwdHistory >-----#
    pwdHistory = CLASS(name='pwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< PwdHistory >-----#
    PwdHistory = SEQ(name='PwdHistory', mode=MODE_TYPE, param=True)
    
    #-----< pwdRecentlyExpired >-----#
    pwdRecentlyExpired = CLASS(name='pwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< pwdHistoryMatch >-----#
    pwdHistoryMatch = CLASS(name='pwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), param=True)
    
    #-----< hierarchyLevel >-----#
    hierarchyLevel = CLASS(name='hierarchyLevel', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyLevel_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyLevel')))
    __ATTRIBUTE_ordering_match_val_AssertionType_0 = INT(name='AssertionType', mode=MODE_TYPE)
    hierarchyLevel._val = dict([('Type', _hierarchyLevel_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 17))])
    
    #-----< HierarchyLevel >-----#
    HierarchyLevel = INT(name='HierarchyLevel', mode=MODE_TYPE)
    
    #-----< hierarchyBelow >-----#
    hierarchyBelow = CLASS(name='hierarchyBelow', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyBelow_val_Type = BOOL(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyBelow')))
    hierarchyBelow._val = dict([('Type', _hierarchyBelow_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 18))])
    
    #-----< HierarchyBelow >-----#
    HierarchyBelow = BOOL(name='HierarchyBelow', mode=MODE_TYPE)
    
    #-----< hierarchyParent >-----#
    hierarchyParent = CLASS(name='hierarchyParent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyParent_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyParent._val = dict([('Type', _hierarchyParent_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 19))])
    
    #-----< hierarchyTop >-----#
    hierarchyTop = CLASS(name='hierarchyTop', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyTop_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyTop._val = dict([('Type', _hierarchyTop_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('usage', 'directoryOperation'), ('id', (2, 5, 18, 20))])
    
    #-----< id-oc-top >-----#
    id_oc_top = OID(name='id-oc-top', mode=MODE_VALUE)
    id_oc_top._val = (2, 5, 6, 0)
    
    #-----< id-oc-alias >-----#
    id_oc_alias = OID(name='id-oc-alias', mode=MODE_VALUE)
    id_oc_alias._val = (2, 5, 6, 1)
    
    #-----< id-oc-parent >-----#
    id_oc_parent = OID(name='id-oc-parent', mode=MODE_VALUE)
    id_oc_parent._val = (2, 5, 6, 28)
    
    #-----< id-oc-child >-----#
    id_oc_child = OID(name='id-oc-child', mode=MODE_VALUE)
    id_oc_child._val = (2, 5, 6, 29)
    
    #-----< id-at-objectClass >-----#
    id_at_objectClass = OID(name='id-at-objectClass', mode=MODE_VALUE)
    id_at_objectClass._val = (2, 5, 4, 0)
    
    #-----< id-at-aliasedEntryName >-----#
    id_at_aliasedEntryName = OID(name='id-at-aliasedEntryName', mode=MODE_VALUE)
    id_at_aliasedEntryName._val = (2, 5, 4, 1)
    
    #-----< id-at-pwdAttribute >-----#
    id_at_pwdAttribute = OID(name='id-at-pwdAttribute', mode=MODE_VALUE)
    id_at_pwdAttribute._val = (2, 5, 4, 84)
    
    #-----< id-mr-objectIdentifierMatch >-----#
    id_mr_objectIdentifierMatch = OID(name='id-mr-objectIdentifierMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierMatch._val = (2, 5, 13, 0)
    
    #-----< id-mr-distinguishedNameMatch >-----#
    id_mr_distinguishedNameMatch = OID(name='id-mr-distinguishedNameMatch', mode=MODE_VALUE)
    id_mr_distinguishedNameMatch._val = (2, 5, 13, 1)
    
    #-----< id-oa-excludeAllCollectiveAttributes >-----#
    id_oa_excludeAllCollectiveAttributes = OID(name='id-oa-excludeAllCollectiveAttributes', mode=MODE_VALUE)
    id_oa_excludeAllCollectiveAttributes._val = (2, 5, 18, 0)
    
    #-----< id-oa-createTimestamp >-----#
    id_oa_createTimestamp = OID(name='id-oa-createTimestamp', mode=MODE_VALUE)
    id_oa_createTimestamp._val = (2, 5, 18, 1)
    
    #-----< id-oa-modifyTimestamp >-----#
    id_oa_modifyTimestamp = OID(name='id-oa-modifyTimestamp', mode=MODE_VALUE)
    id_oa_modifyTimestamp._val = (2, 5, 18, 2)
    
    #-----< id-oa-creatorsName >-----#
    id_oa_creatorsName = OID(name='id-oa-creatorsName', mode=MODE_VALUE)
    id_oa_creatorsName._val = (2, 5, 18, 3)
    
    #-----< id-oa-modifiersName >-----#
    id_oa_modifiersName = OID(name='id-oa-modifiersName', mode=MODE_VALUE)
    id_oa_modifiersName._val = (2, 5, 18, 4)
    
    #-----< id-oa-administrativeRole >-----#
    id_oa_administrativeRole = OID(name='id-oa-administrativeRole', mode=MODE_VALUE)
    id_oa_administrativeRole._val = (2, 5, 18, 5)
    
    #-----< id-oa-subtreeSpecification >-----#
    id_oa_subtreeSpecification = OID(name='id-oa-subtreeSpecification', mode=MODE_VALUE)
    id_oa_subtreeSpecification._val = (2, 5, 18, 6)
    
    #-----< id-oa-collectiveExclusions >-----#
    id_oa_collectiveExclusions = OID(name='id-oa-collectiveExclusions', mode=MODE_VALUE)
    id_oa_collectiveExclusions._val = (2, 5, 18, 7)
    
    #-----< id-oa-subschemaTimestamp >-----#
    id_oa_subschemaTimestamp = OID(name='id-oa-subschemaTimestamp', mode=MODE_VALUE)
    id_oa_subschemaTimestamp._val = (2, 5, 18, 8)
    
    #-----< id-oa-hasSubordinates >-----#
    id_oa_hasSubordinates = OID(name='id-oa-hasSubordinates', mode=MODE_VALUE)
    id_oa_hasSubordinates._val = (2, 5, 18, 9)
    
    #-----< id-oa-subschemaSubentryList >-----#
    id_oa_subschemaSubentryList = OID(name='id-oa-subschemaSubentryList', mode=MODE_VALUE)
    id_oa_subschemaSubentryList._val = (2, 5, 18, 10)
    
    #-----< id-oa-accessControlSubentryList >-----#
    id_oa_accessControlSubentryList = OID(name='id-oa-accessControlSubentryList', mode=MODE_VALUE)
    id_oa_accessControlSubentryList._val = (2, 5, 18, 11)
    
    #-----< id-oa-collectiveAttributeSubentryList >-----#
    id_oa_collectiveAttributeSubentryList = OID(name='id-oa-collectiveAttributeSubentryList', mode=MODE_VALUE)
    id_oa_collectiveAttributeSubentryList._val = (2, 5, 18, 12)
    
    #-----< id-oa-contextDefaultSubentryList >-----#
    id_oa_contextDefaultSubentryList = OID(name='id-oa-contextDefaultSubentryList', mode=MODE_VALUE)
    id_oa_contextDefaultSubentryList._val = (2, 5, 18, 13)
    
    #-----< id-oa-contextAssertionDefault >-----#
    id_oa_contextAssertionDefault = OID(name='id-oa-contextAssertionDefault', mode=MODE_VALUE)
    id_oa_contextAssertionDefault._val = (2, 5, 18, 14)
    
    #-----< id-oa-serviceAdminSubentryList >-----#
    id_oa_serviceAdminSubentryList = OID(name='id-oa-serviceAdminSubentryList', mode=MODE_VALUE)
    id_oa_serviceAdminSubentryList._val = (2, 5, 18, 15)
    
    #-----< id-oa-searchRules >-----#
    id_oa_searchRules = OID(name='id-oa-searchRules', mode=MODE_VALUE)
    id_oa_searchRules._val = (2, 5, 18, 16)
    
    #-----< id-oa-hierarchyLevel >-----#
    id_oa_hierarchyLevel = OID(name='id-oa-hierarchyLevel', mode=MODE_VALUE)
    id_oa_hierarchyLevel._val = (2, 5, 18, 17)
    
    #-----< id-oa-hierarchyBelow >-----#
    id_oa_hierarchyBelow = OID(name='id-oa-hierarchyBelow', mode=MODE_VALUE)
    id_oa_hierarchyBelow._val = (2, 5, 18, 18)
    
    #-----< id-oa-hierarchyParent >-----#
    id_oa_hierarchyParent = OID(name='id-oa-hierarchyParent', mode=MODE_VALUE)
    id_oa_hierarchyParent._val = (2, 5, 18, 19)
    
    #-----< id-oa-hierarchyTop >-----#
    id_oa_hierarchyTop = OID(name='id-oa-hierarchyTop', mode=MODE_VALUE)
    id_oa_hierarchyTop._val = (2, 5, 18, 20)
    
    #-----< id-oa-pwdAdminSubentryList >-----#
    id_oa_pwdAdminSubentryList = OID(name='id-oa-pwdAdminSubentryList', mode=MODE_VALUE)
    id_oa_pwdAdminSubentryList._val = (2, 5, 18, 21)
    
    #-----< id-oa-allAttributeTypes >-----#
    id_oa_allAttributeTypes = OID(name='id-oa-allAttributeTypes', mode=MODE_VALUE)
    id_oa_allAttributeTypes._val = (2, 5, 18, 48)
    
    #-----< id-sc-subentry >-----#
    id_sc_subentry = OID(name='id-sc-subentry', mode=MODE_VALUE)
    id_sc_subentry._val = (2, 5, 17, 0)
    
    #-----< id-sc-accessControlSubentry >-----#
    id_sc_accessControlSubentry = OID(name='id-sc-accessControlSubentry', mode=MODE_VALUE)
    id_sc_accessControlSubentry._val = (2, 5, 17, 1)
    
    #-----< id-sc-collectiveAttributeSubentry >-----#
    id_sc_collectiveAttributeSubentry = OID(name='id-sc-collectiveAttributeSubentry', mode=MODE_VALUE)
    id_sc_collectiveAttributeSubentry._val = (2, 5, 17, 2)
    
    #-----< id-sc-contextAssertionSubentry >-----#
    id_sc_contextAssertionSubentry = OID(name='id-sc-contextAssertionSubentry', mode=MODE_VALUE)
    id_sc_contextAssertionSubentry._val = (2, 5, 17, 3)
    
    #-----< id-sc-serviceAdminSubentry >-----#
    id_sc_serviceAdminSubentry = OID(name='id-sc-serviceAdminSubentry', mode=MODE_VALUE)
    id_sc_serviceAdminSubentry._val = (2, 5, 17, 4)
    
    #-----< id-sc-pwdAdminSubentry >-----#
    id_sc_pwdAdminSubentry = OID(name='id-sc-pwdAdminSubentry', mode=MODE_VALUE)
    id_sc_pwdAdminSubentry._val = (2, 5, 17, 5)
    
    #-----< id-nf-subentryNameForm >-----#
    id_nf_subentryNameForm = OID(name='id-nf-subentryNameForm', mode=MODE_VALUE)
    id_nf_subentryNameForm._val = (2, 5, 15, 16)
    
    #-----< id-ar-autonomousArea >-----#
    id_ar_autonomousArea = OID(name='id-ar-autonomousArea', mode=MODE_VALUE)
    id_ar_autonomousArea._val = (2, 5, 23, 1)
    
    #-----< id-ar-accessControlSpecificArea >-----#
    id_ar_accessControlSpecificArea = OID(name='id-ar-accessControlSpecificArea', mode=MODE_VALUE)
    id_ar_accessControlSpecificArea._val = (2, 5, 23, 2)
    
    #-----< id-ar-accessControlInnerArea >-----#
    id_ar_accessControlInnerArea = OID(name='id-ar-accessControlInnerArea', mode=MODE_VALUE)
    id_ar_accessControlInnerArea._val = (2, 5, 23, 3)
    
    #-----< id-ar-subschemaAdminSpecificArea >-----#
    id_ar_subschemaAdminSpecificArea = OID(name='id-ar-subschemaAdminSpecificArea', mode=MODE_VALUE)
    id_ar_subschemaAdminSpecificArea._val = (2, 5, 23, 4)
    
    #-----< id-ar-collectiveAttributeSpecificArea >-----#
    id_ar_collectiveAttributeSpecificArea = OID(name='id-ar-collectiveAttributeSpecificArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeSpecificArea._val = (2, 5, 23, 5)
    
    #-----< id-ar-collectiveAttributeInnerArea >-----#
    id_ar_collectiveAttributeInnerArea = OID(name='id-ar-collectiveAttributeInnerArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeInnerArea._val = (2, 5, 23, 6)
    
    #-----< id-ar-contextDefaultSpecificArea >-----#
    id_ar_contextDefaultSpecificArea = OID(name='id-ar-contextDefaultSpecificArea', mode=MODE_VALUE)
    id_ar_contextDefaultSpecificArea._val = (2, 5, 23, 7)
    
    #-----< id-ar-serviceSpecificArea >-----#
    id_ar_serviceSpecificArea = OID(name='id-ar-serviceSpecificArea', mode=MODE_VALUE)
    id_ar_serviceSpecificArea._val = (2, 5, 23, 8)
    
    #-----< id-ar-pwdAdminSpecificArea >-----#
    id_ar_pwdAdminSpecificArea = OID(name='id-ar-pwdAdminSpecificArea', mode=MODE_VALUE)
    id_ar_pwdAdminSpecificArea._val = (2, 5, 23, 9)
    
    _all_ = [
        AttributeType,
        AttributeValue,
        __Context_contextType_tab,
        _Context_contextType,
        ___Context_contextValues__item__tab,
        __Context_contextValues__item_,
        _Context_contextValues,
        _Context_fallback,
        Context,
        __AttributeValueAssertion_type_tab,
        ___AttributeValueAssertion_type_tab_val_Type_0,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType,
        ___AttributeValueAssertion_type_tab_val_Type_1,
        ______AttributeCertificateInfo_attributes__item__type_tab_equality_match_val_AssertionType_0,
        _AttributeValueAssertion_type,
        _AttributeValueAssertion_assertion,
        __AttributeValueAssertion_assertedContexts_allContexts,
        ___AttributeValueAssertion_assertedContexts_selectedContexts__item_,
        __AttributeValueAssertion_assertedContexts_selectedContexts,
        _AttributeValueAssertion_assertedContexts,
        AttributeValueAssertion,
        __ContextAssertion_contextType_tab,
        _ContextAssertion_contextType,
        ___ContextAssertion_contextValues__item__tab,
        __ContextAssertion_contextValues__item_,
        _ContextAssertion_contextValues,
        ContextAssertion,
        __AttributeTypeAssertion_type_tab,
        ___AttributeTypeAssertion_type_tab_val_Type_0,
        ___AttributeTypeAssertion_type_tab_val_Type_1,
        _AttributeTypeAssertion_type,
        __AttributeTypeAssertion_assertedContexts__item_,
        _AttributeTypeAssertion_assertedContexts,
        AttributeTypeAssertion,
        SupportedAttributes,
        _SupportedAttributes_val_Type_0,
        _SupportedAttributes_val_Type_1,
        SupportedContexts,
        _Name_rdnSequence,
        Name,
        _RDNSequence__item_,
        RDNSequence,
        DistinguishedName,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        __AttributeTypeAndValue_type_tab,
        ___AttributeTypeAndValue_type_tab_val_Type_0,
        ___AttributeTypeAndValue_type_tab_val_Type_1,
        _AttributeTypeAndValue_type,
        _AttributeTypeAndValue_value,
        AttributeTypeAndValue,
        _SubtreeSpecification_base,
        ___SubtreeSpecification_specificExclusions__item__chopBefore,
        ___SubtreeSpecification_specificExclusions__item__chopAfter,
        __SubtreeSpecification_specificExclusions__item_,
        _SubtreeSpecification_specificExclusions,
        _SubtreeSpecification_minimum,
        _SubtreeSpecification_maximum,
        _SubtreeSpecification_specificationFilter,
        SubtreeSpecification,
        LocalName,
        ___ChopSpecification_specificExclusions__item__chopBefore,
        ___ChopSpecification_specificExclusions__item__chopAfter,
        __ChopSpecification_specificExclusions__item_,
        _ChopSpecification_specificExclusions,
        _ChopSpecification_minimum,
        _ChopSpecification_maximum,
        ChopSpecification,
        BaseDistance,
        _Refinement_item,
        __Refinement_and___item_,
        _Refinement_and_,
        __Refinement_or___item_,
        _Refinement_or_,
        _Refinement_not_,
        Refinement,
        _OBJECT_CLASS_Superclasses,
        _OBJECT_CLASS_kind,
        _OBJECT_CLASS_MandatoryAttributes,
        _OBJECT_CLASS_OptionalAttributes,
        __OBJECT_CLASS_ldapName__item_,
        _OBJECT_CLASS_ldapName,
        _OBJECT_CLASS_ldapDesc,
        _OBJECT_CLASS_id,
        OBJECT_CLASS,
        ObjectClassKind,
        top,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0,
        alias,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0,
        parent,
        child,
        _ATTRIBUTE_derivation,
        _ATTRIBUTE_Type,
        _ATTRIBUTE_equality_match,
        _ATTRIBUTE_ordering_match,
        _ATTRIBUTE_substrings_match,
        _ATTRIBUTE_single_valued,
        _ATTRIBUTE_collective,
        _ATTRIBUTE_dummy,
        _ATTRIBUTE_no_user_modification,
        _ATTRIBUTE_usage,
        _ATTRIBUTE_ldapSyntax,
        __ATTRIBUTE_ldapName__item_,
        _ATTRIBUTE_ldapName,
        _ATTRIBUTE_ldapDesc,
        _ATTRIBUTE_obsolete,
        _ATTRIBUTE_id,
        ATTRIBUTE,
        AttributeUsage,
        objectClass,
        _objectClass_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        aliasedEntryName,
        _aliasedEntryName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _MATCHING_RULE_ParentMatchingRules,
        _MATCHING_RULE_AssertionType,
        _MATCHING_RULE_uniqueMatchIndicator,
        _MATCHING_RULE_ldapSyntax,
        __MATCHING_RULE_ldapName__item_,
        _MATCHING_RULE_ldapName,
        _MATCHING_RULE_ldapDesc,
        _MATCHING_RULE_id,
        MATCHING_RULE,
        objectIdentifierMatch,
        _objectIdentifierMatch_val_AssertionType,
        distinguishedNameMatch,
        _distinguishedNameMatch_val_AssertionType,
        _NAME_FORM_namedObjectClass,
        _NAME_FORM_MandatoryAttributes,
        _NAME_FORM_OptionalAttributes,
        __NAME_FORM_ldapName__item_,
        _NAME_FORM_ldapName,
        _NAME_FORM_ldapDesc,
        _NAME_FORM_id,
        NAME_FORM,
        _DITStructureRule_ruleIdentifier,
        _DITStructureRule_nameForm,
        __DITStructureRule_superiorStructureRules__item_,
        _DITStructureRule_superiorStructureRules,
        DITStructureRule,
        RuleIdentifier,
        _STRUCTURE_RULE_nameForm,
        _STRUCTURE_RULE_SuperiorStructureRules,
        _STRUCTURE_RULE_id,
        STRUCTURE_RULE,
        _DITContentRule_structuralObjectClass,
        __DITContentRule_auxiliaries__item_,
        _DITContentRule_auxiliaries,
        __DITContentRule_mandatory__item_,
        _DITContentRule_mandatory,
        __DITContentRule_optional__item_,
        _DITContentRule_optional,
        __DITContentRule_precluded__item_,
        _DITContentRule_precluded,
        DITContentRule,
        _CONTENT_RULE_structuralClass,
        _CONTENT_RULE_Auxiliaries,
        _CONTENT_RULE_Mandatory,
        _CONTENT_RULE_Optional,
        _CONTENT_RULE_Precluded,
        CONTENT_RULE,
        _CONTEXT_Type,
        _CONTEXT_defaultValue,
        _CONTEXT_Assertion,
        _CONTEXT_absentMatch,
        _CONTEXT_id,
        CONTEXT,
        _DITContextUse_attributeType,
        __DITContextUse_mandatoryContexts__item_,
        _DITContextUse_mandatoryContexts,
        __DITContextUse_optionalContexts__item_,
        _DITContextUse_optionalContexts,
        DITContextUse,
        _DIT_CONTEXT_USE_RULE_attributeType,
        _DIT_CONTEXT_USE_RULE_Mandatory,
        _DIT_CONTEXT_USE_RULE_Optional,
        DIT_CONTEXT_USE_RULE,
        _FRIENDS_anchor,
        _FRIENDS_Friends,
        FRIENDS,
        _SYNTAX_NAME_ldapDesc,
        _SYNTAX_NAME_Type,
        _SYNTAX_NAME_id,
        SYNTAX_NAME,
        subentry,
        __ATTRIBUTE_derivation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_1,
        subentryNameForm,
        __NAME_FORM_MandatoryAttributes_val_Type_0,
        subtreeSpecification,
        _subtreeSpecification_val_Type,
        administrativeRole,
        _administrativeRole_val_Type,
        createTimestamp,
        _createTimestamp_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        modifyTimestamp,
        _modifyTimestamp_val_Type,
        subschemaTimestamp,
        _subschemaTimestamp_val_Type,
        creatorsName,
        _creatorsName_val_Type,
        modifiersName,
        _modifiersName_val_Type,
        subschemaSubentryList,
        _subschemaSubentryList_val_Type,
        accessControlSubentryList,
        _accessControlSubentryList_val_Type,
        collectiveAttributeSubentryList,
        _collectiveAttributeSubentryList_val_Type,
        contextDefaultSubentryList,
        _contextDefaultSubentryList_val_Type,
        serviceAdminSubentryList,
        _serviceAdminSubentryList_val_Type,
        pwdAdminSubentryList,
        _pwdAdminSubentryList_val_Type,
        hasSubordinates,
        _hasSubordinates_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        accessControlSubentry,
        collectiveAttributeSubentry,
        collectiveExclusions,
        _collectiveExclusions_val_Type,
        contextAssertionSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2,
        contextAssertionDefaults,
        _contextAssertionDefaults_val_Type,
        serviceAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        searchRules,
        _searchRules_val_Type,
        _SearchRuleDescription_id,
        _SearchRuleDescription_dmdId,
        _SearchRuleDescription_serviceType,
        _SearchRuleDescription_userClass,
        __SearchRuleDescription_inputAttributeTypes__item_,
        _SearchRuleDescription_inputAttributeTypes,
        _SearchRuleDescription_attributeCombination,
        __SearchRuleDescription_outputAttributeTypes__item_,
        _SearchRuleDescription_outputAttributeTypes,
        _SearchRuleDescription_defaultControls,
        _SearchRuleDescription_mandatoryControls,
        _SearchRuleDescription_searchRuleControls,
        _SearchRuleDescription_familyGrouping,
        _SearchRuleDescription_familyReturn,
        _SearchRuleDescription_relaxation,
        __SearchRuleDescription_additionalControl__item_,
        _SearchRuleDescription_additionalControl,
        _SearchRuleDescription_allowedSubset,
        _SearchRuleDescription_imposedSubset,
        _SearchRuleDescription_entryLimit,
        __SearchRuleDescription_name__item_,
        _SearchRuleDescription_name,
        _SearchRuleDescription_description,
        SearchRuleDescription,
        pwdAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4,
        pwdAttribute,
        _pwdAttribute_val_Type,
        hierarchyLevel,
        _hierarchyLevel_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType_0,
        HierarchyLevel,
        hierarchyBelow,
        _hierarchyBelow_val_Type,
        HierarchyBelow,
        hierarchyParent,
        _hierarchyParent_val_Type,
        hierarchyTop,
        _hierarchyTop_val_Type,
        id_oc_top,
        id_oc_alias,
        id_oc_parent,
        id_oc_child,
        id_at_objectClass,
        id_at_aliasedEntryName,
        id_at_pwdAttribute,
        id_mr_objectIdentifierMatch,
        id_mr_distinguishedNameMatch,
        id_oa_excludeAllCollectiveAttributes,
        id_oa_createTimestamp,
        id_oa_modifyTimestamp,
        id_oa_creatorsName,
        id_oa_modifiersName,
        id_oa_administrativeRole,
        id_oa_subtreeSpecification,
        id_oa_collectiveExclusions,
        id_oa_subschemaTimestamp,
        id_oa_hasSubordinates,
        id_oa_subschemaSubentryList,
        id_oa_accessControlSubentryList,
        id_oa_collectiveAttributeSubentryList,
        id_oa_contextDefaultSubentryList,
        id_oa_contextAssertionDefault,
        id_oa_serviceAdminSubentryList,
        id_oa_searchRules,
        id_oa_hierarchyLevel,
        id_oa_hierarchyBelow,
        id_oa_hierarchyParent,
        id_oa_hierarchyTop,
        id_oa_pwdAdminSubentryList,
        id_oa_allAttributeTypes,
        id_sc_subentry,
        id_sc_accessControlSubentry,
        id_sc_collectiveAttributeSubentry,
        id_sc_contextAssertionSubentry,
        id_sc_serviceAdminSubentry,
        id_sc_pwdAdminSubentry,
        id_nf_subentryNameForm,
        id_ar_autonomousArea,
        id_ar_accessControlSpecificArea,
        id_ar_accessControlInnerArea,
        id_ar_subschemaAdminSpecificArea,
        id_ar_collectiveAttributeSpecificArea,
        id_ar_collectiveAttributeInnerArea,
        id_ar_contextDefaultSpecificArea,
        id_ar_serviceSpecificArea,
        id_ar_pwdAdminSpecificArea,
    ]

class LdapSystemSchema:

    _name_  = 'LdapSystemSchema'
    _oid_   = [2, 5, 1, 38, 7]
    
    _obj_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        'LdapSyntaxDescription',
        'id-lat-namingContexts',
        'id-lat-altServer',
        'id-lat-supportedExtension',
        'id-lat-supportedControl',
        'id-lat-supportedSASLMechanisms',
        'id-lat-supportedLDAPVersion',
        'id-soa-ldapSyntaxes',
        'id-oat-supportedFeatures',
        ]
    _type_ = [
        'LdapSyntaxDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        'id-lat-namingContexts',
        'id-lat-altServer',
        'id-lat-supportedExtension',
        'id-lat-supportedControl',
        'id-lat-supportedSASLMechanisms',
        'id-lat-supportedLDAPVersion',
        'id-soa-ldapSyntaxes',
        'id-oat-supportedFeatures',
        ]
    _class_ = [
        'namingContexts',
        'altServer',
        'supportedExtension',
        'supportedControl',
        'supportedSASLMechanisms',
        'supportedLDAPVersion',
        'supportedFeatures',
        'ldapSyntaxes',
        ]
    _param_ = [
        ]
    
    #-----< namingContexts >-----#
    namingContexts = CLASS(name='namingContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _namingContexts_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    namingContexts._val = dict([('Type', _namingContexts_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['namingContexts']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5))])
    
    #-----< altServer >-----#
    altServer = CLASS(name='altServer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _altServer_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    altServer._val = dict([('Type', _altServer_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['altServer']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6))])
    
    #-----< supportedExtension >-----#
    supportedExtension = CLASS(name='supportedExtension', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedExtension_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedExtension._val = dict([('Type', _supportedExtension_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedExtension']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7))])
    
    #-----< supportedControl >-----#
    supportedControl = CLASS(name='supportedControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedControl_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedControl._val = dict([('Type', _supportedControl_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedControl']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13))])
    
    #-----< supportedSASLMechanisms >-----#
    supportedSASLMechanisms = CLASS(name='supportedSASLMechanisms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedSASLMechanisms_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __supportedSASLMechanisms_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _supportedSASLMechanisms_val_Type._cont = ASN1Dict([
        ('teletexString', __supportedSASLMechanisms_val_Type_teletexString),
        ('printableString', __supportedSASLMechanisms_val_Type_printableString),
        ('bmpString', __supportedSASLMechanisms_val_Type_bmpString),
        ('universalString', __supportedSASLMechanisms_val_Type_universalString),
        ('uTF8String', __supportedSASLMechanisms_val_Type_uTF8String),
        ])
    _supportedSASLMechanisms_val_Type._ext = None
    supportedSASLMechanisms._val = dict([('Type', _supportedSASLMechanisms_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['supportedSASLMechanisms']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14))])
    
    #-----< supportedLDAPVersion >-----#
    supportedLDAPVersion = CLASS(name='supportedLDAPVersion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedLDAPVersion_val_Type = INT(name='Type', mode=MODE_TYPE)
    supportedLDAPVersion._val = dict([('Type', _supportedLDAPVersion_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['supportedLDAPVersion']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15))])
    
    #-----< supportedFeatures >-----#
    supportedFeatures = CLASS(name='supportedFeatures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedFeatures_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedFeatures._val = dict([('Type', _supportedFeatures_val_Type), ('usage', 'dSAOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['supportedFeatures']), ('id', (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5))])
    
    #-----< ldapSyntaxes >-----#
    ldapSyntaxes = CLASS(name='ldapSyntaxes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapSyntaxes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ldapSyntaxes._val = dict([('Type', _ldapSyntaxes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), ('ldapName', ['ldapSyntax']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])
    
    #-----< LdapSyntaxDescription >-----#
    LdapSyntaxDescription = SEQ(name='LdapSyntaxDescription', mode=MODE_TYPE)
    _LdapSyntaxDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), ['id']))
    _LdapSyntaxDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    LdapSyntaxDescription._cont = ASN1Dict([
        ('identifier', _LdapSyntaxDescription_identifier),
        ('description', _LdapSyntaxDescription_description),
        ])
    LdapSyntaxDescription._ext = []
    
    #-----< id-lat-namingContexts >-----#
    id_lat_namingContexts = OID(name='id-lat-namingContexts', mode=MODE_VALUE)
    id_lat_namingContexts._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5)
    
    #-----< id-lat-altServer >-----#
    id_lat_altServer = OID(name='id-lat-altServer', mode=MODE_VALUE)
    id_lat_altServer._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6)
    
    #-----< id-lat-supportedExtension >-----#
    id_lat_supportedExtension = OID(name='id-lat-supportedExtension', mode=MODE_VALUE)
    id_lat_supportedExtension._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7)
    
    #-----< id-lat-supportedControl >-----#
    id_lat_supportedControl = OID(name='id-lat-supportedControl', mode=MODE_VALUE)
    id_lat_supportedControl._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13)
    
    #-----< id-lat-supportedSASLMechanisms >-----#
    id_lat_supportedSASLMechanisms = OID(name='id-lat-supportedSASLMechanisms', mode=MODE_VALUE)
    id_lat_supportedSASLMechanisms._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14)
    
    #-----< id-lat-supportedLDAPVersion >-----#
    id_lat_supportedLDAPVersion = OID(name='id-lat-supportedLDAPVersion', mode=MODE_VALUE)
    id_lat_supportedLDAPVersion._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15)
    
    #-----< id-soa-ldapSyntaxes >-----#
    id_soa_ldapSyntaxes = OID(name='id-soa-ldapSyntaxes', mode=MODE_VALUE)
    id_soa_ldapSyntaxes._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16)
    
    #-----< id-oat-supportedFeatures >-----#
    id_oat_supportedFeatures = OID(name='id-oat-supportedFeatures', mode=MODE_VALUE)
    id_oat_supportedFeatures._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5)
    
    _all_ = [
        namingContexts,
        _namingContexts_val_Type,
        altServer,
        _altServer_val_Type,
        supportedExtension,
        _supportedExtension_val_Type,
        supportedControl,
        _supportedControl_val_Type,
        supportedSASLMechanisms,
        __supportedSASLMechanisms_val_Type_teletexString,
        __supportedSASLMechanisms_val_Type_printableString,
        __supportedSASLMechanisms_val_Type_bmpString,
        __supportedSASLMechanisms_val_Type_universalString,
        __supportedSASLMechanisms_val_Type_uTF8String,
        _supportedSASLMechanisms_val_Type,
        supportedLDAPVersion,
        _supportedLDAPVersion_val_Type,
        supportedFeatures,
        _supportedFeatures_val_Type,
        ldapSyntaxes,
        _ldapSyntaxes_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _LdapSyntaxDescription_identifier,
        _LdapSyntaxDescription_description,
        LdapSyntaxDescription,
        id_lat_namingContexts,
        id_lat_altServer,
        id_lat_supportedExtension,
        id_lat_supportedControl,
        id_lat_supportedSASLMechanisms,
        id_lat_supportedLDAPVersion,
        id_soa_ldapSyntaxes,
        id_oat_supportedFeatures,
    ]

class Lightweight_Directory_Access_Protocol_V3:

    _name_  = 'Lightweight-Directory-Access-Protocol-V3'
    _oid_   = [1, 3, 6, 1, 1, 18]
    
    _obj_ = [
        'LDAPMessage',
        'MessageID',
        'maxInt',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _type_ = [
        'LDAPMessage',
        'MessageID',
        'LDAPString',
        'LDAPOID',
        'LDAPDN',
        'RelativeLDAPDN',
        'AttributeDescription',
        'AttributeValue',
        'AttributeValueAssertion',
        'AssertionValue',
        'PartialAttribute',
        'Attribute',
        'MatchingRuleId',
        'LDAPResult',
        'Referral',
        'URI',
        'Controls',
        'Control',
        'BindRequest',
        'AuthenticationChoice',
        'SaslCredentials',
        'BindResponse',
        'UnbindRequest',
        'SearchRequest',
        'AttributeSelection',
        'Filter',
        'SubstringFilter',
        'MatchingRuleAssertion',
        'SearchResultEntry',
        'PartialAttributeList',
        'SearchResultReference',
        'SearchResultDone',
        'ModifyRequest',
        'ModifyResponse',
        'AddRequest',
        'AttributeList',
        'AddResponse',
        'DelRequest',
        'DelResponse',
        'ModifyDNRequest',
        'ModifyDNResponse',
        'CompareRequest',
        'CompareResponse',
        'AbandonRequest',
        'ExtendedRequest',
        'ExtendedResponse',
        'IntermediateResponse',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxInt',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LDAPMessage >-----#
    LDAPMessage = SEQ(name='LDAPMessage', mode=MODE_TYPE)
    _LDAPMessage_messageID = INT(name='messageID', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    _LDAPMessage_protocolOp = CHOICE(name='protocolOp', mode=MODE_TYPE)
    __LDAPMessage_protocolOp_bindRequest = SEQ(name='bindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindRequest')))
    __LDAPMessage_protocolOp_bindResponse = SEQ(name='bindResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindResponse')))
    __LDAPMessage_protocolOp_unbindRequest = NULL(name='unbindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'UnbindRequest')))
    __LDAPMessage_protocolOp_searchRequest = SEQ(name='searchRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchRequest')))
    __LDAPMessage_protocolOp_searchResEntry = SEQ(name='searchResEntry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultEntry')))
    __LDAPMessage_protocolOp_searchResDone = SEQ(name='searchResDone', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultDone')))
    __LDAPMessage_protocolOp_searchResRef = SEQ_OF(name='searchResRef', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultReference')))
    __LDAPMessage_protocolOp_modifyRequest = SEQ(name='modifyRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyRequest')))
    __LDAPMessage_protocolOp_modifyResponse = SEQ(name='modifyResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyResponse')))
    __LDAPMessage_protocolOp_addRequest = SEQ(name='addRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddRequest')))
    __LDAPMessage_protocolOp_addResponse = SEQ(name='addResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddResponse')))
    __LDAPMessage_protocolOp_delRequest = OCT_STR(name='delRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelRequest')))
    __LDAPMessage_protocolOp_delResponse = SEQ(name='delResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelResponse')))
    __LDAPMessage_protocolOp_modDNRequest = SEQ(name='modDNRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNRequest')))
    __LDAPMessage_protocolOp_modDNResponse = SEQ(name='modDNResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNResponse')))
    __LDAPMessage_protocolOp_compareRequest = SEQ(name='compareRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareRequest')))
    __LDAPMessage_protocolOp_compareResponse = SEQ(name='compareResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareResponse')))
    __LDAPMessage_protocolOp_abandonRequest = INT(name='abandonRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AbandonRequest')))
    __LDAPMessage_protocolOp_extendedReq = SEQ(name='extendedReq', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedRequest')))
    __LDAPMessage_protocolOp_extendedResp = SEQ(name='extendedResp', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedResponse')))
    __LDAPMessage_protocolOp_intermediateResponse = SEQ(name='intermediateResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'IntermediateResponse')))
    _LDAPMessage_protocolOp._cont = ASN1Dict([
        ('bindRequest', __LDAPMessage_protocolOp_bindRequest),
        ('bindResponse', __LDAPMessage_protocolOp_bindResponse),
        ('unbindRequest', __LDAPMessage_protocolOp_unbindRequest),
        ('searchRequest', __LDAPMessage_protocolOp_searchRequest),
        ('searchResEntry', __LDAPMessage_protocolOp_searchResEntry),
        ('searchResDone', __LDAPMessage_protocolOp_searchResDone),
        ('searchResRef', __LDAPMessage_protocolOp_searchResRef),
        ('modifyRequest', __LDAPMessage_protocolOp_modifyRequest),
        ('modifyResponse', __LDAPMessage_protocolOp_modifyResponse),
        ('addRequest', __LDAPMessage_protocolOp_addRequest),
        ('addResponse', __LDAPMessage_protocolOp_addResponse),
        ('delRequest', __LDAPMessage_protocolOp_delRequest),
        ('delResponse', __LDAPMessage_protocolOp_delResponse),
        ('modDNRequest', __LDAPMessage_protocolOp_modDNRequest),
        ('modDNResponse', __LDAPMessage_protocolOp_modDNResponse),
        ('compareRequest', __LDAPMessage_protocolOp_compareRequest),
        ('compareResponse', __LDAPMessage_protocolOp_compareResponse),
        ('abandonRequest', __LDAPMessage_protocolOp_abandonRequest),
        ('extendedReq', __LDAPMessage_protocolOp_extendedReq),
        ('extendedResp', __LDAPMessage_protocolOp_extendedResp),
        ('intermediateResponse', __LDAPMessage_protocolOp_intermediateResponse),
        ])
    _LDAPMessage_protocolOp._ext = ['intermediateResponse']
    _LDAPMessage_controls = SEQ_OF(name='controls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Controls')), opt=True)
    LDAPMessage._cont = ASN1Dict([
        ('messageID', _LDAPMessage_messageID),
        ('protocolOp', _LDAPMessage_protocolOp),
        ('controls', _LDAPMessage_controls),
        ])
    LDAPMessage._ext = []
    
    #-----< MessageID >-----#
    MessageID = INT(name='MessageID', mode=MODE_TYPE)
    MessageID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< maxInt >-----#
    maxInt = INT(name='maxInt', mode=MODE_VALUE)
    maxInt._val = 2147483647
    
    #-----< LDAPString >-----#
    LDAPString = OCT_STR(name='LDAPString', mode=MODE_TYPE)
    
    #-----< LDAPOID >-----#
    LDAPOID = OCT_STR(name='LDAPOID', mode=MODE_TYPE)
    
    #-----< LDAPDN >-----#
    LDAPDN = OCT_STR(name='LDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< RelativeLDAPDN >-----#
    RelativeLDAPDN = OCT_STR(name='RelativeLDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeDescription >-----#
    AttributeDescription = OCT_STR(name='AttributeDescription', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeValue >-----#
    AttributeValue = OCT_STR(name='AttributeValue', mode=MODE_TYPE)
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name='AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_attributeDesc = OCT_STR(name='attributeDesc', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _AttributeValueAssertion_assertionValue = OCT_STR(name='assertionValue', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    AttributeValueAssertion._cont = ASN1Dict([
        ('attributeDesc', _AttributeValueAssertion_attributeDesc),
        ('assertionValue', _AttributeValueAssertion_assertionValue),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< AssertionValue >-----#
    AssertionValue = OCT_STR(name='AssertionValue', mode=MODE_TYPE)
    
    #-----< PartialAttribute >-----#
    PartialAttribute = SEQ(name='PartialAttribute', mode=MODE_TYPE)
    _PartialAttribute_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _PartialAttribute_vals = SET_OF(name='vals', mode=MODE_TYPE)
    __PartialAttribute_vals_value = OCT_STR(name='value', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValue')))
    _PartialAttribute_vals._cont = __PartialAttribute_vals_value
    PartialAttribute._cont = ASN1Dict([
        ('type', _PartialAttribute_type),
        ('vals', _PartialAttribute_vals),
        ])
    PartialAttribute._ext = []
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    
    #-----< MatchingRuleId >-----#
    MatchingRuleId = OCT_STR(name='MatchingRuleId', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< LDAPResult >-----#
    LDAPResult = SEQ(name='LDAPResult', mode=MODE_TYPE)
    _LDAPResult_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _LDAPResult_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _LDAPResult_resultCode._ext = []
    _LDAPResult_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _LDAPResult_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _LDAPResult_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    LDAPResult._cont = ASN1Dict([
        ('resultCode', _LDAPResult_resultCode),
        ('matchedDN', _LDAPResult_matchedDN),
        ('diagnosticMessage', _LDAPResult_diagnosticMessage),
        ('referral', _LDAPResult_referral),
        ])
    LDAPResult._ext = []
    
    #-----< Referral >-----#
    Referral = SEQ_OF(name='Referral', mode=MODE_TYPE)
    _Referral_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    Referral._cont = _Referral_uri
    Referral._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< URI >-----#
    URI = OCT_STR(name='URI', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< Controls >-----#
    Controls = SEQ_OF(name='Controls', mode=MODE_TYPE)
    _Controls_control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Control')))
    Controls._cont = _Controls_control
    
    #-----< Control >-----#
    Control = SEQ(name='Control', mode=MODE_TYPE)
    _Control_controlType = OCT_STR(name='controlType', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _Control_criticality = BOOL(name='criticality', mode=MODE_TYPE, default=False)
    _Control_controlValue = OCT_STR(name='controlValue', mode=MODE_TYPE, opt=True)
    Control._cont = ASN1Dict([
        ('controlType', _Control_controlType),
        ('criticality', _Control_criticality),
        ('controlValue', _Control_controlValue),
        ])
    Control._ext = []
    
    #-----< BindRequest >-----#
    BindRequest = SEQ(name='BindRequest', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _BindRequest_version = INT(name='version', mode=MODE_TYPE)
    _BindRequest_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _BindRequest_name = OCT_STR(name='name', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindRequest_authentication = CHOICE(name='authentication', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AuthenticationChoice')))
    BindRequest._cont = ASN1Dict([
        ('version', _BindRequest_version),
        ('name', _BindRequest_name),
        ('authentication', _BindRequest_authentication),
        ])
    BindRequest._ext = []
    
    #-----< AuthenticationChoice >-----#
    AuthenticationChoice = CHOICE(name='AuthenticationChoice', mode=MODE_TYPE)
    _AuthenticationChoice_simple = OCT_STR(name='simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationChoice_sasl = SEQ(name='sasl', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SaslCredentials')))
    AuthenticationChoice._cont = ASN1Dict([
        ('simple', _AuthenticationChoice_simple),
        ('sasl', _AuthenticationChoice_sasl),
        ])
    AuthenticationChoice._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name='SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = OCT_STR(name='mechanism', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _SaslCredentials_credentials = OCT_STR(name='credentials', mode=MODE_TYPE, opt=True)
    SaslCredentials._cont = ASN1Dict([
        ('mechanism', _SaslCredentials_mechanism),
        ('credentials', _SaslCredentials_credentials),
        ])
    SaslCredentials._ext = []
    
    #-----< BindResponse >-----#
    BindResponse = SEQ(name='BindResponse', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _BindResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _BindResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _BindResponse_resultCode._ext = []
    _BindResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _BindResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _BindResponse_serverSaslCreds = OCT_STR(name='serverSaslCreds', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BindResponse._cont = ASN1Dict([
        ('resultCode', _BindResponse_resultCode),
        ('matchedDN', _BindResponse_matchedDN),
        ('diagnosticMessage', _BindResponse_diagnosticMessage),
        ('referral', _BindResponse_referral),
        ('serverSaslCreds', _BindResponse_serverSaslCreds),
        ])
    BindResponse._ext = []
    
    #-----< UnbindRequest >-----#
    UnbindRequest = NULL(name='UnbindRequest', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    
    #-----< SearchRequest >-----#
    SearchRequest = SEQ(name='SearchRequest', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchRequest_baseObject = OCT_STR(name='baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchRequest_scope = ENUM(name='scope', mode=MODE_TYPE)
    _SearchRequest_scope._cont = ASN1Dict([('baseObject', 0), ('singleLevel', 1), ('wholeSubtree', 2)])
    _SearchRequest_scope._ext = []
    _SearchRequest_derefAliases = ENUM(name='derefAliases', mode=MODE_TYPE)
    _SearchRequest_derefAliases._cont = ASN1Dict([('neverDerefAliases', 0), ('derefInSearching', 1), ('derefFindingBaseObj', 2), ('derefAlways', 3)])
    _SearchRequest_derefAliases._ext = []
    _SearchRequest_sizeLimit = INT(name='sizeLimit', mode=MODE_TYPE)
    _SearchRequest_sizeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_timeLimit = INT(name='timeLimit', mode=MODE_TYPE)
    _SearchRequest_timeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_typesOnly = BOOL(name='typesOnly', mode=MODE_TYPE)
    _SearchRequest_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _SearchRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeSelection')))
    SearchRequest._cont = ASN1Dict([
        ('baseObject', _SearchRequest_baseObject),
        ('scope', _SearchRequest_scope),
        ('derefAliases', _SearchRequest_derefAliases),
        ('sizeLimit', _SearchRequest_sizeLimit),
        ('timeLimit', _SearchRequest_timeLimit),
        ('typesOnly', _SearchRequest_typesOnly),
        ('filter', _SearchRequest_filter),
        ('attributes', _SearchRequest_attributes),
        ])
    SearchRequest._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SEQ_OF(name='AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection_selector = OCT_STR(name='selector', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    AttributeSelection._cont = _AttributeSelection_selector
    
    #-----< Filter >-----#
    Filter = CHOICE(name='Filter', mode=MODE_TYPE)
    _Filter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_and__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_and_._cont = __Filter_and__filter
    _Filter_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_or__filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_or_._cont = __Filter_or__filter
    _Filter_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_equalityMatch = SEQ(name='equalityMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_substrings = SEQ(name='substrings', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SubstringFilter')))
    _Filter_greaterOrEqual = SEQ(name='greaterOrEqual', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_lessOrEqual = SEQ(name='lessOrEqual', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_present = OCT_STR(name='present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _Filter_approxMatch = SEQ(name='approxMatch', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_extensibleMatch = SEQ(name='extensibleMatch', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleAssertion')))
    Filter._cont = ASN1Dict([
        ('and', _Filter_and_),
        ('or', _Filter_or_),
        ('not', _Filter_not_),
        ('equalityMatch', _Filter_equalityMatch),
        ('substrings', _Filter_substrings),
        ('greaterOrEqual', _Filter_greaterOrEqual),
        ('lessOrEqual', _Filter_lessOrEqual),
        ('present', _Filter_present),
        ('approxMatch', _Filter_approxMatch),
        ('extensibleMatch', _Filter_extensibleMatch),
        ])
    Filter._ext = []
    
    #-----< SubstringFilter >-----#
    SubstringFilter = SEQ(name='SubstringFilter', mode=MODE_TYPE)
    _SubstringFilter_type = OCT_STR(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _SubstringFilter_substrings = SEQ_OF(name='substrings', mode=MODE_TYPE)
    __SubstringFilter_substrings_substring = CHOICE(name='substring', mode=MODE_TYPE)
    ___SubstringFilter_substrings_substring_initial = OCT_STR(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_any = OCT_STR(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_final = OCT_STR(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    __SubstringFilter_substrings_substring._cont = ASN1Dict([
        ('initial', ___SubstringFilter_substrings_substring_initial),
        ('any', ___SubstringFilter_substrings_substring_any),
        ('final', ___SubstringFilter_substrings_substring_final),
        ])
    __SubstringFilter_substrings_substring._ext = []
    _SubstringFilter_substrings._cont = __SubstringFilter_substrings_substring
    _SubstringFilter_substrings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubstringFilter._cont = ASN1Dict([
        ('type', _SubstringFilter_type),
        ('substrings', _SubstringFilter_substrings),
        ])
    SubstringFilter._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name='MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = OCT_STR(name='matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleId')), opt=True)
    _MatchingRuleAssertion_type = OCT_STR(name='type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')), opt=True)
    _MatchingRuleAssertion_matchValue = OCT_STR(name='matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    _MatchingRuleAssertion_dnAttributes = BOOL(name='dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        ('matchingRule', _MatchingRuleAssertion_matchingRule),
        ('type', _MatchingRuleAssertion_type),
        ('matchValue', _MatchingRuleAssertion_matchValue),
        ('dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< SearchResultEntry >-----#
    SearchResultEntry = SEQ(name='SearchResultEntry', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultEntry_objectName = OCT_STR(name='objectName', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchResultEntry_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttributeList')))
    SearchResultEntry._cont = ASN1Dict([
        ('objectName', _SearchResultEntry_objectName),
        ('attributes', _SearchResultEntry_attributes),
        ])
    SearchResultEntry._ext = []
    
    #-----< PartialAttributeList >-----#
    PartialAttributeList = SEQ_OF(name='PartialAttributeList', mode=MODE_TYPE)
    _PartialAttributeList_partialAttribute = SEQ(name='partialAttribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    PartialAttributeList._cont = _PartialAttributeList_partialAttribute
    
    #-----< SearchResultReference >-----#
    SearchResultReference = SEQ_OF(name='SearchResultReference', mode=MODE_TYPE, tag=(19, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultReference_uri = OCT_STR(name='uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    SearchResultReference._cont = _SearchResultReference_uri
    SearchResultReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SearchResultDone >-----#
    SearchResultDone = SEQ(name='SearchResultDone', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyRequest >-----#
    ModifyRequest = SEQ(name='ModifyRequest', mode=MODE_TYPE, tag=(6, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyRequest_object = OCT_STR(name='object', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyRequest_changes = SEQ_OF(name='changes', mode=MODE_TYPE)
    __ModifyRequest_changes_change = SEQ(name='change', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation = ENUM(name='operation', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation._cont = ASN1Dict([('add', 0), ('delete', 1), ('replace', 2)])
    ___ModifyRequest_changes_change_operation._ext = []
    ___ModifyRequest_changes_change_modification = SEQ(name='modification', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    __ModifyRequest_changes_change._cont = ASN1Dict([
        ('operation', ___ModifyRequest_changes_change_operation),
        ('modification', ___ModifyRequest_changes_change_modification),
        ])
    __ModifyRequest_changes_change._ext = []
    _ModifyRequest_changes._cont = __ModifyRequest_changes_change
    ModifyRequest._cont = ASN1Dict([
        ('object', _ModifyRequest_object),
        ('changes', _ModifyRequest_changes),
        ])
    ModifyRequest._ext = []
    
    #-----< ModifyResponse >-----#
    ModifyResponse = SEQ(name='ModifyResponse', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AddRequest >-----#
    AddRequest = SEQ(name='AddRequest', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    _AddRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _AddRequest_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeList')))
    AddRequest._cont = ASN1Dict([
        ('entry', _AddRequest_entry),
        ('attributes', _AddRequest_attributes),
        ])
    AddRequest._ext = []
    
    #-----< AttributeList >-----#
    AttributeList = SEQ_OF(name='AttributeList', mode=MODE_TYPE)
    _AttributeList_attribute = SEQ(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Attribute')))
    AttributeList._cont = _AttributeList_attribute
    
    #-----< AddResponse >-----#
    AddResponse = SEQ(name='AddResponse', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< DelRequest >-----#
    DelRequest = OCT_STR(name='DelRequest', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    
    #-----< DelResponse >-----#
    DelResponse = SEQ(name='DelResponse', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyDNRequest >-----#
    ModifyDNRequest = SEQ(name='ModifyDNRequest', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyDNRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyDNRequest_newrdn = OCT_STR(name='newrdn', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'RelativeLDAPDN')))
    _ModifyDNRequest_deleteoldrdn = BOOL(name='deleteoldrdn', mode=MODE_TYPE)
    _ModifyDNRequest_newSuperior = OCT_STR(name='newSuperior', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')), opt=True)
    ModifyDNRequest._cont = ASN1Dict([
        ('entry', _ModifyDNRequest_entry),
        ('newrdn', _ModifyDNRequest_newrdn),
        ('deleteoldrdn', _ModifyDNRequest_deleteoldrdn),
        ('newSuperior', _ModifyDNRequest_newSuperior),
        ])
    ModifyDNRequest._ext = []
    
    #-----< ModifyDNResponse >-----#
    ModifyDNResponse = SEQ(name='ModifyDNResponse', mode=MODE_TYPE, tag=(13, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< CompareRequest >-----#
    CompareRequest = SEQ(name='CompareRequest', mode=MODE_TYPE, tag=(14, TAG_APPLICATION, TAG_IMPLICIT))
    _CompareRequest_entry = OCT_STR(name='entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _CompareRequest_ava = SEQ(name='ava', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    CompareRequest._cont = ASN1Dict([
        ('entry', _CompareRequest_entry),
        ('ava', _CompareRequest_ava),
        ])
    CompareRequest._ext = []
    
    #-----< CompareResponse >-----#
    CompareResponse = SEQ(name='CompareResponse', mode=MODE_TYPE, tag=(15, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AbandonRequest >-----#
    AbandonRequest = INT(name='AbandonRequest', mode=MODE_TYPE, tag=(16, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    
    #-----< ExtendedRequest >-----#
    ExtendedRequest = SEQ(name='ExtendedRequest', mode=MODE_TYPE, tag=(23, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedRequest_requestName = OCT_STR(name='requestName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _ExtendedRequest_requestValue = OCT_STR(name='requestValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedRequest._cont = ASN1Dict([
        ('requestName', _ExtendedRequest_requestName),
        ('requestValue', _ExtendedRequest_requestValue),
        ])
    ExtendedRequest._ext = []
    
    #-----< ExtendedResponse >-----#
    ExtendedResponse = SEQ(name='ExtendedResponse', mode=MODE_TYPE, tag=(24, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedResponse_resultCode = ENUM(name='resultCode', mode=MODE_TYPE)
    _ExtendedResponse_resultCode._cont = ASN1Dict([('success', 0), ('operationsError', 1), ('protocolError', 2), ('timeLimitExceeded', 3), ('sizeLimitExceeded', 4), ('compareFalse', 5), ('compareTrue', 6), ('authMethodNotSupported', 7), ('strongerAuthRequired', 8), ('referral', 10), ('adminLimitExceeded', 11), ('unavailableCriticalExtension', 12), ('confidentialityRequired', 13), ('saslBindInProgress', 14), ('noSuchAttribute', 16), ('undefinedAttributeType', 17), ('inappropriateMatching', 18), ('constraintViolation', 19), ('attributeOrValueExists', 20), ('invalidAttributeSyntax', 21), ('noSuchObject', 32), ('aliasProblem', 33), ('invalidDNSyntax', 34), ('aliasDereferencingProblem', 36), ('inappropriateAuthentication', 48), ('invalidCredentials', 49), ('insufficientAccessRights', 50), ('busy', 51), ('unavailable', 52), ('unwillingToPerform', 53), ('loopDetect', 54), ('namingViolation', 64), ('objectClassViolation', 65), ('notAllowedOnNonLeaf', 66), ('notAllowedOnRDN', 67), ('entryAlreadyExists', 68), ('objectClassModsProhibited', 69), ('affectsMultipleDSAs', 71), ('other', 80)])
    _ExtendedResponse_resultCode._ext = []
    _ExtendedResponse_matchedDN = OCT_STR(name='matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ExtendedResponse_diagnosticMessage = OCT_STR(name='diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _ExtendedResponse_referral = SEQ_OF(name='referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _ExtendedResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _ExtendedResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedResponse._cont = ASN1Dict([
        ('resultCode', _ExtendedResponse_resultCode),
        ('matchedDN', _ExtendedResponse_matchedDN),
        ('diagnosticMessage', _ExtendedResponse_diagnosticMessage),
        ('referral', _ExtendedResponse_referral),
        ('responseName', _ExtendedResponse_responseName),
        ('responseValue', _ExtendedResponse_responseValue),
        ])
    ExtendedResponse._ext = []
    
    #-----< IntermediateResponse >-----#
    IntermediateResponse = SEQ(name='IntermediateResponse', mode=MODE_TYPE, tag=(25, TAG_APPLICATION, TAG_IMPLICIT))
    _IntermediateResponse_responseName = OCT_STR(name='responseName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _IntermediateResponse_responseValue = OCT_STR(name='responseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IntermediateResponse._cont = ASN1Dict([
        ('responseName', _IntermediateResponse_responseName),
        ('responseValue', _IntermediateResponse_responseValue),
        ])
    IntermediateResponse._ext = []
    
    _all_ = [
        _LDAPMessage_messageID,
        __LDAPMessage_protocolOp_bindRequest,
        __LDAPMessage_protocolOp_bindResponse,
        __LDAPMessage_protocolOp_unbindRequest,
        __LDAPMessage_protocolOp_searchRequest,
        __LDAPMessage_protocolOp_searchResEntry,
        __LDAPMessage_protocolOp_searchResDone,
        __LDAPMessage_protocolOp_searchResRef,
        __LDAPMessage_protocolOp_modifyRequest,
        __LDAPMessage_protocolOp_modifyResponse,
        __LDAPMessage_protocolOp_addRequest,
        __LDAPMessage_protocolOp_addResponse,
        __LDAPMessage_protocolOp_delRequest,
        __LDAPMessage_protocolOp_delResponse,
        __LDAPMessage_protocolOp_modDNRequest,
        __LDAPMessage_protocolOp_modDNResponse,
        __LDAPMessage_protocolOp_compareRequest,
        __LDAPMessage_protocolOp_compareResponse,
        __LDAPMessage_protocolOp_abandonRequest,
        __LDAPMessage_protocolOp_extendedReq,
        __LDAPMessage_protocolOp_extendedResp,
        __LDAPMessage_protocolOp_intermediateResponse,
        _LDAPMessage_protocolOp,
        _LDAPMessage_controls,
        LDAPMessage,
        MessageID,
        maxInt,
        LDAPString,
        LDAPOID,
        LDAPDN,
        RelativeLDAPDN,
        AttributeDescription,
        AttributeValue,
        _AttributeValueAssertion_attributeDesc,
        _AttributeValueAssertion_assertionValue,
        AttributeValueAssertion,
        AssertionValue,
        _PartialAttribute_type,
        __PartialAttribute_vals_value,
        _PartialAttribute_vals,
        PartialAttribute,
        Attribute,
        MatchingRuleId,
        _LDAPResult_resultCode,
        _LDAPResult_matchedDN,
        _LDAPResult_diagnosticMessage,
        _LDAPResult_referral,
        LDAPResult,
        _Referral_uri,
        Referral,
        URI,
        _Controls_control,
        Controls,
        _Control_controlType,
        _Control_criticality,
        _Control_controlValue,
        Control,
        _BindRequest_version,
        _BindRequest_name,
        _BindRequest_authentication,
        BindRequest,
        _AuthenticationChoice_simple,
        _AuthenticationChoice_sasl,
        AuthenticationChoice,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        SaslCredentials,
        _BindResponse_resultCode,
        _BindResponse_matchedDN,
        _BindResponse_diagnosticMessage,
        _BindResponse_referral,
        _BindResponse_serverSaslCreds,
        BindResponse,
        UnbindRequest,
        _SearchRequest_baseObject,
        _SearchRequest_scope,
        _SearchRequest_derefAliases,
        _SearchRequest_sizeLimit,
        _SearchRequest_timeLimit,
        _SearchRequest_typesOnly,
        _SearchRequest_filter,
        _SearchRequest_attributes,
        SearchRequest,
        _AttributeSelection_selector,
        AttributeSelection,
        __Filter_and__filter,
        _Filter_and_,
        __Filter_or__filter,
        _Filter_or_,
        _Filter_not_,
        _Filter_equalityMatch,
        _Filter_substrings,
        _Filter_greaterOrEqual,
        _Filter_lessOrEqual,
        _Filter_present,
        _Filter_approxMatch,
        _Filter_extensibleMatch,
        Filter,
        _SubstringFilter_type,
        ___SubstringFilter_substrings_substring_initial,
        ___SubstringFilter_substrings_substring_any,
        ___SubstringFilter_substrings_substring_final,
        __SubstringFilter_substrings_substring,
        _SubstringFilter_substrings,
        SubstringFilter,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        _SearchResultEntry_objectName,
        _SearchResultEntry_attributes,
        SearchResultEntry,
        _PartialAttributeList_partialAttribute,
        PartialAttributeList,
        _SearchResultReference_uri,
        SearchResultReference,
        SearchResultDone,
        _ModifyRequest_object,
        ___ModifyRequest_changes_change_operation,
        ___ModifyRequest_changes_change_modification,
        __ModifyRequest_changes_change,
        _ModifyRequest_changes,
        ModifyRequest,
        ModifyResponse,
        _AddRequest_entry,
        _AddRequest_attributes,
        AddRequest,
        _AttributeList_attribute,
        AttributeList,
        AddResponse,
        DelRequest,
        DelResponse,
        _ModifyDNRequest_entry,
        _ModifyDNRequest_newrdn,
        _ModifyDNRequest_deleteoldrdn,
        _ModifyDNRequest_newSuperior,
        ModifyDNRequest,
        ModifyDNResponse,
        _CompareRequest_entry,
        _CompareRequest_ava,
        CompareRequest,
        CompareResponse,
        AbandonRequest,
        _ExtendedRequest_requestName,
        _ExtendedRequest_requestValue,
        ExtendedRequest,
        _ExtendedResponse_resultCode,
        _ExtendedResponse_matchedDN,
        _ExtendedResponse_diagnosticMessage,
        _ExtendedResponse_referral,
        _ExtendedResponse_responseName,
        _ExtendedResponse_responseValue,
        ExtendedResponse,
        _IntermediateResponse_responseName,
        _IntermediateResponse_responseValue,
        IntermediateResponse,
    ]

class MTSAbstractService:

    _name_  = 'MTSAbstractService'
    _oid_   = [2, 6, 3, 0, 1, 1]
    
    _obj_ = [
        'G3FacsimileNonBasicParameters',
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'ExtensionAttribute',
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttributeTable',
        'common-name',
        'CommonName',
        'teletex-common-name',
        'TeletexCommonName',
        'universal-common-name',
        'UniversalCommonName',
        'teletex-organization-name',
        'TeletexOrganizationName',
        'universal-organization-name',
        'UniversalOrganizationName',
        'teletex-personal-name',
        'TeletexPersonalName',
        'universal-personal-name',
        'UniversalPersonalName',
        'teletex-organizational-unit-names',
        'TeletexOrganizationalUnitNames',
        'TeletexOrganizationalUnitName',
        'universal-organizational-unit-names',
        'UniversalOrganizationalUnitNames',
        'UniversalOrganizationalUnitName',
        'UniversalOrBMPString',
        'pds-name',
        'PDSName',
        'physical-delivery-country-name',
        'PhysicalDeliveryCountryName',
        'postal-code',
        'PostalCode',
        'physical-delivery-office-name',
        'PhysicalDeliveryOfficeName',
        'universal-physical-delivery-office-name',
        'UniversalPhysicalDeliveryOfficeName',
        'physical-delivery-office-number',
        'PhysicalDeliveryOfficeNumber',
        'universal-physical-delivery-office-number',
        'UniversalPhysicalDeliveryOfficeNumber',
        'extension-OR-address-components',
        'ExtensionORAddressComponents',
        'universal-extension-OR-address-components',
        'UniversalExtensionORAddressComponents',
        'physical-delivery-personal-name',
        'PhysicalDeliveryPersonalName',
        'universal-physical-delivery-personal-name',
        'UniversalPhysicalDeliveryPersonalName',
        'physical-delivery-organization-name',
        'PhysicalDeliveryOrganizationName',
        'universal-physical-delivery-organization-name',
        'UniversalPhysicalDeliveryOrganizationName',
        'extension-physical-delivery-address-components',
        'ExtensionPhysicalDeliveryAddressComponents',
        'universal-extension-physical-delivery-address-components',
        'UniversalExtensionPhysicalDeliveryAddressComponents',
        'unformatted-postal-address',
        'UnformattedPostalAddress',
        'universal-unformatted-postal-address',
        'UniversalUnformattedPostalAddress',
        'street-address',
        'StreetAddress',
        'universal-street-address',
        'UniversalStreetAddress',
        'post-office-box-address',
        'PostOfficeBoxAddress',
        'universal-post-office-box-address',
        'UniversalPostOfficeBoxAddress',
        'poste-restante-address',
        'PosteRestanteAddress',
        'universal-poste-restante-address',
        'UniversalPosteRestanteAddress',
        'unique-postal-name',
        'UniquePostalName',
        'universal-unique-postal-name',
        'UniversalUniquePostalName',
        'local-postal-attributes',
        'LocalPostalAttributes',
        'universal-local-postal-attributes',
        'UniversalLocalPostalAttributes',
        'PDSParameter',
        'UniversalPDSParameter',
        'extended-network-address',
        'ExtendedNetworkAddress',
        'terminal-type',
        'TerminalType',
        'teletex-domain-defined-attributes',
        'TeletexDomainDefinedAttributes',
        'TeletexDomainDefinedAttribute',
        'universal-domain-defined-attributes',
        'UniversalDomainDefinedAttributes',
        'UniversalDomainDefinedAttribute',
        'ub-integer-options',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-unformatted-address-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-pds-name-length',
        'ub-universal-surname-length',
        'ub-universal-given-name-length',
        'ub-universal-initials-length',
        'ub-universal-generation-qualifier-length',
        'ub-common-name-length',
        'ub-extension-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-defined-attributes',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-generation-qualifier-length',
        'ub-initials-length',
        'ub-given-name-length',
        'ub-surname-length',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-terminal-id-length',
        'ub-x121-address-length',
        'ub-domain-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        ]
    _type_ = [
        'G3FacsimileNonBasicParameters',
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'ExtensionAttribute',
        'EXTENSION-ATTRIBUTE',
        'CommonName',
        'TeletexCommonName',
        'UniversalCommonName',
        'TeletexOrganizationName',
        'UniversalOrganizationName',
        'TeletexPersonalName',
        'UniversalPersonalName',
        'TeletexOrganizationalUnitNames',
        'TeletexOrganizationalUnitName',
        'UniversalOrganizationalUnitNames',
        'UniversalOrganizationalUnitName',
        'UniversalOrBMPString',
        'PDSName',
        'PhysicalDeliveryCountryName',
        'PostalCode',
        'PhysicalDeliveryOfficeName',
        'UniversalPhysicalDeliveryOfficeName',
        'PhysicalDeliveryOfficeNumber',
        'UniversalPhysicalDeliveryOfficeNumber',
        'ExtensionORAddressComponents',
        'UniversalExtensionORAddressComponents',
        'PhysicalDeliveryPersonalName',
        'UniversalPhysicalDeliveryPersonalName',
        'PhysicalDeliveryOrganizationName',
        'UniversalPhysicalDeliveryOrganizationName',
        'ExtensionPhysicalDeliveryAddressComponents',
        'UniversalExtensionPhysicalDeliveryAddressComponents',
        'UnformattedPostalAddress',
        'UniversalUnformattedPostalAddress',
        'StreetAddress',
        'UniversalStreetAddress',
        'PostOfficeBoxAddress',
        'UniversalPostOfficeBoxAddress',
        'PosteRestanteAddress',
        'UniversalPosteRestanteAddress',
        'UniquePostalName',
        'UniversalUniquePostalName',
        'LocalPostalAttributes',
        'UniversalLocalPostalAttributes',
        'PDSParameter',
        'UniversalPDSParameter',
        'ExtendedNetworkAddress',
        'TerminalType',
        'TeletexDomainDefinedAttributes',
        'TeletexDomainDefinedAttribute',
        'UniversalDomainDefinedAttributes',
        'UniversalDomainDefinedAttribute',
        ]
    _set_ = [
        'ExtensionAttributeTable',
        ]
    _val_ = [
        'common-name',
        'teletex-common-name',
        'universal-common-name',
        'teletex-organization-name',
        'universal-organization-name',
        'teletex-personal-name',
        'universal-personal-name',
        'teletex-organizational-unit-names',
        'universal-organizational-unit-names',
        'pds-name',
        'physical-delivery-country-name',
        'postal-code',
        'physical-delivery-office-name',
        'universal-physical-delivery-office-name',
        'physical-delivery-office-number',
        'universal-physical-delivery-office-number',
        'extension-OR-address-components',
        'universal-extension-OR-address-components',
        'physical-delivery-personal-name',
        'universal-physical-delivery-personal-name',
        'physical-delivery-organization-name',
        'universal-physical-delivery-organization-name',
        'extension-physical-delivery-address-components',
        'universal-extension-physical-delivery-address-components',
        'unformatted-postal-address',
        'universal-unformatted-postal-address',
        'street-address',
        'universal-street-address',
        'post-office-box-address',
        'universal-post-office-box-address',
        'poste-restante-address',
        'universal-poste-restante-address',
        'unique-postal-name',
        'universal-unique-postal-name',
        'local-postal-attributes',
        'universal-local-postal-attributes',
        'extended-network-address',
        'terminal-type',
        'teletex-domain-defined-attributes',
        'universal-domain-defined-attributes',
        'ub-integer-options',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-unformatted-address-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-pds-name-length',
        'ub-universal-surname-length',
        'ub-universal-given-name-length',
        'ub-universal-initials-length',
        'ub-universal-generation-qualifier-length',
        'ub-common-name-length',
        'ub-extension-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-defined-attributes',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-generation-qualifier-length',
        'ub-initials-length',
        'ub-given-name-length',
        'ub-surname-length',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-terminal-id-length',
        'ub-x121-address-length',
        'ub-domain-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        ]
    _class_ = [
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttributeTable',
        'common-name',
        'teletex-common-name',
        'universal-common-name',
        'teletex-organization-name',
        'universal-organization-name',
        'teletex-personal-name',
        'universal-personal-name',
        'teletex-organizational-unit-names',
        'universal-organizational-unit-names',
        'pds-name',
        'physical-delivery-country-name',
        'postal-code',
        'physical-delivery-office-name',
        'universal-physical-delivery-office-name',
        'physical-delivery-office-number',
        'universal-physical-delivery-office-number',
        'extension-OR-address-components',
        'universal-extension-OR-address-components',
        'physical-delivery-personal-name',
        'universal-physical-delivery-personal-name',
        'physical-delivery-organization-name',
        'universal-physical-delivery-organization-name',
        'extension-physical-delivery-address-components',
        'universal-extension-physical-delivery-address-components',
        'unformatted-postal-address',
        'universal-unformatted-postal-address',
        'street-address',
        'universal-street-address',
        'post-office-box-address',
        'universal-post-office-box-address',
        'poste-restante-address',
        'universal-poste-restante-address',
        'unique-postal-name',
        'universal-unique-postal-name',
        'local-postal-attributes',
        'universal-local-postal-attributes',
        'extended-network-address',
        'terminal-type',
        'teletex-domain-defined-attributes',
        'universal-domain-defined-attributes',
        ]
    _param_ = [
        'UniversalOrBMPString',
        ]
    
    #-----< G3FacsimileNonBasicParameters >-----#
    G3FacsimileNonBasicParameters = BIT_STR(name='G3FacsimileNonBasicParameters', mode=MODE_TYPE)
    G3FacsimileNonBasicParameters._cont = ASN1Dict([('two-dimensional', 8), ('fine-resolution', 9), ('unlimited-length', 20), ('b4-length', 21), ('a3-width', 22), ('b4-width', 23), ('t6-coding', 25), ('uncompressed', 30), ('width-middle-864-of-1728', 37), ('width-middle-1216-of-1728', 38), ('resolution-type', 44), ('resolution-400x400', 45), ('resolution-300x300', 46), ('resolution-8x15', 47), ('edi', 49), ('dtm', 50), ('bft', 51), ('mixed-mode', 58), ('character-mode', 60), ('twelve-bits', 65), ('preferred-huffmann', 66), ('full-colour', 67), ('jpeg', 68), ('processable-mode-26', 71)])
    
    #-----< ORAddress >-----#
    ORAddress = SEQ(name='ORAddress', mode=MODE_TYPE)
    _ORAddress_built_in_standard_attributes = SEQ(name='built-in-standard-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'BuiltInStandardAttributes')))
    _ORAddress_built_in_domain_defined_attributes = SEQ_OF(name='built-in-domain-defined-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'BuiltInDomainDefinedAttributes')), opt=True)
    _ORAddress_extension_attributes = SET_OF(name='extension-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionAttributes')), opt=True)
    ORAddress._cont = ASN1Dict([
        ('built-in-standard-attributes', _ORAddress_built_in_standard_attributes),
        ('built-in-domain-defined-attributes', _ORAddress_built_in_domain_defined_attributes),
        ('extension-attributes', _ORAddress_extension_attributes),
        ])
    ORAddress._ext = None
    
    #-----< BuiltInStandardAttributes >-----#
    BuiltInStandardAttributes = SEQ(name='BuiltInStandardAttributes', mode=MODE_TYPE)
    _BuiltInStandardAttributes_country_name = CHOICE(name='country-name', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'CountryName')), opt=True)
    _BuiltInStandardAttributes_administration_domain_name = CHOICE(name='administration-domain-name', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'AdministrationDomainName')), opt=True)
    _BuiltInStandardAttributes_network_address = STR_NUM(name='network-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'NetworkAddress')), opt=True)
    _BuiltInStandardAttributes_terminal_identifier = STR_PRINT(name='terminal-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'TerminalIdentifier')), opt=True)
    _BuiltInStandardAttributes_private_domain_name = CHOICE(name='private-domain-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'PrivateDomainName')), opt=True)
    _BuiltInStandardAttributes_organization_name = STR_PRINT(name='organization-name', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'OrganizationName')), opt=True)
    _BuiltInStandardAttributes_numeric_user_identifier = STR_NUM(name='numeric-user-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'NumericUserIdentifier')), opt=True)
    _BuiltInStandardAttributes_personal_name = SET(name='personal-name', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'PersonalName')), opt=True)
    _BuiltInStandardAttributes_organizational_unit_names = SEQ_OF(name='organizational-unit-names', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'OrganizationalUnitNames')), opt=True)
    BuiltInStandardAttributes._cont = ASN1Dict([
        ('country-name', _BuiltInStandardAttributes_country_name),
        ('administration-domain-name', _BuiltInStandardAttributes_administration_domain_name),
        ('network-address', _BuiltInStandardAttributes_network_address),
        ('terminal-identifier', _BuiltInStandardAttributes_terminal_identifier),
        ('private-domain-name', _BuiltInStandardAttributes_private_domain_name),
        ('organization-name', _BuiltInStandardAttributes_organization_name),
        ('numeric-user-identifier', _BuiltInStandardAttributes_numeric_user_identifier),
        ('personal-name', _BuiltInStandardAttributes_personal_name),
        ('organizational-unit-names', _BuiltInStandardAttributes_organizational_unit_names),
        ])
    BuiltInStandardAttributes._ext = None
    
    #-----< CountryName >-----#
    CountryName = CHOICE(name='CountryName', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _CountryName_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    _CountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CountryName_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    _CountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    CountryName._cont = ASN1Dict([
        ('x121-dcc-code', _CountryName_x121_dcc_code),
        ('iso-3166-alpha2-code', _CountryName_iso_3166_alpha2_code),
        ])
    CountryName._ext = None
    
    #-----< AdministrationDomainName >-----#
    AdministrationDomainName = CHOICE(name='AdministrationDomainName', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _AdministrationDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _AdministrationDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    _AdministrationDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _AdministrationDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    AdministrationDomainName._cont = ASN1Dict([
        ('numeric', _AdministrationDomainName_numeric),
        ('printable', _AdministrationDomainName_printable),
        ])
    AdministrationDomainName._ext = None
    
    #-----< NetworkAddress >-----#
    NetworkAddress = STR_NUM(name='NetworkAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'X121Address')))
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name='X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TerminalIdentifier >-----#
    TerminalIdentifier = STR_PRINT(name='TerminalIdentifier', mode=MODE_TYPE)
    TerminalIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< PrivateDomainName >-----#
    PrivateDomainName = CHOICE(name='PrivateDomainName', mode=MODE_TYPE)
    _PrivateDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _PrivateDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PrivateDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _PrivateDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PrivateDomainName._cont = ASN1Dict([
        ('numeric', _PrivateDomainName_numeric),
        ('printable', _PrivateDomainName_printable),
        ])
    PrivateDomainName._ext = None
    
    #-----< OrganizationName >-----#
    OrganizationName = STR_PRINT(name='OrganizationName', mode=MODE_TYPE)
    OrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< NumericUserIdentifier >-----#
    NumericUserIdentifier = STR_NUM(name='NumericUserIdentifier', mode=MODE_TYPE)
    NumericUserIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PersonalName >-----#
    PersonalName = SET(name='PersonalName', mode=MODE_TYPE)
    _PersonalName_surname = STR_PRINT(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _PersonalName_given_name = STR_PRINT(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PersonalName_initials = STR_PRINT(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _PersonalName_generation_qualifier = STR_PRINT(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    PersonalName._cont = ASN1Dict([
        ('surname', _PersonalName_surname),
        ('given-name', _PersonalName_given_name),
        ('initials', _PersonalName_initials),
        ('generation-qualifier', _PersonalName_generation_qualifier),
        ])
    PersonalName._ext = None
    
    #-----< OrganizationalUnitNames >-----#
    OrganizationalUnitNames = SEQ_OF(name='OrganizationalUnitNames', mode=MODE_TYPE)
    _OrganizationalUnitNames__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'OrganizationalUnitName')))
    OrganizationalUnitNames._cont = _OrganizationalUnitNames__item_
    OrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< OrganizationalUnitName >-----#
    OrganizationalUnitName = STR_PRINT(name='OrganizationalUnitName', mode=MODE_TYPE)
    OrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttributes >-----#
    BuiltInDomainDefinedAttributes = SEQ_OF(name='BuiltInDomainDefinedAttributes', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'BuiltInDomainDefinedAttribute')))
    BuiltInDomainDefinedAttributes._cont = _BuiltInDomainDefinedAttributes__item_
    BuiltInDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttribute >-----#
    BuiltInDomainDefinedAttribute = SEQ(name='BuiltInDomainDefinedAttribute', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type = STR_PRINT(name='type', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _BuiltInDomainDefinedAttribute_value = STR_PRINT(name='value', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    BuiltInDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _BuiltInDomainDefinedAttribute_type),
        ('value', _BuiltInDomainDefinedAttribute_value),
        ])
    BuiltInDomainDefinedAttribute._ext = None
    
    #-----< ExtensionAttributes >-----#
    ExtensionAttributes = SET_OF(name='ExtensionAttributes', mode=MODE_TYPE)
    _ExtensionAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionAttribute')))
    ExtensionAttributes._cont = _ExtensionAttributes__item_
    ExtensionAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ExtensionAttribute >-----#
    ExtensionAttribute = SEQ(name='ExtensionAttribute', mode=MODE_TYPE)
    _ExtensionAttribute_extension_attribute_type = INT(name='extension-attribute-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('MTSAbstractService', 'EXTENSION-ATTRIBUTE'), ['id']))
    __ExtensionAttribute_extension_attribute_type_tab = CLASS(name='_tab_EXTENSION-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'CommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryCountryName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostalCode')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'StreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalStreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'LocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalLocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtendedNetworkAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TerminalType')))
    __ExtensionAttribute_extension_attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0), ('id', 1)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1), ('id', 2)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2), ('id', 24)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3), ('id', 3)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4), ('id', 25)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5), ('id', 4)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6), ('id', 26)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7), ('id', 5)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8), ('id', 27)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9), ('id', 6)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10), ('id', 28)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11), ('id', 7)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12), ('id', 8)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13), ('id', 9)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14), ('id', 10)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15), ('id', 29)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16), ('id', 11)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17), ('id', 30)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18), ('id', 12)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19), ('id', 31)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20), ('id', 13)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21), ('id', 32)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22), ('id', 14)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23), ('id', 33)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24), ('id', 15)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25), ('id', 34)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26), ('id', 16)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27), ('id', 35)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28), ('id', 17)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29), ('id', 36)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30), ('id', 18)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31), ('id', 37)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32), ('id', 19)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33), ('id', 38)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34), ('id', 20)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35), ('id', 39)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36), ('id', 21)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37), ('id', 40)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38), ('id', 22)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39), ('id', 23)])], rr=[], ev=None, er=[])
    _ExtensionAttribute_extension_attribute_type._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_type._const_tab_at = None
    _ExtensionAttribute_extension_attribute_type._const_tab_id = 'id'
    _ExtensionAttribute_extension_attribute_value = OPEN(name='extension-attribute-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('MTSAbstractService', 'EXTENSION-ATTRIBUTE'), ['Type']))
    _ExtensionAttribute_extension_attribute_value._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_value._const_tab_at = ('..', 'extension-attribute-type')
    _ExtensionAttribute_extension_attribute_value._const_tab_id = 'Type'
    ExtensionAttribute._cont = ASN1Dict([
        ('extension-attribute-type', _ExtensionAttribute_extension_attribute_type),
        ('extension-attribute-value', _ExtensionAttribute_extension_attribute_value),
        ])
    ExtensionAttribute._ext = None
    
    #-----< EXTENSION-ATTRIBUTE >-----#
    EXTENSION_ATTRIBUTE = CLASS(name='EXTENSION-ATTRIBUTE', mode=MODE_TYPE)
    _EXTENSION_ATTRIBUTE_id = INT(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ATTRIBUTE_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _EXTENSION_ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE)
    EXTENSION_ATTRIBUTE._cont = ASN1Dict([
        ('id', _EXTENSION_ATTRIBUTE_id),
        ('Type', _EXTENSION_ATTRIBUTE_Type),
        ])
    
    #-----< ExtensionAttributeTable >-----#
    ExtensionAttributeTable = CLASS(name='ExtensionAttributeTable', mode=MODE_SET, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _ExtensionAttributeTable_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'CommonName')))
    _ExtensionAttributeTable_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexCommonName')))
    _ExtensionAttributeTable_val_Type_2 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalCommonName')))
    _ExtensionAttributeTable_val_Type_3 = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationName')))
    _ExtensionAttributeTable_val_Type_4 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationName')))
    _ExtensionAttributeTable_val_Type_5 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexPersonalName')))
    _ExtensionAttributeTable_val_Type_6 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPersonalName')))
    _ExtensionAttributeTable_val_Type_7 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_9 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_10 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSName')))
    _ExtensionAttributeTable_val_Type_12 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryCountryName')))
    _ExtensionAttributeTable_val_Type_13 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostalCode')))
    _ExtensionAttributeTable_val_Type_14 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_20 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_21 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_22 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_23 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_24 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_25 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_26 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_27 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_28 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'StreetAddress')))
    _ExtensionAttributeTable_val_Type_29 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalStreetAddress')))
    _ExtensionAttributeTable_val_Type_30 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_31 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_32 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_33 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_34 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniquePostalName')))
    _ExtensionAttributeTable_val_Type_35 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUniquePostalName')))
    _ExtensionAttributeTable_val_Type_36 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'LocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_37 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalLocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_38 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtendedNetworkAddress')))
    _ExtensionAttributeTable_val_Type_39 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TerminalType')))
    ExtensionAttributeTable._val = ASN1Set(rv=[dict([('Type', _ExtensionAttributeTable_val_Type_0), ('id', 1)]), dict([('Type', _ExtensionAttributeTable_val_Type_1), ('id', 2)]), dict([('Type', _ExtensionAttributeTable_val_Type_2), ('id', 24)]), dict([('Type', _ExtensionAttributeTable_val_Type_3), ('id', 3)]), dict([('Type', _ExtensionAttributeTable_val_Type_4), ('id', 25)]), dict([('Type', _ExtensionAttributeTable_val_Type_5), ('id', 4)]), dict([('Type', _ExtensionAttributeTable_val_Type_6), ('id', 26)]), dict([('Type', _ExtensionAttributeTable_val_Type_7), ('id', 5)]), dict([('Type', _ExtensionAttributeTable_val_Type_8), ('id', 27)]), dict([('Type', _ExtensionAttributeTable_val_Type_9), ('id', 6)]), dict([('Type', _ExtensionAttributeTable_val_Type_10), ('id', 28)]), dict([('Type', _ExtensionAttributeTable_val_Type_11), ('id', 7)]), dict([('Type', _ExtensionAttributeTable_val_Type_12), ('id', 8)]), dict([('Type', _ExtensionAttributeTable_val_Type_13), ('id', 9)]), dict([('Type', _ExtensionAttributeTable_val_Type_14), ('id', 10)]), dict([('Type', _ExtensionAttributeTable_val_Type_15), ('id', 29)]), dict([('Type', _ExtensionAttributeTable_val_Type_16), ('id', 11)]), dict([('Type', _ExtensionAttributeTable_val_Type_17), ('id', 30)]), dict([('Type', _ExtensionAttributeTable_val_Type_18), ('id', 12)]), dict([('Type', _ExtensionAttributeTable_val_Type_19), ('id', 31)]), dict([('Type', _ExtensionAttributeTable_val_Type_20), ('id', 13)]), dict([('Type', _ExtensionAttributeTable_val_Type_21), ('id', 32)]), dict([('Type', _ExtensionAttributeTable_val_Type_22), ('id', 14)]), dict([('Type', _ExtensionAttributeTable_val_Type_23), ('id', 33)]), dict([('Type', _ExtensionAttributeTable_val_Type_24), ('id', 15)]), dict([('Type', _ExtensionAttributeTable_val_Type_25), ('id', 34)]), dict([('Type', _ExtensionAttributeTable_val_Type_26), ('id', 16)]), dict([('Type', _ExtensionAttributeTable_val_Type_27), ('id', 35)]), dict([('Type', _ExtensionAttributeTable_val_Type_28), ('id', 17)]), dict([('Type', _ExtensionAttributeTable_val_Type_29), ('id', 36)]), dict([('Type', _ExtensionAttributeTable_val_Type_30), ('id', 18)]), dict([('Type', _ExtensionAttributeTable_val_Type_31), ('id', 37)]), dict([('Type', _ExtensionAttributeTable_val_Type_32), ('id', 19)]), dict([('Type', _ExtensionAttributeTable_val_Type_33), ('id', 38)]), dict([('Type', _ExtensionAttributeTable_val_Type_34), ('id', 20)]), dict([('Type', _ExtensionAttributeTable_val_Type_35), ('id', 39)]), dict([('Type', _ExtensionAttributeTable_val_Type_36), ('id', 21)]), dict([('Type', _ExtensionAttributeTable_val_Type_37), ('id', 40)]), dict([('Type', _ExtensionAttributeTable_val_Type_38), ('id', 22)]), dict([('Type', _ExtensionAttributeTable_val_Type_39), ('id', 23)])], rr=[], ev=None, er=[])
    
    #-----< common-name >-----#
    common_name = CLASS(name='common-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _common_name_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'CommonName')))
    common_name._val = dict([('Type', _common_name_val_Type), ('id', 1)])
    
    #-----< CommonName >-----#
    CommonName = STR_PRINT(name='CommonName', mode=MODE_TYPE)
    CommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< teletex-common-name >-----#
    teletex_common_name = CLASS(name='teletex-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _teletex_common_name_val_Type = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexCommonName')))
    teletex_common_name._val = dict([('Type', _teletex_common_name_val_Type), ('id', 2)])
    
    #-----< TeletexCommonName >-----#
    TeletexCommonName = STR_TELE(name='TeletexCommonName', mode=MODE_TYPE)
    TeletexCommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-common-name >-----#
    universal_common_name = CLASS(name='universal-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_common_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalCommonName')))
    universal_common_name._val = dict([('Type', _universal_common_name_val_Type), ('id', 24)])
    
    #-----< UniversalCommonName >-----#
    UniversalCommonName = SET(name='UniversalCommonName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    _UniversalCommonName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalCommonName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalCommonName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalCommonName_character_encoding_two_octets),
        ('four-octets', __UniversalCommonName_character_encoding_four_octets),
        ])
    _UniversalCommonName_character_encoding._ext = None
    _UniversalCommonName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalCommonName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalCommonName._cont = ASN1Dict([
        ('character-encoding', _UniversalCommonName_character_encoding),
        ('iso-639-language-code', _UniversalCommonName_iso_639_language_code),
        ])
    UniversalCommonName._ext = None
    
    #-----< teletex-organization-name >-----#
    teletex_organization_name = CLASS(name='teletex-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _teletex_organization_name_val_Type = STR_TELE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationName')))
    teletex_organization_name._val = dict([('Type', _teletex_organization_name_val_Type), ('id', 3)])
    
    #-----< TeletexOrganizationName >-----#
    TeletexOrganizationName = STR_TELE(name='TeletexOrganizationName', mode=MODE_TYPE)
    TeletexOrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-organization-name >-----#
    universal_organization_name = CLASS(name='universal-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationName')))
    universal_organization_name._val = dict([('Type', _universal_organization_name_val_Type), ('id', 25)])
    
    #-----< UniversalOrganizationName >-----#
    UniversalOrganizationName = SET(name='UniversalOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    _UniversalOrganizationName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalOrganizationName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalOrganizationName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalOrganizationName_character_encoding_two_octets),
        ('four-octets', __UniversalOrganizationName_character_encoding_four_octets),
        ])
    _UniversalOrganizationName_character_encoding._ext = None
    _UniversalOrganizationName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationName._cont = ASN1Dict([
        ('character-encoding', _UniversalOrganizationName_character_encoding),
        ('iso-639-language-code', _UniversalOrganizationName_iso_639_language_code),
        ])
    UniversalOrganizationName._ext = None
    
    #-----< teletex-personal-name >-----#
    teletex_personal_name = CLASS(name='teletex-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _teletex_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexPersonalName')))
    teletex_personal_name._val = dict([('Type', _teletex_personal_name_val_Type), ('id', 4)])
    
    #-----< TeletexPersonalName >-----#
    TeletexPersonalName = SET(name='TeletexPersonalName', mode=MODE_TYPE)
    _TeletexPersonalName_surname = STR_TELE(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TeletexPersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _TeletexPersonalName_given_name = STR_TELE(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TeletexPersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _TeletexPersonalName_initials = STR_TELE(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TeletexPersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _TeletexPersonalName_generation_qualifier = STR_TELE(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TeletexPersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    TeletexPersonalName._cont = ASN1Dict([
        ('surname', _TeletexPersonalName_surname),
        ('given-name', _TeletexPersonalName_given_name),
        ('initials', _TeletexPersonalName_initials),
        ('generation-qualifier', _TeletexPersonalName_generation_qualifier),
        ])
    TeletexPersonalName._ext = None
    
    #-----< universal-personal-name >-----#
    universal_personal_name = CLASS(name='universal-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPersonalName')))
    universal_personal_name._val = dict([('Type', _universal_personal_name_val_Type), ('id', 26)])
    
    #-----< UniversalPersonalName >-----#
    UniversalPersonalName = SET(name='UniversalPersonalName', mode=MODE_TYPE)
    _UniversalPersonalName_surname = SET(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    __UniversalPersonalName_surname_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___UniversalPersonalName_surname_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalPersonalName_surname_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_surname_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_surname_character_encoding_four_octets),
        ])
    __UniversalPersonalName_surname_character_encoding._ext = None
    __UniversalPersonalName_surname_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_surname_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_surname._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_surname_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_surname_iso_639_language_code),
        ])
    _UniversalPersonalName_surname._ext = None
    _UniversalPersonalName_given_name = SET(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_given_name_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    ___UniversalPersonalName_given_name_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __UniversalPersonalName_given_name_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_given_name_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_given_name_character_encoding_four_octets),
        ])
    __UniversalPersonalName_given_name_character_encoding._ext = None
    __UniversalPersonalName_given_name_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_given_name_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_given_name._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_given_name_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_given_name_iso_639_language_code),
        ])
    _UniversalPersonalName_given_name._ext = None
    _UniversalPersonalName_initials = SET(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_initials_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_initials_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_initials_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_initials_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_initials_character_encoding_four_octets),
        ])
    __UniversalPersonalName_initials_character_encoding._ext = None
    __UniversalPersonalName_initials_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_initials_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_initials._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_initials_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_initials_iso_639_language_code),
        ])
    _UniversalPersonalName_initials._ext = None
    _UniversalPersonalName_generation_qualifier = SET(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_generation_qualifier_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_generation_qualifier_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets),
        ('four-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets),
        ])
    __UniversalPersonalName_generation_qualifier_character_encoding._ext = None
    __UniversalPersonalName_generation_qualifier_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_generation_qualifier_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_generation_qualifier._cont = ASN1Dict([
        ('character-encoding', __UniversalPersonalName_generation_qualifier_character_encoding),
        ('iso-639-language-code', __UniversalPersonalName_generation_qualifier_iso_639_language_code),
        ])
    _UniversalPersonalName_generation_qualifier._ext = None
    UniversalPersonalName._cont = ASN1Dict([
        ('surname', _UniversalPersonalName_surname),
        ('given-name', _UniversalPersonalName_given_name),
        ('initials', _UniversalPersonalName_initials),
        ('generation-qualifier', _UniversalPersonalName_generation_qualifier),
        ])
    UniversalPersonalName._ext = None
    
    #-----< teletex-organizational-unit-names >-----#
    teletex_organizational_unit_names = CLASS(name='teletex-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _teletex_organizational_unit_names_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationalUnitNames')))
    teletex_organizational_unit_names._val = dict([('Type', _teletex_organizational_unit_names_val_Type), ('id', 5)])
    
    #-----< TeletexOrganizationalUnitNames >-----#
    TeletexOrganizationalUnitNames = SEQ_OF(name='TeletexOrganizationalUnitNames', mode=MODE_TYPE)
    _TeletexOrganizationalUnitNames__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexOrganizationalUnitName')))
    TeletexOrganizationalUnitNames._cont = _TeletexOrganizationalUnitNames__item_
    TeletexOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexOrganizationalUnitName >-----#
    TeletexOrganizationalUnitName = STR_TELE(name='TeletexOrganizationalUnitName', mode=MODE_TYPE)
    TeletexOrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< universal-organizational-unit-names >-----#
    universal_organizational_unit_names = CLASS(name='universal-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_organizational_unit_names_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationalUnitNames')))
    universal_organizational_unit_names._val = dict([('Type', _universal_organizational_unit_names_val_Type), ('id', 27)])
    
    #-----< UniversalOrganizationalUnitNames >-----#
    UniversalOrganizationalUnitNames = SEQ_OF(name='UniversalOrganizationalUnitNames', mode=MODE_TYPE)
    _UniversalOrganizationalUnitNames__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrganizationalUnitName')))
    UniversalOrganizationalUnitNames._cont = _UniversalOrganizationalUnitNames__item_
    UniversalOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalOrganizationalUnitName >-----#
    UniversalOrganizationalUnitName = SET(name='UniversalOrganizationalUnitName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    _UniversalOrganizationalUnitName_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    __UniversalOrganizationalUnitName_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _UniversalOrganizationalUnitName_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalOrganizationalUnitName_character_encoding_two_octets),
        ('four-octets', __UniversalOrganizationalUnitName_character_encoding_four_octets),
        ])
    _UniversalOrganizationalUnitName_character_encoding._ext = None
    _UniversalOrganizationalUnitName_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationalUnitName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationalUnitName._cont = ASN1Dict([
        ('character-encoding', _UniversalOrganizationalUnitName_character_encoding),
        ('iso-639-language-code', _UniversalOrganizationalUnitName_iso_639_language_code),
        ])
    UniversalOrganizationalUnitName._ext = None
    
    #-----< UniversalOrBMPString >-----#
    UniversalOrBMPString = SET(name='UniversalOrBMPString', mode=MODE_TYPE, param=True)
    
    #-----< pds-name >-----#
    pds_name = CLASS(name='pds-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _pds_name_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSName')))
    pds_name._val = dict([('Type', _pds_name_val_Type), ('id', 7)])
    
    #-----< PDSName >-----#
    PDSName = STR_PRINT(name='PDSName', mode=MODE_TYPE)
    PDSName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< physical-delivery-country-name >-----#
    physical_delivery_country_name = CLASS(name='physical-delivery-country-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_country_name_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryCountryName')))
    physical_delivery_country_name._val = dict([('Type', _physical_delivery_country_name_val_Type), ('id', 8)])
    
    #-----< PhysicalDeliveryCountryName >-----#
    PhysicalDeliveryCountryName = CHOICE(name='PhysicalDeliveryCountryName', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    PhysicalDeliveryCountryName._cont = ASN1Dict([
        ('x121-dcc-code', _PhysicalDeliveryCountryName_x121_dcc_code),
        ('iso-3166-alpha2-code', _PhysicalDeliveryCountryName_iso_3166_alpha2_code),
        ])
    PhysicalDeliveryCountryName._ext = None
    
    #-----< postal-code >-----#
    postal_code = CLASS(name='postal-code', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _postal_code_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostalCode')))
    postal_code._val = dict([('Type', _postal_code_val_Type), ('id', 9)])
    
    #-----< PostalCode >-----#
    PostalCode = CHOICE(name='PostalCode', mode=MODE_TYPE)
    _PostalCode_numeric_code = STR_NUM(name='numeric-code', mode=MODE_TYPE)
    _PostalCode_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PostalCode_printable_code = STR_PRINT(name='printable-code', mode=MODE_TYPE)
    _PostalCode_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PostalCode._cont = ASN1Dict([
        ('numeric-code', _PostalCode_numeric_code),
        ('printable-code', _PostalCode_printable_code),
        ])
    PostalCode._ext = None
    
    #-----< physical-delivery-office-name >-----#
    physical_delivery_office_name = CLASS(name='physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeName')))
    physical_delivery_office_name._val = dict([('Type', _physical_delivery_office_name_val_Type), ('id', 10)])
    
    #-----< PhysicalDeliveryOfficeName >-----#
    PhysicalDeliveryOfficeName = SET(name='PhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-name >-----#
    universal_physical_delivery_office_name = CLASS(name='universal-physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeName')))
    universal_physical_delivery_office_name._val = dict([('Type', _universal_physical_delivery_office_name_val_Type), ('id', 29)])
    
    #-----< UniversalPhysicalDeliveryOfficeName >-----#
    UniversalPhysicalDeliveryOfficeName = SET(name='UniversalPhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-office-number >-----#
    physical_delivery_office_number = CLASS(name='physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_number_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOfficeNumber')))
    physical_delivery_office_number._val = dict([('Type', _physical_delivery_office_number_val_Type), ('id', 11)])
    
    #-----< PhysicalDeliveryOfficeNumber >-----#
    PhysicalDeliveryOfficeNumber = SET(name='PhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-number >-----#
    universal_physical_delivery_office_number = CLASS(name='universal-physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_number_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOfficeNumber')))
    universal_physical_delivery_office_number._val = dict([('Type', _universal_physical_delivery_office_number_val_Type), ('id', 30)])
    
    #-----< UniversalPhysicalDeliveryOfficeNumber >-----#
    UniversalPhysicalDeliveryOfficeNumber = SET(name='UniversalPhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< extension-OR-address-components >-----#
    extension_OR_address_components = CLASS(name='extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _extension_OR_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionORAddressComponents')))
    extension_OR_address_components._val = dict([('Type', _extension_OR_address_components_val_Type), ('id', 12)])
    
    #-----< ExtensionORAddressComponents >-----#
    ExtensionORAddressComponents = SET(name='ExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-extension-OR-address-components >-----#
    universal_extension_OR_address_components = CLASS(name='universal-extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_OR_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionORAddressComponents')))
    universal_extension_OR_address_components._val = dict([('Type', _universal_extension_OR_address_components_val_Type), ('id', 31)])
    
    #-----< UniversalExtensionORAddressComponents >-----#
    UniversalExtensionORAddressComponents = SET(name='UniversalExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-personal-name >-----#
    physical_delivery_personal_name = CLASS(name='physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryPersonalName')))
    physical_delivery_personal_name._val = dict([('Type', _physical_delivery_personal_name_val_Type), ('id', 13)])
    
    #-----< PhysicalDeliveryPersonalName >-----#
    PhysicalDeliveryPersonalName = SET(name='PhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-physical-delivery-personal-name >-----#
    universal_physical_delivery_personal_name = CLASS(name='universal-physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_personal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryPersonalName')))
    universal_physical_delivery_personal_name._val = dict([('Type', _universal_physical_delivery_personal_name_val_Type), ('id', 32)])
    
    #-----< UniversalPhysicalDeliveryPersonalName >-----#
    UniversalPhysicalDeliveryPersonalName = SET(name='UniversalPhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-organization-name >-----#
    physical_delivery_organization_name = CLASS(name='physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PhysicalDeliveryOrganizationName')))
    physical_delivery_organization_name._val = dict([('Type', _physical_delivery_organization_name_val_Type), ('id', 14)])
    
    #-----< PhysicalDeliveryOrganizationName >-----#
    PhysicalDeliveryOrganizationName = SET(name='PhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-physical-delivery-organization-name >-----#
    universal_physical_delivery_organization_name = CLASS(name='universal-physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_organization_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPhysicalDeliveryOrganizationName')))
    universal_physical_delivery_organization_name._val = dict([('Type', _universal_physical_delivery_organization_name_val_Type), ('id', 33)])
    
    #-----< UniversalPhysicalDeliveryOrganizationName >-----#
    UniversalPhysicalDeliveryOrganizationName = SET(name='UniversalPhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< extension-physical-delivery-address-components >-----#
    extension_physical_delivery_address_components = CLASS(name='extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _extension_physical_delivery_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtensionPhysicalDeliveryAddressComponents')))
    extension_physical_delivery_address_components._val = dict([('Type', _extension_physical_delivery_address_components_val_Type), ('id', 15)])
    
    #-----< ExtensionPhysicalDeliveryAddressComponents >-----#
    ExtensionPhysicalDeliveryAddressComponents = SET(name='ExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-extension-physical-delivery-address-components >-----#
    universal_extension_physical_delivery_address_components = CLASS(name='universal-extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_physical_delivery_address_components_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    universal_extension_physical_delivery_address_components._val = dict([('Type', _universal_extension_physical_delivery_address_components_val_Type), ('id', 34)])
    
    #-----< UniversalExtensionPhysicalDeliveryAddressComponents >-----#
    UniversalExtensionPhysicalDeliveryAddressComponents = SET(name='UniversalExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< unformatted-postal-address >-----#
    unformatted_postal_address = CLASS(name='unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _unformatted_postal_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UnformattedPostalAddress')))
    unformatted_postal_address._val = dict([('Type', _unformatted_postal_address_val_Type), ('id', 16)])
    
    #-----< UnformattedPostalAddress >-----#
    UnformattedPostalAddress = SET(name='UnformattedPostalAddress', mode=MODE_TYPE)
    _UnformattedPostalAddress_printable_address = SEQ_OF(name='printable-address', mode=MODE_TYPE, opt=True)
    __UnformattedPostalAddress_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    __UnformattedPostalAddress_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UnformattedPostalAddress_printable_address._cont = __UnformattedPostalAddress_printable_address__item_
    _UnformattedPostalAddress_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _UnformattedPostalAddress_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    _UnformattedPostalAddress_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    UnformattedPostalAddress._cont = ASN1Dict([
        ('printable-address', _UnformattedPostalAddress_printable_address),
        ('teletex-string', _UnformattedPostalAddress_teletex_string),
        ])
    UnformattedPostalAddress._ext = None
    
    #-----< universal-unformatted-postal-address >-----#
    universal_unformatted_postal_address = CLASS(name='universal-unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_unformatted_postal_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUnformattedPostalAddress')))
    universal_unformatted_postal_address._val = dict([('Type', _universal_unformatted_postal_address_val_Type), ('id', 35)])
    
    #-----< UniversalUnformattedPostalAddress >-----#
    UniversalUnformattedPostalAddress = SET(name='UniversalUnformattedPostalAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    _UniversalUnformattedPostalAddress_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    __UniversalUnformattedPostalAddress_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    _UniversalUnformattedPostalAddress_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalUnformattedPostalAddress_character_encoding_two_octets),
        ('four-octets', __UniversalUnformattedPostalAddress_character_encoding_four_octets),
        ])
    _UniversalUnformattedPostalAddress_character_encoding._ext = None
    _UniversalUnformattedPostalAddress_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalUnformattedPostalAddress_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalUnformattedPostalAddress._cont = ASN1Dict([
        ('character-encoding', _UniversalUnformattedPostalAddress_character_encoding),
        ('iso-639-language-code', _UniversalUnformattedPostalAddress_iso_639_language_code),
        ])
    UniversalUnformattedPostalAddress._ext = None
    
    #-----< street-address >-----#
    street_address = CLASS(name='street-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _street_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'StreetAddress')))
    street_address._val = dict([('Type', _street_address_val_Type), ('id', 17)])
    
    #-----< StreetAddress >-----#
    StreetAddress = SET(name='StreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-street-address >-----#
    universal_street_address = CLASS(name='universal-street-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_street_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalStreetAddress')))
    universal_street_address._val = dict([('Type', _universal_street_address_val_Type), ('id', 36)])
    
    #-----< UniversalStreetAddress >-----#
    UniversalStreetAddress = SET(name='UniversalStreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< post-office-box-address >-----#
    post_office_box_address = CLASS(name='post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _post_office_box_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PostOfficeBoxAddress')))
    post_office_box_address._val = dict([('Type', _post_office_box_address_val_Type), ('id', 18)])
    
    #-----< PostOfficeBoxAddress >-----#
    PostOfficeBoxAddress = SET(name='PostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-post-office-box-address >-----#
    universal_post_office_box_address = CLASS(name='universal-post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_post_office_box_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPostOfficeBoxAddress')))
    universal_post_office_box_address._val = dict([('Type', _universal_post_office_box_address_val_Type), ('id', 37)])
    
    #-----< UniversalPostOfficeBoxAddress >-----#
    UniversalPostOfficeBoxAddress = SET(name='UniversalPostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< poste-restante-address >-----#
    poste_restante_address = CLASS(name='poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _poste_restante_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PosteRestanteAddress')))
    poste_restante_address._val = dict([('Type', _poste_restante_address_val_Type), ('id', 19)])
    
    #-----< PosteRestanteAddress >-----#
    PosteRestanteAddress = SET(name='PosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-poste-restante-address >-----#
    universal_poste_restante_address = CLASS(name='universal-poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_poste_restante_address_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPosteRestanteAddress')))
    universal_poste_restante_address._val = dict([('Type', _universal_poste_restante_address_val_Type), ('id', 38)])
    
    #-----< UniversalPosteRestanteAddress >-----#
    UniversalPosteRestanteAddress = SET(name='UniversalPosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< unique-postal-name >-----#
    unique_postal_name = CLASS(name='unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _unique_postal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniquePostalName')))
    unique_postal_name._val = dict([('Type', _unique_postal_name_val_Type), ('id', 20)])
    
    #-----< UniquePostalName >-----#
    UniquePostalName = SET(name='UniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-unique-postal-name >-----#
    universal_unique_postal_name = CLASS(name='universal-unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_unique_postal_name_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalUniquePostalName')))
    universal_unique_postal_name._val = dict([('Type', _universal_unique_postal_name_val_Type), ('id', 39)])
    
    #-----< UniversalUniquePostalName >-----#
    UniversalUniquePostalName = SET(name='UniversalUniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< local-postal-attributes >-----#
    local_postal_attributes = CLASS(name='local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _local_postal_attributes_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'LocalPostalAttributes')))
    local_postal_attributes._val = dict([('Type', _local_postal_attributes_val_Type), ('id', 21)])
    
    #-----< LocalPostalAttributes >-----#
    LocalPostalAttributes = SET(name='LocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'PDSParameter')))
    
    #-----< universal-local-postal-attributes >-----#
    universal_local_postal_attributes = CLASS(name='universal-local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_local_postal_attributes_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalLocalPostalAttributes')))
    universal_local_postal_attributes._val = dict([('Type', _universal_local_postal_attributes_val_Type), ('id', 40)])
    
    #-----< UniversalLocalPostalAttributes >-----#
    UniversalLocalPostalAttributes = SET(name='UniversalLocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalPDSParameter')))
    
    #-----< PDSParameter >-----#
    PDSParameter = SET(name='PDSParameter', mode=MODE_TYPE)
    _PDSParameter_printable_string = STR_PRINT(name='printable-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_printable_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _PDSParameter_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    PDSParameter._cont = ASN1Dict([
        ('printable-string', _PDSParameter_printable_string),
        ('teletex-string', _PDSParameter_teletex_string),
        ])
    PDSParameter._ext = None
    
    #-----< UniversalPDSParameter >-----#
    UniversalPDSParameter = SET(name='UniversalPDSParameter', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    _UniversalPDSParameter_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __UniversalPDSParameter_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UniversalPDSParameter_character_encoding._cont = ASN1Dict([
        ('two-octets', __UniversalPDSParameter_character_encoding_two_octets),
        ('four-octets', __UniversalPDSParameter_character_encoding_four_octets),
        ])
    _UniversalPDSParameter_character_encoding._ext = None
    _UniversalPDSParameter_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalPDSParameter_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalPDSParameter._cont = ASN1Dict([
        ('character-encoding', _UniversalPDSParameter_character_encoding),
        ('iso-639-language-code', _UniversalPDSParameter_iso_639_language_code),
        ])
    UniversalPDSParameter._ext = None
    
    #-----< extended-network-address >-----#
    extended_network_address = CLASS(name='extended-network-address', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _extended_network_address_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'ExtendedNetworkAddress')))
    extended_network_address._val = dict([('Type', _extended_network_address_val_Type), ('id', 22)])
    
    #-----< ExtendedNetworkAddress >-----#
    ExtendedNetworkAddress = CHOICE(name='ExtendedNetworkAddress', mode=MODE_TYPE)
    _ExtendedNetworkAddress_e163_4_address = SEQ(name='e163-4-address', mode=MODE_TYPE)
    __ExtendedNetworkAddress_e163_4_address_number = STR_NUM(name='number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ExtendedNetworkAddress_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    __ExtendedNetworkAddress_e163_4_address_sub_address = STR_NUM(name='sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ExtendedNetworkAddress_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _ExtendedNetworkAddress_e163_4_address._cont = ASN1Dict([
        ('number', __ExtendedNetworkAddress_e163_4_address_number),
        ('sub-address', __ExtendedNetworkAddress_e163_4_address_sub_address),
        ])
    _ExtendedNetworkAddress_e163_4_address._ext = None
    _ExtendedNetworkAddress_psap_address = SEQ(name='psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    ExtendedNetworkAddress._cont = ASN1Dict([
        ('e163-4-address', _ExtendedNetworkAddress_e163_4_address),
        ('psap-address', _ExtendedNetworkAddress_psap_address),
        ])
    ExtendedNetworkAddress._ext = None
    
    #-----< terminal-type >-----#
    terminal_type = CLASS(name='terminal-type', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _terminal_type_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TerminalType')))
    terminal_type._val = dict([('Type', _terminal_type_val_Type), ('id', 23)])
    
    #-----< TerminalType >-----#
    TerminalType = INT(name='TerminalType', mode=MODE_TYPE)
    TerminalType._cont = ASN1Dict([('telex', 3), ('teletex', 4), ('g3-facsimile', 5), ('g4-facsimile', 6), ('ia5-terminal', 7), ('videotex', 8)])
    TerminalType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< teletex-domain-defined-attributes >-----#
    teletex_domain_defined_attributes = CLASS(name='teletex-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _teletex_domain_defined_attributes_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexDomainDefinedAttributes')))
    teletex_domain_defined_attributes._val = dict([('Type', _teletex_domain_defined_attributes_val_Type), ('id', 6)])
    
    #-----< TeletexDomainDefinedAttributes >-----#
    TeletexDomainDefinedAttributes = SEQ_OF(name='TeletexDomainDefinedAttributes', mode=MODE_TYPE)
    _TeletexDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'TeletexDomainDefinedAttribute')))
    TeletexDomainDefinedAttributes._cont = _TeletexDomainDefinedAttributes__item_
    TeletexDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexDomainDefinedAttribute >-----#
    TeletexDomainDefinedAttribute = SEQ(name='TeletexDomainDefinedAttribute', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type = STR_TELE(name='type', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _TeletexDomainDefinedAttribute_value = STR_TELE(name='value', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    TeletexDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _TeletexDomainDefinedAttribute_type),
        ('value', _TeletexDomainDefinedAttribute_value),
        ])
    TeletexDomainDefinedAttribute._ext = None
    
    #-----< universal-domain-defined-attributes >-----#
    universal_domain_defined_attributes = CLASS(name='universal-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('MTSAbstractService', 'EXTENSION-ATTRIBUTE')))
    _universal_domain_defined_attributes_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalDomainDefinedAttributes')))
    universal_domain_defined_attributes._val = dict([('Type', _universal_domain_defined_attributes_val_Type), ('id', 28)])
    
    #-----< UniversalDomainDefinedAttributes >-----#
    UniversalDomainDefinedAttributes = SEQ_OF(name='UniversalDomainDefinedAttributes', mode=MODE_TYPE)
    _UniversalDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalDomainDefinedAttribute')))
    UniversalDomainDefinedAttributes._cont = _UniversalDomainDefinedAttributes__item_
    UniversalDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalDomainDefinedAttribute >-----#
    UniversalDomainDefinedAttribute = SEQ(name='UniversalDomainDefinedAttribute', mode=MODE_TYPE)
    _UniversalDomainDefinedAttribute_type = SET(name='type', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_type_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_type_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets),
        ('four-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_type_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_type_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_type_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_type._cont = ASN1Dict([
        ('character-encoding', __UniversalDomainDefinedAttribute_type_character_encoding),
        ('iso-639-language-code', __UniversalDomainDefinedAttribute_type_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_type._ext = None
    _UniversalDomainDefinedAttribute_value = SET(name='value', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_value_character_encoding = CHOICE(name='character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets = STR_BMP(name='two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets = STR_UNIV(name='four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_value_character_encoding._cont = ASN1Dict([
        ('two-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets),
        ('four-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_value_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_value_iso_639_language_code = STR_PRINT(name='iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_value_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_value._cont = ASN1Dict([
        ('character-encoding', __UniversalDomainDefinedAttribute_value_character_encoding),
        ('iso-639-language-code', __UniversalDomainDefinedAttribute_value_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_value._ext = None
    UniversalDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _UniversalDomainDefinedAttribute_type),
        ('value', _UniversalDomainDefinedAttribute_value),
        ])
    UniversalDomainDefinedAttribute._ext = None
    
    #-----< ub-integer-options >-----#
    ub_integer_options = INT(name='ub-integer-options', mode=MODE_VALUE)
    ub_integer_options._val = 256
    
    #-----< ub-e163-4-number-length >-----#
    ub_e163_4_number_length = INT(name='ub-e163-4-number-length', mode=MODE_VALUE)
    ub_e163_4_number_length._val = 15
    
    #-----< ub-e163-4-sub-address-length >-----#
    ub_e163_4_sub_address_length = INT(name='ub-e163-4-sub-address-length', mode=MODE_VALUE)
    ub_e163_4_sub_address_length._val = 40
    
    #-----< ub-unformatted-address-length >-----#
    ub_unformatted_address_length = INT(name='ub-unformatted-address-length', mode=MODE_VALUE)
    ub_unformatted_address_length._val = 180
    
    #-----< ub-pds-parameter-length >-----#
    ub_pds_parameter_length = INT(name='ub-pds-parameter-length', mode=MODE_VALUE)
    ub_pds_parameter_length._val = 30
    
    #-----< ub-pds-physical-address-lines >-----#
    ub_pds_physical_address_lines = INT(name='ub-pds-physical-address-lines', mode=MODE_VALUE)
    ub_pds_physical_address_lines._val = 6
    
    #-----< ub-postal-code-length >-----#
    ub_postal_code_length = INT(name='ub-postal-code-length', mode=MODE_VALUE)
    ub_postal_code_length._val = 16
    
    #-----< ub-pds-name-length >-----#
    ub_pds_name_length = INT(name='ub-pds-name-length', mode=MODE_VALUE)
    ub_pds_name_length._val = 16
    
    #-----< ub-universal-surname-length >-----#
    ub_universal_surname_length = INT(name='ub-universal-surname-length', mode=MODE_VALUE)
    ub_universal_surname_length._val = 64
    
    #-----< ub-universal-given-name-length >-----#
    ub_universal_given_name_length = INT(name='ub-universal-given-name-length', mode=MODE_VALUE)
    ub_universal_given_name_length._val = 40
    
    #-----< ub-universal-initials-length >-----#
    ub_universal_initials_length = INT(name='ub-universal-initials-length', mode=MODE_VALUE)
    ub_universal_initials_length._val = 16
    
    #-----< ub-universal-generation-qualifier-length >-----#
    ub_universal_generation_qualifier_length = INT(name='ub-universal-generation-qualifier-length', mode=MODE_VALUE)
    ub_universal_generation_qualifier_length._val = 16
    
    #-----< ub-common-name-length >-----#
    ub_common_name_length = INT(name='ub-common-name-length', mode=MODE_VALUE)
    ub_common_name_length._val = 64
    
    #-----< ub-extension-attributes >-----#
    ub_extension_attributes = INT(name='ub-extension-attributes', mode=MODE_VALUE)
    ub_extension_attributes._val = 256
    
    #-----< ub-domain-defined-attribute-type-length >-----#
    ub_domain_defined_attribute_type_length = INT(name='ub-domain-defined-attribute-type-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_type_length._val = 8
    
    #-----< ub-domain-defined-attribute-value-length >-----#
    ub_domain_defined_attribute_value_length = INT(name='ub-domain-defined-attribute-value-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_value_length._val = 128
    
    #-----< ub-domain-defined-attributes >-----#
    ub_domain_defined_attributes = INT(name='ub-domain-defined-attributes', mode=MODE_VALUE)
    ub_domain_defined_attributes._val = 4
    
    #-----< ub-organizational-unit-name-length >-----#
    ub_organizational_unit_name_length = INT(name='ub-organizational-unit-name-length', mode=MODE_VALUE)
    ub_organizational_unit_name_length._val = 32
    
    #-----< ub-organizational-units >-----#
    ub_organizational_units = INT(name='ub-organizational-units', mode=MODE_VALUE)
    ub_organizational_units._val = 4
    
    #-----< ub-generation-qualifier-length >-----#
    ub_generation_qualifier_length = INT(name='ub-generation-qualifier-length', mode=MODE_VALUE)
    ub_generation_qualifier_length._val = 3
    
    #-----< ub-initials-length >-----#
    ub_initials_length = INT(name='ub-initials-length', mode=MODE_VALUE)
    ub_initials_length._val = 5
    
    #-----< ub-given-name-length >-----#
    ub_given_name_length = INT(name='ub-given-name-length', mode=MODE_VALUE)
    ub_given_name_length._val = 16
    
    #-----< ub-surname-length >-----#
    ub_surname_length = INT(name='ub-surname-length', mode=MODE_VALUE)
    ub_surname_length._val = 40
    
    #-----< ub-numeric-user-id-length >-----#
    ub_numeric_user_id_length = INT(name='ub-numeric-user-id-length', mode=MODE_VALUE)
    ub_numeric_user_id_length._val = 32
    
    #-----< ub-organization-name-length >-----#
    ub_organization_name_length = INT(name='ub-organization-name-length', mode=MODE_VALUE)
    ub_organization_name_length._val = 64
    
    #-----< ub-terminal-id-length >-----#
    ub_terminal_id_length = INT(name='ub-terminal-id-length', mode=MODE_VALUE)
    ub_terminal_id_length._val = 24
    
    #-----< ub-x121-address-length >-----#
    ub_x121_address_length = INT(name='ub-x121-address-length', mode=MODE_VALUE)
    ub_x121_address_length._val = 16
    
    #-----< ub-domain-name-length >-----#
    ub_domain_name_length = INT(name='ub-domain-name-length', mode=MODE_VALUE)
    ub_domain_name_length._val = 16
    
    #-----< ub-country-name-alpha-length >-----#
    ub_country_name_alpha_length = INT(name='ub-country-name-alpha-length', mode=MODE_VALUE)
    ub_country_name_alpha_length._val = 2
    
    #-----< ub-country-name-numeric-length >-----#
    ub_country_name_numeric_length = INT(name='ub-country-name-numeric-length', mode=MODE_VALUE)
    ub_country_name_numeric_length._val = 3
    
    _all_ = [
        G3FacsimileNonBasicParameters,
        _ORAddress_built_in_standard_attributes,
        _ORAddress_built_in_domain_defined_attributes,
        _ORAddress_extension_attributes,
        ORAddress,
        _BuiltInStandardAttributes_country_name,
        _BuiltInStandardAttributes_administration_domain_name,
        _BuiltInStandardAttributes_network_address,
        _BuiltInStandardAttributes_terminal_identifier,
        _BuiltInStandardAttributes_private_domain_name,
        _BuiltInStandardAttributes_organization_name,
        _BuiltInStandardAttributes_numeric_user_identifier,
        _BuiltInStandardAttributes_personal_name,
        _BuiltInStandardAttributes_organizational_unit_names,
        BuiltInStandardAttributes,
        _CountryName_x121_dcc_code,
        _CountryName_iso_3166_alpha2_code,
        CountryName,
        _AdministrationDomainName_numeric,
        _AdministrationDomainName_printable,
        AdministrationDomainName,
        NetworkAddress,
        X121Address,
        TerminalIdentifier,
        _PrivateDomainName_numeric,
        _PrivateDomainName_printable,
        PrivateDomainName,
        OrganizationName,
        NumericUserIdentifier,
        _PersonalName_surname,
        _PersonalName_given_name,
        _PersonalName_initials,
        _PersonalName_generation_qualifier,
        PersonalName,
        _OrganizationalUnitNames__item_,
        OrganizationalUnitNames,
        OrganizationalUnitName,
        _BuiltInDomainDefinedAttributes__item_,
        BuiltInDomainDefinedAttributes,
        _BuiltInDomainDefinedAttribute_type,
        _BuiltInDomainDefinedAttribute_value,
        BuiltInDomainDefinedAttribute,
        _ExtensionAttributes__item_,
        ExtensionAttributes,
        __ExtensionAttribute_extension_attribute_type_tab,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39,
        _ExtensionAttribute_extension_attribute_type,
        _ExtensionAttribute_extension_attribute_value,
        ExtensionAttribute,
        _EXTENSION_ATTRIBUTE_id,
        _EXTENSION_ATTRIBUTE_Type,
        EXTENSION_ATTRIBUTE,
        ExtensionAttributeTable,
        _ExtensionAttributeTable_val_Type_0,
        _ExtensionAttributeTable_val_Type_1,
        _ExtensionAttributeTable_val_Type_2,
        _ExtensionAttributeTable_val_Type_3,
        _ExtensionAttributeTable_val_Type_4,
        _ExtensionAttributeTable_val_Type_5,
        _ExtensionAttributeTable_val_Type_6,
        _ExtensionAttributeTable_val_Type_7,
        _ExtensionAttributeTable_val_Type_8,
        _ExtensionAttributeTable_val_Type_9,
        _ExtensionAttributeTable_val_Type_10,
        _ExtensionAttributeTable_val_Type_11,
        _ExtensionAttributeTable_val_Type_12,
        _ExtensionAttributeTable_val_Type_13,
        _ExtensionAttributeTable_val_Type_14,
        _ExtensionAttributeTable_val_Type_15,
        _ExtensionAttributeTable_val_Type_16,
        _ExtensionAttributeTable_val_Type_17,
        _ExtensionAttributeTable_val_Type_18,
        _ExtensionAttributeTable_val_Type_19,
        _ExtensionAttributeTable_val_Type_20,
        _ExtensionAttributeTable_val_Type_21,
        _ExtensionAttributeTable_val_Type_22,
        _ExtensionAttributeTable_val_Type_23,
        _ExtensionAttributeTable_val_Type_24,
        _ExtensionAttributeTable_val_Type_25,
        _ExtensionAttributeTable_val_Type_26,
        _ExtensionAttributeTable_val_Type_27,
        _ExtensionAttributeTable_val_Type_28,
        _ExtensionAttributeTable_val_Type_29,
        _ExtensionAttributeTable_val_Type_30,
        _ExtensionAttributeTable_val_Type_31,
        _ExtensionAttributeTable_val_Type_32,
        _ExtensionAttributeTable_val_Type_33,
        _ExtensionAttributeTable_val_Type_34,
        _ExtensionAttributeTable_val_Type_35,
        _ExtensionAttributeTable_val_Type_36,
        _ExtensionAttributeTable_val_Type_37,
        _ExtensionAttributeTable_val_Type_38,
        _ExtensionAttributeTable_val_Type_39,
        common_name,
        _common_name_val_Type,
        CommonName,
        teletex_common_name,
        _teletex_common_name_val_Type,
        TeletexCommonName,
        universal_common_name,
        _universal_common_name_val_Type,
        __UniversalCommonName_character_encoding_two_octets,
        __UniversalCommonName_character_encoding_four_octets,
        _UniversalCommonName_character_encoding,
        _UniversalCommonName_iso_639_language_code,
        UniversalCommonName,
        teletex_organization_name,
        _teletex_organization_name_val_Type,
        TeletexOrganizationName,
        universal_organization_name,
        _universal_organization_name_val_Type,
        __UniversalOrganizationName_character_encoding_two_octets,
        __UniversalOrganizationName_character_encoding_four_octets,
        _UniversalOrganizationName_character_encoding,
        _UniversalOrganizationName_iso_639_language_code,
        UniversalOrganizationName,
        teletex_personal_name,
        _teletex_personal_name_val_Type,
        _TeletexPersonalName_surname,
        _TeletexPersonalName_given_name,
        _TeletexPersonalName_initials,
        _TeletexPersonalName_generation_qualifier,
        TeletexPersonalName,
        universal_personal_name,
        _universal_personal_name_val_Type,
        ___UniversalPersonalName_surname_character_encoding_two_octets,
        ___UniversalPersonalName_surname_character_encoding_four_octets,
        __UniversalPersonalName_surname_character_encoding,
        __UniversalPersonalName_surname_iso_639_language_code,
        _UniversalPersonalName_surname,
        ___UniversalPersonalName_given_name_character_encoding_two_octets,
        ___UniversalPersonalName_given_name_character_encoding_four_octets,
        __UniversalPersonalName_given_name_character_encoding,
        __UniversalPersonalName_given_name_iso_639_language_code,
        _UniversalPersonalName_given_name,
        ___UniversalPersonalName_initials_character_encoding_two_octets,
        ___UniversalPersonalName_initials_character_encoding_four_octets,
        __UniversalPersonalName_initials_character_encoding,
        __UniversalPersonalName_initials_iso_639_language_code,
        _UniversalPersonalName_initials,
        ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets,
        ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets,
        __UniversalPersonalName_generation_qualifier_character_encoding,
        __UniversalPersonalName_generation_qualifier_iso_639_language_code,
        _UniversalPersonalName_generation_qualifier,
        UniversalPersonalName,
        teletex_organizational_unit_names,
        _teletex_organizational_unit_names_val_Type,
        _TeletexOrganizationalUnitNames__item_,
        TeletexOrganizationalUnitNames,
        TeletexOrganizationalUnitName,
        universal_organizational_unit_names,
        _universal_organizational_unit_names_val_Type,
        _UniversalOrganizationalUnitNames__item_,
        UniversalOrganizationalUnitNames,
        __UniversalOrganizationalUnitName_character_encoding_two_octets,
        __UniversalOrganizationalUnitName_character_encoding_four_octets,
        _UniversalOrganizationalUnitName_character_encoding,
        _UniversalOrganizationalUnitName_iso_639_language_code,
        UniversalOrganizationalUnitName,
        pds_name,
        _pds_name_val_Type,
        PDSName,
        physical_delivery_country_name,
        _physical_delivery_country_name_val_Type,
        _PhysicalDeliveryCountryName_x121_dcc_code,
        _PhysicalDeliveryCountryName_iso_3166_alpha2_code,
        PhysicalDeliveryCountryName,
        postal_code,
        _postal_code_val_Type,
        _PostalCode_numeric_code,
        _PostalCode_printable_code,
        PostalCode,
        physical_delivery_office_name,
        _physical_delivery_office_name_val_Type,
        PhysicalDeliveryOfficeName,
        universal_physical_delivery_office_name,
        _universal_physical_delivery_office_name_val_Type,
        UniversalPhysicalDeliveryOfficeName,
        physical_delivery_office_number,
        _physical_delivery_office_number_val_Type,
        PhysicalDeliveryOfficeNumber,
        universal_physical_delivery_office_number,
        _universal_physical_delivery_office_number_val_Type,
        UniversalPhysicalDeliveryOfficeNumber,
        extension_OR_address_components,
        _extension_OR_address_components_val_Type,
        ExtensionORAddressComponents,
        universal_extension_OR_address_components,
        _universal_extension_OR_address_components_val_Type,
        UniversalExtensionORAddressComponents,
        physical_delivery_personal_name,
        _physical_delivery_personal_name_val_Type,
        PhysicalDeliveryPersonalName,
        universal_physical_delivery_personal_name,
        _universal_physical_delivery_personal_name_val_Type,
        UniversalPhysicalDeliveryPersonalName,
        physical_delivery_organization_name,
        _physical_delivery_organization_name_val_Type,
        PhysicalDeliveryOrganizationName,
        universal_physical_delivery_organization_name,
        _universal_physical_delivery_organization_name_val_Type,
        UniversalPhysicalDeliveryOrganizationName,
        extension_physical_delivery_address_components,
        _extension_physical_delivery_address_components_val_Type,
        ExtensionPhysicalDeliveryAddressComponents,
        universal_extension_physical_delivery_address_components,
        _universal_extension_physical_delivery_address_components_val_Type,
        UniversalExtensionPhysicalDeliveryAddressComponents,
        unformatted_postal_address,
        _unformatted_postal_address_val_Type,
        __UnformattedPostalAddress_printable_address__item_,
        _UnformattedPostalAddress_printable_address,
        _UnformattedPostalAddress_teletex_string,
        UnformattedPostalAddress,
        universal_unformatted_postal_address,
        _universal_unformatted_postal_address_val_Type,
        __UniversalUnformattedPostalAddress_character_encoding_two_octets,
        __UniversalUnformattedPostalAddress_character_encoding_four_octets,
        _UniversalUnformattedPostalAddress_character_encoding,
        _UniversalUnformattedPostalAddress_iso_639_language_code,
        UniversalUnformattedPostalAddress,
        street_address,
        _street_address_val_Type,
        StreetAddress,
        universal_street_address,
        _universal_street_address_val_Type,
        UniversalStreetAddress,
        post_office_box_address,
        _post_office_box_address_val_Type,
        PostOfficeBoxAddress,
        universal_post_office_box_address,
        _universal_post_office_box_address_val_Type,
        UniversalPostOfficeBoxAddress,
        poste_restante_address,
        _poste_restante_address_val_Type,
        PosteRestanteAddress,
        universal_poste_restante_address,
        _universal_poste_restante_address_val_Type,
        UniversalPosteRestanteAddress,
        unique_postal_name,
        _unique_postal_name_val_Type,
        UniquePostalName,
        universal_unique_postal_name,
        _universal_unique_postal_name_val_Type,
        UniversalUniquePostalName,
        local_postal_attributes,
        _local_postal_attributes_val_Type,
        LocalPostalAttributes,
        universal_local_postal_attributes,
        _universal_local_postal_attributes_val_Type,
        UniversalLocalPostalAttributes,
        _PDSParameter_printable_string,
        _PDSParameter_teletex_string,
        PDSParameter,
        __UniversalPDSParameter_character_encoding_two_octets,
        __UniversalPDSParameter_character_encoding_four_octets,
        _UniversalPDSParameter_character_encoding,
        _UniversalPDSParameter_iso_639_language_code,
        UniversalPDSParameter,
        extended_network_address,
        _extended_network_address_val_Type,
        __ExtendedNetworkAddress_e163_4_address_number,
        __ExtendedNetworkAddress_e163_4_address_sub_address,
        _ExtendedNetworkAddress_e163_4_address,
        _ExtendedNetworkAddress_psap_address,
        ExtendedNetworkAddress,
        terminal_type,
        _terminal_type_val_Type,
        TerminalType,
        teletex_domain_defined_attributes,
        _teletex_domain_defined_attributes_val_Type,
        _TeletexDomainDefinedAttributes__item_,
        TeletexDomainDefinedAttributes,
        _TeletexDomainDefinedAttribute_type,
        _TeletexDomainDefinedAttribute_value,
        TeletexDomainDefinedAttribute,
        universal_domain_defined_attributes,
        _universal_domain_defined_attributes_val_Type,
        _UniversalDomainDefinedAttributes__item_,
        UniversalDomainDefinedAttributes,
        ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_type_character_encoding,
        __UniversalDomainDefinedAttribute_type_iso_639_language_code,
        _UniversalDomainDefinedAttribute_type,
        ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_value_character_encoding,
        __UniversalDomainDefinedAttribute_value_iso_639_language_code,
        _UniversalDomainDefinedAttribute_value,
        UniversalDomainDefinedAttribute,
        ub_integer_options,
        ub_e163_4_number_length,
        ub_e163_4_sub_address_length,
        ub_unformatted_address_length,
        ub_pds_parameter_length,
        ub_pds_physical_address_lines,
        ub_postal_code_length,
        ub_pds_name_length,
        ub_universal_surname_length,
        ub_universal_given_name_length,
        ub_universal_initials_length,
        ub_universal_generation_qualifier_length,
        ub_common_name_length,
        ub_extension_attributes,
        ub_domain_defined_attribute_type_length,
        ub_domain_defined_attribute_value_length,
        ub_domain_defined_attributes,
        ub_organizational_unit_name_length,
        ub_organizational_units,
        ub_generation_qualifier_length,
        ub_initials_length,
        ub_given_name_length,
        ub_surname_length,
        ub_numeric_user_id_length,
        ub_organization_name_length,
        ub_terminal_id_length,
        ub_x121_address_length,
        ub_domain_name_length,
        ub_country_name_alpha_length,
        ub_country_name_numeric_length,
    ]

class OperationalBindingManagement:

    _name_  = 'OperationalBindingManagement'
    _oid_   = [2, 5, 1, 18, 7]
    
    _obj_ = [
        'dSAOperationalBindingManagementBind',
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'establishOperationalBinding',
        'EstablishOperationalBindingArgument',
        'EstablishOperationalBindingArgumentData',
        'OpBindingSet',
        'OperationalBindingID',
        'Validity',
        'Time',
        'EstablishOperationalBindingResult',
        'EstablishOperationalBindingResultData',
        'modifyOperationalBinding',
        'ModifyOperationalBindingArgument',
        'ModifyOperationalBindingArgumentData',
        'ModifiedValidity',
        'ModifyOperationalBindingResult',
        'ModifyOperationalBindingResultData',
        'terminateOperationalBinding',
        'TerminateOperationalBindingArgument',
        'TerminateOperationalBindingArgumentData',
        'TerminateOperationalBindingResult',
        'TerminateOperationalBindingResultData',
        'operationalBindingError',
        'OpBindingErrorParam',
        ]
    _type_ = [
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'EstablishOperationalBindingArgument',
        'EstablishOperationalBindingArgumentData',
        'OperationalBindingID',
        'Validity',
        'Time',
        'EstablishOperationalBindingResult',
        'EstablishOperationalBindingResultData',
        'ModifyOperationalBindingArgument',
        'ModifyOperationalBindingArgumentData',
        'ModifiedValidity',
        'ModifyOperationalBindingResult',
        'ModifyOperationalBindingResultData',
        'TerminateOperationalBindingArgument',
        'TerminateOperationalBindingArgumentData',
        'TerminateOperationalBindingResult',
        'TerminateOperationalBindingResultData',
        'OpBindingErrorParam',
        ]
    _set_ = [
        'OpBindingSet',
        ]
    _val_ = [
        'dSAOperationalBindingManagementBind',
        'establishOperationalBinding',
        'modifyOperationalBinding',
        'terminateOperationalBinding',
        'operationalBindingError',
        ]
    _class_ = [
        'dSAOperationalBindingManagementBind',
        'OPERATIONAL-BINDING',
        'OP-BINDING-COOP',
        'OP-BIND-ROLE',
        'establishOperationalBinding',
        'OpBindingSet',
        'modifyOperationalBinding',
        'terminateOperationalBinding',
        'operationalBindingError',
        ]
    _param_ = [
        ]
    
    #-----< dSAOperationalBindingManagementBind >-----#
    dSAOperationalBindingManagementBind = CLASS(name='dSAOperationalBindingManagementBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAOperationalBindingManagementBind_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAOperationalBindingManagementBind_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name='error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        ('serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        ('securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        ('versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        ('error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        ('securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name='versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name='error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name='serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name='securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        ('serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        ('securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        ('versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        ('error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        ('securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAOperationalBindingManagementBind._val = dict([('ArgumentType', _dSAOperationalBindingManagementBind_val_ArgumentType), ('ResultType', _dSAOperationalBindingManagementBind_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< OPERATIONAL-BINDING >-----#
    OPERATIONAL_BINDING = CLASS(name='OPERATIONAL-BINDING', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Agreement = OPEN(name='Agreement', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Cooperation = CLASS(name='Cooperation', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BINDING-COOP')))
    _OPERATIONAL_BINDING_both = CLASS(name='both', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleA = CLASS(name='roleA', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleB = CLASS(name='roleB', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    OPERATIONAL_BINDING._cont = ASN1Dict([
        ('Agreement', _OPERATIONAL_BINDING_Agreement),
        ('Cooperation', _OPERATIONAL_BINDING_Cooperation),
        ('both', _OPERATIONAL_BINDING_both),
        ('roleA', _OPERATIONAL_BINDING_roleA),
        ('roleB', _OPERATIONAL_BINDING_roleB),
        ('id', _OPERATIONAL_BINDING_id),
        ])
    
    #-----< OP-BINDING-COOP >-----#
    OP_BINDING_COOP = CLASS(name='OP-BINDING-COOP', mode=MODE_TYPE)
    _OP_BINDING_COOP_applContext = CLASS(name='applContext', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    _OP_BINDING_COOP_Operations = CLASS(name='Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), opt=True)
    OP_BINDING_COOP._cont = ASN1Dict([
        ('applContext', _OP_BINDING_COOP_applContext),
        ('Operations', _OP_BINDING_COOP_Operations),
        ])
    
    #-----< OP-BIND-ROLE >-----#
    OP_BIND_ROLE = CLASS(name='OP-BIND-ROLE', mode=MODE_TYPE)
    _OP_BIND_ROLE_establish = BOOL(name='establish', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_EstablishParam = OPEN(name='EstablishParam', mode=MODE_TYPE)
    _OP_BIND_ROLE_modify = BOOL(name='modify', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_ModifyParam = OPEN(name='ModifyParam', mode=MODE_TYPE, opt=True)
    _OP_BIND_ROLE_terminate = BOOL(name='terminate', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_TerminateParam = OPEN(name='TerminateParam', mode=MODE_TYPE, opt=True)
    OP_BIND_ROLE._cont = ASN1Dict([
        ('establish', _OP_BIND_ROLE_establish),
        ('EstablishParam', _OP_BIND_ROLE_EstablishParam),
        ('modify', _OP_BIND_ROLE_modify),
        ('ModifyParam', _OP_BIND_ROLE_ModifyParam),
        ('terminate', _OP_BIND_ROLE_terminate),
        ('TerminateParam', _OP_BIND_ROLE_TerminateParam),
        ])
    
    #-----< establishOperationalBinding >-----#
    establishOperationalBinding = CLASS(name='establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _establishOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _establishOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    establishOperationalBinding._val = dict([('ArgumentType', _establishOperationalBinding_val_ArgumentType), ('ResultType', _establishOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 100))])
    
    #-----< EstablishOperationalBindingArgument >-----#
    EstablishOperationalBindingArgument = CHOICE(name='EstablishOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    _EstablishOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _EstablishOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __EstablishOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __EstablishOperationalBindingArgument_signed_algorithmIdentifier),
        ('encrypted', __EstablishOperationalBindingArgument_signed_encrypted),
        ])
    _EstablishOperationalBindingArgument_signed._ext = []
    EstablishOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _EstablishOperationalBindingArgument_unsigned),
        ('signed', _EstablishOperationalBindingArgument_signed),
        ])
    EstablishOperationalBindingArgument._ext = None
    
    #-----< EstablishOperationalBindingArgumentData >-----#
    EstablishOperationalBindingArgumentData = SEQ(name='EstablishOperationalBindingArgumentData', mode=MODE_TYPE)
    _EstablishOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __EstablishOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0_0 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0_0 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_EstablishParam = NULL(name='EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        ('parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        ('toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        ('algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        ('encrypted', ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        ('unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        ('signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        ('chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        ('argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name='chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        ('argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name='unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        ('chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        ('result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name='signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name='toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name='chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name='ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        ('chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        ('result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        ('parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        ('toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        ('algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        ('encrypted', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        ('unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        ('signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_0 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_1 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam_0 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_1 = SEQ(name='EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_1 = SEQ(name='ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __EstablishOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingArgumentData_bindingType._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_at = None
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _EstablishOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingArgumentData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'EstablishParam'
    _EstablishOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __EstablishOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __EstablishOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __EstablishOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _EstablishOperationalBindingArgumentData_initiator._ext = None
    _EstablishOperationalBindingArgumentData_agreement = OPEN(name='agreement', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']))
    _EstablishOperationalBindingArgumentData_agreement._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_agreement._const_tab_at = ('..', 'bindingType')
    _EstablishOperationalBindingArgumentData_agreement._const_tab_id = 'Agreement'
    _EstablishOperationalBindingArgumentData_valid = SEQ(name='valid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), default=dict([]))
    _EstablishOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    EstablishOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _EstablishOperationalBindingArgumentData_bindingType),
        ('bindingID', _EstablishOperationalBindingArgumentData_bindingID),
        ('accessPoint', _EstablishOperationalBindingArgumentData_accessPoint),
        ('initiator', _EstablishOperationalBindingArgumentData_initiator),
        ('agreement', _EstablishOperationalBindingArgumentData_agreement),
        ('valid', _EstablishOperationalBindingArgumentData_valid),
        ('securityParameters', _EstablishOperationalBindingArgumentData_securityParameters),
        ])
    EstablishOperationalBindingArgumentData._ext = []
    
    #-----< OpBindingSet >-----#
    OpBindingSet = CLASS(name='OpBindingSet', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _OpBindingSet_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    _OpBindingSet_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    _OpBindingSet_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    OpBindingSet._val = ASN1Set(rv=[dict([('Agreement', _OpBindingSet_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', _OpBindingSet_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', _OpBindingSet_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    
    #-----< OperationalBindingID >-----#
    OperationalBindingID = SEQ(name='OperationalBindingID', mode=MODE_TYPE)
    _OperationalBindingID_identifier = INT(name='identifier', mode=MODE_TYPE)
    _OperationalBindingID_version = INT(name='version', mode=MODE_TYPE)
    OperationalBindingID._cont = ASN1Dict([
        ('identifier', _OperationalBindingID_identifier),
        ('version', _OperationalBindingID_version),
        ])
    OperationalBindingID._ext = []
    
    #-----< Validity >-----#
    Validity = SEQ(name='Validity', mode=MODE_TYPE)
    _Validity_validFrom = CHOICE(name='validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('now', 0))
    __Validity_validFrom_now = NULL(name='now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validFrom_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validFrom._cont = ASN1Dict([
        ('now', __Validity_validFrom_now),
        ('time', __Validity_validFrom_time),
        ])
    _Validity_validFrom._ext = []
    _Validity_validUntil = CHOICE(name='validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('explicitTermination', 0))
    __Validity_validUntil_explicitTermination = NULL(name='explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validUntil_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validUntil._cont = ASN1Dict([
        ('explicitTermination', __Validity_validUntil_explicitTermination),
        ('time', __Validity_validUntil_time),
        ])
    _Validity_validUntil._ext = []
    Validity._cont = ASN1Dict([
        ('validFrom', _Validity_validFrom),
        ('validUntil', _Validity_validUntil),
        ])
    Validity._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name='generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< EstablishOperationalBindingResult >-----#
    EstablishOperationalBindingResult = CHOICE(name='EstablishOperationalBindingResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingResult_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    _EstablishOperationalBindingResult_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingResult_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    __EstablishOperationalBindingResult_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm),
        ('parameters', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingResult_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _EstablishOperationalBindingResult_signed._cont = ASN1Dict([
        ('toBeSigned', __EstablishOperationalBindingResult_signed_toBeSigned),
        ('algorithmIdentifier', __EstablishOperationalBindingResult_signed_algorithmIdentifier),
        ('encrypted', __EstablishOperationalBindingResult_signed_encrypted),
        ])
    _EstablishOperationalBindingResult_signed._ext = []
    EstablishOperationalBindingResult._cont = ASN1Dict([
        ('unsigned', _EstablishOperationalBindingResult_unsigned),
        ('signed', _EstablishOperationalBindingResult_signed),
        ])
    EstablishOperationalBindingResult._ext = None
    
    #-----< EstablishOperationalBindingResultData >-----#
    EstablishOperationalBindingResultData = SEQ(name='EstablishOperationalBindingResultData', mode=MODE_TYPE)
    _EstablishOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __EstablishOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __EstablishOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingResultData_bindingType._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    _EstablishOperationalBindingResultData_bindingType._const_tab_at = None
    _EstablishOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _EstablishOperationalBindingResultData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingResultData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingResultData_initiator = CHOICE(name='initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingResultData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleA_replies = OPEN(name='roleA-replies', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_id = 'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleB_replies = OPEN(name='roleB-replies', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_at = ('..', '..', 'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_id = 'EstablishParam'
    _EstablishOperationalBindingResultData_initiator._cont = ASN1Dict([
        ('symmetric', __EstablishOperationalBindingResultData_initiator_symmetric),
        ('roleA-replies', __EstablishOperationalBindingResultData_initiator_roleA_replies),
        ('roleB-replies', __EstablishOperationalBindingResultData_initiator_roleB_replies),
        ])
    _EstablishOperationalBindingResultData_initiator._ext = None
    _EstablishOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _EstablishOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _EstablishOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EstablishOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EstablishOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___EstablishOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____EstablishOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____EstablishOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___EstablishOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____EstablishOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___EstablishOperationalBindingResultData_notification__item__values._cont = ____EstablishOperationalBindingResultData_notification__item__values__item_
    ___EstablishOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._cont = ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __EstablishOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___EstablishOperationalBindingResultData_notification__item__type),
        ('values', ___EstablishOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___EstablishOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __EstablishOperationalBindingResultData_notification__item_._ext = []
    _EstablishOperationalBindingResultData_notification._cont = __EstablishOperationalBindingResultData_notification__item_
    EstablishOperationalBindingResultData._cont = ASN1Dict([
        ('bindingType', _EstablishOperationalBindingResultData_bindingType),
        ('bindingID', _EstablishOperationalBindingResultData_bindingID),
        ('accessPoint', _EstablishOperationalBindingResultData_accessPoint),
        ('initiator', _EstablishOperationalBindingResultData_initiator),
        ('securityParameters', _EstablishOperationalBindingResultData_securityParameters),
        ('performer', _EstablishOperationalBindingResultData_performer),
        ('aliasDereferenced', _EstablishOperationalBindingResultData_aliasDereferenced),
        ('notification', _EstablishOperationalBindingResultData_notification),
        ])
    EstablishOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< modifyOperationalBinding >-----#
    modifyOperationalBinding = CLASS(name='modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _modifyOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    modifyOperationalBinding._val = dict([('ArgumentType', _modifyOperationalBinding_val_ArgumentType), ('ResultType', _modifyOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 102))])
    
    #-----< ModifyOperationalBindingArgument >-----#
    ModifyOperationalBindingArgument = CHOICE(name='ModifyOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ModifyOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    _ModifyOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __ModifyOperationalBindingArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _ModifyOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __ModifyOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __ModifyOperationalBindingArgument_signed_algorithmIdentifier),
        ('encrypted', __ModifyOperationalBindingArgument_signed_encrypted),
        ])
    _ModifyOperationalBindingArgument_signed._ext = []
    ModifyOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _ModifyOperationalBindingArgument_unsigned),
        ('signed', _ModifyOperationalBindingArgument_signed),
        ])
    ModifyOperationalBindingArgument._ext = None
    
    #-----< ModifyOperationalBindingArgumentData >-----#
    ModifyOperationalBindingArgumentData = SEQ(name='ModifyOperationalBindingArgumentData', mode=MODE_TYPE)
    _ModifyOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __ModifyOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingArgumentData_bindingType._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_at = None
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _ModifyOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_accessPoint = SET(name='accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ModifyOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE, opt=True)
    __ModifyOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'ModifyParam'
    _ModifyOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __ModifyOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __ModifyOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __ModifyOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _ModifyOperationalBindingArgumentData_initiator._ext = None
    _ModifyOperationalBindingArgumentData_newBindingID = SEQ(name='newBindingID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_newAgreement = OPEN(name='newAgreement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']), opt=True)
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_at = ('..', 'bindingType')
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_id = 'Agreement'
    _ModifyOperationalBindingArgumentData_valid = SEQ(name='valid', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'ModifiedValidity')), opt=True)
    _ModifyOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ModifyOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _ModifyOperationalBindingArgumentData_bindingType),
        ('bindingID', _ModifyOperationalBindingArgumentData_bindingID),
        ('accessPoint', _ModifyOperationalBindingArgumentData_accessPoint),
        ('initiator', _ModifyOperationalBindingArgumentData_initiator),
        ('newBindingID', _ModifyOperationalBindingArgumentData_newBindingID),
        ('newAgreement', _ModifyOperationalBindingArgumentData_newAgreement),
        ('valid', _ModifyOperationalBindingArgumentData_valid),
        ('securityParameters', _ModifyOperationalBindingArgumentData_securityParameters),
        ])
    ModifyOperationalBindingArgumentData._ext = []
    
    #-----< ModifiedValidity >-----#
    ModifiedValidity = SEQ(name='ModifiedValidity', mode=MODE_TYPE)
    _ModifiedValidity_validFrom = CHOICE(name='validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('now', 0))
    __ModifiedValidity_validFrom_now = NULL(name='now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validFrom_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _ModifiedValidity_validFrom._cont = ASN1Dict([
        ('now', __ModifiedValidity_validFrom_now),
        ('time', __ModifiedValidity_validFrom_time),
        ])
    _ModifiedValidity_validFrom._ext = []
    _ModifiedValidity_validUntil = CHOICE(name='validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=('unchanged', 0))
    __ModifiedValidity_validUntil_explicitTermination = NULL(name='explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validUntil_time = CHOICE(name='time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    __ModifiedValidity_validUntil_unchanged = NULL(name='unchanged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _ModifiedValidity_validUntil._cont = ASN1Dict([
        ('explicitTermination', __ModifiedValidity_validUntil_explicitTermination),
        ('time', __ModifiedValidity_validUntil_time),
        ('unchanged', __ModifiedValidity_validUntil_unchanged),
        ])
    _ModifiedValidity_validUntil._ext = []
    ModifiedValidity._cont = ASN1Dict([
        ('validFrom', _ModifiedValidity_validFrom),
        ('validUntil', _ModifiedValidity_validUntil),
        ])
    ModifiedValidity._ext = []
    
    #-----< ModifyOperationalBindingResult >-----#
    ModifyOperationalBindingResult = CHOICE(name='ModifyOperationalBindingResult', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_null = NULL(name='null', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_protected = CHOICE(name='protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyOperationalBindingResult_protected_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    __ModifyOperationalBindingResult_protected_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyOperationalBindingResult_protected_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        ('parameters', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___ModifyOperationalBindingResult_protected_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __ModifyOperationalBindingResult_protected_signed._cont = ASN1Dict([
        ('toBeSigned', ___ModifyOperationalBindingResult_protected_signed_toBeSigned),
        ('algorithmIdentifier', ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier),
        ('encrypted', ___ModifyOperationalBindingResult_protected_signed_encrypted),
        ])
    __ModifyOperationalBindingResult_protected_signed._ext = []
    _ModifyOperationalBindingResult_protected._cont = ASN1Dict([
        ('unsigned', __ModifyOperationalBindingResult_protected_unsigned),
        ('signed', __ModifyOperationalBindingResult_protected_signed),
        ])
    _ModifyOperationalBindingResult_protected._ext = None
    ModifyOperationalBindingResult._cont = ASN1Dict([
        ('null', _ModifyOperationalBindingResult_null),
        ('protected', _ModifyOperationalBindingResult_protected),
        ])
    ModifyOperationalBindingResult._ext = []
    
    #-----< ModifyOperationalBindingResultData >-----#
    ModifyOperationalBindingResultData = SEQ(name='ModifyOperationalBindingResultData', mode=MODE_TYPE)
    _ModifyOperationalBindingResultData_newBindingID = SEQ(name='newBindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __ModifyOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingResultData_bindingType._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_bindingType._const_tab_at = None
    _ModifyOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _ModifyOperationalBindingResultData_newAgreement = OPEN(name='newAgreement', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']))
    _ModifyOperationalBindingResultData_newAgreement._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_newAgreement._const_tab_at = ('..', 'bindingType')
    _ModifyOperationalBindingResultData_newAgreement._const_tab_id = 'Agreement'
    _ModifyOperationalBindingResultData_valid = SEQ(name='valid', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), opt=True)
    _ModifyOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____ModifyOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___ModifyOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ModifyOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___ModifyOperationalBindingResultData_notification__item__values._cont = ____ModifyOperationalBindingResultData_notification__item__values__item_
    ___ModifyOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._cont = ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___ModifyOperationalBindingResultData_notification__item__type),
        ('values', ___ModifyOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___ModifyOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __ModifyOperationalBindingResultData_notification__item_._ext = []
    _ModifyOperationalBindingResultData_notification._cont = __ModifyOperationalBindingResultData_notification__item_
    ModifyOperationalBindingResultData._cont = ASN1Dict([
        ('newBindingID', _ModifyOperationalBindingResultData_newBindingID),
        ('bindingType', _ModifyOperationalBindingResultData_bindingType),
        ('newAgreement', _ModifyOperationalBindingResultData_newAgreement),
        ('valid', _ModifyOperationalBindingResultData_valid),
        ('securityParameters', _ModifyOperationalBindingResultData_securityParameters),
        ('performer', _ModifyOperationalBindingResultData_performer),
        ('aliasDereferenced', _ModifyOperationalBindingResultData_aliasDereferenced),
        ('notification', _ModifyOperationalBindingResultData_notification),
        ])
    ModifyOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< terminateOperationalBinding >-----#
    terminateOperationalBinding = CLASS(name='terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _terminateOperationalBinding_val_ArgumentType = CHOICE(name='ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _terminateOperationalBinding_val_ResultType = CHOICE(name='ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    terminateOperationalBinding._val = dict([('ArgumentType', _terminateOperationalBinding_val_ArgumentType), ('ResultType', _terminateOperationalBinding_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_0), ('errorCode', ('local', 100))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 101))])
    
    #-----< TerminateOperationalBindingArgument >-----#
    TerminateOperationalBindingArgument = CHOICE(name='TerminateOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _TerminateOperationalBindingArgument_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    _TerminateOperationalBindingArgument_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __TerminateOperationalBindingArgument_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        ('parameters', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __TerminateOperationalBindingArgument_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    _TerminateOperationalBindingArgument_signed._cont = ASN1Dict([
        ('toBeSigned', __TerminateOperationalBindingArgument_signed_toBeSigned),
        ('algorithmIdentifier', __TerminateOperationalBindingArgument_signed_algorithmIdentifier),
        ('encrypted', __TerminateOperationalBindingArgument_signed_encrypted),
        ])
    _TerminateOperationalBindingArgument_signed._ext = []
    TerminateOperationalBindingArgument._cont = ASN1Dict([
        ('unsigned', _TerminateOperationalBindingArgument_unsigned),
        ('signed', _TerminateOperationalBindingArgument_signed),
        ])
    TerminateOperationalBindingArgument._ext = None
    
    #-----< TerminateOperationalBindingArgumentData >-----#
    TerminateOperationalBindingArgumentData = SEQ(name='TerminateOperationalBindingArgumentData', mode=MODE_TYPE)
    _TerminateOperationalBindingArgumentData_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __TerminateOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingArgumentData_bindingType._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_at = None
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_id = 'id'
    _TerminateOperationalBindingArgumentData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingArgumentData_initiator = CHOICE(name='initiator', mode=MODE_TYPE, opt=True)
    __TerminateOperationalBindingArgumentData_initiator_symmetric = OPEN(name='symmetric', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['both', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_id = 'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name='roleA-initiates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleA', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = 'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name='roleB-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['roleB', 'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', 'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = 'TerminateParam'
    _TerminateOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        ('symmetric', __TerminateOperationalBindingArgumentData_initiator_symmetric),
        ('roleA-initiates', __TerminateOperationalBindingArgumentData_initiator_roleA_initiates),
        ('roleB-initiates', __TerminateOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _TerminateOperationalBindingArgumentData_initiator._ext = None
    _TerminateOperationalBindingArgumentData_terminateAt = CHOICE(name='terminateAt', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _TerminateOperationalBindingArgumentData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    TerminateOperationalBindingArgumentData._cont = ASN1Dict([
        ('bindingType', _TerminateOperationalBindingArgumentData_bindingType),
        ('bindingID', _TerminateOperationalBindingArgumentData_bindingID),
        ('initiator', _TerminateOperationalBindingArgumentData_initiator),
        ('terminateAt', _TerminateOperationalBindingArgumentData_terminateAt),
        ('securityParameters', _TerminateOperationalBindingArgumentData_securityParameters),
        ])
    TerminateOperationalBindingArgumentData._ext = []
    
    #-----< TerminateOperationalBindingResult >-----#
    TerminateOperationalBindingResult = CHOICE(name='TerminateOperationalBindingResult', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_null = NULL(name='null', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_protected = CHOICE(name='protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __TerminateOperationalBindingResult_protected_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    __TerminateOperationalBindingResult_protected_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___TerminateOperationalBindingResult_protected_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        ('parameters', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___TerminateOperationalBindingResult_protected_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __TerminateOperationalBindingResult_protected_signed._cont = ASN1Dict([
        ('toBeSigned', ___TerminateOperationalBindingResult_protected_signed_toBeSigned),
        ('algorithmIdentifier', ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier),
        ('encrypted', ___TerminateOperationalBindingResult_protected_signed_encrypted),
        ])
    __TerminateOperationalBindingResult_protected_signed._ext = []
    _TerminateOperationalBindingResult_protected._cont = ASN1Dict([
        ('unsigned', __TerminateOperationalBindingResult_protected_unsigned),
        ('signed', __TerminateOperationalBindingResult_protected_signed),
        ])
    _TerminateOperationalBindingResult_protected._ext = None
    TerminateOperationalBindingResult._cont = ASN1Dict([
        ('null', _TerminateOperationalBindingResult_null),
        ('protected', _TerminateOperationalBindingResult_protected),
        ])
    TerminateOperationalBindingResult._ext = []
    
    #-----< TerminateOperationalBindingResultData >-----#
    TerminateOperationalBindingResultData = SEQ(name='TerminateOperationalBindingResultData', mode=MODE_TYPE)
    _TerminateOperationalBindingResultData_bindingID = SEQ(name='bindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingResultData_bindingType = OID(name='bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']))
    __TerminateOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingResultData_bindingType._const_tab = __TerminateOperationalBindingResultData_bindingType_tab
    _TerminateOperationalBindingResultData_bindingType._const_tab_at = None
    _TerminateOperationalBindingResultData_bindingType._const_tab_id = 'id'
    _TerminateOperationalBindingResultData_terminateAt = TIME_GEN(name='terminateAt', mode=MODE_TYPE, opt=True)
    _TerminateOperationalBindingResultData_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _TerminateOperationalBindingResultData_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _TerminateOperationalBindingResultData_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _TerminateOperationalBindingResultData_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TerminateOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___TerminateOperationalBindingResultData_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____TerminateOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____TerminateOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_id = 'id'
    ___TerminateOperationalBindingResultData_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____TerminateOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_id = 'Type'
    ___TerminateOperationalBindingResultData_notification__item__values._cont = ____TerminateOperationalBindingResultData_notification__item__values__item_
    ___TerminateOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        ('contextList', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._cont = ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TerminateOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        ('type', ___TerminateOperationalBindingResultData_notification__item__type),
        ('values', ___TerminateOperationalBindingResultData_notification__item__values),
        ('valuesWithContext', ___TerminateOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __TerminateOperationalBindingResultData_notification__item_._ext = []
    _TerminateOperationalBindingResultData_notification._cont = __TerminateOperationalBindingResultData_notification__item_
    TerminateOperationalBindingResultData._cont = ASN1Dict([
        ('bindingID', _TerminateOperationalBindingResultData_bindingID),
        ('bindingType', _TerminateOperationalBindingResultData_bindingType),
        ('terminateAt', _TerminateOperationalBindingResultData_terminateAt),
        ('securityParameters', _TerminateOperationalBindingResultData_securityParameters),
        ('performer', _TerminateOperationalBindingResultData_performer),
        ('aliasDereferenced', _TerminateOperationalBindingResultData_aliasDereferenced),
        ('notification', _TerminateOperationalBindingResultData_notification),
        ])
    TerminateOperationalBindingResultData._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    #-----< operationalBindingError >-----#
    operationalBindingError = CLASS(name='operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _operationalBindingError_val_ParameterType = CHOICE(name='ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __operationalBindingError_val_ParameterType_unsigned = SEQ(name='unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    __operationalBindingError_val_ParameterType_signed = SEQ(name='signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___operationalBindingError_val_ParameterType_signed_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = 'id'
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = 'Type'
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        ('parameters', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___operationalBindingError_val_ParameterType_signed_encrypted = BIT_STR(name='encrypted', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED-HASH')))
    __operationalBindingError_val_ParameterType_signed._cont = ASN1Dict([
        ('toBeSigned', ___operationalBindingError_val_ParameterType_signed_toBeSigned),
        ('algorithmIdentifier', ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier),
        ('encrypted', ___operationalBindingError_val_ParameterType_signed_encrypted),
        ])
    __operationalBindingError_val_ParameterType_signed._ext = []
    _operationalBindingError_val_ParameterType._cont = ASN1Dict([
        ('unsigned', __operationalBindingError_val_ParameterType_unsigned),
        ('signed', __operationalBindingError_val_ParameterType_signed),
        ])
    _operationalBindingError_val_ParameterType._ext = None
    operationalBindingError._val = dict([('ParameterType', _operationalBindingError_val_ParameterType), ('errorCode', ('local', 100))])
    
    #-----< OpBindingErrorParam >-----#
    OpBindingErrorParam = SEQ(name='OpBindingErrorParam', mode=MODE_TYPE)
    _OpBindingErrorParam_problem = ENUM(name='problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OpBindingErrorParam_problem._cont = ASN1Dict([('invalidID', 0), ('duplicateID', 1), ('unsupportedBindingType', 2), ('notAllowedForRole', 3), ('parametersMissing', 4), ('roleAssignment', 5), ('invalidStartTime', 6), ('invalidEndTime', 7), ('invalidAgreement', 8), ('currentlyNotDecidable', 9), ('modificationNotAllowed', 10), ('invalidBindingType', 11), ('invalidNewID', 12)])
    _OpBindingErrorParam_problem._ext = []
    _OpBindingErrorParam_bindingType = OID(name='bindingType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['id']), opt=True)
    __OpBindingErrorParam_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_0 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_1 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_2 = SEQ(name='Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OpBindingErrorParam_bindingType_tab._val = ASN1Set(rv=[dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_0), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 5))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))]), dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 4))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), ('ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_1), ('errorCode', ('local', 1))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), ('modify', True), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), ('terminate', True)])), ('id', (2, 5, 19, 1))]), dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_1), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), ('terminate', True)])), ('id', (2, 5, 19, 2))]), dict([('Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_2), ('Cooperation', ASN1Set(rv=[dict([('applContext', dict([('bind-operation', dict([('ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), ('ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), ('Operations', ASN1Set(rv=[dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 1))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 2))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_3), ('errorCode', ('local', 7))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 3))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_0), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 4))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5), ('errorCode', ('local', 5))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6), ('errorCode', ('local', 6))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 5))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 6))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 7))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_0), ('errorCode', ('local', 1))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_0), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_6_0), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 8))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_1), ('errorCode', ('local', 2))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_0), ('errorCode', ('local', 3))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_3_0), ('errorCode', ('local', 4))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_4_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_5_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 9))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 11))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1), ('errorCode', ('local', 6))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_1), ('errorCode', ('local', 8))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 10))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_1_2), ('errorCode', ('local', 7))]), dict([('ParameterType', __OPERATION_Errors_val_ParameterType_2_2), ('errorCode', ('local', 5))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 12))]), dict([('ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), ('ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), ('Errors', ASN1Set(rv=[dict([('ParameterType', __OPERATION_Errors_val_ParameterType_0_2), ('errorCode', ('local', 9))])], rr=[], ev=None, er=[])), ('operationCode', ('local', 13))])], rr=[], ev=None, er=[])), ('applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), ('roleA', dict([('EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), ('terminate', True)])), ('roleB', dict([('establish', True), ('EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), ('modify', True), ('ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), ('terminate', True)])), ('id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _OpBindingErrorParam_bindingType._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_bindingType._const_tab_at = None
    _OpBindingErrorParam_bindingType._const_tab_id = 'id'
    _OpBindingErrorParam_agreementProposal = OPEN(name='agreementProposal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), ['Agreement']), opt=True)
    _OpBindingErrorParam_agreementProposal._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_agreementProposal._const_tab_at = ('..', 'bindingType')
    _OpBindingErrorParam_agreementProposal._const_tab_id = 'Agreement'
    _OpBindingErrorParam_retryAt = CHOICE(name='retryAt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _OpBindingErrorParam_securityParameters = SET(name='securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _OpBindingErrorParam_performer = SEQ_OF(name='performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _OpBindingErrorParam_aliasDereferenced = BOOL(name='aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _OpBindingErrorParam_notification = SEQ_OF(name='notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OpBindingErrorParam_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___OpBindingErrorParam_notification__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____OpBindingErrorParam_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____OpBindingErrorParam_notification__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__type._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ___OpBindingErrorParam_notification__item__type._const_tab_at = None
    ___OpBindingErrorParam_notification__item__type._const_tab_id = 'id'
    ___OpBindingErrorParam_notification__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____OpBindingErrorParam_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____OpBindingErrorParam_notification__item__values__item_._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_id = 'Type'
    ___OpBindingErrorParam_notification__item__values._cont = ____OpBindingErrorParam_notification__item__values__item_
    ___OpBindingErrorParam_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_id = 'Type'
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._cont = ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____OpBindingErrorParam_notification__item__valuesWithContext__item__value),
        ('contextList', _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList),
        ])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._ext = []
    ___OpBindingErrorParam_notification__item__valuesWithContext._cont = ____OpBindingErrorParam_notification__item__valuesWithContext__item_
    ___OpBindingErrorParam_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __OpBindingErrorParam_notification__item_._cont = ASN1Dict([
        ('type', ___OpBindingErrorParam_notification__item__type),
        ('values', ___OpBindingErrorParam_notification__item__values),
        ('valuesWithContext', ___OpBindingErrorParam_notification__item__valuesWithContext),
        ])
    __OpBindingErrorParam_notification__item_._ext = []
    _OpBindingErrorParam_notification._cont = __OpBindingErrorParam_notification__item_
    OpBindingErrorParam._cont = ASN1Dict([
        ('problem', _OpBindingErrorParam_problem),
        ('bindingType', _OpBindingErrorParam_bindingType),
        ('agreementProposal', _OpBindingErrorParam_agreementProposal),
        ('retryAt', _OpBindingErrorParam_retryAt),
        ('securityParameters', _OpBindingErrorParam_securityParameters),
        ('performer', _OpBindingErrorParam_performer),
        ('aliasDereferenced', _OpBindingErrorParam_aliasDereferenced),
        ('notification', _OpBindingErrorParam_notification),
        ])
    OpBindingErrorParam._ext = ['securityParameters', 'performer', 'aliasDereferenced', 'notification']
    
    _all_ = [
        dSAOperationalBindingManagementBind,
        _dSAOperationalBindingManagementBind_val_ArgumentType,
        _dSAOperationalBindingManagementBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _OPERATIONAL_BINDING_Agreement,
        _OPERATIONAL_BINDING_Cooperation,
        _OPERATIONAL_BINDING_both,
        _OPERATIONAL_BINDING_roleA,
        _OPERATIONAL_BINDING_roleB,
        _OPERATIONAL_BINDING_id,
        OPERATIONAL_BINDING,
        _OP_BINDING_COOP_applContext,
        _OP_BINDING_COOP_Operations,
        OP_BINDING_COOP,
        _OP_BIND_ROLE_establish,
        _OP_BIND_ROLE_EstablishParam,
        _OP_BIND_ROLE_modify,
        _OP_BIND_ROLE_ModifyParam,
        _OP_BIND_ROLE_terminate,
        _OP_BIND_ROLE_TerminateParam,
        OP_BIND_ROLE,
        establishOperationalBinding,
        _establishOperationalBinding_val_ArgumentType,
        _establishOperationalBinding_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _EstablishOperationalBindingArgument_unsigned,
        __EstablishOperationalBindingArgument_signed_toBeSigned,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingArgument_signed_algorithmIdentifier,
        __EstablishOperationalBindingArgument_signed_encrypted,
        _EstablishOperationalBindingArgument_signed,
        EstablishOperationalBindingArgument,
        __EstablishOperationalBindingArgumentData_bindingType_tab,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_1,
        __OP_BINDING_COOP_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0_0,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_encrypted,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_encrypted,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_0,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam_0,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_1,
        _EstablishOperationalBindingArgumentData_bindingType,
        _EstablishOperationalBindingArgumentData_bindingID,
        _EstablishOperationalBindingArgumentData_accessPoint,
        __EstablishOperationalBindingArgumentData_initiator_symmetric,
        __EstablishOperationalBindingArgumentData_initiator_roleA_initiates,
        __EstablishOperationalBindingArgumentData_initiator_roleB_initiates,
        _EstablishOperationalBindingArgumentData_initiator,
        _EstablishOperationalBindingArgumentData_agreement,
        _EstablishOperationalBindingArgumentData_valid,
        _EstablishOperationalBindingArgumentData_securityParameters,
        EstablishOperationalBindingArgumentData,
        OpBindingSet,
        _OpBindingSet_val_Agreement_0,
        _OpBindingSet_val_Agreement_1,
        _OpBindingSet_val_Agreement_2,
        _OperationalBindingID_identifier,
        _OperationalBindingID_version,
        OperationalBindingID,
        __Validity_validFrom_now,
        __Validity_validFrom_time,
        _Validity_validFrom,
        __Validity_validUntil_explicitTermination,
        __Validity_validUntil_time,
        _Validity_validUntil,
        Validity,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _EstablishOperationalBindingResult_unsigned,
        __EstablishOperationalBindingResult_signed_toBeSigned,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingResult_signed_algorithmIdentifier,
        __EstablishOperationalBindingResult_signed_encrypted,
        _EstablishOperationalBindingResult_signed,
        EstablishOperationalBindingResult,
        __EstablishOperationalBindingResultData_bindingType_tab,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _EstablishOperationalBindingResultData_bindingType,
        _EstablishOperationalBindingResultData_bindingID,
        _EstablishOperationalBindingResultData_accessPoint,
        __EstablishOperationalBindingResultData_initiator_symmetric,
        __EstablishOperationalBindingResultData_initiator_roleA_replies,
        __EstablishOperationalBindingResultData_initiator_roleB_replies,
        _EstablishOperationalBindingResultData_initiator,
        _EstablishOperationalBindingResultData_securityParameters,
        _EstablishOperationalBindingResultData_performer,
        _EstablishOperationalBindingResultData_aliasDereferenced,
        ____EstablishOperationalBindingResultData_notification__item__type_tab,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        ___EstablishOperationalBindingResultData_notification__item__type,
        ____EstablishOperationalBindingResultData_notification__item__values__item_,
        ___EstablishOperationalBindingResultData_notification__item__values,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___EstablishOperationalBindingResultData_notification__item__valuesWithContext,
        __EstablishOperationalBindingResultData_notification__item_,
        _EstablishOperationalBindingResultData_notification,
        EstablishOperationalBindingResultData,
        modifyOperationalBinding,
        _modifyOperationalBinding_val_ArgumentType,
        _modifyOperationalBinding_val_ResultType,
        _ModifyOperationalBindingArgument_unsigned,
        __ModifyOperationalBindingArgument_signed_toBeSigned,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __ModifyOperationalBindingArgument_signed_algorithmIdentifier,
        __ModifyOperationalBindingArgument_signed_encrypted,
        _ModifyOperationalBindingArgument_signed,
        ModifyOperationalBindingArgument,
        __ModifyOperationalBindingArgumentData_bindingType_tab,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingArgumentData_bindingType,
        _ModifyOperationalBindingArgumentData_bindingID,
        _ModifyOperationalBindingArgumentData_accessPoint,
        __ModifyOperationalBindingArgumentData_initiator_symmetric,
        __ModifyOperationalBindingArgumentData_initiator_roleA_initiates,
        __ModifyOperationalBindingArgumentData_initiator_roleB_initiates,
        _ModifyOperationalBindingArgumentData_initiator,
        _ModifyOperationalBindingArgumentData_newBindingID,
        _ModifyOperationalBindingArgumentData_newAgreement,
        _ModifyOperationalBindingArgumentData_valid,
        _ModifyOperationalBindingArgumentData_securityParameters,
        ModifyOperationalBindingArgumentData,
        __ModifiedValidity_validFrom_now,
        __ModifiedValidity_validFrom_time,
        _ModifiedValidity_validFrom,
        __ModifiedValidity_validUntil_explicitTermination,
        __ModifiedValidity_validUntil_time,
        __ModifiedValidity_validUntil_unchanged,
        _ModifiedValidity_validUntil,
        ModifiedValidity,
        _ModifyOperationalBindingResult_null,
        __ModifyOperationalBindingResult_protected_unsigned,
        ___ModifyOperationalBindingResult_protected_signed_toBeSigned,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___ModifyOperationalBindingResult_protected_signed_encrypted,
        __ModifyOperationalBindingResult_protected_signed,
        _ModifyOperationalBindingResult_protected,
        ModifyOperationalBindingResult,
        _ModifyOperationalBindingResultData_newBindingID,
        __ModifyOperationalBindingResultData_bindingType_tab,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingResultData_bindingType,
        _ModifyOperationalBindingResultData_newAgreement,
        _ModifyOperationalBindingResultData_valid,
        _ModifyOperationalBindingResultData_securityParameters,
        _ModifyOperationalBindingResultData_performer,
        _ModifyOperationalBindingResultData_aliasDereferenced,
        ____ModifyOperationalBindingResultData_notification__item__type_tab,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___ModifyOperationalBindingResultData_notification__item__type,
        ____ModifyOperationalBindingResultData_notification__item__values__item_,
        ___ModifyOperationalBindingResultData_notification__item__values,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___ModifyOperationalBindingResultData_notification__item__valuesWithContext,
        __ModifyOperationalBindingResultData_notification__item_,
        _ModifyOperationalBindingResultData_notification,
        ModifyOperationalBindingResultData,
        terminateOperationalBinding,
        _terminateOperationalBinding_val_ArgumentType,
        _terminateOperationalBinding_val_ResultType,
        _TerminateOperationalBindingArgument_unsigned,
        __TerminateOperationalBindingArgument_signed_toBeSigned,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __TerminateOperationalBindingArgument_signed_algorithmIdentifier,
        __TerminateOperationalBindingArgument_signed_encrypted,
        _TerminateOperationalBindingArgument_signed,
        TerminateOperationalBindingArgument,
        __TerminateOperationalBindingArgumentData_bindingType_tab,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingArgumentData_bindingType,
        _TerminateOperationalBindingArgumentData_bindingID,
        __TerminateOperationalBindingArgumentData_initiator_symmetric,
        __TerminateOperationalBindingArgumentData_initiator_roleA_initiates,
        __TerminateOperationalBindingArgumentData_initiator_roleB_initiates,
        _TerminateOperationalBindingArgumentData_initiator,
        _TerminateOperationalBindingArgumentData_terminateAt,
        _TerminateOperationalBindingArgumentData_securityParameters,
        TerminateOperationalBindingArgumentData,
        _TerminateOperationalBindingResult_null,
        __TerminateOperationalBindingResult_protected_unsigned,
        ___TerminateOperationalBindingResult_protected_signed_toBeSigned,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___TerminateOperationalBindingResult_protected_signed_encrypted,
        __TerminateOperationalBindingResult_protected_signed,
        _TerminateOperationalBindingResult_protected,
        TerminateOperationalBindingResult,
        _TerminateOperationalBindingResultData_bindingID,
        __TerminateOperationalBindingResultData_bindingType_tab,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingResultData_bindingType,
        _TerminateOperationalBindingResultData_terminateAt,
        _TerminateOperationalBindingResultData_securityParameters,
        _TerminateOperationalBindingResultData_performer,
        _TerminateOperationalBindingResultData_aliasDereferenced,
        ____TerminateOperationalBindingResultData_notification__item__type_tab,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___TerminateOperationalBindingResultData_notification__item__type,
        ____TerminateOperationalBindingResultData_notification__item__values__item_,
        ___TerminateOperationalBindingResultData_notification__item__values,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___TerminateOperationalBindingResultData_notification__item__valuesWithContext,
        __TerminateOperationalBindingResultData_notification__item_,
        _TerminateOperationalBindingResultData_notification,
        TerminateOperationalBindingResultData,
        operationalBindingError,
        __operationalBindingError_val_ParameterType_unsigned,
        ___operationalBindingError_val_ParameterType_signed_toBeSigned,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier,
        ___operationalBindingError_val_ParameterType_signed_encrypted,
        __operationalBindingError_val_ParameterType_signed,
        _operationalBindingError_val_ParameterType,
        _OpBindingErrorParam_problem,
        __OpBindingErrorParam_bindingType_tab,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_0,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_1,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_2,
        _OpBindingErrorParam_bindingType,
        _OpBindingErrorParam_agreementProposal,
        _OpBindingErrorParam_retryAt,
        _OpBindingErrorParam_securityParameters,
        _OpBindingErrorParam_performer,
        _OpBindingErrorParam_aliasDereferenced,
        ____OpBindingErrorParam_notification__item__type_tab,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_0,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_1,
        ___OpBindingErrorParam_notification__item__type,
        ____OpBindingErrorParam_notification__item__values__item_,
        ___OpBindingErrorParam_notification__item__values,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__value,
        ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList,
        ____OpBindingErrorParam_notification__item__valuesWithContext__item_,
        ___OpBindingErrorParam_notification__item__valuesWithContext,
        __OpBindingErrorParam_notification__item_,
        _OpBindingErrorParam_notification,
        OpBindingErrorParam,
    ]

class OSIProtocolSpecification:

    _name_  = 'OSIProtocolSpecification'
    _oid_   = [2, 5, 1, 36, 7]
    
    _obj_ = [
        'OSI-PDU',
        'OsiBind',
        'Presentation-selector',
        'Context-list',
        'Presentation-context-identifier',
        'Abstract-syntax-name',
        'Transfer-syntax-name',
        'AARQ-apdu',
        'Association-informationBind',
        'Application-context-name',
        'AP-invocation-identifier',
        'AE-invocation-identifier',
        'Implementation-data',
        'TheOsiBind',
        'OsiBindResult',
        'Result',
        'AARE-apdu',
        'Association-informationBindRes',
        'Associate-result',
        'Associate-source-diagnostic',
        'TheOsiBindRes',
        'OsiBindError',
        'Result-list',
        'Provider-reason',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiUnbind',
        'TheOsiUnbind',
        'Release-request-reason',
        'OsiUnbindResult',
        'TheOsiUnbindRes',
        'Release-response-reason',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        'OsiRej',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'PresentationAbort',
        'ARU-PPDU',
        'Presentation-context-identifier-list',
        'ABRT-apdu',
        'ABRT-source',
        'ARP-PPDU',
        'Abort-reason',
        'Event-identifier',
        ]
    _type_ = [
        'OSI-PDU',
        'OsiBind',
        'Presentation-selector',
        'Context-list',
        'Presentation-context-identifier',
        'Abstract-syntax-name',
        'Transfer-syntax-name',
        'AARQ-apdu',
        'Association-informationBind',
        'Application-context-name',
        'AP-invocation-identifier',
        'AE-invocation-identifier',
        'Implementation-data',
        'TheOsiBind',
        'OsiBindResult',
        'Result',
        'AARE-apdu',
        'Association-informationBindRes',
        'Associate-result',
        'Associate-source-diagnostic',
        'TheOsiBindRes',
        'OsiBindError',
        'Result-list',
        'Provider-reason',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiUnbind',
        'TheOsiUnbind',
        'Release-request-reason',
        'OsiUnbindResult',
        'TheOsiUnbindRes',
        'Release-response-reason',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        'OsiRej',
        'GeneralProblem',
        'InvokeProblem',
        'ReturnResultProblem',
        'ReturnErrorProblem',
        'PresentationAbort',
        'ARU-PPDU',
        'Presentation-context-identifier-list',
        'ABRT-apdu',
        'ABRT-source',
        'ARP-PPDU',
        'Abort-reason',
        'Event-identifier',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        'OSI-PDU',
        'OsiBind',
        'AARQ-apdu',
        'Association-informationBind',
        'TheOsiBind',
        'OsiBindResult',
        'AARE-apdu',
        'Association-informationBindRes',
        'TheOsiBindRes',
        'OsiBindError',
        'AAREerr-apdu',
        'Association-informationBindErr',
        'TheOsiBindErr',
        'OsiOperation',
        'OsiDirectoryOperation',
        'OsiReq',
        'OsiRes',
        'OsiErr',
        ]
    
    #-----< OSI-PDU >-----#
    OSI_PDU = OPEN(name='OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']), param=True)
    
    #-----< OsiBind >-----#
    OsiBind = SET(name='OsiBind', mode=MODE_TYPE, param=True)
    
    #-----< Presentation-selector >-----#
    Presentation_selector = OCT_STR(name='Presentation-selector', mode=MODE_TYPE)
    Presentation_selector._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[ASN1RangeInt(lb=5, ub=None)])
    
    #-----< Context-list >-----#
    Context_list = SEQ_OF(name='Context-list', mode=MODE_TYPE)
    _Context_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Context_list__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Context_list__item__abstract_syntax_name = OID(name='abstract-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Abstract-syntax-name')))
    __Context_list__item__transfer_syntax_name_list = SEQ_OF(name='transfer-syntax-name-list', mode=MODE_TYPE)
    ___Context_list__item__transfer_syntax_name_list__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    __Context_list__item__transfer_syntax_name_list._cont = ___Context_list__item__transfer_syntax_name_list__item_
    _Context_list__item_._cont = ASN1Dict([
        ('presentation-context-identifier', __Context_list__item__presentation_context_identifier),
        ('abstract-syntax-name', __Context_list__item__abstract_syntax_name),
        ('transfer-syntax-name-list', __Context_list__item__transfer_syntax_name_list),
        ])
    _Context_list__item_._ext = None
    Context_list._cont = _Context_list__item_
    Context_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Presentation-context-identifier >-----#
    Presentation_context_identifier = INT(name='Presentation-context-identifier', mode=MODE_TYPE)
    Presentation_context_identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=[], er=[ASN1RangeInt(lb=128, ub=None)])
    
    #-----< Abstract-syntax-name >-----#
    Abstract_syntax_name = OID(name='Abstract-syntax-name', mode=MODE_TYPE)
    
    #-----< Transfer-syntax-name >-----#
    Transfer_syntax_name = OID(name='Transfer-syntax-name', mode=MODE_TYPE)
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name='AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBind >-----#
    Association_informationBind = SEQ_OF(name='Association-informationBind', mode=MODE_TYPE, param=True)
    
    #-----< Application-context-name >-----#
    Application_context_name = OID(name='Application-context-name', mode=MODE_TYPE)
    
    #-----< AP-invocation-identifier >-----#
    AP_invocation_identifier = INT(name='AP-invocation-identifier', mode=MODE_TYPE)
    
    #-----< AE-invocation-identifier >-----#
    AE_invocation_identifier = INT(name='AE-invocation-identifier', mode=MODE_TYPE)
    
    #-----< Implementation-data >-----#
    Implementation_data = STR_GRAPH(name='Implementation-data', mode=MODE_TYPE)
    
    #-----< TheOsiBind >-----#
    TheOsiBind = OPEN(name='TheOsiBind', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'ArgumentType']), param=True)
    
    #-----< OsiBindResult >-----#
    OsiBindResult = SET(name='OsiBindResult', mode=MODE_TYPE, param=True)
    
    #-----< Result >-----#
    Result = INT(name='Result', mode=MODE_TYPE)
    Result._cont = ASN1Dict([('acceptance', 0), ('user-rejection', 1), ('provider-rejection', 2)])
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name='AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindRes >-----#
    Association_informationBindRes = SEQ_OF(name='Association-informationBindRes', mode=MODE_TYPE, param=True)
    
    #-----< Associate-result >-----#
    Associate_result = INT(name='Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([('accepted', 0), ('rejected-permanent', 1), ('rejected-transient', 2)])
    Associate_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name='Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_acse_service_user = INT(name='acse-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_user._cont = ASN1Dict([('null', 0), ('no-reason-give', 1), ('application-context-name-not-supported', 2), ('calling-AP-title-not-recognized', 3), ('calling-AP-invocation-identifier-not-recognized', 4), ('calling-AE-qualifier-not-recognized', 5), ('calling-AE-invocation-identifier-not-recognized', 6), ('called-AP-title-not-recognized', 7), ('called-AP-invocation-identifier-not-recognized', 8), ('called-AE-qualifier-not-recognized', 9), ('called-AE-invocation-identifier-not-recognized', 10)])
    _Associate_source_diagnostic_acse_service_user._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=[], er=[])
    _Associate_source_diagnostic_acse_service_provider = INT(name='acse-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_provider._cont = ASN1Dict([('null', 0), ('no-reason-given', 1), ('no-common-acse-version', 2)])
    _Associate_source_diagnostic_acse_service_provider._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    Associate_source_diagnostic._cont = ASN1Dict([
        ('acse-service-user', _Associate_source_diagnostic_acse_service_user),
        ('acse-service-provider', _Associate_source_diagnostic_acse_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< TheOsiBindRes >-----#
    TheOsiBindRes = OPEN(name='TheOsiBindRes', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'ResultType']), param=True)
    
    #-----< OsiBindError >-----#
    OsiBindError = CHOICE(name='OsiBindError', mode=MODE_TYPE, param=True)
    
    #-----< Result-list >-----#
    Result_list = SEQ_OF(name='Result-list', mode=MODE_TYPE)
    _Result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Result_list__item__result = INT(name='result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    __Result_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    __Result_list__item__provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Result_list__item__provider_reason._cont = ASN1Dict([('reason-not-specified', 0), ('abstract-syntax-not-supported', 1), ('proposed-transfer-syntaxes-not-supported', 2)])
    _Result_list__item_._cont = ASN1Dict([
        ('result', __Result_list__item__result),
        ('transfer-syntax-name', __Result_list__item__transfer_syntax_name),
        ('provider-reason', __Result_list__item__provider_reason),
        ])
    _Result_list__item_._ext = None
    Result_list._cont = _Result_list__item_
    Result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Provider-reason >-----#
    Provider_reason = INT(name='Provider-reason', mode=MODE_TYPE)
    Provider_reason._cont = ASN1Dict([('reason-not-specified', 0), ('temporary-congestion', 1), ('local-limit-exceeded', 2), ('called-presentation-address-unknown', 3), ('protocol-version-not-supported', 4), ('default-context-not-supported', 5), ('user-data-not-readable', 6), ('no-PSAP-available', 7)])
    
    #-----< AAREerr-apdu >-----#
    AAREerr_apdu = SEQ(name='AAREerr-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindErr >-----#
    Association_informationBindErr = SEQ_OF(name='Association-informationBindErr', mode=MODE_TYPE, param=True)
    
    #-----< TheOsiBindErr >-----#
    TheOsiBindErr = OPEN(name='TheOsiBindErr', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), ['bind-operation', 'Errors', 'ParameterType']), param=True)
    
    #-----< OsiUnbind >-----#
    OsiUnbind = CHOICE(name='OsiUnbind', mode=MODE_TYPE)
    _OsiUnbind_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbind_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbind')))
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbind_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ___OsiUnbind_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbind_fully_encoded_data__item_._ext = None
    _OsiUnbind_fully_encoded_data._cont = __OsiUnbind_fully_encoded_data__item_
    _OsiUnbind_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbind._cont = ASN1Dict([
        ('fully-encoded-data', _OsiUnbind_fully_encoded_data),
        ])
    OsiUnbind._ext = None
    
    #-----< TheOsiUnbind >-----#
    TheOsiUnbind = SEQ(name='TheOsiUnbind', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbind_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-request-reason')), opt=True)
    TheOsiUnbind._cont = ASN1Dict([
        ('reason', _TheOsiUnbind_reason),
        ])
    TheOsiUnbind._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name='Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([('normal', 0)])
    
    #-----< OsiUnbindResult >-----#
    OsiUnbindResult = CHOICE(name='OsiUnbindResult', mode=MODE_TYPE)
    _OsiUnbindResult_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbindResult_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbindRes')))
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbindResult_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbindResult_fully_encoded_data__item_._ext = None
    _OsiUnbindResult_fully_encoded_data._cont = __OsiUnbindResult_fully_encoded_data__item_
    _OsiUnbindResult_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbindResult._cont = ASN1Dict([
        ('fully-encoded-data', _OsiUnbindResult_fully_encoded_data),
        ])
    OsiUnbindResult._ext = None
    
    #-----< TheOsiUnbindRes >-----#
    TheOsiUnbindRes = SEQ(name='TheOsiUnbindRes', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbindRes_reason = INT(name='reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-response-reason')), opt=True)
    TheOsiUnbindRes._cont = ASN1Dict([
        ('reason', _TheOsiUnbindRes_reason),
        ])
    TheOsiUnbindRes._ext = None
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name='Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([('normal', 0)])
    
    #-----< OsiOperation >-----#
    OsiOperation = CHOICE(name='OsiOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiDirectoryOperation >-----#
    OsiDirectoryOperation = CHOICE(name='OsiDirectoryOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiReq >-----#
    OsiReq = SEQ(name='OsiReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRes >-----#
    OsiRes = SEQ(name='OsiRes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiErr >-----#
    OsiErr = SEQ(name='OsiErr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRej >-----#
    OsiRej = SEQ(name='OsiRej', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OsiRej_invokeId = CHOICE(name='invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _OsiRej_problem = CHOICE(name='problem', mode=MODE_TYPE)
    __OsiRej_problem_general = INT(name='general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'GeneralProblem')))
    __OsiRej_problem_invoke = INT(name='invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'InvokeProblem')))
    __OsiRej_problem_returnResult = INT(name='returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnResultProblem')))
    __OsiRej_problem_returnError = INT(name='returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnErrorProblem')))
    _OsiRej_problem._cont = ASN1Dict([
        ('general', __OsiRej_problem_general),
        ('invoke', __OsiRej_problem_invoke),
        ('returnResult', __OsiRej_problem_returnResult),
        ('returnError', __OsiRej_problem_returnError),
        ])
    _OsiRej_problem._ext = []
    OsiRej._cont = ASN1Dict([
        ('invokeId', _OsiRej_invokeId),
        ('problem', _OsiRej_problem),
        ])
    OsiRej._ext = []
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name='GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([('unrecognizedPDU', 0), ('mistypedPDU', 1), ('badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name='InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([('duplicateInvocation', 0), ('unrecognizedOperation', 1), ('mistypedArgument', 2), ('resourceLimitation', 3), ('releaseInProgress', 4)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name='ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('resultResponseUnexpected', 1), ('mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name='ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([('unrecognizedInvocation', 0), ('errorResponseUnexpected', 1), ('unrecognizedError', 2), ('unexpectedError', 3), ('mistypedParameter', 4)])
    
    #-----< PresentationAbort >-----#
    PresentationAbort = CHOICE(name='PresentationAbort', mode=MODE_TYPE)
    _PresentationAbort_aru_ppdu = CHOICE(name='aru-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARU-PPDU')))
    _PresentationAbort_arp_ppdu = SEQ(name='arp-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARP-PPDU')))
    PresentationAbort._cont = ASN1Dict([
        ('aru-ppdu', _PresentationAbort_aru_ppdu),
        ('arp-ppdu', _PresentationAbort_arp_ppdu),
        ])
    PresentationAbort._ext = None
    
    #-----< ARU-PPDU >-----#
    ARU_PPDU = CHOICE(name='ARU-PPDU', mode=MODE_TYPE)
    _ARU_PPDU_normal_mode_parameters = SEQ(name='normal-mode-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list = SEQ_OF(name='presentation-context-identifier-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier-list')))
    __ARU_PPDU_normal_mode_parameters_user_data = CHOICE(name='user-data', mode=MODE_TYPE)
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name='fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name='presentation-data-values', mode=MODE_TYPE)
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name='single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', 'ABSTRACT-SYNTAX'), ['Type']))
    _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name='single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-apdu')))
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        ('single-ASN1-type', ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        ('presentation-context-identifier', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        ('presentation-data-values', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._cont = ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ARU_PPDU_normal_mode_parameters_user_data._cont = ASN1Dict([
        ('fully-encoded-data', ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    __ARU_PPDU_normal_mode_parameters_user_data._ext = None
    _ARU_PPDU_normal_mode_parameters._cont = ASN1Dict([
        ('presentation-context-identifier-list', __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list),
        ('user-data', __ARU_PPDU_normal_mode_parameters_user_data),
        ])
    _ARU_PPDU_normal_mode_parameters._ext = None
    ARU_PPDU._cont = ASN1Dict([
        ('normal-mode-parameters', _ARU_PPDU_normal_mode_parameters),
        ])
    ARU_PPDU._ext = None
    
    #-----< Presentation-context-identifier-list >-----#
    Presentation_context_identifier_list = SEQ_OF(name='Presentation-context-identifier-list', mode=MODE_TYPE)
    _Presentation_context_identifier_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Presentation_context_identifier_list__item__presentation_context_identifier = INT(name='presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Presentation_context_identifier_list__item__transfer_syntax_name = OID(name='transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    _Presentation_context_identifier_list__item_._cont = ASN1Dict([
        ('presentation-context-identifier', __Presentation_context_identifier_list__item__presentation_context_identifier),
        ('transfer-syntax-name', __Presentation_context_identifier_list__item__transfer_syntax_name),
        ])
    _Presentation_context_identifier_list__item_._ext = None
    Presentation_context_identifier_list._cont = _Presentation_context_identifier_list__item_
    Presentation_context_identifier_list._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name='ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name='abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-source')))
    ABRT_apdu._cont = ASN1Dict([
        ('abort-source', _ABRT_apdu_abort_source),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name='ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([('acse-service-user', 0), ('acse-service-provider', 1)])
    
    #-----< ARP-PPDU >-----#
    ARP_PPDU = SEQ(name='ARP-PPDU', mode=MODE_TYPE)
    _ARP_PPDU_provider_reason = INT(name='provider-reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Abort-reason')), opt=True)
    _ARP_PPDU_event_identifier = INT(name='event-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Event-identifier')), opt=True)
    ARP_PPDU._cont = ASN1Dict([
        ('provider-reason', _ARP_PPDU_provider_reason),
        ('event-identifier', _ARP_PPDU_event_identifier),
        ])
    ARP_PPDU._ext = None
    
    #-----< Abort-reason >-----#
    Abort_reason = INT(name='Abort-reason', mode=MODE_TYPE)
    Abort_reason._cont = ASN1Dict([('reason-not-specified', 0), ('unrecognized-ppdu', 1), ('unexpected-ppdu', 2), ('unexpected-session-service-primitive', 3), ('unrecognized-ppdu-parameter', 4), ('unexpected-ppdu-parameter', 5), ('invalid-ppdu-parameter-value', 6)])
    
    #-----< Event-identifier >-----#
    Event_identifier = INT(name='Event-identifier', mode=MODE_TYPE)
    Event_identifier._cont = ASN1Dict([('cp-PPDU', 0), ('cpa-PPDU', 1), ('cpr-PPDU', 2), ('aru-PPDU', 3), ('arp-PPDU', 4), ('td-PPDU', 7), ('s-release-indication', 14), ('s-release-confirm', 15)])
    
    _all_ = [
        Presentation_selector,
        __Context_list__item__presentation_context_identifier,
        __Context_list__item__abstract_syntax_name,
        ___Context_list__item__transfer_syntax_name_list__item_,
        __Context_list__item__transfer_syntax_name_list,
        _Context_list__item_,
        Context_list,
        Presentation_context_identifier,
        Abstract_syntax_name,
        Transfer_syntax_name,
        Application_context_name,
        AP_invocation_identifier,
        AE_invocation_identifier,
        Implementation_data,
        Result,
        Associate_result,
        _Associate_source_diagnostic_acse_service_user,
        _Associate_source_diagnostic_acse_service_provider,
        Associate_source_diagnostic,
        __Result_list__item__result,
        __Result_list__item__transfer_syntax_name,
        __Result_list__item__provider_reason,
        _Result_list__item_,
        Result_list,
        Provider_reason,
        ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbind_fully_encoded_data__item__presentation_data_values,
        __OsiUnbind_fully_encoded_data__item_,
        _OsiUnbind_fully_encoded_data,
        OsiUnbind,
        _TheOsiUnbind_reason,
        TheOsiUnbind,
        Release_request_reason,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values,
        __OsiUnbindResult_fully_encoded_data__item_,
        _OsiUnbindResult_fully_encoded_data,
        OsiUnbindResult,
        _TheOsiUnbindRes_reason,
        TheOsiUnbindRes,
        Release_response_reason,
        _OsiRej_invokeId,
        __OsiRej_problem_general,
        __OsiRej_problem_invoke,
        __OsiRej_problem_returnResult,
        __OsiRej_problem_returnError,
        _OsiRej_problem,
        OsiRej,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        _PresentationAbort_aru_ppdu,
        _PresentationAbort_arp_ppdu,
        PresentationAbort,
        __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data,
        __ARU_PPDU_normal_mode_parameters_user_data,
        _ARU_PPDU_normal_mode_parameters,
        ARU_PPDU,
        __Presentation_context_identifier_list__item__presentation_context_identifier,
        __Presentation_context_identifier_list__item__transfer_syntax_name,
        _Presentation_context_identifier_list__item_,
        Presentation_context_identifier_list,
        _ABRT_apdu_abort_source,
        ABRT_apdu,
        ABRT_source,
        _ARP_PPDU_provider_reason,
        _ARP_PPDU_event_identifier,
        ARP_PPDU,
        Abort_reason,
        Event_identifier,
    ]

class PKIX1Implicit93:

    _name_  = 'PKIX1Implicit93'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 4]
    
    _obj_ = [
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        ]
    _type_ = [
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UserNotice >-----#
    UserNotice = SEQ(name='UserNotice', mode=MODE_TYPE)
    _UserNotice_noticeRef = SEQ(name='noticeRef', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit93', 'NoticeReference')), opt=True)
    _UserNotice_explicitText = CHOICE(name='explicitText', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit93', 'DisplayText')), opt=True)
    UserNotice._cont = ASN1Dict([
        ('noticeRef', _UserNotice_noticeRef),
        ('explicitText', _UserNotice_explicitText),
        ])
    UserNotice._ext = None
    
    #-----< NoticeReference >-----#
    NoticeReference = SEQ(name='NoticeReference', mode=MODE_TYPE)
    _NoticeReference_organization = CHOICE(name='organization', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit93', 'DisplayText')))
    _NoticeReference_noticeNumbers = SEQ_OF(name='noticeNumbers', mode=MODE_TYPE)
    __NoticeReference_noticeNumbers__item_ = INT(name='_item_', mode=MODE_TYPE)
    _NoticeReference_noticeNumbers._cont = __NoticeReference_noticeNumbers__item_
    NoticeReference._cont = ASN1Dict([
        ('organization', _NoticeReference_organization),
        ('noticeNumbers', _NoticeReference_noticeNumbers),
        ])
    NoticeReference._ext = None
    
    #-----< DisplayText >-----#
    DisplayText = CHOICE(name='DisplayText', mode=MODE_TYPE)
    _DisplayText_visibleString = STR_VIS(name='visibleString', mode=MODE_TYPE)
    _DisplayText_visibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _DisplayText_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_utf8String = STR_UTF8(name='utf8String', mode=MODE_TYPE)
    _DisplayText_utf8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    DisplayText._cont = ASN1Dict([
        ('visibleString', _DisplayText_visibleString),
        ('bmpString', _DisplayText_bmpString),
        ('utf8String', _DisplayText_utf8String),
        ])
    DisplayText._ext = None
    
    _all_ = [
        _UserNotice_noticeRef,
        _UserNotice_explicitText,
        UserNotice,
        _NoticeReference_organization,
        __NoticeReference_noticeNumbers__item_,
        _NoticeReference_noticeNumbers,
        NoticeReference,
        _DisplayText_visibleString,
        _DisplayText_bmpString,
        _DisplayText_utf8String,
        DisplayText,
    ]

class SchemaAdministration:

    _name_  = 'SchemaAdministration'
    _oid_   = [2, 5, 1, 23, 7]
    
    _obj_ = [
        'subschema',
        'dITStructureRules',
        'DITStructureRuleDescription',
        'dITContentRules',
        'DITContentRuleDescription',
        'matchingRules',
        'MatchingRuleDescription',
        'attributeTypes',
        'AttributeTypeDescription',
        'AttributeTypeInformation',
        'objectClasses',
        'ObjectClassDescription',
        'ObjectClassInformation',
        'nameForms',
        'NameFormDescription',
        'NameFormInformation',
        'matchingRuleUse',
        'MatchingRuleUseDescription',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'ContextDescription',
        'ContextInformation',
        'dITContextUse',
        'DITContextUseDescription',
        'DITContextUseInformation',
        'friends',
        'FriendsDescription',
        'id-soc-subschema',
        'id-soa-dITStructureRule',
        'id-soa-dITContentRules',
        'id-soa-matchingRules',
        'id-soa-attributeTypes',
        'id-soa-objectClasses',
        'id-soa-nameForms',
        'id-soa-matchingRuleUse',
        'id-soa-structuralObjectClass',
        'id-soa-governingStructureRule',
        'id-soa-contextTypes',
        'id-soa-dITContextUse',
        'id-soa-friends',
        ]
    _type_ = [
        'DITStructureRuleDescription',
        'DITContentRuleDescription',
        'MatchingRuleDescription',
        'AttributeTypeDescription',
        'AttributeTypeInformation',
        'ObjectClassDescription',
        'ObjectClassInformation',
        'NameFormDescription',
        'NameFormInformation',
        'MatchingRuleUseDescription',
        'ContextDescription',
        'ContextInformation',
        'DITContextUseDescription',
        'DITContextUseInformation',
        'FriendsDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        'subschema',
        'dITStructureRules',
        'dITContentRules',
        'matchingRules',
        'attributeTypes',
        'objectClasses',
        'nameForms',
        'matchingRuleUse',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'dITContextUse',
        'friends',
        'id-soc-subschema',
        'id-soa-dITStructureRule',
        'id-soa-dITContentRules',
        'id-soa-matchingRules',
        'id-soa-attributeTypes',
        'id-soa-objectClasses',
        'id-soa-nameForms',
        'id-soa-matchingRuleUse',
        'id-soa-structuralObjectClass',
        'id-soa-governingStructureRule',
        'id-soa-contextTypes',
        'id-soa-dITContextUse',
        'id-soa-friends',
        ]
    _class_ = [
        'subschema',
        'dITStructureRules',
        'dITContentRules',
        'matchingRules',
        'attributeTypes',
        'objectClasses',
        'nameForms',
        'matchingRuleUse',
        'structuralObjectClass',
        'governingStructureRule',
        'contextTypes',
        'dITContextUse',
        'friends',
        ]
    _param_ = [
        ]
    
    #-----< subschema >-----#
    subschema = CLASS(name='subschema', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = OID(name='AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_8 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_9 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_10 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    subschema._val = dict([('kind', 'auxiliary'), ('OptionalAttributes', ASN1Set(rv=[dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), ('ldapName', ['dITStructureRules']), ('id', (2, 5, 21, 1))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), ('ldapName', ['nameForms']), ('id', (2, 5, 21, 7))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), ('ldapName', ['dITContentRules']), ('id', (2, 5, 21, 2))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_3), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), ('ldapName', ['objectClasses']), ('id', (2, 5, 21, 6))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), ('ldapName', ['attributeTypes']), ('id', (2, 5, 21, 5))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_5), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 13))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 11))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_7), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 12))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_8), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), ('ldapName', ['matchingRules']), ('id', (2, 5, 21, 4))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_9), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), ('ldapName', ['matchingRuleUse']), ('id', (2, 5, 21, 8))]), dict([('Type', __OBJECT_CLASS_OptionalAttributes_val_Type_10), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), ('ldapName', ['ldapSyntax']), ('id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])], rr=[], ev=None, er=[])), ('ldapName', ['subschema']), ('id', (2, 5, 20, 1))])
    
    #-----< dITStructureRules >-----#
    dITStructureRules = CLASS(name='dITStructureRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITStructureRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRules._val = dict([('Type', _dITStructureRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), ('ldapName', ['dITStructureRules']), ('id', (2, 5, 21, 1))])
    
    #-----< DITStructureRuleDescription >-----#
    DITStructureRuleDescription = SEQ(name='DITStructureRuleDescription', mode=MODE_TYPE)
    _DITStructureRuleDescription_ruleIdentifier = INT(name='ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_nameForm = OID(name='nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _DITStructureRuleDescription_superiorStructureRules = SET_OF(name='superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRuleDescription_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_superiorStructureRules._cont = __DITStructureRuleDescription_superiorStructureRules__item_
    _DITStructureRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITStructureRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITStructureRuleDescription_name._cont = __DITStructureRuleDescription_name__item_
    _DITStructureRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITStructureRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITStructureRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    DITStructureRuleDescription._cont = ASN1Dict([
        ('ruleIdentifier', _DITStructureRuleDescription_ruleIdentifier),
        ('nameForm', _DITStructureRuleDescription_nameForm),
        ('superiorStructureRules', _DITStructureRuleDescription_superiorStructureRules),
        ('name', _DITStructureRuleDescription_name),
        ('description', _DITStructureRuleDescription_description),
        ('obsolete', _DITStructureRuleDescription_obsolete),
        ])
    DITStructureRuleDescription._ext = []
    
    #-----< dITContentRules >-----#
    dITContentRules = CLASS(name='dITContentRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContentRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRules._val = dict([('Type', _dITContentRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), ('ldapName', ['dITContentRules']), ('id', (2, 5, 21, 2))])
    
    #-----< DITContentRuleDescription >-----#
    DITContentRuleDescription = SEQ(name='DITContentRuleDescription', mode=MODE_TYPE)
    _DITContentRuleDescription_structuralObjectClass = OID(name='structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRuleDescription_auxiliaries = SET_OF(name='auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRuleDescription_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _DITContentRuleDescription_auxiliaries._cont = __DITContentRuleDescription_auxiliaries__item_
    _DITContentRuleDescription_mandatory = SET_OF(name='mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_mandatory._cont = __DITContentRuleDescription_mandatory__item_
    _DITContentRuleDescription_optional = SET_OF(name='optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_optional._cont = __DITContentRuleDescription_optional__item_
    _DITContentRuleDescription_precluded = SET_OF(name='precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContentRuleDescription_precluded._cont = __DITContentRuleDescription_precluded__item_
    _DITContentRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContentRuleDescription_name._cont = __DITContentRuleDescription_name__item_
    _DITContentRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContentRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    DITContentRuleDescription._cont = ASN1Dict([
        ('structuralObjectClass', _DITContentRuleDescription_structuralObjectClass),
        ('auxiliaries', _DITContentRuleDescription_auxiliaries),
        ('mandatory', _DITContentRuleDescription_mandatory),
        ('optional', _DITContentRuleDescription_optional),
        ('precluded', _DITContentRuleDescription_precluded),
        ('name', _DITContentRuleDescription_name),
        ('description', _DITContentRuleDescription_description),
        ('obsolete', _DITContentRuleDescription_obsolete),
        ])
    DITContentRuleDescription._ext = []
    
    #-----< matchingRules >-----#
    matchingRules = CLASS(name='matchingRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRules_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRules._val = dict([('Type', _matchingRules_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), ('ldapName', ['matchingRules']), ('id', (2, 5, 21, 4))])
    
    #-----< MatchingRuleDescription >-----#
    MatchingRuleDescription = SEQ(name='MatchingRuleDescription', mode=MODE_TYPE)
    _MatchingRuleDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __MatchingRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleDescription_name._cont = __MatchingRuleDescription_name__item_
    _MatchingRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleDescription_information = CHOICE(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    MatchingRuleDescription._cont = ASN1Dict([
        ('identifier', _MatchingRuleDescription_identifier),
        ('name', _MatchingRuleDescription_name),
        ('description', _MatchingRuleDescription_description),
        ('obsolete', _MatchingRuleDescription_obsolete),
        ('information', _MatchingRuleDescription_information),
        ])
    MatchingRuleDescription._ext = []
    
    #-----< attributeTypes >-----#
    attributeTypes = CLASS(name='attributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypes._val = dict([('Type', _attributeTypes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), ('ldapName', ['attributeTypes']), ('id', (2, 5, 21, 5))])
    
    #-----< AttributeTypeDescription >-----#
    AttributeTypeDescription = SEQ(name='AttributeTypeDescription', mode=MODE_TYPE)
    _AttributeTypeDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _AttributeTypeDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __AttributeTypeDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _AttributeTypeDescription_name._cont = __AttributeTypeDescription_name__item_
    _AttributeTypeDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeTypeDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _AttributeTypeDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeInformation')))
    AttributeTypeDescription._cont = ASN1Dict([
        ('identifier', _AttributeTypeDescription_identifier),
        ('name', _AttributeTypeDescription_name),
        ('description', _AttributeTypeDescription_description),
        ('obsolete', _AttributeTypeDescription_obsolete),
        ('information', _AttributeTypeDescription_information),
        ])
    AttributeTypeDescription._ext = []
    
    #-----< AttributeTypeInformation >-----#
    AttributeTypeInformation = SEQ(name='AttributeTypeInformation', mode=MODE_TYPE)
    _AttributeTypeInformation_derivation = OID(name='derivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']), opt=True)
    _AttributeTypeInformation_equalityMatch = OID(name='equalityMatch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_orderingMatch = OID(name='orderingMatch', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_substringsMatch = OID(name='substringsMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _AttributeTypeInformation_attributeSyntax = CHOICE(name='attributeSyntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeInformation_multi_valued = BOOL(name='multi-valued', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_collective = BOOL(name='collective', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeTypeInformation_userModifiable = BOOL(name='userModifiable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_application = ENUM(name='application', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default='userApplications')
    AttributeTypeInformation._cont = ASN1Dict([
        ('derivation', _AttributeTypeInformation_derivation),
        ('equalityMatch', _AttributeTypeInformation_equalityMatch),
        ('orderingMatch', _AttributeTypeInformation_orderingMatch),
        ('substringsMatch', _AttributeTypeInformation_substringsMatch),
        ('attributeSyntax', _AttributeTypeInformation_attributeSyntax),
        ('multi-valued', _AttributeTypeInformation_multi_valued),
        ('collective', _AttributeTypeInformation_collective),
        ('userModifiable', _AttributeTypeInformation_userModifiable),
        ('application', _AttributeTypeInformation_application),
        ])
    AttributeTypeInformation._ext = []
    
    #-----< objectClasses >-----#
    objectClasses = CLASS(name='objectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClasses_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClasses._val = dict([('Type', _objectClasses_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), ('ldapName', ['objectClasses']), ('id', (2, 5, 21, 6))])
    
    #-----< ObjectClassDescription >-----#
    ObjectClassDescription = SEQ(name='ObjectClassDescription', mode=MODE_TYPE)
    _ObjectClassDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _ObjectClassDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __ObjectClassDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ObjectClassDescription_name._cont = __ObjectClassDescription_name__item_
    _ObjectClassDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ObjectClassDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _ObjectClassDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassInformation')))
    ObjectClassDescription._cont = ASN1Dict([
        ('identifier', _ObjectClassDescription_identifier),
        ('name', _ObjectClassDescription_name),
        ('description', _ObjectClassDescription_description),
        ('obsolete', _ObjectClassDescription_obsolete),
        ('information', _ObjectClassDescription_information),
        ])
    ObjectClassDescription._ext = []
    
    #-----< ObjectClassInformation >-----#
    ObjectClassInformation = SEQ(name='ObjectClassInformation', mode=MODE_TYPE)
    _ObjectClassInformation_subclassOf = SET_OF(name='subclassOf', mode=MODE_TYPE, opt=True)
    __ObjectClassInformation_subclassOf__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _ObjectClassInformation_subclassOf._cont = __ObjectClassInformation_subclassOf__item_
    _ObjectClassInformation_subclassOf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_kind = ENUM(name='kind', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default='structural')
    _ObjectClassInformation_mandatories = SET_OF(name='mandatories', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_mandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _ObjectClassInformation_mandatories._cont = __ObjectClassInformation_mandatories__item_
    _ObjectClassInformation_mandatories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_optionals = SET_OF(name='optionals', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_optionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _ObjectClassInformation_optionals._cont = __ObjectClassInformation_optionals__item_
    _ObjectClassInformation_optionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ObjectClassInformation._cont = ASN1Dict([
        ('subclassOf', _ObjectClassInformation_subclassOf),
        ('kind', _ObjectClassInformation_kind),
        ('mandatories', _ObjectClassInformation_mandatories),
        ('optionals', _ObjectClassInformation_optionals),
        ])
    ObjectClassInformation._ext = []
    
    #-----< nameForms >-----#
    nameForms = CLASS(name='nameForms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nameForms_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameForms._val = dict([('Type', _nameForms_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), ('ldapName', ['nameForms']), ('id', (2, 5, 21, 7))])
    
    #-----< NameFormDescription >-----#
    NameFormDescription = SEQ(name='NameFormDescription', mode=MODE_TYPE)
    _NameFormDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), ['id']))
    _NameFormDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __NameFormDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _NameFormDescription_name._cont = __NameFormDescription_name__item_
    _NameFormDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NameFormDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _NameFormDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _NameFormDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'NameFormInformation')))
    NameFormDescription._cont = ASN1Dict([
        ('identifier', _NameFormDescription_identifier),
        ('name', _NameFormDescription_name),
        ('description', _NameFormDescription_description),
        ('obsolete', _NameFormDescription_obsolete),
        ('information', _NameFormDescription_information),
        ])
    NameFormDescription._ext = []
    
    #-----< NameFormInformation >-----#
    NameFormInformation = SEQ(name='NameFormInformation', mode=MODE_TYPE)
    _NameFormInformation_subordinate = OID(name='subordinate', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _NameFormInformation_namingMandatories = SET_OF(name='namingMandatories', mode=MODE_TYPE)
    __NameFormInformation_namingMandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _NameFormInformation_namingMandatories._cont = __NameFormInformation_namingMandatories__item_
    _NameFormInformation_namingOptionals = SET_OF(name='namingOptionals', mode=MODE_TYPE, opt=True)
    __NameFormInformation_namingOptionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _NameFormInformation_namingOptionals._cont = __NameFormInformation_namingOptionals__item_
    _NameFormInformation_namingOptionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NameFormInformation._cont = ASN1Dict([
        ('subordinate', _NameFormInformation_subordinate),
        ('namingMandatories', _NameFormInformation_namingMandatories),
        ('namingOptionals', _NameFormInformation_namingOptionals),
        ])
    NameFormInformation._ext = []
    
    #-----< matchingRuleUse >-----#
    matchingRuleUse = CLASS(name='matchingRuleUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleUse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUse._val = dict([('Type', _matchingRuleUse_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), ('ldapName', ['matchingRuleUse']), ('id', (2, 5, 21, 8))])
    
    #-----< MatchingRuleUseDescription >-----#
    MatchingRuleUseDescription = SEQ(name='MatchingRuleUseDescription', mode=MODE_TYPE)
    _MatchingRuleUseDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MatchingRuleUseDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __MatchingRuleUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleUseDescription_name._cont = __MatchingRuleUseDescription_name__item_
    _MatchingRuleUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleUseDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleUseDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleUseDescription_information = SET_OF(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleUseDescription_information__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _MatchingRuleUseDescription_information._cont = __MatchingRuleUseDescription_information__item_
    MatchingRuleUseDescription._cont = ASN1Dict([
        ('identifier', _MatchingRuleUseDescription_identifier),
        ('name', _MatchingRuleUseDescription_name),
        ('description', _MatchingRuleUseDescription_description),
        ('obsolete', _MatchingRuleUseDescription_obsolete),
        ('information', _MatchingRuleUseDescription_information),
        ])
    MatchingRuleUseDescription._ext = []
    
    #-----< structuralObjectClass >-----#
    structuralObjectClass = CLASS(name='structuralObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _structuralObjectClass_val_Type = OID(name='Type', mode=MODE_TYPE)
    structuralObjectClass._val = dict([('Type', _structuralObjectClass_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['structuralObjectClass']), ('id', (2, 5, 21, 9))])
    
    #-----< governingStructureRule >-----#
    governingStructureRule = CLASS(name='governingStructureRule', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _governingStructureRule_val_Type = INT(name='Type', mode=MODE_TYPE)
    governingStructureRule._val = dict([('Type', _governingStructureRule_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('no-user-modification', True), ('usage', 'directoryOperation'), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['governingStructureRule']), ('id', (2, 5, 21, 10))])
    
    #-----< contextTypes >-----#
    contextTypes = CLASS(name='contextTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypes_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    contextTypes._val = dict([('Type', _contextTypes_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 11))])
    
    #-----< ContextDescription >-----#
    ContextDescription = SEQ(name='ContextDescription', mode=MODE_TYPE)
    _ContextDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _ContextDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __ContextDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextDescription_name._cont = __ContextDescription_name__item_
    _ContextDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContextDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ContextDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _ContextDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ContextInformation')))
    ContextDescription._cont = ASN1Dict([
        ('identifier', _ContextDescription_identifier),
        ('name', _ContextDescription_name),
        ('description', _ContextDescription_description),
        ('obsolete', _ContextDescription_obsolete),
        ('information', _ContextDescription_information),
        ])
    ContextDescription._ext = []
    
    #-----< ContextInformation >-----#
    ContextInformation = SEQ(name='ContextInformation', mode=MODE_TYPE)
    _ContextInformation_syntax = CHOICE(name='syntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextInformation_assertionSyntax = CHOICE(name='assertionSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    ContextInformation._cont = ASN1Dict([
        ('syntax', _ContextInformation_syntax),
        ('assertionSyntax', _ContextInformation_assertionSyntax),
        ])
    ContextInformation._ext = []
    
    #-----< dITContextUse >-----#
    dITContextUse = CLASS(name='dITContextUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContextUse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    dITContextUse._val = dict([('Type', _dITContextUse_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 12))])
    
    #-----< DITContextUseDescription >-----#
    DITContextUseDescription = SEQ(name='DITContextUseDescription', mode=MODE_TYPE)
    _DITContextUseDescription_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _DITContextUseDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __DITContextUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContextUseDescription_name._cont = __DITContextUseDescription_name__item_
    _DITContextUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContextUseDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _DITContextUseDescription_information = SEQ(name='information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseInformation')))
    DITContextUseDescription._cont = ASN1Dict([
        ('identifier', _DITContextUseDescription_identifier),
        ('name', _DITContextUseDescription_name),
        ('description', _DITContextUseDescription_description),
        ('obsolete', _DITContextUseDescription_obsolete),
        ('information', _DITContextUseDescription_information),
        ])
    DITContextUseDescription._ext = []
    
    #-----< DITContextUseInformation >-----#
    DITContextUseInformation = SEQ(name='DITContextUseInformation', mode=MODE_TYPE)
    _DITContextUseInformation_mandatoryContexts = SET_OF(name='mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUseInformation_mandatoryContexts._cont = __DITContextUseInformation_mandatoryContexts__item_
    _DITContextUseInformation_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseInformation_optionalContexts = SET_OF(name='optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    _DITContextUseInformation_optionalContexts._cont = __DITContextUseInformation_optionalContexts__item_
    _DITContextUseInformation_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUseInformation._cont = ASN1Dict([
        ('mandatoryContexts', _DITContextUseInformation_mandatoryContexts),
        ('optionalContexts', _DITContextUseInformation_optionalContexts),
        ])
    DITContextUseInformation._ext = []
    
    #-----< friends >-----#
    friends = CLASS(name='friends', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _friends_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    friends._val = dict([('Type', _friends_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])), ('usage', 'directoryOperation'), ('id', (2, 5, 21, 13))])
    
    #-----< FriendsDescription >-----#
    FriendsDescription = SEQ(name='FriendsDescription', mode=MODE_TYPE)
    _FriendsDescription_anchor = OID(name='anchor', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _FriendsDescription_name = SET_OF(name='name', mode=MODE_TYPE, opt=True)
    __FriendsDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _FriendsDescription_name._cont = __FriendsDescription_name__item_
    _FriendsDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _FriendsDescription_description = CHOICE(name='description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _FriendsDescription_obsolete = BOOL(name='obsolete', mode=MODE_TYPE, default=False)
    _FriendsDescription_friends = SET_OF(name='friends', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FriendsDescription_friends__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _FriendsDescription_friends._cont = __FriendsDescription_friends__item_
    _FriendsDescription_friends._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FriendsDescription._cont = ASN1Dict([
        ('anchor', _FriendsDescription_anchor),
        ('name', _FriendsDescription_name),
        ('description', _FriendsDescription_description),
        ('obsolete', _FriendsDescription_obsolete),
        ('friends', _FriendsDescription_friends),
        ])
    FriendsDescription._ext = []
    
    #-----< id-soc-subschema >-----#
    id_soc_subschema = OID(name='id-soc-subschema', mode=MODE_VALUE)
    id_soc_subschema._val = (2, 5, 20, 1)
    
    #-----< id-soa-dITStructureRule >-----#
    id_soa_dITStructureRule = OID(name='id-soa-dITStructureRule', mode=MODE_VALUE)
    id_soa_dITStructureRule._val = (2, 5, 21, 1)
    
    #-----< id-soa-dITContentRules >-----#
    id_soa_dITContentRules = OID(name='id-soa-dITContentRules', mode=MODE_VALUE)
    id_soa_dITContentRules._val = (2, 5, 21, 2)
    
    #-----< id-soa-matchingRules >-----#
    id_soa_matchingRules = OID(name='id-soa-matchingRules', mode=MODE_VALUE)
    id_soa_matchingRules._val = (2, 5, 21, 4)
    
    #-----< id-soa-attributeTypes >-----#
    id_soa_attributeTypes = OID(name='id-soa-attributeTypes', mode=MODE_VALUE)
    id_soa_attributeTypes._val = (2, 5, 21, 5)
    
    #-----< id-soa-objectClasses >-----#
    id_soa_objectClasses = OID(name='id-soa-objectClasses', mode=MODE_VALUE)
    id_soa_objectClasses._val = (2, 5, 21, 6)
    
    #-----< id-soa-nameForms >-----#
    id_soa_nameForms = OID(name='id-soa-nameForms', mode=MODE_VALUE)
    id_soa_nameForms._val = (2, 5, 21, 7)
    
    #-----< id-soa-matchingRuleUse >-----#
    id_soa_matchingRuleUse = OID(name='id-soa-matchingRuleUse', mode=MODE_VALUE)
    id_soa_matchingRuleUse._val = (2, 5, 21, 8)
    
    #-----< id-soa-structuralObjectClass >-----#
    id_soa_structuralObjectClass = OID(name='id-soa-structuralObjectClass', mode=MODE_VALUE)
    id_soa_structuralObjectClass._val = (2, 5, 21, 9)
    
    #-----< id-soa-governingStructureRule >-----#
    id_soa_governingStructureRule = OID(name='id-soa-governingStructureRule', mode=MODE_VALUE)
    id_soa_governingStructureRule._val = (2, 5, 21, 10)
    
    #-----< id-soa-contextTypes >-----#
    id_soa_contextTypes = OID(name='id-soa-contextTypes', mode=MODE_VALUE)
    id_soa_contextTypes._val = (2, 5, 21, 11)
    
    #-----< id-soa-dITContextUse >-----#
    id_soa_dITContextUse = OID(name='id-soa-dITContextUse', mode=MODE_VALUE)
    id_soa_dITContextUse._val = (2, 5, 21, 12)
    
    #-----< id-soa-friends >-----#
    id_soa_friends = OID(name='id-soa-friends', mode=MODE_VALUE)
    id_soa_friends._val = (2, 5, 21, 13)
    
    _all_ = [
        subschema,
        __OBJECT_CLASS_OptionalAttributes_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        __OBJECT_CLASS_OptionalAttributes_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        __OBJECT_CLASS_OptionalAttributes_val_Type_2,
        __OBJECT_CLASS_OptionalAttributes_val_Type_3,
        __OBJECT_CLASS_OptionalAttributes_val_Type_4,
        __OBJECT_CLASS_OptionalAttributes_val_Type_5,
        __OBJECT_CLASS_OptionalAttributes_val_Type_6,
        __OBJECT_CLASS_OptionalAttributes_val_Type_7,
        __OBJECT_CLASS_OptionalAttributes_val_Type_8,
        __OBJECT_CLASS_OptionalAttributes_val_Type_9,
        __OBJECT_CLASS_OptionalAttributes_val_Type_10,
        dITStructureRules,
        _dITStructureRules_val_Type,
        _DITStructureRuleDescription_ruleIdentifier,
        _DITStructureRuleDescription_nameForm,
        __DITStructureRuleDescription_superiorStructureRules__item_,
        _DITStructureRuleDescription_superiorStructureRules,
        __DITStructureRuleDescription_name__item_,
        _DITStructureRuleDescription_name,
        _DITStructureRuleDescription_description,
        _DITStructureRuleDescription_obsolete,
        DITStructureRuleDescription,
        dITContentRules,
        _dITContentRules_val_Type,
        _DITContentRuleDescription_structuralObjectClass,
        __DITContentRuleDescription_auxiliaries__item_,
        _DITContentRuleDescription_auxiliaries,
        __DITContentRuleDescription_mandatory__item_,
        _DITContentRuleDescription_mandatory,
        __DITContentRuleDescription_optional__item_,
        _DITContentRuleDescription_optional,
        __DITContentRuleDescription_precluded__item_,
        _DITContentRuleDescription_precluded,
        __DITContentRuleDescription_name__item_,
        _DITContentRuleDescription_name,
        _DITContentRuleDescription_description,
        _DITContentRuleDescription_obsolete,
        DITContentRuleDescription,
        matchingRules,
        _matchingRules_val_Type,
        _MatchingRuleDescription_identifier,
        __MatchingRuleDescription_name__item_,
        _MatchingRuleDescription_name,
        _MatchingRuleDescription_description,
        _MatchingRuleDescription_obsolete,
        _MatchingRuleDescription_information,
        MatchingRuleDescription,
        attributeTypes,
        _attributeTypes_val_Type,
        _AttributeTypeDescription_identifier,
        __AttributeTypeDescription_name__item_,
        _AttributeTypeDescription_name,
        _AttributeTypeDescription_description,
        _AttributeTypeDescription_obsolete,
        _AttributeTypeDescription_information,
        AttributeTypeDescription,
        _AttributeTypeInformation_derivation,
        _AttributeTypeInformation_equalityMatch,
        _AttributeTypeInformation_orderingMatch,
        _AttributeTypeInformation_substringsMatch,
        _AttributeTypeInformation_attributeSyntax,
        _AttributeTypeInformation_multi_valued,
        _AttributeTypeInformation_collective,
        _AttributeTypeInformation_userModifiable,
        _AttributeTypeInformation_application,
        AttributeTypeInformation,
        objectClasses,
        _objectClasses_val_Type,
        _ObjectClassDescription_identifier,
        __ObjectClassDescription_name__item_,
        _ObjectClassDescription_name,
        _ObjectClassDescription_description,
        _ObjectClassDescription_obsolete,
        _ObjectClassDescription_information,
        ObjectClassDescription,
        __ObjectClassInformation_subclassOf__item_,
        _ObjectClassInformation_subclassOf,
        _ObjectClassInformation_kind,
        __ObjectClassInformation_mandatories__item_,
        _ObjectClassInformation_mandatories,
        __ObjectClassInformation_optionals__item_,
        _ObjectClassInformation_optionals,
        ObjectClassInformation,
        nameForms,
        _nameForms_val_Type,
        _NameFormDescription_identifier,
        __NameFormDescription_name__item_,
        _NameFormDescription_name,
        _NameFormDescription_description,
        _NameFormDescription_obsolete,
        _NameFormDescription_information,
        NameFormDescription,
        _NameFormInformation_subordinate,
        __NameFormInformation_namingMandatories__item_,
        _NameFormInformation_namingMandatories,
        __NameFormInformation_namingOptionals__item_,
        _NameFormInformation_namingOptionals,
        NameFormInformation,
        matchingRuleUse,
        _matchingRuleUse_val_Type,
        _MatchingRuleUseDescription_identifier,
        __MatchingRuleUseDescription_name__item_,
        _MatchingRuleUseDescription_name,
        _MatchingRuleUseDescription_description,
        _MatchingRuleUseDescription_obsolete,
        __MatchingRuleUseDescription_information__item_,
        _MatchingRuleUseDescription_information,
        MatchingRuleUseDescription,
        structuralObjectClass,
        _structuralObjectClass_val_Type,
        governingStructureRule,
        _governingStructureRule_val_Type,
        contextTypes,
        _contextTypes_val_Type,
        _ContextDescription_identifier,
        __ContextDescription_name__item_,
        _ContextDescription_name,
        _ContextDescription_description,
        _ContextDescription_obsolete,
        _ContextDescription_information,
        ContextDescription,
        _ContextInformation_syntax,
        _ContextInformation_assertionSyntax,
        ContextInformation,
        dITContextUse,
        _dITContextUse_val_Type,
        _DITContextUseDescription_identifier,
        __DITContextUseDescription_name__item_,
        _DITContextUseDescription_name,
        _DITContextUseDescription_description,
        _DITContextUseDescription_obsolete,
        _DITContextUseDescription_information,
        DITContextUseDescription,
        __DITContextUseInformation_mandatoryContexts__item_,
        _DITContextUseInformation_mandatoryContexts,
        __DITContextUseInformation_optionalContexts__item_,
        _DITContextUseInformation_optionalContexts,
        DITContextUseInformation,
        friends,
        _friends_val_Type,
        _FriendsDescription_anchor,
        __FriendsDescription_name__item_,
        _FriendsDescription_name,
        _FriendsDescription_description,
        _FriendsDescription_obsolete,
        __FriendsDescription_friends__item_,
        _FriendsDescription_friends,
        FriendsDescription,
        id_soc_subschema,
        id_soa_dITStructureRule,
        id_soa_dITContentRules,
        id_soa_matchingRules,
        id_soa_attributeTypes,
        id_soa_objectClasses,
        id_soa_nameForms,
        id_soa_matchingRuleUse,
        id_soa_structuralObjectClass,
        id_soa_governingStructureRule,
        id_soa_contextTypes,
        id_soa_dITContextUse,
        id_soa_friends,
    ]

class SelectedAttributeTypes:

    _name_  = 'SelectedAttributeTypes'
    _oid_   = [2, 5, 1, 5, 7]
    
    _obj_ = [
        'UnboundedDirectoryString',
        'DirectoryString',
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'UniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'UUIDPair',
        'UUID',
        'uri',
        'URI',
        'urn',
        'url',
        'countryName',
        'CountryName',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'UtmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'Guide',
        'Criteria',
        'CriteriaItem',
        'enhancedSearchGuide',
        'EnhancedGuide',
        'businessCategory',
        'postalAddress',
        'PostalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'TelephoneNumber',
        'ub-telephone-number',
        'collectiveTelephoneNumber',
        'telexNumber',
        'TelexNumber',
        'ub-telex-number',
        'ub-country-code',
        'ub-answerback',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'FacsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'X121Address',
        'ub-x121-address',
        'internationalISDNNumber',
        'InternationalISDNNumber',
        'ub-international-isdn-number',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'DestinationIndicator',
        'communicationsService',
        'CommunicationsService',
        'communicationsNetwork',
        'CommunicationsNetwork',
        'preferredDeliveryMethod',
        'PreferredDeliveryMethod',
        'presentationAddress',
        'PresentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'ProtocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'NameAndOptionalUID',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'UiiFormat',
        'UiiFilter',
        'UiiItem',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'EpcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'MultipleMatchingLocalities',
        'proposedRelaxation',
        'MRMappings',
        'appliedRelaxation',
        'pwdResponseValue',
        'PwdResponse',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'SubstringAssertion',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'CaseIgnoreList',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'OctetSubstringAssertion',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'SequenceMatchType',
        'wordMatchTypes',
        'WordMatchTypes',
        'characterMatchTypes',
        'CharacterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'ZONAL-MATCHING',
        'ZonalSelect',
        'ZonalResult',
        'zonalMatch',
        'uriMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'LanguageContextSyntax',
        'temporalContext',
        'TimeSpecification',
        'Period',
        'XDayOf',
        'NamedDay',
        'DayTimeBand',
        'DayTime',
        'TimeZone',
        'TimeAssertion',
        'localeContext',
        'LocaleContextSyntax',
        'ldapAttributeOptionContext',
        'AttributeOptionList',
        'id-at-knowledgeInformation',
        'id-at-commonName',
        'id-at-surname',
        'id-at-serialNumber',
        'id-at-countryName',
        'id-at-localityName',
        'id-at-collectiveLocalityName',
        'id-at-stateOrProvinceName',
        'id-at-collectiveStateOrProvinceName',
        'id-at-streetAddress',
        'id-at-collectiveStreetAddress',
        'id-at-organizationName',
        'id-at-collectiveOrganizationName',
        'id-at-organizationalUnitName',
        'id-at-collectiveOrganizationalUnitName',
        'id-at-title',
        'id-at-description',
        'id-at-searchGuide',
        'id-at-businessCategory',
        'id-at-postalAddress',
        'id-at-collectivePostalAddress',
        'id-at-postalCode',
        'id-at-collectivePostalCode',
        'id-at-postOfficeBox',
        'id-at-collectivePostOfficeBox',
        'id-at-physicalDeliveryOfficeName',
        'id-at-collectivePhysicalDeliveryOfficeName',
        'id-at-telephoneNumber',
        'id-at-collectiveTelephoneNumber',
        'id-at-telexNumber',
        'id-at-collectiveTelexNumber',
        'id-at-facsimileTelephoneNumber',
        'id-at-collectiveFacsimileTelephoneNumber',
        'id-at-x121Address',
        'id-at-internationalISDNNumber',
        'id-at-collectiveInternationalISDNNumber',
        'id-at-registeredAddress',
        'id-at-destinationIndicator',
        'id-at-preferredDeliveryMethod',
        'id-at-presentationAddress',
        'id-at-supportedApplicationContext',
        'id-at-member',
        'id-at-owner',
        'id-at-roleOccupant',
        'id-at-seeAlso',
        'id-at-name',
        'id-at-givenName',
        'id-at-initials',
        'id-at-generationQualifier',
        'id-at-uniqueIdentifier',
        'id-at-dnQualifier',
        'id-at-enhancedSearchGuide',
        'id-at-protocolInformation',
        'id-at-distinguishedName',
        'id-at-uniqueMember',
        'id-at-houseIdentifier',
        'id-at-dmdName',
        'id-at-pseudonym',
        'id-at-communicationsService',
        'id-at-communicationsNetwork',
        'id-at-uuidpair',
        'id-at-tagOid',
        'id-at-uiiFormat',
        'id-at-uiiInUrn',
        'id-at-contentUrl',
        'id-at-uri',
        'id-at-urn',
        'id-at-url',
        'id-at-utmCoordinates',
        'id-at-urnC',
        'id-at-uii',
        'id-at-epc',
        'id-at-tagAfi',
        'id-at-epcFormat',
        'id-at-epcInUrn',
        'id-at-ldapUrl',
        'id-at-tagLocation',
        'id-at-organizationIdentifier',
        'id-asx-utmCoords',
        'id-asx-uiiForm',
        'id-asx-epcForm',
        'id-lsx-attributeTypeDescription',
        'id-lsx-bitString',
        'id-lsx-boolean',
        'id-lsx-countryString',
        'id-lsx-dn',
        'id-lsx-deliveryMethod',
        'id-lsx-directoryString',
        'id-lsx-dITContentRuleDescription',
        'id-lsx-dITStructureRuleDescription',
        'id-lsx-enhancedGuide',
        'id-lsx-facsimileTelephoneNr',
        'id-lsx-fax',
        'id-lsx-generalizedTime',
        'id-lsx-guide',
        'id-lsx-ia5String',
        'id-lsx-integer',
        'id-lsx-jpeg',
        'id-lsx-matchingRuleDescription',
        'id-lsx-matchingRuleUseDescription',
        'id-lsx-nameAndOptionalUID',
        'id-lsx-nameFormDescription',
        'id-lsx-numericString',
        'id-lsx-objectClassDescription',
        'id-lsx-oid',
        'id-lsx-otherMailbox',
        'id-lsx-octetString',
        'id-lsx-postalAddr',
        'id-lsx-printableString',
        'id-lsx-subtreeSpec',
        'id-lsx-telephoneNr',
        'id-lsx-telexNr',
        'id-lsx-utcTime',
        'id-lsx-ldapSyntaxDescription',
        'id-lsx-substringAssertion',
        'id-oidC1',
        'id-oidC2',
        'id-oidC',
        'id-cat-sequenceMatchType',
        'id-cat-wordMatchType',
        'id-cat-characterMatchTypes',
        'id-cat-selectedContexts',
        'id-not-dSAProblem',
        'id-not-searchServiceProblem',
        'id-not-serviceType',
        'id-not-attributeTypeList',
        'id-not-matchingRuleList',
        'id-not-filterItem',
        'id-not-attributeCombinations',
        'id-not-contextTypeList',
        'id-not-contextList',
        'id-not-contextCombinations',
        'id-not-hierarchySelectList',
        'id-not-searchControlOptionsList',
        'id-not-serviceControlOptionsList',
        'id-not-multipleMatchingLocalities',
        'id-not-proposedRelaxation',
        'id-not-appliedRelaxation',
        'id-not-pwdResponse',
        'id-not-ldapDiagnosticMsg',
        'id-pr-targetDsaUnavailable',
        'id-pr-dataSourceUnavailable',
        'id-pr-unidentifiedOperation',
        'id-pr-unavailableOperation',
        'id-pr-searchAttributeViolation',
        'id-pr-searchAttributeCombinationViolation',
        'id-pr-searchValueNotAllowed',
        'id-pr-missingSearchAttribute',
        'id-pr-searchValueViolation',
        'id-pr-attributeNegationViolation',
        'id-pr-searchValueRequired',
        'id-pr-invalidSearchValue',
        'id-pr-searchContextViolation',
        'id-pr-searchContextCombinationViolation',
        'id-pr-missingSearchContext',
        'id-pr-searchContextValueViolation',
        'id-pr-searchContextValueRequired',
        'id-pr-invalidContextSearchValue',
        'id-pr-unsupportedMatchingRule',
        'id-pr-attributeMatchingViolation',
        'id-pr-unsupportedMatchingUse',
        'id-pr-matchingUseViolation',
        'id-pr-hierarchySelectForbidden',
        'id-pr-invalidHierarchySelect',
        'id-pr-unavailableHierarchySelect',
        'id-pr-invalidSearchControlOptions',
        'id-pr-invalidServiceControlOptions',
        'id-pr-searchSubsetViolation',
        'id-pr-unmatchedKeyAttributes',
        'id-pr-ambiguousKeyAttributes',
        'id-pr-unavailableRelaxationLevel',
        'id-pr-emptyHierarchySelection',
        'id-pr-administratorImposedLimit',
        'id-pr-permanentRestriction',
        'id-pr-temporaryRestriction',
        'id-pr-relaxationNotSupported',
        'id-coat-uid',
        'id-coat-dc',
        'id-mr-caseIgnoreMatch',
        'id-mr-caseIgnoreOrderingMatch',
        'id-mr-caseIgnoreSubstringsMatch',
        'id-mr-caseExactMatch',
        'id-mr-caseExactOrderingMatch',
        'id-mr-caseExactSubstringsMatch',
        'id-mr-numericStringMatch',
        'id-mr-numericStringOrderingMatch',
        'id-mr-numericStringSubstringsMatch',
        'id-mr-caseIgnoreListMatch',
        'id-mr-caseIgnoreListSubstringsMatch',
        'id-mr-booleanMatch',
        'id-mr-integerMatch',
        'id-mr-integerOrderingMatch',
        'id-mr-bitStringMatch',
        'id-mr-octetStringMatch',
        'id-mr-octetStringOrderingMatch',
        'id-mr-octetStringSubstringsMatch',
        'id-mr-telephoneNumberMatch',
        'id-mr-telephoneNumberSubstringsMatch',
        'id-mr-presentationAddressMatch',
        'id-mr-uniqueMemberMatch',
        'id-mr-protocolInformationMatch',
        'id-mr-uTCTimeMatch',
        'id-mr-uTCTimeOrderingMatch',
        'id-mr-generalizedTimeMatch',
        'id-mr-generalizedTimeOrderingMatch',
        'id-mr-integerFirstComponentMatch',
        'id-mr-objectIdentifierFirstComponentMatch',
        'id-mr-directoryStringFirstComponentMatch',
        'id-mr-wordMatch',
        'id-mr-keywordMatch',
        'id-mr-storedPrefixMatch',
        'id-mr-systemProposedMatch',
        'id-mr-generalWordMatch',
        'id-mr-approximateStringMatch',
        'id-mr-ignoreIfAbsentMatch',
        'id-mr-nullMatch',
        'id-mr-zonalMatch',
        'id-mr-facsimileNumberMatch',
        'id-mr-facsimileNumberSubstringsMatch',
        'id-mr-uuidpairmatch',
        'id-mr-uriMatch',
        'id-lmr-caseExactIA5Match',
        'id-lmr-caseIgnoreIA5Match',
        'id-lmr-caseIgnoreIA5SubstringsMatch',
        'id-avc-language',
        'id-avc-temporal',
        'id-avc-locale',
        'id-avc-ldapAttributeOption',
        ]
    _type_ = [
        'UnboundedDirectoryString',
        'DirectoryString',
        'UniqueIdentifier',
        'UUIDPair',
        'UUID',
        'URI',
        'CountryName',
        'UtmCoordinates',
        'Guide',
        'Criteria',
        'CriteriaItem',
        'EnhancedGuide',
        'PostalAddress',
        'TelephoneNumber',
        'TelexNumber',
        'FacsimileTelephoneNumber',
        'X121Address',
        'InternationalISDNNumber',
        'DestinationIndicator',
        'CommunicationsService',
        'CommunicationsNetwork',
        'PreferredDeliveryMethod',
        'PresentationAddress',
        'ProtocolInformation',
        'NameAndOptionalUID',
        'UiiFormat',
        'UiiFilter',
        'UiiItem',
        'EpcFormat',
        'MultipleMatchingLocalities',
        'MRMappings',
        'PwdResponse',
        'SubstringAssertion',
        'CaseIgnoreList',
        'OctetSubstringAssertion',
        'SequenceMatchType',
        'WordMatchTypes',
        'CharacterMatchTypes',
        'ZONAL-MATCHING',
        'ZonalSelect',
        'ZonalResult',
        'LanguageContextSyntax',
        'TimeSpecification',
        'Period',
        'XDayOf',
        'NamedDay',
        'DayTimeBand',
        'DayTime',
        'TimeZone',
        'TimeAssertion',
        'LocaleContextSyntax',
        'AttributeOptionList',
        ]
    _set_ = [
        ]
    _val_ = [
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'uri',
        'urn',
        'url',
        'countryName',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'enhancedSearchGuide',
        'businessCategory',
        'postalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'ub-telephone-number',
        'collectiveTelephoneNumber',
        'telexNumber',
        'ub-telex-number',
        'ub-country-code',
        'ub-answerback',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'ub-x121-address',
        'internationalISDNNumber',
        'ub-international-isdn-number',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'communicationsService',
        'communicationsNetwork',
        'preferredDeliveryMethod',
        'presentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'proposedRelaxation',
        'appliedRelaxation',
        'pwdResponseValue',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'wordMatchTypes',
        'characterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'zonalMatch',
        'uriMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'temporalContext',
        'localeContext',
        'ldapAttributeOptionContext',
        'id-at-knowledgeInformation',
        'id-at-commonName',
        'id-at-surname',
        'id-at-serialNumber',
        'id-at-countryName',
        'id-at-localityName',
        'id-at-collectiveLocalityName',
        'id-at-stateOrProvinceName',
        'id-at-collectiveStateOrProvinceName',
        'id-at-streetAddress',
        'id-at-collectiveStreetAddress',
        'id-at-organizationName',
        'id-at-collectiveOrganizationName',
        'id-at-organizationalUnitName',
        'id-at-collectiveOrganizationalUnitName',
        'id-at-title',
        'id-at-description',
        'id-at-searchGuide',
        'id-at-businessCategory',
        'id-at-postalAddress',
        'id-at-collectivePostalAddress',
        'id-at-postalCode',
        'id-at-collectivePostalCode',
        'id-at-postOfficeBox',
        'id-at-collectivePostOfficeBox',
        'id-at-physicalDeliveryOfficeName',
        'id-at-collectivePhysicalDeliveryOfficeName',
        'id-at-telephoneNumber',
        'id-at-collectiveTelephoneNumber',
        'id-at-telexNumber',
        'id-at-collectiveTelexNumber',
        'id-at-facsimileTelephoneNumber',
        'id-at-collectiveFacsimileTelephoneNumber',
        'id-at-x121Address',
        'id-at-internationalISDNNumber',
        'id-at-collectiveInternationalISDNNumber',
        'id-at-registeredAddress',
        'id-at-destinationIndicator',
        'id-at-preferredDeliveryMethod',
        'id-at-presentationAddress',
        'id-at-supportedApplicationContext',
        'id-at-member',
        'id-at-owner',
        'id-at-roleOccupant',
        'id-at-seeAlso',
        'id-at-name',
        'id-at-givenName',
        'id-at-initials',
        'id-at-generationQualifier',
        'id-at-uniqueIdentifier',
        'id-at-dnQualifier',
        'id-at-enhancedSearchGuide',
        'id-at-protocolInformation',
        'id-at-distinguishedName',
        'id-at-uniqueMember',
        'id-at-houseIdentifier',
        'id-at-dmdName',
        'id-at-pseudonym',
        'id-at-communicationsService',
        'id-at-communicationsNetwork',
        'id-at-uuidpair',
        'id-at-tagOid',
        'id-at-uiiFormat',
        'id-at-uiiInUrn',
        'id-at-contentUrl',
        'id-at-uri',
        'id-at-urn',
        'id-at-url',
        'id-at-utmCoordinates',
        'id-at-urnC',
        'id-at-uii',
        'id-at-epc',
        'id-at-tagAfi',
        'id-at-epcFormat',
        'id-at-epcInUrn',
        'id-at-ldapUrl',
        'id-at-tagLocation',
        'id-at-organizationIdentifier',
        'id-asx-utmCoords',
        'id-asx-uiiForm',
        'id-asx-epcForm',
        'id-lsx-attributeTypeDescription',
        'id-lsx-bitString',
        'id-lsx-boolean',
        'id-lsx-countryString',
        'id-lsx-dn',
        'id-lsx-deliveryMethod',
        'id-lsx-directoryString',
        'id-lsx-dITContentRuleDescription',
        'id-lsx-dITStructureRuleDescription',
        'id-lsx-enhancedGuide',
        'id-lsx-facsimileTelephoneNr',
        'id-lsx-fax',
        'id-lsx-generalizedTime',
        'id-lsx-guide',
        'id-lsx-ia5String',
        'id-lsx-integer',
        'id-lsx-jpeg',
        'id-lsx-matchingRuleDescription',
        'id-lsx-matchingRuleUseDescription',
        'id-lsx-nameAndOptionalUID',
        'id-lsx-nameFormDescription',
        'id-lsx-numericString',
        'id-lsx-objectClassDescription',
        'id-lsx-oid',
        'id-lsx-otherMailbox',
        'id-lsx-octetString',
        'id-lsx-postalAddr',
        'id-lsx-printableString',
        'id-lsx-subtreeSpec',
        'id-lsx-telephoneNr',
        'id-lsx-telexNr',
        'id-lsx-utcTime',
        'id-lsx-ldapSyntaxDescription',
        'id-lsx-substringAssertion',
        'id-oidC1',
        'id-oidC2',
        'id-oidC',
        'id-cat-sequenceMatchType',
        'id-cat-wordMatchType',
        'id-cat-characterMatchTypes',
        'id-cat-selectedContexts',
        'id-not-dSAProblem',
        'id-not-searchServiceProblem',
        'id-not-serviceType',
        'id-not-attributeTypeList',
        'id-not-matchingRuleList',
        'id-not-filterItem',
        'id-not-attributeCombinations',
        'id-not-contextTypeList',
        'id-not-contextList',
        'id-not-contextCombinations',
        'id-not-hierarchySelectList',
        'id-not-searchControlOptionsList',
        'id-not-serviceControlOptionsList',
        'id-not-multipleMatchingLocalities',
        'id-not-proposedRelaxation',
        'id-not-appliedRelaxation',
        'id-not-pwdResponse',
        'id-not-ldapDiagnosticMsg',
        'id-pr-targetDsaUnavailable',
        'id-pr-dataSourceUnavailable',
        'id-pr-unidentifiedOperation',
        'id-pr-unavailableOperation',
        'id-pr-searchAttributeViolation',
        'id-pr-searchAttributeCombinationViolation',
        'id-pr-searchValueNotAllowed',
        'id-pr-missingSearchAttribute',
        'id-pr-searchValueViolation',
        'id-pr-attributeNegationViolation',
        'id-pr-searchValueRequired',
        'id-pr-invalidSearchValue',
        'id-pr-searchContextViolation',
        'id-pr-searchContextCombinationViolation',
        'id-pr-missingSearchContext',
        'id-pr-searchContextValueViolation',
        'id-pr-searchContextValueRequired',
        'id-pr-invalidContextSearchValue',
        'id-pr-unsupportedMatchingRule',
        'id-pr-attributeMatchingViolation',
        'id-pr-unsupportedMatchingUse',
        'id-pr-matchingUseViolation',
        'id-pr-hierarchySelectForbidden',
        'id-pr-invalidHierarchySelect',
        'id-pr-unavailableHierarchySelect',
        'id-pr-invalidSearchControlOptions',
        'id-pr-invalidServiceControlOptions',
        'id-pr-searchSubsetViolation',
        'id-pr-unmatchedKeyAttributes',
        'id-pr-ambiguousKeyAttributes',
        'id-pr-unavailableRelaxationLevel',
        'id-pr-emptyHierarchySelection',
        'id-pr-administratorImposedLimit',
        'id-pr-permanentRestriction',
        'id-pr-temporaryRestriction',
        'id-pr-relaxationNotSupported',
        'id-coat-uid',
        'id-coat-dc',
        'id-mr-caseIgnoreMatch',
        'id-mr-caseIgnoreOrderingMatch',
        'id-mr-caseIgnoreSubstringsMatch',
        'id-mr-caseExactMatch',
        'id-mr-caseExactOrderingMatch',
        'id-mr-caseExactSubstringsMatch',
        'id-mr-numericStringMatch',
        'id-mr-numericStringOrderingMatch',
        'id-mr-numericStringSubstringsMatch',
        'id-mr-caseIgnoreListMatch',
        'id-mr-caseIgnoreListSubstringsMatch',
        'id-mr-booleanMatch',
        'id-mr-integerMatch',
        'id-mr-integerOrderingMatch',
        'id-mr-bitStringMatch',
        'id-mr-octetStringMatch',
        'id-mr-octetStringOrderingMatch',
        'id-mr-octetStringSubstringsMatch',
        'id-mr-telephoneNumberMatch',
        'id-mr-telephoneNumberSubstringsMatch',
        'id-mr-presentationAddressMatch',
        'id-mr-uniqueMemberMatch',
        'id-mr-protocolInformationMatch',
        'id-mr-uTCTimeMatch',
        'id-mr-uTCTimeOrderingMatch',
        'id-mr-generalizedTimeMatch',
        'id-mr-generalizedTimeOrderingMatch',
        'id-mr-integerFirstComponentMatch',
        'id-mr-objectIdentifierFirstComponentMatch',
        'id-mr-directoryStringFirstComponentMatch',
        'id-mr-wordMatch',
        'id-mr-keywordMatch',
        'id-mr-storedPrefixMatch',
        'id-mr-systemProposedMatch',
        'id-mr-generalWordMatch',
        'id-mr-approximateStringMatch',
        'id-mr-ignoreIfAbsentMatch',
        'id-mr-nullMatch',
        'id-mr-zonalMatch',
        'id-mr-facsimileNumberMatch',
        'id-mr-facsimileNumberSubstringsMatch',
        'id-mr-uuidpairmatch',
        'id-mr-uriMatch',
        'id-lmr-caseExactIA5Match',
        'id-lmr-caseIgnoreIA5Match',
        'id-lmr-caseIgnoreIA5SubstringsMatch',
        'id-avc-language',
        'id-avc-temporal',
        'id-avc-locale',
        'id-avc-ldapAttributeOption',
        ]
    _class_ = [
        'knowledgeInformation',
        'name',
        'commonName',
        'surname',
        'givenName',
        'initials',
        'generationQualifier',
        'uniqueIdentifier',
        'dnQualifier',
        'serialNumber',
        'pseudonym',
        'uUIDPair',
        'uri',
        'urn',
        'url',
        'countryName',
        'localityName',
        'collectiveLocalityName',
        'stateOrProvinceName',
        'collectiveStateOrProvinceName',
        'streetAddress',
        'collectiveStreetAddress',
        'houseIdentifier',
        'utmCoordinates',
        'organizationName',
        'collectiveOrganizationName',
        'organizationalUnitName',
        'collectiveOrganizationalUnitName',
        'title',
        'organizationIdentifier',
        'description',
        'searchGuide',
        'enhancedSearchGuide',
        'businessCategory',
        'postalAddress',
        'collectivePostalAddress',
        'postalCode',
        'collectivePostalCode',
        'postOfficeBox',
        'collectivePostOfficeBox',
        'physicalDeliveryOfficeName',
        'collectivePhysicalDeliveryOfficeName',
        'telephoneNumber',
        'collectiveTelephoneNumber',
        'telexNumber',
        'collectiveTelexNumber',
        'facsimileTelephoneNumber',
        'collectiveFacsimileTelephoneNumber',
        'x121Address',
        'internationalISDNNumber',
        'collectiveInternationalISDNNumber',
        'registeredAddress',
        'destinationIndicator',
        'communicationsService',
        'communicationsNetwork',
        'preferredDeliveryMethod',
        'presentationAddress',
        'supportedApplicationContext',
        'protocolInformation',
        'distinguishedName',
        'member',
        'uniqueMember',
        'owner',
        'roleOccupant',
        'seeAlso',
        'dmdName',
        'oidC1',
        'oidC2',
        'oidC',
        'urnC',
        'tagOid',
        'uiiFormat',
        'uiiInUrn',
        'contentUrl',
        'uii',
        'epc',
        'tagAfi',
        'epcFormat',
        'epcInUrn',
        'ldapUrl',
        'tagLocation',
        'dSAProblem',
        'searchServiceProblem',
        'serviceType',
        'attributeTypeList',
        'matchingRuleList',
        'filterItem',
        'attributeCombinations',
        'contextTypeList',
        'contextList',
        'contextCombinations',
        'hierarchySelectList',
        'searchControlOptionsList',
        'serviceControlOptionsList',
        'multipleMatchingLocalities',
        'proposedRelaxation',
        'appliedRelaxation',
        'pwdResponseValue',
        'ldapDiagnosticMsg',
        'uid',
        'dc',
        'caseExactMatch',
        'caseIgnoreMatch',
        'caseExactOrderingMatch',
        'caseIgnoreOrderingMatch',
        'caseExactSubstringsMatch',
        'caseIgnoreSubstringsMatch',
        'numericStringMatch',
        'numericStringOrderingMatch',
        'numericStringSubstringsMatch',
        'caseIgnoreListMatch',
        'caseIgnoreListSubstringsMatch',
        'storedPrefixMatch',
        'booleanMatch',
        'integerMatch',
        'integerOrderingMatch',
        'bitStringMatch',
        'octetStringMatch',
        'octetStringOrderingMatch',
        'octetStringSubstringsMatch',
        'telephoneNumberMatch',
        'telephoneNumberSubstringsMatch',
        'presentationAddressMatch',
        'uniqueMemberMatch',
        'protocolInformationMatch',
        'facsimileNumberMatch',
        'facsimileNumberSubstringsMatch',
        'uUIDPairMatch',
        'uTCTimeMatch',
        'uTCTimeOrderingMatch',
        'generalizedTimeMatch',
        'generalizedTimeOrderingMatch',
        'systemProposedMatch',
        'integerFirstComponentMatch',
        'objectIdentifierFirstComponentMatch',
        'directoryStringFirstComponentMatch',
        'wordMatch',
        'keywordMatch',
        'generalWordMatch',
        'sequenceMatchType',
        'wordMatchTypes',
        'characterMatchTypes',
        'selectedContexts',
        'approximateStringMatch',
        'ignoreIfAbsentMatch',
        'nullMatch',
        'ZONAL-MATCHING',
        'zonalMatch',
        'uriMatch',
        'caseExactIA5Match',
        'caseIgnoreIA5Match',
        'caseIgnoreIA5SubstringsMatch',
        'utmCoords',
        'uiiForm',
        'epcForm',
        'attributeTypeDescription',
        'bitString',
        'boolean',
        'countryString',
        'dn',
        'deliveryMethod',
        'directoryString',
        'dITContentRuleDescription',
        'dITStructureRuleDescription',
        'enhancedGuide',
        'facsimileTelephoneNr',
        'fax',
        'generalizedTime',
        'guide',
        'ia5String',
        'integer',
        'jpeg',
        'matchingRuleDescription',
        'matchingRuleUseDescription',
        'nameAndOptionalUID',
        'nameFormDescription',
        'numericString',
        'objectClassDescription',
        'oid',
        'otherMailbox',
        'octetString',
        'postalAddr',
        'printableString',
        'subtreeSpec',
        'telephoneNr',
        'telexNr',
        'utcTime',
        'ldapSyntaxDescription',
        'substringAssertion',
        'languageContext',
        'temporalContext',
        'localeContext',
        'ldapAttributeOptionContext',
        ]
    _param_ = [
        'DirectoryString',
        ]
    
    #-----< UnboundedDirectoryString >-----#
    UnboundedDirectoryString = CHOICE(name='UnboundedDirectoryString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _UnboundedDirectoryString_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _UnboundedDirectoryString_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _UnboundedDirectoryString_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _UnboundedDirectoryString_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UnboundedDirectoryString._cont = ASN1Dict([
        ('teletexString', _UnboundedDirectoryString_teletexString),
        ('printableString', _UnboundedDirectoryString_printableString),
        ('bmpString', _UnboundedDirectoryString_bmpString),
        ('universalString', _UnboundedDirectoryString_universalString),
        ('uTF8String', _UnboundedDirectoryString_uTF8String),
        ])
    UnboundedDirectoryString._ext = None
    
    #-----< DirectoryString >-----#
    DirectoryString = CHOICE(name='DirectoryString', mode=MODE_TYPE, param=True)
    
    #-----< knowledgeInformation >-----#
    knowledgeInformation = CLASS(name='knowledgeInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _knowledgeInformation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    knowledgeInformation._val = dict([('Type', _knowledgeInformation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('obsolete', True), ('id', (2, 5, 4, 2))])
    
    #-----< name >-----#
    name = CLASS(name='name', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _name_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    name._val = dict([('Type', _name_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])
    
    #-----< commonName >-----#
    commonName = CLASS(name='commonName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _commonName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    commonName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _commonName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['cn', 'commonName']), ('id', (2, 5, 4, 3))])
    
    #-----< surname >-----#
    surname = CLASS(name='surname', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _surname_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    surname._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _surname_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['sn']), ('id', (2, 5, 4, 4))])
    
    #-----< givenName >-----#
    givenName = CLASS(name='givenName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _givenName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    givenName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _givenName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['givenName']), ('id', (2, 5, 4, 42))])
    
    #-----< initials >-----#
    initials = CLASS(name='initials', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _initials_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    initials._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _initials_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['initials']), ('id', (2, 5, 4, 43))])
    
    #-----< generationQualifier >-----#
    generationQualifier = CLASS(name='generationQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _generationQualifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    generationQualifier._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _generationQualifier_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['generationQualifier']), ('id', (2, 5, 4, 44))])
    
    #-----< uniqueIdentifier >-----#
    uniqueIdentifier = CLASS(name='uniqueIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueIdentifier_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    uniqueIdentifier._val = dict([('Type', _uniqueIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['x500UniqueIdentifier']), ('id', (2, 5, 4, 45))])
    
    #-----< UniqueIdentifier >-----#
    UniqueIdentifier = BIT_STR(name='UniqueIdentifier', mode=MODE_TYPE)
    
    #-----< dnQualifier >-----#
    dnQualifier = CLASS(name='dnQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dnQualifier_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dnQualifier._val = dict([('Type', _dnQualifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('ordering-match', dict([('AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreOrderingMatch']), ('id', (2, 5, 13, 3))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['dnQualifier']), ('id', (2, 5, 4, 46))])
    
    #-----< serialNumber >-----#
    serialNumber = CLASS(name='serialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serialNumber_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _serialNumber_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    serialNumber._val = dict([('Type', _serialNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['serialNumber']), ('id', (2, 5, 4, 5))])
    
    #-----< pseudonym >-----#
    pseudonym = CLASS(name='pseudonym', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pseudonym_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    pseudonym._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _pseudonym_val_Type), ('id', (2, 5, 4, 65))])
    
    #-----< uUIDPair >-----#
    uUIDPair = CLASS(name='uUIDPair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uUIDPair_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPair._val = dict([('Type', _uUIDPair_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), ('id', (2, 5, 13, 68))])), ('id', (2, 5, 4, 77))])
    
    #-----< UUIDPair >-----#
    UUIDPair = SEQ(name='UUIDPair', mode=MODE_TYPE)
    _UUIDPair_issuerUUID = OCT_STR(name='issuerUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    _UUIDPair_subjectUUID = OCT_STR(name='subjectUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    UUIDPair._cont = ASN1Dict([
        ('issuerUUID', _UUIDPair_issuerUUID),
        ('subjectUUID', _UUIDPair_subjectUUID),
        ])
    UUIDPair._ext = []
    
    #-----< UUID >-----#
    UUID = OCT_STR(name='UUID', mode=MODE_TYPE)
    UUID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< uri >-----#
    uri = CLASS(name='uri', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uri_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    __ATTRIBUTE_equality_match_val_AssertionType_2 = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    uri._val = dict([('Type', _uri_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])
    
    #-----< URI >-----#
    URI = STR_UTF8(name='URI', mode=MODE_TYPE)
    
    #-----< urn >-----#
    urn = CLASS(name='urn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    urn._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['urn']), ('id', (2, 5, 4, 86))])
    
    #-----< url >-----#
    url = CLASS(name='url', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    url._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])
    
    #-----< countryName >-----#
    countryName = CLASS(name='countryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryName_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _countryName_val_Type), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)), ('ldapName', ['c']), ('id', (2, 5, 4, 6))])
    
    #-----< CountryName >-----#
    CountryName = STR_PRINT(name='CountryName', mode=MODE_TYPE)
    CountryName._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< localityName >-----#
    localityName = CLASS(name='localityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _localityName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    localityName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _localityName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['l']), ('id', (2, 5, 4, 7))])
    
    #-----< collectiveLocalityName >-----#
    collectiveLocalityName = CLASS(name='collectiveLocalityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveLocalityName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['l']), ('id', (2, 5, 4, 7))])), ('collective', True), ('id', (2, 5, 4, 7, 1))])
    
    #-----< stateOrProvinceName >-----#
    stateOrProvinceName = CLASS(name='stateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _stateOrProvinceName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    stateOrProvinceName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _stateOrProvinceName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['st']), ('id', (2, 5, 4, 8))])
    
    #-----< collectiveStateOrProvinceName >-----#
    collectiveStateOrProvinceName = CLASS(name='collectiveStateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStateOrProvinceName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['st']), ('id', (2, 5, 4, 8))])), ('collective', True), ('id', (2, 5, 4, 8, 1))])
    
    #-----< streetAddress >-----#
    streetAddress = CLASS(name='streetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _streetAddress_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    streetAddress._val = dict([('Type', _streetAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['street']), ('id', (2, 5, 4, 9))])
    
    #-----< collectiveStreetAddress >-----#
    collectiveStreetAddress = CLASS(name='collectiveStreetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStreetAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['street']), ('id', (2, 5, 4, 9))])), ('collective', True), ('id', (2, 5, 4, 9, 1))])
    
    #-----< houseIdentifier >-----#
    houseIdentifier = CLASS(name='houseIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _houseIdentifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    houseIdentifier._val = dict([('Type', _houseIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['houseIdentifier']), ('id', (2, 5, 4, 51))])
    
    #-----< utmCoordinates >-----#
    utmCoordinates = CLASS(name='utmCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _utmCoordinates_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoordinates._val = dict([('Type', _utmCoordinates_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['utmCoordinates']), ('id', (2, 5, 4, 88))])
    
    #-----< UtmCoordinates >-----#
    UtmCoordinates = SEQ(name='UtmCoordinates', mode=MODE_TYPE)
    _UtmCoordinates_zone = STR_PRINT(name='zone', mode=MODE_TYPE)
    _UtmCoordinates_easting = STR_NUM(name='easting', mode=MODE_TYPE)
    _UtmCoordinates_northing = STR_NUM(name='northing', mode=MODE_TYPE)
    UtmCoordinates._cont = ASN1Dict([
        ('zone', _UtmCoordinates_zone),
        ('easting', _UtmCoordinates_easting),
        ('northing', _UtmCoordinates_northing),
        ])
    UtmCoordinates._ext = None
    
    #-----< organizationName >-----#
    organizationName = CLASS(name='organizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _organizationName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['o']), ('id', (2, 5, 4, 10))])
    
    #-----< collectiveOrganizationName >-----#
    collectiveOrganizationName = CLASS(name='collectiveOrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['o']), ('id', (2, 5, 4, 10))])), ('collective', True), ('id', (2, 5, 4, 10, 1))])
    
    #-----< organizationalUnitName >-----#
    organizationalUnitName = CLASS(name='organizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationalUnitName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationalUnitName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _organizationalUnitName_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ou']), ('id', (2, 5, 4, 11))])
    
    #-----< collectiveOrganizationalUnitName >-----#
    collectiveOrganizationalUnitName = CLASS(name='collectiveOrganizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationalUnitName._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', __ATTRIBUTE_derivation_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ou']), ('id', (2, 5, 4, 11))])), ('collective', True), ('id', (2, 5, 4, 11, 1))])
    
    #-----< title >-----#
    title = CLASS(name='title', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _title_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    title._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _title_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['title']), ('id', (2, 5, 4, 12))])
    
    #-----< organizationIdentifier >-----#
    organizationIdentifier = CLASS(name='organizationIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationIdentifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationIdentifier._val = dict([('Type', _organizationIdentifier_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['organizationIdentifier']), ('id', (2, 5, 4, 97))])
    
    #-----< description >-----#
    description = CLASS(name='description', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _description_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    description._val = dict([('Type', _description_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['description']), ('id', (2, 5, 4, 13))])
    
    #-----< searchGuide >-----#
    searchGuide = CLASS(name='searchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchGuide_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    searchGuide._val = dict([('Type', _searchGuide_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)), ('ldapName', ['searchGuide']), ('id', (2, 5, 4, 14))])
    
    #-----< Guide >-----#
    Guide = SET(name='Guide', mode=MODE_TYPE)
    _Guide_objectClass = OID(name='objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    _Guide_criteria = CHOICE(name='criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Guide._cont = ASN1Dict([
        ('objectClass', _Guide_objectClass),
        ('criteria', _Guide_criteria),
        ])
    Guide._ext = []
    
    #-----< Criteria >-----#
    Criteria = CHOICE(name='Criteria', mode=MODE_TYPE)
    _Criteria_type = CHOICE(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'CriteriaItem')))
    _Criteria_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_and_._cont = __Criteria_and___item_
    _Criteria_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_or_._cont = __Criteria_or___item_
    _Criteria_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Criteria._cont = ASN1Dict([
        ('type', _Criteria_type),
        ('and', _Criteria_and_),
        ('or', _Criteria_or_),
        ('not', _Criteria_not_),
        ])
    Criteria._ext = []
    
    #-----< CriteriaItem >-----#
    CriteriaItem = CHOICE(name='CriteriaItem', mode=MODE_TYPE)
    _CriteriaItem_equality = OID(name='equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_substrings = OID(name='substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_greaterOrEqual = OID(name='greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_lessOrEqual = OID(name='lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_approximateMatch = OID(name='approximateMatch', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    CriteriaItem._cont = ASN1Dict([
        ('equality', _CriteriaItem_equality),
        ('substrings', _CriteriaItem_substrings),
        ('greaterOrEqual', _CriteriaItem_greaterOrEqual),
        ('lessOrEqual', _CriteriaItem_lessOrEqual),
        ('approximateMatch', _CriteriaItem_approximateMatch),
        ])
    CriteriaItem._ext = []
    
    #-----< enhancedSearchGuide >-----#
    enhancedSearchGuide = CLASS(name='enhancedSearchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _enhancedSearchGuide_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedSearchGuide._val = dict([('Type', _enhancedSearchGuide_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)), ('ldapName', ['enhancedSearchGuide']), ('id', (2, 5, 4, 47))])
    
    #-----< EnhancedGuide >-----#
    EnhancedGuide = SEQ(name='EnhancedGuide', mode=MODE_TYPE)
    _EnhancedGuide_objectClass = OID(name='objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']))
    _EnhancedGuide_criteria = CHOICE(name='criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _EnhancedGuide_subset = INT(name='subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EnhancedGuide_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    EnhancedGuide._cont = ASN1Dict([
        ('objectClass', _EnhancedGuide_objectClass),
        ('criteria', _EnhancedGuide_criteria),
        ('subset', _EnhancedGuide_subset),
        ])
    EnhancedGuide._ext = []
    
    #-----< businessCategory >-----#
    businessCategory = CLASS(name='businessCategory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _businessCategory_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    businessCategory._val = dict([('Type', _businessCategory_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['businessCategory']), ('id', (2, 5, 4, 15))])
    
    #-----< postalAddress >-----#
    postalAddress = CLASS(name='postalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalAddress_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_3 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    postalAddress._val = dict([('Type', _postalAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])
    
    #-----< PostalAddress >-----#
    PostalAddress = SEQ_OF(name='PostalAddress', mode=MODE_TYPE)
    _PostalAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    PostalAddress._cont = _PostalAddress__item_
    PostalAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< collectivePostalAddress >-----#
    collectivePostalAddress = CLASS(name='collectivePostalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    collectivePostalAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])), ('collective', True), ('id', (2, 5, 4, 16, 1))])
    
    #-----< postalCode >-----#
    postalCode = CLASS(name='postalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalCode_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postalCode._val = dict([('Type', _postalCode_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postalCode']), ('id', (2, 5, 4, 17))])
    
    #-----< collectivePostalCode >-----#
    collectivePostalCode = CLASS(name='collectivePostalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostalCode._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postalCode']), ('id', (2, 5, 4, 17))])), ('collective', True), ('id', (2, 5, 4, 17, 1))])
    
    #-----< postOfficeBox >-----#
    postOfficeBox = CLASS(name='postOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postOfficeBox_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postOfficeBox._val = dict([('Type', _postOfficeBox_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postOfficeBox']), ('id', (2, 5, 4, 18))])
    
    #-----< collectivePostOfficeBox >-----#
    collectivePostOfficeBox = CLASS(name='collectivePostOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostOfficeBox._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['postOfficeBox']), ('id', (2, 5, 4, 18))])), ('collective', True), ('id', (2, 5, 4, 18, 1))])
    
    #-----< physicalDeliveryOfficeName >-----#
    physicalDeliveryOfficeName = CLASS(name='physicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _physicalDeliveryOfficeName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    physicalDeliveryOfficeName._val = dict([('Type', _physicalDeliveryOfficeName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['physicalDeliveryOfficeName']), ('id', (2, 5, 4, 19))])
    
    #-----< collectivePhysicalDeliveryOfficeName >-----#
    collectivePhysicalDeliveryOfficeName = CLASS(name='collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePhysicalDeliveryOfficeName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['physicalDeliveryOfficeName']), ('id', (2, 5, 4, 19))])), ('collective', True), ('id', (2, 5, 4, 19, 1))])
    
    #-----< telephoneNumber >-----#
    telephoneNumber = CLASS(name='telephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telephoneNumber_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumber._val = dict([('Type', _telephoneNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['telephoneNumber']), ('id', (2, 5, 4, 20))])
    
    #-----< TelephoneNumber >-----#
    TelephoneNumber = STR_PRINT(name='TelephoneNumber', mode=MODE_TYPE)
    TelephoneNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ub-telephone-number >-----#
    ub_telephone_number = INT(name='ub-telephone-number', mode=MODE_VALUE)
    ub_telephone_number._val = 32
    
    #-----< collectiveTelephoneNumber >-----#
    collectiveTelephoneNumber = CLASS(name='collectiveTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_2 = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    collectiveTelephoneNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_2), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['telephoneNumber']), ('id', (2, 5, 4, 20))])), ('collective', True), ('id', (2, 5, 4, 20, 1))])
    
    #-----< telexNumber >-----#
    telexNumber = CLASS(name='telexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telexNumber_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNumber._val = dict([('Type', _telexNumber_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), ('ldapName', ['telexNumber']), ('id', (2, 5, 4, 21))])
    
    #-----< TelexNumber >-----#
    TelexNumber = SEQ(name='TelexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber = STR_PRINT(name='telexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    _TelexNumber_countryCode = STR_PRINT(name='countryCode', mode=MODE_TYPE)
    _TelexNumber_countryCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _TelexNumber_answerback = STR_PRINT(name='answerback', mode=MODE_TYPE)
    _TelexNumber_answerback._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    TelexNumber._cont = ASN1Dict([
        ('telexNumber', _TelexNumber_telexNumber),
        ('countryCode', _TelexNumber_countryCode),
        ('answerback', _TelexNumber_answerback),
        ])
    TelexNumber._ext = []
    
    #-----< ub-telex-number >-----#
    ub_telex_number = INT(name='ub-telex-number', mode=MODE_VALUE)
    ub_telex_number._val = 14
    
    #-----< ub-country-code >-----#
    ub_country_code = INT(name='ub-country-code', mode=MODE_VALUE)
    ub_country_code._val = 4
    
    #-----< ub-answerback >-----#
    ub_answerback = INT(name='ub-answerback', mode=MODE_VALUE)
    ub_answerback._val = 8
    
    #-----< collectiveTelexNumber >-----#
    collectiveTelexNumber = CLASS(name='collectiveTelexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    collectiveTelexNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), ('ldapName', ['telexNumber']), ('id', (2, 5, 4, 21))])), ('collective', True), ('id', (2, 5, 4, 21, 1))])
    
    #-----< facsimileTelephoneNumber >-----#
    facsimileTelephoneNumber = CLASS(name='facsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _facsimileTelephoneNumber_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNumber._val = dict([('Type', _facsimileTelephoneNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('id', (2, 5, 13, 63))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('id', (2, 5, 13, 64))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), ('ldapName', ['facsimileTelephoneNumber']), ('id', (2, 5, 4, 23))])
    
    #-----< FacsimileTelephoneNumber >-----#
    FacsimileTelephoneNumber = SEQ(name='FacsimileTelephoneNumber', mode=MODE_TYPE)
    _FacsimileTelephoneNumber_telephoneNumber = STR_PRINT(name='telephoneNumber', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    _FacsimileTelephoneNumber_parameters = BIT_STR(name='parameters', mode=MODE_TYPE, typeref=ASN1RefType(('MTSAbstractService', 'G3FacsimileNonBasicParameters')), opt=True)
    FacsimileTelephoneNumber._cont = ASN1Dict([
        ('telephoneNumber', _FacsimileTelephoneNumber_telephoneNumber),
        ('parameters', _FacsimileTelephoneNumber_parameters),
        ])
    FacsimileTelephoneNumber._ext = []
    
    #-----< collectiveFacsimileTelephoneNumber >-----#
    collectiveFacsimileTelephoneNumber = CLASS(name='collectiveFacsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    collectiveFacsimileTelephoneNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_4), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), ('id', (2, 5, 13, 63))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('id', (2, 5, 13, 64))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), ('ldapName', ['facsimileTelephoneNumber']), ('id', (2, 5, 4, 23))])), ('collective', True), ('id', (2, 5, 4, 23, 1))])
    
    #-----< x121Address >-----#
    x121Address = CLASS(name='x121Address', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _x121Address_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'X121Address')))
    __ATTRIBUTE_equality_match_val_AssertionType_5 = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    x121Address._val = dict([('Type', _x121Address_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['x121Address']), ('id', (2, 5, 4, 24))])
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name='X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< ub-x121-address >-----#
    ub_x121_address = INT(name='ub-x121-address', mode=MODE_VALUE)
    ub_x121_address._val = 15
    
    #-----< internationalISDNNumber >-----#
    internationalISDNNumber = CLASS(name='internationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _internationalISDNNumber_val_Type = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    internationalISDNNumber._val = dict([('Type', _internationalISDNNumber_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['internationalISDNNumber']), ('id', (2, 5, 4, 25))])
    
    #-----< InternationalISDNNumber >-----#
    InternationalISDNNumber = STR_NUM(name='InternationalISDNNumber', mode=MODE_TYPE)
    InternationalISDNNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ub-international-isdn-number >-----#
    ub_international_isdn_number = INT(name='ub-international-isdn-number', mode=MODE_VALUE)
    ub_international_isdn_number._val = 16
    
    #-----< collectiveInternationalISDNNumber >-----#
    collectiveInternationalISDNNumber = CLASS(name='collectiveInternationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_5 = STR_NUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    collectiveInternationalISDNNumber._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_5), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['internationalISDNNumber']), ('id', (2, 5, 4, 25))])), ('collective', True), ('id', (2, 5, 4, 25, 1))])
    
    #-----< registeredAddress >-----#
    registeredAddress = CLASS(name='registeredAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _registeredAddress_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    registeredAddress._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['postalAddress']), ('id', (2, 5, 4, 16))])), ('Type', _registeredAddress_val_Type), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['registeredAddress']), ('id', (2, 5, 4, 26))])
    
    #-----< destinationIndicator >-----#
    destinationIndicator = CLASS(name='destinationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _destinationIndicator_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DestinationIndicator')))
    destinationIndicator._val = dict([('Type', _destinationIndicator_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['destinationIndicator']), ('id', (2, 5, 4, 27))])
    
    #-----< DestinationIndicator >-----#
    DestinationIndicator = STR_PRINT(name='DestinationIndicator', mode=MODE_TYPE)
    DestinationIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< communicationsService >-----#
    communicationsService = CLASS(name='communicationsService', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsService_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsService')))
    __ATTRIBUTE_equality_match_val_AssertionType_6 = OID(name='AssertionType', mode=MODE_TYPE)
    communicationsService._val = dict([('Type', _communicationsService_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 4, 66))])
    
    #-----< CommunicationsService >-----#
    CommunicationsService = OID(name='CommunicationsService', mode=MODE_TYPE)
    
    #-----< communicationsNetwork >-----#
    communicationsNetwork = CLASS(name='communicationsNetwork', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsNetwork_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsNetwork')))
    communicationsNetwork._val = dict([('Type', _communicationsNetwork_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('id', (2, 5, 4, 67))])
    
    #-----< CommunicationsNetwork >-----#
    CommunicationsNetwork = OID(name='CommunicationsNetwork', mode=MODE_TYPE)
    
    #-----< preferredDeliveryMethod >-----#
    preferredDeliveryMethod = CLASS(name='preferredDeliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _preferredDeliveryMethod_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    preferredDeliveryMethod._val = dict([('Type', _preferredDeliveryMethod_val_Type), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)), ('ldapName', ['preferredDeliveryMethod']), ('id', (2, 5, 4, 28))])
    
    #-----< PreferredDeliveryMethod >-----#
    PreferredDeliveryMethod = SEQ_OF(name='PreferredDeliveryMethod', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_ = INT(name='_item_', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_._cont = ASN1Dict([('any-delivery-method', 0), ('mhs-delivery', 1), ('physical-delivery', 2), ('telex-delivery', 3), ('teletex-delivery', 4), ('g3-facsimile-delivery', 5), ('g4-facsimile-delivery', 6), ('ia5-terminal-delivery', 7), ('videotex-delivery', 8), ('telephone-delivery', 9)])
    PreferredDeliveryMethod._cont = _PreferredDeliveryMethod__item_
    
    #-----< presentationAddress >-----#
    presentationAddress = CLASS(name='presentationAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _presentationAddress_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_7 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddress._val = dict([('Type', _presentationAddress_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), ('id', (2, 5, 13, 22))])), ('single-valued', True), ('id', (2, 5, 4, 29))])
    
    #-----< PresentationAddress >-----#
    PresentationAddress = SEQ(name='PresentationAddress', mode=MODE_TYPE)
    _PresentationAddress_pSelector = OCT_STR(name='pSelector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_sSelector = OCT_STR(name='sSelector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_tSelector = OCT_STR(name='tSelector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_nAddresses = SET_OF(name='nAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PresentationAddress_nAddresses__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _PresentationAddress_nAddresses._cont = __PresentationAddress_nAddresses__item_
    _PresentationAddress_nAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PresentationAddress._cont = ASN1Dict([
        ('pSelector', _PresentationAddress_pSelector),
        ('sSelector', _PresentationAddress_sSelector),
        ('tSelector', _PresentationAddress_tSelector),
        ('nAddresses', _PresentationAddress_nAddresses),
        ])
    PresentationAddress._ext = []
    
    #-----< supportedApplicationContext >-----#
    supportedApplicationContext = CLASS(name='supportedApplicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedApplicationContext_val_Type = OID(name='Type', mode=MODE_TYPE)
    supportedApplicationContext._val = dict([('Type', _supportedApplicationContext_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 4, 30))])
    
    #-----< protocolInformation >-----#
    protocolInformation = CLASS(name='protocolInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protocolInformation_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    __ATTRIBUTE_equality_match_val_AssertionType_8 = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    protocolInformation._val = dict([('Type', _protocolInformation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_8), ('id', (2, 5, 13, 24))])), ('id', (2, 5, 4, 48))])
    
    #-----< ProtocolInformation >-----#
    ProtocolInformation = SEQ(name='ProtocolInformation', mode=MODE_TYPE)
    _ProtocolInformation_nAddress = OCT_STR(name='nAddress', mode=MODE_TYPE)
    _ProtocolInformation_profiles = SET_OF(name='profiles', mode=MODE_TYPE)
    __ProtocolInformation_profiles__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ProtocolInformation_profiles._cont = __ProtocolInformation_profiles__item_
    ProtocolInformation._cont = ASN1Dict([
        ('nAddress', _ProtocolInformation_nAddress),
        ('profiles', _ProtocolInformation_profiles),
        ])
    ProtocolInformation._ext = None
    
    #-----< distinguishedName >-----#
    distinguishedName = CLASS(name='distinguishedName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _distinguishedName_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_9 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedName._val = dict([('Type', _distinguishedName_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])
    
    #-----< member >-----#
    member = CLASS(name='member', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_6 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    member._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['member']), ('id', (2, 5, 4, 31))])
    
    #-----< uniqueMember >-----#
    uniqueMember = CLASS(name='uniqueMember', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueMember_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    __ATTRIBUTE_equality_match_val_AssertionType_10 = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMember._val = dict([('Type', _uniqueMember_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMemberMatch']), ('id', (2, 5, 13, 23))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMember']), ('id', (2, 5, 4, 50))])
    
    #-----< NameAndOptionalUID >-----#
    NameAndOptionalUID = SEQ(name='NameAndOptionalUID', mode=MODE_TYPE)
    _NameAndOptionalUID_dn = SEQ_OF(name='dn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _NameAndOptionalUID_uid = BIT_STR(name='uid', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    NameAndOptionalUID._cont = ASN1Dict([
        ('dn', _NameAndOptionalUID_dn),
        ('uid', _NameAndOptionalUID_uid),
        ])
    NameAndOptionalUID._ext = []
    
    #-----< owner >-----#
    owner = CLASS(name='owner', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    owner._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['owner']), ('id', (2, 5, 4, 32))])
    
    #-----< roleOccupant >-----#
    roleOccupant = CLASS(name='roleOccupant', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    roleOccupant._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['roleOccupant']), ('id', (2, 5, 4, 33))])
    
    #-----< seeAlso >-----#
    seeAlso = CLASS(name='seeAlso', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    seeAlso._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_6), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedName']), ('id', (2, 5, 4, 49))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['seeAlso']), ('id', (2, 5, 4, 34))])
    
    #-----< dmdName >-----#
    dmdName = CLASS(name='dmdName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dmdName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dmdName._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['name']), ('id', (2, 5, 4, 41))])), ('Type', _dmdName_val_Type), ('id', (2, 5, 4, 54))])
    
    #-----< oidC1 >-----#
    oidC1 = CLASS(name='oidC1', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC1_val_Type = INT(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType__11 = INT(name='AssertionType', mode=MODE_TYPE)
    oidC1._val = dict([('Type', _oidC1_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType__11), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 0))])
    
    #-----< oidC2 >-----#
    oidC2 = CLASS(name='oidC2', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC2_val_Type = INT(name='Type', mode=MODE_TYPE)
    oidC2._val = dict([('Type', _oidC2_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType__11), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 1))])
    
    #-----< oidC >-----#
    oidC = CLASS(name='oidC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC_val_Type = INT(name='Type', mode=MODE_TYPE)
    oidC._val = dict([('Type', _oidC_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType__11), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])), ('single-valued', True), ('id', (2, 17, 1, 2, 2))])
    
    #-----< urnC >-----#
    urnC = CLASS(name='urnC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _urnC_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    urnC._val = dict([('Type', _urnC_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), ('ldapName', ['urnC']), ('id', (2, 5, 4, 89))])
    
    #-----< tagOid >-----#
    tagOid = CLASS(name='tagOid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagOid_val_Type = OID(name='Type', mode=MODE_TYPE)
    tagOid._val = dict([('Type', _tagOid_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['tagOid']), ('id', (2, 5, 4, 78))])
    
    #-----< uiiFormat >-----#
    uiiFormat = CLASS(name='uiiFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiFormat_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiFormat._val = dict([('Type', _uiiFormat_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 5)), ('ldapName', ['uiiFormat']), ('id', (2, 5, 4, 79))])
    
    #-----< UiiFormat >-----#
    UiiFormat = SEQ(name='UiiFormat', mode=MODE_TYPE)
    _UiiFormat_baseObject = STR_UTF8(name='baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')), opt=True)
    _UiiFormat_subset = ENUM(name='subset', mode=MODE_TYPE, default='baseObject')
    _UiiFormat_subset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    _UiiFormat_subset._ext = None
    _UiiFormat_next = CHOICE(name='next', mode=MODE_TYPE)
    __UiiFormat_next_length = INT(name='length', mode=MODE_TYPE)
    __UiiFormat_next_filter = CHOICE(name='filter', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFormat_next._cont = ASN1Dict([
        ('length', __UiiFormat_next_length),
        ('filter', __UiiFormat_next_filter),
        ])
    _UiiFormat_next._ext = None
    UiiFormat._cont = ASN1Dict([
        ('baseObject', _UiiFormat_baseObject),
        ('subset', _UiiFormat_subset),
        ('next', _UiiFormat_next),
        ])
    UiiFormat._ext = None
    
    #-----< UiiFilter >-----#
    UiiFilter = CHOICE(name='UiiFilter', mode=MODE_TYPE)
    _UiiFilter_item = SEQ(name='item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiItem')))
    _UiiFilter_and_ = SET_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_and_._cont = __UiiFilter_and___item_
    _UiiFilter_or_ = SET_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_or_._cont = __UiiFilter_or___item_
    _UiiFilter_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    UiiFilter._cont = ASN1Dict([
        ('item', _UiiFilter_item),
        ('and', _UiiFilter_and_),
        ('or', _UiiFilter_or_),
        ('not', _UiiFilter_not_),
        ])
    UiiFilter._ext = None
    
    #-----< UiiItem >-----#
    UiiItem = SEQ(name='UiiItem', mode=MODE_TYPE)
    _UiiItem_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _UiiItem_length = INT(name='length', mode=MODE_TYPE, opt=True)
    UiiItem._cont = ASN1Dict([
        ('type', _UiiItem_type),
        ('length', _UiiItem_length),
        ])
    UiiItem._ext = None
    
    #-----< uiiInUrn >-----#
    uiiInUrn = CLASS(name='uiiInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiInUrn_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    uiiInUrn._val = dict([('Type', _uiiInUrn_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uiiInUrn']), ('id', (2, 5, 4, 80))])
    
    #-----< contentUrl >-----#
    contentUrl = CLASS(name='contentUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    contentUrl._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['contentUrl']), ('id', (2, 5, 4, 81))])
    
    #-----< uii >-----#
    uii = CLASS(name='uii', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uii_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    uii._val = dict([('Type', _uii_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['uii']), ('id', (2, 5, 4, 90))])
    
    #-----< epc >-----#
    epc = CLASS(name='epc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epc_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    epc._val = dict([('Type', _epc_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['epc']), ('id', (2, 5, 4, 91))])
    
    #-----< tagAfi >-----#
    tagAfi = CLASS(name='tagAfi', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagAfi_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    tagAfi._val = dict([('Type', _tagAfi_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_8), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['tagAfi']), ('id', (2, 5, 4, 92))])
    
    #-----< epcFormat >-----#
    epcFormat = CLASS(name='epcFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epcFormat_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcFormat._val = dict([('Type', _epcFormat_val_Type), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 6)), ('ldapName', ['epcFormat']), ('id', (2, 5, 4, 93))])
    
    #-----< EpcFormat >-----#
    EpcFormat = SEQ(name='EpcFormat', mode=MODE_TYPE)
    _EpcFormat_fields = SEQ_OF(name='fields', mode=MODE_TYPE)
    __EpcFormat_fields__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___EpcFormat_fields__item__bits = INT(name='bits', mode=MODE_TYPE)
    ___EpcFormat_fields__item__charField = CHOICE(name='charField', mode=MODE_TYPE)
    ____EpcFormat_fields__item__charField_characters = INT(name='characters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____EpcFormat_fields__item__charField_maxValue = INT(name='maxValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EpcFormat_fields__item__charField._cont = ASN1Dict([
        ('characters', ____EpcFormat_fields__item__charField_characters),
        ('maxValue', ____EpcFormat_fields__item__charField_maxValue),
        ])
    ___EpcFormat_fields__item__charField._ext = None
    ___EpcFormat_fields__item__result = ENUM(name='result', mode=MODE_TYPE, default='numericPad')
    ___EpcFormat_fields__item__result._cont = ASN1Dict([('numericPad', 0), ('numeric', 1), ('alpha7bits', 2)])
    ___EpcFormat_fields__item__result._ext = None
    __EpcFormat_fields__item_._cont = ASN1Dict([
        ('bits', ___EpcFormat_fields__item__bits),
        ('charField', ___EpcFormat_fields__item__charField),
        ('result', ___EpcFormat_fields__item__result),
        ])
    __EpcFormat_fields__item_._ext = None
    _EpcFormat_fields._cont = __EpcFormat_fields__item_
    _EpcFormat_fields._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EpcFormat_digitShift = INT(name='digitShift', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_checkCalc = INT(name='checkCalc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_urnPrefix = STR_UTF8(name='urnPrefix', mode=MODE_TYPE, opt=True)
    EpcFormat._cont = ASN1Dict([
        ('fields', _EpcFormat_fields),
        ('digitShift', _EpcFormat_digitShift),
        ('checkCalc', _EpcFormat_checkCalc),
        ('urnPrefix', _EpcFormat_urnPrefix),
        ])
    EpcFormat._ext = None
    
    #-----< epcInUrn >-----#
    epcInUrn = CLASS(name='epcInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    epcInUrn._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['urn']), ('id', (2, 5, 4, 86))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['epcInUrn']), ('id', (2, 5, 4, 94))])
    
    #-----< ldapUrl >-----#
    ldapUrl = CLASS(name='ldapUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ldapUrl._val = dict([('derivation', dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uri']), ('id', (2, 5, 4, 83))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['url']), ('id', (2, 5, 4, 87))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['ldapUrl']), ('id', (2, 5, 4, 95))])
    
    #-----< tagLocation >-----#
    tagLocation = CLASS(name='tagLocation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    tagLocation._val = dict([('derivation', dict([('Type', __ATTRIBUTE_derivation_val_Type_7), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['utmCoordinates']), ('id', (2, 5, 4, 88))])), ('single-valued', True), ('ldapSyntax', (2, 5, 40, 4)), ('ldapName', ['tagLocation']), ('id', (2, 5, 4, 96))])
    
    #-----< dSAProblem >-----#
    dSAProblem = CLASS(name='dSAProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dSAProblem_val_Type = OID(name='Type', mode=MODE_TYPE)
    dSAProblem._val = dict([('Type', _dSAProblem_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 0))])
    
    #-----< searchServiceProblem >-----#
    searchServiceProblem = CLASS(name='searchServiceProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchServiceProblem_val_Type = OID(name='Type', mode=MODE_TYPE)
    searchServiceProblem._val = dict([('Type', _searchServiceProblem_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('id', (2, 5, 35, 1))])
    
    #-----< serviceType >-----#
    serviceType = CLASS(name='serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceType_val_Type = OID(name='Type', mode=MODE_TYPE)
    serviceType._val = dict([('Type', _serviceType_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('single-valued', True), ('id', (2, 5, 35, 2))])
    
    #-----< attributeTypeList >-----#
    attributeTypeList = CLASS(name='attributeTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypeList_val_Type = OID(name='Type', mode=MODE_TYPE)
    attributeTypeList._val = dict([('Type', _attributeTypeList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 3))])
    
    #-----< matchingRuleList >-----#
    matchingRuleList = CLASS(name='matchingRuleList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleList_val_Type = OID(name='Type', mode=MODE_TYPE)
    matchingRuleList._val = dict([('Type', _matchingRuleList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 4))])
    
    #-----< filterItem >-----#
    filterItem = CLASS(name='filterItem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _filterItem_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    filterItem._val = dict([('Type', _filterItem_val_Type), ('id', (2, 5, 35, 5))])
    
    #-----< attributeCombinations >-----#
    attributeCombinations = CLASS(name='attributeCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCombinations_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    attributeCombinations._val = dict([('Type', _attributeCombinations_val_Type), ('id', (2, 5, 35, 6))])
    
    #-----< contextTypeList >-----#
    contextTypeList = CLASS(name='contextTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypeList_val_Type = OID(name='Type', mode=MODE_TYPE)
    contextTypeList._val = dict([('Type', _contextTypeList_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 7))])
    
    #-----< contextList >-----#
    contextList = CLASS(name='contextList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextList_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    contextList._val = dict([('Type', _contextList_val_Type), ('id', (2, 5, 35, 8))])
    
    #-----< contextCombinations >-----#
    contextCombinations = CLASS(name='contextCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextCombinations_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    contextCombinations._val = dict([('Type', _contextCombinations_val_Type), ('id', (2, 5, 35, 9))])
    
    #-----< hierarchySelectList >-----#
    hierarchySelectList = CLASS(name='hierarchySelectList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchySelectList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')))
    hierarchySelectList._val = dict([('Type', _hierarchySelectList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 10))])
    
    #-----< searchControlOptionsList >-----#
    searchControlOptionsList = CLASS(name='searchControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchControlOptionsList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')))
    searchControlOptionsList._val = dict([('Type', _searchControlOptionsList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 11))])
    
    #-----< serviceControlOptionsList >-----#
    serviceControlOptionsList = CLASS(name='serviceControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceControlOptionsList_val_Type = BIT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')))
    serviceControlOptionsList._val = dict([('Type', _serviceControlOptionsList_val_Type), ('single-valued', True), ('id', (2, 5, 35, 12))])
    
    #-----< multipleMatchingLocalities >-----#
    multipleMatchingLocalities = CLASS(name='multipleMatchingLocalities', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _multipleMatchingLocalities_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    multipleMatchingLocalities._val = dict([('Type', _multipleMatchingLocalities_val_Type), ('id', (2, 5, 35, 13))])
    
    #-----< MultipleMatchingLocalities >-----#
    MultipleMatchingLocalities = SEQ(name='MultipleMatchingLocalities', mode=MODE_TYPE)
    _MultipleMatchingLocalities_matchingRuleUsed = OID(name='matchingRuleUsed', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _MultipleMatchingLocalities_attributeList = SEQ_OF(name='attributeList', mode=MODE_TYPE)
    __MultipleMatchingLocalities_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _MultipleMatchingLocalities_attributeList._cont = __MultipleMatchingLocalities_attributeList__item_
    MultipleMatchingLocalities._cont = ASN1Dict([
        ('matchingRuleUsed', _MultipleMatchingLocalities_matchingRuleUsed),
        ('attributeList', _MultipleMatchingLocalities_attributeList),
        ])
    MultipleMatchingLocalities._ext = []
    
    #-----< proposedRelaxation >-----#
    proposedRelaxation = CLASS(name='proposedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _proposedRelaxation_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MRMappings')))
    proposedRelaxation._val = dict([('Type', _proposedRelaxation_val_Type), ('id', (2, 5, 35, 14))])
    
    #-----< MRMappings >-----#
    MRMappings = SEQ_OF(name='MRMappings', mode=MODE_TYPE)
    _MRMappings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    MRMappings._cont = _MRMappings__item_
    
    #-----< appliedRelaxation >-----#
    appliedRelaxation = CLASS(name='appliedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _appliedRelaxation_val_Type = OID(name='Type', mode=MODE_TYPE)
    appliedRelaxation._val = dict([('Type', _appliedRelaxation_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('id', (2, 5, 35, 15))])
    
    #-----< pwdResponseValue >-----#
    pwdResponseValue = CLASS(name='pwdResponseValue', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdResponseValue_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PwdResponse')))
    pwdResponseValue._val = dict([('Type', _pwdResponseValue_val_Type), ('id', (2, 5, 35, 16))])
    
    #-----< PwdResponse >-----#
    PwdResponse = SEQ(name='PwdResponse', mode=MODE_TYPE)
    _PwdResponse_warning = CHOICE(name='warning', mode=MODE_TYPE, opt=True)
    __PwdResponse_warning_timeleft = INT(name='timeleft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_timeleft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponse_warning_graceRemaining = INT(name='graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponse_warning._cont = ASN1Dict([
        ('timeleft', __PwdResponse_warning_timeleft),
        ('graceRemaining', __PwdResponse_warning_graceRemaining),
        ])
    _PwdResponse_warning._ext = []
    _PwdResponse_error = ENUM(name='error', mode=MODE_TYPE, opt=True)
    _PwdResponse_error._cont = ASN1Dict([('passwordExpired', 0), ('changeAfterReset', 1)])
    _PwdResponse_error._ext = []
    PwdResponse._cont = ASN1Dict([
        ('warning', _PwdResponse_warning),
        ('error', _PwdResponse_error),
        ])
    PwdResponse._ext = None
    
    #-----< ldapDiagnosticMsg >-----#
    ldapDiagnosticMsg = CLASS(name='ldapDiagnosticMsg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapDiagnosticMsg_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    ldapDiagnosticMsg._val = dict([('Type', _ldapDiagnosticMsg_val_Type), ('single-valued', True), ('id', (2, 5, 35, 17))])
    
    #-----< uid >-----#
    uid = CLASS(name='uid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uid_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    uid._val = dict([('Type', _uid_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uid']), ('id', (0, 9, 2342, 19200300, 100, 1, 1))])
    
    #-----< dc >-----#
    dc = CLASS(name='dc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dc_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    dc._val = dict([('Type', _dc_val_Type), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])), ('substrings-match', dict([('AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['dc']), ('id', (0, 9, 2342, 19200300, 100, 1, 25))])
    
    #-----< caseExactMatch >-----#
    caseExactMatch = CLASS(name='caseExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactMatch._val = dict([('AssertionType', _caseExactMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactMatch']), ('id', (2, 5, 13, 5))])
    
    #-----< caseIgnoreMatch >-----#
    caseIgnoreMatch = CLASS(name='caseIgnoreMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreMatch._val = dict([('AssertionType', _caseIgnoreMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreMatch']), ('id', (2, 5, 13, 2))])
    
    #-----< caseExactOrderingMatch >-----#
    caseExactOrderingMatch = CLASS(name='caseExactOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactOrderingMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactOrderingMatch._val = dict([('AssertionType', _caseExactOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseExactOrderingMatch']), ('id', (2, 5, 13, 6))])
    
    #-----< caseIgnoreOrderingMatch >-----#
    caseIgnoreOrderingMatch = CLASS(name='caseIgnoreOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreOrderingMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreOrderingMatch._val = dict([('AssertionType', _caseIgnoreOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['caseIgnoreOrderingMatch']), ('id', (2, 5, 13, 3))])
    
    #-----< caseExactSubstringsMatch >-----#
    caseExactSubstringsMatch = CLASS(name='caseExactSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseExactSubstringsMatch._val = dict([('AssertionType', _caseExactSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseExactSubstringsMatch']), ('id', (2, 5, 13, 7))])
    
    #-----< caseIgnoreSubstringsMatch >-----#
    caseIgnoreSubstringsMatch = CLASS(name='caseIgnoreSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreSubstringsMatch._val = dict([('AssertionType', _caseIgnoreSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreSubstringsMatch']), ('id', (2, 5, 13, 4))])
    
    #-----< SubstringAssertion >-----#
    SubstringAssertion = SEQ_OF(name='SubstringAssertion', mode=MODE_TYPE)
    _SubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __SubstringAssertion__item__initial = CHOICE(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__any = CHOICE(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__final = CHOICE(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__control = SEQ(name='control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubstringAssertion__item__control_type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    ____SubstringAssertion__item__control_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubstringAssertion__item__control_type_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_type_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubstringAssertion__item__control_type_tab._val = ASN1Set(rv=[dict([('Type', _____SubstringAssertion__item__control_type_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', _____SubstringAssertion__item__control_type_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubstringAssertion__item__control_type._const_tab = ____SubstringAssertion__item__control_type_tab
    ___SubstringAssertion__item__control_type._const_tab_at = None
    ___SubstringAssertion__item__control_type._const_tab_id = 'id'
    ___SubstringAssertion__item__control_values = SET_OF(name='values', mode=MODE_TYPE)
    ____SubstringAssertion__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____SubstringAssertion__item__control_values__item_._const_tab = ____SubstringAssertion__item__control_type_tab
    ____SubstringAssertion__item__control_values__item_._const_tab_at = ('..', '..', 'type')
    ____SubstringAssertion__item__control_values__item_._const_tab_id = 'Type'
    ___SubstringAssertion__item__control_values._cont = ____SubstringAssertion__item__control_values__item_
    ___SubstringAssertion__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubstringAssertion__item__control_valuesWithContext = SET_OF(name='valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubstringAssertion__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_valuesWithContext__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab = ____SubstringAssertion__item__control_type_tab
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', 'type')
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_id = 'Type'
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList = SET_OF(name='contextList', mode=MODE_TYPE)
    ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._cont = ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubstringAssertion__item__control_valuesWithContext__item_._cont = ASN1Dict([
        ('value', _____SubstringAssertion__item__control_valuesWithContext__item__value),
        ('contextList', _____SubstringAssertion__item__control_valuesWithContext__item__contextList),
        ])
    ____SubstringAssertion__item__control_valuesWithContext__item_._ext = []
    ___SubstringAssertion__item__control_valuesWithContext._cont = ____SubstringAssertion__item__control_valuesWithContext__item_
    ___SubstringAssertion__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubstringAssertion__item__control._cont = ASN1Dict([
        ('type', ___SubstringAssertion__item__control_type),
        ('values', ___SubstringAssertion__item__control_values),
        ('valuesWithContext', ___SubstringAssertion__item__control_valuesWithContext),
        ])
    __SubstringAssertion__item__control._ext = []
    _SubstringAssertion__item_._cont = ASN1Dict([
        ('initial', __SubstringAssertion__item__initial),
        ('any', __SubstringAssertion__item__any),
        ('final', __SubstringAssertion__item__final),
        ('control', __SubstringAssertion__item__control),
        ])
    _SubstringAssertion__item_._ext = []
    SubstringAssertion._cont = _SubstringAssertion__item_
    
    #-----< numericStringMatch >-----#
    numericStringMatch = CLASS(name='numericStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringMatch_val_AssertionType = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    numericStringMatch._val = dict([('AssertionType', _numericStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringMatch']), ('id', (2, 5, 13, 8))])
    
    #-----< numericStringOrderingMatch >-----#
    numericStringOrderingMatch = CLASS(name='numericStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringOrderingMatch_val_AssertionType = STR_NUM(name='AssertionType', mode=MODE_TYPE)
    numericStringOrderingMatch._val = dict([('AssertionType', _numericStringOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), ('ldapName', ['numericStringOrderingMatch']), ('id', (2, 5, 13, 9))])
    
    #-----< numericStringSubstringsMatch >-----#
    numericStringSubstringsMatch = CLASS(name='numericStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    numericStringSubstringsMatch._val = dict([('AssertionType', _numericStringSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['numericStringSubstringsMatch']), ('id', (2, 5, 13, 10))])
    
    #-----< caseIgnoreListMatch >-----#
    caseIgnoreListMatch = CLASS(name='caseIgnoreListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    caseIgnoreListMatch._val = dict([('AssertionType', _caseIgnoreListMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), ('ldapName', ['caseIgnoreListMatch']), ('id', (2, 5, 13, 11))])
    
    #-----< CaseIgnoreList >-----#
    CaseIgnoreList = SEQ_OF(name='CaseIgnoreList', mode=MODE_TYPE)
    _CaseIgnoreList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    CaseIgnoreList._cont = _CaseIgnoreList__item_
    
    #-----< caseIgnoreListSubstringsMatch >-----#
    caseIgnoreListSubstringsMatch = CLASS(name='caseIgnoreListSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreListSubstringsMatch._val = dict([('AssertionType', _caseIgnoreListSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreListSubstringsMatch']), ('id', (2, 5, 13, 12))])
    
    #-----< storedPrefixMatch >-----#
    storedPrefixMatch = CLASS(name='storedPrefixMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _storedPrefixMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    storedPrefixMatch._val = dict([('AssertionType', _storedPrefixMatch_val_AssertionType), ('id', (2, 5, 13, 41))])
    
    #-----< booleanMatch >-----#
    booleanMatch = CLASS(name='booleanMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _booleanMatch_val_AssertionType = BOOL(name='AssertionType', mode=MODE_TYPE)
    booleanMatch._val = dict([('AssertionType', _booleanMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['booleanMatch']), ('id', (2, 5, 13, 13))])
    
    #-----< integerMatch >-----#
    integerMatch = CLASS(name='integerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerMatch._val = dict([('AssertionType', _integerMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerMatch']), ('id', (2, 5, 13, 14))])
    
    #-----< integerOrderingMatch >-----#
    integerOrderingMatch = CLASS(name='integerOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerOrderingMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerOrderingMatch._val = dict([('AssertionType', _integerOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerOrderingMatch']), ('id', (2, 5, 13, 15))])
    
    #-----< bitStringMatch >-----#
    bitStringMatch = CLASS(name='bitStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _bitStringMatch_val_AssertionType = BIT_STR(name='AssertionType', mode=MODE_TYPE)
    bitStringMatch._val = dict([('AssertionType', _bitStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), ('ldapName', ['bitStringMatch']), ('id', (2, 5, 13, 16))])
    
    #-----< octetStringMatch >-----#
    octetStringMatch = CLASS(name='octetStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    octetStringMatch._val = dict([('AssertionType', _octetStringMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringMatch']), ('id', (2, 5, 13, 17))])
    
    #-----< octetStringOrderingMatch >-----#
    octetStringOrderingMatch = CLASS(name='octetStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringOrderingMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    octetStringOrderingMatch._val = dict([('AssertionType', _octetStringOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), ('ldapName', ['octetStringOrderingMatch']), ('id', (2, 5, 13, 18))])
    
    #-----< octetStringSubstringsMatch >-----#
    octetStringSubstringsMatch = CLASS(name='octetStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'OctetSubstringAssertion')))
    octetStringSubstringsMatch._val = dict([('AssertionType', _octetStringSubstringsMatch_val_AssertionType), ('id', (2, 5, 13, 19))])
    
    #-----< OctetSubstringAssertion >-----#
    OctetSubstringAssertion = SEQ_OF(name='OctetSubstringAssertion', mode=MODE_TYPE)
    _OctetSubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __OctetSubstringAssertion__item__initial = OCT_STR(name='initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__any = OCT_STR(name='any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__final = OCT_STR(name='final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OctetSubstringAssertion__item_._cont = ASN1Dict([
        ('initial', __OctetSubstringAssertion__item__initial),
        ('any', __OctetSubstringAssertion__item__any),
        ('final', __OctetSubstringAssertion__item__final),
        ])
    _OctetSubstringAssertion__item_._ext = []
    OctetSubstringAssertion._cont = _OctetSubstringAssertion__item_
    
    #-----< telephoneNumberMatch >-----#
    telephoneNumberMatch = CLASS(name='telephoneNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberMatch_val_AssertionType = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumberMatch._val = dict([('AssertionType', _telephoneNumberMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), ('ldapName', ['telephoneNumberMatch']), ('id', (2, 5, 13, 20))])
    
    #-----< telephoneNumberSubstringsMatch >-----#
    telephoneNumberSubstringsMatch = CLASS(name='telephoneNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    telephoneNumberSubstringsMatch._val = dict([('AssertionType', _telephoneNumberSubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['telephoneNumberSubstringsMatch']), ('id', (2, 5, 13, 21))])
    
    #-----< presentationAddressMatch >-----#
    presentationAddressMatch = CLASS(name='presentationAddressMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _presentationAddressMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddressMatch._val = dict([('AssertionType', _presentationAddressMatch_val_AssertionType), ('id', (2, 5, 13, 22))])
    
    #-----< uniqueMemberMatch >-----#
    uniqueMemberMatch = CLASS(name='uniqueMemberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uniqueMemberMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMemberMatch._val = dict([('AssertionType', _uniqueMemberMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), ('ldapName', ['uniqueMemberMatch']), ('id', (2, 5, 13, 23))])
    
    #-----< protocolInformationMatch >-----#
    protocolInformationMatch = CLASS(name='protocolInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _protocolInformationMatch_val_AssertionType = OCT_STR(name='AssertionType', mode=MODE_TYPE)
    protocolInformationMatch._val = dict([('AssertionType', _protocolInformationMatch_val_AssertionType), ('id', (2, 5, 13, 24))])
    
    #-----< facsimileNumberMatch >-----#
    facsimileNumberMatch = CLASS(name='facsimileNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberMatch_val_AssertionType = STR_PRINT(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    facsimileNumberMatch._val = dict([('AssertionType', _facsimileNumberMatch_val_AssertionType), ('id', (2, 5, 13, 63))])
    
    #-----< facsimileNumberSubstringsMatch >-----#
    facsimileNumberSubstringsMatch = CLASS(name='facsimileNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberSubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    facsimileNumberSubstringsMatch._val = dict([('AssertionType', _facsimileNumberSubstringsMatch_val_AssertionType), ('id', (2, 5, 13, 64))])
    
    #-----< uUIDPairMatch >-----#
    uUIDPairMatch = CLASS(name='uUIDPairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uUIDPairMatch_val_AssertionType = SEQ(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPairMatch._val = dict([('AssertionType', _uUIDPairMatch_val_AssertionType), ('id', (2, 5, 13, 68))])
    
    #-----< uTCTimeMatch >-----#
    uTCTimeMatch = CLASS(name='uTCTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeMatch_val_AssertionType = TIME_UTC(name='AssertionType', mode=MODE_TYPE)
    uTCTimeMatch._val = dict([('AssertionType', _uTCTimeMatch_val_AssertionType), ('id', (2, 5, 13, 25))])
    
    #-----< uTCTimeOrderingMatch >-----#
    uTCTimeOrderingMatch = CLASS(name='uTCTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeOrderingMatch_val_AssertionType = TIME_UTC(name='AssertionType', mode=MODE_TYPE)
    uTCTimeOrderingMatch._val = dict([('AssertionType', _uTCTimeOrderingMatch_val_AssertionType), ('id', (2, 5, 13, 26))])
    
    #-----< generalizedTimeMatch >-----#
    generalizedTimeMatch = CLASS(name='generalizedTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeMatch_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    generalizedTimeMatch._val = dict([('AssertionType', _generalizedTimeMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeMatch']), ('id', (2, 5, 13, 27))])
    
    #-----< generalizedTimeOrderingMatch >-----#
    generalizedTimeOrderingMatch = CLASS(name='generalizedTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeOrderingMatch_val_AssertionType = TIME_GEN(name='AssertionType', mode=MODE_TYPE)
    generalizedTimeOrderingMatch._val = dict([('AssertionType', _generalizedTimeOrderingMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), ('ldapName', ['generalizedTimeOrderingMatch']), ('id', (2, 5, 13, 28))])
    
    #-----< systemProposedMatch >-----#
    systemProposedMatch = CLASS(name='systemProposedMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    systemProposedMatch._val = dict([('id', (2, 5, 13, 47))])
    
    #-----< integerFirstComponentMatch >-----#
    integerFirstComponentMatch = CLASS(name='integerFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerFirstComponentMatch_val_AssertionType = INT(name='AssertionType', mode=MODE_TYPE)
    integerFirstComponentMatch._val = dict([('AssertionType', _integerFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), ('ldapName', ['integerFirstComponentMatch']), ('id', (2, 5, 13, 29))])
    
    #-----< objectIdentifierFirstComponentMatch >-----#
    objectIdentifierFirstComponentMatch = CLASS(name='objectIdentifierFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierFirstComponentMatch_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    objectIdentifierFirstComponentMatch._val = dict([('AssertionType', _objectIdentifierFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierFirstComponentMatch']), ('id', (2, 5, 13, 30))])
    
    #-----< directoryStringFirstComponentMatch >-----#
    directoryStringFirstComponentMatch = CLASS(name='directoryStringFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _directoryStringFirstComponentMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryStringFirstComponentMatch._val = dict([('AssertionType', _directoryStringFirstComponentMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['directoryStringFirstComponentMatch']), ('id', (2, 5, 13, 31))])
    
    #-----< wordMatch >-----#
    wordMatch = CLASS(name='wordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _wordMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    wordMatch._val = dict([('AssertionType', _wordMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['wordMatch']), ('id', (2, 5, 13, 32))])
    
    #-----< keywordMatch >-----#
    keywordMatch = CLASS(name='keywordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _keywordMatch_val_AssertionType = CHOICE(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    keywordMatch._val = dict([('AssertionType', _keywordMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['keywordMatch']), ('id', (2, 5, 13, 33))])
    
    #-----< generalWordMatch >-----#
    generalWordMatch = CLASS(name='generalWordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalWordMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    generalWordMatch._val = dict([('AssertionType', _generalWordMatch_val_AssertionType), ('id', (2, 5, 13, 48))])
    
    #-----< sequenceMatchType >-----#
    sequenceMatchType = CLASS(name='sequenceMatchType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _sequenceMatchType_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SequenceMatchType')))
    sequenceMatchType._val = dict([('Type', _sequenceMatchType_val_Type), ('single-valued', True), ('id', (2, 5, 37, 1))])
    
    #-----< SequenceMatchType >-----#
    SequenceMatchType = ENUM(name='SequenceMatchType', mode=MODE_TYPE)
    SequenceMatchType._cont = ASN1Dict([('sequenceExact', 0), ('sequenceDeletion', 1), ('sequenceRestrictedDeletion', 2), ('sequencePermutation', 3), ('sequencePermutationAndDeletion', 4), ('sequenceProviderDefined', 5)])
    SequenceMatchType._ext = []
    
    #-----< wordMatchTypes >-----#
    wordMatchTypes = CLASS(name='wordMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _wordMatchTypes_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'WordMatchTypes')))
    wordMatchTypes._val = dict([('Type', _wordMatchTypes_val_Type), ('single-valued', True), ('id', (2, 5, 37, 2))])
    
    #-----< WordMatchTypes >-----#
    WordMatchTypes = ENUM(name='WordMatchTypes', mode=MODE_TYPE)
    WordMatchTypes._cont = ASN1Dict([('wordExact', 0), ('wordTruncated', 1), ('wordPhonetic', 2), ('wordProviderDefined', 3)])
    WordMatchTypes._ext = []
    
    #-----< characterMatchTypes >-----#
    characterMatchTypes = CLASS(name='characterMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _characterMatchTypes_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CharacterMatchTypes')))
    characterMatchTypes._val = dict([('Type', _characterMatchTypes_val_Type), ('single-valued', True), ('id', (2, 5, 37, 3))])
    
    #-----< CharacterMatchTypes >-----#
    CharacterMatchTypes = ENUM(name='CharacterMatchTypes', mode=MODE_TYPE)
    CharacterMatchTypes._cont = ASN1Dict([('characterExact', 0), ('characterCaseIgnore', 1), ('characterMapped', 2)])
    CharacterMatchTypes._ext = []
    
    #-----< selectedContexts >-----#
    selectedContexts = CLASS(name='selectedContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _selectedContexts_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    selectedContexts._val = dict([('Type', _selectedContexts_val_Type), ('id', (2, 5, 37, 4))])
    
    #-----< approximateStringMatch >-----#
    approximateStringMatch = CLASS(name='approximateStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    approximateStringMatch._val = dict([('id', (2, 5, 13, 49))])
    
    #-----< ignoreIfAbsentMatch >-----#
    ignoreIfAbsentMatch = CLASS(name='ignoreIfAbsentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    ignoreIfAbsentMatch._val = dict([('id', (2, 5, 13, 50))])
    
    #-----< nullMatch >-----#
    nullMatch = CLASS(name='nullMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    nullMatch._val = dict([('id', (2, 5, 13, 51))])
    
    #-----< ZONAL-MATCHING >-----#
    ZONAL_MATCHING = CLASS(name='ZONAL-MATCHING', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'MAPPING-BASED-MATCHING')))
    _ZONAL_MATCHING_selectBy = SEQ_OF(name='selectBy', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalSelect')), opt=True)
    _ZONAL_MATCHING_ApplicableTo = CLASS(name='ApplicableTo', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ZONAL_MATCHING_subtypesIncluded = BOOL(name='subtypesIncluded', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_combinable = BOOL(name='combinable', mode=MODE_VALUE)
    _ZONAL_MATCHING_combinable._const_val = ASN1Set(rv=[True], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_mappingResults = ENUM(name='mappingResults', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalResult')), opt=True)
    _ZONAL_MATCHING_userControl = BOOL(name='userControl', mode=MODE_VALUE, default=False)
    _ZONAL_MATCHING_exclusive = BOOL(name='exclusive', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_matching_rule = OID(name='matching-rule', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _ZONAL_MATCHING_matching_rule._const_val = ASN1Set(rv=[(2, 5, 13, 52)], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    ZONAL_MATCHING._cont = ASN1Dict([
        ('selectBy', _ZONAL_MATCHING_selectBy),
        ('ApplicableTo', _ZONAL_MATCHING_ApplicableTo),
        ('subtypesIncluded', _ZONAL_MATCHING_subtypesIncluded),
        ('combinable', _ZONAL_MATCHING_combinable),
        ('mappingResults', _ZONAL_MATCHING_mappingResults),
        ('userControl', _ZONAL_MATCHING_userControl),
        ('exclusive', _ZONAL_MATCHING_exclusive),
        ('matching-rule', _ZONAL_MATCHING_matching_rule),
        ('id', _ZONAL_MATCHING_id),
        ])
    
    #-----< ZonalSelect >-----#
    ZonalSelect = SEQ_OF(name='ZonalSelect', mode=MODE_TYPE)
    _ZonalSelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ZonalSelect._cont = _ZonalSelect__item_
    
    #-----< ZonalResult >-----#
    ZonalResult = ENUM(name='ZonalResult', mode=MODE_TYPE)
    ZonalResult._cont = ASN1Dict([('cannot-select-mapping', 0), ('zero-mappings', 2), ('multiple-mappings', 3)])
    ZonalResult._ext = []
    
    #-----< zonalMatch >-----#
    zonalMatch = CLASS(name='zonalMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    __MATCHING_RULE_uniqueMatchIndicator_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    zonalMatch._val = dict([('uniqueMatchIndicator', dict([('Type', __MATCHING_RULE_uniqueMatchIndicator_val_Type), ('id', (2, 5, 35, 13))])), ('id', (2, 5, 13, 52))])
    
    #-----< uriMatch >-----#
    uriMatch = CLASS(name='uriMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uriMatch_val_AssertionType = STR_UTF8(name='AssertionType', mode=MODE_TYPE)
    uriMatch._val = dict([('AssertionType', _uriMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), ('ldapName', ['uriMatch']), ('id', (2, 5, 13, 70))])
    
    #-----< caseExactIA5Match >-----#
    caseExactIA5Match = CLASS(name='caseExactIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactIA5Match_val_AssertionType = STR_IA5(name='AssertionType', mode=MODE_TYPE)
    caseExactIA5Match._val = dict([('AssertionType', _caseExactIA5Match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['caseExactIA5Match']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1))])
    
    #-----< caseIgnoreIA5Match >-----#
    caseIgnoreIA5Match = CLASS(name='caseIgnoreIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5Match_val_AssertionType = STR_IA5(name='AssertionType', mode=MODE_TYPE)
    caseIgnoreIA5Match._val = dict([('AssertionType', _caseIgnoreIA5Match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), ('ldapName', ['caseIgnoreIA5Match']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< caseIgnoreIA5SubstringsMatch >-----#
    caseIgnoreIA5SubstringsMatch = CLASS(name='caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5SubstringsMatch_val_AssertionType = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreIA5SubstringsMatch._val = dict([('AssertionType', _caseIgnoreIA5SubstringsMatch_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), ('ldapName', ['caseIgnoreIA5SubstringsMatch']), ('id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< utmCoords >-----#
    utmCoords = CLASS(name='utmCoords', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utmCoords_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoords._val = dict([('ldapDesc', 'UTM Coordinates'), ('Type', _utmCoords_val_Type), ('id', (2, 5, 40, 4))])
    
    #-----< uiiForm >-----#
    uiiForm = CLASS(name='uiiForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _uiiForm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiForm._val = dict([('ldapDesc', 'UII Format'), ('Type', _uiiForm_val_Type), ('id', (2, 5, 40, 5))])
    
    #-----< epcForm >-----#
    epcForm = CLASS(name='epcForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _epcForm_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcForm._val = dict([('ldapDesc', 'EPC Format'), ('Type', _epcForm_val_Type), ('id', (2, 5, 40, 6))])
    
    #-----< attributeTypeDescription >-----#
    attributeTypeDescription = CLASS(name='attributeTypeDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _attributeTypeDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypeDescription._val = dict([('ldapDesc', 'Attribute Type Description'), ('Type', _attributeTypeDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3))])
    
    #-----< bitString >-----#
    bitString = CLASS(name='bitString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _bitString_val_Type = BIT_STR(name='Type', mode=MODE_TYPE)
    bitString._val = dict([('ldapDesc', 'Bit String'), ('Type', _bitString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6))])
    
    #-----< boolean >-----#
    boolean = CLASS(name='boolean', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _boolean_val_Type = BOOL(name='Type', mode=MODE_TYPE)
    boolean._val = dict([('ldapDesc', 'Boolean'), ('Type', _boolean_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7))])
    
    #-----< countryString >-----#
    countryString = CLASS(name='countryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryString._val = dict([('ldapDesc', 'Country String'), ('Type', _countryString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11))])
    
    #-----< dn >-----#
    dn = CLASS(name='dn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dn_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    dn._val = dict([('ldapDesc', 'DN'), ('Type', _dn_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12))])
    
    #-----< deliveryMethod >-----#
    deliveryMethod = CLASS(name='deliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _deliveryMethod_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    deliveryMethod._val = dict([('ldapDesc', 'Delevery Method'), ('Type', _deliveryMethod_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14))])
    
    #-----< directoryString >-----#
    directoryString = CLASS(name='directoryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _directoryString_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryString._val = dict([('ldapDesc', 'Directory String'), ('Type', _directoryString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15))])
    
    #-----< dITContentRuleDescription >-----#
    dITContentRuleDescription = CLASS(name='dITContentRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITContentRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRuleDescription._val = dict([('ldapDesc', 'DIT Content Rule Description'), ('Type', _dITContentRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16))])
    
    #-----< dITStructureRuleDescription >-----#
    dITStructureRuleDescription = CLASS(name='dITStructureRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITStructureRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRuleDescription._val = dict([('ldapDesc', 'DIT StructureRule Description'), ('Type', _dITStructureRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17))])
    
    #-----< enhancedGuide >-----#
    enhancedGuide = CLASS(name='enhancedGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _enhancedGuide_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedGuide._val = dict([('ldapDesc', 'Enhanced Guide'), ('Type', _enhancedGuide_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21))])
    
    #-----< facsimileTelephoneNr >-----#
    facsimileTelephoneNr = CLASS(name='facsimileTelephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _facsimileTelephoneNr_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNr._val = dict([('ldapDesc', 'Facsimile Telephone Number'), ('Type', _facsimileTelephoneNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22))])
    
    #-----< fax >-----#
    fax = CLASS(name='fax', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _fax_val_Type = NULL(name='Type', mode=MODE_TYPE)
    fax._val = dict([('ldapDesc', 'Fax'), ('Type', _fax_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23))])
    
    #-----< generalizedTime >-----#
    generalizedTime = CLASS(name='generalizedTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _generalizedTime_val_Type = TIME_GEN(name='Type', mode=MODE_TYPE)
    generalizedTime._val = dict([('ldapDesc', 'Generalized Time'), ('Type', _generalizedTime_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24))])
    
    #-----< guide >-----#
    guide = CLASS(name='guide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _guide_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    guide._val = dict([('ldapDesc', 'Guide'), ('Type', _guide_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25))])
    
    #-----< ia5String >-----#
    ia5String = CLASS(name='ia5String', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ia5String_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    ia5String._val = dict([('ldapDesc', 'IA5 String'), ('Type', _ia5String_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26))])
    
    #-----< integer >-----#
    integer = CLASS(name='integer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _integer_val_Type = INT(name='Type', mode=MODE_TYPE)
    integer._val = dict([('ldapDesc', 'INTEGER'), ('Type', _integer_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27))])
    
    #-----< jpeg >-----#
    jpeg = CLASS(name='jpeg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _jpeg_val_Type = NULL(name='Type', mode=MODE_TYPE)
    jpeg._val = dict([('ldapDesc', 'JPEG'), ('Type', _jpeg_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28))])
    
    #-----< matchingRuleDescription >-----#
    matchingRuleDescription = CLASS(name='matchingRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRuleDescription._val = dict([('ldapDesc', 'Matching Rule Description'), ('Type', _matchingRuleDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30))])
    
    #-----< matchingRuleUseDescription >-----#
    matchingRuleUseDescription = CLASS(name='matchingRuleUseDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleUseDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUseDescription._val = dict([('ldapDesc', 'Matching Rule Use Description'), ('Type', _matchingRuleUseDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31))])
    
    #-----< nameAndOptionalUID >-----#
    nameAndOptionalUID = CLASS(name='nameAndOptionalUID', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameAndOptionalUID_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    nameAndOptionalUID._val = dict([('ldapDesc', 'Name And Optional UID'), ('Type', _nameAndOptionalUID_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34))])
    
    #-----< nameFormDescription >-----#
    nameFormDescription = CLASS(name='nameFormDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameFormDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameFormDescription._val = dict([('ldapDesc', 'Name Form Description'), ('Type', _nameFormDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35))])
    
    #-----< numericString >-----#
    numericString = CLASS(name='numericString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _numericString_val_Type = STR_NUM(name='Type', mode=MODE_TYPE)
    numericString._val = dict([('ldapDesc', 'Numeric String'), ('Type', _numericString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36))])
    
    #-----< objectClassDescription >-----#
    objectClassDescription = CLASS(name='objectClassDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _objectClassDescription_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClassDescription._val = dict([('ldapDesc', 'Object Class Description'), ('Type', _objectClassDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37))])
    
    #-----< oid >-----#
    oid = CLASS(name='oid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _oid_val_Type = OID(name='Type', mode=MODE_TYPE)
    oid._val = dict([('ldapDesc', 'OID'), ('Type', _oid_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38))])
    
    #-----< otherMailbox >-----#
    otherMailbox = CLASS(name='otherMailbox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _otherMailbox_val_Type = NULL(name='Type', mode=MODE_TYPE)
    otherMailbox._val = dict([('ldapDesc', 'Other Mailbox'), ('Type', _otherMailbox_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39))])
    
    #-----< octetString >-----#
    octetString = CLASS(name='octetString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _octetString_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    octetString._val = dict([('ldapDesc', 'Octet String'), ('Type', _octetString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40))])
    
    #-----< postalAddr >-----#
    postalAddr = CLASS(name='postalAddr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _postalAddr_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    postalAddr._val = dict([('ldapDesc', 'Postal Address'), ('Type', _postalAddr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41))])
    
    #-----< printableString >-----#
    printableString = CLASS(name='printableString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _printableString_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    printableString._val = dict([('ldapDesc', 'Printable String'), ('Type', _printableString_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44))])
    
    #-----< subtreeSpec >-----#
    subtreeSpec = CLASS(name='subtreeSpec', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _subtreeSpec_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpec._val = dict([('ldapDesc', 'SubtreeSpecification'), ('Type', _subtreeSpec_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45))])
    
    #-----< telephoneNr >-----#
    telephoneNr = CLASS(name='telephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telephoneNr_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNr._val = dict([('ldapDesc', 'Telephone Number'), ('Type', _telephoneNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50))])
    
    #-----< telexNr >-----#
    telexNr = CLASS(name='telexNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telexNr_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNr._val = dict([('ldapDesc', 'Telex Number'), ('Type', _telexNr_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52))])
    
    #-----< utcTime >-----#
    utcTime = CLASS(name='utcTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utcTime_val_Type = TIME_UTC(name='Type', mode=MODE_TYPE)
    utcTime._val = dict([('ldapDesc', 'UTC Time'), ('Type', _utcTime_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53))])
    
    #-----< ldapSyntaxDescription >-----#
    ldapSyntaxDescription = CLASS(name='ldapSyntaxDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ldapSyntaxDescription_val_Type = NULL(name='Type', mode=MODE_TYPE)
    ldapSyntaxDescription._val = dict([('ldapDesc', 'LDAP Syntax Description'), ('Type', _ldapSyntaxDescription_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54))])
    
    #-----< substringAssertion >-----#
    substringAssertion = CLASS(name='substringAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _substringAssertion_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    substringAssertion._val = dict([('ldapDesc', 'Substring Assertion'), ('Type', _substringAssertion_val_Type), ('id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58))])
    
    #-----< languageContext >-----#
    languageContext = CLASS(name='languageContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _languageContext_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LanguageContextSyntax')))
    languageContext._val = dict([('Type', _languageContext_val_Type), ('id', (2, 5, 31, 0))])
    
    #-----< LanguageContextSyntax >-----#
    LanguageContextSyntax = STR_PRINT(name='LanguageContextSyntax', mode=MODE_TYPE)
    LanguageContextSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< temporalContext >-----#
    temporalContext = CLASS(name='temporalContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _temporalContext_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    _temporalContext_val_Assertion = CHOICE(name='Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeAssertion')))
    temporalContext._val = dict([('Type', _temporalContext_val_Type), ('Assertion', _temporalContext_val_Assertion), ('id', (2, 5, 31, 1))])
    
    #-----< TimeSpecification >-----#
    TimeSpecification = SEQ(name='TimeSpecification', mode=MODE_TYPE)
    _TimeSpecification_time = CHOICE(name='time', mode=MODE_TYPE)
    __TimeSpecification_time_absolute = SEQ(name='absolute', mode=MODE_TYPE)
    ___TimeSpecification_time_absolute_startTime = TIME_GEN(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___TimeSpecification_time_absolute_endTime = TIME_GEN(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeSpecification_time_absolute._cont = ASN1Dict([
        ('startTime', ___TimeSpecification_time_absolute_startTime),
        ('endTime', ___TimeSpecification_time_absolute_endTime),
        ])
    __TimeSpecification_time_absolute._ext = []
    __TimeSpecification_time_periodic = SET_OF(name='periodic', mode=MODE_TYPE)
    ___TimeSpecification_time_periodic__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Period')))
    __TimeSpecification_time_periodic._cont = ___TimeSpecification_time_periodic__item_
    __TimeSpecification_time_periodic._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TimeSpecification_time._cont = ASN1Dict([
        ('absolute', __TimeSpecification_time_absolute),
        ('periodic', __TimeSpecification_time_periodic),
        ])
    _TimeSpecification_time._ext = None
    _TimeSpecification_notThisTime = BOOL(name='notThisTime', mode=MODE_TYPE, default=False)
    _TimeSpecification_timeZone = INT(name='timeZone', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeZone')), opt=True)
    TimeSpecification._cont = ASN1Dict([
        ('time', _TimeSpecification_time),
        ('notThisTime', _TimeSpecification_notThisTime),
        ('timeZone', _TimeSpecification_timeZone),
        ])
    TimeSpecification._ext = []
    
    #-----< Period >-----#
    Period = SEQ(name='Period', mode=MODE_TYPE)
    _Period_timesOfDay = SET_OF(name='timesOfDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_timesOfDay__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTimeBand')))
    _Period_timesOfDay._cont = __Period_timesOfDay__item_
    _Period_timesOfDay._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Period_days = CHOICE(name='days', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_days_intDay = SET_OF(name='intDay', mode=MODE_TYPE)
    ___Period_days_intDay__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_days_intDay._cont = ___Period_days_intDay__item_
    __Period_days_bitDay = BIT_STR(name='bitDay', mode=MODE_TYPE)
    __Period_days_bitDay._cont = ASN1Dict([('sunday', 0), ('monday', 1), ('tuesday', 2), ('wednesday', 3), ('thursday', 4), ('friday', 5), ('saturday', 6)])
    __Period_days_dayOf = CHOICE(name='dayOf', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'XDayOf')))
    _Period_days._cont = ASN1Dict([
        ('intDay', __Period_days_intDay),
        ('bitDay', __Period_days_bitDay),
        ('dayOf', __Period_days_dayOf),
        ])
    _Period_days._ext = []
    _Period_weeks = CHOICE(name='weeks', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_weeks_allWeeks = NULL(name='allWeeks', mode=MODE_TYPE)
    __Period_weeks_intWeek = SET_OF(name='intWeek', mode=MODE_TYPE)
    ___Period_weeks_intWeek__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_weeks_intWeek._cont = ___Period_weeks_intWeek__item_
    __Period_weeks_bitWeek = BIT_STR(name='bitWeek', mode=MODE_TYPE)
    __Period_weeks_bitWeek._cont = ASN1Dict([('week1', 0), ('week2', 1), ('week3', 2), ('week4', 3), ('week5', 4)])
    _Period_weeks._cont = ASN1Dict([
        ('allWeeks', __Period_weeks_allWeeks),
        ('intWeek', __Period_weeks_intWeek),
        ('bitWeek', __Period_weeks_bitWeek),
        ])
    _Period_weeks._ext = []
    _Period_months = CHOICE(name='months', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_months_allMonths = NULL(name='allMonths', mode=MODE_TYPE)
    __Period_months_intMonth = SET_OF(name='intMonth', mode=MODE_TYPE)
    ___Period_months_intMonth__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_months_intMonth._cont = ___Period_months_intMonth__item_
    __Period_months_bitMonth = BIT_STR(name='bitMonth', mode=MODE_TYPE)
    __Period_months_bitMonth._cont = ASN1Dict([('january', 0), ('february', 1), ('march', 2), ('april', 3), ('may', 4), ('june', 5), ('july', 6), ('august', 7), ('september', 8), ('october', 9), ('november', 10), ('december', 11)])
    _Period_months._cont = ASN1Dict([
        ('allMonths', __Period_months_allMonths),
        ('intMonth', __Period_months_intMonth),
        ('bitMonth', __Period_months_bitMonth),
        ])
    _Period_months._ext = []
    _Period_years = SET_OF(name='years', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_years__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_years__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=None)], ev=None, er=[])
    _Period_years._cont = __Period_years__item_
    Period._cont = ASN1Dict([
        ('timesOfDay', _Period_timesOfDay),
        ('days', _Period_days),
        ('weeks', _Period_weeks),
        ('months', _Period_months),
        ('years', _Period_years),
        ])
    Period._ext = []
    
    #-----< XDayOf >-----#
    XDayOf = CHOICE(name='XDayOf', mode=MODE_TYPE)
    _XDayOf_first = CHOICE(name='first', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_second = CHOICE(name='second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_third = CHOICE(name='third', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fourth = CHOICE(name='fourth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fifth = CHOICE(name='fifth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    XDayOf._cont = ASN1Dict([
        ('first', _XDayOf_first),
        ('second', _XDayOf_second),
        ('third', _XDayOf_third),
        ('fourth', _XDayOf_fourth),
        ('fifth', _XDayOf_fifth),
        ])
    XDayOf._ext = None
    
    #-----< NamedDay >-----#
    NamedDay = CHOICE(name='NamedDay', mode=MODE_TYPE)
    _NamedDay_intNamedDays = ENUM(name='intNamedDays', mode=MODE_TYPE)
    _NamedDay_intNamedDays._cont = ASN1Dict([('sunday', 1), ('monday', 2), ('tuesday', 3), ('wednesday', 4), ('thursday', 5), ('friday', 6), ('saturday', 7)])
    _NamedDay_intNamedDays._ext = None
    _NamedDay_bitNamedDays = BIT_STR(name='bitNamedDays', mode=MODE_TYPE)
    _NamedDay_bitNamedDays._cont = ASN1Dict([('sunday', 0), ('monday', 1), ('tuesday', 2), ('wednesday', 3), ('thursday', 4), ('friday', 5), ('saturday', 6)])
    NamedDay._cont = ASN1Dict([
        ('intNamedDays', _NamedDay_intNamedDays),
        ('bitNamedDays', _NamedDay_bitNamedDays),
        ])
    NamedDay._ext = None
    
    #-----< DayTimeBand >-----#
    DayTimeBand = SEQ(name='DayTimeBand', mode=MODE_TYPE)
    _DayTimeBand_startDayTime = SEQ(name='startDayTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([('hour', 0)]))
    _DayTimeBand_endDayTime = SEQ(name='endDayTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([('hour', 23), ('minute', 59), ('second', 59)]))
    DayTimeBand._cont = ASN1Dict([
        ('startDayTime', _DayTimeBand_startDayTime),
        ('endDayTime', _DayTimeBand_endDayTime),
        ])
    DayTimeBand._ext = []
    
    #-----< DayTime >-----#
    DayTime = SEQ(name='DayTime', mode=MODE_TYPE)
    _DayTime_hour = INT(name='hour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _DayTime_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _DayTime_minute = INT(name='minute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _DayTime_second = INT(name='second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_second._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    DayTime._cont = ASN1Dict([
        ('hour', _DayTime_hour),
        ('minute', _DayTime_minute),
        ('second', _DayTime_second),
        ])
    DayTime._ext = []
    
    #-----< TimeZone >-----#
    TimeZone = INT(name='TimeZone', mode=MODE_TYPE)
    TimeZone._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=12)], ev=None, er=[])
    
    #-----< TimeAssertion >-----#
    TimeAssertion = CHOICE(name='TimeAssertion', mode=MODE_TYPE)
    _TimeAssertion_now = NULL(name='now', mode=MODE_TYPE)
    _TimeAssertion_at = TIME_GEN(name='at', mode=MODE_TYPE)
    _TimeAssertion_between = SEQ(name='between', mode=MODE_TYPE)
    __TimeAssertion_between_startTime = TIME_GEN(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TimeAssertion_between_endTime = TIME_GEN(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeAssertion_between_entirely = BOOL(name='entirely', mode=MODE_TYPE, default=False)
    _TimeAssertion_between._cont = ASN1Dict([
        ('startTime', __TimeAssertion_between_startTime),
        ('endTime', __TimeAssertion_between_endTime),
        ('entirely', __TimeAssertion_between_entirely),
        ])
    _TimeAssertion_between._ext = []
    TimeAssertion._cont = ASN1Dict([
        ('now', _TimeAssertion_now),
        ('at', _TimeAssertion_at),
        ('between', _TimeAssertion_between),
        ])
    TimeAssertion._ext = []
    
    #-----< localeContext >-----#
    localeContext = CLASS(name='localeContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _localeContext_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LocaleContextSyntax')))
    localeContext._val = dict([('Type', _localeContext_val_Type), ('id', (2, 5, 31, 2))])
    
    #-----< LocaleContextSyntax >-----#
    LocaleContextSyntax = CHOICE(name='LocaleContextSyntax', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID1 = OID(name='localeID1', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID2 = CHOICE(name='localeID2', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    LocaleContextSyntax._cont = ASN1Dict([
        ('localeID1', _LocaleContextSyntax_localeID1),
        ('localeID2', _LocaleContextSyntax_localeID2),
        ])
    LocaleContextSyntax._ext = []
    
    #-----< ldapAttributeOptionContext >-----#
    ldapAttributeOptionContext = CLASS(name='ldapAttributeOptionContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _ldapAttributeOptionContext_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    _ldapAttributeOptionContext_val_Assertion = SEQ_OF(name='Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    ldapAttributeOptionContext._val = dict([('Type', _ldapAttributeOptionContext_val_Type), ('Assertion', _ldapAttributeOptionContext_val_Assertion), ('absentMatch', False), ('id', (2, 5, 31, 5))])
    
    #-----< AttributeOptionList >-----#
    AttributeOptionList = SEQ_OF(name='AttributeOptionList', mode=MODE_TYPE)
    _AttributeOptionList__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    AttributeOptionList._cont = _AttributeOptionList__item_
    
    #-----< id-at-knowledgeInformation >-----#
    id_at_knowledgeInformation = OID(name='id-at-knowledgeInformation', mode=MODE_VALUE)
    id_at_knowledgeInformation._val = (2, 5, 4, 2)
    
    #-----< id-at-commonName >-----#
    id_at_commonName = OID(name='id-at-commonName', mode=MODE_VALUE)
    id_at_commonName._val = (2, 5, 4, 3)
    
    #-----< id-at-surname >-----#
    id_at_surname = OID(name='id-at-surname', mode=MODE_VALUE)
    id_at_surname._val = (2, 5, 4, 4)
    
    #-----< id-at-serialNumber >-----#
    id_at_serialNumber = OID(name='id-at-serialNumber', mode=MODE_VALUE)
    id_at_serialNumber._val = (2, 5, 4, 5)
    
    #-----< id-at-countryName >-----#
    id_at_countryName = OID(name='id-at-countryName', mode=MODE_VALUE)
    id_at_countryName._val = (2, 5, 4, 6)
    
    #-----< id-at-localityName >-----#
    id_at_localityName = OID(name='id-at-localityName', mode=MODE_VALUE)
    id_at_localityName._val = (2, 5, 4, 7)
    
    #-----< id-at-collectiveLocalityName >-----#
    id_at_collectiveLocalityName = OID(name='id-at-collectiveLocalityName', mode=MODE_VALUE)
    id_at_collectiveLocalityName._val = (2, 5, 4, 7, 1)
    
    #-----< id-at-stateOrProvinceName >-----#
    id_at_stateOrProvinceName = OID(name='id-at-stateOrProvinceName', mode=MODE_VALUE)
    id_at_stateOrProvinceName._val = (2, 5, 4, 8)
    
    #-----< id-at-collectiveStateOrProvinceName >-----#
    id_at_collectiveStateOrProvinceName = OID(name='id-at-collectiveStateOrProvinceName', mode=MODE_VALUE)
    id_at_collectiveStateOrProvinceName._val = (2, 5, 4, 8, 1)
    
    #-----< id-at-streetAddress >-----#
    id_at_streetAddress = OID(name='id-at-streetAddress', mode=MODE_VALUE)
    id_at_streetAddress._val = (2, 5, 4, 9)
    
    #-----< id-at-collectiveStreetAddress >-----#
    id_at_collectiveStreetAddress = OID(name='id-at-collectiveStreetAddress', mode=MODE_VALUE)
    id_at_collectiveStreetAddress._val = (2, 5, 4, 9, 1)
    
    #-----< id-at-organizationName >-----#
    id_at_organizationName = OID(name='id-at-organizationName', mode=MODE_VALUE)
    id_at_organizationName._val = (2, 5, 4, 10)
    
    #-----< id-at-collectiveOrganizationName >-----#
    id_at_collectiveOrganizationName = OID(name='id-at-collectiveOrganizationName', mode=MODE_VALUE)
    id_at_collectiveOrganizationName._val = (2, 5, 4, 10, 1)
    
    #-----< id-at-organizationalUnitName >-----#
    id_at_organizationalUnitName = OID(name='id-at-organizationalUnitName', mode=MODE_VALUE)
    id_at_organizationalUnitName._val = (2, 5, 4, 11)
    
    #-----< id-at-collectiveOrganizationalUnitName >-----#
    id_at_collectiveOrganizationalUnitName = OID(name='id-at-collectiveOrganizationalUnitName', mode=MODE_VALUE)
    id_at_collectiveOrganizationalUnitName._val = (2, 5, 4, 11, 1)
    
    #-----< id-at-title >-----#
    id_at_title = OID(name='id-at-title', mode=MODE_VALUE)
    id_at_title._val = (2, 5, 4, 12)
    
    #-----< id-at-description >-----#
    id_at_description = OID(name='id-at-description', mode=MODE_VALUE)
    id_at_description._val = (2, 5, 4, 13)
    
    #-----< id-at-searchGuide >-----#
    id_at_searchGuide = OID(name='id-at-searchGuide', mode=MODE_VALUE)
    id_at_searchGuide._val = (2, 5, 4, 14)
    
    #-----< id-at-businessCategory >-----#
    id_at_businessCategory = OID(name='id-at-businessCategory', mode=MODE_VALUE)
    id_at_businessCategory._val = (2, 5, 4, 15)
    
    #-----< id-at-postalAddress >-----#
    id_at_postalAddress = OID(name='id-at-postalAddress', mode=MODE_VALUE)
    id_at_postalAddress._val = (2, 5, 4, 16)
    
    #-----< id-at-collectivePostalAddress >-----#
    id_at_collectivePostalAddress = OID(name='id-at-collectivePostalAddress', mode=MODE_VALUE)
    id_at_collectivePostalAddress._val = (2, 5, 4, 16, 1)
    
    #-----< id-at-postalCode >-----#
    id_at_postalCode = OID(name='id-at-postalCode', mode=MODE_VALUE)
    id_at_postalCode._val = (2, 5, 4, 17)
    
    #-----< id-at-collectivePostalCode >-----#
    id_at_collectivePostalCode = OID(name='id-at-collectivePostalCode', mode=MODE_VALUE)
    id_at_collectivePostalCode._val = (2, 5, 4, 17, 1)
    
    #-----< id-at-postOfficeBox >-----#
    id_at_postOfficeBox = OID(name='id-at-postOfficeBox', mode=MODE_VALUE)
    id_at_postOfficeBox._val = (2, 5, 4, 18)
    
    #-----< id-at-collectivePostOfficeBox >-----#
    id_at_collectivePostOfficeBox = OID(name='id-at-collectivePostOfficeBox', mode=MODE_VALUE)
    id_at_collectivePostOfficeBox._val = (2, 5, 4, 18, 1)
    
    #-----< id-at-physicalDeliveryOfficeName >-----#
    id_at_physicalDeliveryOfficeName = OID(name='id-at-physicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_physicalDeliveryOfficeName._val = (2, 5, 4, 19)
    
    #-----< id-at-collectivePhysicalDeliveryOfficeName >-----#
    id_at_collectivePhysicalDeliveryOfficeName = OID(name='id-at-collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_collectivePhysicalDeliveryOfficeName._val = (2, 5, 4, 19, 1)
    
    #-----< id-at-telephoneNumber >-----#
    id_at_telephoneNumber = OID(name='id-at-telephoneNumber', mode=MODE_VALUE)
    id_at_telephoneNumber._val = (2, 5, 4, 20)
    
    #-----< id-at-collectiveTelephoneNumber >-----#
    id_at_collectiveTelephoneNumber = OID(name='id-at-collectiveTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveTelephoneNumber._val = (2, 5, 4, 20, 1)
    
    #-----< id-at-telexNumber >-----#
    id_at_telexNumber = OID(name='id-at-telexNumber', mode=MODE_VALUE)
    id_at_telexNumber._val = (2, 5, 4, 21)
    
    #-----< id-at-collectiveTelexNumber >-----#
    id_at_collectiveTelexNumber = OID(name='id-at-collectiveTelexNumber', mode=MODE_VALUE)
    id_at_collectiveTelexNumber._val = (2, 5, 4, 21, 1)
    
    #-----< id-at-facsimileTelephoneNumber >-----#
    id_at_facsimileTelephoneNumber = OID(name='id-at-facsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_facsimileTelephoneNumber._val = (2, 5, 4, 23)
    
    #-----< id-at-collectiveFacsimileTelephoneNumber >-----#
    id_at_collectiveFacsimileTelephoneNumber = OID(name='id-at-collectiveFacsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveFacsimileTelephoneNumber._val = (2, 5, 4, 23, 1)
    
    #-----< id-at-x121Address >-----#
    id_at_x121Address = OID(name='id-at-x121Address', mode=MODE_VALUE)
    id_at_x121Address._val = (2, 5, 4, 24)
    
    #-----< id-at-internationalISDNNumber >-----#
    id_at_internationalISDNNumber = OID(name='id-at-internationalISDNNumber', mode=MODE_VALUE)
    id_at_internationalISDNNumber._val = (2, 5, 4, 25)
    
    #-----< id-at-collectiveInternationalISDNNumber >-----#
    id_at_collectiveInternationalISDNNumber = OID(name='id-at-collectiveInternationalISDNNumber', mode=MODE_VALUE)
    id_at_collectiveInternationalISDNNumber._val = (2, 5, 4, 25, 1)
    
    #-----< id-at-registeredAddress >-----#
    id_at_registeredAddress = OID(name='id-at-registeredAddress', mode=MODE_VALUE)
    id_at_registeredAddress._val = (2, 5, 4, 26)
    
    #-----< id-at-destinationIndicator >-----#
    id_at_destinationIndicator = OID(name='id-at-destinationIndicator', mode=MODE_VALUE)
    id_at_destinationIndicator._val = (2, 5, 4, 27)
    
    #-----< id-at-preferredDeliveryMethod >-----#
    id_at_preferredDeliveryMethod = OID(name='id-at-preferredDeliveryMethod', mode=MODE_VALUE)
    id_at_preferredDeliveryMethod._val = (2, 5, 4, 28)
    
    #-----< id-at-presentationAddress >-----#
    id_at_presentationAddress = OID(name='id-at-presentationAddress', mode=MODE_VALUE)
    id_at_presentationAddress._val = (2, 5, 4, 29)
    
    #-----< id-at-supportedApplicationContext >-----#
    id_at_supportedApplicationContext = OID(name='id-at-supportedApplicationContext', mode=MODE_VALUE)
    id_at_supportedApplicationContext._val = (2, 5, 4, 30)
    
    #-----< id-at-member >-----#
    id_at_member = OID(name='id-at-member', mode=MODE_VALUE)
    id_at_member._val = (2, 5, 4, 31)
    
    #-----< id-at-owner >-----#
    id_at_owner = OID(name='id-at-owner', mode=MODE_VALUE)
    id_at_owner._val = (2, 5, 4, 32)
    
    #-----< id-at-roleOccupant >-----#
    id_at_roleOccupant = OID(name='id-at-roleOccupant', mode=MODE_VALUE)
    id_at_roleOccupant._val = (2, 5, 4, 33)
    
    #-----< id-at-seeAlso >-----#
    id_at_seeAlso = OID(name='id-at-seeAlso', mode=MODE_VALUE)
    id_at_seeAlso._val = (2, 5, 4, 34)
    
    #-----< id-at-name >-----#
    id_at_name = OID(name='id-at-name', mode=MODE_VALUE)
    id_at_name._val = (2, 5, 4, 41)
    
    #-----< id-at-givenName >-----#
    id_at_givenName = OID(name='id-at-givenName', mode=MODE_VALUE)
    id_at_givenName._val = (2, 5, 4, 42)
    
    #-----< id-at-initials >-----#
    id_at_initials = OID(name='id-at-initials', mode=MODE_VALUE)
    id_at_initials._val = (2, 5, 4, 43)
    
    #-----< id-at-generationQualifier >-----#
    id_at_generationQualifier = OID(name='id-at-generationQualifier', mode=MODE_VALUE)
    id_at_generationQualifier._val = (2, 5, 4, 44)
    
    #-----< id-at-uniqueIdentifier >-----#
    id_at_uniqueIdentifier = OID(name='id-at-uniqueIdentifier', mode=MODE_VALUE)
    id_at_uniqueIdentifier._val = (2, 5, 4, 45)
    
    #-----< id-at-dnQualifier >-----#
    id_at_dnQualifier = OID(name='id-at-dnQualifier', mode=MODE_VALUE)
    id_at_dnQualifier._val = (2, 5, 4, 46)
    
    #-----< id-at-enhancedSearchGuide >-----#
    id_at_enhancedSearchGuide = OID(name='id-at-enhancedSearchGuide', mode=MODE_VALUE)
    id_at_enhancedSearchGuide._val = (2, 5, 4, 47)
    
    #-----< id-at-protocolInformation >-----#
    id_at_protocolInformation = OID(name='id-at-protocolInformation', mode=MODE_VALUE)
    id_at_protocolInformation._val = (2, 5, 4, 48)
    
    #-----< id-at-distinguishedName >-----#
    id_at_distinguishedName = OID(name='id-at-distinguishedName', mode=MODE_VALUE)
    id_at_distinguishedName._val = (2, 5, 4, 49)
    
    #-----< id-at-uniqueMember >-----#
    id_at_uniqueMember = OID(name='id-at-uniqueMember', mode=MODE_VALUE)
    id_at_uniqueMember._val = (2, 5, 4, 50)
    
    #-----< id-at-houseIdentifier >-----#
    id_at_houseIdentifier = OID(name='id-at-houseIdentifier', mode=MODE_VALUE)
    id_at_houseIdentifier._val = (2, 5, 4, 51)
    
    #-----< id-at-dmdName >-----#
    id_at_dmdName = OID(name='id-at-dmdName', mode=MODE_VALUE)
    id_at_dmdName._val = (2, 5, 4, 54)
    
    #-----< id-at-pseudonym >-----#
    id_at_pseudonym = OID(name='id-at-pseudonym', mode=MODE_VALUE)
    id_at_pseudonym._val = (2, 5, 4, 65)
    
    #-----< id-at-communicationsService >-----#
    id_at_communicationsService = OID(name='id-at-communicationsService', mode=MODE_VALUE)
    id_at_communicationsService._val = (2, 5, 4, 66)
    
    #-----< id-at-communicationsNetwork >-----#
    id_at_communicationsNetwork = OID(name='id-at-communicationsNetwork', mode=MODE_VALUE)
    id_at_communicationsNetwork._val = (2, 5, 4, 67)
    
    #-----< id-at-uuidpair >-----#
    id_at_uuidpair = OID(name='id-at-uuidpair', mode=MODE_VALUE)
    id_at_uuidpair._val = (2, 5, 4, 77)
    
    #-----< id-at-tagOid >-----#
    id_at_tagOid = OID(name='id-at-tagOid', mode=MODE_VALUE)
    id_at_tagOid._val = (2, 5, 4, 78)
    
    #-----< id-at-uiiFormat >-----#
    id_at_uiiFormat = OID(name='id-at-uiiFormat', mode=MODE_VALUE)
    id_at_uiiFormat._val = (2, 5, 4, 79)
    
    #-----< id-at-uiiInUrn >-----#
    id_at_uiiInUrn = OID(name='id-at-uiiInUrn', mode=MODE_VALUE)
    id_at_uiiInUrn._val = (2, 5, 4, 80)
    
    #-----< id-at-contentUrl >-----#
    id_at_contentUrl = OID(name='id-at-contentUrl', mode=MODE_VALUE)
    id_at_contentUrl._val = (2, 5, 4, 81)
    
    #-----< id-at-uri >-----#
    id_at_uri = OID(name='id-at-uri', mode=MODE_VALUE)
    id_at_uri._val = (2, 5, 4, 83)
    
    #-----< id-at-urn >-----#
    id_at_urn = OID(name='id-at-urn', mode=MODE_VALUE)
    id_at_urn._val = (2, 5, 4, 86)
    
    #-----< id-at-url >-----#
    id_at_url = OID(name='id-at-url', mode=MODE_VALUE)
    id_at_url._val = (2, 5, 4, 87)
    
    #-----< id-at-utmCoordinates >-----#
    id_at_utmCoordinates = OID(name='id-at-utmCoordinates', mode=MODE_VALUE)
    id_at_utmCoordinates._val = (2, 5, 4, 88)
    
    #-----< id-at-urnC >-----#
    id_at_urnC = OID(name='id-at-urnC', mode=MODE_VALUE)
    id_at_urnC._val = (2, 5, 4, 89)
    
    #-----< id-at-uii >-----#
    id_at_uii = OID(name='id-at-uii', mode=MODE_VALUE)
    id_at_uii._val = (2, 5, 4, 90)
    
    #-----< id-at-epc >-----#
    id_at_epc = OID(name='id-at-epc', mode=MODE_VALUE)
    id_at_epc._val = (2, 5, 4, 91)
    
    #-----< id-at-tagAfi >-----#
    id_at_tagAfi = OID(name='id-at-tagAfi', mode=MODE_VALUE)
    id_at_tagAfi._val = (2, 5, 4, 92)
    
    #-----< id-at-epcFormat >-----#
    id_at_epcFormat = OID(name='id-at-epcFormat', mode=MODE_VALUE)
    id_at_epcFormat._val = (2, 5, 4, 93)
    
    #-----< id-at-epcInUrn >-----#
    id_at_epcInUrn = OID(name='id-at-epcInUrn', mode=MODE_VALUE)
    id_at_epcInUrn._val = (2, 5, 4, 94)
    
    #-----< id-at-ldapUrl >-----#
    id_at_ldapUrl = OID(name='id-at-ldapUrl', mode=MODE_VALUE)
    id_at_ldapUrl._val = (2, 5, 4, 95)
    
    #-----< id-at-tagLocation >-----#
    id_at_tagLocation = OID(name='id-at-tagLocation', mode=MODE_VALUE)
    id_at_tagLocation._val = (2, 5, 4, 96)
    
    #-----< id-at-organizationIdentifier >-----#
    id_at_organizationIdentifier = OID(name='id-at-organizationIdentifier', mode=MODE_VALUE)
    id_at_organizationIdentifier._val = (2, 5, 4, 97)
    
    #-----< id-asx-utmCoords >-----#
    id_asx_utmCoords = OID(name='id-asx-utmCoords', mode=MODE_VALUE)
    id_asx_utmCoords._val = (2, 5, 40, 4)
    
    #-----< id-asx-uiiForm >-----#
    id_asx_uiiForm = OID(name='id-asx-uiiForm', mode=MODE_VALUE)
    id_asx_uiiForm._val = (2, 5, 40, 5)
    
    #-----< id-asx-epcForm >-----#
    id_asx_epcForm = OID(name='id-asx-epcForm', mode=MODE_VALUE)
    id_asx_epcForm._val = (2, 5, 40, 6)
    
    #-----< id-lsx-attributeTypeDescription >-----#
    id_lsx_attributeTypeDescription = OID(name='id-lsx-attributeTypeDescription', mode=MODE_VALUE)
    id_lsx_attributeTypeDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)
    
    #-----< id-lsx-bitString >-----#
    id_lsx_bitString = OID(name='id-lsx-bitString', mode=MODE_VALUE)
    id_lsx_bitString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)
    
    #-----< id-lsx-boolean >-----#
    id_lsx_boolean = OID(name='id-lsx-boolean', mode=MODE_VALUE)
    id_lsx_boolean._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)
    
    #-----< id-lsx-countryString >-----#
    id_lsx_countryString = OID(name='id-lsx-countryString', mode=MODE_VALUE)
    id_lsx_countryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)
    
    #-----< id-lsx-dn >-----#
    id_lsx_dn = OID(name='id-lsx-dn', mode=MODE_VALUE)
    id_lsx_dn._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)
    
    #-----< id-lsx-deliveryMethod >-----#
    id_lsx_deliveryMethod = OID(name='id-lsx-deliveryMethod', mode=MODE_VALUE)
    id_lsx_deliveryMethod._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)
    
    #-----< id-lsx-directoryString >-----#
    id_lsx_directoryString = OID(name='id-lsx-directoryString', mode=MODE_VALUE)
    id_lsx_directoryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)
    
    #-----< id-lsx-dITContentRuleDescription >-----#
    id_lsx_dITContentRuleDescription = OID(name='id-lsx-dITContentRuleDescription', mode=MODE_VALUE)
    id_lsx_dITContentRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)
    
    #-----< id-lsx-dITStructureRuleDescription >-----#
    id_lsx_dITStructureRuleDescription = OID(name='id-lsx-dITStructureRuleDescription', mode=MODE_VALUE)
    id_lsx_dITStructureRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)
    
    #-----< id-lsx-enhancedGuide >-----#
    id_lsx_enhancedGuide = OID(name='id-lsx-enhancedGuide', mode=MODE_VALUE)
    id_lsx_enhancedGuide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)
    
    #-----< id-lsx-facsimileTelephoneNr >-----#
    id_lsx_facsimileTelephoneNr = OID(name='id-lsx-facsimileTelephoneNr', mode=MODE_VALUE)
    id_lsx_facsimileTelephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)
    
    #-----< id-lsx-fax >-----#
    id_lsx_fax = OID(name='id-lsx-fax', mode=MODE_VALUE)
    id_lsx_fax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23)
    
    #-----< id-lsx-generalizedTime >-----#
    id_lsx_generalizedTime = OID(name='id-lsx-generalizedTime', mode=MODE_VALUE)
    id_lsx_generalizedTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)
    
    #-----< id-lsx-guide >-----#
    id_lsx_guide = OID(name='id-lsx-guide', mode=MODE_VALUE)
    id_lsx_guide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)
    
    #-----< id-lsx-ia5String >-----#
    id_lsx_ia5String = OID(name='id-lsx-ia5String', mode=MODE_VALUE)
    id_lsx_ia5String._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)
    
    #-----< id-lsx-integer >-----#
    id_lsx_integer = OID(name='id-lsx-integer', mode=MODE_VALUE)
    id_lsx_integer._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)
    
    #-----< id-lsx-jpeg >-----#
    id_lsx_jpeg = OID(name='id-lsx-jpeg', mode=MODE_VALUE)
    id_lsx_jpeg._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28)
    
    #-----< id-lsx-matchingRuleDescription >-----#
    id_lsx_matchingRuleDescription = OID(name='id-lsx-matchingRuleDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)
    
    #-----< id-lsx-matchingRuleUseDescription >-----#
    id_lsx_matchingRuleUseDescription = OID(name='id-lsx-matchingRuleUseDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleUseDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)
    
    #-----< id-lsx-nameAndOptionalUID >-----#
    id_lsx_nameAndOptionalUID = OID(name='id-lsx-nameAndOptionalUID', mode=MODE_VALUE)
    id_lsx_nameAndOptionalUID._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)
    
    #-----< id-lsx-nameFormDescription >-----#
    id_lsx_nameFormDescription = OID(name='id-lsx-nameFormDescription', mode=MODE_VALUE)
    id_lsx_nameFormDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)
    
    #-----< id-lsx-numericString >-----#
    id_lsx_numericString = OID(name='id-lsx-numericString', mode=MODE_VALUE)
    id_lsx_numericString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)
    
    #-----< id-lsx-objectClassDescription >-----#
    id_lsx_objectClassDescription = OID(name='id-lsx-objectClassDescription', mode=MODE_VALUE)
    id_lsx_objectClassDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)
    
    #-----< id-lsx-oid >-----#
    id_lsx_oid = OID(name='id-lsx-oid', mode=MODE_VALUE)
    id_lsx_oid._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)
    
    #-----< id-lsx-otherMailbox >-----#
    id_lsx_otherMailbox = OID(name='id-lsx-otherMailbox', mode=MODE_VALUE)
    id_lsx_otherMailbox._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39)
    
    #-----< id-lsx-octetString >-----#
    id_lsx_octetString = OID(name='id-lsx-octetString', mode=MODE_VALUE)
    id_lsx_octetString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)
    
    #-----< id-lsx-postalAddr >-----#
    id_lsx_postalAddr = OID(name='id-lsx-postalAddr', mode=MODE_VALUE)
    id_lsx_postalAddr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)
    
    #-----< id-lsx-printableString >-----#
    id_lsx_printableString = OID(name='id-lsx-printableString', mode=MODE_VALUE)
    id_lsx_printableString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)
    
    #-----< id-lsx-subtreeSpec >-----#
    id_lsx_subtreeSpec = OID(name='id-lsx-subtreeSpec', mode=MODE_VALUE)
    id_lsx_subtreeSpec._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)
    
    #-----< id-lsx-telephoneNr >-----#
    id_lsx_telephoneNr = OID(name='id-lsx-telephoneNr', mode=MODE_VALUE)
    id_lsx_telephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)
    
    #-----< id-lsx-telexNr >-----#
    id_lsx_telexNr = OID(name='id-lsx-telexNr', mode=MODE_VALUE)
    id_lsx_telexNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)
    
    #-----< id-lsx-utcTime >-----#
    id_lsx_utcTime = OID(name='id-lsx-utcTime', mode=MODE_VALUE)
    id_lsx_utcTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53)
    
    #-----< id-lsx-ldapSyntaxDescription >-----#
    id_lsx_ldapSyntaxDescription = OID(name='id-lsx-ldapSyntaxDescription', mode=MODE_VALUE)
    id_lsx_ldapSyntaxDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)
    
    #-----< id-lsx-substringAssertion >-----#
    id_lsx_substringAssertion = OID(name='id-lsx-substringAssertion', mode=MODE_VALUE)
    id_lsx_substringAssertion._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)
    
    #-----< id-oidC1 >-----#
    id_oidC1 = OID(name='id-oidC1', mode=MODE_VALUE)
    id_oidC1._val = (2, 17, 1, 2, 0)
    
    #-----< id-oidC2 >-----#
    id_oidC2 = OID(name='id-oidC2', mode=MODE_VALUE)
    id_oidC2._val = (2, 17, 1, 2, 1)
    
    #-----< id-oidC >-----#
    id_oidC = OID(name='id-oidC', mode=MODE_VALUE)
    id_oidC._val = (2, 17, 1, 2, 2)
    
    #-----< id-cat-sequenceMatchType >-----#
    id_cat_sequenceMatchType = OID(name='id-cat-sequenceMatchType', mode=MODE_VALUE)
    id_cat_sequenceMatchType._val = (2, 5, 37, 1)
    
    #-----< id-cat-wordMatchType >-----#
    id_cat_wordMatchType = OID(name='id-cat-wordMatchType', mode=MODE_VALUE)
    id_cat_wordMatchType._val = (2, 5, 37, 2)
    
    #-----< id-cat-characterMatchTypes >-----#
    id_cat_characterMatchTypes = OID(name='id-cat-characterMatchTypes', mode=MODE_VALUE)
    id_cat_characterMatchTypes._val = (2, 5, 37, 3)
    
    #-----< id-cat-selectedContexts >-----#
    id_cat_selectedContexts = OID(name='id-cat-selectedContexts', mode=MODE_VALUE)
    id_cat_selectedContexts._val = (2, 5, 37, 4)
    
    #-----< id-not-dSAProblem >-----#
    id_not_dSAProblem = OID(name='id-not-dSAProblem', mode=MODE_VALUE)
    id_not_dSAProblem._val = (2, 5, 35, 0)
    
    #-----< id-not-searchServiceProblem >-----#
    id_not_searchServiceProblem = OID(name='id-not-searchServiceProblem', mode=MODE_VALUE)
    id_not_searchServiceProblem._val = (2, 5, 35, 1)
    
    #-----< id-not-serviceType >-----#
    id_not_serviceType = OID(name='id-not-serviceType', mode=MODE_VALUE)
    id_not_serviceType._val = (2, 5, 35, 2)
    
    #-----< id-not-attributeTypeList >-----#
    id_not_attributeTypeList = OID(name='id-not-attributeTypeList', mode=MODE_VALUE)
    id_not_attributeTypeList._val = (2, 5, 35, 3)
    
    #-----< id-not-matchingRuleList >-----#
    id_not_matchingRuleList = OID(name='id-not-matchingRuleList', mode=MODE_VALUE)
    id_not_matchingRuleList._val = (2, 5, 35, 4)
    
    #-----< id-not-filterItem >-----#
    id_not_filterItem = OID(name='id-not-filterItem', mode=MODE_VALUE)
    id_not_filterItem._val = (2, 5, 35, 5)
    
    #-----< id-not-attributeCombinations >-----#
    id_not_attributeCombinations = OID(name='id-not-attributeCombinations', mode=MODE_VALUE)
    id_not_attributeCombinations._val = (2, 5, 35, 6)
    
    #-----< id-not-contextTypeList >-----#
    id_not_contextTypeList = OID(name='id-not-contextTypeList', mode=MODE_VALUE)
    id_not_contextTypeList._val = (2, 5, 35, 7)
    
    #-----< id-not-contextList >-----#
    id_not_contextList = OID(name='id-not-contextList', mode=MODE_VALUE)
    id_not_contextList._val = (2, 5, 35, 8)
    
    #-----< id-not-contextCombinations >-----#
    id_not_contextCombinations = OID(name='id-not-contextCombinations', mode=MODE_VALUE)
    id_not_contextCombinations._val = (2, 5, 35, 9)
    
    #-----< id-not-hierarchySelectList >-----#
    id_not_hierarchySelectList = OID(name='id-not-hierarchySelectList', mode=MODE_VALUE)
    id_not_hierarchySelectList._val = (2, 5, 35, 10)
    
    #-----< id-not-searchControlOptionsList >-----#
    id_not_searchControlOptionsList = OID(name='id-not-searchControlOptionsList', mode=MODE_VALUE)
    id_not_searchControlOptionsList._val = (2, 5, 35, 11)
    
    #-----< id-not-serviceControlOptionsList >-----#
    id_not_serviceControlOptionsList = OID(name='id-not-serviceControlOptionsList', mode=MODE_VALUE)
    id_not_serviceControlOptionsList._val = (2, 5, 35, 12)
    
    #-----< id-not-multipleMatchingLocalities >-----#
    id_not_multipleMatchingLocalities = OID(name='id-not-multipleMatchingLocalities', mode=MODE_VALUE)
    id_not_multipleMatchingLocalities._val = (2, 5, 35, 13)
    
    #-----< id-not-proposedRelaxation >-----#
    id_not_proposedRelaxation = OID(name='id-not-proposedRelaxation', mode=MODE_VALUE)
    id_not_proposedRelaxation._val = (2, 5, 35, 14)
    
    #-----< id-not-appliedRelaxation >-----#
    id_not_appliedRelaxation = OID(name='id-not-appliedRelaxation', mode=MODE_VALUE)
    id_not_appliedRelaxation._val = (2, 5, 35, 15)
    
    #-----< id-not-pwdResponse >-----#
    id_not_pwdResponse = OID(name='id-not-pwdResponse', mode=MODE_VALUE)
    id_not_pwdResponse._val = (2, 5, 35, 16)
    
    #-----< id-not-ldapDiagnosticMsg >-----#
    id_not_ldapDiagnosticMsg = OID(name='id-not-ldapDiagnosticMsg', mode=MODE_VALUE)
    id_not_ldapDiagnosticMsg._val = (2, 5, 35, 17)
    
    #-----< id-pr-targetDsaUnavailable >-----#
    id_pr_targetDsaUnavailable = OID(name='id-pr-targetDsaUnavailable', mode=MODE_VALUE)
    id_pr_targetDsaUnavailable._val = (2, 5, 34, 1)
    
    #-----< id-pr-dataSourceUnavailable >-----#
    id_pr_dataSourceUnavailable = OID(name='id-pr-dataSourceUnavailable', mode=MODE_VALUE)
    id_pr_dataSourceUnavailable._val = (2, 5, 34, 2)
    
    #-----< id-pr-unidentifiedOperation >-----#
    id_pr_unidentifiedOperation = OID(name='id-pr-unidentifiedOperation', mode=MODE_VALUE)
    id_pr_unidentifiedOperation._val = (2, 5, 34, 3)
    
    #-----< id-pr-unavailableOperation >-----#
    id_pr_unavailableOperation = OID(name='id-pr-unavailableOperation', mode=MODE_VALUE)
    id_pr_unavailableOperation._val = (2, 5, 34, 4)
    
    #-----< id-pr-searchAttributeViolation >-----#
    id_pr_searchAttributeViolation = OID(name='id-pr-searchAttributeViolation', mode=MODE_VALUE)
    id_pr_searchAttributeViolation._val = (2, 5, 34, 5)
    
    #-----< id-pr-searchAttributeCombinationViolation >-----#
    id_pr_searchAttributeCombinationViolation = OID(name='id-pr-searchAttributeCombinationViolation', mode=MODE_VALUE)
    id_pr_searchAttributeCombinationViolation._val = (2, 5, 34, 6)
    
    #-----< id-pr-searchValueNotAllowed >-----#
    id_pr_searchValueNotAllowed = OID(name='id-pr-searchValueNotAllowed', mode=MODE_VALUE)
    id_pr_searchValueNotAllowed._val = (2, 5, 34, 7)
    
    #-----< id-pr-missingSearchAttribute >-----#
    id_pr_missingSearchAttribute = OID(name='id-pr-missingSearchAttribute', mode=MODE_VALUE)
    id_pr_missingSearchAttribute._val = (2, 5, 34, 8)
    
    #-----< id-pr-searchValueViolation >-----#
    id_pr_searchValueViolation = OID(name='id-pr-searchValueViolation', mode=MODE_VALUE)
    id_pr_searchValueViolation._val = (2, 5, 34, 9)
    
    #-----< id-pr-attributeNegationViolation >-----#
    id_pr_attributeNegationViolation = OID(name='id-pr-attributeNegationViolation', mode=MODE_VALUE)
    id_pr_attributeNegationViolation._val = (2, 5, 34, 10)
    
    #-----< id-pr-searchValueRequired >-----#
    id_pr_searchValueRequired = OID(name='id-pr-searchValueRequired', mode=MODE_VALUE)
    id_pr_searchValueRequired._val = (2, 5, 34, 11)
    
    #-----< id-pr-invalidSearchValue >-----#
    id_pr_invalidSearchValue = OID(name='id-pr-invalidSearchValue', mode=MODE_VALUE)
    id_pr_invalidSearchValue._val = (2, 5, 34, 12)
    
    #-----< id-pr-searchContextViolation >-----#
    id_pr_searchContextViolation = OID(name='id-pr-searchContextViolation', mode=MODE_VALUE)
    id_pr_searchContextViolation._val = (2, 5, 34, 13)
    
    #-----< id-pr-searchContextCombinationViolation >-----#
    id_pr_searchContextCombinationViolation = OID(name='id-pr-searchContextCombinationViolation', mode=MODE_VALUE)
    id_pr_searchContextCombinationViolation._val = (2, 5, 34, 14)
    
    #-----< id-pr-missingSearchContext >-----#
    id_pr_missingSearchContext = OID(name='id-pr-missingSearchContext', mode=MODE_VALUE)
    id_pr_missingSearchContext._val = (2, 5, 34, 15)
    
    #-----< id-pr-searchContextValueViolation >-----#
    id_pr_searchContextValueViolation = OID(name='id-pr-searchContextValueViolation', mode=MODE_VALUE)
    id_pr_searchContextValueViolation._val = (2, 5, 34, 16)
    
    #-----< id-pr-searchContextValueRequired >-----#
    id_pr_searchContextValueRequired = OID(name='id-pr-searchContextValueRequired', mode=MODE_VALUE)
    id_pr_searchContextValueRequired._val = (2, 5, 34, 17)
    
    #-----< id-pr-invalidContextSearchValue >-----#
    id_pr_invalidContextSearchValue = OID(name='id-pr-invalidContextSearchValue', mode=MODE_VALUE)
    id_pr_invalidContextSearchValue._val = (2, 5, 34, 18)
    
    #-----< id-pr-unsupportedMatchingRule >-----#
    id_pr_unsupportedMatchingRule = OID(name='id-pr-unsupportedMatchingRule', mode=MODE_VALUE)
    id_pr_unsupportedMatchingRule._val = (2, 5, 34, 19)
    
    #-----< id-pr-attributeMatchingViolation >-----#
    id_pr_attributeMatchingViolation = OID(name='id-pr-attributeMatchingViolation', mode=MODE_VALUE)
    id_pr_attributeMatchingViolation._val = (2, 5, 34, 20)
    
    #-----< id-pr-unsupportedMatchingUse >-----#
    id_pr_unsupportedMatchingUse = OID(name='id-pr-unsupportedMatchingUse', mode=MODE_VALUE)
    id_pr_unsupportedMatchingUse._val = (2, 5, 34, 21)
    
    #-----< id-pr-matchingUseViolation >-----#
    id_pr_matchingUseViolation = OID(name='id-pr-matchingUseViolation', mode=MODE_VALUE)
    id_pr_matchingUseViolation._val = (2, 5, 34, 22)
    
    #-----< id-pr-hierarchySelectForbidden >-----#
    id_pr_hierarchySelectForbidden = OID(name='id-pr-hierarchySelectForbidden', mode=MODE_VALUE)
    id_pr_hierarchySelectForbidden._val = (2, 5, 34, 23)
    
    #-----< id-pr-invalidHierarchySelect >-----#
    id_pr_invalidHierarchySelect = OID(name='id-pr-invalidHierarchySelect', mode=MODE_VALUE)
    id_pr_invalidHierarchySelect._val = (2, 5, 34, 24)
    
    #-----< id-pr-unavailableHierarchySelect >-----#
    id_pr_unavailableHierarchySelect = OID(name='id-pr-unavailableHierarchySelect', mode=MODE_VALUE)
    id_pr_unavailableHierarchySelect._val = (2, 5, 34, 25)
    
    #-----< id-pr-invalidSearchControlOptions >-----#
    id_pr_invalidSearchControlOptions = OID(name='id-pr-invalidSearchControlOptions', mode=MODE_VALUE)
    id_pr_invalidSearchControlOptions._val = (2, 5, 34, 26)
    
    #-----< id-pr-invalidServiceControlOptions >-----#
    id_pr_invalidServiceControlOptions = OID(name='id-pr-invalidServiceControlOptions', mode=MODE_VALUE)
    id_pr_invalidServiceControlOptions._val = (2, 5, 34, 27)
    
    #-----< id-pr-searchSubsetViolation >-----#
    id_pr_searchSubsetViolation = OID(name='id-pr-searchSubsetViolation', mode=MODE_VALUE)
    id_pr_searchSubsetViolation._val = (2, 5, 34, 28)
    
    #-----< id-pr-unmatchedKeyAttributes >-----#
    id_pr_unmatchedKeyAttributes = OID(name='id-pr-unmatchedKeyAttributes', mode=MODE_VALUE)
    id_pr_unmatchedKeyAttributes._val = (2, 5, 34, 29)
    
    #-----< id-pr-ambiguousKeyAttributes >-----#
    id_pr_ambiguousKeyAttributes = OID(name='id-pr-ambiguousKeyAttributes', mode=MODE_VALUE)
    id_pr_ambiguousKeyAttributes._val = (2, 5, 34, 30)
    
    #-----< id-pr-unavailableRelaxationLevel >-----#
    id_pr_unavailableRelaxationLevel = OID(name='id-pr-unavailableRelaxationLevel', mode=MODE_VALUE)
    id_pr_unavailableRelaxationLevel._val = (2, 5, 34, 31)
    
    #-----< id-pr-emptyHierarchySelection >-----#
    id_pr_emptyHierarchySelection = OID(name='id-pr-emptyHierarchySelection', mode=MODE_VALUE)
    id_pr_emptyHierarchySelection._val = (2, 5, 34, 32)
    
    #-----< id-pr-administratorImposedLimit >-----#
    id_pr_administratorImposedLimit = OID(name='id-pr-administratorImposedLimit', mode=MODE_VALUE)
    id_pr_administratorImposedLimit._val = (2, 5, 34, 33)
    
    #-----< id-pr-permanentRestriction >-----#
    id_pr_permanentRestriction = OID(name='id-pr-permanentRestriction', mode=MODE_VALUE)
    id_pr_permanentRestriction._val = (2, 5, 34, 34)
    
    #-----< id-pr-temporaryRestriction >-----#
    id_pr_temporaryRestriction = OID(name='id-pr-temporaryRestriction', mode=MODE_VALUE)
    id_pr_temporaryRestriction._val = (2, 5, 34, 35)
    
    #-----< id-pr-relaxationNotSupported >-----#
    id_pr_relaxationNotSupported = OID(name='id-pr-relaxationNotSupported', mode=MODE_VALUE)
    id_pr_relaxationNotSupported._val = (2, 5, 34, 36)
    
    #-----< id-coat-uid >-----#
    id_coat_uid = OID(name='id-coat-uid', mode=MODE_VALUE)
    id_coat_uid._val = (0, 9, 2342, 19200300, 100, 1, 1)
    
    #-----< id-coat-dc >-----#
    id_coat_dc = OID(name='id-coat-dc', mode=MODE_VALUE)
    id_coat_dc._val = (0, 9, 2342, 19200300, 100, 1, 25)
    
    #-----< id-mr-caseIgnoreMatch >-----#
    id_mr_caseIgnoreMatch = OID(name='id-mr-caseIgnoreMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreMatch._val = (2, 5, 13, 2)
    
    #-----< id-mr-caseIgnoreOrderingMatch >-----#
    id_mr_caseIgnoreOrderingMatch = OID(name='id-mr-caseIgnoreOrderingMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreOrderingMatch._val = (2, 5, 13, 3)
    
    #-----< id-mr-caseIgnoreSubstringsMatch >-----#
    id_mr_caseIgnoreSubstringsMatch = OID(name='id-mr-caseIgnoreSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreSubstringsMatch._val = (2, 5, 13, 4)
    
    #-----< id-mr-caseExactMatch >-----#
    id_mr_caseExactMatch = OID(name='id-mr-caseExactMatch', mode=MODE_VALUE)
    id_mr_caseExactMatch._val = (2, 5, 13, 5)
    
    #-----< id-mr-caseExactOrderingMatch >-----#
    id_mr_caseExactOrderingMatch = OID(name='id-mr-caseExactOrderingMatch', mode=MODE_VALUE)
    id_mr_caseExactOrderingMatch._val = (2, 5, 13, 6)
    
    #-----< id-mr-caseExactSubstringsMatch >-----#
    id_mr_caseExactSubstringsMatch = OID(name='id-mr-caseExactSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseExactSubstringsMatch._val = (2, 5, 13, 7)
    
    #-----< id-mr-numericStringMatch >-----#
    id_mr_numericStringMatch = OID(name='id-mr-numericStringMatch', mode=MODE_VALUE)
    id_mr_numericStringMatch._val = (2, 5, 13, 8)
    
    #-----< id-mr-numericStringOrderingMatch >-----#
    id_mr_numericStringOrderingMatch = OID(name='id-mr-numericStringOrderingMatch', mode=MODE_VALUE)
    id_mr_numericStringOrderingMatch._val = (2, 5, 13, 9)
    
    #-----< id-mr-numericStringSubstringsMatch >-----#
    id_mr_numericStringSubstringsMatch = OID(name='id-mr-numericStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_numericStringSubstringsMatch._val = (2, 5, 13, 10)
    
    #-----< id-mr-caseIgnoreListMatch >-----#
    id_mr_caseIgnoreListMatch = OID(name='id-mr-caseIgnoreListMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListMatch._val = (2, 5, 13, 11)
    
    #-----< id-mr-caseIgnoreListSubstringsMatch >-----#
    id_mr_caseIgnoreListSubstringsMatch = OID(name='id-mr-caseIgnoreListSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListSubstringsMatch._val = (2, 5, 13, 12)
    
    #-----< id-mr-booleanMatch >-----#
    id_mr_booleanMatch = OID(name='id-mr-booleanMatch', mode=MODE_VALUE)
    id_mr_booleanMatch._val = (2, 5, 13, 13)
    
    #-----< id-mr-integerMatch >-----#
    id_mr_integerMatch = OID(name='id-mr-integerMatch', mode=MODE_VALUE)
    id_mr_integerMatch._val = (2, 5, 13, 14)
    
    #-----< id-mr-integerOrderingMatch >-----#
    id_mr_integerOrderingMatch = OID(name='id-mr-integerOrderingMatch', mode=MODE_VALUE)
    id_mr_integerOrderingMatch._val = (2, 5, 13, 15)
    
    #-----< id-mr-bitStringMatch >-----#
    id_mr_bitStringMatch = OID(name='id-mr-bitStringMatch', mode=MODE_VALUE)
    id_mr_bitStringMatch._val = (2, 5, 13, 16)
    
    #-----< id-mr-octetStringMatch >-----#
    id_mr_octetStringMatch = OID(name='id-mr-octetStringMatch', mode=MODE_VALUE)
    id_mr_octetStringMatch._val = (2, 5, 13, 17)
    
    #-----< id-mr-octetStringOrderingMatch >-----#
    id_mr_octetStringOrderingMatch = OID(name='id-mr-octetStringOrderingMatch', mode=MODE_VALUE)
    id_mr_octetStringOrderingMatch._val = (2, 5, 13, 18)
    
    #-----< id-mr-octetStringSubstringsMatch >-----#
    id_mr_octetStringSubstringsMatch = OID(name='id-mr-octetStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_octetStringSubstringsMatch._val = (2, 5, 13, 19)
    
    #-----< id-mr-telephoneNumberMatch >-----#
    id_mr_telephoneNumberMatch = OID(name='id-mr-telephoneNumberMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberMatch._val = (2, 5, 13, 20)
    
    #-----< id-mr-telephoneNumberSubstringsMatch >-----#
    id_mr_telephoneNumberSubstringsMatch = OID(name='id-mr-telephoneNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberSubstringsMatch._val = (2, 5, 13, 21)
    
    #-----< id-mr-presentationAddressMatch >-----#
    id_mr_presentationAddressMatch = OID(name='id-mr-presentationAddressMatch', mode=MODE_VALUE)
    id_mr_presentationAddressMatch._val = (2, 5, 13, 22)
    
    #-----< id-mr-uniqueMemberMatch >-----#
    id_mr_uniqueMemberMatch = OID(name='id-mr-uniqueMemberMatch', mode=MODE_VALUE)
    id_mr_uniqueMemberMatch._val = (2, 5, 13, 23)
    
    #-----< id-mr-protocolInformationMatch >-----#
    id_mr_protocolInformationMatch = OID(name='id-mr-protocolInformationMatch', mode=MODE_VALUE)
    id_mr_protocolInformationMatch._val = (2, 5, 13, 24)
    
    #-----< id-mr-uTCTimeMatch >-----#
    id_mr_uTCTimeMatch = OID(name='id-mr-uTCTimeMatch', mode=MODE_VALUE)
    id_mr_uTCTimeMatch._val = (2, 5, 13, 25)
    
    #-----< id-mr-uTCTimeOrderingMatch >-----#
    id_mr_uTCTimeOrderingMatch = OID(name='id-mr-uTCTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_uTCTimeOrderingMatch._val = (2, 5, 13, 26)
    
    #-----< id-mr-generalizedTimeMatch >-----#
    id_mr_generalizedTimeMatch = OID(name='id-mr-generalizedTimeMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeMatch._val = (2, 5, 13, 27)
    
    #-----< id-mr-generalizedTimeOrderingMatch >-----#
    id_mr_generalizedTimeOrderingMatch = OID(name='id-mr-generalizedTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeOrderingMatch._val = (2, 5, 13, 28)
    
    #-----< id-mr-integerFirstComponentMatch >-----#
    id_mr_integerFirstComponentMatch = OID(name='id-mr-integerFirstComponentMatch', mode=MODE_VALUE)
    id_mr_integerFirstComponentMatch._val = (2, 5, 13, 29)
    
    #-----< id-mr-objectIdentifierFirstComponentMatch >-----#
    id_mr_objectIdentifierFirstComponentMatch = OID(name='id-mr-objectIdentifierFirstComponentMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierFirstComponentMatch._val = (2, 5, 13, 30)
    
    #-----< id-mr-directoryStringFirstComponentMatch >-----#
    id_mr_directoryStringFirstComponentMatch = OID(name='id-mr-directoryStringFirstComponentMatch', mode=MODE_VALUE)
    id_mr_directoryStringFirstComponentMatch._val = (2, 5, 13, 31)
    
    #-----< id-mr-wordMatch >-----#
    id_mr_wordMatch = OID(name='id-mr-wordMatch', mode=MODE_VALUE)
    id_mr_wordMatch._val = (2, 5, 13, 32)
    
    #-----< id-mr-keywordMatch >-----#
    id_mr_keywordMatch = OID(name='id-mr-keywordMatch', mode=MODE_VALUE)
    id_mr_keywordMatch._val = (2, 5, 13, 33)
    
    #-----< id-mr-storedPrefixMatch >-----#
    id_mr_storedPrefixMatch = OID(name='id-mr-storedPrefixMatch', mode=MODE_VALUE)
    id_mr_storedPrefixMatch._val = (2, 5, 13, 41)
    
    #-----< id-mr-systemProposedMatch >-----#
    id_mr_systemProposedMatch = OID(name='id-mr-systemProposedMatch', mode=MODE_VALUE)
    id_mr_systemProposedMatch._val = (2, 5, 13, 47)
    
    #-----< id-mr-generalWordMatch >-----#
    id_mr_generalWordMatch = OID(name='id-mr-generalWordMatch', mode=MODE_VALUE)
    id_mr_generalWordMatch._val = (2, 5, 13, 48)
    
    #-----< id-mr-approximateStringMatch >-----#
    id_mr_approximateStringMatch = OID(name='id-mr-approximateStringMatch', mode=MODE_VALUE)
    id_mr_approximateStringMatch._val = (2, 5, 13, 49)
    
    #-----< id-mr-ignoreIfAbsentMatch >-----#
    id_mr_ignoreIfAbsentMatch = OID(name='id-mr-ignoreIfAbsentMatch', mode=MODE_VALUE)
    id_mr_ignoreIfAbsentMatch._val = (2, 5, 13, 50)
    
    #-----< id-mr-nullMatch >-----#
    id_mr_nullMatch = OID(name='id-mr-nullMatch', mode=MODE_VALUE)
    id_mr_nullMatch._val = (2, 5, 13, 51)
    
    #-----< id-mr-zonalMatch >-----#
    id_mr_zonalMatch = OID(name='id-mr-zonalMatch', mode=MODE_VALUE)
    id_mr_zonalMatch._val = (2, 5, 13, 52)
    
    #-----< id-mr-facsimileNumberMatch >-----#
    id_mr_facsimileNumberMatch = OID(name='id-mr-facsimileNumberMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberMatch._val = (2, 5, 13, 63)
    
    #-----< id-mr-facsimileNumberSubstringsMatch >-----#
    id_mr_facsimileNumberSubstringsMatch = OID(name='id-mr-facsimileNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberSubstringsMatch._val = (2, 5, 13, 64)
    
    #-----< id-mr-uuidpairmatch >-----#
    id_mr_uuidpairmatch = OID(name='id-mr-uuidpairmatch', mode=MODE_VALUE)
    id_mr_uuidpairmatch._val = (2, 5, 13, 68)
    
    #-----< id-mr-uriMatch >-----#
    id_mr_uriMatch = OID(name='id-mr-uriMatch', mode=MODE_VALUE)
    id_mr_uriMatch._val = (2, 5, 13, 70)
    
    #-----< id-lmr-caseExactIA5Match >-----#
    id_lmr_caseExactIA5Match = OID(name='id-lmr-caseExactIA5Match', mode=MODE_VALUE)
    id_lmr_caseExactIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1)
    
    #-----< id-lmr-caseIgnoreIA5Match >-----#
    id_lmr_caseIgnoreIA5Match = OID(name='id-lmr-caseIgnoreIA5Match', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2)
    
    #-----< id-lmr-caseIgnoreIA5SubstringsMatch >-----#
    id_lmr_caseIgnoreIA5SubstringsMatch = OID(name='id-lmr-caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5SubstringsMatch._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 3)
    
    #-----< id-avc-language >-----#
    id_avc_language = OID(name='id-avc-language', mode=MODE_VALUE)
    id_avc_language._val = (2, 5, 31, 0)
    
    #-----< id-avc-temporal >-----#
    id_avc_temporal = OID(name='id-avc-temporal', mode=MODE_VALUE)
    id_avc_temporal._val = (2, 5, 31, 1)
    
    #-----< id-avc-locale >-----#
    id_avc_locale = OID(name='id-avc-locale', mode=MODE_VALUE)
    id_avc_locale._val = (2, 5, 31, 2)
    
    #-----< id-avc-ldapAttributeOption >-----#
    id_avc_ldapAttributeOption = OID(name='id-avc-ldapAttributeOption', mode=MODE_VALUE)
    id_avc_ldapAttributeOption._val = (2, 5, 31, 5)
    
    _all_ = [
        _UnboundedDirectoryString_teletexString,
        _UnboundedDirectoryString_printableString,
        _UnboundedDirectoryString_bmpString,
        _UnboundedDirectoryString_universalString,
        _UnboundedDirectoryString_uTF8String,
        UnboundedDirectoryString,
        knowledgeInformation,
        _knowledgeInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        name,
        _name_val_Type,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        commonName,
        __ATTRIBUTE_derivation_val_Type,
        _commonName_val_Type,
        surname,
        _surname_val_Type,
        givenName,
        _givenName_val_Type,
        initials,
        _initials_val_Type,
        generationQualifier,
        _generationQualifier_val_Type,
        uniqueIdentifier,
        _uniqueIdentifier_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        UniqueIdentifier,
        dnQualifier,
        _dnQualifier_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        serialNumber,
        _serialNumber_val_Type,
        pseudonym,
        _pseudonym_val_Type,
        uUIDPair,
        _uUIDPair_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        _UUIDPair_issuerUUID,
        _UUIDPair_subjectUUID,
        UUIDPair,
        UUID,
        uri,
        _uri_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        URI,
        urn,
        __ATTRIBUTE_derivation_val_Type_0,
        url,
        countryName,
        _countryName_val_Type,
        CountryName,
        localityName,
        _localityName_val_Type,
        collectiveLocalityName,
        stateOrProvinceName,
        _stateOrProvinceName_val_Type,
        collectiveStateOrProvinceName,
        streetAddress,
        _streetAddress_val_Type,
        collectiveStreetAddress,
        houseIdentifier,
        _houseIdentifier_val_Type,
        utmCoordinates,
        _utmCoordinates_val_Type,
        _UtmCoordinates_zone,
        _UtmCoordinates_easting,
        _UtmCoordinates_northing,
        UtmCoordinates,
        organizationName,
        _organizationName_val_Type,
        collectiveOrganizationName,
        organizationalUnitName,
        _organizationalUnitName_val_Type,
        collectiveOrganizationalUnitName,
        title,
        _title_val_Type,
        organizationIdentifier,
        _organizationIdentifier_val_Type,
        description,
        _description_val_Type,
        searchGuide,
        _searchGuide_val_Type,
        _Guide_objectClass,
        _Guide_criteria,
        Guide,
        _Criteria_type,
        __Criteria_and___item_,
        _Criteria_and_,
        __Criteria_or___item_,
        _Criteria_or_,
        _Criteria_not_,
        Criteria,
        _CriteriaItem_equality,
        _CriteriaItem_substrings,
        _CriteriaItem_greaterOrEqual,
        _CriteriaItem_lessOrEqual,
        _CriteriaItem_approximateMatch,
        CriteriaItem,
        enhancedSearchGuide,
        _enhancedSearchGuide_val_Type,
        _EnhancedGuide_objectClass,
        _EnhancedGuide_criteria,
        _EnhancedGuide_subset,
        EnhancedGuide,
        businessCategory,
        _businessCategory_val_Type,
        postalAddress,
        _postalAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        _PostalAddress__item_,
        PostalAddress,
        collectivePostalAddress,
        __ATTRIBUTE_derivation_val_Type_1,
        postalCode,
        _postalCode_val_Type,
        collectivePostalCode,
        postOfficeBox,
        _postOfficeBox_val_Type,
        collectivePostOfficeBox,
        physicalDeliveryOfficeName,
        _physicalDeliveryOfficeName_val_Type,
        collectivePhysicalDeliveryOfficeName,
        telephoneNumber,
        _telephoneNumber_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        TelephoneNumber,
        ub_telephone_number,
        collectiveTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_2,
        telexNumber,
        _telexNumber_val_Type,
        _TelexNumber_telexNumber,
        _TelexNumber_countryCode,
        _TelexNumber_answerback,
        TelexNumber,
        ub_telex_number,
        ub_country_code,
        ub_answerback,
        collectiveTelexNumber,
        __ATTRIBUTE_derivation_val_Type_3,
        facsimileTelephoneNumber,
        _facsimileTelephoneNumber_val_Type,
        _FacsimileTelephoneNumber_telephoneNumber,
        _FacsimileTelephoneNumber_parameters,
        FacsimileTelephoneNumber,
        collectiveFacsimileTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_4,
        x121Address,
        _x121Address_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_5,
        X121Address,
        ub_x121_address,
        internationalISDNNumber,
        _internationalISDNNumber_val_Type,
        InternationalISDNNumber,
        ub_international_isdn_number,
        collectiveInternationalISDNNumber,
        __ATTRIBUTE_derivation_val_Type_5,
        registeredAddress,
        _registeredAddress_val_Type,
        destinationIndicator,
        _destinationIndicator_val_Type,
        DestinationIndicator,
        communicationsService,
        _communicationsService_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_6,
        CommunicationsService,
        communicationsNetwork,
        _communicationsNetwork_val_Type,
        CommunicationsNetwork,
        preferredDeliveryMethod,
        _preferredDeliveryMethod_val_Type,
        _PreferredDeliveryMethod__item_,
        PreferredDeliveryMethod,
        presentationAddress,
        _presentationAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_7,
        _PresentationAddress_pSelector,
        _PresentationAddress_sSelector,
        _PresentationAddress_tSelector,
        __PresentationAddress_nAddresses__item_,
        _PresentationAddress_nAddresses,
        PresentationAddress,
        supportedApplicationContext,
        _supportedApplicationContext_val_Type,
        protocolInformation,
        _protocolInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_8,
        _ProtocolInformation_nAddress,
        __ProtocolInformation_profiles__item_,
        _ProtocolInformation_profiles,
        ProtocolInformation,
        distinguishedName,
        _distinguishedName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_9,
        member,
        __ATTRIBUTE_derivation_val_Type_6,
        uniqueMember,
        _uniqueMember_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_10,
        _NameAndOptionalUID_dn,
        _NameAndOptionalUID_uid,
        NameAndOptionalUID,
        owner,
        roleOccupant,
        seeAlso,
        dmdName,
        _dmdName_val_Type,
        oidC1,
        _oidC1_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType__11,
        oidC2,
        _oidC2_val_Type,
        oidC,
        _oidC_val_Type,
        urnC,
        _urnC_val_Type,
        tagOid,
        _tagOid_val_Type,
        uiiFormat,
        _uiiFormat_val_Type,
        _UiiFormat_baseObject,
        _UiiFormat_subset,
        __UiiFormat_next_length,
        __UiiFormat_next_filter,
        _UiiFormat_next,
        UiiFormat,
        _UiiFilter_item,
        __UiiFilter_and___item_,
        _UiiFilter_and_,
        __UiiFilter_or___item_,
        _UiiFilter_or_,
        _UiiFilter_not_,
        UiiFilter,
        _UiiItem_type,
        _UiiItem_length,
        UiiItem,
        uiiInUrn,
        _uiiInUrn_val_Type,
        contentUrl,
        uii,
        _uii_val_Type,
        epc,
        _epc_val_Type,
        tagAfi,
        _tagAfi_val_Type,
        epcFormat,
        _epcFormat_val_Type,
        ___EpcFormat_fields__item__bits,
        ____EpcFormat_fields__item__charField_characters,
        ____EpcFormat_fields__item__charField_maxValue,
        ___EpcFormat_fields__item__charField,
        ___EpcFormat_fields__item__result,
        __EpcFormat_fields__item_,
        _EpcFormat_fields,
        _EpcFormat_digitShift,
        _EpcFormat_checkCalc,
        _EpcFormat_urnPrefix,
        EpcFormat,
        epcInUrn,
        ldapUrl,
        tagLocation,
        __ATTRIBUTE_derivation_val_Type_7,
        dSAProblem,
        _dSAProblem_val_Type,
        searchServiceProblem,
        _searchServiceProblem_val_Type,
        serviceType,
        _serviceType_val_Type,
        attributeTypeList,
        _attributeTypeList_val_Type,
        matchingRuleList,
        _matchingRuleList_val_Type,
        filterItem,
        _filterItem_val_Type,
        attributeCombinations,
        _attributeCombinations_val_Type,
        contextTypeList,
        _contextTypeList_val_Type,
        contextList,
        _contextList_val_Type,
        contextCombinations,
        _contextCombinations_val_Type,
        hierarchySelectList,
        _hierarchySelectList_val_Type,
        searchControlOptionsList,
        _searchControlOptionsList_val_Type,
        serviceControlOptionsList,
        _serviceControlOptionsList_val_Type,
        multipleMatchingLocalities,
        _multipleMatchingLocalities_val_Type,
        _MultipleMatchingLocalities_matchingRuleUsed,
        __MultipleMatchingLocalities_attributeList__item_,
        _MultipleMatchingLocalities_attributeList,
        MultipleMatchingLocalities,
        proposedRelaxation,
        _proposedRelaxation_val_Type,
        _MRMappings__item_,
        MRMappings,
        appliedRelaxation,
        _appliedRelaxation_val_Type,
        pwdResponseValue,
        _pwdResponseValue_val_Type,
        __PwdResponse_warning_timeleft,
        __PwdResponse_warning_graceRemaining,
        _PwdResponse_warning,
        _PwdResponse_error,
        PwdResponse,
        ldapDiagnosticMsg,
        _ldapDiagnosticMsg_val_Type,
        uid,
        _uid_val_Type,
        dc,
        _dc_val_Type,
        caseExactMatch,
        _caseExactMatch_val_AssertionType,
        caseIgnoreMatch,
        _caseIgnoreMatch_val_AssertionType,
        caseExactOrderingMatch,
        _caseExactOrderingMatch_val_AssertionType,
        caseIgnoreOrderingMatch,
        _caseIgnoreOrderingMatch_val_AssertionType,
        caseExactSubstringsMatch,
        _caseExactSubstringsMatch_val_AssertionType,
        caseIgnoreSubstringsMatch,
        _caseIgnoreSubstringsMatch_val_AssertionType,
        __SubstringAssertion__item__initial,
        __SubstringAssertion__item__any,
        __SubstringAssertion__item__final,
        ____SubstringAssertion__item__control_type_tab,
        _____SubstringAssertion__item__control_type_tab_val_Type_0,
        _____SubstringAssertion__item__control_type_tab_val_Type_1,
        ___SubstringAssertion__item__control_type,
        ____SubstringAssertion__item__control_values__item_,
        ___SubstringAssertion__item__control_values,
        _____SubstringAssertion__item__control_valuesWithContext__item__value,
        ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_,
        _____SubstringAssertion__item__control_valuesWithContext__item__contextList,
        ____SubstringAssertion__item__control_valuesWithContext__item_,
        ___SubstringAssertion__item__control_valuesWithContext,
        __SubstringAssertion__item__control,
        _SubstringAssertion__item_,
        SubstringAssertion,
        numericStringMatch,
        _numericStringMatch_val_AssertionType,
        numericStringOrderingMatch,
        _numericStringOrderingMatch_val_AssertionType,
        numericStringSubstringsMatch,
        _numericStringSubstringsMatch_val_AssertionType,
        caseIgnoreListMatch,
        _caseIgnoreListMatch_val_AssertionType,
        _CaseIgnoreList__item_,
        CaseIgnoreList,
        caseIgnoreListSubstringsMatch,
        _caseIgnoreListSubstringsMatch_val_AssertionType,
        storedPrefixMatch,
        _storedPrefixMatch_val_AssertionType,
        booleanMatch,
        _booleanMatch_val_AssertionType,
        integerMatch,
        _integerMatch_val_AssertionType,
        integerOrderingMatch,
        _integerOrderingMatch_val_AssertionType,
        bitStringMatch,
        _bitStringMatch_val_AssertionType,
        octetStringMatch,
        _octetStringMatch_val_AssertionType,
        octetStringOrderingMatch,
        _octetStringOrderingMatch_val_AssertionType,
        octetStringSubstringsMatch,
        _octetStringSubstringsMatch_val_AssertionType,
        __OctetSubstringAssertion__item__initial,
        __OctetSubstringAssertion__item__any,
        __OctetSubstringAssertion__item__final,
        _OctetSubstringAssertion__item_,
        OctetSubstringAssertion,
        telephoneNumberMatch,
        _telephoneNumberMatch_val_AssertionType,
        telephoneNumberSubstringsMatch,
        _telephoneNumberSubstringsMatch_val_AssertionType,
        presentationAddressMatch,
        _presentationAddressMatch_val_AssertionType,
        uniqueMemberMatch,
        _uniqueMemberMatch_val_AssertionType,
        protocolInformationMatch,
        _protocolInformationMatch_val_AssertionType,
        facsimileNumberMatch,
        _facsimileNumberMatch_val_AssertionType,
        facsimileNumberSubstringsMatch,
        _facsimileNumberSubstringsMatch_val_AssertionType,
        uUIDPairMatch,
        _uUIDPairMatch_val_AssertionType,
        uTCTimeMatch,
        _uTCTimeMatch_val_AssertionType,
        uTCTimeOrderingMatch,
        _uTCTimeOrderingMatch_val_AssertionType,
        generalizedTimeMatch,
        _generalizedTimeMatch_val_AssertionType,
        generalizedTimeOrderingMatch,
        _generalizedTimeOrderingMatch_val_AssertionType,
        systemProposedMatch,
        integerFirstComponentMatch,
        _integerFirstComponentMatch_val_AssertionType,
        objectIdentifierFirstComponentMatch,
        _objectIdentifierFirstComponentMatch_val_AssertionType,
        directoryStringFirstComponentMatch,
        _directoryStringFirstComponentMatch_val_AssertionType,
        wordMatch,
        _wordMatch_val_AssertionType,
        keywordMatch,
        _keywordMatch_val_AssertionType,
        generalWordMatch,
        _generalWordMatch_val_AssertionType,
        sequenceMatchType,
        _sequenceMatchType_val_Type,
        SequenceMatchType,
        wordMatchTypes,
        _wordMatchTypes_val_Type,
        WordMatchTypes,
        characterMatchTypes,
        _characterMatchTypes_val_Type,
        CharacterMatchTypes,
        selectedContexts,
        _selectedContexts_val_Type,
        approximateStringMatch,
        ignoreIfAbsentMatch,
        nullMatch,
        _ZONAL_MATCHING_selectBy,
        _ZONAL_MATCHING_ApplicableTo,
        _ZONAL_MATCHING_subtypesIncluded,
        _ZONAL_MATCHING_combinable,
        _ZONAL_MATCHING_mappingResults,
        _ZONAL_MATCHING_userControl,
        _ZONAL_MATCHING_exclusive,
        _ZONAL_MATCHING_matching_rule,
        _ZONAL_MATCHING_id,
        ZONAL_MATCHING,
        _ZonalSelect__item_,
        ZonalSelect,
        ZonalResult,
        zonalMatch,
        __MATCHING_RULE_uniqueMatchIndicator_val_Type,
        uriMatch,
        _uriMatch_val_AssertionType,
        caseExactIA5Match,
        _caseExactIA5Match_val_AssertionType,
        caseIgnoreIA5Match,
        _caseIgnoreIA5Match_val_AssertionType,
        caseIgnoreIA5SubstringsMatch,
        _caseIgnoreIA5SubstringsMatch_val_AssertionType,
        utmCoords,
        _utmCoords_val_Type,
        uiiForm,
        _uiiForm_val_Type,
        epcForm,
        _epcForm_val_Type,
        attributeTypeDescription,
        _attributeTypeDescription_val_Type,
        bitString,
        _bitString_val_Type,
        boolean,
        _boolean_val_Type,
        countryString,
        _countryString_val_Type,
        dn,
        _dn_val_Type,
        deliveryMethod,
        _deliveryMethod_val_Type,
        directoryString,
        _directoryString_val_Type,
        dITContentRuleDescription,
        _dITContentRuleDescription_val_Type,
        dITStructureRuleDescription,
        _dITStructureRuleDescription_val_Type,
        enhancedGuide,
        _enhancedGuide_val_Type,
        facsimileTelephoneNr,
        _facsimileTelephoneNr_val_Type,
        fax,
        _fax_val_Type,
        generalizedTime,
        _generalizedTime_val_Type,
        guide,
        _guide_val_Type,
        ia5String,
        _ia5String_val_Type,
        integer,
        _integer_val_Type,
        jpeg,
        _jpeg_val_Type,
        matchingRuleDescription,
        _matchingRuleDescription_val_Type,
        matchingRuleUseDescription,
        _matchingRuleUseDescription_val_Type,
        nameAndOptionalUID,
        _nameAndOptionalUID_val_Type,
        nameFormDescription,
        _nameFormDescription_val_Type,
        numericString,
        _numericString_val_Type,
        objectClassDescription,
        _objectClassDescription_val_Type,
        oid,
        _oid_val_Type,
        otherMailbox,
        _otherMailbox_val_Type,
        octetString,
        _octetString_val_Type,
        postalAddr,
        _postalAddr_val_Type,
        printableString,
        _printableString_val_Type,
        subtreeSpec,
        _subtreeSpec_val_Type,
        telephoneNr,
        _telephoneNr_val_Type,
        telexNr,
        _telexNr_val_Type,
        utcTime,
        _utcTime_val_Type,
        ldapSyntaxDescription,
        _ldapSyntaxDescription_val_Type,
        substringAssertion,
        _substringAssertion_val_Type,
        languageContext,
        _languageContext_val_Type,
        LanguageContextSyntax,
        temporalContext,
        _temporalContext_val_Type,
        _temporalContext_val_Assertion,
        ___TimeSpecification_time_absolute_startTime,
        ___TimeSpecification_time_absolute_endTime,
        __TimeSpecification_time_absolute,
        ___TimeSpecification_time_periodic__item_,
        __TimeSpecification_time_periodic,
        _TimeSpecification_time,
        _TimeSpecification_notThisTime,
        _TimeSpecification_timeZone,
        TimeSpecification,
        __Period_timesOfDay__item_,
        _Period_timesOfDay,
        ___Period_days_intDay__item_,
        __Period_days_intDay,
        __Period_days_bitDay,
        __Period_days_dayOf,
        _Period_days,
        __Period_weeks_allWeeks,
        ___Period_weeks_intWeek__item_,
        __Period_weeks_intWeek,
        __Period_weeks_bitWeek,
        _Period_weeks,
        __Period_months_allMonths,
        ___Period_months_intMonth__item_,
        __Period_months_intMonth,
        __Period_months_bitMonth,
        _Period_months,
        __Period_years__item_,
        _Period_years,
        Period,
        _XDayOf_first,
        _XDayOf_second,
        _XDayOf_third,
        _XDayOf_fourth,
        _XDayOf_fifth,
        XDayOf,
        _NamedDay_intNamedDays,
        _NamedDay_bitNamedDays,
        NamedDay,
        _DayTimeBand_startDayTime,
        _DayTimeBand_endDayTime,
        DayTimeBand,
        _DayTime_hour,
        _DayTime_minute,
        _DayTime_second,
        DayTime,
        TimeZone,
        _TimeAssertion_now,
        _TimeAssertion_at,
        __TimeAssertion_between_startTime,
        __TimeAssertion_between_endTime,
        __TimeAssertion_between_entirely,
        _TimeAssertion_between,
        TimeAssertion,
        localeContext,
        _localeContext_val_Type,
        _LocaleContextSyntax_localeID1,
        _LocaleContextSyntax_localeID2,
        LocaleContextSyntax,
        ldapAttributeOptionContext,
        _ldapAttributeOptionContext_val_Type,
        _ldapAttributeOptionContext_val_Assertion,
        _AttributeOptionList__item_,
        AttributeOptionList,
        id_at_knowledgeInformation,
        id_at_commonName,
        id_at_surname,
        id_at_serialNumber,
        id_at_countryName,
        id_at_localityName,
        id_at_collectiveLocalityName,
        id_at_stateOrProvinceName,
        id_at_collectiveStateOrProvinceName,
        id_at_streetAddress,
        id_at_collectiveStreetAddress,
        id_at_organizationName,
        id_at_collectiveOrganizationName,
        id_at_organizationalUnitName,
        id_at_collectiveOrganizationalUnitName,
        id_at_title,
        id_at_description,
        id_at_searchGuide,
        id_at_businessCategory,
        id_at_postalAddress,
        id_at_collectivePostalAddress,
        id_at_postalCode,
        id_at_collectivePostalCode,
        id_at_postOfficeBox,
        id_at_collectivePostOfficeBox,
        id_at_physicalDeliveryOfficeName,
        id_at_collectivePhysicalDeliveryOfficeName,
        id_at_telephoneNumber,
        id_at_collectiveTelephoneNumber,
        id_at_telexNumber,
        id_at_collectiveTelexNumber,
        id_at_facsimileTelephoneNumber,
        id_at_collectiveFacsimileTelephoneNumber,
        id_at_x121Address,
        id_at_internationalISDNNumber,
        id_at_collectiveInternationalISDNNumber,
        id_at_registeredAddress,
        id_at_destinationIndicator,
        id_at_preferredDeliveryMethod,
        id_at_presentationAddress,
        id_at_supportedApplicationContext,
        id_at_member,
        id_at_owner,
        id_at_roleOccupant,
        id_at_seeAlso,
        id_at_name,
        id_at_givenName,
        id_at_initials,
        id_at_generationQualifier,
        id_at_uniqueIdentifier,
        id_at_dnQualifier,
        id_at_enhancedSearchGuide,
        id_at_protocolInformation,
        id_at_distinguishedName,
        id_at_uniqueMember,
        id_at_houseIdentifier,
        id_at_dmdName,
        id_at_pseudonym,
        id_at_communicationsService,
        id_at_communicationsNetwork,
        id_at_uuidpair,
        id_at_tagOid,
        id_at_uiiFormat,
        id_at_uiiInUrn,
        id_at_contentUrl,
        id_at_uri,
        id_at_urn,
        id_at_url,
        id_at_utmCoordinates,
        id_at_urnC,
        id_at_uii,
        id_at_epc,
        id_at_tagAfi,
        id_at_epcFormat,
        id_at_epcInUrn,
        id_at_ldapUrl,
        id_at_tagLocation,
        id_at_organizationIdentifier,
        id_asx_utmCoords,
        id_asx_uiiForm,
        id_asx_epcForm,
        id_lsx_attributeTypeDescription,
        id_lsx_bitString,
        id_lsx_boolean,
        id_lsx_countryString,
        id_lsx_dn,
        id_lsx_deliveryMethod,
        id_lsx_directoryString,
        id_lsx_dITContentRuleDescription,
        id_lsx_dITStructureRuleDescription,
        id_lsx_enhancedGuide,
        id_lsx_facsimileTelephoneNr,
        id_lsx_fax,
        id_lsx_generalizedTime,
        id_lsx_guide,
        id_lsx_ia5String,
        id_lsx_integer,
        id_lsx_jpeg,
        id_lsx_matchingRuleDescription,
        id_lsx_matchingRuleUseDescription,
        id_lsx_nameAndOptionalUID,
        id_lsx_nameFormDescription,
        id_lsx_numericString,
        id_lsx_objectClassDescription,
        id_lsx_oid,
        id_lsx_otherMailbox,
        id_lsx_octetString,
        id_lsx_postalAddr,
        id_lsx_printableString,
        id_lsx_subtreeSpec,
        id_lsx_telephoneNr,
        id_lsx_telexNr,
        id_lsx_utcTime,
        id_lsx_ldapSyntaxDescription,
        id_lsx_substringAssertion,
        id_oidC1,
        id_oidC2,
        id_oidC,
        id_cat_sequenceMatchType,
        id_cat_wordMatchType,
        id_cat_characterMatchTypes,
        id_cat_selectedContexts,
        id_not_dSAProblem,
        id_not_searchServiceProblem,
        id_not_serviceType,
        id_not_attributeTypeList,
        id_not_matchingRuleList,
        id_not_filterItem,
        id_not_attributeCombinations,
        id_not_contextTypeList,
        id_not_contextList,
        id_not_contextCombinations,
        id_not_hierarchySelectList,
        id_not_searchControlOptionsList,
        id_not_serviceControlOptionsList,
        id_not_multipleMatchingLocalities,
        id_not_proposedRelaxation,
        id_not_appliedRelaxation,
        id_not_pwdResponse,
        id_not_ldapDiagnosticMsg,
        id_pr_targetDsaUnavailable,
        id_pr_dataSourceUnavailable,
        id_pr_unidentifiedOperation,
        id_pr_unavailableOperation,
        id_pr_searchAttributeViolation,
        id_pr_searchAttributeCombinationViolation,
        id_pr_searchValueNotAllowed,
        id_pr_missingSearchAttribute,
        id_pr_searchValueViolation,
        id_pr_attributeNegationViolation,
        id_pr_searchValueRequired,
        id_pr_invalidSearchValue,
        id_pr_searchContextViolation,
        id_pr_searchContextCombinationViolation,
        id_pr_missingSearchContext,
        id_pr_searchContextValueViolation,
        id_pr_searchContextValueRequired,
        id_pr_invalidContextSearchValue,
        id_pr_unsupportedMatchingRule,
        id_pr_attributeMatchingViolation,
        id_pr_unsupportedMatchingUse,
        id_pr_matchingUseViolation,
        id_pr_hierarchySelectForbidden,
        id_pr_invalidHierarchySelect,
        id_pr_unavailableHierarchySelect,
        id_pr_invalidSearchControlOptions,
        id_pr_invalidServiceControlOptions,
        id_pr_searchSubsetViolation,
        id_pr_unmatchedKeyAttributes,
        id_pr_ambiguousKeyAttributes,
        id_pr_unavailableRelaxationLevel,
        id_pr_emptyHierarchySelection,
        id_pr_administratorImposedLimit,
        id_pr_permanentRestriction,
        id_pr_temporaryRestriction,
        id_pr_relaxationNotSupported,
        id_coat_uid,
        id_coat_dc,
        id_mr_caseIgnoreMatch,
        id_mr_caseIgnoreOrderingMatch,
        id_mr_caseIgnoreSubstringsMatch,
        id_mr_caseExactMatch,
        id_mr_caseExactOrderingMatch,
        id_mr_caseExactSubstringsMatch,
        id_mr_numericStringMatch,
        id_mr_numericStringOrderingMatch,
        id_mr_numericStringSubstringsMatch,
        id_mr_caseIgnoreListMatch,
        id_mr_caseIgnoreListSubstringsMatch,
        id_mr_booleanMatch,
        id_mr_integerMatch,
        id_mr_integerOrderingMatch,
        id_mr_bitStringMatch,
        id_mr_octetStringMatch,
        id_mr_octetStringOrderingMatch,
        id_mr_octetStringSubstringsMatch,
        id_mr_telephoneNumberMatch,
        id_mr_telephoneNumberSubstringsMatch,
        id_mr_presentationAddressMatch,
        id_mr_uniqueMemberMatch,
        id_mr_protocolInformationMatch,
        id_mr_uTCTimeMatch,
        id_mr_uTCTimeOrderingMatch,
        id_mr_generalizedTimeMatch,
        id_mr_generalizedTimeOrderingMatch,
        id_mr_integerFirstComponentMatch,
        id_mr_objectIdentifierFirstComponentMatch,
        id_mr_directoryStringFirstComponentMatch,
        id_mr_wordMatch,
        id_mr_keywordMatch,
        id_mr_storedPrefixMatch,
        id_mr_systemProposedMatch,
        id_mr_generalWordMatch,
        id_mr_approximateStringMatch,
        id_mr_ignoreIfAbsentMatch,
        id_mr_nullMatch,
        id_mr_zonalMatch,
        id_mr_facsimileNumberMatch,
        id_mr_facsimileNumberSubstringsMatch,
        id_mr_uuidpairmatch,
        id_mr_uriMatch,
        id_lmr_caseExactIA5Match,
        id_lmr_caseIgnoreIA5Match,
        id_lmr_caseIgnoreIA5SubstringsMatch,
        id_avc_language,
        id_avc_temporal,
        id_avc_locale,
        id_avc_ldapAttributeOption,
    ]

class ServiceAdministration:

    _name_  = 'ServiceAdministration'
    _oid_   = [2, 5, 1, 33, 7]
    
    _obj_ = [
        'SearchRule',
        'SearchRuleId',
        'AllowedSubset',
        'ImposedSubset',
        'RequestAttribute',
        'ContextProfile',
        'ContextCombination',
        'MatchingUse',
        'SupportedMatchingRestrictions',
        'AttributeCombination',
        'ResultAttribute',
        'ControlOptions',
        'EntryLimit',
        'RelaxationPolicy',
        'MRMapping',
        'Mapping',
        'MRSubstitution',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _type_ = [
        'SearchRule',
        'SearchRuleId',
        'AllowedSubset',
        'ImposedSubset',
        'RequestAttribute',
        'ContextProfile',
        'ContextCombination',
        'MatchingUse',
        'AttributeCombination',
        'ResultAttribute',
        'ControlOptions',
        'EntryLimit',
        'RelaxationPolicy',
        'MRMapping',
        'Mapping',
        'MRSubstitution',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _set_ = [
        'SupportedMatchingRestrictions',
        ]
    _val_ = [
        ]
    _class_ = [
        'SupportedMatchingRestrictions',
        'SEARCH-RULE',
        'REQUEST-ATTRIBUTE',
        'RESULT-ATTRIBUTE',
        'MATCHING-RESTRICTION',
        ]
    _param_ = [
        ]
    
    #-----< SearchRule >-----#
    SearchRule = SEQ(name='SearchRule', mode=MODE_TYPE)
    _SearchRule_id = INT(name='id', mode=MODE_TYPE)
    _SearchRule_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRule_serviceType = OID(name='serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_userClass = INT(name='userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_inputAttributeTypes = SEQ_OF(name='inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRule_inputAttributeTypes._cont = __SearchRule_inputAttributeTypes__item_
    _SearchRule_inputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _SearchRule_attributeCombination = CHOICE(name='attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=('and', []))
    _SearchRule_outputAttributeTypes = SEQ_OF(name='outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRule_outputAttributeTypes._cont = __SearchRule_outputAttributeTypes__item_
    _SearchRule_outputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_defaultControls = SEQ(name='defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_familyGrouping = ENUM(name='familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRule_familyReturn = SEQ(name='familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRule_relaxation = SEQ(name='relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRule_additionalControl = SEQ_OF(name='additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRule_additionalControl._cont = __SearchRule_additionalControl__item_
    _SearchRule_additionalControl._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRule_imposedSubset = ENUM(name='imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRule_entryLimit = SEQ(name='entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    SearchRule._cont = ASN1Dict([
        ('id', _SearchRule_id),
        ('dmdId', _SearchRule_dmdId),
        ('serviceType', _SearchRule_serviceType),
        ('userClass', _SearchRule_userClass),
        ('inputAttributeTypes', _SearchRule_inputAttributeTypes),
        ('attributeCombination', _SearchRule_attributeCombination),
        ('outputAttributeTypes', _SearchRule_outputAttributeTypes),
        ('defaultControls', _SearchRule_defaultControls),
        ('mandatoryControls', _SearchRule_mandatoryControls),
        ('searchRuleControls', _SearchRule_searchRuleControls),
        ('familyGrouping', _SearchRule_familyGrouping),
        ('familyReturn', _SearchRule_familyReturn),
        ('relaxation', _SearchRule_relaxation),
        ('additionalControl', _SearchRule_additionalControl),
        ('allowedSubset', _SearchRule_allowedSubset),
        ('imposedSubset', _SearchRule_imposedSubset),
        ('entryLimit', _SearchRule_entryLimit),
        ])
    SearchRule._ext = []
    
    #-----< SearchRuleId >-----#
    SearchRuleId = SEQ(name='SearchRuleId', mode=MODE_TYPE)
    _SearchRuleId_id = INT(name='id', mode=MODE_TYPE)
    _SearchRuleId_dmdId = OID(name='dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    SearchRuleId._cont = ASN1Dict([
        ('id', _SearchRuleId_id),
        ('dmdId', _SearchRuleId_dmdId),
        ])
    SearchRuleId._ext = None
    
    #-----< AllowedSubset >-----#
    AllowedSubset = BIT_STR(name='AllowedSubset', mode=MODE_TYPE)
    AllowedSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    
    #-----< ImposedSubset >-----#
    ImposedSubset = ENUM(name='ImposedSubset', mode=MODE_TYPE)
    ImposedSubset._cont = ASN1Dict([('baseObject', 0), ('oneLevel', 1), ('wholeSubtree', 2)])
    ImposedSubset._ext = []
    
    #-----< RequestAttribute >-----#
    RequestAttribute = SEQ(name='RequestAttribute', mode=MODE_TYPE)
    _RequestAttribute_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __RequestAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___RequestAttribute_attributeType_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name='AssertionType', mode=MODE_TYPE)
    ___RequestAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name='AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __RequestAttribute_attributeType_tab._val = ASN1Set(rv=[dict([('Type', ___RequestAttribute_attributeType_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___RequestAttribute_attributeType_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _RequestAttribute_attributeType._const_tab = __RequestAttribute_attributeType_tab
    _RequestAttribute_attributeType._const_tab_at = None
    _RequestAttribute_attributeType._const_tab_id = 'id'
    _RequestAttribute_includeSubtypes = BOOL(name='includeSubtypes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestAttribute_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __RequestAttribute_selectedValues__item_._const_tab = __RequestAttribute_attributeType_tab
    __RequestAttribute_selectedValues__item_._const_tab_at = ('..', '..', 'attributeType')
    __RequestAttribute_selectedValues__item_._const_tab_id = 'Type'
    _RequestAttribute_selectedValues._cont = __RequestAttribute_selectedValues__item_
    _RequestAttribute_selectedValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_defaultValues = SEQ_OF(name='defaultValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_defaultValues__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___RequestAttribute_defaultValues__item__entryType = OID(name='entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    ___RequestAttribute_defaultValues__item__values = SEQ_OF(name='values', mode=MODE_TYPE)
    ____RequestAttribute_defaultValues__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ____RequestAttribute_defaultValues__item__values__item_._const_tab = __RequestAttribute_attributeType_tab
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_at = ('..', '..', '..', '..', 'attributeType')
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_id = 'Type'
    ___RequestAttribute_defaultValues__item__values._cont = ____RequestAttribute_defaultValues__item__values__item_
    __RequestAttribute_defaultValues__item_._cont = ASN1Dict([
        ('entryType', ___RequestAttribute_defaultValues__item__entryType),
        ('values', ___RequestAttribute_defaultValues__item__values),
        ])
    __RequestAttribute_defaultValues__item_._ext = []
    _RequestAttribute_defaultValues._cont = __RequestAttribute_defaultValues__item_
    _RequestAttribute_defaultValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contexts = SEQ_OF(name='contexts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _RequestAttribute_contexts._cont = __RequestAttribute_contexts__item_
    _RequestAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contextCombination = CHOICE(name='contextCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), default=('and', []))
    _RequestAttribute_matchingUse = SEQ_OF(name='matchingUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_matchingUse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')))
    _RequestAttribute_matchingUse._cont = __RequestAttribute_matchingUse__item_
    _RequestAttribute_matchingUse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RequestAttribute._cont = ASN1Dict([
        ('attributeType', _RequestAttribute_attributeType),
        ('includeSubtypes', _RequestAttribute_includeSubtypes),
        ('selectedValues', _RequestAttribute_selectedValues),
        ('defaultValues', _RequestAttribute_defaultValues),
        ('contexts', _RequestAttribute_contexts),
        ('contextCombination', _RequestAttribute_contextCombination),
        ('matchingUse', _RequestAttribute_matchingUse),
        ])
    RequestAttribute._ext = []
    
    #-----< ContextProfile >-----#
    ContextProfile = SEQ(name='ContextProfile', mode=MODE_TYPE)
    _ContextProfile_contextType = OID(name='contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextProfile_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextProfile_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextProfile_contextType._const_tab = __ContextProfile_contextType_tab
    _ContextProfile_contextType._const_tab_at = None
    _ContextProfile_contextType._const_tab_id = 'id'
    _ContextProfile_contextValue = SEQ_OF(name='contextValue', mode=MODE_TYPE, opt=True)
    __ContextProfile_contextValue__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['Assertion']))
    ___ContextProfile_contextValue__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextProfile_contextValue__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextProfile_contextValue__item_._const_tab = ___ContextProfile_contextValue__item__tab
    __ContextProfile_contextValue__item_._const_tab_at = ('..', '..', 'contextType')
    __ContextProfile_contextValue__item_._const_tab_id = 'Assertion'
    _ContextProfile_contextValue._cont = __ContextProfile_contextValue__item_
    _ContextProfile_contextValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextProfile._cont = ASN1Dict([
        ('contextType', _ContextProfile_contextType),
        ('contextValue', _ContextProfile_contextValue),
        ])
    ContextProfile._ext = []
    
    #-----< ContextCombination >-----#
    ContextCombination = CHOICE(name='ContextCombination', mode=MODE_TYPE)
    _ContextCombination_context = OID(name='context', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), ['id']))
    __ContextCombination_context_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextCombination_context_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextCombination_context._const_tab = __ContextCombination_context_tab
    _ContextCombination_context._const_tab_at = None
    _ContextCombination_context._const_tab_id = 'id'
    _ContextCombination_and_ = SEQ_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_and_._cont = __ContextCombination_and___item_
    _ContextCombination_or_ = SEQ_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_or_._cont = __ContextCombination_or___item_
    _ContextCombination_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    ContextCombination._cont = ASN1Dict([
        ('context', _ContextCombination_context),
        ('and', _ContextCombination_and_),
        ('or', _ContextCombination_or_),
        ('not', _ContextCombination_not_),
        ])
    ContextCombination._ext = []
    
    #-----< MatchingUse >-----#
    MatchingUse = SEQ(name='MatchingUse', mode=MODE_TYPE)
    _MatchingUse_restrictionType = OID(name='restrictionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), ['id']))
    __MatchingUse_restrictionType_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionType._const_tab = __MatchingUse_restrictionType_tab
    _MatchingUse_restrictionType._const_tab_at = None
    _MatchingUse_restrictionType._const_tab_id = 'id'
    _MatchingUse_restrictionValue = OPEN(name='restrictionValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), ['Restriction']))
    __MatchingUse_restrictionValue_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionValue._const_tab = __MatchingUse_restrictionValue_tab
    _MatchingUse_restrictionValue._const_tab_at = ('..', 'restrictionType')
    _MatchingUse_restrictionValue._const_tab_id = 'Restriction'
    MatchingUse._cont = ASN1Dict([
        ('restrictionType', _MatchingUse_restrictionType),
        ('restrictionValue', _MatchingUse_restrictionValue),
        ])
    MatchingUse._ext = []
    
    #-----< SupportedMatchingRestrictions >-----#
    SupportedMatchingRestrictions = CLASS(name='SupportedMatchingRestrictions', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    SupportedMatchingRestrictions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeCombination >-----#
    AttributeCombination = CHOICE(name='AttributeCombination', mode=MODE_TYPE)
    _AttributeCombination_attribute = OID(name='attribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCombination_and_ = SEQ_OF(name='and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_and_._cont = __AttributeCombination_and___item_
    _AttributeCombination_or_ = SEQ_OF(name='or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_or_._cont = __AttributeCombination_or___item_
    _AttributeCombination_not_ = CHOICE(name='not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    AttributeCombination._cont = ASN1Dict([
        ('attribute', _AttributeCombination_attribute),
        ('and', _AttributeCombination_and_),
        ('or', _AttributeCombination_or_),
        ('not', _AttributeCombination_not_),
        ])
    AttributeCombination._ext = []
    
    #-----< ResultAttribute >-----#
    ResultAttribute = SEQ(name='ResultAttribute', mode=MODE_TYPE)
    _ResultAttribute_attributeType = OID(name='attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    __ResultAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___ResultAttribute_attributeType_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE)
    ___ResultAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ResultAttribute_attributeType_tab._val = ASN1Set(rv=[dict([('Type', ___ResultAttribute_attributeType_tab_val_Type_0), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectIdentifierMatch']), ('id', (2, 5, 13, 0))])), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), ('ldapName', ['objectClass']), ('id', (2, 5, 4, 0))]), dict([('Type', ___ResultAttribute_attributeType_tab_val_Type_1), ('equality-match', dict([('AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['distinguishedNameMatch']), ('id', (2, 5, 13, 1))])), ('single-valued', True), ('ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), ('ldapName', ['aliasedObjectName']), ('id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _ResultAttribute_attributeType._const_tab = __ResultAttribute_attributeType_tab
    _ResultAttribute_attributeType._const_tab_at = None
    _ResultAttribute_attributeType._const_tab_id = 'id'
    _ResultAttribute_outputValues = CHOICE(name='outputValues', mode=MODE_TYPE, opt=True)
    __ResultAttribute_outputValues_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE)
    ___ResultAttribute_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab = __ResultAttribute_attributeType_tab
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_at = ('..', '..', '..', 'attributeType')
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_id = 'Type'
    __ResultAttribute_outputValues_selectedValues._cont = ___ResultAttribute_outputValues_selectedValues__item_
    __ResultAttribute_outputValues_matchedValuesOnly = NULL(name='matchedValuesOnly', mode=MODE_TYPE)
    _ResultAttribute_outputValues._cont = ASN1Dict([
        ('selectedValues', __ResultAttribute_outputValues_selectedValues),
        ('matchedValuesOnly', __ResultAttribute_outputValues_matchedValuesOnly),
        ])
    _ResultAttribute_outputValues._ext = None
    _ResultAttribute_contexts = SEQ_OF(name='contexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ResultAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _ResultAttribute_contexts._cont = __ResultAttribute_contexts__item_
    _ResultAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ResultAttribute._cont = ASN1Dict([
        ('attributeType', _ResultAttribute_attributeType),
        ('outputValues', _ResultAttribute_outputValues),
        ('contexts', _ResultAttribute_contexts),
        ])
    ResultAttribute._ext = []
    
    #-----< ControlOptions >-----#
    ControlOptions = SEQ(name='ControlOptions', mode=MODE_TYPE)
    _ControlOptions_serviceControls = BIT_STR(name='serviceControls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ControlOptions_searchOptions = BIT_STR(name='searchOptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _ControlOptions_hierarchyOptions = BIT_STR(name='hierarchyOptions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), opt=True)
    ControlOptions._cont = ASN1Dict([
        ('serviceControls', _ControlOptions_serviceControls),
        ('searchOptions', _ControlOptions_searchOptions),
        ('hierarchyOptions', _ControlOptions_hierarchyOptions),
        ])
    ControlOptions._ext = []
    
    #-----< EntryLimit >-----#
    EntryLimit = SEQ(name='EntryLimit', mode=MODE_TYPE)
    _EntryLimit_default = INT(name='default', mode=MODE_TYPE)
    _EntryLimit_max = INT(name='max', mode=MODE_TYPE)
    EntryLimit._cont = ASN1Dict([
        ('default', _EntryLimit_default),
        ('max', _EntryLimit_max),
        ])
    EntryLimit._ext = []
    
    #-----< RelaxationPolicy >-----#
    RelaxationPolicy = SEQ(name='RelaxationPolicy', mode=MODE_TYPE)
    _RelaxationPolicy_basic = SEQ(name='basic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), default=dict([]))
    _RelaxationPolicy_tightenings = SEQ_OF(name='tightenings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_tightenings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_tightenings._cont = __RelaxationPolicy_tightenings__item_
    _RelaxationPolicy_tightenings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_relaxations = SEQ_OF(name='relaxations', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_relaxations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_relaxations._cont = __RelaxationPolicy_relaxations__item_
    _RelaxationPolicy_relaxations._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RelaxationPolicy_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    RelaxationPolicy._cont = ASN1Dict([
        ('basic', _RelaxationPolicy_basic),
        ('tightenings', _RelaxationPolicy_tightenings),
        ('relaxations', _RelaxationPolicy_relaxations),
        ('maximum', _RelaxationPolicy_maximum),
        ('minimum', _RelaxationPolicy_minimum),
        ])
    RelaxationPolicy._ext = []
    
    #-----< MRMapping >-----#
    MRMapping = SEQ(name='MRMapping', mode=MODE_TYPE)
    _MRMapping_mapping = SEQ_OF(name='mapping', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'Mapping')))
    _MRMapping_mapping._cont = __MRMapping_mapping__item_
    _MRMapping_mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MRMapping_substitution = SEQ_OF(name='substitution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_substitution__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRSubstitution')))
    _MRMapping_substitution._cont = __MRMapping_substitution__item_
    _MRMapping_substitution._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    MRMapping._cont = ASN1Dict([
        ('mapping', _MRMapping_mapping),
        ('substitution', _MRMapping_substitution),
        ])
    MRMapping._ext = []
    
    #-----< Mapping >-----#
    Mapping = SEQ(name='Mapping', mode=MODE_TYPE)
    _Mapping_mappingFunction = OID(name='mappingFunction', mode=MODE_TYPE)
    _Mapping_level = INT(name='level', mode=MODE_TYPE, default=0)
    Mapping._cont = ASN1Dict([
        ('mappingFunction', _Mapping_mappingFunction),
        ('level', _Mapping_level),
        ])
    Mapping._ext = []
    
    #-----< MRSubstitution >-----#
    MRSubstitution = SEQ(name='MRSubstitution', mode=MODE_TYPE)
    _MRSubstitution_attribute = OID(name='attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MRSubstitution_oldMatchingRule = OID(name='oldMatchingRule', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    _MRSubstitution_newMatchingRule = OID(name='newMatchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']), opt=True)
    MRSubstitution._cont = ASN1Dict([
        ('attribute', _MRSubstitution_attribute),
        ('oldMatchingRule', _MRSubstitution_oldMatchingRule),
        ('newMatchingRule', _MRSubstitution_newMatchingRule),
        ])
    MRSubstitution._ext = []
    
    #-----< SEARCH-RULE >-----#
    SEARCH_RULE = CLASS(name='SEARCH-RULE', mode=MODE_TYPE)
    _SEARCH_RULE_dmdId = OID(name='dmdId', mode=MODE_VALUE)
    _SEARCH_RULE_serviceType = OID(name='serviceType', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_userClass = INT(name='userClass', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_InputAttributeTypes = CLASS(name='InputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'REQUEST-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_combination = CHOICE(name='combination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), opt=True)
    _SEARCH_RULE_OutputAttributeTypes = CLASS(name='OutputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'RESULT-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_defaultControls = SEQ(name='defaultControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_mandatoryControls = SEQ(name='mandatoryControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_searchRuleControls = SEQ(name='searchRuleControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_familyGrouping = ENUM(name='familyGrouping', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SEARCH_RULE_familyReturn = SEQ(name='familyReturn', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SEARCH_RULE_additionalControl = OID(name='additionalControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _SEARCH_RULE_relaxation = SEQ(name='relaxation', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SEARCH_RULE_allowedSubset = BIT_STR(name='allowedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SEARCH_RULE_imposedSubset = ENUM(name='imposedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SEARCH_RULE_entryLimit = SEQ(name='entryLimit', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SEARCH_RULE_id = INT(name='id', mode=MODE_VALUE, uniq=True)
    SEARCH_RULE._cont = ASN1Dict([
        ('dmdId', _SEARCH_RULE_dmdId),
        ('serviceType', _SEARCH_RULE_serviceType),
        ('userClass', _SEARCH_RULE_userClass),
        ('InputAttributeTypes', _SEARCH_RULE_InputAttributeTypes),
        ('combination', _SEARCH_RULE_combination),
        ('OutputAttributeTypes', _SEARCH_RULE_OutputAttributeTypes),
        ('defaultControls', _SEARCH_RULE_defaultControls),
        ('mandatoryControls', _SEARCH_RULE_mandatoryControls),
        ('searchRuleControls', _SEARCH_RULE_searchRuleControls),
        ('familyGrouping', _SEARCH_RULE_familyGrouping),
        ('familyReturn', _SEARCH_RULE_familyReturn),
        ('additionalControl', _SEARCH_RULE_additionalControl),
        ('relaxation', _SEARCH_RULE_relaxation),
        ('allowedSubset', _SEARCH_RULE_allowedSubset),
        ('imposedSubset', _SEARCH_RULE_imposedSubset),
        ('entryLimit', _SEARCH_RULE_entryLimit),
        ('id', _SEARCH_RULE_id),
        ])
    
    #-----< REQUEST-ATTRIBUTE >-----#
    REQUEST_ATTRIBUTE = CLASS(name='REQUEST-ATTRIBUTE', mode=MODE_TYPE)
    _REQUEST_ATTRIBUTE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _REQUEST_ATTRIBUTE_SelectedValues = OPEN(name='SelectedValues', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']), opt=True)
    _REQUEST_ATTRIBUTE_DefaultValues = SEQ(name='DefaultValues', mode=MODE_SET, opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_entryType = OID(name='entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), ['id']), opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_values = SEQ_OF(name='values', mode=MODE_TYPE)
    ___REQUEST_ATTRIBUTE_DefaultValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __REQUEST_ATTRIBUTE_DefaultValues_values._cont = ___REQUEST_ATTRIBUTE_DefaultValues_values__item_
    _REQUEST_ATTRIBUTE_DefaultValues._cont = ASN1Dict([
        ('entryType', __REQUEST_ATTRIBUTE_DefaultValues_entryType),
        ('values', __REQUEST_ATTRIBUTE_DefaultValues_values),
        ])
    _REQUEST_ATTRIBUTE_DefaultValues._ext = None
    _REQUEST_ATTRIBUTE_contexts = SEQ_OF(name='contexts', mode=MODE_VALUE, opt=True)
    __REQUEST_ATTRIBUTE_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _REQUEST_ATTRIBUTE_contexts._cont = __REQUEST_ATTRIBUTE_contexts__item_
    _REQUEST_ATTRIBUTE_contextCombination = CHOICE(name='contextCombination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), opt=True)
    _REQUEST_ATTRIBUTE_MatchingUse = SEQ(name='MatchingUse', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')), opt=True)
    _REQUEST_ATTRIBUTE_includeSubtypes = BOOL(name='includeSubtypes', mode=MODE_VALUE, default=False)
    REQUEST_ATTRIBUTE._cont = ASN1Dict([
        ('attributeType', _REQUEST_ATTRIBUTE_attributeType),
        ('SelectedValues', _REQUEST_ATTRIBUTE_SelectedValues),
        ('DefaultValues', _REQUEST_ATTRIBUTE_DefaultValues),
        ('contexts', _REQUEST_ATTRIBUTE_contexts),
        ('contextCombination', _REQUEST_ATTRIBUTE_contextCombination),
        ('MatchingUse', _REQUEST_ATTRIBUTE_MatchingUse),
        ('includeSubtypes', _REQUEST_ATTRIBUTE_includeSubtypes),
        ])
    
    #-----< RESULT-ATTRIBUTE >-----#
    RESULT_ATTRIBUTE = CLASS(name='RESULT-ATTRIBUTE', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['id']))
    _RESULT_ATTRIBUTE_outputValues = CHOICE(name='outputValues', mode=MODE_VALUE, opt=True)
    __RESULT_ATTRIBUTE_outputValues_selectedValues = SEQ_OF(name='selectedValues', mode=MODE_TYPE)
    ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), ['Type']))
    __RESULT_ATTRIBUTE_outputValues_selectedValues._cont = ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_
    __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly = NULL(name='matchedValuesOnly', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_outputValues._cont = ASN1Dict([
        ('selectedValues', __RESULT_ATTRIBUTE_outputValues_selectedValues),
        ('matchedValuesOnly', __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly),
        ])
    _RESULT_ATTRIBUTE_outputValues._ext = None
    _RESULT_ATTRIBUTE_contexts = SEQ(name='contexts', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')), opt=True)
    RESULT_ATTRIBUTE._cont = ASN1Dict([
        ('attributeType', _RESULT_ATTRIBUTE_attributeType),
        ('outputValues', _RESULT_ATTRIBUTE_outputValues),
        ('contexts', _RESULT_ATTRIBUTE_contexts),
        ])
    
    #-----< MATCHING-RESTRICTION >-----#
    MATCHING_RESTRICTION = CLASS(name='MATCHING-RESTRICTION', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Restriction = OPEN(name='Restriction', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Rules = OID(name='Rules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), ['id']))
    _MATCHING_RESTRICTION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    MATCHING_RESTRICTION._cont = ASN1Dict([
        ('Restriction', _MATCHING_RESTRICTION_Restriction),
        ('Rules', _MATCHING_RESTRICTION_Rules),
        ('id', _MATCHING_RESTRICTION_id),
        ])
    
    _all_ = [
        _SearchRule_id,
        _SearchRule_dmdId,
        _SearchRule_serviceType,
        _SearchRule_userClass,
        __SearchRule_inputAttributeTypes__item_,
        _SearchRule_inputAttributeTypes,
        _SearchRule_attributeCombination,
        __SearchRule_outputAttributeTypes__item_,
        _SearchRule_outputAttributeTypes,
        _SearchRule_defaultControls,
        _SearchRule_mandatoryControls,
        _SearchRule_searchRuleControls,
        _SearchRule_familyGrouping,
        _SearchRule_familyReturn,
        _SearchRule_relaxation,
        __SearchRule_additionalControl__item_,
        _SearchRule_additionalControl,
        _SearchRule_allowedSubset,
        _SearchRule_imposedSubset,
        _SearchRule_entryLimit,
        SearchRule,
        _SearchRuleId_id,
        _SearchRuleId_dmdId,
        SearchRuleId,
        AllowedSubset,
        ImposedSubset,
        __RequestAttribute_attributeType_tab,
        ___RequestAttribute_attributeType_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        ___RequestAttribute_attributeType_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _RequestAttribute_attributeType,
        _RequestAttribute_includeSubtypes,
        __RequestAttribute_selectedValues__item_,
        _RequestAttribute_selectedValues,
        ___RequestAttribute_defaultValues__item__entryType,
        ____RequestAttribute_defaultValues__item__values__item_,
        ___RequestAttribute_defaultValues__item__values,
        __RequestAttribute_defaultValues__item_,
        _RequestAttribute_defaultValues,
        __RequestAttribute_contexts__item_,
        _RequestAttribute_contexts,
        _RequestAttribute_contextCombination,
        __RequestAttribute_matchingUse__item_,
        _RequestAttribute_matchingUse,
        RequestAttribute,
        __ContextProfile_contextType_tab,
        _ContextProfile_contextType,
        ___ContextProfile_contextValue__item__tab,
        __ContextProfile_contextValue__item_,
        _ContextProfile_contextValue,
        ContextProfile,
        __ContextCombination_context_tab,
        _ContextCombination_context,
        __ContextCombination_and___item_,
        _ContextCombination_and_,
        __ContextCombination_or___item_,
        _ContextCombination_or_,
        _ContextCombination_not_,
        ContextCombination,
        __MatchingUse_restrictionType_tab,
        _MatchingUse_restrictionType,
        __MatchingUse_restrictionValue_tab,
        _MatchingUse_restrictionValue,
        MatchingUse,
        SupportedMatchingRestrictions,
        _AttributeCombination_attribute,
        __AttributeCombination_and___item_,
        _AttributeCombination_and_,
        __AttributeCombination_or___item_,
        _AttributeCombination_or_,
        _AttributeCombination_not_,
        AttributeCombination,
        __ResultAttribute_attributeType_tab,
        ___ResultAttribute_attributeType_tab_val_Type_0,
        ___ResultAttribute_attributeType_tab_val_Type_1,
        _ResultAttribute_attributeType,
        ___ResultAttribute_outputValues_selectedValues__item_,
        __ResultAttribute_outputValues_selectedValues,
        __ResultAttribute_outputValues_matchedValuesOnly,
        _ResultAttribute_outputValues,
        __ResultAttribute_contexts__item_,
        _ResultAttribute_contexts,
        ResultAttribute,
        _ControlOptions_serviceControls,
        _ControlOptions_searchOptions,
        _ControlOptions_hierarchyOptions,
        ControlOptions,
        _EntryLimit_default,
        _EntryLimit_max,
        EntryLimit,
        _RelaxationPolicy_basic,
        __RelaxationPolicy_tightenings__item_,
        _RelaxationPolicy_tightenings,
        __RelaxationPolicy_relaxations__item_,
        _RelaxationPolicy_relaxations,
        _RelaxationPolicy_maximum,
        _RelaxationPolicy_minimum,
        RelaxationPolicy,
        __MRMapping_mapping__item_,
        _MRMapping_mapping,
        __MRMapping_substitution__item_,
        _MRMapping_substitution,
        MRMapping,
        _Mapping_mappingFunction,
        _Mapping_level,
        Mapping,
        _MRSubstitution_attribute,
        _MRSubstitution_oldMatchingRule,
        _MRSubstitution_newMatchingRule,
        MRSubstitution,
        _SEARCH_RULE_dmdId,
        _SEARCH_RULE_serviceType,
        _SEARCH_RULE_userClass,
        _SEARCH_RULE_InputAttributeTypes,
        _SEARCH_RULE_combination,
        _SEARCH_RULE_OutputAttributeTypes,
        _SEARCH_RULE_defaultControls,
        _SEARCH_RULE_mandatoryControls,
        _SEARCH_RULE_searchRuleControls,
        _SEARCH_RULE_familyGrouping,
        _SEARCH_RULE_familyReturn,
        _SEARCH_RULE_additionalControl,
        _SEARCH_RULE_relaxation,
        _SEARCH_RULE_allowedSubset,
        _SEARCH_RULE_imposedSubset,
        _SEARCH_RULE_entryLimit,
        _SEARCH_RULE_id,
        SEARCH_RULE,
        _REQUEST_ATTRIBUTE_attributeType,
        _REQUEST_ATTRIBUTE_SelectedValues,
        __REQUEST_ATTRIBUTE_DefaultValues_entryType,
        ___REQUEST_ATTRIBUTE_DefaultValues_values__item_,
        __REQUEST_ATTRIBUTE_DefaultValues_values,
        _REQUEST_ATTRIBUTE_DefaultValues,
        __REQUEST_ATTRIBUTE_contexts__item_,
        _REQUEST_ATTRIBUTE_contexts,
        _REQUEST_ATTRIBUTE_contextCombination,
        _REQUEST_ATTRIBUTE_MatchingUse,
        _REQUEST_ATTRIBUTE_includeSubtypes,
        REQUEST_ATTRIBUTE,
        _RESULT_ATTRIBUTE_attributeType,
        ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_,
        __RESULT_ATTRIBUTE_outputValues_selectedValues,
        __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly,
        _RESULT_ATTRIBUTE_outputValues,
        _RESULT_ATTRIBUTE_contexts,
        RESULT_ATTRIBUTE,
        _MATCHING_RESTRICTION_Restriction,
        _MATCHING_RESTRICTION_Rules,
        _MATCHING_RESTRICTION_id,
        MATCHING_RESTRICTION,
    ]

class SpkmGssTokens:

    _name_  = 'SpkmGssTokens'
    _oid_   = [1, 3, 6, 1, 5, 5, 1, 10]
    
    _obj_ = [
        'SPKM-REQ',
        'CertificationData',
        'CertificationPath',
        'REQ-TOKEN',
        'Integrity',
        'Req-contents',
        'Random-Integer',
        'Context-Data',
        'ChannelId',
        'Options',
        'Conf-Algs',
        'Intg-Algs',
        'OWF-Algs',
        'Key-Estb-Algs',
        'SPKM-REP-TI',
        'REP-TI-TOKEN',
        'Rep-ti-contents',
        'SPKM-REP-IT',
        'REP-IT-TOKEN',
        'SPKM-ERROR',
        'ERROR-TOKEN',
        'SPKM-MIC',
        'Mic-Header',
        'SeqNum',
        'SPKM-WRAP',
        'Wrap-Header',
        'Wrap-Body',
        'Conf-Alg',
        'SPKM-DEL',
        'Del-Header',
        'MechType',
        'InitialContextToken',
        'SPKMInnerContextToken',
        'AuthorizationData',
        'md5-DES-CBC',
        'sum64-DES-CBC',
        'spkm-1',
        'spkm-2',
        ]
    _type_ = [
        'SPKM-REQ',
        'CertificationData',
        'CertificationPath',
        'REQ-TOKEN',
        'Integrity',
        'Req-contents',
        'Random-Integer',
        'Context-Data',
        'ChannelId',
        'Options',
        'Conf-Algs',
        'Intg-Algs',
        'OWF-Algs',
        'Key-Estb-Algs',
        'SPKM-REP-TI',
        'REP-TI-TOKEN',
        'Rep-ti-contents',
        'SPKM-REP-IT',
        'REP-IT-TOKEN',
        'SPKM-ERROR',
        'ERROR-TOKEN',
        'SPKM-MIC',
        'Mic-Header',
        'SeqNum',
        'SPKM-WRAP',
        'Wrap-Header',
        'Wrap-Body',
        'Conf-Alg',
        'SPKM-DEL',
        'Del-Header',
        'MechType',
        'InitialContextToken',
        'SPKMInnerContextToken',
        'AuthorizationData',
        ]
    _set_ = [
        ]
    _val_ = [
        'md5-DES-CBC',
        'sum64-DES-CBC',
        'spkm-1',
        'spkm-2',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SPKM-REQ >-----#
    SPKM_REQ = SEQ(name='SPKM-REQ', mode=MODE_TYPE)
    _SPKM_REQ_requestToken = SEQ(name='requestToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REQ-TOKEN')))
    _SPKM_REQ_certif_data = SEQ(name='certif-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    _SPKM_REQ_auth_data = SEQ_OF(name='auth-data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'AuthorizationData')), opt=True)
    SPKM_REQ._cont = ASN1Dict([
        ('requestToken', _SPKM_REQ_requestToken),
        ('certif-data', _SPKM_REQ_certif_data),
        ('auth-data', _SPKM_REQ_auth_data),
        ])
    SPKM_REQ._ext = None
    
    #-----< CertificationData >-----#
    CertificationData = SEQ(name='CertificationData', mode=MODE_TYPE)
    _CertificationData_certificationPath = SEQ(name='certificationPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationPath')), opt=True)
    _CertificationData_certificateRevocationList = SEQ(name='certificateRevocationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')), opt=True)
    CertificationData._cont = ASN1Dict([
        ('certificationPath', _CertificationData_certificationPath),
        ('certificateRevocationList', _CertificationData_certificateRevocationList),
        ])
    CertificationData._ext = None
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name='CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userKeyId = OCT_STR(name='userKeyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userCertif = SEQ(name='userCertif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_verifKeyId = OCT_STR(name='verifKeyId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userVerifCertif = SEQ(name='userVerifCertif', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_theCACertificates = SEQ_OF(name='theCACertificates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    CertificationPath._cont = ASN1Dict([
        ('userKeyId', _CertificationPath_userKeyId),
        ('userCertif', _CertificationPath_userCertif),
        ('verifKeyId', _CertificationPath_verifKeyId),
        ('userVerifCertif', _CertificationPath_userVerifCertif),
        ('theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = None
    
    #-----< REQ-TOKEN >-----#
    REQ_TOKEN = SEQ(name='REQ-TOKEN', mode=MODE_TYPE)
    _REQ_TOKEN_req_contents = SEQ(name='req-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Req-contents')))
    _REQ_TOKEN_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REQ_TOKEN_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___REQ_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_algorithm._const_tab = ___REQ_TOKEN_algId_algorithm_tab
    __REQ_TOKEN_algId_algorithm._const_tab_at = None
    __REQ_TOKEN_algId_algorithm._const_tab_id = 'id'
    __REQ_TOKEN_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___REQ_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_parameters._const_tab = ___REQ_TOKEN_algId_parameters_tab
    __REQ_TOKEN_algId_parameters._const_tab_at = ('..', 'algorithm')
    __REQ_TOKEN_algId_parameters._const_tab_id = 'Type'
    _REQ_TOKEN_algId._cont = ASN1Dict([
        ('algorithm', __REQ_TOKEN_algId_algorithm),
        ('parameters', __REQ_TOKEN_algId_parameters),
        ])
    _REQ_TOKEN_algId._ext = []
    _REQ_TOKEN_req_integrity = BIT_STR(name='req-integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REQ_TOKEN._cont = ASN1Dict([
        ('req-contents', _REQ_TOKEN_req_contents),
        ('algId', _REQ_TOKEN_algId),
        ('req-integrity', _REQ_TOKEN_req_integrity),
        ])
    REQ_TOKEN._ext = None
    
    #-----< Integrity >-----#
    Integrity = BIT_STR(name='Integrity', mode=MODE_TYPE)
    
    #-----< Req-contents >-----#
    Req_contents = SEQ(name='Req-contents', mode=MODE_TYPE)
    _Req_contents_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Req_contents_tok_id._const_val = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _Req_contents_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_pvno = BIT_STR(name='pvno', mode=MODE_TYPE)
    _Req_contents_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, opt=True)
    _Req_contents_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Req_contents_src_name = CHOICE(name='src-name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Req_contents_req_data = SEQ(name='req-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Req_contents_validity = SEQ(name='validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Req_contents_key_estb_set = SEQ_OF(name='key-estb-set', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Key-Estb-Algs')))
    _Req_contents_key_estb_req = BIT_STR(name='key-estb-req', mode=MODE_TYPE, opt=True)
    _Req_contents_key_src_bind = OCT_STR(name='key-src-bind', mode=MODE_TYPE, opt=True)
    Req_contents._cont = ASN1Dict([
        ('tok-id', _Req_contents_tok_id),
        ('context-id', _Req_contents_context_id),
        ('pvno', _Req_contents_pvno),
        ('timestamp', _Req_contents_timestamp),
        ('randSrc', _Req_contents_randSrc),
        ('targ-name', _Req_contents_targ_name),
        ('src-name', _Req_contents_src_name),
        ('req-data', _Req_contents_req_data),
        ('validity', _Req_contents_validity),
        ('key-estb-set', _Req_contents_key_estb_set),
        ('key-estb-req', _Req_contents_key_estb_req),
        ('key-src-bind', _Req_contents_key_src_bind),
        ])
    Req_contents._ext = None
    
    #-----< Random-Integer >-----#
    Random_Integer = BIT_STR(name='Random-Integer', mode=MODE_TYPE)
    
    #-----< Context-Data >-----#
    Context_Data = SEQ(name='Context-Data', mode=MODE_TYPE)
    _Context_Data_channelId = OCT_STR(name='channelId', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ChannelId')), opt=True)
    _Context_Data_seq_number = INT(name='seq-number', mode=MODE_TYPE, opt=True)
    _Context_Data_options = BIT_STR(name='options', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Options')))
    _Context_Data_conf_alg = CHOICE(name='conf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Algs')))
    _Context_Data_intg_alg = SEQ_OF(name='intg-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Intg-Algs')))
    _Context_Data_owf_alg = SEQ_OF(name='owf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'OWF-Algs')))
    Context_Data._cont = ASN1Dict([
        ('channelId', _Context_Data_channelId),
        ('seq-number', _Context_Data_seq_number),
        ('options', _Context_Data_options),
        ('conf-alg', _Context_Data_conf_alg),
        ('intg-alg', _Context_Data_intg_alg),
        ('owf-alg', _Context_Data_owf_alg),
        ])
    Context_Data._ext = None
    
    #-----< ChannelId >-----#
    ChannelId = OCT_STR(name='ChannelId', mode=MODE_TYPE)
    
    #-----< Options >-----#
    Options = BIT_STR(name='Options', mode=MODE_TYPE)
    Options._cont = ASN1Dict([('delegation-state', 0), ('mutual-state', 1), ('replay-det-state', 2), ('sequence-state', 3), ('conf-avail', 4), ('integ-avail', 5), ('target-certif-data-required', 6)])
    
    #-----< Conf-Algs >-----#
    Conf_Algs = CHOICE(name='Conf-Algs', mode=MODE_TYPE)
    _Conf_Algs_algs = SEQ_OF(name='algs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Conf_Algs_algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___Conf_Algs_algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ____Conf_Algs_algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__algorithm._const_tab = ____Conf_Algs_algs__item__algorithm_tab
    ___Conf_Algs_algs__item__algorithm._const_tab_at = None
    ___Conf_Algs_algs__item__algorithm._const_tab_id = 'id'
    ___Conf_Algs_algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ____Conf_Algs_algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__parameters._const_tab = ____Conf_Algs_algs__item__parameters_tab
    ___Conf_Algs_algs__item__parameters._const_tab_at = ('..', 'algorithm')
    ___Conf_Algs_algs__item__parameters._const_tab_id = 'Type'
    __Conf_Algs_algs__item_._cont = ASN1Dict([
        ('algorithm', ___Conf_Algs_algs__item__algorithm),
        ('parameters', ___Conf_Algs_algs__item__parameters),
        ])
    __Conf_Algs_algs__item_._ext = []
    _Conf_Algs_algs._cont = __Conf_Algs_algs__item_
    _Conf_Algs_null = NULL(name='null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Algs._cont = ASN1Dict([
        ('algs', _Conf_Algs_algs),
        ('null', _Conf_Algs_null),
        ])
    Conf_Algs._ext = None
    
    #-----< Intg-Algs >-----#
    Intg_Algs = SEQ_OF(name='Intg-Algs', mode=MODE_TYPE)
    _Intg_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Intg_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Intg_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__algorithm._const_tab = ___Intg_Algs__item__algorithm_tab
    __Intg_Algs__item__algorithm._const_tab_at = None
    __Intg_Algs__item__algorithm._const_tab_id = 'id'
    __Intg_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Intg_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__parameters._const_tab = ___Intg_Algs__item__parameters_tab
    __Intg_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __Intg_Algs__item__parameters._const_tab_id = 'Type'
    _Intg_Algs__item_._cont = ASN1Dict([
        ('algorithm', __Intg_Algs__item__algorithm),
        ('parameters', __Intg_Algs__item__parameters),
        ])
    _Intg_Algs__item_._ext = []
    Intg_Algs._cont = _Intg_Algs__item_
    
    #-----< OWF-Algs >-----#
    OWF_Algs = SEQ_OF(name='OWF-Algs', mode=MODE_TYPE)
    _OWF_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __OWF_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___OWF_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__algorithm._const_tab = ___OWF_Algs__item__algorithm_tab
    __OWF_Algs__item__algorithm._const_tab_at = None
    __OWF_Algs__item__algorithm._const_tab_id = 'id'
    __OWF_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___OWF_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__parameters._const_tab = ___OWF_Algs__item__parameters_tab
    __OWF_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __OWF_Algs__item__parameters._const_tab_id = 'Type'
    _OWF_Algs__item_._cont = ASN1Dict([
        ('algorithm', __OWF_Algs__item__algorithm),
        ('parameters', __OWF_Algs__item__parameters),
        ])
    _OWF_Algs__item_._ext = []
    OWF_Algs._cont = _OWF_Algs__item_
    
    #-----< Key-Estb-Algs >-----#
    Key_Estb_Algs = SEQ_OF(name='Key-Estb-Algs', mode=MODE_TYPE)
    _Key_Estb_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Key_Estb_Algs__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Key_Estb_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__algorithm._const_tab = ___Key_Estb_Algs__item__algorithm_tab
    __Key_Estb_Algs__item__algorithm._const_tab_at = None
    __Key_Estb_Algs__item__algorithm._const_tab_id = 'id'
    __Key_Estb_Algs__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Key_Estb_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__parameters._const_tab = ___Key_Estb_Algs__item__parameters_tab
    __Key_Estb_Algs__item__parameters._const_tab_at = ('..', 'algorithm')
    __Key_Estb_Algs__item__parameters._const_tab_id = 'Type'
    _Key_Estb_Algs__item_._cont = ASN1Dict([
        ('algorithm', __Key_Estb_Algs__item__algorithm),
        ('parameters', __Key_Estb_Algs__item__parameters),
        ])
    _Key_Estb_Algs__item_._ext = []
    Key_Estb_Algs._cont = _Key_Estb_Algs__item_
    
    #-----< SPKM-REP-TI >-----#
    SPKM_REP_TI = SEQ(name='SPKM-REP-TI', mode=MODE_TYPE)
    _SPKM_REP_TI_responseToken = SEQ(name='responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-TI-TOKEN')))
    _SPKM_REP_TI_certif_data = SEQ(name='certif-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    SPKM_REP_TI._cont = ASN1Dict([
        ('responseToken', _SPKM_REP_TI_responseToken),
        ('certif-data', _SPKM_REP_TI_certif_data),
        ])
    SPKM_REP_TI._ext = None
    
    #-----< REP-TI-TOKEN >-----#
    REP_TI_TOKEN = SEQ(name='REP-TI-TOKEN', mode=MODE_TYPE)
    _REP_TI_TOKEN_rep_ti_contents = SEQ(name='rep-ti-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Rep-ti-contents')))
    _REP_TI_TOKEN_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REP_TI_TOKEN_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___REP_TI_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_algorithm._const_tab = ___REP_TI_TOKEN_algId_algorithm_tab
    __REP_TI_TOKEN_algId_algorithm._const_tab_at = None
    __REP_TI_TOKEN_algId_algorithm._const_tab_id = 'id'
    __REP_TI_TOKEN_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___REP_TI_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_parameters._const_tab = ___REP_TI_TOKEN_algId_parameters_tab
    __REP_TI_TOKEN_algId_parameters._const_tab_at = ('..', 'algorithm')
    __REP_TI_TOKEN_algId_parameters._const_tab_id = 'Type'
    _REP_TI_TOKEN_algId._cont = ASN1Dict([
        ('algorithm', __REP_TI_TOKEN_algId_algorithm),
        ('parameters', __REP_TI_TOKEN_algId_parameters),
        ])
    _REP_TI_TOKEN_algId._ext = []
    _REP_TI_TOKEN_rep_ti_integ = BIT_STR(name='rep-ti-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REP_TI_TOKEN._cont = ASN1Dict([
        ('rep-ti-contents', _REP_TI_TOKEN_rep_ti_contents),
        ('algId', _REP_TI_TOKEN_algId),
        ('rep-ti-integ', _REP_TI_TOKEN_rep_ti_integ),
        ])
    REP_TI_TOKEN._ext = None
    
    #-----< Rep-ti-contents >-----#
    Rep_ti_contents = SEQ(name='Rep-ti-contents', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id._const_val = ASN1Set(rv=[512], rr=[], ev=None, er=[])
    _Rep_ti_contents_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_pvno = BIT_STR(name='pvno', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Rep_ti_contents_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, opt=True)
    _Rep_ti_contents_randTarg = BIT_STR(name='randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_src_name = CHOICE(name='src-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Rep_ti_contents_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Rep_ti_contents_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_rep_data = SEQ(name='rep-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Rep_ti_contents_validity = SEQ(name='validity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Rep_ti_contents_key_estb_id = SEQ(name='key-estb-id', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Rep_ti_contents_key_estb_id_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Rep_ti_contents_key_estb_id_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_algorithm._const_tab = ___Rep_ti_contents_key_estb_id_algorithm_tab
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_at = None
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_id = 'id'
    __Rep_ti_contents_key_estb_id_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Rep_ti_contents_key_estb_id_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_parameters._const_tab = ___Rep_ti_contents_key_estb_id_parameters_tab
    __Rep_ti_contents_key_estb_id_parameters._const_tab_at = ('..', 'algorithm')
    __Rep_ti_contents_key_estb_id_parameters._const_tab_id = 'Type'
    _Rep_ti_contents_key_estb_id._cont = ASN1Dict([
        ('algorithm', __Rep_ti_contents_key_estb_id_algorithm),
        ('parameters', __Rep_ti_contents_key_estb_id_parameters),
        ])
    _Rep_ti_contents_key_estb_id._ext = []
    _Rep_ti_contents_key_estb_str = BIT_STR(name='key-estb-str', mode=MODE_TYPE, opt=True)
    Rep_ti_contents._cont = ASN1Dict([
        ('tok-id', _Rep_ti_contents_tok_id),
        ('context-id', _Rep_ti_contents_context_id),
        ('pvno', _Rep_ti_contents_pvno),
        ('timestamp', _Rep_ti_contents_timestamp),
        ('randTarg', _Rep_ti_contents_randTarg),
        ('src-name', _Rep_ti_contents_src_name),
        ('targ-name', _Rep_ti_contents_targ_name),
        ('randSrc', _Rep_ti_contents_randSrc),
        ('rep-data', _Rep_ti_contents_rep_data),
        ('validity', _Rep_ti_contents_validity),
        ('key-estb-id', _Rep_ti_contents_key_estb_id),
        ('key-estb-str', _Rep_ti_contents_key_estb_str),
        ])
    Rep_ti_contents._ext = None
    
    #-----< SPKM-REP-IT >-----#
    SPKM_REP_IT = SEQ(name='SPKM-REP-IT', mode=MODE_TYPE)
    _SPKM_REP_IT_responseToken = SEQ(name='responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-IT-TOKEN')))
    _SPKM_REP_IT_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_REP_IT_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SPKM_REP_IT_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_algorithm._const_tab = ___SPKM_REP_IT_algId_algorithm_tab
    __SPKM_REP_IT_algId_algorithm._const_tab_at = None
    __SPKM_REP_IT_algId_algorithm._const_tab_id = 'id'
    __SPKM_REP_IT_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SPKM_REP_IT_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_parameters._const_tab = ___SPKM_REP_IT_algId_parameters_tab
    __SPKM_REP_IT_algId_parameters._const_tab_at = ('..', 'algorithm')
    __SPKM_REP_IT_algId_parameters._const_tab_id = 'Type'
    _SPKM_REP_IT_algId._cont = ASN1Dict([
        ('algorithm', __SPKM_REP_IT_algId_algorithm),
        ('parameters', __SPKM_REP_IT_algId_parameters),
        ])
    _SPKM_REP_IT_algId._ext = []
    _SPKM_REP_IT_rep_it_integ = BIT_STR(name='rep-it-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_REP_IT._cont = ASN1Dict([
        ('responseToken', _SPKM_REP_IT_responseToken),
        ('algId', _SPKM_REP_IT_algId),
        ('rep-it-integ', _SPKM_REP_IT_rep_it_integ),
        ])
    SPKM_REP_IT._ext = None
    
    #-----< REP-IT-TOKEN >-----#
    REP_IT_TOKEN = SEQ(name='REP-IT-TOKEN', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id._const_val = ASN1Set(rv=[768], rr=[], ev=None, er=[])
    _REP_IT_TOKEN_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randSrc = BIT_STR(name='randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randTarg = BIT_STR(name='randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_targ_name = CHOICE(name='targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _REP_IT_TOKEN_src_name = CHOICE(name='src-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _REP_IT_TOKEN_key_estb_rep = BIT_STR(name='key-estb-rep', mode=MODE_TYPE, opt=True)
    REP_IT_TOKEN._cont = ASN1Dict([
        ('tok-id', _REP_IT_TOKEN_tok_id),
        ('context-id', _REP_IT_TOKEN_context_id),
        ('randSrc', _REP_IT_TOKEN_randSrc),
        ('randTarg', _REP_IT_TOKEN_randTarg),
        ('targ-name', _REP_IT_TOKEN_targ_name),
        ('src-name', _REP_IT_TOKEN_src_name),
        ('key-estb-rep', _REP_IT_TOKEN_key_estb_rep),
        ])
    REP_IT_TOKEN._ext = None
    
    #-----< SPKM-ERROR >-----#
    SPKM_ERROR = SEQ(name='SPKM-ERROR', mode=MODE_TYPE)
    _SPKM_ERROR_errorToken = SEQ(name='errorToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ERROR-TOKEN')))
    _SPKM_ERROR_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_ERROR_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___SPKM_ERROR_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_algorithm._const_tab = ___SPKM_ERROR_algId_algorithm_tab
    __SPKM_ERROR_algId_algorithm._const_tab_at = None
    __SPKM_ERROR_algId_algorithm._const_tab_id = 'id'
    __SPKM_ERROR_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___SPKM_ERROR_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_parameters._const_tab = ___SPKM_ERROR_algId_parameters_tab
    __SPKM_ERROR_algId_parameters._const_tab_at = ('..', 'algorithm')
    __SPKM_ERROR_algId_parameters._const_tab_id = 'Type'
    _SPKM_ERROR_algId._cont = ASN1Dict([
        ('algorithm', __SPKM_ERROR_algId_algorithm),
        ('parameters', __SPKM_ERROR_algId_parameters),
        ])
    _SPKM_ERROR_algId._ext = []
    _SPKM_ERROR_integrity = BIT_STR(name='integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_ERROR._cont = ASN1Dict([
        ('errorToken', _SPKM_ERROR_errorToken),
        ('algId', _SPKM_ERROR_algId),
        ('integrity', _SPKM_ERROR_integrity),
        ])
    SPKM_ERROR._ext = None
    
    #-----< ERROR-TOKEN >-----#
    ERROR_TOKEN = SEQ(name='ERROR-TOKEN', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id._const_val = ASN1Set(rv=[1024], rr=[], ev=None, er=[])
    _ERROR_TOKEN_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    ERROR_TOKEN._cont = ASN1Dict([
        ('tok-id', _ERROR_TOKEN_tok_id),
        ('context-id', _ERROR_TOKEN_context_id),
        ])
    ERROR_TOKEN._ext = None
    
    #-----< SPKM-MIC >-----#
    SPKM_MIC = SEQ(name='SPKM-MIC', mode=MODE_TYPE)
    _SPKM_MIC_mic_header = SEQ(name='mic-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Mic-Header')))
    _SPKM_MIC_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    SPKM_MIC._cont = ASN1Dict([
        ('mic-header', _SPKM_MIC_mic_header),
        ('int-cksum', _SPKM_MIC_int_cksum),
        ])
    SPKM_MIC._ext = None
    
    #-----< Mic-Header >-----#
    Mic_Header = SEQ(name='Mic-Header', mode=MODE_TYPE)
    _Mic_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Mic_Header_tok_id._const_val = ASN1Set(rv=[257], rr=[], ev=None, er=[])
    _Mic_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Mic_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Mic_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Mic_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_algorithm._const_tab = ___Mic_Header_int_alg_algorithm_tab
    __Mic_Header_int_alg_algorithm._const_tab_at = None
    __Mic_Header_int_alg_algorithm._const_tab_id = 'id'
    __Mic_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Mic_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_parameters._const_tab = ___Mic_Header_int_alg_parameters_tab
    __Mic_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Mic_Header_int_alg_parameters._const_tab_id = 'Type'
    _Mic_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Mic_Header_int_alg_algorithm),
        ('parameters', __Mic_Header_int_alg_parameters),
        ])
    _Mic_Header_int_alg._ext = []
    _Mic_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Mic_Header._cont = ASN1Dict([
        ('tok-id', _Mic_Header_tok_id),
        ('context-id', _Mic_Header_context_id),
        ('int-alg', _Mic_Header_int_alg),
        ('snd-seq', _Mic_Header_snd_seq),
        ])
    Mic_Header._ext = None
    
    #-----< SeqNum >-----#
    SeqNum = SEQ(name='SeqNum', mode=MODE_TYPE)
    _SeqNum_num = INT(name='num', mode=MODE_TYPE)
    _SeqNum_dir_ind = BOOL(name='dir-ind', mode=MODE_TYPE)
    SeqNum._cont = ASN1Dict([
        ('num', _SeqNum_num),
        ('dir-ind', _SeqNum_dir_ind),
        ])
    SeqNum._ext = None
    
    #-----< SPKM-WRAP >-----#
    SPKM_WRAP = SEQ(name='SPKM-WRAP', mode=MODE_TYPE)
    _SPKM_WRAP_wrap_header = SEQ(name='wrap-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Header')))
    _SPKM_WRAP_wrap_body = SEQ(name='wrap-body', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Body')))
    SPKM_WRAP._cont = ASN1Dict([
        ('wrap-header', _SPKM_WRAP_wrap_header),
        ('wrap-body', _SPKM_WRAP_wrap_body),
        ])
    SPKM_WRAP._ext = None
    
    #-----< Wrap-Header >-----#
    Wrap_Header = SEQ(name='Wrap-Header', mode=MODE_TYPE)
    _Wrap_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Wrap_Header_tok_id._const_val = ASN1Set(rv=[513], rr=[], ev=None, er=[])
    _Wrap_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Wrap_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Wrap_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Wrap_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_algorithm._const_tab = ___Wrap_Header_int_alg_algorithm_tab
    __Wrap_Header_int_alg_algorithm._const_tab_at = None
    __Wrap_Header_int_alg_algorithm._const_tab_id = 'id'
    __Wrap_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Wrap_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_parameters._const_tab = ___Wrap_Header_int_alg_parameters_tab
    __Wrap_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Wrap_Header_int_alg_parameters._const_tab_id = 'Type'
    _Wrap_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Wrap_Header_int_alg_algorithm),
        ('parameters', __Wrap_Header_int_alg_parameters),
        ])
    _Wrap_Header_int_alg._ext = []
    _Wrap_Header_conf_alg = CHOICE(name='conf-alg', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Alg')), opt=True)
    _Wrap_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Wrap_Header._cont = ASN1Dict([
        ('tok-id', _Wrap_Header_tok_id),
        ('context-id', _Wrap_Header_context_id),
        ('int-alg', _Wrap_Header_int_alg),
        ('conf-alg', _Wrap_Header_conf_alg),
        ('snd-seq', _Wrap_Header_snd_seq),
        ])
    Wrap_Header._ext = None
    
    #-----< Wrap-Body >-----#
    Wrap_Body = SEQ(name='Wrap-Body', mode=MODE_TYPE)
    _Wrap_Body_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    _Wrap_Body_data = BIT_STR(name='data', mode=MODE_TYPE)
    Wrap_Body._cont = ASN1Dict([
        ('int-cksum', _Wrap_Body_int_cksum),
        ('data', _Wrap_Body_data),
        ])
    Wrap_Body._ext = None
    
    #-----< Conf-Alg >-----#
    Conf_Alg = CHOICE(name='Conf-Alg', mode=MODE_TYPE)
    _Conf_Alg_algId = SEQ(name='algId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Conf_Alg_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Conf_Alg_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_algorithm._const_tab = ___Conf_Alg_algId_algorithm_tab
    __Conf_Alg_algId_algorithm._const_tab_at = None
    __Conf_Alg_algId_algorithm._const_tab_id = 'id'
    __Conf_Alg_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Conf_Alg_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_parameters._const_tab = ___Conf_Alg_algId_parameters_tab
    __Conf_Alg_algId_parameters._const_tab_at = ('..', 'algorithm')
    __Conf_Alg_algId_parameters._const_tab_id = 'Type'
    _Conf_Alg_algId._cont = ASN1Dict([
        ('algorithm', __Conf_Alg_algId_algorithm),
        ('parameters', __Conf_Alg_algId_parameters),
        ])
    _Conf_Alg_algId._ext = []
    _Conf_Alg_null = NULL(name='null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Alg._cont = ASN1Dict([
        ('algId', _Conf_Alg_algId),
        ('null', _Conf_Alg_null),
        ])
    Conf_Alg._ext = None
    
    #-----< SPKM-DEL >-----#
    SPKM_DEL = SEQ(name='SPKM-DEL', mode=MODE_TYPE)
    _SPKM_DEL_del_header = SEQ(name='del-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Del-Header')))
    _SPKM_DEL_int_cksum = BIT_STR(name='int-cksum', mode=MODE_TYPE)
    SPKM_DEL._cont = ASN1Dict([
        ('del-header', _SPKM_DEL_del_header),
        ('int-cksum', _SPKM_DEL_int_cksum),
        ])
    SPKM_DEL._ext = None
    
    #-----< Del-Header >-----#
    Del_Header = SEQ(name='Del-Header', mode=MODE_TYPE)
    _Del_Header_tok_id = INT(name='tok-id', mode=MODE_TYPE)
    _Del_Header_tok_id._const_val = ASN1Set(rv=[769], rr=[], ev=None, er=[])
    _Del_Header_context_id = BIT_STR(name='context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Del_Header_int_alg = SEQ(name='int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Del_Header_int_alg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['id']))
    ___Del_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_algorithm._const_tab = ___Del_Header_int_alg_algorithm_tab
    __Del_Header_int_alg_algorithm._const_tab_at = None
    __Del_Header_int_alg_algorithm._const_tab_id = 'id'
    __Del_Header_int_alg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), ['Type']), opt=True)
    ___Del_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_parameters._const_tab = ___Del_Header_int_alg_parameters_tab
    __Del_Header_int_alg_parameters._const_tab_at = ('..', 'algorithm')
    __Del_Header_int_alg_parameters._const_tab_id = 'Type'
    _Del_Header_int_alg._cont = ASN1Dict([
        ('algorithm', __Del_Header_int_alg_algorithm),
        ('parameters', __Del_Header_int_alg_parameters),
        ])
    _Del_Header_int_alg._ext = []
    _Del_Header_snd_seq = SEQ(name='snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Del_Header._cont = ASN1Dict([
        ('tok-id', _Del_Header_tok_id),
        ('context-id', _Del_Header_context_id),
        ('int-alg', _Del_Header_int_alg),
        ('snd-seq', _Del_Header_snd_seq),
        ])
    Del_Header._ext = None
    
    #-----< MechType >-----#
    MechType = OID(name='MechType', mode=MODE_TYPE)
    
    #-----< InitialContextToken >-----#
    InitialContextToken = SEQ(name='InitialContextToken', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _InitialContextToken_thisMech = OID(name='thisMech', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'MechType')))
    _InitialContextToken_innerContextToken = CHOICE(name='innerContextToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'SPKMInnerContextToken')))
    InitialContextToken._cont = ASN1Dict([
        ('thisMech', _InitialContextToken_thisMech),
        ('innerContextToken', _InitialContextToken_innerContextToken),
        ])
    InitialContextToken._ext = None
    
    #-----< SPKMInnerContextToken >-----#
    SPKMInnerContextToken = CHOICE(name='SPKMInnerContextToken', mode=MODE_TYPE)
    _SPKMInnerContextToken_req = SEQ(name='req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SPKMInnerContextToken_rep_ti = SEQ(name='rep-ti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    _SPKMInnerContextToken_rep_it = SEQ(name='rep-it', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-IT')))
    _SPKMInnerContextToken_error = SEQ(name='error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')))
    _SPKMInnerContextToken_mic = SEQ(name='mic', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-MIC')))
    _SPKMInnerContextToken_wrap = SEQ(name='wrap', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-WRAP')))
    _SPKMInnerContextToken_del_ = SEQ(name='del', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-DEL')))
    SPKMInnerContextToken._cont = ASN1Dict([
        ('req', _SPKMInnerContextToken_req),
        ('rep-ti', _SPKMInnerContextToken_rep_ti),
        ('rep-it', _SPKMInnerContextToken_rep_it),
        ('error', _SPKMInnerContextToken_error),
        ('mic', _SPKMInnerContextToken_mic),
        ('wrap', _SPKMInnerContextToken_wrap),
        ('del', _SPKMInnerContextToken_del_),
        ])
    SPKMInnerContextToken._ext = None
    
    #-----< AuthorizationData >-----#
    AuthorizationData = SEQ_OF(name='AuthorizationData', mode=MODE_TYPE)
    _AuthorizationData__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AuthorizationData__item__ad_type = INT(name='ad-type', mode=MODE_TYPE)
    __AuthorizationData__item__ad_data = OCT_STR(name='ad-data', mode=MODE_TYPE)
    _AuthorizationData__item_._cont = ASN1Dict([
        ('ad-type', __AuthorizationData__item__ad_type),
        ('ad-data', __AuthorizationData__item__ad_data),
        ])
    _AuthorizationData__item_._ext = None
    AuthorizationData._cont = _AuthorizationData__item_
    
    #-----< md5-DES-CBC >-----#
    md5_DES_CBC = OID(name='md5-DES-CBC', mode=MODE_VALUE)
    md5_DES_CBC._val = (1, 3, 6, 1, 5, 3, 1)
    
    #-----< sum64-DES-CBC >-----#
    sum64_DES_CBC = OID(name='sum64-DES-CBC', mode=MODE_VALUE)
    sum64_DES_CBC._val = (1, 3, 6, 1, 5, 3, 2)
    
    #-----< spkm-1 >-----#
    spkm_1 = OID(name='spkm-1', mode=MODE_VALUE)
    spkm_1._val = (1, 3, 6, 1, 5, 5, 1, 1)
    
    #-----< spkm-2 >-----#
    spkm_2 = OID(name='spkm-2', mode=MODE_VALUE)
    spkm_2._val = (1, 3, 6, 1, 5, 5, 1, 2)
    
    _all_ = [
        _SPKM_REQ_requestToken,
        _SPKM_REQ_certif_data,
        _SPKM_REQ_auth_data,
        SPKM_REQ,
        _CertificationData_certificationPath,
        _CertificationData_certificateRevocationList,
        CertificationData,
        _CertificationPath_userKeyId,
        _CertificationPath_userCertif,
        _CertificationPath_verifKeyId,
        _CertificationPath_userVerifCertif,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _REQ_TOKEN_req_contents,
        ___REQ_TOKEN_algId_algorithm_tab,
        __REQ_TOKEN_algId_algorithm,
        ___REQ_TOKEN_algId_parameters_tab,
        __REQ_TOKEN_algId_parameters,
        _REQ_TOKEN_algId,
        _REQ_TOKEN_req_integrity,
        REQ_TOKEN,
        Integrity,
        _Req_contents_tok_id,
        _Req_contents_context_id,
        _Req_contents_pvno,
        _Req_contents_timestamp,
        _Req_contents_randSrc,
        _Req_contents_targ_name,
        _Req_contents_src_name,
        _Req_contents_req_data,
        _Req_contents_validity,
        _Req_contents_key_estb_set,
        _Req_contents_key_estb_req,
        _Req_contents_key_src_bind,
        Req_contents,
        Random_Integer,
        _Context_Data_channelId,
        _Context_Data_seq_number,
        _Context_Data_options,
        _Context_Data_conf_alg,
        _Context_Data_intg_alg,
        _Context_Data_owf_alg,
        Context_Data,
        ChannelId,
        Options,
        ____Conf_Algs_algs__item__algorithm_tab,
        ___Conf_Algs_algs__item__algorithm,
        ____Conf_Algs_algs__item__parameters_tab,
        ___Conf_Algs_algs__item__parameters,
        __Conf_Algs_algs__item_,
        _Conf_Algs_algs,
        _Conf_Algs_null,
        Conf_Algs,
        ___Intg_Algs__item__algorithm_tab,
        __Intg_Algs__item__algorithm,
        ___Intg_Algs__item__parameters_tab,
        __Intg_Algs__item__parameters,
        _Intg_Algs__item_,
        Intg_Algs,
        ___OWF_Algs__item__algorithm_tab,
        __OWF_Algs__item__algorithm,
        ___OWF_Algs__item__parameters_tab,
        __OWF_Algs__item__parameters,
        _OWF_Algs__item_,
        OWF_Algs,
        ___Key_Estb_Algs__item__algorithm_tab,
        __Key_Estb_Algs__item__algorithm,
        ___Key_Estb_Algs__item__parameters_tab,
        __Key_Estb_Algs__item__parameters,
        _Key_Estb_Algs__item_,
        Key_Estb_Algs,
        _SPKM_REP_TI_responseToken,
        _SPKM_REP_TI_certif_data,
        SPKM_REP_TI,
        _REP_TI_TOKEN_rep_ti_contents,
        ___REP_TI_TOKEN_algId_algorithm_tab,
        __REP_TI_TOKEN_algId_algorithm,
        ___REP_TI_TOKEN_algId_parameters_tab,
        __REP_TI_TOKEN_algId_parameters,
        _REP_TI_TOKEN_algId,
        _REP_TI_TOKEN_rep_ti_integ,
        REP_TI_TOKEN,
        _Rep_ti_contents_tok_id,
        _Rep_ti_contents_context_id,
        _Rep_ti_contents_pvno,
        _Rep_ti_contents_timestamp,
        _Rep_ti_contents_randTarg,
        _Rep_ti_contents_src_name,
        _Rep_ti_contents_targ_name,
        _Rep_ti_contents_randSrc,
        _Rep_ti_contents_rep_data,
        _Rep_ti_contents_validity,
        ___Rep_ti_contents_key_estb_id_algorithm_tab,
        __Rep_ti_contents_key_estb_id_algorithm,
        ___Rep_ti_contents_key_estb_id_parameters_tab,
        __Rep_ti_contents_key_estb_id_parameters,
        _Rep_ti_contents_key_estb_id,
        _Rep_ti_contents_key_estb_str,
        Rep_ti_contents,
        _SPKM_REP_IT_responseToken,
        ___SPKM_REP_IT_algId_algorithm_tab,
        __SPKM_REP_IT_algId_algorithm,
        ___SPKM_REP_IT_algId_parameters_tab,
        __SPKM_REP_IT_algId_parameters,
        _SPKM_REP_IT_algId,
        _SPKM_REP_IT_rep_it_integ,
        SPKM_REP_IT,
        _REP_IT_TOKEN_tok_id,
        _REP_IT_TOKEN_context_id,
        _REP_IT_TOKEN_randSrc,
        _REP_IT_TOKEN_randTarg,
        _REP_IT_TOKEN_targ_name,
        _REP_IT_TOKEN_src_name,
        _REP_IT_TOKEN_key_estb_rep,
        REP_IT_TOKEN,
        _SPKM_ERROR_errorToken,
        ___SPKM_ERROR_algId_algorithm_tab,
        __SPKM_ERROR_algId_algorithm,
        ___SPKM_ERROR_algId_parameters_tab,
        __SPKM_ERROR_algId_parameters,
        _SPKM_ERROR_algId,
        _SPKM_ERROR_integrity,
        SPKM_ERROR,
        _ERROR_TOKEN_tok_id,
        _ERROR_TOKEN_context_id,
        ERROR_TOKEN,
        _SPKM_MIC_mic_header,
        _SPKM_MIC_int_cksum,
        SPKM_MIC,
        _Mic_Header_tok_id,
        _Mic_Header_context_id,
        ___Mic_Header_int_alg_algorithm_tab,
        __Mic_Header_int_alg_algorithm,
        ___Mic_Header_int_alg_parameters_tab,
        __Mic_Header_int_alg_parameters,
        _Mic_Header_int_alg,
        _Mic_Header_snd_seq,
        Mic_Header,
        _SeqNum_num,
        _SeqNum_dir_ind,
        SeqNum,
        _SPKM_WRAP_wrap_header,
        _SPKM_WRAP_wrap_body,
        SPKM_WRAP,
        _Wrap_Header_tok_id,
        _Wrap_Header_context_id,
        ___Wrap_Header_int_alg_algorithm_tab,
        __Wrap_Header_int_alg_algorithm,
        ___Wrap_Header_int_alg_parameters_tab,
        __Wrap_Header_int_alg_parameters,
        _Wrap_Header_int_alg,
        _Wrap_Header_conf_alg,
        _Wrap_Header_snd_seq,
        Wrap_Header,
        _Wrap_Body_int_cksum,
        _Wrap_Body_data,
        Wrap_Body,
        ___Conf_Alg_algId_algorithm_tab,
        __Conf_Alg_algId_algorithm,
        ___Conf_Alg_algId_parameters_tab,
        __Conf_Alg_algId_parameters,
        _Conf_Alg_algId,
        _Conf_Alg_null,
        Conf_Alg,
        _SPKM_DEL_del_header,
        _SPKM_DEL_int_cksum,
        SPKM_DEL,
        _Del_Header_tok_id,
        _Del_Header_context_id,
        ___Del_Header_int_alg_algorithm_tab,
        __Del_Header_int_alg_algorithm,
        ___Del_Header_int_alg_parameters_tab,
        __Del_Header_int_alg_parameters,
        _Del_Header_int_alg,
        _Del_Header_snd_seq,
        Del_Header,
        MechType,
        _InitialContextToken_thisMech,
        _InitialContextToken_innerContextToken,
        InitialContextToken,
        _SPKMInnerContextToken_req,
        _SPKMInnerContextToken_rep_ti,
        _SPKMInnerContextToken_rep_it,
        _SPKMInnerContextToken_error,
        _SPKMInnerContextToken_mic,
        _SPKMInnerContextToken_wrap,
        _SPKMInnerContextToken_del_,
        SPKMInnerContextToken,
        __AuthorizationData__item__ad_type,
        __AuthorizationData__item__ad_data,
        _AuthorizationData__item_,
        AuthorizationData,
        md5_DES_CBC,
        sum64_DES_CBC,
        spkm_1,
        spkm_2,
    ]

class UsefulDefinitions:

    _name_  = 'UsefulDefinitions'
    _oid_   = [2, 5, 1, 0, 7]
    
    _obj_ = [
        'ID',
        'ds',
        'id',
        'internet',
        'ldap-dir',
        'ldap-enterprise',
        'ldap-x509',
        'ldap-openLDAP',
        'openLDAP-attributes',
        'openLDAP-controls',
        'ldap-wall',
        'ldap-dynExt',
        'ldap-attr',
        'ldap-match',
        'ldap-syntax',
        'cosine',
        'cosineAttr',
        'module',
        'serviceElement',
        'applicationContext',
        'attributeType',
        'attributeSyntaxVendor',
        'objectClass',
        'algorithm',
        'abstractSyntax',
        'dsaOperationalAttribute',
        'matchingRule',
        'knowledgeMatchingRule',
        'nameForm',
        'group',
        'subentry',
        'operationalAttributeType',
        'operationalBinding',
        'schemaObjectClass',
        'schemaOperationalAttribute',
        'administrativeRoles',
        'accessControlAttribute',
        'accessControlSchemes',
        'certificateExtension',
        'managementObject',
        'attributeValueContext',
        'idmProtocol',
        'problem',
        'notification',
        'matchingRestriction',
        'controlAttributeType',
        'keyPurposes',
        'passwordQuality',
        'attributeSyntax',
        'usefulDefinitions',
        'informationFramework',
        'directoryAbstractService',
        'distributedOperations',
        'selectedAttributeTypes',
        'selectedObjectClasses',
        'authenticationFramework',
        'algorithmObjectIdentifiers',
        'directoryObjectIdentifiers',
        'distributedDirectoryOIDs',
        'directoryShadowOIDs',
        'directoryShadowAbstractService',
        'opBindingManagement',
        'opBindingOIDs',
        'hierarchicalOperationalBindings',
        'dsaOperationalAttributeTypes',
        'schemaAdministration',
        'basicAccessControl',
        'directoryOperationalBindingTypes',
        'certificateExtensions',
        'directoryManagement',
        'enhancedSecurity',
        'iDMProtocolSpecification',
        'directoryIDMProtocols',
        'attributeCertificateDefinitions',
        'serviceAdministration',
        'ldapAttributes',
        'commonProtocolSpecification',
        'oSIProtocolSpecification',
        'directoryOSIProtocols',
        'ldapSystemSchema',
        'id-oc',
        'id-at',
        'id-as',
        'id-mr',
        'id-nf',
        'id-sc',
        'id-oa',
        'id-ob',
        'id-doa',
        'id-kmr',
        'id-soc',
        'id-soa',
        'id-ar',
        'id-aca',
        'id-ac',
        'id-acScheme',
        'id-ce',
        'id-mgt',
        'id-avc',
        'id-idm',
        'id-pr',
        'id-not',
        'id-mre',
        'id-cat',
        'id-kp',
        'id-pq',
        'id-ats',
        'id-asx',
        'id-lsx',
        'id-ldx',
        'id-lat',
        'id-lmr',
        'id-oat',
        'id-coat',
        ]
    _type_ = [
        'ID',
        ]
    _set_ = [
        ]
    _val_ = [
        'ds',
        'id',
        'internet',
        'ldap-dir',
        'ldap-enterprise',
        'ldap-x509',
        'ldap-openLDAP',
        'openLDAP-attributes',
        'openLDAP-controls',
        'ldap-wall',
        'ldap-dynExt',
        'ldap-attr',
        'ldap-match',
        'ldap-syntax',
        'cosine',
        'cosineAttr',
        'module',
        'serviceElement',
        'applicationContext',
        'attributeType',
        'attributeSyntaxVendor',
        'objectClass',
        'algorithm',
        'abstractSyntax',
        'dsaOperationalAttribute',
        'matchingRule',
        'knowledgeMatchingRule',
        'nameForm',
        'group',
        'subentry',
        'operationalAttributeType',
        'operationalBinding',
        'schemaObjectClass',
        'schemaOperationalAttribute',
        'administrativeRoles',
        'accessControlAttribute',
        'accessControlSchemes',
        'certificateExtension',
        'managementObject',
        'attributeValueContext',
        'idmProtocol',
        'problem',
        'notification',
        'matchingRestriction',
        'controlAttributeType',
        'keyPurposes',
        'passwordQuality',
        'attributeSyntax',
        'usefulDefinitions',
        'informationFramework',
        'directoryAbstractService',
        'distributedOperations',
        'selectedAttributeTypes',
        'selectedObjectClasses',
        'authenticationFramework',
        'algorithmObjectIdentifiers',
        'directoryObjectIdentifiers',
        'distributedDirectoryOIDs',
        'directoryShadowOIDs',
        'directoryShadowAbstractService',
        'opBindingManagement',
        'opBindingOIDs',
        'hierarchicalOperationalBindings',
        'dsaOperationalAttributeTypes',
        'schemaAdministration',
        'basicAccessControl',
        'directoryOperationalBindingTypes',
        'certificateExtensions',
        'directoryManagement',
        'enhancedSecurity',
        'iDMProtocolSpecification',
        'directoryIDMProtocols',
        'attributeCertificateDefinitions',
        'serviceAdministration',
        'ldapAttributes',
        'commonProtocolSpecification',
        'oSIProtocolSpecification',
        'directoryOSIProtocols',
        'ldapSystemSchema',
        'id-oc',
        'id-at',
        'id-as',
        'id-mr',
        'id-nf',
        'id-sc',
        'id-oa',
        'id-ob',
        'id-doa',
        'id-kmr',
        'id-soc',
        'id-soa',
        'id-ar',
        'id-aca',
        'id-ac',
        'id-acScheme',
        'id-ce',
        'id-mgt',
        'id-avc',
        'id-idm',
        'id-pr',
        'id-not',
        'id-mre',
        'id-cat',
        'id-kp',
        'id-pq',
        'id-ats',
        'id-asx',
        'id-lsx',
        'id-ldx',
        'id-lat',
        'id-lmr',
        'id-oat',
        'id-coat',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ID >-----#
    ID = OID(name='ID', mode=MODE_TYPE)
    
    #-----< ds >-----#
    ds = OID(name='ds', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ds._val = (2, 5)
    
    #-----< id >-----#
    id = OID(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id._val = (2, 17, 1, 2)
    
    #-----< internet >-----#
    internet = OID(name='internet', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    internet._val = (1, 3, 6, 1)
    
    #-----< ldap-dir >-----#
    ldap_dir = OID(name='ldap-dir', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dir._val = (1, 3, 6, 1, 1)
    
    #-----< ldap-enterprise >-----#
    ldap_enterprise = OID(name='ldap-enterprise', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_enterprise._val = (1, 3, 6, 1, 4, 1)
    
    #-----< ldap-x509 >-----#
    ldap_x509 = OID(name='ldap-x509', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_x509._val = (1, 3, 6, 1, 1, 15)
    
    #-----< ldap-openLDAP >-----#
    ldap_openLDAP = OID(name='ldap-openLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_openLDAP._val = (1, 3, 6, 1, 4, 1, 4203, 1)
    
    #-----< openLDAP-attributes >-----#
    openLDAP_attributes = OID(name='openLDAP-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_attributes._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< openLDAP-controls >-----#
    openLDAP_controls = OID(name='openLDAP-controls', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_controls._val = (1, 3, 6, 1, 4, 1, 4203, 1, 10)
    
    #-----< ldap-wall >-----#
    ldap_wall = OID(name='ldap-wall', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_wall._val = (1, 3, 6, 1, 4, 1, 1466)
    
    #-----< ldap-dynExt >-----#
    ldap_dynExt = OID(name='ldap-dynExt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dynExt._val = (1, 3, 6, 1, 4, 1, 1466, 101, 119)
    
    #-----< ldap-attr >-----#
    ldap_attr = OID(name='ldap-attr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_attr._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< ldap-match >-----#
    ldap_match = OID(name='ldap-match', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< ldap-syntax >-----#
    ldap_syntax = OID(name='ldap-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_syntax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< cosine >-----#
    cosine = OID(name='cosine', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosine._val = (0, 9, 2342, 19200300, 100)
    
    #-----< cosineAttr >-----#
    cosineAttr = OID(name='cosineAttr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosineAttr._val = (0, 9, 2342, 19200300, 100, 1)
    
    #-----< module >-----#
    module = OID(name='module', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    module._val = (2, 5, 1)
    
    #-----< serviceElement >-----#
    serviceElement = OID(name='serviceElement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceElement._val = (2, 5, 2)
    
    #-----< applicationContext >-----#
    applicationContext = OID(name='applicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    applicationContext._val = (2, 5, 3)
    
    #-----< attributeType >-----#
    attributeType = OID(name='attributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeType._val = (2, 5, 4)
    
    #-----< attributeSyntaxVendor >-----#
    attributeSyntaxVendor = OID(name='attributeSyntaxVendor', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntaxVendor._val = (2, 5, 5)
    
    #-----< objectClass >-----#
    objectClass = OID(name='objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    objectClass._val = (2, 5, 6)
    
    #-----< algorithm >-----#
    algorithm = OID(name='algorithm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithm._val = (2, 5, 8)
    
    #-----< abstractSyntax >-----#
    abstractSyntax = OID(name='abstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    abstractSyntax._val = (2, 5, 9)
    
    #-----< dsaOperationalAttribute >-----#
    dsaOperationalAttribute = OID(name='dsaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttribute._val = (2, 5, 12)
    
    #-----< matchingRule >-----#
    matchingRule = OID(name='matchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRule._val = (2, 5, 13)
    
    #-----< knowledgeMatchingRule >-----#
    knowledgeMatchingRule = OID(name='knowledgeMatchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    knowledgeMatchingRule._val = (2, 5, 14)
    
    #-----< nameForm >-----#
    nameForm = OID(name='nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    nameForm._val = (2, 5, 15)
    
    #-----< group >-----#
    group = OID(name='group', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    group._val = (2, 5, 16)
    
    #-----< subentry >-----#
    subentry = OID(name='subentry', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    subentry._val = (2, 5, 17)
    
    #-----< operationalAttributeType >-----#
    operationalAttributeType = OID(name='operationalAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalAttributeType._val = (2, 5, 18)
    
    #-----< operationalBinding >-----#
    operationalBinding = OID(name='operationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalBinding._val = (2, 5, 19)
    
    #-----< schemaObjectClass >-----#
    schemaObjectClass = OID(name='schemaObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaObjectClass._val = (2, 5, 20)
    
    #-----< schemaOperationalAttribute >-----#
    schemaOperationalAttribute = OID(name='schemaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaOperationalAttribute._val = (2, 5, 21)
    
    #-----< administrativeRoles >-----#
    administrativeRoles = OID(name='administrativeRoles', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    administrativeRoles._val = (2, 5, 23)
    
    #-----< accessControlAttribute >-----#
    accessControlAttribute = OID(name='accessControlAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlAttribute._val = (2, 5, 24)
    
    #-----< accessControlSchemes >-----#
    accessControlSchemes = OID(name='accessControlSchemes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlSchemes._val = (2, 5, 28)
    
    #-----< certificateExtension >-----#
    certificateExtension = OID(name='certificateExtension', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtension._val = (2, 5, 29)
    
    #-----< managementObject >-----#
    managementObject = OID(name='managementObject', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    managementObject._val = (2, 5, 30)
    
    #-----< attributeValueContext >-----#
    attributeValueContext = OID(name='attributeValueContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeValueContext._val = (2, 5, 31)
    
    #-----< idmProtocol >-----#
    idmProtocol = OID(name='idmProtocol', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    idmProtocol._val = (2, 5, 33)
    
    #-----< problem >-----#
    problem = OID(name='problem', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    problem._val = (2, 5, 34)
    
    #-----< notification >-----#
    notification = OID(name='notification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    notification._val = (2, 5, 35)
    
    #-----< matchingRestriction >-----#
    matchingRestriction = OID(name='matchingRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRestriction._val = (2, 5, 36)
    
    #-----< controlAttributeType >-----#
    controlAttributeType = OID(name='controlAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    controlAttributeType._val = (2, 5, 37)
    
    #-----< keyPurposes >-----#
    keyPurposes = OID(name='keyPurposes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    keyPurposes._val = (2, 5, 38)
    
    #-----< passwordQuality >-----#
    passwordQuality = OID(name='passwordQuality', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    passwordQuality._val = (2, 5, 39)
    
    #-----< attributeSyntax >-----#
    attributeSyntax = OID(name='attributeSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntax._val = (2, 5, 40)
    
    #-----< usefulDefinitions >-----#
    usefulDefinitions = OID(name='usefulDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    usefulDefinitions._val = (2, 5, 1, 0, 7)
    
    #-----< informationFramework >-----#
    informationFramework = OID(name='informationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    informationFramework._val = (2, 5, 1, 1, 7)
    
    #-----< directoryAbstractService >-----#
    directoryAbstractService = OID(name='directoryAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryAbstractService._val = (2, 5, 1, 2, 7)
    
    #-----< distributedOperations >-----#
    distributedOperations = OID(name='distributedOperations', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedOperations._val = (2, 5, 1, 3, 7)
    
    #-----< selectedAttributeTypes >-----#
    selectedAttributeTypes = OID(name='selectedAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedAttributeTypes._val = (2, 5, 1, 5, 7)
    
    #-----< selectedObjectClasses >-----#
    selectedObjectClasses = OID(name='selectedObjectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedObjectClasses._val = (2, 5, 1, 6, 7)
    
    #-----< authenticationFramework >-----#
    authenticationFramework = OID(name='authenticationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    authenticationFramework._val = (2, 5, 1, 7, 7)
    
    #-----< algorithmObjectIdentifiers >-----#
    algorithmObjectIdentifiers = OID(name='algorithmObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithmObjectIdentifiers._val = (2, 5, 1, 8, 7)
    
    #-----< directoryObjectIdentifiers >-----#
    directoryObjectIdentifiers = OID(name='directoryObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryObjectIdentifiers._val = (2, 5, 1, 9, 7)
    
    #-----< distributedDirectoryOIDs >-----#
    distributedDirectoryOIDs = OID(name='distributedDirectoryOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedDirectoryOIDs._val = (2, 5, 1, 13, 7)
    
    #-----< directoryShadowOIDs >-----#
    directoryShadowOIDs = OID(name='directoryShadowOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowOIDs._val = (2, 5, 1, 14, 7)
    
    #-----< directoryShadowAbstractService >-----#
    directoryShadowAbstractService = OID(name='directoryShadowAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowAbstractService._val = (2, 5, 1, 15, 7)
    
    #-----< opBindingManagement >-----#
    opBindingManagement = OID(name='opBindingManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingManagement._val = (2, 5, 1, 18, 7)
    
    #-----< opBindingOIDs >-----#
    opBindingOIDs = OID(name='opBindingOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingOIDs._val = (2, 5, 1, 19, 7)
    
    #-----< hierarchicalOperationalBindings >-----#
    hierarchicalOperationalBindings = OID(name='hierarchicalOperationalBindings', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    hierarchicalOperationalBindings._val = (2, 5, 1, 20, 7)
    
    #-----< dsaOperationalAttributeTypes >-----#
    dsaOperationalAttributeTypes = OID(name='dsaOperationalAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttributeTypes._val = (2, 5, 1, 22, 7)
    
    #-----< schemaAdministration >-----#
    schemaAdministration = OID(name='schemaAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaAdministration._val = (2, 5, 1, 23, 7)
    
    #-----< basicAccessControl >-----#
    basicAccessControl = OID(name='basicAccessControl', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    basicAccessControl._val = (2, 5, 1, 24, 7)
    
    #-----< directoryOperationalBindingTypes >-----#
    directoryOperationalBindingTypes = OID(name='directoryOperationalBindingTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOperationalBindingTypes._val = (2, 5, 1, 25, 7)
    
    #-----< certificateExtensions >-----#
    certificateExtensions = OID(name='certificateExtensions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtensions._val = (2, 5, 1, 26, 7)
    
    #-----< directoryManagement >-----#
    directoryManagement = OID(name='directoryManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryManagement._val = (2, 5, 1, 27, 7)
    
    #-----< enhancedSecurity >-----#
    enhancedSecurity = OID(name='enhancedSecurity', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    enhancedSecurity._val = (2, 5, 1, 28, 7)
    
    #-----< iDMProtocolSpecification >-----#
    iDMProtocolSpecification = OID(name='iDMProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    iDMProtocolSpecification._val = (2, 5, 1, 30, 7)
    
    #-----< directoryIDMProtocols >-----#
    directoryIDMProtocols = OID(name='directoryIDMProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryIDMProtocols._val = (2, 5, 1, 31, 7)
    
    #-----< attributeCertificateDefinitions >-----#
    attributeCertificateDefinitions = OID(name='attributeCertificateDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeCertificateDefinitions._val = (2, 5, 1, 32, 7)
    
    #-----< serviceAdministration >-----#
    serviceAdministration = OID(name='serviceAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceAdministration._val = (2, 5, 1, 33, 7)
    
    #-----< ldapAttributes >-----#
    ldapAttributes = OID(name='ldapAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapAttributes._val = (2, 5, 1, 34, 7)
    
    #-----< commonProtocolSpecification >-----#
    commonProtocolSpecification = OID(name='commonProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    commonProtocolSpecification._val = (2, 5, 1, 35, 7)
    
    #-----< oSIProtocolSpecification >-----#
    oSIProtocolSpecification = OID(name='oSIProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    oSIProtocolSpecification._val = (2, 5, 1, 36, 7)
    
    #-----< directoryOSIProtocols >-----#
    directoryOSIProtocols = OID(name='directoryOSIProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOSIProtocols._val = (2, 5, 1, 37, 7)
    
    #-----< ldapSystemSchema >-----#
    ldapSystemSchema = OID(name='ldapSystemSchema', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapSystemSchema._val = (2, 5, 1, 38, 7)
    
    #-----< id-oc >-----#
    id_oc = OID(name='id-oc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oc._val = (2, 5, 6)
    
    #-----< id-at >-----#
    id_at = OID(name='id-at', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_at._val = (2, 5, 4)
    
    #-----< id-as >-----#
    id_as = OID(name='id-as', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_as._val = (2, 5, 9)
    
    #-----< id-mr >-----#
    id_mr = OID(name='id-mr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mr._val = (2, 5, 13)
    
    #-----< id-nf >-----#
    id_nf = OID(name='id-nf', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_nf._val = (2, 5, 15)
    
    #-----< id-sc >-----#
    id_sc = OID(name='id-sc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_sc._val = (2, 5, 17)
    
    #-----< id-oa >-----#
    id_oa = OID(name='id-oa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oa._val = (2, 5, 18)
    
    #-----< id-ob >-----#
    id_ob = OID(name='id-ob', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ob._val = (2, 5, 19)
    
    #-----< id-doa >-----#
    id_doa = OID(name='id-doa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_doa._val = (2, 5, 12)
    
    #-----< id-kmr >-----#
    id_kmr = OID(name='id-kmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kmr._val = (2, 5, 14)
    
    #-----< id-soc >-----#
    id_soc = OID(name='id-soc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soc._val = (2, 5, 20)
    
    #-----< id-soa >-----#
    id_soa = OID(name='id-soa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soa._val = (2, 5, 21)
    
    #-----< id-ar >-----#
    id_ar = OID(name='id-ar', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ar._val = (2, 5, 23)
    
    #-----< id-aca >-----#
    id_aca = OID(name='id-aca', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_aca._val = (2, 5, 24)
    
    #-----< id-ac >-----#
    id_ac = OID(name='id-ac', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ac._val = (2, 5, 3)
    
    #-----< id-acScheme >-----#
    id_acScheme = OID(name='id-acScheme', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_acScheme._val = (2, 5, 28)
    
    #-----< id-ce >-----#
    id_ce = OID(name='id-ce', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ce._val = (2, 5, 29)
    
    #-----< id-mgt >-----#
    id_mgt = OID(name='id-mgt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mgt._val = (2, 5, 30)
    
    #-----< id-avc >-----#
    id_avc = OID(name='id-avc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_avc._val = (2, 5, 31)
    
    #-----< id-idm >-----#
    id_idm = OID(name='id-idm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_idm._val = (2, 5, 33)
    
    #-----< id-pr >-----#
    id_pr = OID(name='id-pr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pr._val = (2, 5, 34)
    
    #-----< id-not >-----#
    id_not = OID(name='id-not', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_not._val = (2, 5, 35)
    
    #-----< id-mre >-----#
    id_mre = OID(name='id-mre', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mre._val = (2, 5, 36)
    
    #-----< id-cat >-----#
    id_cat = OID(name='id-cat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_cat._val = (2, 5, 37)
    
    #-----< id-kp >-----#
    id_kp = OID(name='id-kp', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kp._val = (2, 5, 38)
    
    #-----< id-pq >-----#
    id_pq = OID(name='id-pq', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pq._val = (2, 5, 39)
    
    #-----< id-ats >-----#
    id_ats = OID(name='id-ats', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ats._val = (2, 5, 40)
    
    #-----< id-asx >-----#
    id_asx = OID(name='id-asx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_asx._val = (2, 5, 40)
    
    #-----< id-lsx >-----#
    id_lsx = OID(name='id-lsx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lsx._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< id-ldx >-----#
    id_ldx = OID(name='id-ldx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ldx._val = (1, 3, 6, 1, 1, 15)
    
    #-----< id-lat >-----#
    id_lat = OID(name='id-lat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lat._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< id-lmr >-----#
    id_lmr = OID(name='id-lmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lmr._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< id-oat >-----#
    id_oat = OID(name='id-oat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oat._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< id-coat >-----#
    id_coat = OID(name='id-coat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_coat._val = (0, 9, 2342, 19200300, 100, 1)
    
    _all_ = [
        ID,
        ds,
        id,
        internet,
        ldap_dir,
        ldap_enterprise,
        ldap_x509,
        ldap_openLDAP,
        openLDAP_attributes,
        openLDAP_controls,
        ldap_wall,
        ldap_dynExt,
        ldap_attr,
        ldap_match,
        ldap_syntax,
        cosine,
        cosineAttr,
        module,
        serviceElement,
        applicationContext,
        attributeType,
        attributeSyntaxVendor,
        objectClass,
        algorithm,
        abstractSyntax,
        dsaOperationalAttribute,
        matchingRule,
        knowledgeMatchingRule,
        nameForm,
        group,
        subentry,
        operationalAttributeType,
        operationalBinding,
        schemaObjectClass,
        schemaOperationalAttribute,
        administrativeRoles,
        accessControlAttribute,
        accessControlSchemes,
        certificateExtension,
        managementObject,
        attributeValueContext,
        idmProtocol,
        problem,
        notification,
        matchingRestriction,
        controlAttributeType,
        keyPurposes,
        passwordQuality,
        attributeSyntax,
        usefulDefinitions,
        informationFramework,
        directoryAbstractService,
        distributedOperations,
        selectedAttributeTypes,
        selectedObjectClasses,
        authenticationFramework,
        algorithmObjectIdentifiers,
        directoryObjectIdentifiers,
        distributedDirectoryOIDs,
        directoryShadowOIDs,
        directoryShadowAbstractService,
        opBindingManagement,
        opBindingOIDs,
        hierarchicalOperationalBindings,
        dsaOperationalAttributeTypes,
        schemaAdministration,
        basicAccessControl,
        directoryOperationalBindingTypes,
        certificateExtensions,
        directoryManagement,
        enhancedSecurity,
        iDMProtocolSpecification,
        directoryIDMProtocols,
        attributeCertificateDefinitions,
        serviceAdministration,
        ldapAttributes,
        commonProtocolSpecification,
        oSIProtocolSpecification,
        directoryOSIProtocols,
        ldapSystemSchema,
        id_oc,
        id_at,
        id_as,
        id_mr,
        id_nf,
        id_sc,
        id_oa,
        id_ob,
        id_doa,
        id_kmr,
        id_soc,
        id_soa,
        id_ar,
        id_aca,
        id_ac,
        id_acScheme,
        id_ce,
        id_mgt,
        id_avc,
        id_idm,
        id_pr,
        id_not,
        id_mre,
        id_cat,
        id_kp,
        id_pq,
        id_ats,
        id_asx,
        id_lsx,
        id_ldx,
        id_lat,
        id_lmr,
        id_oat,
        id_coat,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(AlgorithmObjectIdentifiers, AttributeCertificateDefinitions, AuthenticationFramework, BasicAccessControl, CertificateExtensions, CommonProtocolSpecification, DirectoryAbstractService, DirectoryOperationalBindingTypes, DirectoryOSIProtocols, DirectoryShadowAbstractService, DistributedOperations, DSAOperationalAttributeTypes, EnhancedSecurity, HierarchicalOperationalBindings, InformationFramework, LdapSystemSchema, Lightweight_Directory_Access_Protocol_V3, MTSAbstractService, OperationalBindingManagement, OSIProtocolSpecification, PKIX1Implicit93, SchemaAdministration, SelectedAttributeTypes, ServiceAdministration, SpkmGssTokens, UsefulDefinitions, _IMPL_)
